/////////////////
// CBFile.cpp	:	ڡͼͼȫݽṹ
// CBFile.cpp	:	<< chibi >> global map data structure
//
// 汾0010		:	1996918
// v0012		:	Nov.7.1996
// v0013		:	Feb.5.1997
// v0020		:	Feb.28.1997,add function named DATA_ReadDATAFile()
//
// д			:	
// written by	:	Liu Gang
//
// 		:	Visual C++ 4.2
// Compiler		:	Visual C++ 4.2
//
// Ȩ			:	ǰ޹˾		1996-1997
// Copyright	:	WayAhead Software Co.Ltd.	1996-1997
/////////////////
// ļжԵκ͵ԪͼصĶȡ
#include "stdafx.h"
#include <stdio.h>	// for FILE
#include "Assert.h"	// Error message

#include "CBMap.h"
#include "CBGame.h"	
#include "L_Scan.h"    //lwc
#ifdef	_GAME_
	#include "CBDraw.h"
	#include "CBData.h"
	#include "CBMini.h"
#endif

///////////
// ļȡ
// ȡ
BOOL MAP_ReadGroundFile( HWND hwnd, LPCTSTR filename , LPCTSTR pathDAT, LPCTSTR pathBMP )
{
	char fname[_MAX_FNAME];
	if( pathDAT != 0 )
	{
		strcpy( fname, pathDAT );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );

	CScan_read FSCAN;
	FSCAN.scan_open (fname);//lwc ground.dat
	//FILE * fp=fopen(fname,"rt");
	/*if(!fp)
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+0,"Cannot open ground map data file: ",fname );
		return FALSE;
	}
	*/
	
	// reset value to zero
	memset( MAP_Lib.Ground, MAP_DATA_NONE, sizeof(struct MAP_GROUND_LIB_STRUCT)*MAP_GROUND_LIB_NUM );
	
	// read number of graphic files
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &MAP_Lib.nGLibNum ) );
	//fscanf( fp, "%d\n", &MAP_Lib.nGLibNum );
	for( int i=0; i< MAP_Lib.nGLibNum; i++ )
	{
		// read file, layer and type attributes
		/*		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d,%d\n", 
					  &MAP_Lib.Other[i].nMaxFrame, 
					  &MAP_Lib.Other[i].szItem.cx, &MAP_Lib.Other[i].szItem.cy,
					  &MAP_Lib.Other[i].nID );
		*/
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d\n",
			                  &MAP_Lib.Ground[i].nFile,
							  &MAP_Lib.Ground[i].nLayer,
							  &MAP_Lib.Ground[i].nType) );
		/*fscanf(fp,"%d,%d,%d\n",
			&MAP_Lib.Ground[i].nFile,&MAP_Lib.Ground[i].nLayer,&MAP_Lib.Ground[i].nType);*/
		// read graphic file names
		//char strFile1[33], strFile2[33], strFile[_MAX_FNAME];
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n",&MAP_Lib.Ground[i].nID));
		//fscanf( fp, "%s %s\n", strFile1, strFile2 );
		/*strcpy( strFile, pathBMP );
		strcat( strFile, strFile1 );
		strcat( strFile, ".bmp");
		strcpy( MAP_Lib.Ground[i].strMaskFile, strFile );
		strcpy( strFile, pathBMP );
		strcat( strFile, strFile2 );
		strcat( strFile, ".bmp");
		strcpy( MAP_Lib.Ground[i].strFile, strFile );*/

		// read window name
		/*fscanf( fp,"%s\n", strFile1 );
		strcpy( fname, pathBMP ); strcat( fname, strFile1 );
		strcpy( MAP_Lib.Ground[i].strWnd, fname );*/

		// read window rectangle
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d,%d\n",
			&MAP_Lib.Ground[i].rcWnd.left,
			&MAP_Lib.Ground[i].rcWnd.top,
			&MAP_Lib.Ground[i].rcWnd.right,
			&MAP_Lib.Ground[i].rcWnd.bottom) );
		//fscanf(fp,"%d,%d,%d,%d\n",&MAP_Lib.Ground[i].rcWnd.left,&MAP_Lib.Ground[i].rcWnd.top,&MAP_Lib.Ground[i].rcWnd.right,&MAP_Lib.Ground[i].rcWnd.bottom);
		// read item size and height
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d\n",
							  &MAP_Lib.Ground[i].szItem.cx,
							  &MAP_Lib.Ground[i].szItem.cy,
							  &MAP_Lib.Ground[i].nHeight) );
		//fscanf(fp,"%d,%d,%d\n",
		//	&MAP_Lib.Ground[i].szItem.cx,&MAP_Lib.Ground[i].szItem.cy,&MAP_Lib.Ground[i].nHeight);
		// read data arrage style, column and row numbers
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d\n",&MAP_Lib.Ground[i].szNum.cx,&MAP_Lib.Ground[i].szNum.cy));
		//fscanf(fp,"%d,%d\n",&MAP_Lib.Ground[i].szNum.cx,&MAP_Lib.Ground[i].szNum.cy);
		//ASSERT(MAP_Lib.Ground[i].szNum.cx<=GROUND_ITEM_COL);
		//ASSERT(MAP_Lib.Ground[i].szNum.cy<=GROUND_ITEM_ROW);

		// read data for each column and encode
		for(int j=0; j<MAP_Lib.Ground[i].szNum.cx; j++)
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,",&MAP_Lib.Ground[i].nItemHeights[j]));
			//fscanf(fp,"%d,",&MAP_Lib.Ground[i].nItemHeights[j]);
			for( int s=0; s<MAP_GROUND_ITEM_ROW; s++)
				MAP_Lib.Ground[i].nItems[j][s] = MAP_DATA_NONE;
			for(int k=0; k<MAP_Lib.Ground[i].nItemHeights[j]; k++)
			{
				struct MAP_GROUND_CODE_STRUCT code_struct;
				code_struct.nFile=MAP_Lib.Ground[i].nFile;
				code_struct.nAttr = MAP_SPECIAL_NONE;
				//code_struct.nLayer=MAP_Lib.Ground[i].nLayer;
				//code_struct.nType=MAP_Lib.Ground[i].nType;
				code_struct.nCol=j;
				code_struct.nRow=k;
				MAP_Lib.Ground[i].nItems[j][k]=MAP_GroundEnCode(code_struct);
			}
		}
	}
	FSCAN.scan_close ();
	//fclose(fp);
	return TRUE;
}// end of MAP_ReadGroundFile()
//////////////////////

//////////////////////
// ȡԪ
BOOL MAP_ReadUnitFile( HWND hwnd, LPCTSTR filename , LPCTSTR pathDAT, LPCTSTR pathBMP )
{
	char fname[_MAX_FNAME];
	CScan_read FSCAN;

	if( pathDAT != 0 )
	{
		strcpy( fname, pathDAT );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FSCAN.scan_open (fname);
	/*
	FILE * fp = fopen( fname, "rt" );//unit.dat
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+1, "Cannot open unit map data file: ", fname );
		return FALSE;
	}
	*/
	// reset value to zero
	memset( MAP_Lib.Unit, MAP_DATA_NONE, sizeof(struct MAP_UNIT_LIB_STRUCT)*MAP_UNIT_LIB_NUM );

	// read number of graphic files
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &MAP_Lib.nULibNum ));
	//fscanf( fp, "%d\n", &MAP_Lib.nULibNum );
	for( int i=0; i< MAP_Lib.nULibNum ; i++ )
	{
		// read file number
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &MAP_Lib.Unit[i].nFile ));
		//fscanf( fp, "%d\n", &MAP_Lib.Unit[i].nFile );
		// read graphic file names
		// read graphic file names
		char strFile1[33], strFile2[33], strFile[_MAX_FNAME];
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%s %s\n", strFile1, strFile2 ));
		//fscanf( fp, "%s %s\n", strFile1, strFile2 );
		strcpy( strFile, pathBMP );
		strcat( strFile, strFile1 );
		strcat( strFile, ".bmp");
		strcpy( MAP_Lib.Unit[i].strMaskFile, strFile );
		strcpy( strFile, pathBMP );
		strcat( strFile, strFile2 );
		strcat( strFile, ".bmp");
		strcpy( MAP_Lib.Unit[i].strFile, strFile );

		// read item size and type 
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,
			"%d,%d,%d,%d\n", 
			&MAP_Lib.Unit[i].szItem.cx, &MAP_Lib.Unit[i].szItem.cy, 
			&MAP_Lib.Unit[i].nType, &MAP_Lib.Unit[i].nLocationSize ));
		/*
		fscanf( fp, "%d,%d,%d,%d\n", 
			&MAP_Lib.Unit[i].szItem.cx, &MAP_Lib.Unit[i].szItem.cy, 
			&MAP_Lib.Unit[i].nType, &MAP_Lib.Unit[i].nLocationSize );
		*/
		// read data column and row numbers
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d\n", &MAP_Lib.Unit[i].szNum.cx, &MAP_Lib.Unit[i].szNum.cy ));
		//fscanf( fp, "%d,%d\n", &MAP_Lib.Unit[i].szNum.cx, &MAP_Lib.Unit[i].szNum.cy );
		// encode
		for( int j=0; j< MAP_Lib.Unit[i].szNum.cy; j++ )
		{
			struct MAP_UNIT_CODE_STRUCT code_struct;
			code_struct.nPlayer = 0;
			code_struct.nFile = MAP_Lib.Unit[i].nFile;
			code_struct.nCol = 0;
			code_struct.nRow = j;
			code_struct.nLayer = 0;
			code_struct.nFrame = 0;
			MAP_Lib.Unit[i].nItems[j] = MAP_UnitEnCode( code_struct );
		}
	}
	FSCAN.scan_close ();
	//fclose( fp );

	return TRUE;
}// end of MAP_ReadUnitFile()
//////////////////////

//////////////////////
// ȡ
BOOL MAP_ReadSpecFile( HWND hwnd, LPCTSTR filename , LPCTSTR path )
{
	char fname[_MAX_FNAME];
	CScan_read FSCAN;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	
	FSCAN.scan_open (fname);//lwc
/*	FILE * fp = fopen( fname, "rt" );	//data\spec.dat
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+2, "Cannot open special unit map data file: ", fname );
		return FALSE;
	}
*/
	// reset
	memset( MAP_Lib.Special, 0, sizeof(DWORD)*MAP_SPECIAL_MAX );
	int num=0, i=0;
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &num ));
	//fscanf( fp, "%d\n", &num );
	while( num != -1 )
	{
		
		struct MAP_UNIT_CODE_STRUCT code_s;
		code_s.nPlayer=0;
		code_s.nCol=0;
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d \n", &code_s.nFile, &code_s.nRow ));
		//fscanf( fp, "%d,%d\n", &code_s.nFile, &code_s.nRow );
		MAP_Lib.Special[i]=MAP_UnitEnCode( code_s );
		i++;
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d", &num ));
		//fscanf( fp, "%d", &num );
	}
	FSCAN.scan_close ();
	//fclose( fp );
	return TRUE;
}// end of MAP_ReadSpecFile()
//////////////////////

//////////////////////
// ȡ̽
// read senser file, declared in CBMap.h
BOOL MAP_ReadSenserFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[_MAX_FNAME];
	CScan_read FSCAN;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FSCAN.scan_open (fname);//lwc   senser.dat
	/*
	FILE * fp = fopen( fname, "rb" );
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+3, "Cannot open senser data file: ", fname );
		return FALSE;
	}
	*/
	// initialize
	memset( MAP_ptSenser, 0, sizeof(POINT)*2*MAP_SENSER_MAX*MAP_SENSER_MAX*8 );

	// yΪżʱ
	for( int i=0; i<MAP_SENSER_MAX; i++ )
	{
		int num=0;
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &num ));
		//fscanf( fp, "%d\n", &num );
		for( int j=0; j<num; j++ )
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,
						  "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n",
				          &MAP_ptSenser[0][i][j*8+0].x,&MAP_ptSenser[0][i][j*8+0].y,
				          &MAP_ptSenser[0][i][j*8+1].x,&MAP_ptSenser[0][i][j*8+1].y,
						  &MAP_ptSenser[0][i][j*8+2].x,&MAP_ptSenser[0][i][j*8+2].y,
						  &MAP_ptSenser[0][i][j*8+3].x,&MAP_ptSenser[0][i][j*8+3].y,
						  &MAP_ptSenser[0][i][j*8+4].x,&MAP_ptSenser[0][i][j*8+4].y,
						  &MAP_ptSenser[0][i][j*8+5].x,&MAP_ptSenser[0][i][j*8+5].y,
						  &MAP_ptSenser[0][i][j*8+6].x,&MAP_ptSenser[0][i][j*8+6].y,
						  &MAP_ptSenser[0][i][j*8+7].x,&MAP_ptSenser[0][i][j*8+7].y
						 ));
			/*
			fscanf(fp, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n",
				&MAP_ptSenser[0][i][j*8+0].x,&MAP_ptSenser[0][i][j*8+0].y,
				&MAP_ptSenser[0][i][j*8+1].x,&MAP_ptSenser[0][i][j*8+1].y,
				&MAP_ptSenser[0][i][j*8+2].x,&MAP_ptSenser[0][i][j*8+2].y,
				&MAP_ptSenser[0][i][j*8+3].x,&MAP_ptSenser[0][i][j*8+3].y,
				&MAP_ptSenser[0][i][j*8+4].x,&MAP_ptSenser[0][i][j*8+4].y,
				&MAP_ptSenser[0][i][j*8+5].x,&MAP_ptSenser[0][i][j*8+5].y,
				&MAP_ptSenser[0][i][j*8+6].x,&MAP_ptSenser[0][i][j*8+6].y,
				&MAP_ptSenser[0][i][j*8+7].x,&MAP_ptSenser[0][i][j*8+7].y
			);
			*/
		}
	}
	// yΪʱ
	for( i=0; i<MAP_SENSER_MAX; i++ )
	{
		int num=0;
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &num ));
		//fscanf( fp, "%d\n", &num );
		for( int j=0; j<num; j++ )
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,
				"%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n",
				&MAP_ptSenser[1][i][j*8+0].x,&MAP_ptSenser[1][i][j*8+0].y,
				&MAP_ptSenser[1][i][j*8+1].x,&MAP_ptSenser[1][i][j*8+1].y,
				&MAP_ptSenser[1][i][j*8+2].x,&MAP_ptSenser[1][i][j*8+2].y,
				&MAP_ptSenser[1][i][j*8+3].x,&MAP_ptSenser[1][i][j*8+3].y,
				&MAP_ptSenser[1][i][j*8+4].x,&MAP_ptSenser[1][i][j*8+4].y,
				&MAP_ptSenser[1][i][j*8+5].x,&MAP_ptSenser[1][i][j*8+5].y,
				&MAP_ptSenser[1][i][j*8+6].x,&MAP_ptSenser[1][i][j*8+6].y,
				&MAP_ptSenser[1][i][j*8+7].x,&MAP_ptSenser[1][i][j*8+7].y
			));
			/*
			fscanf(fp, "%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n",
				&MAP_ptSenser[1][i][j*8+0].x,&MAP_ptSenser[1][i][j*8+0].y,
				&MAP_ptSenser[1][i][j*8+1].x,&MAP_ptSenser[1][i][j*8+1].y,
				&MAP_ptSenser[1][i][j*8+2].x,&MAP_ptSenser[1][i][j*8+2].y,
				&MAP_ptSenser[1][i][j*8+3].x,&MAP_ptSenser[1][i][j*8+3].y,
				&MAP_ptSenser[1][i][j*8+4].x,&MAP_ptSenser[1][i][j*8+4].y,
				&MAP_ptSenser[1][i][j*8+5].x,&MAP_ptSenser[1][i][j*8+5].y,
				&MAP_ptSenser[1][i][j*8+6].x,&MAP_ptSenser[1][i][j*8+6].y,
				&MAP_ptSenser[1][i][j*8+7].x,&MAP_ptSenser[1][i][j*8+7].y
			);
			*/
		}
	}
//	fclose( fp );
	FSCAN.scan_close ();
	// initialize Location data
	{
	}
	return TRUE;
}// end of ReadSenserFile()
//////////////////////

//////////////////////
// Ԫͼضݶļ
// declared in file CBMAP.h
// hwnd			:	ʱھ
// filename		:	Ԫͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
#ifdef	_MAP_COMPRESS_
BOOL MAP_ReadAniSeqFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[_MAX_FNAME];
	CScan_read FSCAN;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FSCAN.scan_open (fname);//lwc
	/*FILE * fp = fopen( fname, "rb" );//aniseq01.dat
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+9, "Cannot open animation sequency data file: ", fname );
		return FALSE;
	}
		*/
	// initialize
	memset( MAP_Lib.AniSeq, 0, sizeof( struct MAP_ANISEQ_STRUCT )*MAP_UNIT_LIB_NUM );

	int nNum, nFile, nState;
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nNum ));
	//fscanf( fp, "%d,", &nNum );
	for( int x = 0; x< nNum; x++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nFile  ));
		//fscanf( fp, "%d,", &nFile );
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &MAP_Lib.AniSeq[nFile].nMaxState ));
		//fscanf( fp, "%d,", &MAP_Lib.AniSeq[nFile].nMaxState );
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &MAP_Lib.AniSeq[nFile].nOffset ));
		//fscanf( fp, "%d\n", &MAP_Lib.AniSeq[nFile].nOffset );

		for( int i=0; i< MAP_Lib.AniSeq[nFile].nMaxState; i++ )
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nState ));
			//fscanf( fp, "%d,", &nState );
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &MAP_Lib.AniSeq[nFile].nMaxSequence[nState] ));
			//fscanf( fp, "%d\n", &MAP_Lib.AniSeq[nFile].nMaxSequence[nState] );
			for( int j=0; j< MAP_Lib.AniSeq[nFile].nMaxSequence[nState]; j++ )
			{
				FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &MAP_Lib.AniSeq[nFile].nAniSeq[nState][j] ));
				//fscanf( fp, "%d,", &MAP_Lib.AniSeq[nFile].nAniSeq[nState][j] );
			}
		}
	}
	//fclose( fp );
	FSCAN.scan_close ();
	return TRUE;
}

#else

BOOL MAP_ReadAniSeqFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[_MAX_FNAME];
	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FILE * fp = fopen( fname, "rb" );
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+4, "Cannot open animation sequency data file: ", fname );
		return FALSE;
	}

	// initialize
	memset( MAP_Lib.AniSeq, 0, sizeof( struct MAP_ANISEQ_STRUCT )*MAP_UNIT_LIB_NUM );

	int nNum, nFile, nState;
	fscanf( fp, "%d,", &nNum );
	for( int x = 0; x< nNum; x++ )
	{
		fscanf( fp, "%d,", &nFile );
		fscanf( fp, "%d\n", &MAP_Lib.AniSeq[nFile].nMaxState );

		for( int i=0; i< MAP_Lib.AniSeq[nFile].nMaxState; i++ )
		{
			fscanf( fp, "%d,", &nState );
			fscanf( fp, "%d\n", &MAP_Lib.AniSeq[nFile].nMaxSequence[nState] );
			for( int j=0; j< MAP_Lib.AniSeq[nFile].nMaxSequence[nState]; j++ )
			{
				fscanf( fp, "%d,%d,", 
					&MAP_Lib.AniSeq[nFile].ptAniSeq[nState][j].x,
					&MAP_Lib.AniSeq[nFile].ptAniSeq[nState][j].y );
			}
		}
	}
	fclose( fp );

	return TRUE;
}
#endif	// _MAP_COMPRESS_

// ĵԪͼضݶļ
// defined in file CBFile.cpp
// hwnd			:	ʱھ
// filename		:	Ԫͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadAniSeqFileEx( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[_MAX_FNAME];
	CScan_read FSCAN;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	/*
	FILE * fp = fopen( fname, "rb" );//ANISEQ02.DAT
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+10, "Cannot open animation sequency data extension file: ", fname );
		return FALSE;
	}
	*/
	FSCAN.scan_open (fname);//lwc
	int nNum, nFile;
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	for( int i=0; i< nNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nFile ));
		//fscanf( fp, "%d,", &nFile );
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,
			"%d,%d,%d,%d,%d,%d,%d\n", 
			&MAP_Lib.AniSeq[nFile].nDeadDir,	// ķ8Ϊ8Ϊʱķ
			&MAP_Lib.AniSeq[nFile].nEventBegin[0],	// ƶ
			&MAP_Lib.AniSeq[nFile].nEventBegin[1],	// 
			&MAP_Lib.AniSeq[nFile].nEventBegin[2],	// 
			&MAP_Lib.AniSeq[nFile].nEventBegin[3],	// 
			&MAP_Lib.AniSeq[nFile].nEventBegin[4],
			&MAP_Lib.AniSeq[nFile].nEventBegin[5] ));
		/*
		fscanf( fp, "%d,%d,%d,%d,%d,%d,%d\n", 
			&MAP_Lib.AniSeq[nFile].nDeadDir,	// ķ8Ϊ8Ϊʱķ
			&MAP_Lib.AniSeq[nFile].nEventBegin[0],	// ƶ
			&MAP_Lib.AniSeq[nFile].nEventBegin[1],	// 
			&MAP_Lib.AniSeq[nFile].nEventBegin[2],	// 
			&MAP_Lib.AniSeq[nFile].nEventBegin[3],	// 
			&MAP_Lib.AniSeq[nFile].nEventBegin[4],
			&MAP_Lib.AniSeq[nFile].nEventBegin[5] );
		// 3
		// ڹˣΪľģʳ
		// ڲΪ
		// 100˲ΪľͶʯ
		// 100˹ΪľͶʯ
		*/

	}
//	fclose( fp );
FSCAN.scan_close ();
	return TRUE;
}
//////////////////////

#ifdef	_GAME_
//////////////////////
// ȡڵ
// read cover file, declared in CBDraw.h
BOOL DRAW_ReadCoverFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[_MAX_FNAME];
	CScan_read FSCAN;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FSCAN.scan_open (fname);
	/*
	FILE * fp = fopen( fname, "rb" );//cover.dat
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+13, "Cannot open cover data file: ", fname );
		return FALSE;
	}
	*/
	memset( &DRAW_CoverLib, 0, sizeof(DRAW_COVER_STRUCT) );

	int i,j;
	for( i=0; i< DRAW_LOCATION_MAX*2; i++ )
	{
		// read covered
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &DRAW_CoverLib.nCoveredMax[i&1][i>>1] ));
		//fscanf( fp, "%d\n", &DRAW_CoverLib.nCoveredMax[i&1][i>>1] );
		for( j=0; j< DRAW_CoverLib.nCoveredMax[i&1][i>>1]; j++ )
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,", 
				&DRAW_CoverLib.ptCovered[i&1][i>>1][j].x,
				&DRAW_CoverLib.ptCovered[i&1][i>>1][j].y ));
			/*
			fscanf( fp, "%d,%d,", 
				&DRAW_CoverLib.ptCovered[i&1][i>>1][j].x,
				&DRAW_CoverLib.ptCovered[i&1][i>>1][j].y );
			*/
		}
		// read covering
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &DRAW_CoverLib.nCoveringMax[i&1][i>>1] ));
		//fscanf( fp, "%d\n", &DRAW_CoverLib.nCoveringMax[i&1][i>>1] );
		for( j=0; j< DRAW_CoverLib.nCoveringMax[i&1][i>>1]; j++ )
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,", 
				&DRAW_CoverLib.ptCovering[i&1][i>>1][j].x,
				&DRAW_CoverLib.ptCovering[i&1][i>>1][j].y ));
			/*
			fscanf( fp, "%d,%d,", 
				&DRAW_CoverLib.ptCovering[i&1][i>>1][j].x,
				&DRAW_CoverLib.ptCovering[i&1][i>>1][j].y );
			*/
		}
	}
//	fclose( fp );
	FSCAN.scan_close ();
	return TRUE;
}// end of DRAW_ReadCoverFile()

///////////
// ȡͼļ
// declared in file CBMAP.cpp
// hwnd			:	ʱھ
// filename		:	Ԫͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadMiniFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[_MAX_FNAME];
	CScan_read FSCAN;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FSCAN.scan_open (fname);
/*	FILE * fp = fopen( fname, "rb" );//minimap.dat
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+5, "Cannot open minimap data file: ", fname );
		return FALSE;
	}
*/
	// initialize
	memset( &MINI_Lib, 0, sizeof( struct MAP_MINI_LIB_STRUCT ) );
	MINI_Lib.nType =-1;

	int nNum;

	// read screen rectangle of battlefield
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d,%d\n", 
		&MINI_Lib.rcScreen.left, 
		&MINI_Lib.rcScreen.top,
		&MINI_Lib.rcScreen.right,
		&MINI_Lib.rcScreen.bottom ));
	/*
	fscanf( fp, "%d,%d,%d,%d\n", 
		&MINI_Lib.rcScreen.left, 
		&MINI_Lib.rcScreen.top,
		&MINI_Lib.rcScreen.right,
		&MINI_Lib.rcScreen.bottom );
	*/
	// read position and size of minimap of each type
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	if( nNum > MAP_MINI_TYPE_MAX )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+6, "read minimap data file error: ", fname );
	}

	// ע⣺ȡĲͼ½꣬ǿȺ͸߶
	for( int i=0; i< nNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d,%d\n", 
			&MINI_Lib.rcMap[i].left, 
			&MINI_Lib.rcMap[i].top,
			&MINI_Lib.rcMap[i].right,
			&MINI_Lib.rcMap[i].bottom ));
		/*
		fscanf( fp, "%d,%d,%d,%d\n", 
			&MINI_Lib.rcMap[i].left, 
			&MINI_Lib.rcMap[i].top,
			&MINI_Lib.rcMap[i].right,
			&MINI_Lib.rcMap[i].bottom );
		*/
		MINI_Lib.rcMap[i].right += MINI_Lib.rcMap[i].left;
		MINI_Lib.rcMap[i].bottom += MINI_Lib.rcMap[i].top;
	}

	// read color table
	FSCAN.l_scan (sscanf (FSCAN.expand_buf, "%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	if( nNum > MAP_MINI_COLOR_MAX )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+7, "read minimap data file error: ", fname );
	}
	for( i=0; i< nNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &MINI_Lib.nColorTable[i] ));
		//fscanf( fp, "%d,", &MINI_Lib.nColorTable[i] );
	}

	//fclose( fp );
	FSCAN.scan_close ();
	return TRUE;
}// end of MAP_ReadMiniFile()
///////////

///////////
BOOL DATA_ReadDATAFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[_MAX_FNAME];
	

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	strcpy( DATA_Lib.strDATA, fname );
	BOOL ret = DATA_ReloadDATAFile( hwnd );
	strcpy( DATA_Lib.strDATA, fname );
	return ret;
}// end of DATA_ReadDATAFile()

BOOL DATA_ReloadDATAFile( HWND hwnd )
{
	char fname[_MAX_FNAME];
	strcpy( fname, DATA_Lib.strDATA );
	CScan_read FSCAN;
	FSCAN.scan_open (fname);
	/*
	FILE * fp = fopen( fname, "rb" );//data.dat
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+8, "Cannot open DATA file: ", fname );
		return FALSE;
	}
	*/
	// initialize
	memset( &DATA_Lib, 0, sizeof(DATA_STRUCT) );
	strcpy( DATA_Lib.strDATA, fname );

	int nNum, i, nNum2;

	// read grade data
	FSCAN.l_scan (sscanf (FSCAN.expand_buf, "%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	for( i=0; i< nNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf, "%s %d %d %d\n",
							  DATA_Lib.Grade[i].strName,
							  &DATA_Lib.Grade[i].nAddWuLi,
							  &DATA_Lib.Grade[i].nAddZhiLi,
							  &DATA_Lib.Grade[i].nGrade
							  ));

		for( int j=0; j<(int)strlen(DATA_Lib.Grade[i].strName); j++ )
		{
			if( DATA_Lib.Grade[i].strName[j] == '$' )
				DATA_Lib.Grade[i].strName[j] = ' ';
		}
		/*
		fscanf( fp, "%s %d %d %d\n",
			DATA_Lib.Grade[i].strName,
			&DATA_Lib.Grade[i].nAddWuLi,
			&DATA_Lib.Grade[i].nAddZhiLi,
			&DATA_Lib.Grade[i].nGrade
			);
		*/
	}

	// read building data
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	//int nsss;
	for( i=0; i< nNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,
			"%d %s %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
			&DATA_Lib.Unit[i].nID,
			DATA_Lib.Unit[i].strName,
			&DATA_Lib.Unit[i].dwLife,
			&DATA_Lib.Unit[i].nFarAttack,
			&DATA_Lib.Unit[i].nNearDefend,
			&DATA_Lib.Unit[i].nFarDefend,
			&DATA_Lib.Unit[i].nViewRange,
			&DATA_Lib.Unit[i].nFightRange,
			&DATA_Lib.Unit[i].nFightSpeed,
			&DATA_Lib.Unit[i].nCreateIron,
			//&nsss,
			//&DATA_Lib.Unit[i].wCreateFood,
			&DATA_Lib.Unit[i].nCreateGold,
			&DATA_Lib.Unit[i].nCreateWood,
			&DATA_Lib.Unit[i].nCreateSpeed,
			&DATA_Lib.Unit[i].nAddExp,		// ٺԷֵ
			&DATA_Lib.Unit[i].nAddMorale	// ٺԷʿӣԼʿ
		));

		for( int j=0; j<(int)strlen(DATA_Lib.Unit[i].strName); j++ )
		{
			if( DATA_Lib.Unit[i].strName[j] == '$' )
				DATA_Lib.Unit[i].strName[j] = ' ';
		}
		/*
		fscanf( fp, "%d %s %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
			&DATA_Lib.Unit[i].nID,
			DATA_Lib.Unit[i].strName,
			&DATA_Lib.Unit[i].dwLife,
			&DATA_Lib.Unit[i].nFarAttack,
			&DATA_Lib.Unit[i].nNearDefend,
			&DATA_Lib.Unit[i].nFarDefend,
			&DATA_Lib.Unit[i].nViewRange,
			&DATA_Lib.Unit[i].nFightRange,
			&DATA_Lib.Unit[i].nFightSpeed,
			&DATA_Lib.Unit[i].nCreateIron,
			//&DATA_Lib.Unit[i].wCreateFood,
			&DATA_Lib.Unit[i].nCreateGold,
			&DATA_Lib.Unit[i].nCreateWood,
			&DATA_Lib.Unit[i].nCreateSpeed,
			&DATA_Lib.Unit[i].nAddExp,		// ٺԷֵ
			&DATA_Lib.Unit[i].nAddMorale	// ٺԷʿӣԼʿ
		);
		*/
	}

	// read soldier data
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &nNum2 ));
	//fscanf( fp, "%d\n", &nNum2 );
	for( i=nNum; i< nNum+nNum2; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,
			"%d %s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
			&DATA_Lib.Unit[i].nID,
			DATA_Lib.Unit[i].strName,
			&DATA_Lib.Unit[i].dwLife,
			&DATA_Lib.Unit[i].nNearAttack,
			&DATA_Lib.Unit[i].nFarAttack,
			&DATA_Lib.Unit[i].nNearDefend,
			&DATA_Lib.Unit[i].nFarDefend,
			&DATA_Lib.Unit[i].nViewRange,
			&DATA_Lib.Unit[i].nFightRange,
			&DATA_Lib.Unit[i].nMoveSpeed,
			&DATA_Lib.Unit[i].nFightSpeed,
			&DATA_Lib.Unit[i].nCreateIron,
			&DATA_Lib.Unit[i].nCreateFood,
			&DATA_Lib.Unit[i].nCreateWood,
			&DATA_Lib.Unit[i].nCreateGold,
			&DATA_Lib.Unit[i].nCreateSpeed,
			&DATA_Lib.Unit[i].nAddExp,		// ٺԷֵ
			&DATA_Lib.Unit[i].nAddMorale	// ٺԷʿӣԼʿ
		));
		for( int j=0; j<(int)strlen(DATA_Lib.Unit[i].strName); j++ )
		{
			if( DATA_Lib.Unit[i].strName[j] == '$' )
				DATA_Lib.Unit[i].strName[j] = ' ';
		}
		/*
		fscanf( fp, "%d %s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
			&DATA_Lib.Unit[i].nID,
			DATA_Lib.Unit[i].strName,
			&DATA_Lib.Unit[i].dwLife,
			&DATA_Lib.Unit[i].nNearAttack,
			&DATA_Lib.Unit[i].nFarAttack,
			&DATA_Lib.Unit[i].nNearDefend,
			&DATA_Lib.Unit[i].nFarDefend,
			&DATA_Lib.Unit[i].nViewRange,
			&DATA_Lib.Unit[i].nFightRange,
			&DATA_Lib.Unit[i].nMoveSpeed,
			&DATA_Lib.Unit[i].nFightSpeed,
			&DATA_Lib.Unit[i].nCreateIron,
			&DATA_Lib.Unit[i].nCreateFood,
			&DATA_Lib.Unit[i].nCreateWood,
			&DATA_Lib.Unit[i].nCreateGold,
			&DATA_Lib.Unit[i].nCreateSpeed,
			&DATA_Lib.Unit[i].nAddExp,		// ٺԷֵ
			&DATA_Lib.Unit[i].nAddMorale	// ٺԷʿӣԼʿ
		);
		*/
	}		

	// read upgrade data
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	for( i=0; i< nNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,
			"%d %d %d %d %d %d %d %d\n",
			&DATA_Lib.Upgrade[i].nGold,
			&DATA_Lib.Upgrade[i].nWood,
			&DATA_Lib.Upgrade[i].nIron,
			&DATA_Lib.Upgrade[i].nFood,
			&DATA_Lib.Upgrade[i].dwParam1,
			&DATA_Lib.Upgrade[i].dwParam2,
			&DATA_Lib.Upgrade[i].dwParam3,
			&DATA_Lib.Upgrade[i].dwParam4
		));
		/*
		fscanf( fp, "%d %d %d %d %d %d %d %d\n",
			&DATA_Lib.Upgrade[i].nGold,
			&DATA_Lib.Upgrade[i].nWood,
			&DATA_Lib.Upgrade[i].nIron,
			&DATA_Lib.Upgrade[i].nFood,
			&DATA_Lib.Upgrade[i].dwParam1,
			&DATA_Lib.Upgrade[i].dwParam2,
			&DATA_Lib.Upgrade[i].dwParam3,
			&DATA_Lib.Upgrade[i].dwParam4
		);
		*/
	}		

	// read general data
	int nGenFile[4]={35,31,33,29};
	nNum = 1, nNum2 = 0;
	for( int j=0; j<4; j++ )
	{
		nNum += nNum2;
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n",&nNum2 ));
		//fscanf( fp, "%d\n", &nNum2 );
		for( i=nNum; i< nNum+nNum2; i++ )
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,
				"%s %d %d %d %d %d\n",
				DATA_Lib.Gen[i].strName,
				&DATA_Lib.Gen[i].nWuLi,
				&DATA_Lib.Gen[i].nZhiLi,
				&DATA_Lib.Gen[i].nType,
				&DATA_Lib.Gen[i].nLevel,
				&DATA_Lib.Gen[i].dwLife
			));
			for( int k=0; k<(int)strlen(DATA_Lib.Gen[i].strName); k++ )
			{
				if( DATA_Lib.Gen[i].strName[k] == '$' )
					DATA_Lib.Gen[i].strName[k] = ' ';
			}
			/*
			fscanf( fp, "%s %d %d %d %d %d\n",
				DATA_Lib.Gen[i].strName,
				&DATA_Lib.Gen[i].nWuLi,
				&DATA_Lib.Gen[i].nZhiLi,
				&DATA_Lib.Gen[i].nType,
				&DATA_Lib.Gen[i].nLevel,
				&DATA_Lib.Gen[i].dwLife
			);
			*/
			DATA_Lib.Gen[i].nLevel--;
			DATA_Lib.Gen[i].dwLife = DATA_Lib.Unit[nGenFile[DATA_Lib.Gen[i].nType-1]].dwLife;
			DATA_Lib.Gen[i].nID = i;
			DATA_Lib.Gen[i].nJunZhu = j+1;
		}		
	}

	FSCAN.scan_close ();
//	fclose( fp );
	return TRUE;
}// end of DATA_ReadDATAFile()

// ΪʹϷٶȼӿһЩҪЧֵWAVļ
// ӲϣֻеӲûЧļʱŴӹ̶ȡԣ
// úڲӦ޸ģⲿӿûб䡣
BOOL DATA_ReadWAVEFile( HWND hwnd, LPCTSTR filename, LPCTSTR path, LPCTSTR pathWAVE )
{
	char fname[_MAX_FNAME];

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	strcpy( DATA_WAVE_Lib.strWAVFile, fname );	// ļ

	char strPath[_MAX_PATH];
	strcpy( strPath, GAME_strSetupDirectory );

	CScan_read FSCAN;
	FSCAN.scan_open (fname);
	/*
	FILE * fp = fopen( fname, "rb" );//wave.dat
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+11, "Cannot open Wave file: ", fname );
		return FALSE;
	}
	*/
	int nNum;
	char strFile[_MAX_FNAME], strFile1[33];
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	for( int i=0; i<nNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%s\n", strFile1 ));
		//fscanf( fp, "%s\n", strFile1 );
		//strcpy( strFile, pathWAVE );
		strcpy( strFile, strPath );
		strcat( strFile, "\\" );
		strcat( strFile, pathWAVE );
		strcat( strFile, strFile1 );
		strcpy( DATA_WAVE_Lib.Music[i].strName, strFile );
	}

	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	for( i=0; i<nNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%s\n", strFile1 ));
		//fscanf( fp, "%s\n", strFile1 );
		//strcpy( strFile, pathWAVE );
/*
		strcpy( strFile, strPath );
		strcat( strFile, "\\" );
		strcat( strFile, pathWAVE );
		strcat( strFile, strFile1 );
*/
		strcpy( strFile, strFile1 );
		strcpy( DATA_WAVE_Lib.Effect[i].strName, strFile );
	}
	FSCAN.scan_close ();
	//fclose( fp );
	return TRUE;
}
/*
BOOL DATA_ReloadWAVEFile( HWND hwnd )
{
	char fname[_MAX_NAME];
	strcpy( fname, DATA_WAVE_Lib.strWAVFile );	// ļ

	FILE * fp = fopen( fname, "rb" );
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+11, "Cannot open Wave file: ", fname );
		return FALSE;
	}

	int nNum;
	fscanf( fp, "%d\n", &nNum );
	char strFile[33], strFile1[33];
	for( int i=0; i<nNum; i++ )
	{
		fscanf( fp, "%s\n", strFile1 );
		strcpy( strFile, pathWAVE );
		strcat( strFile, strFile1 );
		strcpy( DATA_WAVE_Lib.Effect[i].strName, strFile );
	}

	fclose( fp );
	return TRUE;
}
*/
///////////

///////////
BOOL MAP_ReadOtherFile( HWND hwnd, LPCTSTR filename, LPCTSTR pathDAT, LPCTSTR pathBMP )
{
	CScan_read	FSCAN;
	char fname[_MAX_FNAME];
	if( pathDAT != 0 )
	{
		strcpy( fname, pathDAT );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );

	FSCAN.scan_open (fname);//lwc other.dat
	/*FILE * fp = fopen( fname, "rb" );
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+11, "Cannot open Others file: ", fname );
		return FALSE;
	}
	*/
	// initialize
	memset( MAP_Lib.Other, 0, sizeof( MAP_Lib.Other ) );

	char strFile[65];//, strFile1[33];
	// ȡѹĵԪͼļLWC
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%s\n", strFile ));
	//fscanf( fp, "%s\n", strFile );
	strcpy( MAP_Lib.strBMP, GAME.strPathBMP );
	strcat( MAP_Lib.strBMP, strFile );

	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &MAP_Lib.nOtherNum ));
	//fscanf( fp, "%d\n", &MAP_Lib.nOtherNum );	// ȡͼļ
	for( int i=0; i<MAP_Lib.nOtherNum; i++ )
	{
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d,%d\n", 
					  &MAP_Lib.Other[i].nMaxFrame, 
					  &MAP_Lib.Other[i].szItem.cx, &MAP_Lib.Other[i].szItem.cy,
					  &MAP_Lib.Other[i].nID ) );
		/*
		fscanf( fp, "%d,%d,%d,%s\n", &MAP_Lib.Other[i].nMaxFrame, 
			&MAP_Lib.Other[i].szItem.cx, &MAP_Lib.Other[i].szItem.cy,
			strFile1 );
		
		strcpy( strFile, pathBMP );
		strcat( strFile, strFile1 );
		strcat( strFile, ".BMP" );
		strcpy( MAP_Lib.Other[i].strFile, strFile );*/
	}
	FSCAN.scan_close ();
	//fclose( fp );
	return TRUE;
}// end of MAP_ReadOtherFile()

// load all the mouse cursors in system
// used in CBMain.cpp
#include "DDCompo.h"
extern class CDDCursor MAIN_Cursors[4];	// declared in CBMain.cpp
extern CDDPalette pal, palMain;	// defined in CBMain.cpp
BOOL MAIN_LoadCursors( HWND hwnd, LPCTSTR filename , LPCTSTR path )
{
	char  fname[_MAX_FNAME];
	short picture_number;
	CScan_read	FSCAN;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FSCAN.scan_open (fname);//mouse.dat
	/*
	FILE * fp = fopen( fname, "rt" );//mouse.dat
	
	if( !fp )
	{
		ErrorMessage( hwnd, MAP_ERROR_ID+12, "Cannot open cursor map file: ", fname );
		return FALSE;
	}
	*/

	// read cursor one
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n",&picture_number));
	//fscanf( fp, "%s\n", fname );
	int nRow[10] ={4,4,4,4,4,4,4,4,4,4};	// ÿ״̬֡
	POINT ptHot[10]={{1,3},{26,17},{26,17},{26,17},{24,19},{24,19},{26,17},{26,17},{1,3},{26,17}};// ȵ
//	int nRow[1] ={4};	// ÿ״̬֡
//	POINT ptHot[1]={1,3};//,{26,17},{26,17},{24,19},{24,19},{26,17},{26,17}};// ȵ
	if( !MAIN_Cursors[0].LoadEx( "res\\mouse.lwc","res\\mouse.idx", picture_number, 10, nRow, ptHot ) )
	{
		ErrorMessage( hwndGame, MAP_ERROR_ID+20, " Cannot load Cursor file", "mouse" );
			return FALSE;
	}
//	MAIN_Cursors[0].SetSpeed( 3 );
//	MAIN_Cursors[0].SetState( 0 );

	// read cursor two
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n",&picture_number));
	//fscanf( fp, "%s\n", fname );
	int nRow1[8]={1,1,1,1,1,1,1,1};
	POINT ptHot1[8]={{0,0},{10,0},{23,0},{23,10},{23,23},{13,23},{0,23},{0,13}};
	if( !MAIN_Cursors[1].LoadEx( "res\\mouse.lwc","res\\mouse.idx", picture_number,8, nRow1, ptHot1 ) )
	{
		ErrorMessage( hwndGame, MAP_ERROR_ID+21, " Cannot load Cursor file", "mouse" );
			return FALSE;
	}

	// read cursor three
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n",&picture_number));
	//fscanf( fp, "%s\n", fname );
	int nRow2[1]={4};
	POINT ptHot2[1]={{1,3}};
	pal.SetPalette();
	if( !MAIN_Cursors[2].LoadEx( "res\\mouse.lwc","res\\mouse.idx", picture_number, 1, nRow2, ptHot2 ) )
	{
		ErrorMessage( hwndGame, MAP_ERROR_ID+22, " Cannot load Cursor file", fname );
		return FALSE;
	}
	palMain.SetPalette();
	FSCAN.scan_close ();
	//fclose( fp );
	return TRUE;
}

///////////
#endif