/////////////////
// CBMini.h		:	ڡͼ
// v0010		:	Jan.31.1997
// v0011		:	May.5.1997, add blinking on the map, add size of each unit
// written by	:	Liu Gang
// Compiler		:	Visual C++ 4.2 & DirectX
// Library		:	DDraw.lib
// Copyright	:	WayAhead Software Co.Ltd.	1996-1997
/////////////////
// ļжͼĲ

#ifndef	__CBMINI_H__
#define	__CBMINI_H__
////////////////////
#define	MINI_ERROR_ID	1200


////////////////////
// ͼ
extern struct MAP_MINI_LIB_STRUCT MINI_Lib;
////////////////////

BOOL MINI_Load();
void MINI_Release();

// draw from mini surface to back buffer , and to front buffer
// bFront	:	1 for draw to front buffer, 
//				2 for only update to front buffer
//				0 for do not draw to front buffer
// bClearBlink	:	TRUE if should erase blink point array right after drawing blink
void MINI_Update( BOOL bFront = TRUE, BOOL bClearBlink = TRUE );

// draw all the items on the battlefield to buffer
// bDraw	:	TRUE if Draw data from ground data to buffer
//				else erase buffer with black
void MINI_DrawAll( BOOL bDraw = TRUE );

// set unit data and ground data, draw or erase
void MINI_SetUnitData( int nCol, int nRow, int nType, int nLocationSize );
void MINI_SetGroundData( int nCol, int nRow, int nLocationSize );

// if there is a war draw blinking cross on the map
void MINI_SetBlink( int nCol, int nRow );
////////////////////
#endif