/////////////
//	CBMouse.h		:	v0021
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.2 & DirectX
//	Library			:	DDraw.Lib
//	Copyright (C)	:	1996-1997 WayAhead Corporation 
//	v0021			:	Jan.22.1997, devided from CBDraw.cpp
//  v0022			:	Sep.11.1997, HitTestU() parameters changed
/////////////
// header file

#ifndef	__CBMOUSE_H__
#define	__CBMOUSE_H__

//////////////////
// Ч
#define	MOUSE_HITRESULT_NONE	0
#define	MOUSE_HITRESULT_GROUND	1
#define	MOUSE_HITRESULT_UNIT	2

struct MOUSE_HITRESULT_STRUCT
{
	int nType;		// Ŀ
	int nLayer;		// 
	WORD wCode;		// ͼش
	POINT ptHit;	// ͼλãӣ
};

// ʼ̽
void MOUSE_InitByConts();

// 
// pt			:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// pHitResult	:	Ľ
// nLayer		:	ĲȱʡֵΪ2ĵζҪ
// FALSEʱpHitResultЧ
BOOL MOUSE_HitTestG( POINT pt, struct MOUSE_HITRESULT_STRUCT *pHitResult, int nLayer = 2 );

// ⵥԪ
// pt			:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// pHitResult	:	Ľ
// bEnemy		:	ֻѡʱΪ
// FALSEʱpHitResultЧ
BOOL MOUSE_HitTestU( POINT pt, struct MOUSE_HITRESULT_STRUCT *pHitResult, BOOL bEnemy = 0 );

// ȼⵥԪ
// pt			:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// pHitResult	:	Ľ
// bEnemy		:	ֻѡʱΪ
// FALSEʱpHitResultЧ
BOOL MOUSE_HitTestUG( POINT pt, struct MOUSE_HITRESULT_STRUCT *pHitResult, BOOL bEnemy = 0 );

// ȼκⵥԪ
// pt			:	ֱ꣬ӴGetCursorPos()еĵõģԵΪλ
// pHitResult	:	Ľ
// FALSEʱpHitResultЧ
BOOL MOUSE_HitTestGU( POINT pt, struct MOUSE_HITRESULT_STRUCT *pHitResult );
//////////////////

//////////////////
// test mouse dragging
// if mouse left button down, set down flag, begin dragging process
// nPosX, nPosY	:	mouse cursor position
void MOUSE_LeftDown( int nPosX, int nPosY );

// if mouse left button up, clear down flag, end dragging process
// nPosX, nPosY	:	mouse cursor position
// return		:	dragging rectangle
RECT MOUSE_LeftUp( int nPosX, int nPosY );

// if mouse is moving with left button holds down, do dragging process
// nPosX, nPosY	:	mouse cursor position
void MOUSE_IsLeftDown( int nPosX, int nPosY );

// display dragging rectangle to back buffer
void MOUSE_DrawDragRect();

// update dragging rectangle to front buffer
void MOUSE_UpdateDrag();
//////////////////

//////////////////
// test if mouse hit in the minimap
// nPosX,nPosY	:	mouse hit position from screen, in point
// return		:	the relative position to whole battlefield map that mouse hit,
//					in grid
POINT MOUSE_InMiniMap(  int nPosX, int nPosY  );
//////////////////

//////////////////
// change grid position to point position
// ptPos:	grid position
POINT MOUSE_Grid2Point( int nLayer, POINT ptPosG );
//////////////////

//////////////////
// for states of the cursor
#define	MOUSE_STATE_NONE			0
#define	MOUSE_STATE_GONGJI			1	
#define	MOUSE_STATE_GONGJI_END1		2	// Լ
#define	MOUSE_STATE_GONGJI_END2		3	// 
#define	MOUSE_STATE_YUNSONG			4
#define	MOUSE_STATE_YUNSONG_END		5
#define	MOUSE_STATE_EYE				6
#define	MOUSE_STATE_DOWN			7
#define	MOUSE_STATE_JIARU			8
#define	MOUSE_STATE_JIARU_END		9

// nState	:	new state
// bForce	:	TRUE if set the state exactly you give
void MOUSE_SetState( int nState, BOOL bForce = FALSE );

void MOUSE_EnableTest( BOOL bEnable=TRUE );
//////////////////
#endif