/////////////////
// CBOther.cpp	:	v0020
// v0010		:	Mar.21.1997
// v0020		:	May.16.1997, add stone, fixed some bugs
// written by	:	Liu Gang
// Compiler		:	Visual C++ 4.2
// Copyright	:	WayAhead Software Co.Ltd.	1996-1997
/////////////////
// header file
// 𣬹ľʯͶʯѪը꣬ѩݽṹ

#define	OTHER_MAX		100

enum	OTHER_TYPE
{	OTHER_TYPE_NONE=0,
	OTHER_TYPE_BLOOD,
	OTHER_TYPE_MOUSE,
	OTHER_TYPE_FIRE,
	OTHER_TYPE_ARROW,
	OTHER_TYPE_BOMB,
	OTHER_TYPE_STONE,
	OTHER_TYPE_HUOGONG,
	OTHER_TYPE_GUNMU
};

#define	OTHER_FRAME_MAX	12

struct OTHER_STRUCT
{
	int nType;				// ͣЧʱΪOTHER_TYPE_NONE
	int nFile;				// ΪBMP״ֵ̬ΪļţΪCMP״̬Ч
	POINT ptBegin;			// ʼλ
	POINT ptEnd;			// Ŀλ
	POINT ptCur;			// ǰλ
	SIZE szItem;			// ͼεĴС
	int nHit;				// 
	int nCol[OTHER_FRAME_MAX];				// ͼѹеƫ
	int nFrame;				// ǰ֡
	int nMaxFrame;			// ֡
	int nDelay;				// ÿһ֡ʱ
	int nCounter;			// 
	WORD nOwnerID;			// ID
	WORD nTargetID;			// Ŀ굥ԪID
	int nSpeed;				// ƶٶȣĳϵٶ
	float fSin;			// Sin()
	float fCos;			// Cos()
};

extern struct OTHER_STRUCT OTHER[OTHER_MAX];
extern int OTHER_nCounter;

/////////////////
// initialize
void OTHER_InitOther();
/////////////////

/////////////////
// õ
// pOther	:	source structure
// return	:	index in array, -1 if failed
int OTHER_CreateData( struct OTHER_STRUCT *pOther );

// õ
// רΪãDec.8.1997
// pOther	:	source structure
// return	:	index in array, -1 if failed
int OTHER_CreateDataEx( struct OTHER_STRUCT *pOther );

// ɾݣCreateDataӦ
// nIndex	:	index in OTHER array
void OTHER_DestroyData( int nIndex );

// ʼṹ
// pOther	:	source structure
void OTHER_ClearData( struct OTHER_STRUCT *pOther );
/////////////////

/////////////////
// ƶ
// nIndex	:	index in array
// return	:	TRUE if hit
BOOL OTHER_Move( int nIndex );

// õĻϵľ
// ptScreenOff	:	offset of screen relative to the whole map
// nIndex		:	index in array
// return		:	rectangle on screen
RECT OTHER_GetRect( POINT ptScreenOff, int nIndex );

// Ŀĵغ󣬶ԸõϵĵԪʧ
// nIndex	:	index in array
// return	:	TRUE if hit someone
BOOL OTHER_HitStone( int nIndex );

// Ŀĵغ󣬶Ŀ굥Ԫʧ
// nIndex	:	index in array
// return	:	TRUE if hit someone
BOOL OTHER_HitArrow( int nIndex );

// 𹥵Ļ
// nX, nY	:	Żλãӣ
// nLife	:	ʱ䣨֣
// nDai		:	ĴΪ0ʱ
// nNum		:	ĸ19
extern void OTHER_HUOGONG_Set( int nX, int nY, int nLife, int nDai, int nNum );

// Ч
// nIndex	:	index in array
// return	:	TRUE if hit someone
BOOL OTHER_HUOGONG_Hit( int nIndex );

// ɾЧԴԴʹõ
void OTHER_HUOGONG_Die( int nIndex );
/////////////////

