/////////////
//	CBRun.cpp		:	v0040
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.2
//	Copyright (C)	:	1996 WayAhead Corporation
//	v0010			:	Nov.18.1996
//	v0030			:	Apr.2.1997, total changed
//	v0040			:	May.15.1997, fixed bugs in CreateBuild(), 
//						Harvest(), add some features in Repair(), Fight(), OnShip()
/////////////
// implementation file
// moving units, calculating units
// ״ִ̬ģ

#include "stdafx.h"
#include "Assert.h"

#include "CBGame.h"
#include "CBCtrl.h"
#include "CBRun.h"

#include "CBMap.h"
#include "CBData.h"
#include "CBEyes.h"

#include "CBOther.h"
#include "CBDraw.h"
#include "DDCompo.h"

#include "CBBuild.h"	// BUILD_
#include "CBZhenFa.h"	// 

#include "CBShadow.h"	// SHADOW_death(), SHADOW_existent
#include "CBMini.h"		// MINI_SetUnitData()
#include "CBMouse.h"	// MOUSE_SetState()

#include "CBEvent.h"	// ¼EVENT_Fire(), etc.

//////////////////////
//- TianYue
#include "Tai.h"	// ܲ
#include "Temperor.h"
#include "TGeneral.h"
//////////////////////

//////////////////////
// Li Haijun
#include "marco.h"
#include "interfa1.h"
#include "interfac.h"
#include "CBprompt.h"
//////////////////////

//////////////////////
// Dong hai, о㷨
#include "March_n.h"
//extern	BYTE		MARCH_TrackForward[NUMBER_OF_TRACK];//Ϊ洢о켣о·ߵķ仯
#define	__TY_AI__

// ãΪʱִ˫
BOOL RUN_bAUTO = FALSE;

// ãΪʱս
BOOL RUN_DEBUG_bEndGame = FALSE;

extern BOOL RUN_SOUND_bWeAreUnderAttack;	// declared in CBRunOT.cpp
// ʱʱ300
#define	RUN_SOUND_ATTACKDELAY	300
//////////////////////

#include "CBRDelay.h"	// defines
//////////////////////

//////////////////////
// externals
extern int MAP_nLocationNum[4];	// defined in CBMAp.cpp
extern POINT MAP_ptLocation[2][MAP_LOCATION_MAX];
extern RECT DRAW_rcScreen;	// defined in CBDraw.cpp
// defined in CBCtrl.cpp
// ļ
extern int	CTRL_nHitCounter;
// contains the units player want to send command to
// 
// ֻnID
extern struct CTRL_TASK_STRUCT CTRL_hitSrc[CTRL_TASK_LIST_MAX-1];

extern struct CTRL_TASK_SAVE_CMDUNIT CTRL_TASK_saveCmdUnit;

// defined in CBCtrl.cpp, uesed by CreateBuild()
//extern void CTRL_TASK_BuildCommand( int nFile );
extern void CTRL_TASK_BuildCommand( struct UNIT_STRUCT *pUnit );
//////////////////////

//////////////////////
// սǷ, Nov.6.1007
//////////////////////
struct RUN_COUNTDOWN RUN_CountDown[GAME_PLAYER_MAX];
///////////////////////////////
void RUN_EndGame( int bWin );

void RUN_DrawUpAndDown(struct CTRL_FRAME_STRUCT * pDraw);
BOOL RUN_GetNextForward(struct CTRL_FRAME_STRUCT * pDraw,struct UNIT_STRUCT * pUnit);

void RUN_MOULUE_Add();
///////////////////////////////

///////////////////////////////
// ĳԪ״̬һִ
BOOL RUN_RunUnit( int nPlayer, int nUnit );
///////////////////////////////

// ״̬Ĵ
///////////////////////////////
// ״̬YIDONGʱ
// return	:	ƶһʱĿĵʱ
BOOL RUN_MoveUnit( struct UNIT_STRUCT *pUnit );
// ״̬CHANSHENGʱãڽ
void RUN_CreateSoldier( struct UNIT_STRUCT *pUnit );
// ״̬JIANZAOʱãڹ˲ӽ콨
void RUN_CreateBuild( struct UNIT_STRUCT *pUnit );
// ״̬SHANCHUʱ
void RUN_DestroyUnit( struct UNIT_STRUCT *pUnit );
// ǰ״̬GONGJIʱ
void RUN_FightUnit( struct UNIT_STRUCT *pUnit );
// ǰ״̬ZUJIANʱ
void RUN_GroupUnit( struct UNIT_STRUCT *pUnit );
// ǰ״̬JIARUʱ
void RUN_GroupAdd( struct UNIT_STRUCT *pUnit );
// ǰ״̬JIESANʱ
void RUN_GroupSub( struct UNIT_STRUCT *pUnit );
// ǰ״̬XIULIʱ
void RUN_RepairBuild( struct UNIT_STRUCT *pUnit );
// ǰ״̬QXSHENGCHANʱ
void RUN_QXCreateSoldier( struct UNIT_STRUCT *pUnit );
// ״̬QXJIANZAOʱ
void RUN_QXCreateBuild( struct UNIT_STRUCT *pUnit );
// ״̬JIANZAOZHONGʱ
void RUN_CreatingBuild( struct UNIT_STRUCT *pUnit );
// ״̬YUNSONGʱ
void RUN_Harvest( struct UNIT_STRUCT *pUnit );
// ״̬HUISONGʱ
void RUN_ReturnOfTheJedi( struct UNIT_STRUCT *pUnit );
// ״̬TISHENGʱ
void RUN_Upgrade( struct UNIT_STRUCT *pUnit );
// ״̬QXTISHENGʱ
void RUN_QxUpgrade( struct UNIT_STRUCT *pUnit );
// ״̬DUSEʱ
void RUN_Blocked( struct UNIT_STRUCT *pUnit );
BOOL RUN_bBlock;		// ÿֻһ֧ӴӶ״ָ̬

// ״̬YUNZAIʱ
void RUN_OnShip( struct UNIT_STRUCT *pUnit );
// ״̬XIEZAIʱ
void RUN_OffShip( struct UNIT_STRUCT *pUnit );

// ״̬ZHENXINGʱ
void RUN_LineUp( struct UNIT_STRUCT *pUnit );

// ״̬JIESHUʱ, not used now
void RUN_EndAll( struct UNIT_STRUCT *pUnit );

// ״̬KAIMENʱ
void RUN_OpenDoor( struct UNIT_STRUCT *pUnit );

// ״̬JIMOUʱ
void RUN_Strategy( struct UNIT_STRUCT *pUnit );

// ״̬HLUANʱ
void RUN_HLuan( struct UNIT_STRUCT *pUnit );
// ״̬MFUʱ
void RUN_MFu( struct UNIT_STRUCT *pUnit );

// ״̬DANTIAOʱ
void RUN_FightSingle( struct UNIT_STRUCT *pUnit );

// ״̬XIUXIʱ
void RUN_Rest( struct UNIT_STRUCT *pUnit );
///////////////////////////////

// others, defined in CBRunOT.cpp
///////////////////////////////
// Ǯ
BOOL RUN_CREATE_Consume( int nPlayer, int nFile );
// Ǯ
BOOL RUN_CREATE_PayBack( int nPlayer, int nFile );

// õԪĶ
// pUnit	:	ĵԪָ
void RUN_DESTROY_SetAfterLife( struct UNIT_STRUCT *pUnit );

// ʱҪŻ
// pU	:	Ľָ
void RUN_FIGHT_SetFire( struct UNIT_STRUCT *pU );

// ͶʯҪͶʯ
// pUnit	:	Ͷʯ
// pU		:	
void RUN_FIGHT_SetStone( struct UNIT_STRUCT *pUnit , struct UNIT_STRUCT *pU );

// 100˵Ĳ򹭱ʹùľıʱʹùľ
// pUnit	:	Ͷľ
// pU		:	
void RUN_FIGHT_SetGunMu( struct UNIT_STRUCT *pUnit , struct UNIT_STRUCT *pU );

// ڹ֣¥սҪ
// pUnit	:	
// pU		:	
void RUN_FIGHT_SetArrow( struct UNIT_STRUCT *pUnit , struct UNIT_STRUCT *pU );

// սЧ
// pUnit	:	
// pUnit2	:	
// return	:	TRUE if 
BOOL RUN_FIGHT_CalcResult( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pUnit2 );

// Ƿ񵽴Ŀĵ
// return	:	Ӧתķ0-1Ϊ-1ʱδ
int RUN_MOVE_IfArrived( struct UNIT_STRUCT *pUnit );

// ȡԴĶ
// pUnit	:	˲
// pU		:	Դ
int RUN_HARVEST_Build( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU );

//ѲɼԴͻص
// pUnit	:	˲
// pU		:	
// return	:	Ϊʱǻϣ򳬳ֵĴʧ
BOOL RUN_RETURN_Build( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU );

// 
BOOL RUN_REPAIR_Build( struct UNIT_STRUCT *pUnit );

// Ԥ
BOOL RUN_UPGRADE_Pay( int nPlayer, int nTaskIDEx );

// 
//void RUN_UPGRADE_Get( int nPlayer, int nTaskIDEx );
void RUN_UPGRADE_Get( struct UNIT_STRUCT *pUnit );

// ȡǮ
// nTaskIDEx	:	
void RUN_UPGRADE_PayBack( int nPlayer, int nTaskIDEx );
///////////////////////////////

///////////////////////////////
// debug only
void RUN_MoveUnitTest( struct UNIT_STRUCT *pUnit );
///////////////////////////////


///////////////////////////////
//#define	_DEBUG_OFFSET_
#ifdef	_DEBUG_OFFSET_
void TestOff( struct UNIT_STRUCT *pUnit, LPCTSTR info )
{
	Assert( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0 );
	if( !(pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0) )
	{
		pUnit->Draw.ptOff.x = pUnit->Draw.ptOff.y = 0;
//		WriteLogFile( "off.log", info );
	}
}
#endif	//_DEBUG_OFFSET_
///////////////////////////////

///////////////////////////////
// м
int RUN_nCounter = 0;

void RUN_RunUnits()
{
	int i, j;
	int nRun[GAME_PLAYER_MAX]={0,0,0,0,0};

//#undef	__TY_AI__
BOOL nRet;
#ifdef	__TY_AI__

if( RUN_bAUTO == FALSE )
{
	for( int i=0; i<GAME_PLAYER_MAX; i++ )
	{
		if( GAME.Players[i].nType == PLAYER_TYPE_COMPUTER )
		{
			TY_AI( i, GAME.nID );
		}
	}
}
else
{
	for( int i=0; i<GAME_PLAYER_MAX; i++ )
	{
		if( GAME.Players[i].nType == PLAYER_TYPE_COMPUTER )
		{
			Assert( i != GAME.nMe );
			TY_AI( i, GAME.nID );
		}
		else if( GAME.Players[i].nType == PLAYER_TYPE_HUMAN )
		{
			int nMeSave = GAME.nMe;
			BOOL bFind = FALSE;
			for( int j=0; j<GAME_PLAYER_MAX; j++ )
			{
				if( GAME.Players[j].nType == PLAYER_TYPE_COMPUTER )
				{
					GAME.nMe = j;	bFind = TRUE;	break;
				}
			}
			if( bFind == TRUE )
			{
				Assert( i != GAME.nMe );
				TY_AI( i, GAME.nID );
			}
			GAME.nMe = nMeSave;
		}
	}
}
#endif

	// 
	CTRL_STATUS_Main();
	CTRL_TASK_Main();

	RUN_bBlock = 0;	// ״ָ̬־

	for( i=0; i<GAME_PLAYER_MAX; i++ )
	{
		for( j=0; j<PLAYER_UNIT_MAX; j++ )
		{
			if( RUN_RunUnit( i, j ) == TRUE )
			{
				nRun[i]++;
//				if( i == 3 )
//					OutputDebugString("a");
			}
			if( nRun[i] == GAME.Players[i].wUnitCounter )
				break;
		}
	}

	//save file each moment

	if( RUN_nCounter%RUN_ENDGAME_DELAY == 0 
		|| RUN_DEBUG_bEndGame )
	{
		// ¼
		nRet = EVENT_Main( GAME.nID );

		int nEnd = -1;
		// test if should end the game
		if( GAME.nID == 5
				&& ( nRet == 1 || RUN_DEBUG_bEndGame == 2 )  )
		{	// ·֧һ
			nEnd = 2;
			RUN_DEBUG_bEndGame = FALSE;
		}
		else if( GAME.nID == 8
				&& ( nRet == 1 || RUN_DEBUG_bEndGame == 2 )  )
		{	// 
			nEnd = 1;
			RUN_DEBUG_bEndGame = FALSE;
		}
		else if( GAME.nID == 14
				&& ( nRet == 2 || RUN_DEBUG_bEndGame == 2 )  )
		{	// ݵܲѣ֧
			nEnd = 2;
			RUN_DEBUG_bEndGame = FALSE;
		}
		else if( GAME.nID == 29 )
		{
			if ( EYE_IfPlayerIsOver( 2, nRun[2] ) 
				|| RUN_DEBUG_bEndGame == 2 )
			{	// ڴսܲٷ֧һ
				nEnd = 2;
				RUN_DEBUG_bEndGame = FALSE;
			}
			else if ( EYE_IfPlayerIsOver( 1, nRun[1] ) 
				|| RUN_DEBUG_bEndGame == 1 )
			{	// ڴսȨܲٷ֧
				nEnd = 1;
				RUN_DEBUG_bEndGame = FALSE;
			}
		}
		else if( GAME.nID == 30
				&& ( nRet == 1 || RUN_DEBUG_bEndGame == 2 )  )
		{	// ݵܲ
			nEnd = 1;
			RUN_DEBUG_bEndGame = FALSE;
		}
		else if( RUN_DEBUG_bEndGame > 0 )
		{	// һԽ
			nEnd = 1;
			RUN_DEBUG_bEndGame = FALSE;
		}
		else if( EYE_IfPlayerIsOver( GAME.nMe, nRun[GAME.nMe] ) )
		{
			// July 24, 1997
			// ԼĽǮΪ0ʱнݻʱսû
			// 죬Ϸ
			nEnd = 0;// 
		}
		else 
		{
			BOOL bEnd = TRUE;
			for( int i=0; i<GAME_PLAYER_MAX; i++ )
			{
				if( GAME.Players[i].nType == PLAYER_TYPE_NONE 
					|| GAME.nMe == i
					|| GAME.Players[i].wUnitCounter == 0 )
				{	// ޾ԼĳûеԪˣ
					continue;
				}
				if( (GAME.Players[i].nType == PLAYER_TYPE_REMOTE )
					&& EYE_PlayerIsAllied( GAME.nMe, i ) )
				{	// ߲ͬ
					continue;
				}
				// ΪƹһBugʱȻΪ0ʵʽѾΪ0ˡ
				if( nRun[i] == 0 && GAME.Players[i].wGroupCounter >= 1 )
				{
					for( int x = 0; x<PLAYER_GROUP_MAX; x++ )
					{
						if( GAME.Players[i].wGroup[x] != MAP_DATA_NONE )
						{
							struct UNIT_STRUCT *pU=MAP_GetUnit(GAME.Players[i].wGroup[x]);
							if( EYE_IfUnitIsDead(pU) )
							{
								GAME.Players[i].wGroup[x] = MAP_DATA_NONE;
								GAME.Players[i].wGroupCounter --;
							}
						}
					}
				}
				if( EYE_IfPlayerIsOver( i, nRun[i] ) )
				{	// ĳ군ˣ
					continue;
				}
				bEnd = FALSE;
				break;
			}
			if( bEnd == TRUE )
			{
				nEnd = 1;
			}
		}
		if( nEnd != -1 )
			RUN_EndGame( nEnd );	// Խˣ0ʱˣ12Ӯ
	}

	// debug for dead lock
/*	if( nCounter%1000 == 0 )
	{
		GAME_Save( 19 );
	}
*/
	if( RUN_nCounter%RUN_SOUND_ATTACKDELAY == 0 )
	{
		RUN_SOUND_bWeAreUnderAttack = TRUE;	// ش
	}

	if( RUN_nCounter%RUN_MOULUE_DELAY == 0 )
	{
		// Զıֵһμ壬ֻгϵļ
		// Զֵһμʮֻгļ
		RUN_MOULUE_Add();
	
		// µǰѡнıֵ
		if( CTRL_nHitCounter > 0 )
		{
			Assert( CTRL_hitSrc[0].nID != MAP_DATA_NONE );
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
			Assert( pUnit );
			// ڽ״̬ʱıֵ
			if( EYE_IfFocusOnUnit( pUnit )
				&& EYE_IfUnitIsGen( pUnit ) )
			{
				FACE_UpdateRuse( DATA_Lib.Gen[pUnit->Gen.nID].nMouLue );
			}
		}
	}

	RUN_nCounter++;

}

// ÿXнıֵ
void RUN_MOULUE_Add()
{
	int nGenFile[4]={35,31,33,29};
	for( int i=0; i<DATA_UNIT_GENERAL_MAX; i++ )
	{
		if( DATA_Lib.Gen[i].nID == 0 )	continue;
		// ıֵһ
		if( DATA_Lib.Gen[i].bOnBattle == TRUE )
		{	// սϵĽӼıֵ
			//if(	DATA_Lib.Gen[i].nMouLue < DATA_MOULUE_MAX )
			// ıֵǸýֵ215
			if(	DATA_Lib.Gen[i].nMouLue < (DATA_Lib.Gen[i].nZhiLi<<1)+15 )
			{
				DATA_Lib.Gen[i].nMouLue+=5;
			}
		}
		else
		{	// ӽֵֻսĽ
			if( DATA_Lib.Gen[i].dwLife 
				< DWORD(EYE_GetFullLife( -1, nGenFile[DATA_Lib.Gen[i].nType-1] )) )
			{
				DATA_Lib.Gen[i].dwLife+=10;
			}
		}
	}
}

void RUN_EndGame( int bWin )
{
	BOOL	FadeFlag = FALSE;
	FACE_SetProgramState( PROGRAM_STATE_NONE );
	MOUSE_SetState( MOUSE_STATE_NONE, TRUE );

	if( GAME_bNetwork )
		PostMessage(hwndGame, WM_COMMAND, SHOW_BATTLE_RESULT, bWin );
	else
		PostMessage( hwndGame, WM_GAME_END, GAME.nID, bWin );
}
///////////////////////////////


///////////////////////////////
#define	RUN_CLOCK_CIRCLE	20
BOOL RUN_RunUnit( int nPlayer, int nUnit )
{
	struct UNIT_STRUCT *pUnit = &GAME.Players[nPlayer].Unit[nUnit];
	if( pUnit->nType == MAP_UNIT_TYPE_NONE )	return FALSE;

	if( pUnit->bPause == TRUE )
	{
		pUnit->bPause = FALSE;	return FALSE;
	}

	switch( pUnit->Status.nTaskID )
	{
	case	YIDONG:	// ƶ
		RUN_MoveUnit( pUnit );
		break;
	case	SHENGCHAN:	// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_ShengChan\n" );
#endif	//_DEBUG_OFFSET_
		RUN_CreateSoldier( pUnit );
		break;
	case	JIANZAO:	// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_JianZao\n" );
#endif	//_DEBUG_OFFSET_
		RUN_CreateBuild( pUnit );
		break;
	case	SHANCHU:	// ɾ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_ShanChu\n" );
#endif	//_DEBUG_OFFSET_
		RUN_DestroyUnit( pUnit );
		break;
	case	GONGJI:		// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_Gongji\n" );
#endif	//_DEBUG_OFFSET_
		RUN_FightUnit( pUnit );
		break;
	case	ZUJIAN:		// 齨
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_ZuJian\n" );
#endif	//_DEBUG_OFFSET_
		RUN_GroupUnit( pUnit );
		break;
	case	JIARU:		// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_JiaRu\n" );
#endif	//_DEBUG_OFFSET_
		RUN_GroupAdd( pUnit );
		break;
	case	JIESAN:		// ɢ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_JieSan\n" );
#endif	//_DEBUG_OFFSET_
		RUN_GroupSub( pUnit );
		break;
	case	XIULI:		// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_XiuLi\n" );
#endif	//_DEBUG_OFFSET_
		RUN_RepairBuild( pUnit );
		break;
	case	QXSHENGCHAN:// ȡ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_QXShengChan\n" );
#endif	//_DEBUG_OFFSET_
		RUN_QXCreateSoldier( pUnit );
		break;
	case	QXJIANZAO:	// ȡ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_QXJianZao\n" );
#endif	//_DEBUG_OFFSET_
		RUN_QXCreateBuild( pUnit );
		break;
	case	JIANZAOZHONG:// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_JianZaoZhong\n" );
#endif	//_DEBUG_OFFSET_
		RUN_CreatingBuild( pUnit );
		break;
	case	YUNSONG:	// ͣɼ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_Harvest\n" );
#endif	//_DEBUG_OFFSET_
		RUN_Harvest( pUnit );
		break;	
	case	HUISONG:	// ͣɼϺ󣬻ص
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_Harvest\n" );
#endif	//_DEBUG_OFFSET_
		RUN_ReturnOfTheJedi( pUnit );
		break;
	case	TISHENG:	// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_TiSheng\n" );
#endif	//_DEBUG_OFFSET_
		RUN_Upgrade( pUnit );
		break;
	case	QXTISHENG:	// ȡ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_QXTiSheng\n" );
#endif	//_DEBUG_OFFSET_
		RUN_QxUpgrade( pUnit );
		break;
	case	DUSE:		// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_DuSe\n" );
#endif	//_DEBUG_OFFSET_
		RUN_Blocked( pUnit );
		break;
	case	YUNZAI:		// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_YunZai\n" );
#endif	//_DEBUG_OFFSET_
		RUN_OnShip( pUnit );
		break;
	case	XIEZAI:		// ж
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_XieZai\n" );
#endif	//_DEBUG_OFFSET_
		RUN_OffShip( pUnit );
		break;
	case	ZHENXING:	// 
		RUN_LineUp( pUnit );
		break;
	case	KAIMEN:		// 
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "R_Door\n" );
#endif	//_DEBUG_OFFSET_
		RUN_OpenDoor( pUnit );
		break;
	case	QUXIAO:		// ȡ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Quxiao\n" );
#endif	//_DEBUG_OFFSET_
		break;
	case	JIMOU:		// ı
		// ״̬JIMOUʱ
		RUN_Strategy( pUnit );
		break;
	case	HLUAN:		// 
		RUN_HLuan( pUnit );
		break;
	case	MFU:		// 
		RUN_MFu( pUnit );
		break;
	case	DANTIAO:	// 
		RUN_FightSingle( pUnit );
		break;
	case	XIUXI:
		RUN_Rest( pUnit );
		break;
	}


	//- TianYue
	// ܲ,ִһ˵ıܲ
//#define	__TY_AI__
#ifdef	__TY_AI__
	TY_InstanceAI_ForStruct( pUnit );
	GuardTowerProcess(pUnit);
#endif

	// ııԶһ
	if( !EYE_IfUnitIsBuild( pUnit ) )
	{
		for( int i=0; i<CTRL_JIMOU_MAX; i++ )
		{
			if( pUnit->Draw.nSTG[i] == 1 )
			{
				pUnit->Draw.wSTGCounter[i]++;
				if( pUnit->Draw.wSTGCounter[i] >= RUN_TIMEDELAY_STG )
				{
					if( i == YUANSHI )
					{	// ȥӰ
						// ֻҷӰı
						if( GAME.nMe == pUnit->Draw.nPlayer )
						{
							//lwc
							// ʧ
							int nVRange = EYE_GetViewRange( &pUnit->Draw );
							Assert( pUnit->nHasShadow == 1 );
							SHADOW_death (pUnit->Draw.nX,pUnit->Draw.nY,nVRange);
							//lwc
						}
						pUnit->nHasShadow--;
					}
					CTRL_SetSTG( &pUnit->Draw, (CTRL_JIMOU)i, FALSE );
					if( i == YUANSHI )
					{	// Ӱ
						if( GAME.nMe == pUnit->Draw.nPlayer )
						{
							int nSight = EYE_GetViewRange( &pUnit->Draw );
							Assert( pUnit->nHasShadow == 0 );
							SHADOW_existent( pUnit->Draw.nX, pUnit->Draw.nY, nSight );
						}
						pUnit->nHasShadow++;
						// draw to minimap
						MINI_SetUnitData( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nPlayer, pUnit->Draw.nLocationSize );	// for minimap
					}
					else if( i == JILI 
						&& EYE_IfFocusOnUnit( pUnit )
						&& EYE_IfUnitIsGen( pUnit ) )
					{
						FACE_UpdateMorale( EYE_GetMorale( pUnit ) );
					}
				}
			}
		}
	}

//	RUN_MoveUnitTest( pUnit );
//	if( nPlayer == 3 )
//		OutputDebugString( "f" );
	// ԳΪû
	// July 31, 1997, Liu Gang
	if( EYE_IfUnitIsDoor( pUnit ) )
		return FALSE;
	if( EYE_IfUnitIsBuild( pUnit ) )
		return TRUE;// ֻнֵ
	return FALSE;
}
///////////////////////////////

///////////////////////////////
// ״̬YIDONGʱ
BOOL RUN_MoveUnit( struct UNIT_STRUCT *pUnit )
{
	BOOL bStep = FALSE;

#ifdef	_DEBUG
	if( pUnit->Status.nTaskID == QUXIAO )
	{
		OutputDebugString( "RUN_MoveUnit Error(1): no task but still move!\n" );
		return FALSE;
	}
#endif

	if( EYE_IfUnitIsBuild( pUnit ) 
		|| EYE_IfUnitIsSpec( pUnit ) )
	{	// 
		OutputDebugString( "RUN_MoveUnit Error(2): this unit should not move!\n" );
		return FALSE;
	}

	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;
	// move soldiers
	pUnit->nCounter++;

	// save old 1
	pDraw->nXLast = pDraw->nX;
	pDraw->nYLast = pDraw->nY;

	pDraw->ptOffLast.x = pDraw->ptOff.x;
	pDraw->ptOffLast.y = pDraw->ptOff.y;

	int nFrame = pDraw->nFrame;
	POINT ptDD[8] = {{0,-1},{2,-1},{2,0},{2,1},{0,1},{-2,1},{-2,0},{-2,-1}};
	POINT ptDDD[8] = {{0,-2},{1,-1},{2,0},{1,1},{0,2},{-1,1},{-2,0},{-1,-1}};
	int nDirState[8] = {0,1,2,3,4,3,2,1};

	if( pDraw->ptOff.x == 0 && pDraw->ptOff.y == 0 )
	{
		Assert( pUnit->nID == MAP_GetUnitDataEx( pDraw->nX, pDraw->nY ) 
			|| pUnit->nHasShadow == 0 );

		// move 2
		BOOL bChangeDir = FALSE;

		int nDir;
		nDir = RUN_MOVE_IfArrived( pUnit );
		if( nDir != -1 )
		{	// Ŀĵ
			pUnit->Draw.nDir = nDir;
			if( pUnit->Status.nParam4 == DUSE )	// Ԥ
			{
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "AAA1\n" );
#endif	//_DEBUG_OFFSET_
				pUnit->Status.nTaskID = DUSE;	// 
				pUnit->nCounter = 0;
			}
			else
			{
				pUnit->Status.bDone = TRUE;
			}
			return TRUE;
		}
		else
		{
			// set dir
			int nState = pDraw->nState-pDraw->nDir;
			pDraw->nDir = pUnit->MarchTrack[pUnit->StepNum];
			// Dong Hai
			if(RUN_GetNextForward(pDraw,pUnit)==TRUE){return TRUE;}
			// Dong Hai
//			Assert(pDraw->nDir==255);
			
			pUnit->StepNum++;
			// set state
			//pDraw->nState = nDirState[pDraw->nDir];
			pDraw->nState = pDraw->nDir+nState;

			// set current position
			//BOOL bOdd = pDraw->nYLast%2;
			BOOL bOdd = pDraw->nY&1;
			pDraw->nX = (WORD)(pDraw->nX+MAP_ptSenser[bOdd][0][pDraw->nDir].x);
			pDraw->nY = (WORD)(pDraw->nY+MAP_ptSenser[bOdd][0][pDraw->nDir].y);

			// set offset
			pDraw->ptOff.x -= MAP_Lib.szItem.cx*ptDDD[pDraw->nDir].x>>1;
			pDraw->ptOff.y -= MAP_Lib.szItem.cy*ptDDD[pDraw->nDir].y>>1;

			// set move flag
			bStep = TRUE;
		}

		// move data
		if( !bChangeDir )
		{
			int bMove = CTRL_UNIT_Move( pDraw, pUnit->nType );
			if( bMove == 0 )
			{	// ס
				bChangeDir = TRUE;
			}
			else if( bMove == 1 )
			{
				//pUnit->bSlow = FALSE;	
				CTRL_SetSTG( &pUnit->Draw, ZHAOZE, FALSE );
			}
			else if( bMove == 2 )
			{
				//pUnit->bSlow = TRUE;	// 
				CTRL_SetSTG( &pUnit->Draw, ZHAOZE, TRUE );
			}
			else if( bMove > 2 )
			{	// Լĳ
				// ŷŵ
				struct CTRL_TASK_STRUCT Task;
				CTRL_TASK_Clear( &Task );
				Task.nID = bMove;	// ŵID
				Task.nTaskID = KAIMEN;
				Task.bDone = TRUE;
				CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );

				pUnit->StepNum--;
				pDraw->nX = pDraw->nXLast;
				pDraw->nY = pDraw->nYLast;
				pDraw->ptOff.x = pDraw->ptOffLast.x;
				pDraw->ptOff.y = pDraw->ptOffLast.y;

	#ifdef	_MAP_COMPRESS_
				pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+MAP_Lib.AniSeq[pDraw->nFile].nOffset;
				pDraw->nRow = 0;//(WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].y;
	#else
				pDraw->nCol = (WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].x;
				pDraw->nRow = (WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].y;
	#endif
				return FALSE;
			}

		}

		if( bChangeDir )
		{	// ı
			pUnit->StepNum--;
			pDraw->nX = pDraw->nXLast;
			pDraw->nY = pDraw->nYLast;
			pDraw->ptOff.x = pDraw->ptOffLast.x;
			pDraw->ptOff.y = pDraw->ptOffLast.y;

			// Dong Hai
			if(pUnit->MarchTrack[pUnit->StepNum-1]==8)
				{
					pUnit->StepNum--;
					pDraw->nLayer--;
				}
			if(pUnit->MarchTrack[pUnit->StepNum-1]==9)
				{
					pUnit->StepNum--;
					pDraw->nLayer++;
				}
			// Dong Hai

#ifdef	_MAP_COMPRESS_
			pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+MAP_Lib.AniSeq[pDraw->nFile].nOffset;
			pDraw->nRow = 0;//(WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].y;
#else
			pDraw->nCol = (WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].x;
			pDraw->nRow = (WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].y;
#endif
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "AAA2\n" );
#endif	//_DEBUG_OFFSET_
			pUnit->Status.nTaskID = DUSE;	// סˣ
			pUnit->nCounter = 0;
			return TRUE;
		}
	}

#ifdef	_DEBUG
	if( pUnit->StepNum > 0 )
	{
		Assert( pUnit->MarchTrack[pUnit->StepNum-1] == pDraw->nDir );
		if( pUnit->MarchTrack[pUnit->StepNum-1] != pDraw->nDir )
		{
			pDraw->nDir = pUnit->MarchTrack[pUnit->StepNum-1];
//			WriteLogFile( "off.log", "Dir\n" );
		}
	}
#endif
	Assert( abs(pDraw->ptOff.x)==abs(pDraw->ptOff.y)*2
		|| pDraw->ptOff.x==0 || pDraw->ptOff.y==0  );

#ifdef	_DEBUG_OFFSET_
	if(	!(abs(pDraw->ptOff.x)==abs(pDraw->ptOff.y)*2
		|| pDraw->ptOff.x==0 || pDraw->ptOff.y==0) )
	{
//		WriteLogFile( "off.log", "abs\n" );
	}
#endif // _DEBUG_OFFSET_
	// move 1
//	if( pUnit->bSlow == FALSE 
	int bFast = -1;
	if( EYE_IfUnitIsCavalry( pUnit ) )
		bFast = 2;
	else
		bFast = 1;
	if( CTRL_GetSTG( &pUnit->Draw, ZHAOZE ) == TRUE )
	{
		bFast--;
	}
	if( CTRL_GetSTG( &pUnit->Draw, JIANSU ) == TRUE )
		bFast = 0;
	else if( CTRL_GetSTG( &pUnit->Draw, JIASU ) == TRUE )
		bFast = 2;

	if( bFast != 0 || ((pUnit->nCounter&1) == 1 && bFast == 0) )
	{
		if( bFast == 2 )
		{
			if( pDraw->ptOff.x == 2 || pDraw->ptOff.x == -2 
				|| pDraw->ptOff.y == 1 || pDraw->ptOff.y == -1 )
			{
				pDraw->ptOff.x = 0, pDraw->ptOff.y = 0;
			}
			else
			{
				pDraw->ptOff.x += ptDD[pDraw->nDir].x<<1;
				pDraw->ptOff.y += ptDD[pDraw->nDir].y<<1;
			}
		}
		else
		{
			pDraw->ptOff.x += ptDD[pDraw->nDir].x;
			pDraw->ptOff.y += ptDD[pDraw->nDir].y;
		}

		// Dong Hai
		RUN_DrawUpAndDown(pDraw);
		// Dong Hai

		// change frame
		if( MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState] != 0 
			&& (pUnit->nCounter&1) == 1 )
			pDraw->nFrame = ( nFrame+1 )%MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState];
	#ifdef	_MAP_COMPRESS_
		pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+MAP_Lib.AniSeq[pDraw->nFile].nOffset;
		pDraw->nRow = 0;//(WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].y;
	#else
		pDraw->nCol = (WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].x;
		pDraw->nRow = (WORD)MAP_Lib.AniSeq[pDraw->nFile].ptAniSeq[pDraw->nState][pDraw->nFrame].y;
	#endif

	}
	Assert( pDraw->ptOff.x >= -44 && pDraw->ptOff.y <= 44 
		&& pDraw->ptOff.y >= -22 && pDraw->ptOff.y <= 22 );

#ifdef	_DEBUG_OFFSET_
	if( !(pDraw->ptOff.x >= -44 && pDraw->ptOff.y <= 44
		&& pDraw->ptOff.y >= -22 && pDraw->ptOff.y <= 22) )
	{
		pUnit->Draw.ptOff.x = pUnit->Draw.ptOff.y = 0;
//		WriteLogFile( "off.log", "Move\n" );
	}
#endif //_DEBUG_OFFSET_
	return bStep;
}


void RUN_MoveUnitTest( struct UNIT_STRUCT *pUnit )
{
}
///////////////////////////////

///////////////////////////////
// ״̬JIANZAOʱ
// Ҫ裺
//	1Ƿǵһν뽨캯
//	1.1жǷѾý
//	1.1.1񣬽ýͬӵʿ죩λ
//	1.1.2ǣжǷѾڸýڲ
//	1.1.2.1Լ
//	2Ѫ
//	3ýѪǷ
//	3.1ǣ״̬
//	41

// ע⣺1.1.1޸˱ʿͽ
void RUN_CreateBuild( struct UNIT_STRUCT *pUnit )
{
	WORD arTroop[GENERAL_TROOP_MAX];
	int nTrp;
	struct UNIT_STRUCT *pU=NULL;	// Ľָ룬ʿָ룬ָ
	int i, j;

	//added by tian yue
	int nJingYanGrade[10]={200,500,1000,1800,3000,5000,8000,12000,18000,27000};

	Assert( EYE_IfUnitIsWorker( pUnit ) 
		|| EYE_IfUnitIsWorkerGen( pUnit ) );

	//	1Ƿǵһν뽨캯
	if( pUnit->nCounter == 0 )
	{	// һʱҪõԪ
		// ڹ˲ӣֻеһĿĵص˲ܴõԪ

		//	1.1жǷѾý
		if( pUnit->Task.nTaskIDEx == 1 )
 		{
			if( !RUN_CREATE_IfEnoughMoney( pUnit->Draw.nPlayer, pUnit->Status.nTaskIDEx2 ) )
			{	// Ǯˣ
				pUnit->Status.bDone = TRUE;
				return;
			}

			if( EYE_GetGeneral( pUnit ) == NULL )
			{	// ûнˣ
				pUnit->Status.bDone = TRUE;
				return;
			}

			if( pUnit->Status.nParam2 != pUnit->Draw.nX
				|| pUnit->Status.nParam3 != pUnit->Draw.nY )
			{
#ifdef	_DEBUG
				for( int x=0; x<PLAYER_UNIT_MAX; x++ )
				{
					struct UNIT_STRUCT *pUB = &GAME.Players[pUnit->Draw.nPlayer].Unit[x];
					Assert( pUB->Draw.nFile != pUnit->Task.nTaskIDEx2 
						|| pUB->Status.nTaskID != JIANZAOZHONG 
						|| pUnit->Status.nParam2 != pUB->Draw.nX 
						|| pUnit->Status.nParam3 != pUB->Draw.nY );
				}
#endif
				//pUnit->Status.bDone = TRUE;
				// ö
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Build\n" );
#endif	//_DEBUG_OFFSET_
				pUnit->Status.nTaskID = DUSE;	// 
				pUnit->nCounter = 0;
				return;
			}
			//	1.1.1񣬽ýͬӵʿ죩λ
			// ߵĿĵأʾû
			// set player
			// ҪĽϷ

			DWORD codeU = MAP_Lib.Unit[pUnit->Status.nTaskIDEx2].nItems[0];
			struct MAP_UNIT_CODE_STRUCT stctU;
			MAP_UnitDeCode( codeU, &stctU );
			stctU.nPlayer = pUnit->Draw.nPlayer;
			codeU = MAP_UnitEnCode( stctU );

			if( EYE_IfUnitIsSoldier( pUnit ) )
			{
				pU = MAP_GetUnit( pUnit->Soldier.nGenID );
				if( pU == NULL || EYE_IfUnitIsDead( pU ) )	// ûˣ
				{
					pUnit->Status.bDone = TRUE;
					return;
				}
			}
			// õͬһӵԪ
			nTrp = GENERAL_TROOP_MAX;
			EYE_GetUnitInGroup( 1, pUnit->nID, arTroop, &nTrp );
			Assert( nTrp >= 0 );

			// ˴Ƿܹ콨
			int  nXNext, nYNext;
			BOOL bOdd = pUnit->Draw.nY&1;
			BOOL bSame = TRUE;
			WORD codeUEx;
			for( i=0; i< MAP_nLocationNum[MAP_Lib.Unit[stctU.nFile].nLocationSize]; i++ )
			{
				nXNext = pUnit->Draw.nX + MAP_ptLocation[bOdd][i].x;
				nYNext = pUnit->Draw.nY + MAP_ptLocation[bOdd][i].y;
				codeUEx = MAP_GetUnitDataEx( nXNext, nYNext );
				if( codeUEx != MAP_DATA_NONE )
				{	// Ӧý콨λԪ
					bSame = FALSE;
					if( codeUEx == pUnit->nID )
					{
						bSame = TRUE;	// Լ
					}
					// õ
					else if( EYE_IfUnitIsSoldier( pUnit ) 
						&& codeUEx == pUnit->Soldier.nGenID )
					{	// ԪǱӵĽ
						bSame = TRUE;	// ԼĽ
					}
					else
					{
						for( j=0; j<nTrp; j++ )
						{
							if( codeUEx == arTroop[j] )
							{	// ԪǱӵģԺ
								bSame = TRUE;	break;
							}
						}
					}
					if( !bSame )	break;
					// ӵʿߵˣ
					// ǿֹƶ뽨״̬
					pU = MAP_GetUnit( codeUEx );
					Assert( pU );
					Assert( !EYE_IfUnitIsDead( pU ) );
					if( pU->Task.nTaskID != JIANZAO )
					{
						bSame = FALSE;
						break;	// ǽ
					}

					// ﲻԼ
					if( pU->Status.nTaskID != JIANZAO )
					{	
						Assert( pU->Task.bIRQ == FALSE );
						Assert( pU->Status.bIRQ == FALSE );
						//pU->Status.bDone = TRUE;

						// ò
//						pU->Task.bIRQ = TRUE;	// δ״̬òж
						pU->Draw.ptOff.x = pU->Draw.ptOff.y = 0;

						// Ӧ AAA
						//---
						// ߽
						CTRL_UNIT_InUnit( pU );	
						// ж
						pU->Status.bIRQ = TRUE;
						//---
					}
				}
			}
			if( !bSame )
			{	// Ӧý콨λзǱӵԪʧ
				OutputDebugString( "RUN_CreateUnit Error(5): cannot build here!\n" );
				pUnit->Status.bDone = TRUE;
				goto CREATE_FAILED;
			}

			pU->Draw.ptOff.x = pU->Draw.ptOff.y = 0;
			//---
			// Լ߽
			CTRL_UNIT_InUnit( pUnit );
			// ԼΪж
			pUnit->Status.bIRQ = TRUE;
			//---

			// create
			// Ԫ
			Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
			int ret = CTRL_UNIT_Create( pUnit->Status.nParam1, pUnit->Status.nParam2, pUnit->Status.nParam3, codeU, FALSE );
			//BOOL ret = CTRL_UNIT_Create( pUnit->Draw.nLayer, pUnit->Draw.nX, pUnit->Draw.nY, codeU, FALSE );
			if( ret == MAP_DATA_NONE )	goto CREATE_FAILED;	// ʧ

			// Ǯ
			if( !RUN_CREATE_Consume( stctU.nPlayer, stctU.nFile ) )
			{
				Assert( 1==0 );	// ûǮ
				goto CREATE_FAILED;		// ûǮ
			}

			// øýԪѪ
			// Warning : ﶨһⲿͬıд
			//			뿴
			//struct UNIT_STRUCT *pU = MAP_GetUnit( ret );
			pU = MAP_GetUnit( ret );
			Assert( pU );
			Assert( EYE_IfUnitIsBuild( pU ) );
			pU->nLife = 0;
			pU->Draw.nCol = 1 + MAP_Lib.AniSeq[26].nOffset;	// óʼ֡
			pU->Draw.nRow = 0;

			// øý
			struct CTRL_TASK_STRUCT Task;
			CTRL_TASK_Clear( &Task );
			Task.nID = pU->nID;
			Task.nTaskID = JIANZAOZHONG;
			Task.nTaskIDEx = pUnit->nID;
			Task.bIRQ = TRUE;
			Task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
			// Aug.8, ͣһ֣Ϊ޸һǰ깤Bug
			pU->bPause = TRUE;

			// ɹĻҪµʿnTaskIDExΪõԪID
			// ǳṹĵطӦڴ˴޸ĵԪṹ
			// ʿҪҵ죬ڽʿnTaskIDExΪõԪID
			for( i=0; i<nTrp; i++ )
			{
				pU = MAP_GetUnit( arTroop[i] );
				Assert( pU );
				Assert( EYE_IfUnitIsSoldier( pU ) );
				// δĿĵصĵԪµ
				// nTaskIDExдŵƶʽĿĵǵԪ
				// nParam1дŵ½ĽID
				//		Ԫ״̬ƶжϳǷߵ½Ľƶ״̬
				//		״̬ѾǽˣnTaskIDExãnParam1ֱ֪½ĽΪѪ

				// ע⣺
				// ֻиõԪҲǽ񣬶δ뽨ʱЧBug
				if( pU->Task.nTaskID == JIANZAO )
				{
					if( pU->Status.bIRQ == FALSE )
					{	
						//pU->Status.nTaskID = DUSE;
						//pU->nCounter = 0;
						pU->bPause = 1;	// ͣ
						//pU->Draw.ptOff.x = pU->Draw.ptOff.y = 0;
						//pU->Status.nTaskID = JIANZAO;
						//pU->Status.bDone = TRUE;	// ǰ
						struct CTRL_TASK_STRUCT task;
						CTRL_TASK_Clear( &task );
						task.nID = pU->nID;
						task.nTaskID = JIANZAO;
						task.nTaskIDEx = 2;	// MOUSE_HITRESULT_UNIT
						task.nParam1 = ret;
						task.bDone = TRUE;
						CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &task );
					}
					else if( pU->Status.nTaskIDEx == 1 )	// Ѿڽڲ
					{// Լ
						pU->Status.nTaskID = JIANZAO;
						pU->Task.nTaskIDEx = 2;
						pU->Status.nTaskIDEx = 2;
						pU->Task.nParam1 = ret;
						pU->Status.nParam1 = ret;
						pU->nCounter = 0;
						pU->Task.bDone = 0;
						Assert( pU->Status.bDone == FALSE );
					}
				}
				else
				{
					OutputDebugString( "c" );
				}
			}

			// õԪĽ
			pU = EYE_GetGeneral( pUnit );
			Assert( pU );
			Assert( EYE_IfUnitIsWorkerGen( pU ) );
			// ڴ֮nTaskIDExݴŸõԪID
			// ǳṹĵطӦڴ˴޸ĵԪṹ
			// nTaskIDExдŵƶʽĿĵǵԪ
			// nParam1дŵ½ĽID
			//		Ԫ״̬ƶжϳǷߵ½Ľƶ״̬
			//		״̬ѾǽˣnTaskIDExãnParam1ֱ֪½ĽΪѪ

			// ע⣺
			// ֻиõԪҲǽ񣬶δ뽨ʱЧBug
			if( pU->Task.nTaskID == JIANZAO )
			{
				if( pU->Status.bIRQ == FALSE )
				{
					//pU->Status.nTaskID = DUSE;
					//pU->nCounter = 0;
					pU->bPause = 1;	// ͣ
					//pU->Draw.ptOff.x = pU->Draw.ptOff.y = 0;
					//pU->Status.nTaskID = JIANZAO;
					//pU->Status.bDone = TRUE;	// ǰ
					struct CTRL_TASK_STRUCT task;
					CTRL_TASK_Clear( &task );
					task.nID = pU->nID;
					task.nTaskID = JIANZAO;
					task.nTaskIDEx = 2;	// MOUSE_HITRESULT_UNIT
					task.nParam1 = ret;
					task.bDone = TRUE;
					CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &task );
				}
				else if( pU->Status.nTaskIDEx == 1 )	// Ѿڽڲ
				{	// Լ
					pU->Status.nTaskID = JIANZAO;
					pU->Task.nTaskIDEx = 2;
					pU->Status.nTaskIDEx = 2;
					pU->Task.nParam1 = ret;
					pU->Status.nParam1 = ret;
					pU->nCounter = 0;
					pU->Task.bDone = 0;
					Assert( pU->Status.bDone == FALSE );
				}
			}
			else
			{
				OutputDebugString( "c" );
			}

			if( EYE_IfFocusOnUnit( pUnit ) )
			{	// ó
				if( EYE_IfSheIsMine( pUnit ) )
				{
					CTRL_TASK_ClearAssembleSrc( TRUE );
					CTRL_TASK_ClearAssembleDest();

					// ȡͼ
					if( BUILD_IfEnable() )
					{
						BUILD_Enable( FALSE );
					}

					// 
					FACE_ShowCommandUnit( COMMANDUNIT_NONE, 0xFFFF ); // clear command sets
				}
				// ϢҶҪ
				struct	PROMPT_BLOCK	temp;
				temp.PromptBlockId = PROMPT_NONE;	
				FACE_ShowPromptBlock( temp );
			}
		}
		else
		{
			Assert( pUnit->Draw.nLocationSize == 0 );
			Assert( pUnit->Status.nTaskIDEx == 2 );
			Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
			Assert( pUnit->Status.nParam1 != 0 );
			pU = MAP_GetUnit( pUnit->Status.nParam1 );
			Assert( pU );
			if( EYE_IfUnitIsDead( pU ) )
			{	// Ѿ
				if( pUnit->nHasShadow == 0 )
				{
					//---
					// ߳
					if( CTRL_UNIT_OutUnit( pUnit ) )
					{
						pUnit->Status.bIRQ = FALSE;
					//---
						pUnit->Status.bDone = TRUE;
						return;
					}
				}
			}
			//	1.1.2ǣжǷѾڸýڲ
			// ˲ӣʿͽ죩ڽ콨ʱҪԼλõϵͳ棬
			// 蹤ֻռһ
			// Ѿڽˣ򲻽д˲
			//if( pUnit->Status.bIRQ == FALSE )
			if( pUnit->nHasShadow == 1 )	// ڽ
			{

#ifdef	_DEBUG_OFFSET_
				TestOff( pUnit, "Build\n" );
#endif	//_DEBUG_OFFSET_
				//---
				// ߽
				//CTRL_UNIT_InUnit( pUnit, TRUE );	
				CTRL_UNIT_InUnit( pUnit );	
				// ԼΪж
				pUnit->Status.bIRQ = TRUE;
				//---
				Assert(pUnit->Task.bIRQ == FALSE );	
			}
			else
			{
				Assert(pUnit->Status.bIRQ == TRUE );	
			}
		}
	}	// End of if( pUnit->nCounter == 0 )
	else if( (pUnit->nCounter%4) == 0 )
	{
		//	2Ѫ
		// ԺÿӸõԪѪ
		Assert( pUnit->Draw.nLocationSize == 0 );
		Assert( pUnit->Status.nParam1  != MAP_DATA_NONE );
		Assert( pUnit->Status.nParam1  != 0 );
		struct UNIT_STRUCT *pCreated = MAP_GetUnit( pUnit->Status.nParam1 );
		Assert( pCreated );

		//	3ýѪǷ
		// Ѫˣ
		BOOL bDead = EYE_IfUnitIsDead( pCreated );
		if( bDead	// ýѾݻ
			|| pCreated->Status.nTaskID != JIANZAOZHONG )
		{
			// ڹ˲ӣҪûȥ
			Assert( pUnit->Draw.nLocationSize == 0 );

			//---
			// ߳
			if( CTRL_UNIT_OutUnit( pUnit ) )
			{
				// ж
				pUnit->Status.bIRQ = FALSE;
				Assert( pUnit->nHasShadow == 1 );
				//---
				pUnit->Status.bDone = TRUE;
			}

			//added by tian yue .
			if( bDead == TRUE
				|| pCreated->Status.nTaskID == QXJIANZAO )
			{
			}
			else
			{	// 
				pUnit->Task.nParam4 = JZFINISH;
				if( EYE_IfUnitIsWorkerGen( pUnit ) )
				{
					TY_IDProcess(pCreated->nID,pUnit->Task.nParam4,CBNULL);
					// Nov.6.1997
					// սǷ
					RUN_CountDown[pCreated->Draw.nPlayer].nBuildings ++;

					// ֵ
					DATA_Lib.Gen[pUnit->Gen.nID].nJingYan += 
					DATA_Lib.Unit[pCreated->Draw.nFile].nAddExp;

					//added by tian yue.
					// 
					if( DATA_Lib.Gen[pUnit->Gen.nID].nLevel < 9 )
					{
						if( DATA_Lib.Gen[pUnit->Gen.nID].nJingYan >= nJingYanGrade[DATA_Lib.Gen[pUnit->Gen.nID].nLevel] )
						{
							DATA_Lib.Gen[pUnit->Gen.nID].nJingYan -= nJingYanGrade[DATA_Lib.Gen[pUnit->Gen.nID].nLevel];
							DATA_Lib.Gen[pUnit->Gen.nID].nLevel++;

							//ҽսӢ£ն࣬һ
							if( EYE_IfFocusOnUnit( pUnit ) && EYE_IfSheIsMine( pUnit ) )
							{
								FACE_ShowPromptInfor( 12 );
								//---- ϶Ч
								// victory.wav
								DATA_WAVE_EffectPlay( 106 );
								//---- ϶Ч
							}
						}
					}
				}
			}

#ifdef	_DEBUG
			int nXNext, nYNext;
			int bOdd = pCreated->Draw.nY&1;
			for( i=0; i< MAP_nLocationNum[pCreated->Draw.nLocationSize]; i++ )
			{
				nXNext = pCreated->Draw.nX + MAP_ptLocation[bOdd][i].x;
				nYNext = pCreated->Draw.nY + MAP_ptLocation[bOdd][i].y;
				Assert( (!EYE_IfUnitIsDead( pCreated )
					&&(pUnit->Draw.nX != nXNext || pUnit->Draw.nY != nYNext))
					|| EYE_IfUnitIsDead( pCreated ) );
			}
			OutputDebugString( "RUN_CreateUnit Status(0): Unit created!\n" );
#endif
		}
		else
		{	// ӽѪ
			pCreated->nLife += RUN_CREATE_VALUE;
		}
	}

	//	41
	pUnit->nCounter++;
	return;

CREATE_FAILED:

	// ʧܣ˳
	// ʧܵĻҪµʿbDoneΪ棬ǵĲ
	for( i=0; i<nTrp; i++ )
	{
		pU = MAP_GetUnit( arTroop[i] );
		Assert( pU );
		Assert( EYE_IfUnitIsSoldier( pU ) );
		if( pU->Task.nTaskID == JIANZAO )
		{
			if( pU->nHasShadow == 0 )
			{	
				// Ӧ AAA
				Assert( pU->Status.nTaskID != JIANZAO 
					|| pU == pUnit );

				//---
				// ߳
				if( CTRL_UNIT_OutUnit( pU ) )
					pU->Status.bIRQ = FALSE;
				//---
			}

#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "BuildFail\n" );
#endif	//_DEBUG_OFFSET_
			Assert( pU->Status.bIRQ == FALSE );
			pU->bPause = 1;
//			pU->Status.nTaskID = DUSE;
//			pU->nCounter = 0;

			//pU->Status.nTaskID = JIANZAO;
			//pU->Status.bDone = TRUE;	// ǰ
			//Assert( pU->Status.bIRQ == FALSE );
			struct CTRL_TASK_STRUCT Task;
			CTRL_TASK_Clear( &Task );
			Task.nID = pU->nID;
			Task.nTaskID = JIESHU;
			Task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pU->Draw.nPlayer, &Task );
		}
	}
	
	// ʿҪĽ
	pU = EYE_GetGeneral( pUnit );
	if( pU )
	{
		Assert( EYE_IfUnitIsWorkerGen( pU ) );
		if( pU->Task.nTaskID == JIANZAO )
		{
			if( pU->nHasShadow == 0 )
			{
				// Ӧ AAA
				Assert( pU->Status.nTaskID != JIANZAO );
				//---
				// ߳
				if( CTRL_UNIT_OutUnit( pU ) )
					pU->Status.bIRQ = FALSE;
				//---
			}

			Assert( pU->Status.bIRQ == FALSE );
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "BuildFail2\n" );
#endif	//_DEBUG_OFFSET_
			pU->bPause = 1;
//			pU->Status.nTaskID = DUSE;
//			pU->nCounter = 0;

			//pU->Status.nTaskID = JIANZAO;
			//pU->Status.bDone = TRUE;	// ǰ
			//Assert( pU->Status.bIRQ == FALSE );
			struct CTRL_TASK_STRUCT Task;
			CTRL_TASK_Clear( &Task );
			Task.nID = pU->nID;
			Task.nTaskID = JIESHU;
			Task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pU->Draw.nPlayer, &Task );
		}
	}
	OutputDebugString( "RUN_CreateUnit Error(0): Cannot create unit!\n" );

	//added by tian yue
	TY_IDProcess(CBNULL,BUILDDESTROY,CBNULL);

	return;
}

// ״̬SHENGCHANʱ
// ʿ
//岽裺
//	1Ƿǵһν뽨캯
//	2ʿѪ
//	3ʿѪǷ
//	41

// ע⣺޸StatusnParam4ΪʿѪ
//		޸StatusnTaskIDEx2Ϊʿѹ
void RUN_CreateSoldier( struct UNIT_STRUCT *pUnit )
{
	int ret;
	Assert( pUnit );
	Assert( EYE_IfUnitIsBuild( pUnit ) );

	//	1Ƿǵһν뽨캯
	if( pUnit->nCounter == 0 )
	{	// һʱҪõԪ

		// set player
		// ҪĽϷ
		DWORD codeU = MAP_Lib.Unit[pUnit->Status.nTaskIDEx].nItems[0];
		struct MAP_UNIT_CODE_STRUCT stctU;
		MAP_UnitDeCode( codeU, &stctU );
		stctU.nPlayer = pUnit->Draw.nPlayer;
		codeU = MAP_UnitEnCode( stctU );

		// Ǯ
		if( !RUN_CREATE_Consume( stctU.nPlayer, stctU.nFile ) )
		{
			pUnit->Status.bDone = TRUE;
			return;
		}

		// õѪ
		pUnit->Status.nTaskIDEx2 = codeU;
		pUnit->Status.nParam4 = EYE_GetFullLife( stctU.nPlayer, stctU.nFile );
		//	41
		pUnit->nCounter++;

		pUnit->Status.bIRQ = TRUE;
		if( EYE_IfSheIsMine( pUnit ) 
			&& EYE_IfFocusOnUnit( pUnit ) )
		{
			// Ϣ
			struct	PROMPT_BLOCK	temp;
			temp.PromptBlockId = PROMPT_CONSTRUCTION_WORKING;
			temp.PromptBlockUnion.Construction_Working.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
			temp.PromptBlockUnion.Construction_Working.ConstructionGrade = pUnit->Build.dwUpgrade[0];	//???ļ
			temp.PromptBlockUnion.Construction_Working.Stone = 
				pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);;	// Լֵ
			struct MAP_UNIT_CODE_STRUCT stctU;
			MAP_UnitDeCode( pUnit->Status.nTaskIDEx2, &stctU ); 
			temp.PromptBlockUnion.Construction_Working.ProductBitmapId = stctU.nFile;	// ʿļ
			strcpy( temp.PromptBlockUnion.Construction_Working.ConstructionName, 
				DATA_Lib.Unit[pUnit->Draw.nFile].strName );						// Լ
			temp.PromptBlockUnion.Construction_Working.Percent = pUnit->nCounter*100/pUnit->Status.nParam4;	// ɶ
			FACE_ShowPromptBlock( temp );

			// 
			CTRL_TASK_saveCmdUnit.Busy = 1;	// ȡ
			FACE_ShowCommandUnit( COMMANDUNIT_CANCEL, 0xFFFF ); // clear command sets
			//CTRL_TASK_ClearAssembleDest();
		}
	}	// End of if( pUnit->nCounter == 0 )
	else
	{
		// ԺÿӸõԪѪ
		//	2ʿѪ;	41
		pUnit->nCounter++;
		if( EYE_IfFocusOnUnit( pUnit ) 
			&& EYE_IfSheIsMine( pUnit ) )
		{
			// Ѫ
			FACE_ShowProcessBar( PROCESSBAR_PROCESS, pUnit->nCounter*100/pUnit->Status.nParam4 );
		}

		//	3ʿѪǷ
		// Ѫˣ
		if( pUnit->nCounter >= pUnit->Status.nParam4 )
		{
			pUnit->Status.bIRQ = FALSE;
			Assert( pUnit->nHasShadow == 1 );
			
			if( EYE_IfSheIsMine( pUnit ) )
			{
				//------------Ч
				// XRj.wav, ѵ
				int nID = 87;
				DATA_WAVE_EffectPlay( nID );
				//------------Ч
				//------------ʾ
				FACE_ShowPromptInfor( nID-82 ) ;
				//------------ʾ
			}


			if( EYE_IfFocusOnUnit( pUnit ) 
				&& EYE_IfSheIsMine( pUnit ) )
			{
				// Ϣ
				struct	PROMPT_BLOCK	temp;
				temp.PromptBlockId = PROMPT_CONSTRUCTION_IDLESS;	
				temp.PromptBlockUnion.Construction_Idless.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
				strcpy( temp.PromptBlockUnion.Construction_Idless.ConstructionName, 
						DATA_Lib.Unit[pUnit->Draw.nFile].strName );		// Լ
				if( pUnit->Draw.nFile == 22 )	// 
					temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.nResource;	// ԴĴ
				else
					temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.dwUpgrade[0];	// Լļ
				temp.PromptBlockUnion.Construction_Idless.Stone = 
					pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile );	// Լֵ
				FACE_ShowPromptBlock( temp );

				// 
				CTRL_TASK_saveCmdUnit.Busy = 0;// ָԭ
				FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
				//CTRL_TASK_ClearAssembleDest();
			}
			pUnit->Status.bDone = TRUE;
			OutputDebugString( "RUN_CreateUnit Status(0): Unit created!\n" );

			// create
			// Ԫ
			ret = CTRL_UNIT_Create( pUnit->Draw.nLayer, pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Status.nTaskIDEx2 );
			if( ret == MAP_DATA_NONE )
			{
				//ʧܣ˳
				OutputDebugString( "RUN_CreateUnit Error(11): Cannot create unit!\n" );
				return;
			}
			// սǷ֣Nov.6.1997
			UNIT_STRUCT *pU = MAP_GetUnit( ret );
			RUN_CountDown[pU->Draw.nPlayer].nSoldiers += EYE_GetFullLife( -1, pU->Draw.nFile );

			//add by tian yue
			TY_IDProcess(ret,pUnit->Status.nParam2,pUnit->Status.nParam3);
		}
	}
	return;
}
///////////////////////////////

///////////////////////////////
// ״̬SHANCHUʱ
void RUN_DestroyUnit( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;
	Assert( pUnit->nType != MAP_UNIT_TYPE_NONE );

	if( EYE_IfFocusOnUnit( pUnit ) )
	{
		if( CTRL_nHitCounter == 1
			|| EYE_IfUnitIsGen( pUnit ) )
		{
			if( EYE_IfSheIsMine( pUnit ) )
			{
				Assert( CTRL_nHitCounter>0 );
	//			if( CTRL_hitSrc[0].nID == pUnit->nID )
	//			{
					// 
					CTRL_TASK_ClearAssembleSrc( TRUE );
					CTRL_TASK_ClearAssembleDest();
					FACE_ShowCommandUnit( COMMANDUNIT_NONE, 0xFFFF ); // clear command sets
	//			}

				// ȡͼ
				if( BUILD_IfEnable() )
				{
					BUILD_Enable( FALSE );
				}
			}

			// ϢҶҪ
			struct	PROMPT_BLOCK	temp;
			temp.PromptBlockId = PROMPT_NONE;	
			FACE_ShowPromptBlock( temp );
		
			// еĽ㶼ȥ
			// һBug
			int nCounter = CTRL_nHitCounter;
			for( int i=0; i<nCounter; i++ )
			{
				Assert( CTRL_hitSrc[i].nID != MAP_DATA_NONE );
				struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[i].nID );
				Assert( pU );
				pU->Draw.bUpdate = FALSE;
				CTRL_hitSrc[i].nID = MAP_DATA_NONE;
				CTRL_nHitCounter--;
			}
			Assert( CTRL_nHitCounter == 0 );
		}
		else
		// Լѡɾ
		{
			for( int i=0; i< CTRL_nHitCounter; i++ )
			{
				if( CTRL_hitSrc[i].nID == pUnit->nID )
				{	// ĵԪǰŲ
					for( int j=i;j<CTRL_nHitCounter-1; j++ )
					{
						CTRL_hitSrc[j].nID = CTRL_hitSrc[j+1].nID;
					}
					CTRL_nHitCounter--;
					break;
				}
			}
		}
	}	// End of if( EYE_IfFocusOnUnit( pUnit ) )

	// ȡ״̬
	// pDraw->bUpdate = FALSE;

	// it is time to destroy
	Assert( pUnit->Status.nTaskID == SHANCHU ) ;

	if( pUnit->nCounter == 0 )
	{
		pUnit->Draw.nFrame = 0;
	}
	// ﵽһֻ֡ɾɾõԪ
	else if( pUnit->nCounter == RUN_TIMEDELAY_DESTROY )
	{
		// ͼ񣬴
		if( !EYE_IfUnitIsShip( pUnit ) )
		{
			RUN_DESTROY_SetAfterLife( pUnit );
		}

		// ǽҪȥ
		if( EYE_IfUnitIsBuild( pUnit ) )
		{
			for( int i=0; i<pUnit->Build.nFireLvl; i++ )
			{
				OTHER_DestroyData( pUnit->Build.nFireID[i] );
			}
			//added by tian yue
			TY_DestroyUnit(pUnit); 
		}

		// ɾ
		if( EYE_IfUnitIsGen( pUnit ) )
		{
			// ɢʿ
			CTRL_GROUP_ToSubAll( pUnit );
			CTRL_GROUP_Destroy( pUnit );
		}
		else
		{
			if( EYE_IfUnitIsSoldier( pUnit ) 
				&& pUnit->Soldier.nGenID != MAP_DATA_NONE )
				CTRL_GROUP_Sub( pUnit );	// Ѹʿӽ½ų
			CTRL_UNIT_Destroy( pUnit );
		}
		// 
		pUnit->Status.bDone = TRUE;
		OutputDebugString( "RUN_CreateUnit Status(0): Unit destroyed!\n" );
		return;
	}

	if( !EYE_IfUnitIsBuild( pUnit ) )
	{	// 

		// ɾӦ״̬
		int nMaxFrame;
		if( pDraw->nFile >= 37 && pDraw->nFile <= 44 )	// Լ
				nMaxFrame = 6;
		else	nMaxFrame = MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState];
		if( MAP_Lib.AniSeq[pDraw->nFile].nDeadDir == 8 )
		{	// 8
			pUnit->Draw.nState = pUnit->Draw.nDir+MAP_Lib.AniSeq[pUnit->Draw.nFile].nEventBegin[1];
			// change frame
			//if( pDraw->nFrame < MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState]-1 )
			if( pDraw->nFrame < nMaxFrame )
			{
				int nDelay = 3;
				if( EYE_IfUnitIsShip( pUnit ) )
					nDelay 	= 15;
				if( (pUnit->nCounter&nDelay) == nDelay )
				{
					pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+MAP_Lib.AniSeq[pDraw->nFile].nOffset;
					pDraw->nRow = 0;
					pDraw->nFrame = pDraw->nFrame+1;
				}
				pUnit->nCounter++;
			}
			else	pUnit->nCounter = RUN_TIMEDELAY_DESTROY;
		}
		else
		{	// Ҫķ
			if( (pDraw->nDir+8-MAP_Lib.AniSeq[pDraw->nFile].nDeadDir)%8 >0 )// ʱת
			{
				pDraw->nDir = (pDraw->nDir + 7)%8;
				pDraw->nState = pDraw->nDir;
			}
			else if ( (pDraw->nDir+8-MAP_Lib.AniSeq[pDraw->nFile].nDeadDir)%8 <0 )// ˳ʱת
			{
				pDraw->nDir = (pDraw->nDir + 1)%8;
				pDraw->nState = pDraw->nDir;
			}
			else
			{	// תԷ
				pDraw->nState = MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[1];
				// change frame
				//if( pDraw->nFrame < MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState]-1 )
				Assert( nMaxFrame > 0 );
				if( pDraw->nFrame < nMaxFrame )
				{
					int nDelay = 3;
					if( (pUnit->nCounter&nDelay) == nDelay )
					{
						pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+MAP_Lib.AniSeq[pDraw->nFile].nOffset;
						pDraw->nRow = 0;
						pDraw->nFrame = pDraw->nFrame+1;
					}
					pUnit->nCounter++;
				}
				else	pUnit->nCounter = RUN_TIMEDELAY_DESTROY;
			}
		}
	}
	else
	{	// 
		pUnit->nCounter = RUN_TIMEDELAY_DESTROY;
	}
}
///////////////////////////////
///////////////////////////////
// ǰ״̬GONGJIʱ
void RUN_FightUnit( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	Assert( pUnit->Status.nTaskID == GONGJI );
	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;

	Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
	struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
	Assert( pU );
	if( EYE_IfUnitIsDead( pU ) )
	{	// ֵѾ
		pUnit->Status.bDone = TRUE;
		return;
	}

	// ޸Bug, ˲
	// July.16.1997, Liu Gang
	if( pU->nLife <= 0 
		&& pU->Task.nTaskID == SHANCHU 
		&& pU->Task.bDone == FALSE )
	{
		pU->Status.nTaskID = SHANCHU;
		while( pU->Status.bDone == FALSE )
			RUN_DestroyUnit( pU );
//		WriteLogFile( "Bad.log", "Destroy!\n" );
	}

	// ö֡״̬
	// 2
	//pDraw->nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[2];
	// Чӵһ£㹥Чһ
	Assert( DATA_Lib.Unit[pUnit->Draw.nFile].nFightSpeed != 0 );
	int nSpeed = DATA_Lib.Unit[pUnit->Draw.nFile].nFightSpeed;
	if( CTRL_GetSTG( &pUnit->Draw, JIASU ) == TRUE )
		nSpeed *= 2;
	else if( CTRL_GetSTG( &pUnit->Draw, JIANSU ) == TRUE )
		nSpeed /= 2;
	if( pUnit->nCounter == 0 )
	{
		// ֡ѵ
		pDraw->nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[0];
		pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+
			MAP_Lib.AniSeq[pDraw->nFile].nOffset;
		pDraw->nRow = 0;
	}
	else if( pUnit->nCounter == RUN_TIMEDELAY_FIGHT/nSpeed )
	{
		// change frame
		if( !EYE_IfUnitIsBuild( pUnit ) )
		{
			// ӵһ
			if( CTRL_GetSTG( &pUnit->Draw, GUNMU ) == TRUE 
				&& (pUnit->Draw.nFile == 32 || pUnit->Draw.nFile == 45) )
			{
				if( pUnit->Draw.nFile == 32 )	// ʯͷ
					pUnit->Draw.nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[4];
				else							// ľͷ
					pUnit->Draw.nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[3];
			}
			else
			{
				pUnit->Draw.nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[2];
			}
			pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+MAP_Lib.AniSeq[pDraw->nFile].nOffset;
			pDraw->nRow = 0;
			if( MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState] != 0 )
				pDraw->nFrame = ( pDraw->nFrame+1 )%MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState];
			if( pDraw->nFrame != 2 )
				return;	// û
		}
		else
		{
			Assert( EYE_IfUnitIsTower( pUnit ) );
		}
		
	// һֹ
		pUnit->nCounter = 0;
		// ӳΧ׷
		Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
		int nDir = EYE_IfUnitIsInRange( pUnit->nID, pUnit->Status.nParam1 );
		if( nDir == -1 )
		{	
			if( EYE_IfUnitIsBuild( pUnit ) )
				pUnit->Status.bDone = TRUE;	// ¥׷
			else
			{	// ׷
				struct CTRL_TASK_STRUCT Task;
				CTRL_TASK_Clear( &Task );
				Task.nID = pUnit->nID;
				Task.nTaskID = GONGJI;
				Task.nTaskIDEx = 2;
				Task.nParam1 = pUnit->Status.nParam1;
				Task.bDone = TRUE;
				CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
			}
			return;
		}
		else if( nDir == -2 )
		{	// ˶
			pUnit->Status.bDone = TRUE;
			return;
		}
		else if( nDir != pUnit->Draw.nDir )
		{	// ת
			Assert( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0 );
			Assert( nDir >= 0 && nDir < 8 );
			int nState = pUnit->Draw.nState-pUnit->Draw.nDir;
			pUnit->Draw.nDir = nDir;
			pUnit->Draw.nState = pUnit->Draw.nDir+nState;
		}

		if( CTRL_GetSTG( &pUnit->Draw, GUNMU ) == TRUE 
			&& (pUnit->Draw.nFile == 32 || pUnit->Draw.nFile == 45) )
		{
			// 100˵Ĳ͹ʹõļıǹľ
			RUN_FIGHT_SetGunMu( pUnit, pU );
		}
		else if( EYE_IfUnitIsArcher( pUnit ) 
			|| EYE_IfUnitIsTower( pUnit ) 
			|| EYE_IfUnitIsBattleShip( pUnit ) )
		{// ֣
			RUN_FIGHT_SetArrow( pUnit , pU );
		}
		else if( EYE_IfUnitIsCatapult( pUnit ) )
		{// ͶʯͶʯ
			RUN_FIGHT_SetStone( pUnit, pU );
		}
		else if( RUN_FIGHT_CalcResult( pUnit, pU ) )
		{// ǹ
			// Ѿ
			return;
		}

		// 
		if( EYE_IfUnitIsBuild( pU ) )
		{
			// ڽҪŻ
			RUN_FIGHT_SetFire( pU );
		}
		return;
	} // End of if( pUnit->nCounter == 
	pUnit->nCounter++;//ȴһ
}

// ǰ״̬ZUJIANʱ
void RUN_GroupUnit( struct UNIT_STRUCT *pUnit )
{
	int nGenID;

	Assert( EYE_IfUnitIsSoldier( pUnit ) );

	Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
	nGenID = CTRL_GROUP_Find( pUnit->Draw.nPlayer, pUnit->Status.nParam1 );
	if( nGenID == MAP_DATA_NONE )
	{
		int nType;// ӵ
		if( EYE_IfUnitIsWorker( pUnit ) )
			nType = MAP_UNIT_TYPE_WGEN;	// 
		else if( EYE_IfUnitIsShip( pUnit ) )
			nType = MAP_UNIT_TYPE_SGEN;	// ˮ
		else
			nType = MAP_UNIT_TYPE_GEN;	// ½
//		Assert( nType == (int)pUnit->Status.nTaskIDEx );
		nGenID = CTRL_GROUP_Create( pUnit->Draw.nLayer, pUnit->Draw.nX, 
			pUnit->Draw.nY, pUnit->Status.nParam1, pUnit->Draw.nPlayer, nType );
	}
	if( nGenID != MAP_DATA_NONE )
	{
		// to soldier
		pUnit->Status.nParam1 = nGenID;
		RUN_GroupAdd( pUnit );

		// ͻضID
		//add by tian yue
		TY_IDProcess(nGenID,pUnit->Status.nParam2,pUnit->Status.nParam3);
	}
	pUnit->Status.bDone = TRUE;

}

void RUN_GroupAdd( struct UNIT_STRUCT *pUnit )
{
	// to soldier
	Assert( pUnit );
	Assert( EYE_IfUnitIsSoldier( pUnit ) );
	Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
	struct UNIT_STRUCT *pUnitG = MAP_GetUnit( pUnit->Status.nParam1 );
	Assert( pUnitG );
	Assert( EYE_IfUnitIsGen( pUnitG ) );
	if( (EYE_IfUnitIsWorkerGen( pUnitG )
		&& !EYE_IfUnitIsWorker( pUnit ))
		||(!EYE_IfUnitIsWorkerGen( pUnitG )
		&& EYE_IfUnitIsWorker( pUnit )) )
	{
		OutputDebugString( "RUN_GroupAdd Warning:  cannot combine troops with different types!\n" );
		pUnit->Status.bDone = TRUE;
		return;
	}

	if( CTRL_GROUP_Add( pUnitG, pUnit ) )
	{
		// ¼ʿ´ｫִе
		struct CTRL_TASK_STRUCT Task;
		CTRL_TASK_Clear( &Task );
		CTRL_TASK_Copy( &Task, &pUnitG->Task );
		Task.nID = pUnit->nID;
		Task.bDone = TRUE;
		CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );

		if( EYE_IfFocusOnUnit( pUnit ) 
			&&EYE_IfSheIsMine( pUnit ) 
			&& !EYE_IfFocusOnUnit( pUnitG ) )
		{
			// ѽӵУΪһ
			Assert(CTRL_nHitCounter < PLAYER_UNIT_MAX );
			for( int i=CTRL_nHitCounter; i>0; i-- )
			{	// ԪŲ
				CTRL_hitSrc[i].nID = CTRL_hitSrc[i-1].nID;
			}
//			CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
			CTRL_hitSrc[0].nID = pUnitG->nID;
			CTRL_nHitCounter++;
			pUnitG->Draw.bUpdate = TRUE;	// Ͻ

			// ѸýµʿϽ
			for( int j=0; j< GENERAL_TROOP_MAX; j++ )
			{
				if( pUnitG->Gen.wTroop[j] == MAP_DATA_NONE ) continue;
				struct UNIT_STRUCT *pU = MAP_GetUnit( pUnitG->Gen.wTroop[j] );
				Assert( pU );
				Assert( EYE_IfUnitIsSoldier( pU ) );
				if( !EYE_IfFocusOnUnit( pU ) )
				{
					CTRL_hitSrc[CTRL_nHitCounter].nID = pUnitG->Gen.wTroop[j];
//					CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
					CTRL_nHitCounter++;
					pU->Draw.bUpdate = TRUE;	// ʿϽ
				}
			}
			Assert( CTRL_nHitCounter <= PLAYER_UNIT_MAX );

			// Ϣ
			// ýϢ
			struct	PROMPT_BLOCK	temp;
			temp.PromptBlockId = PROMPT_UNIT;
			DATA_GENERAL_STRUCT *pUnitGData = &DATA_Lib.Gen[pUnitG->Gen.nID];
			temp.PromptBlockUnion.Unit.GeneralBitmapId = pUnitG->Gen.nID;	// ͼƬ
			temp.PromptBlockUnion.Unit.GeneralPower = EYE_GetWuLi( pUnitG->Gen.nID )*100/120;
				//pUnitGData->nHealth;	// 
			temp.PromptBlockUnion.Unit.GeneralBlood =
				//pUnitG->nLife/2;		// ֵ200
				pUnitG->nLife*100/EYE_GetFullLife( pUnitG->Draw.nPlayer, pUnitG->Draw.nFile );	// 
			strcpy( temp.PromptBlockUnion.Unit.GeneralName, pUnitGData->strName );	// 

			// 
			EYE_GetLevelName( pUnitG->Gen.nID, temp.PromptBlockUnion.Unit.Office ); // 

			temp.PromptBlockUnion.Unit.Experience = pUnitGData->nJingYan;	// 
			temp.PromptBlockUnion.Unit.Ruse = pUnitGData->nMouLue;			// ı
			temp.PromptBlockUnion.Unit.UnitMorale = EYE_GetMorale(pUnitG);	// ʿ
			temp.PromptBlockUnion.Unit.UnitLineUp = pUnitG->Gen.nLineUp;	// 
			// õʿ
			temp.PromptBlockUnion.Unit.NumberOfSolider = CTRL_GetFocusSoldierNumber();

			FACE_ShowPromptBlock( temp );

			Assert( CTRL_nHitCounter >= 1 );
			// Ϊ˲
			if( EYE_IfUnitIsWorker( pUnit ) )
			{
				//if( (GAME.nMe&1) == 1 )
				if( GAME.Players[GAME.nMe].nBuildType == 0 )
					CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_CHAO_PEASANT;
				else
					CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_LIU_PEASANT;
				CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			}
			// Ϊ
			else
			{
				CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_FIGHTUNIT,
				CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			}
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, 
				CTRL_TASK_saveCmdUnit.Ex );
		}
	}
	else
	{
		if( EYE_IfFocusOnUnit( pUnit ) )
		{
			if( EYE_IfSheIsMine( pUnit ) )
			{
				// ѡɾ
				for( int i=0; i< CTRL_nHitCounter; i++ )
				{
					if( CTRL_hitSrc[i].nID == pUnit->nID )
					{	// ĵԪǰŲ
						for( int j=i;j<CTRL_nHitCounter-1; j++ )
						{
							CTRL_hitSrc[j].nID = CTRL_hitSrc[j+1].nID;
						}
						CTRL_nHitCounter--;
						break;
					}
				}
				//һ֧ʮʿ޷롣
				FACE_ShowPromptInfor( 11 );
				pUnit->Draw.bUpdate = FALSE;	// ʧܺõԪȥ

				// Ϣ
				// ýϢ
				struct	PROMPT_BLOCK	temp;
				temp.PromptBlockId = PROMPT_UNIT;
				DATA_GENERAL_STRUCT *pUnitGData = &DATA_Lib.Gen[pUnitG->Gen.nID];
				temp.PromptBlockUnion.Unit.GeneralBitmapId = pUnitG->Gen.nID;	// ͼƬ
				temp.PromptBlockUnion.Unit.GeneralPower = EYE_GetWuLi( pUnitG->Gen.nID )*100/120;
					//pUnitGData->nHealth;	// 
				temp.PromptBlockUnion.Unit.GeneralBlood =
					//pUnitG->nLife/2;		// ֵ200
					pUnitG->nLife*100/EYE_GetFullLife( pUnitG->Draw.nPlayer, pUnitG->Draw.nFile );	// 
				strcpy( temp.PromptBlockUnion.Unit.GeneralName, pUnitGData->strName );	// 

				// 
				EYE_GetLevelName( pUnitG->Gen.nID, temp.PromptBlockUnion.Unit.Office ); // 

				temp.PromptBlockUnion.Unit.Experience = pUnitGData->nJingYan;	// 
				temp.PromptBlockUnion.Unit.Ruse = pUnitGData->nMouLue;			// ı
				temp.PromptBlockUnion.Unit.UnitMorale = EYE_GetMorale(pUnitG);	// ʿ
				temp.PromptBlockUnion.Unit.UnitLineUp = pUnitG->Gen.nLineUp;	// 
				// õʿ
				temp.PromptBlockUnion.Unit.NumberOfSolider = CTRL_GetFocusSoldierNumber();

				FACE_ShowPromptBlock( temp );

			}
		}
	}
	pUnit->Status.bDone = TRUE;
}

// ǰ״̬JIESANʱ
void RUN_GroupSub( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit );
	if( EYE_IfFocusOnUnit( pUnit ) )
//		&& ( CTRL_nHitCounter == 1
//			|| EYE_IfUnitIsGen( pUnit ) ) )
	{
		if( EYE_IfSheIsMine( pUnit ) )
		{
			Assert( CTRL_nHitCounter>0 );
//			if( CTRL_hitSrc[0].nID == pUnit->nID )
//			{
				// 
				CTRL_TASK_ClearAssembleSrc( TRUE );
				CTRL_TASK_ClearAssembleDest();
				FACE_ShowCommandUnit( COMMANDUNIT_NONE, 0xFFFF ); // clear command sets
//			}

			// ȡͼ
			if( BUILD_IfEnable() )
			{
				BUILD_Enable( FALSE );
			}
		}

		// ϢҶҪ
		struct	PROMPT_BLOCK	temp;
		temp.PromptBlockId = PROMPT_NONE;	
		FACE_ShowPromptBlock( temp );
	
		// еĽ㶼ȥ
		// һBug
		int nCounter = CTRL_nHitCounter;
		for( int i=0; i<nCounter; i++ )
		{
			Assert( CTRL_hitSrc[i].nID != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[i].nID );
			Assert( pU );
			pU->Draw.bUpdate = FALSE;
			CTRL_hitSrc[i].nID = MAP_DATA_NONE;
			CTRL_nHitCounter--;
		}
		Assert( CTRL_nHitCounter == 0 );
	}
	
	if( EYE_IfUnitIsGen( pUnit ) )
	{	
		// ǽ죬ɢµʿ
		CTRL_GROUP_ToSubAll( pUnit );
		CTRL_GROUP_Destroy( pUnit );
	}
	else
	{	// ʿֻԼͽĹϵ
		WORD nGenID = pUnit->Soldier.nGenID;
		if( nGenID != MAP_DATA_NONE )
		{
			Assert( EYE_IfUnitIsSoldier( pUnit ) );
			CTRL_GROUP_Sub( pUnit );
		}
	}

	pUnit->Status.bDone = TRUE;
}

// ǰ״̬XIULIʱ
void RUN_RepairBuild( struct UNIT_STRUCT *pUnit )
{
	Assert( EYE_IfUnitIsWorker( pUnit ) 
		|| EYE_IfUnitIsWorkerGen( pUnit ) );

	// ö֡״̬
	// 2
	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;

	// Чӵһ£Чһ
	Assert( DATA_Lib.Unit[pUnit->Draw.nFile].nFightSpeed != 0 );
	int nSpeed = DATA_Lib.Unit[pUnit->Draw.nFile].nFightSpeed;
	if( CTRL_GetSTG( &pUnit->Draw, JIASU ) == TRUE )
		nSpeed *= 2;
	else if( CTRL_GetSTG( &pUnit->Draw, JIANSU ) == TRUE )
		nSpeed /= 2;
	if( pUnit->nCounter == 0 )
	{
		int nDir = EYE_IfUnitIsInRange( pUnit->nID, pUnit->Status.nParam1 );
		if( nDir == -1 )
		{	// ýΧ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Repair\n" );
#endif	//_DEBUG_OFFSET_
			pUnit->Status.nTaskID = DUSE;
			pUnit->nCounter = 0;
			return;
		}

		// ֡ѵ
		pDraw->nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[0];
		pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+
			MAP_Lib.AniSeq[pDraw->nFile].nOffset;
		pDraw->nRow = 0;
	}
	else if( pUnit->nCounter == RUN_TIMEDELAY_FIGHT/nSpeed )
	{
		// change frame
		// ӵһ
		pUnit->Draw.nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[2];
		pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+MAP_Lib.AniSeq[pDraw->nFile].nOffset;
		pDraw->nRow = 0;
		if( MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState] != 0 )
			pDraw->nFrame = ( pDraw->nFrame+1 )%MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState];
		if( pDraw->nFrame != 2 )
			return;	// û

		pUnit->nCounter = 0;
		if( RUN_REPAIR_Build( pUnit ) )
		{	// 
			pUnit->Status.bDone = TRUE;
		}
		return;
	}
	pUnit->nCounter++;//ȴһ
}

// ǰ״̬QXSHENGCHANʱ
void RUN_QXCreateSoldier( struct UNIT_STRUCT *pUnit )
{
	pUnit->Status.bIRQ = FALSE;
	Assert( pUnit->nHasShadow == 1 );
	if( EYE_IfFocusOnUnit( pUnit )
		&& EYE_IfSheIsMine( pUnit ) )
	{
		// Ϣ
		struct	PROMPT_BLOCK	temp;
		temp.PromptBlockId = PROMPT_CONSTRUCTION_IDLESS;	
		temp.PromptBlockUnion.Construction_Idless.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
		strcpy( temp.PromptBlockUnion.Construction_Idless.ConstructionName, 
				DATA_Lib.Unit[pUnit->Draw.nFile].strName );		// Լ
		if( pUnit->Draw.nFile == 22 )	// 
			temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.nResource;	// ԴĴ
		else
			temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.dwUpgrade[0];	// Լļ
		temp.PromptBlockUnion.Construction_Idless.Stone = 
			pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile );	// Լֵ
		FACE_ShowPromptBlock( temp );

		// 
		CTRL_TASK_saveCmdUnit.Busy = 0;// ָԭ
		FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
		//CTRL_TASK_ClearAssembleDest();
	}
	// һǮ
	//...pUnit->Status.nTaskIDEx
	// Ǯ
	RUN_CREATE_PayBack( pUnit->Draw.nPlayer, pUnit->Status.nTaskIDEx );

	OutputDebugString( "CRL_QXCreateSoldier() : Create canceled!\n" );
	pUnit->Status.bDone = TRUE;
}

// ״̬QXJIANZAOʱ
void RUN_QXCreateBuild( struct UNIT_STRUCT *pUnit )
{
	if( pUnit->nCounter == 0 )
	{
	Assert( EYE_IfUnitIsBuild( pUnit ) );
	// һǮ
	//...
	// Ǯ
	RUN_CREATE_PayBack( pUnit->Draw.nPlayer, pUnit->Draw.nFile );

	//	ɾδɵĽ
	//pUnit->Status.bIRQ = FALSE;
	struct CTRL_TASK_STRUCT Task;
	CTRL_TASK_Clear( &Task );
	Task.nID = pUnit->nID;
	Task.nTaskID = SHANCHU;
	Task.bIRQ = TRUE;
	Task.bDone = TRUE;
	CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
	OutputDebugString( "CRL_QXCreateSoldier() : Create canceled!\n" );
	}
	else if( pUnit->nCounter == 2 )
	{	// to fix a bug:
		// ȥһȡִд״̬ȻϽ״̬
		// ˽Ĺ˲вܹʱõӦΪý
		// ȡģǽˣӶһҪģĻҡ
		// һӳʱ䣬ʹ֮Խ
		// ⡣
		// Sep 1, 1997
		pUnit->Status.bDone = TRUE;
	}
	pUnit->nCounter++;
}

// ״̬JIANZAOZHONGʱ
void RUN_CreatingBuild( struct UNIT_STRUCT *pUnit )
{
	Assert( EYE_IfUnitIsBuild( pUnit ) );
	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;
	if( pUnit->nCounter == 0 )
	{// һ״̬
		// Aug.8, ͣһ֣Ϊ޸һǰ깤Bug
		pUnit->bPause = TRUE;
		
		pUnit->Status.bIRQ = TRUE;
		pUnit->nCounter++;
		Assert( pUnit->nLife == 0 );
		if( pDraw->nFile == 0 || pDraw->nFile == 1 )
		{
			pDraw->nCol = 9 + MAP_Lib.AniSeq[0].nOffset;
		}
		else if( pDraw->nLocationSize == 0 )
		{
			pDraw->nCol = 1 + MAP_Lib.AniSeq[26].nOffset;
		}
		else if( pDraw->nLocationSize == 1 )
		{
			pDraw->nCol = 2 + MAP_Lib.AniSeq[24].nOffset;
		}
		else if( pDraw->nFile == 20 )	// 
		{
			pDraw->nCol = 2 + MAP_Lib.AniSeq[pDraw->nFile].nOffset;
		}
		else
		{
			pDraw->nCol = 2 + MAP_Lib.AniSeq[22].nOffset;
		}
		pDraw->nRow = 0;
	}
	else if( pUnit->nCounter == 1 
		&& pUnit->nLife >= (EYE_GetFullLife( pDraw->nPlayer, pDraw->nFile )/3) )
	{// ڶ״̬	
		pUnit->nCounter++;
		if( pDraw->nFile == 0 || pDraw->nFile == 1 )
		{
			pDraw->nCol = 8 + MAP_Lib.AniSeq[0].nOffset;
		}
		else if( pDraw->nLocationSize == 0 )
		{
			pDraw->nCol = 1 + MAP_Lib.AniSeq[26].nOffset;
		}
		else if( pDraw->nLocationSize == 1 )
		{
			pDraw->nCol = 1 + MAP_Lib.AniSeq[24].nOffset;
		}
		else if( pDraw->nFile == 20 )	// 
		{
			pDraw->nCol = 1 + MAP_Lib.AniSeq[pDraw->nFile].nOffset;
		}
		else
		{
			pDraw->nCol = 1 + MAP_Lib.AniSeq[22].nOffset;
		}
		pDraw->nRow = 0;

	}
	else if( pUnit->nCounter == 2
		&& pUnit->nLife >= (EYE_GetFullLife( pDraw->nPlayer, pDraw->nFile )*2/3) )
	{// ״̬
		pDraw->nCol = 1 + MAP_Lib.AniSeq[pDraw->nFile].nOffset;
		pDraw->nRow = 0;
		pUnit->nCounter++;
	}
	else if( pUnit->nCounter == 3
		&& pUnit->nLife >= EYE_GetFullLife( pDraw->nPlayer, pDraw->nFile ) )
	{	// 
		pUnit->nLife = EYE_GetFullLife( pDraw->nPlayer, pDraw->nFile );
		pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nOffset;
		pDraw->nRow = 0;
		pUnit->Status.bDone = TRUE;
		pUnit->Status.bIRQ = FALSE;
		Assert( pUnit->nHasShadow == 1 );

		if( EYE_IfSheIsMine( pUnit ) )
		{
			//------------Ч
			// XRg.wav, XRh.wav, ,ɽ
			int nID = getrandom(84,85);
			DATA_WAVE_EffectPlay( nID );
			//------------Ч
			//------------ʾ
			FACE_ShowPromptInfor( nID-82 ) ;
			//------------ʾ
		}

		if( EYE_IfFocusOnUnit( pUnit ) 
			&& EYE_IfSheIsMine( pUnit ) )
		{
			// Ϣ
			struct	PROMPT_BLOCK	temp;
			temp.PromptBlockId = PROMPT_CONSTRUCTION_IDLESS;	
			temp.PromptBlockUnion.Construction_Idless.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
			strcpy( temp.PromptBlockUnion.Construction_Idless.ConstructionName, 
					DATA_Lib.Unit[pUnit->Draw.nFile].strName );		// Լ
			if( pUnit->Draw.nFile == 22 )	// 
				temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.nResource;	// ԴĴ
			else
				temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.dwUpgrade[0];	// Լļ
			temp.PromptBlockUnion.Construction_Idless.Stone = 
				pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);	// Լֵ
			FACE_ShowPromptBlock( temp );

			// 
			CTRL_TASK_saveCmdUnit.Busy = 0;// ָԭ
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
			//CTRL_TASK_ClearAssembleDest();
		}

		// ޸Ļ𣬰ѻȥ
		RUN_FIGHT_SetFire( pUnit );
		return;
	}

	if( EYE_IfFocusOnUnit( pUnit ) )
	{
		// Ѫ
		FACE_ShowProcessBar( PROCESSBAR_STONE, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile) );
		if( EYE_IfSheIsMine( pUnit ) )
	//		&& pUnit->nLife >= 0 )
		{
			FACE_ShowProcessBar( PROCESSBAR_PROCESS, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile) );
		}
	}
}

// ״̬YUNSONGʱ
void RUN_Harvest( struct UNIT_STRUCT *pUnit )
{
	if( pUnit->Status.nTaskIDEx == 1 )	// ͵Դ
	{	// ֣
		struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;
		if( pUnit->nCounter == 0 
			&& EYE_IfUnitIsWorker( pUnit ) )
		{	// ˵ĵһ
			int nDir;
			nDir = EYE_IfResIsInRange( pUnit, pUnit->Status.nTaskIDEx2 );
			if( nDir == -1 )
			{	// δҵԴ
				pUnit->Status.bDone = TRUE;

				// 
				// øʿΪ͵
				// ȡ׼ԴID
				POINT ptNew;
				int nSight;
				nSight = EYE_GetViewRange( &pUnit->Draw );
				Assert( pUnit->Task.nTaskIDEx == 1 );
				//pUnit->Task.nTaskIDEx = 1;	// Ϊ	// MOUSE_HITRESULT_GROUND
				ptNew = EYE_IfResIsInSight( pUnit->Status.nParam1, pUnit->Status.nParam2, 
					pUnit->Status.nParam3, nSight+3, pUnit->Status.nTaskIDEx2 );
				// ҪɼԴ
				pUnit->Task.nParam2 = (WORD)ptNew.x;
				pUnit->Task.nParam3 = (WORD)ptNew.y;
				pUnit->Task.bDone = TRUE;
				CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &pUnit->Task );
				return;
			}
			pDraw->nDir = nDir;

			// ڹʿԴջ
			pUnit->Soldier.nResType = pUnit->Status.nTaskIDEx2;
			pUnit->Soldier.nResource = 0;

			// ѸԴռ
			int bOdd = pUnit->Draw.nY&1;
			int nX = pUnit->Draw.nX + MAP_ptSenser[bOdd][0][nDir].x;
			int nY = pUnit->Draw.nY + MAP_ptSenser[bOdd][0][nDir].y;
			WORD codeG = MAP_GetGroundData( pUnit->Draw.nLayer, nX, nY );
			if( codeG != MAP_DATA_NONE )
			{
				struct MAP_GROUND_CODE_STRUCT stctG;
				MAP_GroundDeCode( codeG, &stctG );
				Assert( stctG.nAttr != MAP_SPECIAL_NONE );
				Assert( stctG.nAttr == pUnit->Soldier.nResType );	// 
				Assert( stctG.nAttr <4 && stctG.nAttr >= 0 );
				stctG.nAttr += 4;	// Ϊռ
				codeG = MAP_GroundEnCode( stctG );
				MAP_SetGroundData( pUnit->Draw.nLayer, nX, nY, codeG );
			}

			// ö֡״̬
			pDraw->nState = pDraw->nDir + MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[2];
			pDraw->nFrame = 0;
		}
		else
		{
			// ֡
			if( pUnit->nCounter >= RUN_TIMEDELAY_HARVEST_G )
			{	// ʱ䵽

				// 
				pUnit->Status.bDone = TRUE;

				if( EYE_IfUnitIsWorker( pUnit ) )
				{	// ʳռؼ

					int nDir;
					nDir = pUnit->Draw.nDir;
					int bOdd = pUnit->Draw.nY&1;
					int nX = pUnit->Draw.nX + MAP_ptSenser[bOdd][0][nDir].x;
					int nY = pUnit->Draw.nY + MAP_ptSenser[bOdd][0][nDir].y;
					WORD codeG = MAP_GetGroundData( pUnit->Draw.nLayer, nX, nY );
					if( codeG != MAP_DATA_NONE )
					{
						struct MAP_GROUND_CODE_STRUCT stctG;
						MAP_GroundDeCode( codeG, &stctG );
						Assert( stctG.nAttr != MAP_SPECIAL_NONE );
						Assert( stctG.nAttr == pUnit->Soldier.nResType+4 );	// 
						Assert( stctG.nAttr >= 4 && stctG.nAttr < 8 );
						stctG.nAttr += 4;	// Ϊɼ
						codeG = MAP_GroundEnCode( stctG );
						MAP_SetGroundData( pUnit->Draw.nLayer, nX, nY, codeG );
						pUnit->Soldier.nResource = RUN_RESOURCE_GETG;
						DRAW_OTHER_UpdateResource( pUnit->Draw.nLayer, nX, nY );
					}
				}

				if( pUnit->Status.nParam4 != MAP_DATA_NONE )// Ҳǿ
				{
					// ؼ
					// øʿΪ͵
					struct CTRL_TASK_STRUCT Task;
					CTRL_TASK_Clear( &Task );
					Task.nID = pUnit->nID;
					Task.nTaskID = HUISONG;
					Task.nTaskIDEx = 2;	// MOUSE_HITRESULT_UNIT
					Task.nParam1 = pUnit->Status.nParam4;	// ĿĵǼ
					// ԴIDݣȰԴͻȥٻʱʹ
					Task.nParam2 = pUnit->Status.nParam1;	// ԭλZ
					Task.nParam3 = pUnit->Status.nParam2;	// ԭλX
					Task.nParam4 = pUnit->Status.nParam3;	// ԭλY
					Task.nTaskIDEx2 = pUnit->Status.nTaskIDEx2;	// ԴͣĿĵȥ
					Task.bDone = TRUE;
					Assert( Task.nParam1 != MAP_DATA_NONE );
#ifdef	_DEBUG
					UNIT_STRUCT *pUUU = MAP_GetUnit( pUnit->Status.nParam4 );
					Assert( pUUU->Draw.nPlayer == pUnit->Draw.nPlayer );
#endif
					CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
				}
			}
		}
		if( EYE_IfUnitIsWorker( pUnit ) 
			&& (pUnit->nCounter&3) == 3 )
		{	// ֡
			pDraw->nFrame = ( pDraw->nFrame+1 )%MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState];
			pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+MAP_Lib.AniSeq[pDraw->nFile].nOffset;
			pDraw->nRow = 0;
			if( pDraw->nFrame == MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState]-1 )
			{
				//---- Ч
				POINT pt;
				pt.x = pUnit->Draw.nX, pt.y = pUnit->Draw.nY;
				if( PtInRect( &DRAW_rcScreen, pt ) )
				{
					int nID = 28;	// woodcut2.wav
					if( pUnit->Status.nTaskIDEx2 == 1 )
						nID = 92;	// cut.wav
					DATA_WAVE_EffectPlay( nID );
				}
				//---- Ч
			}
		}
	}
	else if( pUnit->Status.nTaskIDEx == 2 )// Դ
	{	// ӣ
		// ԴĵԪID
		if( pUnit->nCounter == 0 )
		{
			int nDir = EYE_IfUnitIsInRange( pUnit->nID, pUnit->Status.nParam1 );
			if( nDir == -1 )
			{	// ýڲɼΧ
	#ifdef	_DEBUG_OFFSET_
			TestOff( pUnit, "Harvest2\n" );
	#endif	//_DEBUG_OFFSET_
				pUnit->Status.nTaskID = DUSE;
				pUnit->nCounter = 0;
				return;
			}

			Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
			Assert( pU );
			if( EYE_IfUnitIsDead( pU ) )	// ԴѾٻˣ
			{
				pUnit->Status.bDone = TRUE;
				return;
			}
			Assert( EYE_GetUResType( pU, pUnit->Draw.nPlayer ) != QXZIYUAN );
			// ڹʿԴջ
			if( EYE_IfUnitIsWorker( pUnit ) )
			{
				pUnit->Soldier.nResType = pUnit->Status.nTaskIDEx2;
				pUnit->Soldier.nResource = 0;
			}

			// ˲ӣʿͽ죩ڽ뽨ԴӣʱҪԼλõϵͳ棬
			// 蹤ֻռһ
			Assert( pUnit->Draw.nLocationSize == 0 );

#ifdef	_DEBUG_OFFSET_
			TestOff( pUnit, "Harvest\n" );
#endif	//_DEBUG_OFFSET_
			//---
			// ߽
			CTRL_UNIT_InUnit( pUnit );
			// ԼΪж
			pUnit->Status.bIRQ = TRUE;
			//---
		}
		else if( pUnit->nCounter%4 == 0 )
		{
			Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
			Assert( pU );
			Assert( EYE_GetUResType( pU, pUnit->Draw.nPlayer ) != QXZIYUAN );
			// ж˽ǷѾ
			int nRet = RUN_HARVEST_Build( pUnit, pU );	
			if( nRet != 0 )
			{
				// ڹ˲ӣҪûȥ
				Assert( pUnit->Draw.nLocationSize == 0 );

				//---
				// ӽ߳
				if( CTRL_UNIT_OutUnit( pUnit ) )
				{
					// ж
					pUnit->Status.bIRQ = FALSE;		// ж
					Assert( pUnit->nHasShadow == 1 );
					//---
					pUnit->Status.bDone = TRUE;
				}

				if( nRet == 1 )	// Դɹȡ
				{
					// øʿΪ͵
					struct CTRL_TASK_STRUCT task;
					CTRL_TASK_Clear( &task );
					task.nID = pUnit->nID;
					task.nTaskID = HUISONG;
					task.nTaskIDEx = 2;
					if( pUnit->Status.nParam4 != MAP_DATA_NONE )
					{
						task.nParam1 = pUnit->Status.nParam4;	// ĿĵǼ
						// ԴIDݣȰԴͻȥٻʱʹ
						Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
						task.nParam4 = pUnit->Status.nParam1;	// ԭԴID
						task.nTaskIDEx2 = (WORD)pUnit->Status.nTaskIDEx2;	// ԴͣĿĵȥ
						task.bDone = TRUE;
#ifdef	_DEBUG
						UNIT_STRUCT *pUUU = MAP_GetUnit( pUnit->Status.nParam4 );
						Assert( pUUU->Draw.nPlayer == pUnit->Draw.nPlayer );
#endif
						CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &task );
					}
				}
			}
		}
	}
	pUnit->nCounter++;
}

// ״̬HUISONGʱ
void RUN_ReturnOfTheJedi( struct UNIT_STRUCT *pUnit )
{
	// ҵID
	if( pUnit->nCounter == 0 )
	{
		if( EYE_IfUnitIsWorker( pUnit ) // ûԴ
			&& pUnit->Soldier.nResource == 0 )
		{
			pUnit->Status.bDone = TRUE;
			return ;
		}

		// Դͻؼ
		Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
		struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
		Assert( pU );
		if( EYE_IfUnitIsDead( pU ) )
		{
			pUnit->Status.bDone = TRUE;	// Ѿûˣ
			return;
		}

		// ýڽУܽȥֻȴ
		if( pU->Status.nTaskID == JIANZAOZHONG )
		{
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "JeDi\n" );
#endif	//_DEBUG_OFFSET_
			pUnit->Status.nTaskID = DUSE;
			pUnit->nCounter = 0;
			return;
		}
		Assert( EYE_IfUnitIsBuild( pU ) );
		if( RUN_RETURN_Build( pUnit, pU ) == FALSE )
		{	// ˣ
			pUnit->Status.bDone = TRUE;
			return;
		}

		// ˲ӣʿͽ죩ڽң˧ʣľ֣ʱҪԼλõϵͳ棬
		// 蹤ֻռһ
		Assert( pUnit->Draw.nLocationSize == 0 );

#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Jedi\n" );
#endif	//_DEBUG_OFFSET_
		//---
		// ߽
		CTRL_UNIT_InUnit( pUnit );

		// ԼΪж
		pUnit->Status.bIRQ = TRUE;
		//---
	}
	else if( pUnit->nCounter%4 == 0 )
	{
		Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
		struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
		Assert( pU );	// 
		BOOL bDone = FALSE;
		if( EYE_IfUnitIsDead( pU ) )
			bDone = TRUE;
		if( pUnit->nCounter >= RUN_TIMEDELAY_RETURN 
			|| bDone == TRUE )// ϻұˣ
		{
			// ڹ˲ӣҪûȥ
			Assert( pUnit->Draw.nLocationSize == 0 );

			//---
			// ӽ߳
			if( CTRL_UNIT_OutUnit( pUnit ) )
			{
				// ж
				pUnit->Status.bIRQ = FALSE;
				Assert( pUnit->nHasShadow == 1 );
				//---
				pUnit->Status.bDone = TRUE;
			}


			if( pUnit->Soldier.nResource == 0 )
			{
				// Ϊƽ״̬룬ֹ˸
				pUnit->Draw.nState = pUnit->Draw.nDir;	
				pUnit->Draw.nCol = MAP_Lib.AniSeq[pUnit->Draw.nFile].nAniSeq[pUnit->Draw.nState][pUnit->Draw.nFrame]+
					MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
				pUnit->Draw.nRow = 0;
			}
			if( bDone ) return;	// ұˣ
		
			// øʿΪ͵
			// ȡ׼ԴID
			struct CTRL_TASK_STRUCT Task;
			CTRL_TASK_Clear( &Task );
			Task.nID = pUnit->nID;
			Task.nTaskID = YUNSONG;
			Task.nTaskIDEx2 = pUnit->Status.nTaskIDEx2;		// Դ
			// Ŀĵ
			if( Task.nTaskIDEx2 == SHULIN
				|| Task.nTaskIDEx2 == MAITIAN )
			{
				Task.nTaskIDEx = 1;
				if( pUnit->Status.nParam4 != MAP_DATA_NONE )
				{
					Task.nParam1 = pUnit->Status.nParam2;
					Task.nParam2 = pUnit->Status.nParam3;
					Task.nParam3 = pUnit->Status.nParam4;
				}
				else return;	// 
			}
			else
			{
				Task.nTaskIDEx = 2;
				// ܸԴڲڣֻҪԭУȻ´
				if( pUnit->Status.nParam4 != MAP_DATA_NONE )
					Task.nParam1 = pUnit->Status.nParam4;	// ԴID
				else return;	// 
			}
			Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
			Task.nParam4 = pUnit->Status.nParam1;	// ҵID
			Task.bDone = TRUE;
#ifdef	_DEBUG
			UNIT_STRUCT *pUUU = MAP_GetUnit( pUnit->Status.nParam1 );
			Assert( pUUU->Draw.nPlayer == pUnit->Draw.nPlayer );
#endif
			CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
		}
	}
	pUnit->nCounter++;
}

// ״̬TISHENGʱ
void RUN_Upgrade( struct UNIT_STRUCT *pUnit )
{
	Assert( EYE_IfUnitIsBuild( pUnit ) );
	if( pUnit->nCounter == 0 )
	{
		if( EYE_IfFocusOnUnit( pUnit ) 
			&& EYE_IfSheIsMine( pUnit ) )
		{
			// Ϣ
			struct	PROMPT_BLOCK	temp;
			temp.PromptBlockId = PROMPT_CONSTRUCTION_WORKING;
			temp.PromptBlockUnion.Construction_Working.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
			temp.PromptBlockUnion.Construction_Working.ConstructionGrade = pUnit->Build.dwUpgrade[0];	//???ļ
			temp.PromptBlockUnion.Construction_Working.Stone = 
				pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);;	// Լֵ
			temp.PromptBlockUnion.Construction_Working.ProductBitmapId = pUnit->Status.nTaskIDEx2;	// ʿļ
			strcpy( temp.PromptBlockUnion.Construction_Working.ConstructionName, 
				DATA_Lib.Unit[pUnit->Draw.nFile].strName );						// Լ
			temp.PromptBlockUnion.Construction_Working.Percent = pUnit->nCounter*100/RUN_TIMEDELAY_UPGRADE;	// ɶ
			FACE_ShowPromptBlock( temp );

			// 
			CTRL_TASK_saveCmdUnit.Busy = 1;	// ȡ
			FACE_ShowCommandUnit( COMMANDUNIT_CANCEL, 0xFFFF ); // clear command sets
			//CTRL_TASK_ClearAssembleDest();
		}
		
		// 
		if( !RUN_UPGRADE_Pay( pUnit->Draw.nPlayer, pUnit->Status.nTaskIDEx ) )
		{	// ûǮˣ
			pUnit->Status.bDone = TRUE;
			return;
		}

		// ˧ҪµĶ֡
		if( pUnit->Status.nTaskIDEx == SHENGJI1 )
		{
			pUnit->Draw.nCol = 3 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
		}
		else if( pUnit->Status.nTaskIDEx == SHENGJI2 )
		{
			pUnit->Draw.nCol = 5 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
		}
		else if( pUnit->Status.nTaskIDEx == SHENGJI3 )
		{
			pUnit->Draw.nCol = 7 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
		}

		pUnit->Status.bIRQ = TRUE;
	}
	else if( pUnit->nCounter >= RUN_TIMEDELAY_UPGRADE )
	{	// 
		// 
		//RUN_UPGRADE_Get( pUnit->Draw.nPlayer, pUnit->Status.nTaskIDEx );
		RUN_UPGRADE_Get( pUnit );

		if( EYE_IfSheIsMine( pUnit ) 
			&& pUnit->Status.nTaskIDEx < MUCAI1 )
		{
			//------------Ч
			// XRi.wav, 
			int nID = 86;
			DATA_WAVE_EffectPlay( nID );
			//------------Ч
			//------------ʾ
			FACE_ShowPromptInfor( nID-82 );
			//------------ʾ
		}


		if( EYE_IfFocusOnUnit( pUnit ) 
			&& EYE_IfSheIsMine( pUnit ) )
		{
			// ý
			// CTRL_TASK_saveCmdUnit.CmdCTRL_TASK_saveCmdUnit.Ex
			//CTRL_TASK_BuildCommand( pUnit->Draw.nFile );
			CTRL_TASK_BuildCommand( pUnit );

			// Ϣ
			struct	PROMPT_BLOCK	temp;
			temp.PromptBlockId = PROMPT_CONSTRUCTION_IDLESS;	
			temp.PromptBlockUnion.Construction_Idless.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
			strcpy( temp.PromptBlockUnion.Construction_Idless.ConstructionName, 
					DATA_Lib.Unit[pUnit->Draw.nFile].strName );		// Լ
			if( pUnit->Draw.nFile == 22 )	// 
				temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.nResource;	// ԴĴ
			else
				temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.dwUpgrade[0];	// Լļ
			temp.PromptBlockUnion.Construction_Idless.Stone = 
				pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);	// Լֵ
			FACE_ShowPromptBlock( temp );

			// 
			CTRL_TASK_saveCmdUnit.Busy = 0;// ָԭ
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
			//CTRL_TASK_ClearAssembleDest();
		}

		// ˧ҪµĶ֡
		if( pUnit->Status.nTaskIDEx == SHENGJI1 )
		{
			pUnit->Draw.nCol = 2 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
		}
		else if( pUnit->Status.nTaskIDEx == SHENGJI2 )
		{
			pUnit->Draw.nCol = 4 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
		}
		else if( pUnit->Status.nTaskIDEx == SHENGJI3 )
		{
			pUnit->Draw.nCol = 6 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
		}

		pUnit->Status.bIRQ = FALSE;
		Assert( pUnit->nHasShadow == 1 );
		pUnit->Status.bDone = TRUE;
		return;
	}

	if( EYE_IfSheIsMine( pUnit )
		&& EYE_IfFocusOnUnit( pUnit ) )
	{
		// Ѫ
		FACE_ShowProcessBar( PROCESSBAR_PROCESS, pUnit->nCounter*100/RUN_TIMEDELAY_UPGRADE );
	}
	pUnit->nCounter++;
}

// ״̬QXTISHENGʱ
void RUN_QxUpgrade( struct UNIT_STRUCT *pUnit )
{
	if( EYE_IfFocusOnUnit( pUnit )
		&& EYE_IfSheIsMine( pUnit ) )
	{
		// Ϣ
		struct	PROMPT_BLOCK	temp;
		temp.PromptBlockId = PROMPT_CONSTRUCTION_IDLESS;	
		temp.PromptBlockUnion.Construction_Idless.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
		strcpy( temp.PromptBlockUnion.Construction_Idless.ConstructionName, 
				DATA_Lib.Unit[pUnit->Draw.nFile].strName );		// Լ
		if( pUnit->Draw.nFile == 22 )	// 
			temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.nResource;	// ԴĴ
		else
			temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.dwUpgrade[0];	// Լļ
		temp.PromptBlockUnion.Construction_Idless.Stone = 
			pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);	// Լֵ
		FACE_ShowPromptBlock( temp );

		// 
		CTRL_TASK_saveCmdUnit.Busy = 0;// ָԭ
		FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
		//CTRL_TASK_ClearAssembleDest();
	}

	// ˧ҪµĶ֡
	if( pUnit->Status.nTaskIDEx == SHENGJI1 )
	{
		pUnit->Draw.nCol = 0 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
		pUnit->Draw.nRow = 0;
	}
	else if( pUnit->Status.nTaskIDEx == SHENGJI2 )
	{
		pUnit->Draw.nCol = 2 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
		pUnit->Draw.nRow = 0;
	}
	else if( pUnit->Status.nTaskIDEx == SHENGJI3 )
	{
		pUnit->Draw.nCol = 4 + MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
		pUnit->Draw.nRow = 0;
	}

	// һǮ
	//...pUnit->Status.nTaskIDEx
	// Ǯ
	RUN_UPGRADE_PayBack( pUnit->Draw.nPlayer, pUnit->Status.nTaskIDEx );

	pUnit->Status.bIRQ = FALSE;
	Assert( pUnit->nHasShadow == 1 );
	pUnit->Status.bDone = TRUE;
}

// ״̬DUSEʱ
void RUN_Blocked( struct UNIT_STRUCT *pUnit )
{
	Assert( !EYE_IfUnitIsBuild( pUnit ) );
	Assert( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0 );

	if( pUnit->Draw.ptOff.x != 0 || pUnit->Draw.ptOff.y != 0 )
	{
		pUnit->Draw.ptOff.x = pUnit->Draw.ptOff.y = 0;
#ifdef	_DEBUG_OFFSET_
//		WriteLogFile( "off.log", "Blocked\n" );
#endif //_DEBUG_OFFSET_
	}

	if( RUN_bBlock == 1 )	return;		// ÿֻһ֧ӴӶ״ָ̬
	if( pUnit->nCounter == 0 )
	{	// ָΪԭʼ֡𴦽ղ״̬
		pUnit->Draw.nFrame = 1;
		pUnit->Draw.nCol = MAP_Lib.AniSeq[pUnit->Draw.nFile].nAniSeq[pUnit->Draw.nState][pUnit->Draw.nFrame]+
			MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
		pUnit->Draw.nRow = 0;
	}
	else if( pUnit->nCounter >= RUN_TIMEDELAY_BLOCK )
	{	// ʱ´
//		struct CTRL_TASK_STRUCT task;
//		CTRL_TASK_Clear( &task );
//		memcpy( &task, &pUnit->Task, sizeof( CTRL_TASK_STRUCT ) );
//		task.bDone = TRUE;
//		if( pUnit->Task.nTaskID == JIANZAO 
//			&& pUnit->Task.nTaskIDEx == 1 )
//			OutputDebugString( "e" );
		pUnit->Task.bDone = TRUE;
		// Aug 8, Liu Gang
		if( pUnit->Task.nTaskID == YUNZAI 
			&& !EYE_IfUnitIsTransport( MAP_GetUnit( pUnit->Task.nParam1 ) ) )
		{
			pUnit->Status.bDone = TRUE;
			return;
		}
		CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &pUnit->Task );

		RUN_bBlock = 1;	// ڱнֹԪ
	}
	pUnit->nCounter++;
}

// ״̬YUNZAIʱ
void RUN_OnShip( struct UNIT_STRUCT *pUnit )
{
	if( pUnit->nCounter == 0 )
	{	// 봬
		if( !EYE_IfUnitIsTransport( pUnit ) )
		{	// ϴ
			int nDir = EYE_IfUnitIsInRange( pUnit->nID, pUnit->Status.nParam1, 1 );
			if( nDir == -1 )
			{	// 䴬ڸ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "OnShip\n" );
#endif	//_DEBUG_OFFSET_
				pUnit->Status.nTaskID = DUSE;
				pUnit->nCounter = 0;
				return;
			}

			struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
			Assert( pU );
			Assert( EYE_IfUnitIsTransport( pU ) );
			if( !EYE_IfUnitIsTransport( pU ) )
			{
				pUnit->Status.bDone = TRUE;
				return;
			}
			if( pU->Status.nTaskID == YUNZAI )
			{
				Assert( pU->Soldier.nOnBoard <= SOLDIER_ONBOARD_MAX );
				if( pU->Soldier.nOnBoard == SOLDIER_ONBOARD_MAX )
				{
					pUnit->Status.bDone = TRUE;
					return;
				}

				pU->Soldier.bOnBoard = TRUE;
				pU->Soldier.nOnBoard++;
				pU->Soldier.nOnBoardSoldier+=pUnit->nLife;// ڴϵĲ

				if( EYE_IfFocusOnUnit( pU ) )
				{
					// Ϣ䴬
					struct	PROMPT_BLOCK	temp;
					temp.PromptBlockId = PROMPT_TRANSPORT_SHIP;
					temp.PromptBlockUnion.Transport_Ship.SoldierBitmapId = pU->Draw.nFile;
					strcpy( temp.PromptBlockUnion.Transport_Ship.SoldierKind, DATA_Lib.Unit[pU->Draw.nFile].strName );			// the kind of this soldier
					temp.PromptBlockUnion.Transport_Ship.SoldierPower = 
						pU->nLife*100/EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile);				// power -->
					temp.PromptBlockUnion.Transport_Ship.NumberOfUnit = pU->Soldier.nOnBoard;
					temp.PromptBlockUnion.Transport_Ship.NumberOfSolider = pU->Soldier.nOnBoardSoldier;
					FACE_ShowPromptBlock( temp );
				}

#ifdef	_DEBUG_OFFSET_
				TestOff( pUnit, "OnShip\n" );
#endif	//_DEBUG_OFFSET_
				//---
				// ϴ
				CTRL_UNIT_InUnit( pUnit );
				// ж
				pUnit->Status.bIRQ = TRUE;
				//---
			}
			else	// 䴬δ׼ãβѯ´μ
				return;
		}
		else
			return;
		// Ȼ䴬һֱָ״̬䣬ʿԵǴ
	}
	else if( pUnit->nCounter %4 == 0 )
	{	// Ƿ´
		struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
		if( EYE_IfUnitIsDead( pU ) )
		{
			// ´
			pUnit->Draw.nXLast = pUnit->Draw.nX, 
			pUnit->Draw.nYLast = pUnit->Draw.nY;
			pUnit->Draw.nX = pU->Draw.nX, 
			pUnit->Draw.nY = pU->Draw.nY;

			pU->Soldier.nOnBoard--;
			Assert( pU->Soldier.nOnBoard >=0 );

			//---
			// ߳
			//CTRL_UNIT_OutUnit( pUnit );
			// ж
			//pUnit->Status.bIRQ = FALSE;
			Assert( pUnit->nHasShadow == 0 );
			//---

			//CTRL_UNIT_Destroy( pUnit );// ֱɾϵĲӣṹ
			//pUnit->Status.bDone = TRUE;
			// ´ɾ
			struct CTRL_TASK_STRUCT task;
			CTRL_TASK_Clear( &task );
			task.nID = pUnit->nID;
			task.nTaskID = SHANCHU;
			task.bIRQ = TRUE;
			task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &task );
			return;
		}

		Assert( pU );
		Assert( EYE_IfUnitIsTransport( pU ) );
		Assert( !EYE_IfUnitIsTransport( pUnit ) );
		if( pU->Soldier.bOnBoard == FALSE )
		{
			// ´
			pUnit->Draw.nXLast = pUnit->Draw.nX, 
			pUnit->Draw.nYLast = pUnit->Draw.nY;
			pUnit->Draw.nX = pU->Draw.nX, 
			pUnit->Draw.nY = pU->Draw.nY;

			Assert( pU->Soldier.nOnBoard >=0 );

			//---
			// ߳
			if( CTRL_UNIT_OutUnit( pUnit ) )
			{
				pU->Soldier.nOnBoard--;
				pU->Soldier.nOnBoardSoldier-=pUnit->nLife;

				// ж
				pUnit->Status.bIRQ = FALSE;
				Assert( pUnit->nHasShadow == 1 );
				//---
				pUnit->Status.bDone = TRUE;
			}
		}
	}
	pUnit->nCounter++;
}

// ״̬XIEZAIʱ
void RUN_OffShip( struct UNIT_STRUCT *pUnit )
{
	Assert( EYE_IfUnitIsTransport( pUnit ) );
	if( !EYE_IfNearBank( pUnit->Draw.nLayer, pUnit->Draw.nX, 
		pUnit->Draw.nY, pUnit->Draw.nLocationSize ) )
	{	// ˮߣ
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "OffShip\n" );
#endif	//_DEBUG_OFFSET_
		pUnit->Status.nTaskID = DUSE;
		pUnit->nCounter = 0;
		return;
	}
	pUnit->Soldier.bOnBoard = FALSE;
	pUnit->Status.bDone = TRUE;

	if( EYE_IfFocusOnUnit( pUnit ) )
	{
		// Ϣ䴬
		struct	PROMPT_BLOCK	temp;
		temp.PromptBlockId = PROMPT_TRANSPORT_SHIP;
		temp.PromptBlockUnion.Transport_Ship.SoldierBitmapId = pUnit->Draw.nFile;
		strcpy( temp.PromptBlockUnion.Transport_Ship.SoldierKind, DATA_Lib.Unit[pUnit->Draw.nFile].strName );			// the kind of this soldier
		temp.PromptBlockUnion.Transport_Ship.SoldierPower = 
			pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);				// power -->
		temp.PromptBlockUnion.Transport_Ship.NumberOfUnit = pUnit->Soldier.nOnBoard;
		temp.PromptBlockUnion.Transport_Ship.NumberOfSolider = pUnit->Soldier.nOnBoardSoldier;
		FACE_ShowPromptBlock( temp );
	}
}

void RUN_LineUp( struct UNIT_STRUCT *pUnit )
{
	int i;
	WORD arTroop[GENERAL_TROOP_MAX];	// űӵʿID
	int nTrp;							// ʿĸ
	struct UNIT_STRUCT *pU = NULL;

	Assert( !EYE_IfUnitIsWorkerGen( pUnit ) );
	// սӵĽ죨½ˮ
	// 
	ZHEN_Change( pUnit, pUnit->Status.nTaskIDEx );

	// ʿ´ƶ
	nTrp = GENERAL_TROOP_MAX;
	EYE_GetUnitInGroup( 1, pUnit->nID, arTroop, &nTrp );
	Assert( nTrp >= 0 );
	for( i=0; i<nTrp; i++ )
	{
		Assert( arTroop[i] != MAP_DATA_NONE );
		pU = MAP_GetUnit( arTroop[i] );
		Assert( pU );

		// ƶ
		struct CTRL_TASK_STRUCT Task;
		CTRL_TASK_Clear( &Task );
		Task.nID = pU->nID;
		Task.nTaskID = YIDONG;
		Task.nTaskIDEx = 1;	// MOUSE_HITRESULT_GROUND
		Task.nParam1 = pU->Draw.nLayer;
		int nX = pUnit->Draw.nX+pU->ptZhenFa.x;
		int nY = pUnit->Draw.nY+pU->ptZhenFa.y;
		if( nX <= 1 )
			nX = 2;
		else if( nX >= MAP_Lib.szNum.cx-1 )
			nX = MAP_Lib.szNum.cx - 2;
		if( nY <= 3 )
			nY = 4;
		else if( nY >= MAP_Lib.szNum.cy-3 )
			nY = MAP_Lib.szNum.cy-4;

		Task.nParam2 = WORD(pUnit->Draw.nX+pU->ptZhenFa.x);
		Task.nParam3 = WORD(pUnit->Draw.nY+pU->ptZhenFa.y);
		Task.bDone = TRUE;
		CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
	}
	pUnit->Status.bDone = TRUE;
}

// ״̬JIESHUʱ
void RUN_EndAll( struct UNIT_STRUCT *pUnit )
{
	pUnit->Status.bDone = TRUE;
}

// ״̬ʱ
void RUN_OpenDoor( struct UNIT_STRUCT *pUnit )
{
	Assert( EYE_IfUnitIsDoor( pUnit ) );
	if( pUnit->nCounter == 0 )
	{
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Door\n" );
#endif	//_DEBUG_OFFSET_
		//---
		// ߽
		CTRL_UNIT_InUnit( pUnit );
		// ж
		pUnit->Status.bIRQ = TRUE;
		//---
	}
	else if( pUnit->nCounter >= RUN_TIMEDELAY_OPENDOOR )
	{
		POINT ptNew = MAP_FindRegion( pUnit->Draw.nLayer, pUnit->Draw.nX, 
			pUnit->Draw.nY, MAP_Lib.Unit[pUnit->Draw.nFile].nItems[0] );
		if( ptNew.x != pUnit->Draw.nX
			|| ptNew.y != pUnit->Draw.nY )
		{
			pUnit->nCounter = 0;
		}
		else
		{
			//---
			// ߳
			if( CTRL_UNIT_OutUnit( pUnit ) )
			{
				pUnit->Status.bIRQ = FALSE;	// ж
			//---
				pUnit->Status.bDone = TRUE;
			}
		}
	}
	pUnit->nCounter++;
}

// ״̬JIMOUʱ
int	RUN_MOULUE_nConsume[CTRL_JIMOU_MAX]=
{
	0, 50, 100, 100, 100, 200, 100, 100, 10, 100, 0, 0
};

extern BOOL CTRL_bDebugCommand;
void RUN_Strategy( struct UNIT_STRUCT *pUnit )
{
	Assert( EYE_IfUnitIsGen( pUnit ) );
	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;
	
	if( pUnit->nCounter > 0 )
	{	//֡
		Assert( MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState] != 0 );
		pDraw->nFrame = ( pDraw->nFrame+1 )%MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState];
		if( pDraw->nFrame == MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState]-1 )
			pUnit->Status.bDone = TRUE;
		return;
	}

	// 趯֡
	if( pDraw->nFile == 31 || pDraw->nFile == 35 )	// ｫ
		pDraw->nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[3];
	else
		pDraw->nState = pDraw->nDir+MAP_Lib.AniSeq[pDraw->nFile].nEventBegin[2];
	pDraw->nCol = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][pDraw->nFrame]+
		MAP_Lib.AniSeq[pDraw->nFile].nOffset;
	pDraw->nRow = 0;

	pUnit->nCounter++;

	Assert( RUN_MOULUE_IfEnough( pUnit, CTRL_JIMOU(pUnit->Status.nTaskIDEx2) ) 
		|| CTRL_bDebugCommand == TRUE );
	if( !RUN_MOULUE_IfEnough( pUnit, CTRL_JIMOU(pUnit->Status.nTaskIDEx2) ) )
		return;
	// ıԵ
	DATA_Lib.Gen[pUnit->Gen.nID].nMouLue -= RUN_MOULUE_nConsume[pUnit->Status.nTaskIDEx2];

	if( EYE_IfFocusOnUnit( pUnit ) )
	{	// ıֵʾ
		FACE_UpdateRuse( DATA_Lib.Gen[pUnit->Gen.nID].nMouLue );
	}

	WORD wTroop[GENERAL_TROOP_MAX];
	int nNum = GENERAL_TROOP_MAX;
	struct UNIT_STRUCT *pU = NULL;
	if( pUnit->Status.nTaskIDEx2 != HUOGONG )
	{
		if( pUnit->Status.nTaskIDEx2 == HUIFU )
		{
			pU = MAP_GetUnit( pUnit->Status.nParam1 );
		}
		else
		{
			Assert( pUnit->Status.nTaskIDEx == 2 );
			Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
			EYE_GetUnitInGroup( 1, pUnit->Status.nParam1, wTroop, &nNum );
			pU = MAP_GetUnit( pUnit->Status.nParam1 );
			pU = EYE_GetGeneral( pU );
			if( pU == NULL )
			{	// Ŀ겻κβӣֻԸĿһʵʩı
				nNum = 0;
				pU = MAP_GetUnit( pUnit->Status.nParam1 );
				return;
			}
		}
		Assert( pU );
		Assert( EYE_IfUnitIsSoldier( pU ) || EYE_IfUnitIsGen( pU ) );
	}
	int i;
	switch( pUnit->Status.nTaskIDEx2 )
	{
	case	JILI:	// 
		// üıͼıļʱ
		CTRL_SetSTG( &pU->Draw, JILI, TRUE );
		if( EYE_IfFocusOnUnit( pU ) )
		{// ʿ
			FACE_UpdateMorale( EYE_GetMorale( pU ) ) ;
		}
		for( i=0; i<nNum; i++ )
		{
			pU = MAP_GetUnit( wTroop[i] );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) );
			CTRL_SetSTG( &pU->Draw, JILI, TRUE );
		}
		break;
	case	JIASU:	// 
		// üıͼıļʱ
		CTRL_SetSTG( &pU->Draw, JIASU, TRUE );
		CTRL_SetSTG( &pU->Draw, JIANSU, FALSE );// ٺͼٻ
		for( i=0; i<nNum; i++ )
		{
			pU = MAP_GetUnit( wTroop[i] );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) );
			CTRL_SetSTG( &pU->Draw, JIASU, TRUE );
			CTRL_SetSTG( &pU->Draw, JIANSU, FALSE );// ٺͼٻ
		}
		break;
	case	JIANSU:	// 
		// üıͼıļʱ
		CTRL_SetSTG( &pU->Draw, JIANSU, TRUE );
		CTRL_SetSTG( &pU->Draw, JIASU, FALSE );// ٺͼٻ
		for( i=0; i<nNum; i++ )
		{
			pU = MAP_GetUnit( wTroop[i] );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) );
			CTRL_SetSTG( &pU->Draw, JIANSU, TRUE );
			CTRL_SetSTG( &pU->Draw, JIASU, FALSE );// ٺͼٻ
		}
		break;
	case	YUANSHI:	// Զ
		// üıͼıļʱ
		// ֻҷӰı
		if( GAME.nMe == pU->Draw.nPlayer )
		{
			//lwc
			// ʧ
			int nVRange = EYE_GetViewRange( &pU->Draw );
			Assert( pU->nHasShadow == 1 );
			SHADOW_death (pU->Draw.nX,pU->Draw.nY,nVRange);
			//lwc
		}
		pU->nHasShadow--;
		CTRL_SetSTG( &pU->Draw, YUANSHI, TRUE );
		// Ӱ
		if( GAME.nMe == pU->Draw.nPlayer )
		{
			int nSight = EYE_GetViewRange( &pU->Draw );
			Assert( pU->nHasShadow == 0 );
			SHADOW_existent( pU->Draw.nX, pU->Draw.nY, nSight );
		}
		pU->nHasShadow++;
		// draw to minimap
		MINI_SetUnitData( pU->Draw.nX, pU->Draw.nY, pU->Draw.nPlayer, pU->Draw.nLocationSize );	// for minimap

		for( i=0; i<nNum; i++ )
		{
			pU = MAP_GetUnit( wTroop[i] );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) );
			// ֻҷӰı
			if( GAME.nMe == pU->Draw.nPlayer )
			{
				//lwc
				// ʧ
				int nVRange = EYE_GetViewRange( &pU->Draw );
				Assert( pU->nHasShadow == 1 );
				SHADOW_death (pU->Draw.nX,pU->Draw.nY,nVRange);
				//lwc
			}
			pU->nHasShadow--;

			CTRL_SetSTG( &pU->Draw, YUANSHI, TRUE );
			// Ӱ
			if( GAME.nMe == pU->Draw.nPlayer )
			{
				int nSight = EYE_GetViewRange( &pU->Draw );
				Assert( pU->nHasShadow == 0 );
				SHADOW_existent( pU->Draw.nX, pU->Draw.nY, nSight );
			}
			pU->nHasShadow++;
			// draw to minimap
			MINI_SetUnitData( pU->Draw.nX, pU->Draw.nY, pU->Draw.nPlayer, pU->Draw.nLocationSize );	// for minimap
		}
		break;
	case	HUNLUAN:	// 
		{
			// üıͼıļʱ
			CTRL_SetSTG( &pU->Draw, HUNLUAN, TRUE );

			// ´
			struct CTRL_TASK_STRUCT Task;
			CTRL_TASK_Clear( &Task );
			Task.nID = pU->nID;
			Task.nTaskID = HLUAN;
			Task.bIRQ = TRUE;	// ж
			Task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pU->Draw.nPlayer, &Task );

			for( i=0; i<nNum; i++ )
			{
				pU = MAP_GetUnit( wTroop[i] );
				Assert( pU );
				Assert( EYE_IfUnitIsSoldier( pU ) );
				CTRL_SetSTG( &pU->Draw, HUNLUAN, TRUE );

				// ´
				struct CTRL_TASK_STRUCT Task;
				CTRL_TASK_Clear( &Task );
				Task.nID = pU->nID;
				Task.nTaskID = HLUAN;	// ж
				Task.bIRQ = TRUE;
				Task.bDone = TRUE;
				CTRL_TASK_DeployByComputer( pU->Draw.nPlayer, &Task );
			}
		}
		break;
	case	GUNMU:	// ľ
		// üıͼıļʱ
		CTRL_SetSTG( &pU->Draw, GUNMU, TRUE );
		for( i=0; i<nNum; i++ )
		{
			pU = MAP_GetUnit( wTroop[i] );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) );
			CTRL_SetSTG( &pU->Draw, GUNMU, TRUE );
		}
		break;
	case	MAIFU:	// 
		{
			// üıͼıļʱ
			CTRL_SetSTG( &pU->Draw, MAIFU, TRUE );

			// ´
			struct CTRL_TASK_STRUCT Task;
			CTRL_TASK_Clear( &Task );
			Task.nID = pU->nID;
			Task.nTaskID = MFU;
			//Task.bIRQ = TRUE;
			Task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pU->Draw.nPlayer, &Task );

			for( i=0; i<nNum; i++ )
			{
				pU = MAP_GetUnit( wTroop[i] );
				Assert( pU );
				Assert( EYE_IfUnitIsSoldier( pU ) );
				CTRL_SetSTG( &pU->Draw, MAIFU, TRUE );

				// ´
				struct CTRL_TASK_STRUCT Task;
				CTRL_TASK_Clear( &Task );
				Task.nID = pU->nID;
				Task.nTaskID = MFU;
				//Task.bIRQ = TRUE;
				Task.bDone = TRUE;
				CTRL_TASK_DeployByComputer( pU->Draw.nPlayer, &Task );
			}
		}
		break;
	case	HUIFU:	// ָ
		{
			pU->nLife += RUN_MOULUE_HUIFU_ADD;
			int nLife = EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile );
			if( pU->nLife > nLife )
				pU->nLife = nLife;
		}
		break;
	case	HUOGONG:	// 
		Assert( pUnit->Status.nTaskIDEx == 1 );
		// ˻𹥵ĳʱ䣬Aug 29, 1997
		OTHER_HUOGONG_Set( pUnit->Status.nParam2, pUnit->Status.nParam3, 200, 4, 1 );

		// ¼
		EVENT_Fire( GAME.nID, pUnit->Draw.nPlayer, pUnit->Status.nParam2, pUnit->Status.nParam3 );
		break;
	}
}

// ״̬HLUANʱ
void RUN_HLuan( struct UNIT_STRUCT *pUnit )
{
	if( CTRL_GetSTG( &pUnit->Draw, HUNLUAN ) == FALSE )
	{
		pUnit->Status.bIRQ = FALSE;
		pUnit->Status.bDone = TRUE;
	}
}

// ״̬MFUʱ
void RUN_MFu( struct UNIT_STRUCT *pUnit )
{
	if( CTRL_GetSTG( &pUnit->Draw, MAIFU ) == FALSE )
	{
		//pUnit->Status.bIRQ = FALSE;
		pUnit->Status.bDone = TRUE;
	}
	if( pUnit->nCounter%30 == 0 )
	{
		WORD wTroop[GENERAL_TROOP_MAX];
		int nNum = GENERAL_TROOP_MAX;
		EYE_GetUnitInSight( 2, pUnit->nID, wTroop, &nNum );
		if( nNum > 0 )
		{
			struct UNIT_STRUCT *pU = NULL;
			for( int i=0; i<nNum; i++ )
			{
				pU = MAP_GetUnit( wTroop[i] );
				pU = EYE_GetGeneral( pU );
				if( pU != NULL )
				{
					pU->Gen.nMorale-=50;	// нʿ50
					CTRL_SetSTG( &pUnit->Draw, MAIFU, FALSE );
					if( EYE_IfFocusOnUnit( pU ) )
					{	// ʿ
						FACE_UpdateMorale( EYE_GetMorale( pU ) ) ;
					}
					break;
				}
			}
		}
	}
	pUnit->nCounter++;
}

// ״̬DANTIAOʱ
#include "cbprompt.h"
extern struct	SINGLE_UNIT		Single_Battle ;	// defined in interfa1.cpp
void RUN_FightSingle( struct UNIT_STRUCT *pUnit )
{
	if( GAME.bFightEnabled == FALSE 
		|| GAME_bNetwork == TRUE )
	{	// رϻսʱ
		pUnit->Status.bDone = TRUE;
		return;
	}

	Assert( EYE_IfUnitIsGen( pUnit ) );
	struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
	Assert( pU );
	pU = EYE_GetGeneral( pU );
	if( pU == NULL )
	{	// Էûн죬˳
		pUnit->Status.bDone = TRUE;
		return;
	}
	Assert( EYE_IfUnitIsGen( pU ) );
	Single_Battle.General_One.UnitId = pUnit->nID;
	Single_Battle.General_One.GeneralBitmapId = pUnit->Gen.nID;
	strcpy( Single_Battle.General_One.GeneralName, DATA_Lib.Gen[pUnit->Gen.nID].strName );
	Single_Battle.General_One.GeneralPower = EYE_GetWuLi( pUnit->Gen.nID )*100/120;
	Single_Battle.General_One.GeneralBlood = pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile );	// 
	Single_Battle.General_Two.UnitId = pU->nID;
	Single_Battle.General_Two.GeneralBitmapId = pU->Gen.nID;
	strcpy( Single_Battle.General_Two.GeneralName, DATA_Lib.Gen[pU->Gen.nID].strName );
	Single_Battle.General_Two.GeneralPower = EYE_GetWuLi( pU->Gen.nID )*100/120;
	Single_Battle.General_Two.GeneralBlood = pU->nLife*100/EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile );	// 

	PostMessage( hwndGame, WM_COMMAND, BUTTON_SINGLE_SHOWMENU, 0 );
	pUnit->Status.bDone = TRUE;
}

// ״̬XIUXIʱ
void RUN_Rest( struct UNIT_STRUCT *pUnit )
{
	int nGenFile[4]={35,31,33,29};

	if( !EYE_IfUnitIsGen( pUnit ) )
	{
		pUnit->Status.bDone = TRUE;
		return;
	}
	Assert( EYE_IfUnitIsGen( pUnit ) );
	pUnit->nCounter++;
	if( pUnit->nCounter%10 != 0 )
	{
		return;
	}

	if( pUnit->nLife < EYE_GetFullLife( -1, nGenFile[DATA_Lib.Gen[pUnit->Gen.nID].nType-1] ) )
	{
		pUnit->nLife++;
	}
	else
	{
		pUnit->Status.bDone = TRUE;
	}
	if( pUnit->nCounter%100 == 0
		&& EYE_IfFocusOnUnit( pUnit ) 
		&& EYE_IfSheIsMine( pUnit ) )
	{
		FACE_ShowProcessBar( PROCESSBAR_BLOOD, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile) );
	}
}
///////////////////////////////


///////////////////////////////
// Added by Dong Hai
inline BOOL RUN_GetNextForward(struct CTRL_FRAME_STRUCT * pDraw,struct UNIT_STRUCT * pUnit)
{
	int	nDir;

	nDir=pUnit->MarchTrack[pUnit->StepNum+1];
	if(pDraw->nDir==8)
		{
			pDraw->Status=MARCH_NO_UP_DOWN;
//			pDraw->Status=MARCH_UP_UP;
			pUnit->StepNum++;
			pDraw->nDir = pUnit->MarchTrack[pUnit->StepNum];
			pDraw->nLayer++;
			if(pDraw->nDir==255)
				{
					if( pUnit->Status.nTaskIDEx2 == DUSE )
					{
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Next1\n" );
#endif	//_DEBUG_OFFSET_
						pUnit->Status.nTaskID = DUSE;	// 
						pUnit->nCounter = 0;
					}
					else
						pUnit->Status.bDone = TRUE;
					return TRUE;
				}
		}
	if((pDraw->nDir!=8)&&(nDir==8))
		{
//			pDraw->Status=MARCH_NO_UP_DOWN;
			pDraw->Status=MARCH_UP_UP;
//			pUnit->StepNum++;
//			pDraw->nDir = pUnit->MarchTrack[pUnit->StepNum];
			if(pDraw->nDir==255)
				{
					if( pUnit->Status.nTaskIDEx2 == DUSE )
					{
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Next2\n" );
#endif	//_DEBUG_OFFSET_
						pUnit->Status.nTaskID = DUSE;	// 
						pUnit->nCounter = 0;
					}
					else
						pUnit->Status.bDone = TRUE;
					return TRUE;
				}
//			pUnit->StepNum++;
		}
	else{
			if(pDraw->nDir==9)
				{
					pDraw->Status=MARCH_NO_UP_DOWN;
					pUnit->StepNum++;
					pDraw->nDir = pUnit->MarchTrack[pUnit->StepNum];
					pDraw->nLayer--;
					if(pDraw->nDir==255)
						{
							if( pUnit->Status.nTaskIDEx2 == DUSE )
							{
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Next3\n" );
#endif	//_DEBUG_OFFSET_
								pUnit->Status.nTaskID = DUSE;	// 
								pUnit->nCounter = 0;
							}
							else
								pUnit->Status.bDone = TRUE;
							return TRUE;
						}
				}
			if((pDraw->nDir!=9)&&(nDir==9))
				{
					pDraw->Status=MARCH_DOWN_DOWN;
//					pUnit->StepNum++;
//					pDraw->nLayer--;
//					pDraw->nDir = pUnit->MarchTrack[pUnit->StepNum];
/*					if((pUnit->MarchTrack[pUnit->StepNum+2]==0)||(pUnit->MarchTrack[pUnit->StepNum+2]==1)||(pUnit->MarchTrack[pUnit->StepNum+2]==7))
						{
							pDraw->nLayer--;
							pDraw->Status=MARCH_OK;
						}*/
					if(pDraw->nDir==255)
						{
							if( pUnit->Status.nTaskIDEx2 == DUSE )
							{
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Next4\n" );
#endif	//_DEBUG_OFFSET_
								pUnit->Status.nTaskID = DUSE;	// 
								pUnit->nCounter = 0;
							}
							else
								pUnit->Status.bDone = TRUE;
							return TRUE;
						}
//					pUnit->StepNum++;
				}
			else{
					if((pDraw->nDir==9)&&((pUnit->MarchTrack[pUnit->StepNum]==0)||(pUnit->MarchTrack[pUnit->StepNum]==1)||(pUnit->MarchTrack[pUnit->StepNum]==7)))
						{pDraw->Status=MARCH_OK;}
					else{pDraw->Status=MARCH_OK;}
					while(pDraw->nDir==13)
						{
							pUnit->StepNum++;
							pDraw->nDir = pUnit->MarchTrack[pUnit->StepNum];
							if(pDraw->nDir==255)
								{
									if( pUnit->Status.nTaskIDEx2 == DUSE )
									{
#ifdef	_DEBUG_OFFSET_
		TestOff( pUnit, "Next5\n" );
#endif	//_DEBUG_OFFSET_
										pUnit->Status.nTaskID = DUSE;	// 
										pUnit->nCounter = 0;
									}
									else
										pUnit->Status.bDone = TRUE;
									return TRUE;
								}
						}
				}
		}
	return	FALSE;
}

inline void RUN_DrawUpAndDown(struct CTRL_FRAME_STRUCT * pDraw)
{

	if((pDraw->Status==MARCH_UP_UP)&&(pDraw->nLayer==0))
		{
			if((pDraw->nDir==5)||(pDraw->nDir==4)||(pDraw->nDir==3))
				{
					pDraw->ptOff.x=0;
					pDraw->ptOff.y=0;
					pDraw->nOff_Z=0;
				}
//			if(((pDraw->ptOff.x==0)&&(pDraw->ptOff.y==0))||(pDraw->nDir==2)||(pDraw->nDir==6))
			if((pDraw->ptOff.x==0)&&(pDraw->ptOff.y==0))
				{
//					pDraw->nOff_Z=0;
				}
			else{
					int		i;
					int		j;
					switch(pDraw->nDir)
						{
							case	0:
							case	1:
							case	3:
							case	4:
							case	5:
							case	7:
									i=pDraw->ptOff.y;
									if(i<0){i=-i;}
									j=50-pDraw->nOff_Z;
									j=(int)j/i;
									pDraw->nOff_Z=pDraw->nOff_Z+j;
									break;
							case	2:
							case	6:
									i=pDraw->ptOff.x;
									if(i<0){i=-i;}
									i=i>>1;
									j=50-pDraw->nOff_Z;
									j=(int)j/i;
									pDraw->nOff_Z=pDraw->nOff_Z+j;
									break;
						}
				}
		}
	if((pDraw->Status==MARCH_UP_UP)&&(pDraw->nLayer==1))
		{
			if((pDraw->nDir==5)||(pDraw->nDir==4)||(pDraw->nDir==3))
				{
					pDraw->ptOff.x=0;
					pDraw->ptOff.y=0;
					pDraw->nOff_Z=0;
				}
//			if(((pDraw->ptOff.x==0)&&(pDraw->ptOff.y==0))||(pDraw->nDir==2)||(pDraw->nDir==6))
			if((pDraw->ptOff.x==0)&&(pDraw->ptOff.y==0))
				{
//					pDraw->nOff_Z=0;
				}
			else{
					int		i;
					int		j;
					switch(pDraw->nDir)
						{
							case	0:
							case	1:
							case	3:
							case	4:
							case	5:
							case	7:
									i=pDraw->ptOff.y;
									if(i<0){i=-i;}
									j=19-pDraw->nOff_Z;
									j=(int)j/i;
									pDraw->nOff_Z=pDraw->nOff_Z+j;
									break;
							case	2:
							case	6:
									i=pDraw->ptOff.x;
									if(i<0){i=-i;}
									i=i>>1;
									j=19-pDraw->nOff_Z;
									j=(int)j/i;
									pDraw->nOff_Z=pDraw->nOff_Z+j;
									break;
						}
				}
		}
	if((pDraw->Status==MARCH_DOWN_DOWN)&&(pDraw->nLayer==2))
		{
			if((pDraw->nDir==0)||(pDraw->nDir==1)||(pDraw->nDir==7))
				{
					pDraw->ptOff.x=0;
					pDraw->ptOff.y=0;
					pDraw->nOff_Z=0;
				}
//			if(((pDraw->ptOff.x==0)&&(pDraw->ptOff.y==0))||(pDraw->nDir==2)||(pDraw->nDir==6))
			if((pDraw->ptOff.x==0)&&(pDraw->ptOff.y==0))
				{
//					pDraw->nLayer--;
//					pDraw->nOff_Z=0;
				}
			else{
					int		i;
					int		j;
					switch(pDraw->nDir)
						{
							case	0:
							case	1:
							case	3:
							case	4:
							case	5:
							case	7:
									i=pDraw->ptOff.y;
									if(i<0){i=-i;}
									j=19+pDraw->nOff_Z;
									j=(int)j/i;
									pDraw->nOff_Z=pDraw->nOff_Z-j;
									break;
							case	2:
							case	6:
									i=pDraw->ptOff.x;
									if(i<0){i=-i;}
									i=i>>1;
									j=19+pDraw->nOff_Z;
									j=(int)j/i;
									pDraw->nOff_Z=pDraw->nOff_Z-j;
									break;
						}
				}
		}
	else{
			if((pDraw->Status==MARCH_DOWN_DOWN)&&(pDraw->nLayer==1))
				{
					if((pDraw->nDir==0)||(pDraw->nDir==1)||(pDraw->nDir==7))
						{
							pDraw->ptOff.x=0;
							pDraw->ptOff.y=0;
							pDraw->nOff_Z=0;
						}
//					if(((pDraw->ptOff.x==0)&&(pDraw->ptOff.y==0))||(pDraw->nDir==2)||(pDraw->nDir==6))
					if((pDraw->ptOff.x==0)&&(pDraw->ptOff.y==0))
						{
//							pDraw->nLayer--;
//							pDraw->nOff_Z=0;
						}
					else{
							int		i;
							int		j;
							switch(pDraw->nDir)
								{
									case	0:
									case	1:
									case	3:
									case	4:
									case	5:
									case	7:
											i=pDraw->ptOff.y;
											if(i<0){i=-i;}
											j=50+pDraw->nOff_Z;
											j=(int)j/i;
											pDraw->nOff_Z=pDraw->nOff_Z-j;
											break;
									case	2:
									case	6:
											i=pDraw->ptOff.x;
											if(i<0){i=-i;}
											i=i>>1;
											j=50+pDraw->nOff_Z;
											j=(int)j/i;
											pDraw->nOff_Z=pDraw->nOff_Z-j;
											break;
								}
						}
				}
		}
	if(pDraw->Status==MARCH_OK)
		{
			pDraw->nOff_Z=0;
		}
}
/////////////

/////////////
// 
BOOL RUN_FIGHT_Single()
{
	int nRet = 0;
	int nHit1 = (int)(Single_Battle.General_One.GeneralBlood
				*Single_Battle.General_One.GeneralPower
				*(1+(Single_Battle.General_One.GeneralPower-Single_Battle.General_Two.GeneralPower)*4/60.0)
				*getrandom( 4, 8 )/1000.0);
	int nHit2 = (int)(Single_Battle.General_Two.GeneralBlood
				*Single_Battle.General_Two.GeneralPower
				*(1+(Single_Battle.General_Two.GeneralPower-Single_Battle.General_One.GeneralPower)*4/60.0)
				*getrandom( 4, 8 )/1000.0);
	if( nHit1 < 0 )
		nHit1 = 0;
	if( nHit2 < 0 )
		nHit2 = 0;
	if( nHit1 >= Single_Battle.General_Two.GeneralBlood )
	{	// з佫ˣʤ10%Ѫ
		Single_Battle.General_Two.GeneralBlood = 0;
		Single_Battle.General_One.GeneralBlood -= Single_Battle.General_One.GeneralBlood/10;
		Single_Battle.Winner = 1;
		nRet = 1;
	}
	else if( nHit2 >= Single_Battle.General_One.GeneralBlood )
	{	// ҷ佫ˣʤ10%Ѫ
		Single_Battle.General_One.GeneralBlood = 0;
		Single_Battle.General_Two.GeneralBlood -= Single_Battle.General_Two.GeneralBlood/10;
		Single_Battle.Winner = 2;
		nRet = 2;
	}
	else
	{	// Ѫ
		Single_Battle.General_One.GeneralBlood -= nHit2;
		Single_Battle.General_Two.GeneralBlood -= nHit1;
		Single_Battle.Winner = 0;
		nRet = 0;
	}

	struct UNIT_STRUCT *pU = MAP_GetUnit( Single_Battle.General_One.UnitId );
	Assert( pU );
	Assert( EYE_IfUnitIsGen( pU ) );
	pU->nLife = Single_Battle.General_One.GeneralBlood
		*EYE_GetFullLife( -1, pU->Draw.nFile )/100 ;
	struct UNIT_STRUCT *pU2 = MAP_GetUnit( Single_Battle.General_Two.UnitId );
	Assert( pU2 );
	Assert( EYE_IfUnitIsGen( pU2 ) );
	pU2->nLife = Single_Battle.General_Two.GeneralBlood
		*EYE_GetFullLife( -1, pU2->Draw.nFile )/100 ;

	if( nRet != 0 )
	{
		struct CTRL_TASK_STRUCT Task;
		CTRL_TASK_Clear( &Task );
		int nPlayer = -1;
		if( nRet == 1 )
		{
			Task.nID = Single_Battle.General_Two.UnitId;
			nPlayer = pU2->Draw.nPlayer;
		}
		else
		{
			Task.nID = Single_Battle.General_One.UnitId;
			nPlayer = pU->Draw.nPlayer;
		}
		Task.nTaskID = SHANCHU;
		Task.bIRQ = TRUE;
		Task.bDone = TRUE;
		CTRL_TASK_DeployByComputer( nPlayer, &Task );
	}
	else
	{
		if( pU->nLife == 0 )
			pU->nLife = 1;
		if( pU2->nLife == 0 )
			pU2->nLife = 1;
	}
	return nRet;
} 

// Ƿ
BOOL RUN_IfFight()
{
	return EYE_IfFight( 
		Single_Battle.General_One.GeneralBlood, 
		Single_Battle.General_One.GeneralPower,
		Single_Battle.General_Two.GeneralBlood, 
		Single_Battle.General_Two.GeneralPower );
}
/////////////
