/////////////////////
//	CBShadow.h		:	v0012
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.0 & DirectX
//	Library			:	DDraw.Lib
//  Copyright		:	WayAhead Software Co.Ltd.	1996-1997
//	v0010			:	Feb.10.1997
//	v0011			:	Mar.28.1997, changed SHADOW_sItem to SHADOW_psItem
//	v0012			:	May.2.1997, make Drawall() faster if need not to draw the whole screen
/////////////////////
// header file
// shadow functions
// ӰѩЧĲ

#ifndef	__CBSHADOW_H__
#define	__CBSHADOW_H__
/////////////////////

// 룬ʱʹԴΪ׼Ĵ룬Ҵ
#define	SHADOW_ERROR_ID		1300
/////////////////////

/////////////////////
// װӰ棨Ӱʾͼ
// load shadow surfaces
// return :	TRUE if successful
BOOL SHADOW_Load();

// ͷӰ
// release shadow surfaces
void SHADOW_Release();

// ӰӸcMap_shadowEx
void SHADOW_Clear();
/////////////////////

////lwc
void SHADOW_existent(int nX,int nY,int nRange);

////lwc
void SHADOW_death (int nX,int nY,int nRange);

/////////////////////
// ʾһӰ
// nX, nY	:	λãԸΪλ
// nXLast, nYLast:	һε
// nRange	:	ԪҰСԸΪλ
void SHADOW_Draw( int nX, int nY, int nXLast, int nYLast, int nRange );

// ʾһӰֻʾһ
// nX, nY	:	λãԸΪλ
// nXLast, nYLast:	һε
// nRange	:	ԪҰСԸΪλ
void SHADOW_Draw0( int nX, int nY, int nXLast, int nYLast, int nRange );

// Ӱı濽Ϸı
void SHADOW_Update2Back( CONST RECT *prcCut = NULL, BOOL bFront=FALSE );

// redraw all the shadows in client area
// ػսӰϷһʼƶĻʱ
void SHADOW_DrawAll( LPRECT prcCut = NULL );

// Ӱϱµλ
extern void SHADOW_MoveBack( POINT ptDest, LPRECT prcSrc );
/////////////////////

/////////////////////
// ӰЧ
// enable or disable shadow
// bEnable	:	enable or disable shadow
void SHADOW_Enable( BOOL bEnable = TRUE );

// ӰЧǿǹ
// test if shadow is enabled
// return :	TRUE if enabled
BOOL SHADOW_IfEnabled();

// õǷӰ
// test if this point is under the shadow
// nX, nY	:	point to test
// return	:	MAP_SHADOW_NONE if it is blanked
//				else returns the content of stctR.nShadow
extern int SHADOW_IfBlanked( int nX, int nY );
/////////////////////

#endif