/////////////
//	CBZhenFa.cpp	:	v0010
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.2
//	Copyright (C)	:	1996 WayAhead Corporation
//	v0010			:	Apr.16.1997
/////////////
// implementation file
// 

#include "stdafx.h"
#include "Assert.h"
#include "CBGame.h"		// struct UNIT_STRUCT
#include "CBMap.h"
#include "CBCtrl.h"		// enum CTRL_ZHENXING
#include "CBEyes.h"		// EYE_
#include "CBZhenFa.h"

/////////////
// local functions
// 
void ZHEN_SetAll( struct UNIT_STRUCT *pUnit, int nID );

// һֳ
void ZHEN_Set1( struct UNIT_STRUCT *pUnit );

// ˮ
void ZHEN_Set2( struct UNIT_STRUCT *pUnit );

// 
void ZHEN_Set3( struct UNIT_STRUCT *pUnit );

// 
void ZHEN_Set4( struct UNIT_STRUCT *pUnit );

// ÷
void ZHEN_Set5( struct UNIT_STRUCT *pUnit );

// 
void ZHEN_Set6( struct UNIT_STRUCT *pUnit );

// Ǳ
void ZHEN_Set7( struct UNIT_STRUCT *pUnit );

// Ž
void ZHEN_Set8( struct UNIT_STRUCT *pUnit );

// Ź
void ZHEN_Set9( struct UNIT_STRUCT *pUnit );

// ʮ
void ZHEN_Set10( struct UNIT_STRUCT *pUnit );
/////////////

/////////////
// ı
// pUnit	:	ıĲӣǽID
// nID		:	ID
void ZHEN_Change( struct UNIT_STRUCT *pUnit, int nID )
{
	Assert( EYE_IfUnitIsGen( pUnit ) );
	Assert( !EYE_IfUnitIsWorkerGen( pUnit ) );

	ZHEN_SetAll( pUnit, nID-1 );
/*
	switch( nID )	
	{
	case	YIZI:	// һֳ
		ZHEN_Set1( pUnit );
		break;
	case	ERLONG:	// ˮ
		ZHEN_Set2( pUnit );
		break;
	case	SANCAI:	// 
		ZHEN_Set3( pUnit );
		break;
	case	SIXIANG:// 
		ZHEN_Set4( pUnit );
		break;
	case	WUXING:	// ÷
		ZHEN_Set5( pUnit );
		break;
	case	LIUHE:	// 
		ZHEN_Set6( pUnit );
		break;
	case	QIXING:	// Ǳ
		ZHEN_Set7( pUnit );
		break;
	case	BAMEN:	// Ž
		ZHEN_Set8( pUnit );
		break;
	case	JIUGONG:// Ź
		ZHEN_Set9( pUnit );
		break;
	case	SHIMIAN:// ʮ
		ZHEN_Set10( pUnit );
		break;
	}
*/
}
/////////////

/////////////
// local functions

void ZHEN_SetAll( struct UNIT_STRUCT *pUnit, int nType )
{
	// λ
	POINT ptPOS[CTRL_ZHENXING_MAX][GENERAL_TROOP_MAX]=
	{
		//1
		{{0,-4},{-1,-2},{1,-2},{-2,-2},{2,-2},
		{-3,-2},{3,-2},{-4,-2},{4,-2},{-5,-2},
		{5,-2},{-6,-2},{6,-2},{-7,-2},{7,-2}},

		//2
		{{0,-6},{-1,4},{1,4},{-2,2},{2,2},
		{-2,0},{2,0,},{-3,-2},{3,-2},{-3,-4},
		{3,-4},{-4,-6},{4,-6},{-4,-8},{4,-8}},

		//3
		{{0,-6},{-3,2},{3,2},{-2,-6},{-4,0},
		{4,0},{2,-6},{-2,4},{2,4},{-4,-6},
		{-5,-2},{5,-2},{4,-6},{-1,6},{1,6}},

		//4
		{{2,0},{0,4},{2,4},{0,-4},{2,-4},
		{-2,0},{-2,-4},{-2,4},{-2,-8},{0,-8},
		{2,-8},{4,0},{4,-4},{4,4},{4,-8}},

		//5
		{{0,-8,},{-4,-2},{4,-2},{-3,6},{3,6},
		{-1,-4},{-3,2},{3,2},{-2,4},{2,4},
		{1,-4},{-2,-2},{2,-2},{-1,6},{1,6}},

		//6
		{{0,-6},{-2,-2},{2,-2},{-2,2},{2,2},
		{0,6},{-3,-2},{3,-2},{-3,2},{3,2},
		{0,8},{0,-2},{-1,0},{1,0},{0,2}},
		
		//7
		{{0,-4},{-1,-2},{-3,2},{-2,-4},{-3,-2},
		{1,-4},{2,-6},{0,4},{1,2},{3,-2},
		{2,4},{3,2},{-1,4},{-2,6},{0,-10}},

		//8
		{{0,-8},{-1,-6},{1,-6},{-2,-4},{2,-4},
		{-1,-2},{1,-2},{0,-12},{-4,-4},{4,-4},
		{0,4},{-2,-8},{2,-8},{-2,0},{2,0}},

		//9
		{{2,0},{0,4},{2,4},{-1,-2},{3,-2},
		{-1,6},{3,6},{-2,0},{0,8},{4,4},
		{2,-4},{-3,2},{1,10},{5,2},{1,-6}},

		//10
		{{0,-10},{-1,-8},{1,-8},{0,4},{-2,-8},
		{2,-8},{-1,4},{1,4},{-3,-6},{3,-6},
		{-4,-6},{4,-6},{-2,4},{2,4},{0,-4}},
	};

	int i;	// 
	WORD arTroop[GENERAL_TROOP_MAX];	// űӵʿID
	int nTrp;							// ʿĸ
	struct UNIT_STRUCT *parUnit[GENERAL_TROOP_MAX];	// // űӵʿָ

	// õӵʿ
	nTrp = GENERAL_TROOP_MAX;
	EYE_GetUnitInGroup( 1, pUnit->nID, arTroop, &nTrp );
	Assert( nTrp >= 0 );
	for( i=0; i<nTrp; i++ )
	{
		Assert( arTroop[i] != MAP_DATA_NONE );
		parUnit[i] = MAP_GetUnit( arTroop[i] );
		Assert( parUnit[i] );
		Assert( !EYE_IfUnitIsDead( parUnit[i] ) );
		//parUnit[i]->nZhenFa = nType;	// 
	}

	// ÿʿеλ
	for( i=0; i<nTrp; i++ )
	{
		parUnit[i]->ptZhenFa.x = ptPOS[nType][i].x,
		parUnit[i]->ptZhenFa.y = ptPOS[nType][i].y;
	}

	// 汾
//	pUnit->nZhenFa = nType;
}

// һֳ
void ZHEN_Set1( struct UNIT_STRUCT *pUnit )
{
	// λ
	POINT ptPOS[GENERAL_TROOP_MAX]=
	{{0,-2},{-1,-2},{1,-2},{-2,-2},{2,-2},
	{-3,-2},{3,-2},{-4,-2},{4,-2},{-5,-2},
	{5,-2},{-6,-2},{6,-2},{-7,-2},{7,-2}};

	int i;	// 
	WORD arTroop[GENERAL_TROOP_MAX];	// űӵʿID
	int nTrp;							// ʿĸ
	struct UNIT_STRUCT *parUnit[GENERAL_TROOP_MAX];	// // űӵʿָ

	// õӵʿ
	nTrp = GENERAL_TROOP_MAX;
	EYE_GetUnitInGroup( 1, pUnit->nID, arTroop, &nTrp );
	Assert( nTrp >= 0 );
	for( i=0; i<nTrp; i++ )
	{
		Assert( arTroop[i] != MAP_DATA_NONE );
		parUnit[i] = MAP_GetUnit( arTroop[i] );
//		parUnit[i]->nZhenFa = YIZI;	// 
		Assert( parUnit[i] );
		Assert( !EYE_IfUnitIsDead( parUnit[i] ) );
	}

	// ÿʿеλ
	for( i=0; i<nTrp; i++ )
	{
		parUnit[i]->ptZhenFa.x = ptPOS[i].x,
		parUnit[i]->ptZhenFa.y = ptPOS[i].y;
	}

	// 汾
//	pUnit->nZhenFa = YIZI;
}

// ˮ
void ZHEN_Set2( struct UNIT_STRUCT *pUnit )
{
}

// 
void ZHEN_Set3( struct UNIT_STRUCT *pUnit )
{
}

// 
void ZHEN_Set4( struct UNIT_STRUCT *pUnit )
{
}

// ÷
void ZHEN_Set5( struct UNIT_STRUCT *pUnit )
{
}

// 
void ZHEN_Set6( struct UNIT_STRUCT *pUnit )
{
}

// Ǳ
void ZHEN_Set7( struct UNIT_STRUCT *pUnit )
{
}

// Ž
void ZHEN_Set8( struct UNIT_STRUCT *pUnit )
{
}

// Ź
void ZHEN_Set9( struct UNIT_STRUCT *pUnit )
{
}

// ʮ
void ZHEN_Set10( struct UNIT_STRUCT *pUnit )
{
}
/////////////
