/////////////
//	Interfac.cpp	:	v0010
//	Written by		:	Li Haijun
//	Compiler		:	Microsoft Visual C++ 4.0 & DirectX
//	Library			:	DDraw.Lib
//	Copyright (C)	:	1996 WayAhead Corporation 
//	v0010			:	Nev.7.1996
/////////////
// implementation file
// This file provide basic interface function 
//////////////////////////////
#include "stdafx.h"
#include <stdio.h>

#include "Assert.h"		// debug function
#include "puthz.h"		// to include the string output function
#include "DDCompo.h"
#include "CBGame.h"		// to include the GAME
#include "CBDraw.h"		// 
#include "cbdata.h"
#include "cbmini.h"		// to use the function MINI_Update 

#include "Marco.h"		// the define of all macroPO
#include "DDButton.h"	// to include button's define 
#include "DDComUn.h"	// to include command unit's define
#include "DDBitmap.h"	// to include class CDDBitmap's defnie
#include "DDMenu.h"		// to include the menu
#include "DDCheck.h"	// to include the check-box
#include "DDList.h"		// to include the list
#include "DDCombo.h"	// to include the combo-box
#include "DDScroll.h"	// to include the scroll-bar
#include "cbperbar.h"	// to include the process bar
#include "cbprompt.h"	// to include the prompt block define
#include "ddtext.h"
#include "cbavi.h"

#include "cbarray.h"
#include "Interfac.h"
#include "Interfa1.h"

#include "l_text.h"		// to include the read prompt information function writeen by LWC
////////////////////////////
#include "l_scan.h"
#include "l_allbmp.h"
extern char	bmpfilename[30];
extern char	listfilename[30];
/////////////////////////////////////

/////////////////////////////////////////////////
//	this veriable is decleared only for net_work
extern BOOL GAME_bNetwork ;
/////////////////////////////////////////////////



#define		ENGLISH
/////////////////////////////////////////////
//////////////////Donghai///////////////////////////
#include	"Network.h"
extern	BYTE	DP_SendMessageBuff[BUFFER_MAX_BYTE];
extern	LPSTR	DP_NickName;

 

//////////////////Donghai///////////////////////////
//		the flag for message box
extern	BOOL	FACE_bMessageBox ;		// FALSE-->NO MESSAGE BOX
								// TRUE -->SHOW MESSAGE BOX
extern class	CDDBitmap	*	pAllBitmap[MAX_BITMAP];		//to store all bitmap's pointer 
extern class	CDDButton	*	pAllButton[MAX_BUTTON];		//to restore all button's pointer
extern class	CDDButton	*	pAllCommandButton[MAX_COMMANDBUTTON];		//to restore all command button's pointer
extern class	CDDCheckBoxUnit	*	pAllCheckBoxUnit[MAX_CHECKBOXUNIT];	//to restore all check-box's pointer
extern class	CDDListUnit	*	pAllListUnit[MAX_LISTUNIT]; //to record all list-unit's pointer
extern class	CDDComboBox	*	pAllComboBox[MAX_COMBOBOX];	//to record all combo-box's pointer
extern class	CDDString	*	pAllString[MAX_TEXT] ;		// to store the four network game player's name in this

extern class	CDDScrollBar *	pAllScrollBar[MAX_SCROLLBAR];
/////////////////////////////////////////////
//		the flag for percent bar
BOOL	FACE_bPercentBar = FALSE;		// FALSE --> have no percent bar
										// TRUE  --> have a percent bar
/////////////////////////////////////////////
//			Global		character		   //
/////////////////////////////////////////////
extern	char	DIALOG_BUF[MAX_DIALOG_LETTER+1];	//to restore the string input to dialog
extern class	CDDText DIALOG_TEXT;	// the string attribute of DIALOG_BUF
extern	int		DIALOG_LETTER_X ;	// x coordinates to use in dialog text matrix DIALOG_BUF

extern char	MESSAGE_BUF[MAX_MESSAGE_LETTER+1] ; //keyboard buffer --> to restore your input for message
extern int		MESSAGE_LETTER_X;	// x coordinates to use in text matrix MESSAGE_BUF
extern char	MESSAGE_PROMPT[MAX_PROMPT_LETTER+1] ; //prompt   buffer -->to restore your message prompt only
extern char	MESSAGE_STRING[MAX_PROMPT_LETTER + MAX_MESSAGE_LETTER + 1] ; //prompt the MESSAGE_PROMPT+MESSAGE_BUF --> to restore all message

extern char	NETWORK_MESSAGE_BUF[NETWORK_MAX_MESSAGE_LETTER+1] ; //keyboard buffer --> to restore your input for message
extern int		NETWORK_MESSAGE_LETTER_X ;	// x coordinates to use in text matrix MESSAGE_BUF
extern char	NETWORK_MESSAGE_PROMPT[MAX_PROMPT_LETTER+1] ; //prompt   buffer -->to restore your message prompt only
extern char	NETWORK_MESSAGE_STRING[MAX_PROMPT_LETTER + NETWORK_MAX_MESSAGE_LETTER + 1] ; //prompt the MESSAGE_PROMPT+MESSAGE_BUF --> to restore all message

// the following four string is used to store the network message that passed from the others
extern class	CDDString	Net_Message_1 ;
extern class	CDDString	Net_Message_2 ;
extern class	CDDString	Net_Message_3 ;
extern class	CDDString	Net_Message_4 ;

extern class	CDDString	Net_EchoPrompt_Message ;

//	process bar veriable
class	CPercentBar	FACE_Stone;		// to show the stone of a building
class	CPercentBar FACE_Power;		// to show the power of a general
class	CPercentBar FACE_Blood;		// to show the blood of a general
class	CPercentBar FACE_Process;	// to show the process of a product to be producted
//////////////////////////////////
//	the pointer array for all you general that can been select for establish battle unit
extern	struct DATA_GENERAL_STRUCT * pAllGeneral[ MAX_ONEKINGGENERAL ];
// the pointer of all kind of element of menu
extern class	CDDButton	*	pAllButton[MAX_BUTTON];		//to restore all button's pointer
class			CDDButton	*	pAllCommandButton[MAX_COMMANDBUTTON];	//to store all command button's pointer
extern class	CDDCheckBoxUnit	*	pAllCheckBoxUnit[MAX_CHECKBOXUNIT];	//to restore all check-box's pointer
extern class	CDDListUnit	*	pAllListUnit[MAX_LISTUNIT]; //to record all list-unit's pointer
extern class	CDDComboBox	*	pAllComboBox[MAX_COMBOBOX];	//to record all combo-box's pointer

extern class	CDDScrollBar *	pAllScrollBar[MAX_SCROLLBAR];
// major parameter for bitmap(it record the current state of operate)
extern	int		nPreviousButtonState;	// previous button's state,0-up,1-down,2-disable,3-focus,4-disable,5-hide
extern	int		nCurrentButtonState;	// current button's state,0-up,1-down,2-disable,3-focus,4-disable,5-hide
extern	int		nPreviousCheckBoxState;	// previous check-box's state,0-uncheck-up,1-uncheck-down,2-check-up,3-check-down,4-disable
extern	int		nCurrentCheckBoxState;	// current check-box's state,0-uncheck-up,1-uncheck-down,2-check-up,3-check-down,4-disable
extern	int		nCurrentListState;	// current List's state,0-up,1-down,2-focus,3-disable,4-hide
// current command unit pointer
// peasant-command-unit is a main command unit to build command unit
class	CDDCommandUnit	* pCurrentMainCommandUnit = NULL;	// a pointer point to the current main command unit
class	CDDCommandUnit	* pCurrentCommandUnit = NULL;	// a pointer point to the current command unit
////////////////////////////////
//	the current prompt block
extern	struct	PROMPT_BLOCK	FACE_CURRENT_PROMPT_BLOCK;
///////////////////////////////////////////
//	to decide which unit of number to show
///////////////////////////////////////////
BOOL	nNumState = FALSE;		//	0 -> to show   1 --- 10
								//  1 -> to show   11 -- 20
///////////////////////////////
// to declear command unit
///////////////////////////////
class	CDDCommandUnit	buCancel;

class	CDDCommandUnit	buPeasant_Chao;
	class	CDDCommandUnit	buBuild_Chao_PageOne;
	class	CDDCommandUnit	buBuild_Chao_PageTwo;
class	CDDCommandUnit	buPeasant_Liu;
	class	CDDCommandUnit	buBuild_Liu_PageOne;
	class	CDDCommandUnit	buBuild_Liu_PageTwo;
class	CDDCommandUnit	buFightUnit;
	class	CDDCommandUnit	buLineUp_PageOne;
	class	CDDCommandUnit	buLineUp_PageTwo;
	class	CDDCommandUnit	buStratagem;	// stratagem --> ı
	
class	CDDCommandUnit	buSingleSoldier;
class	CDDCommandUnit	buRegimentSoldier;	// regiment --> 
class	CDDCommandUnit	buTransportShip;

class	CDDCommandUnit	buMainBuilding_Chao;
class	CDDCommandUnit	buMainBuilding_Liu;
class	CDDCommandUnit	buLumber;
class	CDDCommandUnit	buWeaponFactory;
class	CDDCommandUnit	buShop;
class	CDDCommandUnit	buFootmanSchool;
class	CDDCommandUnit	buKnightSchool;
class	CDDCommandUnit	buBowmanSchool;
class	CDDCommandUnit	buVehiclemanSchool;
class	CDDCommandUnit	buShipyard;

class	CDDButtonUnit	m_nSmallNumber;
class	CDDButtonUnit	m_nBigNumber;

/////////////////////////////////////
//	main interface frame (four part)
/////////////////////////////////////
//	  ClassName   VaribleName         BitmapSize   top-left point	 bottom-right point
class CDDBitmap	*	psMainBack = NULL;	//(640,480) -> (0,0)-----------------(639,479)
class CDDBitmap		bmCommandArea;	//(120, 120) -> (501, 336) ---------------
class CDDBitmap		bmPromptArea;	//(120, 169) -> (501, 158) ---------------
class CDDBitmap		bmButtonBackground;		// the background of the command button when it show in prompt region
class CDDBitmap		bmGeneralBackground;	// the background of the general head picture when it show in prompt region
class CDDBitmap		sTop;		//(640,48)  -> (0,0)-----------------(639,47)
class CDDBitmap		sBottom;	//(640,24)  -> (0,456)---------------(639,479)
class CDDBitmap		sLeft;		//(24,408)  -> (0,48)----------------(23,455)
class CDDBitmap		sRight;		//(157,408) -> (483,48)--------------(639,455)

class CDDBitmap		sInputName;		//(216,26) -> (211,337)--------------(427,362)
/////////////////////////////////////
// all bitmap button
/////////////////////////////////////
//		ClassName   VaribleName		BitmapSize       top-left point   bottom-right point
class	CDDBitmap		tq;		//(16,16)	  ->	(3,101)---------(18,116)	 
class	CDDBitmap		fx;		//(16,16)	  ->	(3,123)---------(18,138)	 
class	CDDBitmap		sz;		//(16,16)	  ->	(3,145)---------(18,160)	 
class	CDDBitmap		FACE_GeneralFace;		//(59,74)	  ->	(3,145)---------(18,160)	 

class	CDDButton		zt;			//(16,16)	  ->	(3,167)---------(18,182)	 

class	CDDButton		num_arr;    //(16,16)	  ->	(3,391)---------(18,406)
class	CDDButton		num_01;		//(16,16)	  ->	(3,228)---------(18,243)
class	CDDButton		num_02;		//(16,16)	  ->	(3,244)---------(18,259)
class	CDDButton		num_03;		//(16,16)	  ->	(3,260)---------(18,275)
class	CDDButton		num_04;		//(16,16)	  ->	(3,276)---------(18,291)
class	CDDButton		num_05;		//(16,16)	  ->	(3,292)---------(18,307)
class	CDDButton		num_06;		//(16,16)	  ->	(3,308)---------(18,323)
class	CDDButton		num_07;		//(16,16)	  ->	(3,324)---------(18,339)
class	CDDButton		num_08;		//(16,16)	  ->	(3,340)---------(18,355)
class	CDDButton		num_09;		//(16,16)	  ->	(3,356)---------(18,371)
class	CDDButton		num_10;		//(16,16)	  ->	(3,372)---------(18,387)

class	CDDButton		num_11;		//(16,16)	  ->	(3,228)---------(18,243)
class	CDDButton		num_12;		//(16,16)	  ->	(3,244)---------(18,259)
class	CDDButton		num_13;		//(16,16)	  ->	(3,260)---------(18,275)
class	CDDButton		num_14;		//(16,16)	  ->	(3,276)---------(18,291)
class	CDDButton		num_15;		//(16,16)	  ->	(3,292)---------(18,307)
class	CDDButton		num_16;		//(16,16)	  ->	(3,308)---------(18,323)
class	CDDButton		num_17;		//(16,16)	  ->	(3,324)---------(18,339)
class	CDDButton		num_18;		//(16,16)	  ->	(3,340)---------(18,355)
class	CDDButton		num_19;		//(16,16)	  ->	(3,356)---------(18,371)
class	CDDButton		num_20;		//(16,16)	  ->	(3,372)---------(18,387)

class	CDDButton		systemenu;	

class	CDDButton		ml_Cancel;		// to cancel the last command

class	CDDButton		prompt_Iron_Mine;		// ͼ
class	CDDButton		prompt_Citizen_Male;	// ƽ
class	CDDButton		prompt_Citizen_Female;	// Ůƽ

class	CDDButton		ml_Main_Peasant;
class	CDDButton		ml_Chao_Main_Upgrade1;
class	CDDButton		ml_Chao_Main_Upgrade2;
class	CDDButton		ml_Chao_Main_Upgrade3;
class	CDDButton		ml_Liu_Main_Upgrade1;
class	CDDButton		ml_Liu_Main_Upgrade2;
class	CDDButton		ml_Liu_Main_Upgrade3;

class	CDDButton		ml_Lumber_UpgradeBow1;
class	CDDButton		ml_Lumber_UpgradeBow2;
class	CDDButton		ml_Lumber_UpgradeBow3;

class	CDDButton		ml_WeaponFactory_UpgradeWeapon1;
class	CDDButton		ml_WeaponFactory_UpgradeWeapon2;
class	CDDButton		ml_WeaponFactory_UpgradeWeapon3;
class	CDDButton		ml_WeaponFactory_UpgradeArmor1;		// armor --> ףװ
class	CDDButton		ml_WeaponFactory_UpgradeArmor2;
class	CDDButton		ml_WeaponFactory_UpgradeArmor3;

class	CDDButton		ml_Shop_Sale100Wood;
class	CDDButton		ml_Shop_Sale100Food;
class	CDDButton		ml_Shop_Sale100Iron;
class	CDDButton		ml_Shop_Sale1000Wood;
class	CDDButton		ml_Shop_Sale1000Food;
class	CDDButton		ml_Shop_Sale1000Iron;

class	CDDButton		ml_FootmanSchool_100;		// Footman --> 
class	CDDButton		ml_FootmanSchool_200;
class	CDDButton		ml_FootmanSchool_500;
class	CDDButton		ml_FootmanSchool_1000;

class	CDDButton		ml_KnightSchool_100;		// Knight --> 
class	CDDButton		ml_KnightSchool_200;
class	CDDButton		ml_KnightSchool_500;

class	CDDButton		ml_BowmanSchool_100;		// bowman --> 
class	CDDButton		ml_BowmanSchool_200;
class	CDDButton		ml_BowmanSchool_500;
class	CDDButton		ml_BowmanSchool_1000;

class	CDDButton		ml_VehiclemanSchool_Vehicleman;		// Vehicleman --> 
class	CDDButton		ml_VehiclemanSchool_Upgrade1;
class	CDDButton		ml_VehiclemanSchool_Upgrade2;

class	CDDButton		ml_Shipyard_Destroyer;				// destroyer  -->  (촬)
class	CDDButton		ml_Shipyard_Battleship;				// battleship -->  (ս)
class	CDDButton		ml_Shipyard_Transport;				// transport  --> 䴬
class	CDDButton		ml_Shipyard_UpgradeDestroyer;
class	CDDButton		ml_Shipyard_UpgradeBattleship;
class	CDDButton		ml_Shipyard_UpgradeShipArmor;
class	CDDButton		ml_Shipyard_GroupShip;				// group ship --> 

class	CDDButton		ml_Establish;	// establish --> 齨
class	CDDButton		ml_Join;		// join --> 

class	CDDButton		ml_Move;
class	CDDButton		ml_Attack;
class	CDDButton		ml_Guard;		// guard --> 
class	CDDButton		ml_LineUp;		// lineup --> 
class	CDDButton		ml_Rest;		
class	CDDButton		ml_Stratagem;	// stratagem --> ı
class	CDDButton		ml_Dismiss;		// dismiss --> ɢ
class	CDDButton		ml_Single;		// single --> 
class	CDDButton		ml_Transport;	// transport --> 
class	CDDButton		ml_Chao_Build;	// ΪܲʱĽ
class	CDDButton		ml_Liu_Build;	// ΪʱĽ
class	CDDButton		ml_Repair;
class	CDDButton		ml_Ship;
class	CDDButton		ml_Unship;
class	CDDButton		ml_Back;		// 

class	CDDButton		ml_Chao_Build_Main;
class	CDDButton		ml_Chao_Build_Farm;
class	CDDButton		ml_Chao_Build_Lumber;
class	CDDButton		ml_Chao_Build_WeaponFactory;
class	CDDButton		ml_Chao_Build_Shop;
class	CDDButton		ml_Chao_Build_FootmanSchool;
class	CDDButton		ml_Chao_Build_KnightSchool;
class	CDDButton		ml_Chao_Build_BowmanSchool;
class	CDDButton		ml_Chao_Build_VehiclemanSchool;
class	CDDButton		ml_Chao_Build_Shipyard;
class	CDDButton		ml_Chao_Build_Tower;
class	CDDButton		ml_Chao_Build_Flag;
class	CDDButton		ml_Chao_Build_Door;
class	CDDButton		ml_Chao_Build_PageUp;
class	CDDButton		ml_Chao_Build_PageDown;
class	CDDButton		prompt_Chao_House;				// ܲٷͼ

class	CDDButton		ml_Liu_Build_Main;
class	CDDButton		ml_Liu_Build_Farm;
class	CDDButton		ml_Liu_Build_Lumber;
class	CDDButton		ml_Liu_Build_WeaponFactory;
class	CDDButton		ml_Liu_Build_Shop;
class	CDDButton		ml_Liu_Build_FootmanSchool;
class	CDDButton		ml_Liu_Build_KnightSchool;
class	CDDButton		ml_Liu_Build_BowmanSchool;
class	CDDButton		ml_Liu_Build_VehiclemanSchool;
class	CDDButton		ml_Liu_Build_Shipyard;
class	CDDButton		ml_Liu_Build_Tower;
class	CDDButton		ml_Liu_Build_Flag;
class	CDDButton		ml_Liu_Build_Door;
class	CDDButton		ml_Liu_Build_PageUp;
class	CDDButton		ml_Liu_Build_PageDown;
class	CDDButton		prompt_Liu_House;				// ͼ

class	CDDButton		ml_LineUp_One;		//һֳ
class	CDDButton		ml_LineUp_Two;		//ˮ
class	CDDButton		ml_LineUp_Three;	//
class	CDDButton		ml_LineUp_Four;		//
class	CDDButton		ml_LineUp_Five;		//÷
class	CDDButton		ml_LineUp_Six;		//
class	CDDButton		ml_LineUp_Seven;	//Ǳ
class	CDDButton		ml_LineUp_Eight;	//Ž
class	CDDButton		ml_LineUp_Nine;		//Ź
class	CDDButton		ml_LineUp_Ten;		//ʮ
class	CDDButton		ml_LineUp_PageUp;
class	CDDButton		ml_LineUp_PageDown;

class	CDDButton		ml_Stratagem_Encourage;	//
class	CDDButton		ml_Stratagem_SpeedUp;	//
class	CDDButton		ml_Stratagem_SpeedDown;	//
class	CDDButton		ml_Stratagem_SeeFar;	//Զ
class	CDDButton		ml_Stratagem_Anarchy;	// 
class	CDDButton		ml_Stratagem_RollTimber;//ľ
class	CDDButton		ml_Stratagem_Ambuscade;	//
class	CDDButton		ml_Stratagem_BringBack;	//ָ
class	CDDButton		ml_Stratagem_Fire;		//

////////////////////////////////////
//	       all menu
////////////////////////////////////
extern	CDDMenu		* CurrentMenu;
extern	CDDMenu		Menu_Main;
extern	CDDMenu		Menu_NewGame;
extern	CDDMenu		Menu_MainLoad;
extern	CDDMenu		Menu_NetWork;
extern	CDDMenu		Menu_NetWork_InputName;
extern	CDDMenu		Menu_NetWork_Serial;
extern	CDDMenu		Menu_NetWork_Internet;
extern	CDDMenu		Menu_NetWork_Ipx;
extern	CDDMenu		Menu_NetWork_SetNet;
extern	CDDMenu		Menu_NetWork_SetNet_SelectMap;
extern	CDDMenu		Menu_NetWork_SetNet_SelectKing;
extern	CDDMenu		Menu_NetWork_Modem;
/////////////////////////////
//	system menu structure
extern	CDDMenu		Menu_System;
extern	CDDMenu		Menu_System_Save;
extern	CDDMenu		Menu_System_Load;
extern	CDDMenu		Menu_System_Query;
extern	CDDMenu		Menu_System_Query_General_1;
extern	CDDMenu		Menu_System_Query_General_2;
extern	CDDMenu		Menu_System_Query_Army;
extern	CDDMenu		Menu_System_Query_Building;
extern	CDDMenu		Menu_System_Query_Campaign_Mission;
extern	CDDMenu		Menu_System_Option;
extern	CDDMenu		Menu_System_Help;
extern	CDDMenu		Menu_System_Help_Operate;
extern	CDDMenu		Menu_System_Help_Icon;
extern	CDDMenu		Menu_System_Help_Game;
extern	CDDMenu		Menu_System_Exit;
///////////////////////////
//	menu to select general
extern	CDDMenu		Menu_Select_General;
//	menu to show the information of the generals want to single battle
extern	CDDMenu		Menu_Single ;
extern	CDDMenu		Menu_Single_Reject ;
extern	CDDMenu		Menu_Single_Result ;
/////////////////////////////////////
// menu to show some error and prompt information
extern	CDDMenu		Menu_Link_Error ;
/////////////////////////////////////
// to store the six golbal list pointers for establish menu
////////////////////////////////////
class	CDDList	* pEstablishList_1;
class	CDDList	* pEstablishList_2;
class	CDDList	* pEstablishList_3;
class	CDDList	* pEstablishList_4;
class	CDDList	* pEstablishList_5;
class	CDDList	* pEstablishList_6;
/////////////////////////////////////
// all bitmap button
/////////////////////////////////////
//		ClassName   VaribleName		BitmapSize       top-left point   bottom-right point
/////////////////////////////////////////////////
//	to preload the main back-ground of begin menu
/////////////////////////////////////////////////
BOOL	FACE_PreloadMainBackGround()
{
	CScan_read	FSCAN;

	int	    BitmapFileId = NONE;
	char	fname[20];

	if( psMainBack == NULL )
	{
		strcpy( fname, "set\\mainback.exp" );
		FSCAN.scan_open (fname);

		POINT	pShow;
		int		nWidth;
		int		nHeight;

		// to read the date of top surface bitmap from file interface.set
		FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight));//lwc
		// to close this information file
		FSCAN.scan_close ();

		psMainBack = new CDDBitmap;
		// to load bitmap from file
		if( !psMainBack->PreLoad(BitmapFileId, pShow.x, pShow.y, nWidth, nHeight) )
			return FALSE;
	}
	return TRUE;
}
//	to show the main back-ground of the begin menu of this game
//	if every intput veriable is 0 then to show the whole bitmap
//  if they are not 0 then to show the assigned block of this bitmap
BOOL	FACE_ShowMainBackGround(int PosX/*=0*/, int PosY/*=0*/, int Width/*=0*/, int Height/*=0*/)
{
	RECT FileRect;
	POINT	pShow;

	if( psMainBack != NULL )
	{
		if( PosX == 0 )
		{
			//to blit the all main back-ground to the back buffer
			psMainBack->Show();
		}
		else
		{
			pShow.x = PosX;
			pShow.y = PosY;

			FileRect.left = PosX;
			FileRect.top = PosY;
			FileRect.right = FileRect.left + Width;
			FileRect.bottom = FileRect.top + Height;

			//to blit the assigned area to the back buffer
			psMainBack->m_BitmapSurface.BltToBack(pShow, &FileRect);
			// to update the region that this bitmap placed
			DDC_UpdateScreen(&FileRect);
		}
	}
	return FALSE;
}
//////////////////////////////////
void	FACE_DeleteMainBackGround()
{
	if(psMainBack == NULL)
		return;
	psMainBack->Release();
	psMainBack = NULL;
}
//////////////////////////////////
// to clear command unit argion
void	FACE_ClearCommandUnitArea(BOOL	flag)
{
//	pCurrentCommandUnit = NULL;
	if(flag)
		bmCommandArea.Update();
	else
	{
		FACE_HideAllCommandButton();
		bmCommandArea.Blit();
	}
}

/////////////////////////////////////////////////
//	to set the state of the twenty number buttons
void	FACE_SetNumberButtonState(int number, int state, BOOL ShowCurrentPage/*=TRUE*/)
{
	Assert( (state==BUTTON_UP) || (state==BUTTON_DISABLE));

	if( (number >= 0)&&(number<10) )
	{
		m_nSmallNumber.m_pButton[number]->SetState(state);	
//		m_nSmallNumber.m_pButton[number]->Show();	
	}
	else if( (number >= 10)&&(number<20) )
	{
		m_nBigNumber.m_pButton[number-10]->SetState(state);	
//		m_nBigNumber.m_pButton[number-10]->Show();	
	}
	if( ShowCurrentPage )
	{
		if( nNumState )
			m_nBigNumber.Show();	
		else
			m_nSmallNumber.Show();	
	}
}
  //////////////////////////////////
// to clear prompt argion
void	FACE_ClearPromptArea()
{
	bmPromptArea.Show();
}
//////////////////////////////////
BOOL	FACE_LoadAllBmp( )
{
	CScan_read	FSCAN;		// for read the interfac.exp data file
	CScan_read	FSCANP;		// for read the prompt.exp string file
	CScan_read	FSCAND;		// for read the cost.exp data file
	CScan_read	FSCANJ;		// for read the jimou.exp data file

	int		BitmapFileId;
	char	fname[20];

	POINT	pShow;
	int		OneBitmapWidth = 0;
	int		OneBitmapHeight = 0;
	int		nState;
	int		nID;

	int		nWidth, nHeight;

	int		FrameWidth;
	int		ColorId;

	char    PromptString[256];

	char	pfname[256];
	// to open the whole information of the interface
    strcpy( fname, "set\\Interfac.exp" );
	FSCAN.scan_open (fname);

	// to read the date of top surface bitmap from file interface.exp
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight ));//lwc
    //fscanf( fp, "%d%d%d%d%d", BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight );
	if( !sTop.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight ));//lwc
    //fscanf( fp, "%d%d%d%d%d", BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight );
	if( !sBottom.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;
    FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight ));//lwc
	//fscanf( fp, "%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight );
	if( !sLeft.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;
    FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight ));
	//fscanf( fp, "%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight );
	if( !sRight.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;

	////////////////////////////////////
	//		to preload system button
	////////////////////////////////////
// preload the bitmap
	// to preload the area block of main interface frame
	// to preload the command unit area block
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight));
	if( ! bmCommandArea.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;
	// to preload the prompt area block
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight));
	if( !bmPromptArea.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;
	// to preload the background of the command button when it show in prompt region
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight));
	if( ! bmButtonBackground.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;
	// to preload the background of the general head picture when it show in prompt region
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight));
	if( !bmGeneralBackground.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &OneBitmapWidth, &OneBitmapHeight, &nState));
	if( !FACE_GeneralFace.PreLoad( BitmapFileId, pShow.x, pShow.y, OneBitmapWidth, OneBitmapHeight) )
		return FALSE;
	FACE_GeneralFace.SetState(nState);

/////////////////////////////////////////////
//	process bar veriable
/////////////////////////////////////////////

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &FrameWidth, &ColorId));
	FACE_Stone.PreLoad( BitmapFileId, pShow.x, pShow.y, FrameWidth, ColorId );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d",&BitmapFileId, &pShow.x, &pShow.y, &FrameWidth, &ColorId));
	FACE_Power.PreLoad( BitmapFileId, pShow.x, pShow.y, FrameWidth, ColorId );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &FrameWidth, &ColorId));
	FACE_Blood.PreLoad( BitmapFileId, pShow.x, pShow.y, FrameWidth, ColorId );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &FrameWidth, &ColorId));
	FACE_Process.PreLoad( BitmapFileId, pShow.x, pShow.y, FrameWidth, ColorId);
	
// to preload all bitmap on interface . eg : weather, time, wind ...
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nState));
	if( !tq.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	tq.SetState(nState);

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nState));
	if( !fx.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	fx.SetState(nState);

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nState));
	if( !sz.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	sz.SetState(nState);

//////////////////////////////////////////////////////////////////////////
//	to open the prompt information file for you to preload the prompt text
//////////////////////////////////////////////////////////////////////////
	// to open the prompt information file
	strcpy( pfname, "set\\prompt.exp" );
	FSCANP.scan_open (pfname);

// begin to set the prompt string
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !zt.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	zt.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	zt.SetPromptString( PromptString );
	if( GAME_bNetwork == TRUE )
		zt.SetState( BUTTON_DISABLE ) ;
////////////////////////////////////////////
//	to preload the system menu button
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight, &nID, &nState));
	if( !systemenu.PreLoad( BitmapFileId, pShow.x, pShow.y, nWidth, nHeight) )
		return FALSE;
	systemenu.SetID(nID);
	systemenu.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	systemenu.SetPromptString( PromptString );
/////////////////////////////////////////////
//		to preload the number button
////////////////////////////////////////////
	// to pre load the number arrow button
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_arr.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_arr.SetID(nID);
	num_arr.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_arr.SetPromptString( PromptString );
	/////////////////////////////////////////////////
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_01.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_01.SetID(nID);
	num_01.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_01.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_02.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_02.SetID(nID);
	num_02.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_02.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_03.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_03.SetID(nID);
	num_03.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_03.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_04.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_04.SetID(nID);
	num_04.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_04.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_05.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_05.SetID(nID);
	num_05.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_05.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_06.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_06.SetID(nID);
	num_06.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_06.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_07.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_07.SetID(nID);
	num_07.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_07.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_08.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_08.SetID(nID);
	num_08.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_08.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_09.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_09.SetID(nID);
	num_09.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_09.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_10.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_10.SetID(nID);
	num_10.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_10.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_11.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_11.SetID(nID);
	num_11.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_11.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_12.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_12.SetID(nID);
	num_12.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_12.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_13.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_13.SetID(nID);
	num_13.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_13.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf, "%d%d%d%d%d",&BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_14.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_14.SetID(nID);
	num_14.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_14.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_15.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_15.SetID(nID);
	num_15.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_15.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_16.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_16.SetID(nID);
	num_16.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_16.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_17.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_17.SetID(nID);
	num_17.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_17.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_18.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_18.SetID(nID);
	num_18.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_18.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_19.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_19.SetID(nID);
	num_19.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_19.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d",&BitmapFileId, &pShow.x, &pShow.y, &nID, &nState));
	if( !num_20.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	num_20.SetID(nID);
	num_20.SetState(nState);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	num_20.SetPromptString( PromptString );

////////////////////////////////////////////
//		to preload the command button
////////////////////////////////////////////
//	to open the prompt.set file to read the prompt string for every command button

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Cancel.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Cancel.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Cancel.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Move.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Move.SetID(nID);
	ml_Move.SetPromptString("go to hell");
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Move.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Attack.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Attack.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Attack.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Guard.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Guard.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf, "%s", PromptString ));
	ml_Guard.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Rest.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Rest.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Rest.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Dismiss.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Dismiss.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Dismiss.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Single.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Single.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Single.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Transport.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Transport.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Transport.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Repair.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Repair.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Repair.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Ship.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Ship.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Ship.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Unship.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Unship.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Unship.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Establish.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Establish.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Establish.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Join.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Join.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Join.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Back.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Back.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Back.SetPromptString( PromptString );

// the son command unit of battle LineUp
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_One.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_One.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_One.SetPromptString( PromptString );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Two.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Two.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Two.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Three.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Three.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Three.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Four.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Four.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Four.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Five.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Five.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Five.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Six.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Six.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Six.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Seven.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Seven.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Seven.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Eight.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Eight.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Eight.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Nine.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Nine.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Nine.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_Ten.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_Ten.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_Ten.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_PageUp.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_PageUp.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_PageUp.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_LineUp_PageDown.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_LineUp_PageDown.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_LineUp_PageDown.SetPromptString( PromptString );

// all son command of command unit battle statagem
	int		JiMou ;		//ı
// to open the all jm data of this game
    strcpy( fname, "set\\jimou.exp" );
	FSCANJ.scan_open (fname);

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d",&BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_Encourage.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_Encourage.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_Encourage.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_Encourage.CatJmString( JiMou );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_SpeedUp.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_SpeedUp.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_SpeedUp.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_SpeedUp.CatJmString( JiMou );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_SpeedDown.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_SpeedDown.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_SpeedDown.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_SpeedDown.CatJmString( JiMou );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_SeeFar.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_SeeFar.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_SeeFar.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_SeeFar.CatJmString( JiMou );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_Anarchy.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_Anarchy.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_Anarchy.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_Anarchy.CatJmString( JiMou );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_RollTimber.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_RollTimber.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_RollTimber.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_RollTimber.CatJmString( JiMou );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_Ambuscade.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_Ambuscade.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_Ambuscade.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_Ambuscade.CatJmString( JiMou );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_BringBack.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_BringBack.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_BringBack.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_BringBack.CatJmString( JiMou );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Stratagem_Fire.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Stratagem_Fire.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Stratagem_Fire.SetPromptString( PromptString );
	FSCANJ.l_scan(sscanf (FSCANJ.expand_buf,"%d", &JiMou));
	ml_Stratagem_Fire.CatJmString( JiMou );
	
	// to close the cost information file
	FSCANJ.scan_close() ;
// the son command unit of peasant build
	// CHAO
	int		Money, Food, Wood, Iron ;
// to open the all cost data of this game
    strcpy( fname, "set\\cost.exp" );
	FSCAND.scan_open (fname);

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_Main.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_Main.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_Main.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_Main.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_Farm.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_Farm.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_Farm.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_Farm.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_Lumber.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_Lumber.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_Lumber.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_Lumber.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_WeaponFactory.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_WeaponFactory.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_WeaponFactory.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_WeaponFactory.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_Shop.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_Shop.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_Shop.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_Shop.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_FootmanSchool.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_FootmanSchool.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_FootmanSchool.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_FootmanSchool.CatPromptString( Money, Food, Wood, Iron );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_KnightSchool.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_KnightSchool.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_KnightSchool.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_KnightSchool.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_BowmanSchool.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_BowmanSchool.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_BowmanSchool.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_BowmanSchool.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf, "%d%d%d%d",&BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_VehiclemanSchool.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_VehiclemanSchool.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString));
	ml_Chao_Build_VehiclemanSchool.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_VehiclemanSchool.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_Shipyard.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_Shipyard.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s",PromptString ));
	ml_Chao_Build_Shipyard.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_Shipyard.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_Tower.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_Tower.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_Tower.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_Tower.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_Flag.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_Flag.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_Flag.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_Flag.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_Door.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_Door.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_Door.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Build_Door.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_PageUp.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_PageUp.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_PageUp.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Build_PageDown.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Build_PageDown.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Build_PageDown.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !prompt_Chao_House.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	prompt_Chao_House.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	prompt_Chao_House.SetPromptString( PromptString );

//	LIU
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_Main.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_Main.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_Main.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_Main.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_Farm.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_Farm.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_Farm.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_Farm.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_Lumber.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_Lumber.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_Lumber.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_Lumber.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_WeaponFactory.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_WeaponFactory.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_WeaponFactory.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_WeaponFactory.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_Shop.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_Shop.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_Shop.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_Shop.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_FootmanSchool.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_FootmanSchool.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_FootmanSchool.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_FootmanSchool.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_KnightSchool.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_KnightSchool.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_KnightSchool.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_KnightSchool.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_BowmanSchool.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_BowmanSchool.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_BowmanSchool.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_BowmanSchool.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_VehiclemanSchool.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_VehiclemanSchool.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_VehiclemanSchool.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_VehiclemanSchool.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_Shipyard.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_Shipyard.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_Shipyard.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_Shipyard.CatPromptString( Money, Food, Wood, Iron );
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_Tower.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_Tower.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_Tower.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_Tower.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_Flag.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_Flag.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_Flag.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_Flag.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_Door.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_Door.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_Door.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Build_Door.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_PageUp.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_PageUp.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_PageUp.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Build_PageDown.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Build_PageDown.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Build_PageDown.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !prompt_Liu_House.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	prompt_Liu_House.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	prompt_Liu_House.SetPromptString( PromptString );

// all son command of command unit main-building
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Main_Peasant.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Main_Peasant.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Main_Peasant.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Main_Peasant.CatPromptString( Money, Food, Wood, Iron );

	//	CHAO	upgrade
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Main_Upgrade1.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Main_Upgrade1.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Main_Upgrade1.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Main_Upgrade1.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Main_Upgrade2.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Main_Upgrade2.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Main_Upgrade2.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Main_Upgrade2.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Chao_Main_Upgrade3.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Chao_Main_Upgrade3.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Chao_Main_Upgrade3.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Chao_Main_Upgrade3.CatPromptString( Money, Food, Wood, Iron );

	// LIU	upgrade
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Main_Upgrade1.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Main_Upgrade1.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Main_Upgrade1.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Main_Upgrade1.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Main_Upgrade2.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Main_Upgrade2.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Main_Upgrade2.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Main_Upgrade2.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Liu_Main_Upgrade3.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Liu_Main_Upgrade3.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Liu_Main_Upgrade3.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Liu_Main_Upgrade3.CatPromptString( Money, Food, Wood, Iron );
	
// all son command of command unit Lumber
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Lumber_UpgradeBow1.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Lumber_UpgradeBow1.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Lumber_UpgradeBow1.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Lumber_UpgradeBow1.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Lumber_UpgradeBow2.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Lumber_UpgradeBow2.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Lumber_UpgradeBow2.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Lumber_UpgradeBow2.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Lumber_UpgradeBow3.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Lumber_UpgradeBow3.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Lumber_UpgradeBow3.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Lumber_UpgradeBow3.CatPromptString( Money, Food, Wood, Iron );
	
// all son command of command unit weapon factory
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_WeaponFactory_UpgradeWeapon1.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_WeaponFactory_UpgradeWeapon1.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_WeaponFactory_UpgradeWeapon1.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_WeaponFactory_UpgradeWeapon1.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_WeaponFactory_UpgradeWeapon2.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_WeaponFactory_UpgradeWeapon2.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_WeaponFactory_UpgradeWeapon2.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_WeaponFactory_UpgradeWeapon2.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_WeaponFactory_UpgradeWeapon3.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_WeaponFactory_UpgradeWeapon3.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_WeaponFactory_UpgradeWeapon3.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_WeaponFactory_UpgradeWeapon3.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_WeaponFactory_UpgradeArmor1.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_WeaponFactory_UpgradeArmor1.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_WeaponFactory_UpgradeArmor1.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_WeaponFactory_UpgradeArmor1.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_WeaponFactory_UpgradeArmor2.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_WeaponFactory_UpgradeArmor2.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_WeaponFactory_UpgradeArmor2.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_WeaponFactory_UpgradeArmor2.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_WeaponFactory_UpgradeArmor3.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_WeaponFactory_UpgradeArmor3.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_WeaponFactory_UpgradeArmor3.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_WeaponFactory_UpgradeArmor3.CatPromptString( Money, Food, Wood, Iron );

// all son command of commnad unit shop
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shop_Sale100Wood.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shop_Sale100Wood.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shop_Sale100Wood.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shop_Sale100Food.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shop_Sale100Food.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shop_Sale100Food.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shop_Sale100Iron.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shop_Sale100Iron.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shop_Sale100Iron.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shop_Sale1000Wood.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shop_Sale1000Wood.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shop_Sale1000Wood.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shop_Sale1000Food.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shop_Sale1000Food.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shop_Sale1000Food.SetPromptString( PromptString );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shop_Sale1000Iron.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shop_Sale1000Iron.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shop_Sale1000Iron.SetPromptString( PromptString );

// all son command of command unit footman school
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_FootmanSchool_100.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_FootmanSchool_100.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_FootmanSchool_100.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_FootmanSchool_100.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_FootmanSchool_200.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_FootmanSchool_200.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_FootmanSchool_200.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_FootmanSchool_200.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_FootmanSchool_500.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_FootmanSchool_500.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_FootmanSchool_500.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_FootmanSchool_500.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_FootmanSchool_1000.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_FootmanSchool_1000.SetID(nID);
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_FootmanSchool_1000.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_FootmanSchool_1000.CatPromptString( Money, Food, Wood, Iron );
	
// all son command of command unit knight school
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_KnightSchool_100.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_KnightSchool_100.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_KnightSchool_100.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_KnightSchool_100.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_KnightSchool_200.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_KnightSchool_200.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_KnightSchool_200.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_KnightSchool_200.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_KnightSchool_500.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_KnightSchool_500.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_KnightSchool_500.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_KnightSchool_500.CatPromptString( Money, Food, Wood, Iron );

// all son command of command unit bowman school
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_BowmanSchool_100.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_BowmanSchool_100.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_BowmanSchool_100.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_BowmanSchool_100.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_BowmanSchool_200.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_BowmanSchool_200.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_BowmanSchool_200.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_BowmanSchool_200.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_BowmanSchool_500.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_BowmanSchool_500.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_BowmanSchool_500.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_BowmanSchool_500.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_BowmanSchool_1000.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_BowmanSchool_1000.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_BowmanSchool_1000.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_BowmanSchool_1000.CatPromptString( Money, Food, Wood, Iron );

// all son command of command unit vehicleman school
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_VehiclemanSchool_Vehicleman.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_VehiclemanSchool_Vehicleman.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_VehiclemanSchool_Vehicleman.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_VehiclemanSchool_Vehicleman.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf, "%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_VehiclemanSchool_Upgrade1.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_VehiclemanSchool_Upgrade1.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_VehiclemanSchool_Upgrade1.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_VehiclemanSchool_Upgrade1.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf, "%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_VehiclemanSchool_Upgrade2.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_VehiclemanSchool_Upgrade2.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_VehiclemanSchool_Upgrade2.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_VehiclemanSchool_Upgrade2.CatPromptString( Money, Food, Wood, Iron );

// all son command of command unit shipyard
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shipyard_Destroyer.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shipyard_Destroyer.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shipyard_Destroyer.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Shipyard_Destroyer.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shipyard_Battleship.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shipyard_Battleship.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shipyard_Battleship.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Shipyard_Battleship.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shipyard_Transport.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shipyard_Transport.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shipyard_Transport.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Shipyard_Transport.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shipyard_UpgradeDestroyer.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shipyard_UpgradeDestroyer.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shipyard_UpgradeDestroyer.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Shipyard_UpgradeDestroyer.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shipyard_UpgradeBattleship.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shipyard_UpgradeBattleship.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shipyard_UpgradeBattleship.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Shipyard_UpgradeBattleship.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shipyard_UpgradeShipArmor.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shipyard_UpgradeShipArmor.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shipyard_UpgradeShipArmor.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Shipyard_UpgradeShipArmor.CatPromptString( Money, Food, Wood, Iron );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !ml_Shipyard_GroupShip.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	ml_Shipyard_GroupShip.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	ml_Shipyard_GroupShip.SetPromptString( PromptString );
	FSCAND.l_scan(sscanf (FSCAND.expand_buf,"%d%d%d%d", &Money, &Food, &Wood, &Iron));
	ml_Shipyard_GroupShip.CatPromptString( Money, Food, Wood, Iron );

//	the iron mine
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !prompt_Iron_Mine.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	prompt_Iron_Mine.SetID(nID);	
	FSCANP.l_scan(sscanf (FSCANP.expand_buf,"%s", PromptString ));
	prompt_Iron_Mine.SetPromptString( PromptString );

//	the Male citizen
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !prompt_Citizen_Male.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	prompt_Citizen_Male.SetID(nID);	

//	the Female citizen
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nID));
	if( !prompt_Citizen_Female.PreLoad( BitmapFileId, pShow.x, pShow.y) )
		return FALSE;
	prompt_Citizen_Female.SetID(nID);	

	// to close the cost information file
	FSCAND.scan_close() ;

	// to close the prompt informaiton file
	FSCAN.scan_close() ;

	// to close the prompt informaiton file
	FSCANP.scan_close();

//////////////////////////////////////////////////
//	to preload the MENU_SELECT_GENERAL menu for show it quickly
	strcpy( fname, "set\\m_establ.exp" );
	FSCAN.scan_open (fname);

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d", &BitmapFileId, &pShow.x, &pShow.y));
	if( !Menu_Select_General.PreLoad( BitmapFileId, pShow.x, pShow.y) )
	{
		return FALSE;
	}
	// to preload all button of this menu
	for(int i=0; i<4; i++)
	{
		Menu_Select_General.m_MenuButtonUnit.m_pButton[i] = new CDDButton;
		FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight, &nID));
		if( !Menu_Select_General.m_MenuButtonUnit.m_pButton[i]->
			PreLoad( BitmapFileId, pShow.x, pShow.y, nWidth, nHeight) )
			return FALSE;
		Menu_Select_General.m_MenuButtonUnit.m_pButton[i]->SetID(nID);
	}
	// to set the state of all buttons in this menu's button-unit
	Menu_Select_General.m_MenuButtonUnit.SetMemberState( BUTTON_DISABLE );

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight, &nID));
	pEstablishList_1 = new CDDList;
	pEstablishList_1->PreLoad( BitmapFileId, pShow.x, pShow.y, nWidth, nHeight);
	pEstablishList_1->SetID( nID );
	pEstablishList_1->SetStringPos( 30, 6 ) ;

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight, &nID));
	pEstablishList_2 = new CDDList;
	pEstablishList_2->PreLoad( BitmapFileId, pShow.x, pShow.y, nWidth, nHeight);
	pEstablishList_2->SetID( nID );
	pEstablishList_2->SetStringPos( 30, 6 ) ;

	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight, &nID));
	pEstablishList_3 = new CDDList;
	pEstablishList_3->PreLoad( BitmapFileId, pShow.x, pShow.y, nWidth, nHeight);
	pEstablishList_3->SetID( nID );
	pEstablishList_3->SetStringPos( 30, 6 ) ;
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight, &nID));
	pEstablishList_4 = new CDDList;
	pEstablishList_4->PreLoad( BitmapFileId, pShow.x, pShow.y, nWidth, nHeight);
	pEstablishList_4->SetID( nID );
	pEstablishList_4->SetStringPos( 30, 6 ) ;
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight, &nID));
	pEstablishList_5 = new CDDList;
	pEstablishList_5->PreLoad( BitmapFileId, pShow.x, pShow.y, nWidth, nHeight);
	pEstablishList_5->SetID( nID );
	pEstablishList_5->SetStringPos( 30, 6 ) ;
	
	FSCAN.l_scan(sscanf (FSCAN.expand_buf,"%d%d%d%d%d%d", &BitmapFileId, &pShow.x, &pShow.y, &nWidth, &nHeight, &nID));
	pEstablishList_6 = new CDDList;
	pEstablishList_6->PreLoad( BitmapFileId, pShow.x, pShow.y, nWidth, nHeight);
	pEstablishList_6->SetID( nID );
	pEstablishList_6->SetStringPos( 30, 6 ) ;

	// to close the prompt informaiton file
	FSCAN.scan_close() ;
//////////////////////////////////////////////////
//		to set big and small number unit
//////////////////////////////////////////////////
	m_nSmallNumber.m_pButton[0] = &num_01;
	m_nSmallNumber.m_pButton[1] = &num_02;
	m_nSmallNumber.m_pButton[2] = &num_03;
	m_nSmallNumber.m_pButton[3] = &num_04;
	m_nSmallNumber.m_pButton[4] = &num_05;
	m_nSmallNumber.m_pButton[5] = &num_06;
	m_nSmallNumber.m_pButton[6] = &num_07;
	m_nSmallNumber.m_pButton[7] = &num_08;
	m_nSmallNumber.m_pButton[8] = &num_09;
	m_nSmallNumber.m_pButton[9] = &num_10;

	m_nBigNumber.m_pButton[0] = &num_11;
	m_nBigNumber.m_pButton[1] = &num_12;
	m_nBigNumber.m_pButton[2] = &num_13;
	m_nBigNumber.m_pButton[3] = &num_14;
	m_nBigNumber.m_pButton[4] = &num_15;
	m_nBigNumber.m_pButton[5] = &num_16;
	m_nBigNumber.m_pButton[6] = &num_17;
	m_nBigNumber.m_pButton[7] = &num_18;
	m_nBigNumber.m_pButton[8] = &num_19;
	m_nBigNumber.m_pButton[9] = &num_20;
	//////////////////////////////////////////////////
	//		to set every command unit for every unit
	//////////////////////////////////////////////////
	pAllCommandButton[0]	= &ml_Move;
	pAllCommandButton[1]	= &ml_Attack;
	pAllCommandButton[2]	= &ml_Guard;
	pAllCommandButton[3]	= &ml_LineUp;
	pAllCommandButton[4]	= &ml_Rest;
	pAllCommandButton[5]	= &ml_Stratagem;
	pAllCommandButton[6]	= &ml_Dismiss;
	pAllCommandButton[7]	= &ml_Single;
	pAllCommandButton[8]	= &ml_Transport;
	pAllCommandButton[9]	= &ml_Chao_Build;
	pAllCommandButton[10]	= &ml_Liu_Build;
	pAllCommandButton[11]	= &ml_Repair;
	pAllCommandButton[12]	= &ml_Ship;
	pAllCommandButton[13]	= &ml_Unship;
	pAllCommandButton[14]	= &ml_Establish;
	pAllCommandButton[15]	= &ml_Join;
	// ˧
	pAllCommandButton[16]	= &ml_Main_Peasant;
	pAllCommandButton[17]	= &ml_Chao_Main_Upgrade1;
	pAllCommandButton[18]	= &ml_Chao_Main_Upgrade2;
	pAllCommandButton[19]	= &ml_Chao_Main_Upgrade3;
	pAllCommandButton[20]	= &ml_Liu_Main_Upgrade1;
	pAllCommandButton[21]	= &ml_Liu_Main_Upgrade2;
	pAllCommandButton[22]	= &ml_Liu_Main_Upgrade3;
	//	ľĳ
	pAllCommandButton[23]	= &ml_Lumber_UpgradeBow1;
	pAllCommandButton[24]	= &ml_Lumber_UpgradeBow2;
	pAllCommandButton[25]	= &ml_Lumber_UpgradeBow3;
	//	
	pAllCommandButton[26]	= &ml_WeaponFactory_UpgradeWeapon1;
	pAllCommandButton[27]	= &ml_WeaponFactory_UpgradeWeapon2;
	pAllCommandButton[28]	= &ml_WeaponFactory_UpgradeWeapon3;
	pAllCommandButton[29]	= &ml_WeaponFactory_UpgradeArmor1;
	pAllCommandButton[30]	= &ml_WeaponFactory_UpgradeArmor2;
	pAllCommandButton[31]	= &ml_WeaponFactory_UpgradeArmor3;
	//	Ǯׯ
	pAllCommandButton[32]	= &ml_Shop_Sale100Wood;
	pAllCommandButton[33]	= &ml_Shop_Sale100Food;
	pAllCommandButton[34]	= &ml_Shop_Sale100Iron;
	pAllCommandButton[35]	= &ml_Shop_Sale1000Wood;
	pAllCommandButton[36]	= &ml_Shop_Sale1000Food;
	pAllCommandButton[37]	= &ml_Shop_Sale1000Iron;
	//	
	pAllCommandButton[38]	= &ml_FootmanSchool_100;
	pAllCommandButton[39]	= &ml_FootmanSchool_200;
	pAllCommandButton[40]	= &ml_FootmanSchool_500;
	pAllCommandButton[41]	= &ml_FootmanSchool_1000;
	//	
	pAllCommandButton[42]	= &ml_KnightSchool_100;
	pAllCommandButton[43]	= &ml_KnightSchool_200;
	pAllCommandButton[44]	= &ml_KnightSchool_500;
	//	
	pAllCommandButton[45]	= &ml_BowmanSchool_100;
	pAllCommandButton[46]	= &ml_BowmanSchool_200;
	pAllCommandButton[47]	= &ml_BowmanSchool_500;
	pAllCommandButton[48]	= &ml_BowmanSchool_1000;
	//	
	pAllCommandButton[49]	= &ml_VehiclemanSchool_Vehicleman;
	pAllCommandButton[50]	= &ml_VehiclemanSchool_Upgrade1;
	pAllCommandButton[51]	= &ml_VehiclemanSchool_Upgrade2;
	//	
	pAllCommandButton[52]	= &ml_Shipyard_Destroyer;
	pAllCommandButton[53]	= &ml_Shipyard_Battleship;
	pAllCommandButton[54]	= &ml_Shipyard_Transport;
	pAllCommandButton[55]	= &ml_Shipyard_UpgradeDestroyer;
	pAllCommandButton[56]	= &ml_Shipyard_UpgradeBattleship;
	pAllCommandButton[57]	= &ml_Shipyard_UpgradeShipArmor;
	pAllCommandButton[58]	= &ml_Shipyard_GroupShip;
	//	˲
	//	Chao
	pAllCommandButton[59]	= &ml_Chao_Build_Main;
	pAllCommandButton[60]	= &ml_Chao_Build_Farm;
	pAllCommandButton[61]	= &ml_Chao_Build_Lumber;
	pAllCommandButton[62]	= &ml_Chao_Build_WeaponFactory;
	pAllCommandButton[63]	= &ml_Chao_Build_Shop;
	pAllCommandButton[64]	= &ml_Chao_Build_FootmanSchool;
	pAllCommandButton[65]	= &ml_Chao_Build_KnightSchool;
	pAllCommandButton[66]	= &ml_Chao_Build_BowmanSchool;
	pAllCommandButton[67]	= &ml_Chao_Build_PageDown;
	pAllCommandButton[68]	= &ml_Chao_Build_VehiclemanSchool;
	pAllCommandButton[69]	= &ml_Chao_Build_Shipyard;
	pAllCommandButton[70]	= &ml_Chao_Build_Tower;
	pAllCommandButton[71]	= &ml_Chao_Build_Flag;
	pAllCommandButton[72]	= &ml_Chao_Build_Door;
	pAllCommandButton[73]	= &ml_Chao_Build_PageUp;
	// Liu
	pAllCommandButton[74]	= &ml_Liu_Build_Main;
	pAllCommandButton[75]	= &ml_Liu_Build_Farm;
	pAllCommandButton[76]	= &ml_Liu_Build_Lumber;
	pAllCommandButton[77]	= &ml_Liu_Build_WeaponFactory;
	pAllCommandButton[78]	= &ml_Liu_Build_Shop;
	pAllCommandButton[79]	= &ml_Liu_Build_FootmanSchool;
	pAllCommandButton[80]	= &ml_Liu_Build_KnightSchool;
	pAllCommandButton[81]	= &ml_Liu_Build_BowmanSchool;
	pAllCommandButton[82]	= &ml_Liu_Build_PageDown;
	pAllCommandButton[83]	= &ml_Liu_Build_VehiclemanSchool;
	pAllCommandButton[84]	= &ml_Liu_Build_Shipyard;
	pAllCommandButton[85]	= &ml_Liu_Build_Tower;
	pAllCommandButton[86]	= &ml_Liu_Build_Flag;
	pAllCommandButton[87]	= &ml_Liu_Build_Door;
	pAllCommandButton[88]	= &ml_Liu_Build_PageUp;
	//	սӵ
	pAllCommandButton[89]	= &ml_LineUp_One;
	pAllCommandButton[90]	= &ml_LineUp_Two;
	pAllCommandButton[91]	= &ml_LineUp_Three;
	pAllCommandButton[92]	= &ml_LineUp_Four;
	pAllCommandButton[93]	= &ml_LineUp_Five;
	pAllCommandButton[94]	= &ml_LineUp_Six;
	pAllCommandButton[95]	= &ml_LineUp_Seven;
	pAllCommandButton[96]	= &ml_LineUp_Eight;
	pAllCommandButton[97]	= &ml_LineUp_PageDown;
	pAllCommandButton[98]	= &ml_LineUp_Nine;
	pAllCommandButton[99]	= &ml_LineUp_Ten;
	pAllCommandButton[100]	= &ml_LineUp_PageUp;
	//	սӵļı
	pAllCommandButton[101]	= &ml_Stratagem_Encourage;	//
	pAllCommandButton[102]	= &ml_Stratagem_SpeedUp;	//
	pAllCommandButton[103]	= &ml_Stratagem_SpeedDown;	//
	pAllCommandButton[104]	= &ml_Stratagem_SeeFar;		//Զ
	pAllCommandButton[105]	= &ml_Stratagem_Anarchy;	// 
	pAllCommandButton[106]	= &ml_Stratagem_RollTimber;	//ľ
	pAllCommandButton[107]	= &ml_Stratagem_Ambuscade;	//
	pAllCommandButton[108]	= &ml_Stratagem_BringBack;	//ָ
	pAllCommandButton[109]	= &ml_Stratagem_Fire;		//
	//	 ȡ
	pAllCommandButton[110]	= &ml_Cancel;			//ȡ
	pAllCommandButton[111]	= &ml_Back;				//
	pAllCommandButton[112]	= &prompt_Chao_House;	//ܲٷ
	pAllCommandButton[113]	= &prompt_Liu_House;	//
	pAllCommandButton[114]	= &prompt_Iron_Mine;	//
	pAllCommandButton[115]	= &prompt_Citizen_Male;		//ƽ
	pAllCommandButton[116]	= &prompt_Citizen_Female;	//Ůƽ
	//	˲
	//	CHAO
	buPeasant_Chao.m_pButton[0]	= &ml_Move;
	buPeasant_Chao.m_pButton[1]	= &ml_Attack;
	buPeasant_Chao.m_pButton[2]	= &ml_Transport;
	buPeasant_Chao.m_pButton[3]	= &ml_Chao_Build;
	buPeasant_Chao.m_pButton[4]	= &ml_Repair;
	buPeasant_Chao.m_pButton[5]	= &ml_Rest;
	buPeasant_Chao.m_pButton[6]	= &ml_Dismiss;
	buPeasant_Chao.m_pButton[7]	= &ml_Ship;
	//	LIU
	buPeasant_Liu.m_pButton[0]	= &ml_Move;
	buPeasant_Liu.m_pButton[1]	= &ml_Attack;
	buPeasant_Liu.m_pButton[2]	= &ml_Transport;
	buPeasant_Liu.m_pButton[3]	= &ml_Liu_Build;
	buPeasant_Liu.m_pButton[4]	= &ml_Repair;
	buPeasant_Liu.m_pButton[5]	= &ml_Rest;
	buPeasant_Liu.m_pButton[6]	= &ml_Dismiss;
	buPeasant_Liu.m_pButton[7]	= &ml_Ship;
	//	˲ӵĽĵһ
	//	chao
	buBuild_Chao_PageOne.m_pButton[0]	= &ml_Chao_Build_Main;
	buBuild_Chao_PageOne.m_pButton[1]	= &ml_Chao_Build_Farm;
	buBuild_Chao_PageOne.m_pButton[2]	= &ml_Chao_Build_Lumber;
	buBuild_Chao_PageOne.m_pButton[3]	= &ml_Chao_Build_WeaponFactory;
	buBuild_Chao_PageOne.m_pButton[4]	= &ml_Chao_Build_Shop;
	buBuild_Chao_PageOne.m_pButton[5]	= &ml_Chao_Build_FootmanSchool;
	buBuild_Chao_PageOne.m_pButton[6]	= &ml_Chao_Build_Tower;				// exchanged with KnightSchool
	buBuild_Chao_PageOne.m_pButton[7]	= &ml_Chao_Build_BowmanSchool;
	buBuild_Chao_PageOne.m_pButton[8]	= &ml_Chao_Build_PageDown;
	//	liu
	buBuild_Liu_PageOne.m_pButton[0]	= &ml_Liu_Build_Main;
	buBuild_Liu_PageOne.m_pButton[1]	= &ml_Liu_Build_Farm;
	buBuild_Liu_PageOne.m_pButton[2]	= &ml_Liu_Build_Lumber;
	buBuild_Liu_PageOne.m_pButton[3]	= &ml_Liu_Build_WeaponFactory;
	buBuild_Liu_PageOne.m_pButton[4]	= &ml_Liu_Build_Shop;
	buBuild_Liu_PageOne.m_pButton[5]	= &ml_Liu_Build_FootmanSchool;
	buBuild_Liu_PageOne.m_pButton[6]	= &ml_Liu_Build_Tower;				// exchanged with KnightSchool
	buBuild_Liu_PageOne.m_pButton[7]	= &ml_Liu_Build_BowmanSchool;
	buBuild_Liu_PageOne.m_pButton[8]	= &ml_Liu_Build_PageDown;
	//	˲ӵĽĵڶ
	//	chao
	buBuild_Chao_PageTwo.m_pButton[0]	= &ml_Chao_Build_VehiclemanSchool;
	buBuild_Chao_PageTwo.m_pButton[1]	= &ml_Chao_Build_Shipyard;
	buBuild_Chao_PageTwo.m_pButton[2]	= &ml_Chao_Build_KnightSchool;		// exchanged with Tower
	buBuild_Chao_PageTwo.m_pButton[3]	= &ml_Chao_Build_Flag;
	buBuild_Chao_PageTwo.m_pButton[4]	= &ml_Chao_Build_Door;
	buBuild_Chao_PageTwo.m_pButton[6]	= &ml_Cancel;				// changed by Liu Gang, Apr,25,1997
	buBuild_Chao_PageTwo.m_pButton[8]	= &ml_Chao_Build_PageUp;	// changed by Liu Gang, Apr,25,1997
	//	liu
	buBuild_Liu_PageTwo.m_pButton[0]	= &ml_Liu_Build_VehiclemanSchool;
	buBuild_Liu_PageTwo.m_pButton[1]	= &ml_Liu_Build_Shipyard;
	buBuild_Liu_PageTwo.m_pButton[2]	= &ml_Liu_Build_KnightSchool;		// exchanged with Tower
	buBuild_Liu_PageTwo.m_pButton[3]	= &ml_Liu_Build_Flag;
	buBuild_Liu_PageTwo.m_pButton[4]	= &ml_Liu_Build_Door;
	buBuild_Liu_PageTwo.m_pButton[6]	= &ml_Cancel;				// changed by Liu Gang, Apr,25,1997
	buBuild_Liu_PageTwo.m_pButton[8]	= &ml_Liu_Build_PageUp;		// changed by Liu Gang, Apr,25,1997
	//	ս
	buFightUnit.m_pButton[0]	= &ml_Move;
	buFightUnit.m_pButton[1]	= &ml_Attack;
	buFightUnit.m_pButton[2]	= &ml_Guard;
	buFightUnit.m_pButton[3]	= &ml_LineUp;
	buFightUnit.m_pButton[4]	= &ml_Stratagem;
	buFightUnit.m_pButton[5]	= &ml_Rest;
	buFightUnit.m_pButton[6]	= &ml_Dismiss;
	buFightUnit.m_pButton[7]	= &ml_Ship;
	buFightUnit.m_pButton[8]	= &ml_Single;
	//	սӵ͵ĵһ
	buLineUp_PageOne.m_pButton[0]	= &ml_LineUp_One;
	buLineUp_PageOne.m_pButton[1]	= &ml_LineUp_Two;
	buLineUp_PageOne.m_pButton[2]	= &ml_LineUp_Three;
	buLineUp_PageOne.m_pButton[3]	= &ml_LineUp_Four;
	buLineUp_PageOne.m_pButton[4]	= &ml_LineUp_Five;
	buLineUp_PageOne.m_pButton[5]	= &ml_LineUp_Six;
	buLineUp_PageOne.m_pButton[6]	= &ml_LineUp_Seven;
	buLineUp_PageOne.m_pButton[7]	= &ml_LineUp_Eight;
	buLineUp_PageOne.m_pButton[8]	= &ml_LineUp_PageDown;
	//	սӵ͵ĵڶ
	buLineUp_PageTwo.m_pButton[0]	= &ml_LineUp_Nine;
	buLineUp_PageTwo.m_pButton[1]	= &ml_LineUp_Ten;
	buLineUp_PageTwo.m_pButton[8]	= &ml_LineUp_PageUp;	// changed by Liu Gang, Apr.25.1997
	//	սӵļı
	buStratagem.m_pButton[0]	= &ml_Stratagem_Encourage ;
	buStratagem.m_pButton[1]	= &ml_Stratagem_SpeedUp ;
	buStratagem.m_pButton[2]	= &ml_Stratagem_SpeedDown ;
	buStratagem.m_pButton[3]	= &ml_Stratagem_SeeFar ;
	buStratagem.m_pButton[4]	= &ml_Stratagem_Anarchy ;
	buStratagem.m_pButton[5]	= &ml_Stratagem_RollTimber ;
	buStratagem.m_pButton[6]	= &ml_Stratagem_Ambuscade ;
	buStratagem.m_pButton[7]	= &ml_Stratagem_BringBack ;
	buStratagem.m_pButton[8]	= &ml_Stratagem_Fire ;
	//	ʿ
	buSingleSoldier.m_pButton[0]	= &ml_Move ;
	buSingleSoldier.m_pButton[1]	= &ml_Establish ;
	buSingleSoldier.m_pButton[2]	= &ml_Join ;
	buSingleSoldier.m_pButton[3]	= &ml_Ship ;
	buSingleSoldier.m_pButton[4]	= &ml_Back ;
	//	ʿ
	buRegimentSoldier.m_pButton[0]	= &ml_Move ;
	buRegimentSoldier.m_pButton[1]	= &ml_Dismiss ;
	buRegimentSoldier.m_pButton[2]	= &ml_Ship ;
	buRegimentSoldier.m_pButton[3]	= &ml_Back ;	// added by Liu Gang, Arp.25.1997
	//	䴬
	buTransportShip.m_pButton[0]	= &ml_Move ;
	buTransportShip.m_pButton[1]	= &ml_Unship ;
	//	˧
	// CHAO
	buMainBuilding_Chao.m_pButton[0]		= &ml_Main_Peasant ;
	buMainBuilding_Chao.m_pButton[1]		= &ml_Chao_Main_Upgrade1 ;
	buMainBuilding_Chao.m_pButton[2]		= &ml_Chao_Main_Upgrade2 ;
	buMainBuilding_Chao.m_pButton[3]		= &ml_Chao_Main_Upgrade3 ;
	// LIU
	buMainBuilding_Liu.m_pButton[0]		= &ml_Main_Peasant ;
	buMainBuilding_Liu.m_pButton[1]		= &ml_Liu_Main_Upgrade1 ;
	buMainBuilding_Liu.m_pButton[2]		= &ml_Liu_Main_Upgrade2 ;
	buMainBuilding_Liu.m_pButton[3]		= &ml_Liu_Main_Upgrade3 ;
	//	ľĳ
	buLumber.m_pButton[0]		= &ml_Lumber_UpgradeBow1 ;
	buLumber.m_pButton[1]		= &ml_Lumber_UpgradeBow2 ;
	buLumber.m_pButton[2]		= &ml_Lumber_UpgradeBow3 ;
	//	
	buWeaponFactory.m_pButton[0]		= &ml_WeaponFactory_UpgradeWeapon1 ;
	buWeaponFactory.m_pButton[1]		= &ml_WeaponFactory_UpgradeWeapon2 ;
	buWeaponFactory.m_pButton[2]		= &ml_WeaponFactory_UpgradeWeapon3 ;
	buWeaponFactory.m_pButton[3]		= &ml_WeaponFactory_UpgradeArmor1 ;
	buWeaponFactory.m_pButton[4]		= &ml_WeaponFactory_UpgradeArmor2 ;
	buWeaponFactory.m_pButton[5]		= &ml_WeaponFactory_UpgradeArmor3 ;
	//	Ǯׯ
	buShop.m_pButton[0]		= &ml_Shop_Sale100Food ;
	buShop.m_pButton[1]		= &ml_Shop_Sale100Wood ;
	buShop.m_pButton[2]		= &ml_Shop_Sale100Iron ;
	buShop.m_pButton[3]		= &ml_Shop_Sale1000Food ;
	buShop.m_pButton[4]		= &ml_Shop_Sale1000Wood ;
	buShop.m_pButton[5]		= &ml_Shop_Sale1000Iron ;
	//	
	buFootmanSchool.m_pButton[0]		= &ml_FootmanSchool_100 ;
	buFootmanSchool.m_pButton[1]		= &ml_FootmanSchool_200 ;
	buFootmanSchool.m_pButton[2]		= &ml_FootmanSchool_500 ;
	buFootmanSchool.m_pButton[3]		= &ml_FootmanSchool_1000 ;
	//	
	buKnightSchool.m_pButton[0]		= &ml_KnightSchool_100 ;
	buKnightSchool.m_pButton[1]		= &ml_KnightSchool_200 ;
	buKnightSchool.m_pButton[2]		= &ml_KnightSchool_500 ;
	//	
	buBowmanSchool.m_pButton[0]		= &ml_BowmanSchool_100 ;
	buBowmanSchool.m_pButton[1]		= &ml_BowmanSchool_200 ;
	buBowmanSchool.m_pButton[2]		= &ml_BowmanSchool_500 ;
	buBowmanSchool.m_pButton[3]		= &ml_BowmanSchool_1000 ;
	//	
	buVehiclemanSchool.m_pButton[0]		= &ml_VehiclemanSchool_Vehicleman ;
	buVehiclemanSchool.m_pButton[1]		= &ml_VehiclemanSchool_Upgrade1 ;
	buVehiclemanSchool.m_pButton[2]		= &ml_VehiclemanSchool_Upgrade2 ;
	//	
	buShipyard.m_pButton[0]		= &ml_Shipyard_Destroyer ;
	buShipyard.m_pButton[1]		= &ml_Shipyard_Battleship ;
	buShipyard.m_pButton[2]		= &ml_Shipyard_Transport ;
	buShipyard.m_pButton[3]		= &ml_Shipyard_UpgradeDestroyer ;
	buShipyard.m_pButton[4]		= &ml_Shipyard_UpgradeBattleship ;
	buShipyard.m_pButton[5]		= &ml_Shipyard_UpgradeShipArmor ;
	buShipyard.m_pButton[6]		= &ml_Shipyard_GroupShip ;
	//	 ȡ
	buCancel.m_pButton[0]		= &ml_Cancel;

	return TRUE;
}
////////////////////////////////////////////////
//	to show the right block of the main frame
////////////////////////////////////////////////
BOOL	FACE_ShowRightBlock()
{
	// to blit sRight bitmap to back buffer
	sRight.Blit();
	if( FACE_CURRENT_PROMPT_BLOCK.PromptBlockId != PROMPT_NONE )
		FACE_ShowCurrentBlock();
	if( pCurrentCommandUnit != NULL )
		pCurrentCommandUnit->Blit();

	return TRUE;
}
////////////////////////////////////////////////////////////////////////////////////
// to show all bitmap file that had been load in last function -> FACE_LoadAllBmp()
////////////////////////////////////////////////////////////////////////////////////
BOOL FACE_ShowAllBmp(BOOL	showflag/*=FALSE*/)
{
//	// this function need to blit instead of show all bmp to the interface
//	// so i correct it from show to blit but keep the function name 

	// to show all bitmap that should be show on interface of this game
	// to show sTop surface to the back buffer
	sTop.Blit();
	sBottom.Blit();
	sLeft.Blit();
	sRight.Blit();
	// to blit all CDDBitmap instances
	// to blit all CDDButton instances
	zt.Blit();
	systemenu.Blit();
	// to blit the number arrow button
	num_arr.Blit();
	// to blit number button unit
	for(int i=0; i<10; i++)
	{
		if( GAME.Players[GAME.nMe].wGroup[i] != 65535 )
			m_nSmallNumber.m_pButton[i]->SetState(BUTTON_UP);
		else
			m_nSmallNumber.m_pButton[i]->SetState(BUTTON_DISABLE);
	}
	m_nSmallNumber.Blit();

	if( showflag==TRUE )
	{
		sTop.Update();
		sBottom.Update();
		sLeft.Update();
		sRight.Update();
		// to update all CDDBitmap instances
		// to update all CDDButton instances
		zt.Update();
		systemenu.Update();
		// to update the number arrow button
		num_arr.Update();
		// to update number button unit
		m_nSmallNumber.Update();
	}

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////
//	to release all bitmap file that had been load in function -> FACE_LoadAllBmp()
///////////////////////////////////////////////////////////////////////////////////
void FACE_ReleaseAllBmp()
{
// to release the four main interface block
	sTop.Release();
	sBottom.Release();
	sLeft.Release();
	sRight.Release();

	// to release the input name background
	sInputName.Release();
// to release all instance of CDDBitmap
	// to release the three instance of CDDBitmap that show in interface
	tq.Release();
	fx.Release();
	sz.Release();
	// to release the two background of command area and prompt area
	bmCommandArea.Release();	//(120, 120) -> (501, 336) ---------------
	bmPromptArea.Release();	//(120, 169) -> (501, 158) ---------------
	// to release the back ground of a command button when it show in prompt area
	bmButtonBackground.Release();		// the background of the command button when it show in prompt region
	// to release the back ground of a general head picture
	bmGeneralBackground.Release();	// the background of the general head picture when it show in prompt region
	// to release the four CDDBitmap instance of percent bar back ground 
	FACE_Stone.Release();		// to show the stone of a building
	FACE_Power.Release();		// to show the power of a general
	FACE_Blood.Release();		// to show the blood of a general
	FACE_Process.Release();		// to show the process of a product to be producted
	// to release the main back ground of the main menu
	FACE_DeleteMainBackGround();
// to release the big all general face bitmap
	FACE_GeneralFace.Release();

// to release the select general menu
	Menu_Select_General.Release() ;

	delete pEstablishList_1;
	delete pEstablishList_2;
	delete pEstablishList_3;
	delete pEstablishList_4;
	delete pEstablishList_5;
	delete pEstablishList_6;

	pEstablishList_1 = NULL ;
	pEstablishList_2 = NULL ;
	pEstablishList_3 = NULL ;
	pEstablishList_4 = NULL ;
	pEstablishList_5 = NULL ;
	pEstablishList_6 = NULL ;
	
}
////////////////////////////////////////
//	to set state of command
////////////////////////////////////////
int	FACE_SetCommandState( int nState )
{
	int	back;

	back = GAME.nCommandState;
	GAME.nCommandStateLast = GAME.nCommandState;
	GAME.nCommandState = nState;

	if( GAME.nCommandState == COMMAND_STATE_DIALOG)
	{
		for( int k = 0; k < MAX_DIALOG_LETTER; k++ )
			DIALOG_BUF[k] = '\0';
		DIALOG_BUF[0] = '_';
		DIALOG_LETTER_X = 0;
	}
	
	return back;
}
////////////////////////////////////////
//	to get state of command
////////////////////////////////////////
int	FACE_GetCommandState( )
{
	return GAME.nCommandState;
}
// to get previous state of command
int FACE_GetPreCommandState()
{
	return GAME.nCommandStateLast;
}
////////////////////////////////////////
//	to set state of program
////////////////////////////////////////
int	FACE_SetProgramState( int nState )
{
	int	back;

	back = GAME.nProgramState;
	GAME.nProgramStateLast = GAME.nProgramState;
	GAME.nProgramState = nState;

	return back;
}
////////////////////////////////////////
//	to get state of program
////////////////////////////////////////
int	FACE_GetProgramState( )
{
	return	GAME.nProgramState;
}
// to get previous state of program
int FACE_GetPreProgramState( )
{
	return GAME.nProgramStateLast ;
}
/////////////////////////////////////////
// to set all command button to hide
void	FACE_HideAllCommandButton()
{
	for(int i=0; i<MAX_COMMANDBUTTON; i++)
	{
		if( pAllCommandButton[i] != NULL )
			pAllCommandButton[i]->SetState(BUTTON_HIDE);
	}
}
//////////////////////////////////////////////////////
//				mouse	function
////////////////////////////////////////
// to test whether a button is clicked
/////////////////////////////////////////

/////////////////////////////////////////////
// to initialize all interface variable
void	FACE_InitInterface(void)
{
	// to init the command state and progrem state
	FACE_SetCommandState(COMMAND_STATE_MENU);
	FACE_SetProgramState(PROGRAM_STATE_MENU);

	for(int i1 = 0; i1<MAX_BITMAP; i1++ )
		pAllBitmap[i1] = NULL ;
	for(int i2 = 0; i2< MAX_BUTTON; i2++)
		pAllButton[i2] = NULL;
	for(int i3 = 0; i3<MAX_COMMANDBUTTON; i3++)
		pAllCommandButton[i3] = NULL ;
	for(int i4 = 0; i4< MAX_CHECKBOXUNIT; i4++)
		pAllCheckBoxUnit[i4] = NULL;
	for(int i5 = 0; i5< MAX_LISTUNIT; i5++)
		pAllListUnit[i5] = NULL;
//	for(int i6 = 0; i6< MAX_COMBOBOX; i6++)
//		pAllComboBox[i6] = NULL;
	for(int i7 = 0; i7<MAX_TEXT; i7++)
		pAllString[i7] = NULL ;
	for(int i8 = 0; i8<MAX_SCROLLBAR; i8++)
		pAllScrollBar[i8] = NULL ;

	return;
}
//////////////////////////////
void	FACE_SetPalette( class CDDPalette	Pal )
{
	// to set current palette
	Pal.SetPalette();
}


class CDDBitmap	* FACE_pWaitBitmap = NULL ;

// to show the begin bitmap file
BOOL	FACE_ShowABitmapPicture( int flag )	// flag -> to indentify which bitmap picture to show
{
	class CDDBitmap	* pBeginBitmap ;
	class CDDBitmap	* pEndBitmap ;
	class CDDBitmap	* pFailBitmap;

	class CDDPalette	palBeginBitmap;
	class CDDPalette	palWaitBitmap;
	class CDDPalette	palEndBitmap;
	class CDDPalette	palFailBitmap;

	if( flag == PICTURE_BEGIN )
	{
		pBeginBitmap = new CDDBitmap;

		// create and set the palette
		if( !palBeginBitmap.LoadPalettePAL( "res\\begin.pal", TRUE ) )
		{
			ErrorMessage( hwndGame, INTERFACE_ERROR+3, " Cannot load Palette file", "res\\begin.pal" );
			return FALSE;
		}

		//palBeginBitmap.SetPalette();
//		pBeginBitmap->PreLoad( 4, 0, 0, 640, 480 );
//		pBeginBitmap->PreLoad( "bmp\\begin.bmp", 0, 0, 640, 480 );
		// to load bitmap from file
		if( !pBeginBitmap->PreLoad(0, 0, 0, 640, 480, "bmp\\picture.lwc", "bmp\\picture.idx") )
			return FALSE;

		//--fade in
		DD_FadeClear( palBeginBitmap.GetPalette() );
		palBeginBitmap.SetPalette();
		//--fade in

		pBeginBitmap->Show();

		//--fade in
		DD_FadeInScreen( 5, 10 );
		DD_FadeRestore( palBeginBitmap.GetPalette() );
		//--fade in

#ifndef	_DEBUG		
		Sleep(1000);
		DD_FadeOutScreen( 5, 10 );
/*
		BOOL	FadeFlag = FALSE;
		while( ! FadeFlag )
		{
			Sleep( 20 );
			FadeFlag = DD_FadeOut( 30 );
		}
*/
#endif

		// to delete the begin bitmap
		DD_EraseFrontScreen();
		delete pBeginBitmap;
		// to erase the front buffer to black
		return TRUE;
	}
	else if( flag == PICTURE_WAIT )
	{
		FACE_pWaitBitmap = new CDDBitmap;

		if( !palWaitBitmap.LoadPalettePAL( "res\\wait.pal", TRUE ) )
		{
			ErrorMessage( hwndGame, INTERFACE_ERROR+3, " Cannot load Palette file", "res\\wait.pal" );
			return FALSE;
		}

//		FACE_pWaitBitmap->PreLoad( "bmp\\wait.bmp", 0, 0, 640, 480 );
		if( !FACE_pWaitBitmap->PreLoad(1, 0, 0, 640, 480, "bmp\\picture.lwc", "bmp\\picture.idx") )
			return FALSE;

		//--fade in
		DD_FadeClear( palWaitBitmap.GetPalette() );
		palWaitBitmap.SetPalette();
		//--fade in

		CURSOR_Set( NULL );
		FACE_pWaitBitmap->Show();

		//--fade in
		DD_FadeInScreen( 5, 10 );
		DD_FadeRestore( palWaitBitmap.GetPalette() );
		//--fade in

		return TRUE;
	}
	else if( flag == PICTURE_END )
	{
		pEndBitmap = new CDDBitmap;

		// create and set the palette
//		if( !palEndBitmap.LoadPalette( "bmp\\end.bmp", TRUE ) )
		if( !palEndBitmap.LoadPalettePAL( "res\\end.pal", TRUE ) )
		{
			//ErrorMessage( hwndGame, INTERFACE_ERROR+3, " Cannot load Palette file", "bmp\\end.bmp" );
			ErrorMessage( hwndGame, INTERFACE_ERROR+3, " Cannot load Palette file", "res\\end.pal" );
			return FALSE;
		}
		//palEndBitmap.SetPalette();

//		pEndBitmap->PreLoad( "bmp\\end.bmp", 0, 0, 640, 480 );
		if( !pEndBitmap->PreLoad(2, 0, 0, 640, 480, "bmp\\picture.lwc", "bmp\\picture.idx") )
			return FALSE;

		//--fade in
		DD_FadeClear( palEndBitmap.GetPalette() );
		palEndBitmap.SetPalette();
		//--fade in

		CURSOR_Set( NULL );
		pEndBitmap->Show();

		//--fade in
		DD_FadeInScreen( 5, 10 );
		DD_FadeRestore( palEndBitmap.GetPalette() );
		//--fade in

#ifndef	_DEBUG
		Sleep(1000);
		DD_FadeOutScreen( 5, 10 );
/*
		BOOL	FadeFlag = FALSE;

		while( ! FadeFlag )
		{
			Sleep( 20 );
			FadeFlag = DD_FadeOut( 30 );
		}
*/
#endif
		// to delete this bitmap
		delete pEndBitmap;
		// to erase the front buffer to black
//		DD_EraseFrontScreen();
		return TRUE;
	}
	else if( flag == PICTURE_FAIL )
	{
		class CDDCursor *pCursor ;
		pCursor = CURSOR_Get();

		CURSOR_Set( NULL );

		DD_EraseFrontScreen();

		pFailBitmap = new CDDBitmap;
		// create and set the palette
		if( !palFailBitmap.LoadPalettePAL( "res\\fail.pal", TRUE ) )
		{
			ErrorMessage( hwndGame, INTERFACE_ERROR+3, " Cannot load Palette file", "res\\fial.pal" );
			return FALSE;
		}
		if( !pFailBitmap->PreLoad(3, 0, 0, 640, 480, "bmp\\picture.lwc", "bmp\\picture.idx") )
			return FALSE;

		//--fade in
		DD_FadeClear( palFailBitmap.GetPalette() );
		palFailBitmap.SetPalette();
		//--fade in

		pFailBitmap->Show();

		//--fade in
		DD_FadeInScreen( 5, 10 );
		DD_FadeRestore( palFailBitmap.GetPalette() );
		//--fade in

//#ifndef	_DEBUG
		Sleep(2000);
		DD_FadeOutScreen( 5, 10 );
//#endif
		// to delete this bitmap
		delete pFailBitmap;

		CURSOR_Set( pCursor );

		return TRUE;
	}
	return FALSE;
}

extern	class CDDPalette	palMain;
// to show the event
BOOL	FACE_ShowEvent( int ser )	// flag -> to indentify which event happen
{
	if(FACE_GetCommandState() != COMMAND_STATE_PLAY)
		return FALSE ;

#define	_EVENT_EX_
#ifdef	_EVENT_EX_

	DD_FadeOutScreen( 5, 10 );
	DD_EraseFrontScreen();

	// to read the event text from the event information file
	CText_apply Text;				// the instance to open a pressed file for read the mission text
	char		event_text[1024] ;	// the string to store the input mission text	

	memset (event_text, 0, sizeof(event_text)) ;
	Text.Text_open ("set\\eventex.ext") ;
	Text.Text_use (event_text, ser ) ;
	Text.Text_close ();

	char AviFileName[_MAX_FNAME] ;
	memset( AviFileName, 0, sizeof(AviFileName) ) ;

	strcpy( AviFileName, GAME_strSetupDirectory ) ;
	strcat( AviFileName, "\\avi\\" );
	strcat( AviFileName, event_text );

	FACE_Avi_Play( AviFileName, COMMAND_STATE_AVI_REALTIME ) ;

#else

	FACE_SetProgramState(PROGRAM_STATE_MENU) ;
	FACE_SetCommandState(COMMAND_STATE_MENU) ;

	CURSOR_Get()->Show( FALSE );
	DD_FadeOutScreen( 5, 10 );

	// to read the event text from the event information file
	CText_apply Text;				// the instance to open a pressed file for read the mission text
	char		event_text[1024] ;	// the string to store the input mission text	

	memset (event_text, 0, sizeof(event_text)) ;
	Text.Text_open ("set\\event.ext") ;
	Text.Text_use (event_text, ser ) ;
	Text.Text_close ();

	int					iResult ;
	class	CDDText		text;	// the text surface to blit to the back buffer

	iResult = text.BeginText( 56, 4 );
	if( ! iResult )
		return FALSE;

	// to set the color of this text show 
	text.SetTextColor( RGB(192, 192, 192) );
	text.PolyTextOut(DD_GetFrontBuffer(), 140, 180, event_text);
	// to blit the attribute prompt word to the prompt area
	text.GetDDSurface()->Erase();
	text.EndText();


	Sleep(5000);

  
	//--fade in
	DD_FadeClear( palMain.GetPalette() );
	palMain.SetPalette();
	//--fade in

	// to get current cursor and show it
	CURSOR_Get()->Show(TRUE);

	FACE_SetProgramState( PROGRAM_STATE_PLAY );
	FACE_SetCommandState( COMMAND_STATE_PLAY );

	// to fade in the interface of this game
	DDC_UpdateScreen();
	//--fade in
	DD_FadeInScreen( 5, 10 );
	DD_FadeRestore( palMain.GetPalette() );
	//--fade in
#endif //_EVENT_EX_
	return TRUE ;
}
//////////////////////////////////////////////////////////
// to blit current menu to the back buffer
void FACE_BlitCurrentMenu()
{
	if( CurrentMenu == NULL )
		return ;
	CurrentMenu->Blit() ;
	FACE_BlitAllBitmap() ;
	CurrentMenu->m_MenuButtonUnit.Blit();
	FACE_BlitAllList() ;
	FACE_BlitAllScrollBar() ;
	FACE_BlitAllCheckBox() ;
}
//////////////////////////////////////////////////////////