// SPLASHAPI.H
// ------------------------------------------------------------------
// Header file used to call Splash API.
// ------------------------------------------------------------------

#define SPLASH_LANG_ENGLISH			0
#define SPLASH_LANG_FRENCH			1
#define SPLASH_LANG_ITALIAN			2
#define SPLASH_LANG_GERMAN			3
#define SPLASH_LANG_SPANISH			4
#define SPLASH_LANG_JAPANESE		5
#define SPLASH_LANG_KOREAN			6
#define SPLASH_LANG_CHINESEPRC		7

#if WIN16
#define EXPORT		_export
#define SPLASHAPI	FAR PASCAL EXPORT
#endif
#if WIN32
#define EXPORT
#define SPLASHAPI	__declspec(dllexport) __stdcall
#endif

// ------------------------------------------------------------------
// ------------------------------------------------------------------
#ifdef __cplusplus
extern "C" {
#endif

int SPLASHAPI SplashInit( DWORD dwLang );
int SPLASHAPI SplashExecute();

#ifdef __cplusplus
}
#endif


