/////////////////
// CBCtrl.cpp	:	ڡȫֿݽṹ
// CBCtrl.cpp	:	<< chibi >> global contral data structure
//
// v0010		:	Oct.3.1996
// v0011		:	Oct.18.1996
// v0012		:	Jan.25.1997
// v0013		:	Feb.5.1997
// v0020		:	Mar.29.1997, add most controls
// v0021		:	Apr.2.1997, add deploy asserts
// v0030		:	May.16.1997, add Block(), OpenDoor(), etc. changed a lot
// v0031		:	Sep.11.1997, changed a lot
//
// д			:	
// written by	:	Liu Gang
//
// 		:	Visual C++ 4.2
// Compiler		:	Visual C++ 4.2
//
// Ȩ			:	ǰ޹˾	1996-1997
// Copyright	:	WayAhead Co.Ltd.		1996-1997
/////////////////
// ļϷĿƽṹ״̬֡ĲԼ񻺳еĲ

#include "stdafx.h"
#include "CBCtrl.h"

#ifndef	_CTRL_DEBUG
#include "Assert.h"

#include "CBMap.h"
#include "CBData.h"
#include "CBGame.h"		// ʹGAME.MeжǷϷ
#include "CBMouse.h"
#include "CbEyes.h"		// ⺯
#include "CBShadow.h"	// SHADOW_IfEnabled()

//#include "CBRun.h"	// RUN_CREATE_IfEnoughMoney()
#include "CBRDelay.h"

#include "DDCompo.h"

// LHJ
#include "marco.h"
#include "interfa1.h"
#include "interfac.h"
#include "cbprompt.h"
// LHJ

// TY
#include "TbnBase.h"
#include "Temperor.h"
// TY

#include "CBBuild.h"
#include "CBRDelay.h"	// defines
#include "CBOther.h"

#include "CBDraw.h"		// DRAW_JumpScreen()
#endif

// debug only
#include <stdio.h>

//////////////////////
// externals
// defined in CBDraw.cpp
extern RECT DRAW_rcScreen;			// defined in CBDraw.cpp
extern POINT DRAW_ptScreenOffset;	// defined in CBDraw.cpp
extern int MAP_nLocationNum[4];		// defined in CBMap.cpp
extern POINT MAP_ptLocation[2][MAP_LOCATION_MAX]; // defined in CBMap.cpp

// defined in CBDraw.cpp
// ѡΪĿĵصĵԪҪ˸ʾı߽
extern int DRAW_BLINK_nCounter;
extern int DRAW_BLINK_nDelay;
extern BOOL DRAW_BLINK_bDraw;
extern WORD DRAW_BLINK_nID;
extern int DRAW_BLINK_nSave;
//////////////////////

//////////////////////
// defines
#define CTRL_TIMEDELAY_COMMAND	200		// Ҽļʱ䣨룩
#define CTRL_TIMEDELAY_MOUSE	2		// ĿҼĺۼ
//////////////////////

//////////////////////
// ˮߣˮߵкǱļڲ
// ȫ

// ָʾеβλ
// points to the Task List's tail
int	CTRL_nTaskTail[GAME_PLAYER_MAX]={0,0,0,0,0};

// ָһЧλ
int CTRL_nTaskHead[GAME_PLAYER_MAX]={0,0,0,0,0};

// First demension: 0-4 are the Waiting List of player 0-4
// һ±꣺0-4Ϸ0-4ĵȴ
struct CTRL_TASK_STRUCT	CTRL_TaskList[GAME_PLAYER_MAX][CTRL_TASK_LIST_MAX+CTRL_TASK_LIST_MAX];

// 浱ǰ
struct CTRL_TASK_SAVE_CMDUNIT CTRL_TASK_saveCmdUnit;
//////////////////////
// local functions

// get contents from Task List
// nPlayer		:	player's ID, 0-4 are player  0-4
// pTask		:	the Task you got
// return vlaue	:	TRUE if get one 
extern BOOL CTRL_TASK_LIST_Peek( int nPlayer, struct CTRL_TASK_STRUCT *pTask );	// ȡ񷵻

// store contents to Task List
// nPlayer		:	player's ID, 0-4 are player  0-4
// pTask		:	the Task you want to send
// return vlaue	:	TRUE if there is room for the Task
extern BOOL CTRL_TASK_LIST_Send( int nPlayer, CONST struct CTRL_TASK_STRUCT *pTask );	// 񷵻

extern	BOOL CTRL_TASK_LIST_SendEx( int nPlayer, CONST struct CTRL_TASK_STRUCT *pTask, int nIndex ,int nTail);


// copy list
// nFrom		:	ID for Task List to copy from
// nTo			:	ID for Task List to copy to
extern void CTRL_TASK_LIST_Copy( int bTo, int nFrom );

// clear list
// nList	: number of list to cleared
extern void CTRL_TASK_LIST_Clear( int nList );
//////////////////////

//////////////////////
// ۼ
void CTRL_MOUSE_Clip( int nX, int nY );
//////////////////////

//////////////////////
// Ч
// ѡĳԪ
// nFile	:	Ԫļ
void CTRL_SOUND_select( int nFile );
// ĳԪ´
// nFile	:	Ԫļ
void CTRL_SOUND_doIt( int nFile );
//////////////////////

//////////////////////
// 
BOOL CTRL_bDebugCommand	= FALSE;
BOOL CTRL_bDebugDie = FALSE;
//////////////////////

///////////////////////////////////Donghai//////////////////////////////////////
#include "network.h"
extern	BYTE    DP_SendMessageBuff[BUFFER_MAX_BYTE];
extern	int		DP_NetworkInterface(int	Action, HWND   MainWndHandle);
int		CB_SendTaskMessage(int nPlayer, CONST struct CTRL_TASK_STRUCT *pTask);
extern	int	CB_Counter;
///////////////////////////////////Donghai//////////////////////////////////////

//////////////////////
// 
//////////////////////
// get contents from Task List
// nPlayer		:	player's ID, 1-4 are player  1-4, 0 is my Waiting List
// pTask		:	the Task you got
// return value	:	TRUE if get one 
inline BOOL CTRL_TASK_LIST_Peek( int nPlayer, struct CTRL_TASK_STRUCT *pTask )
{
	// ж϶Ƿǿյ
	if( CTRL_nTaskTail[nPlayer] == CTRL_nTaskHead[nPlayer] )
		return FALSE;

	int nHead = CTRL_nTaskHead[nPlayer];
	struct CTRL_TASK_STRUCT *pTaskSrc = &CTRL_TaskList[nPlayer][nHead];
	//Assert( pTaskSrc->nTaskID != QUXIAO );
	// жȡ
	CTRL_TASK_Copy( pTask, pTaskSrc );
	// Ӷɾ
	CTRL_TASK_Clear( pTaskSrc );

	// ͷָƶ
	nHead++;
	if( nHead == CTRL_TASK_LIST_MAX )
	{
		nHead = 0;
	}
	CTRL_nTaskHead[nPlayer] = nHead;
	return TRUE;
}

// store contents to Task List
// nPlayer		:	player's ID, 1-4 are player  1-4, 0 is my Waiting List
// pTask		:	the Task you want to send
// return vlaue	:	TRUE if there is room for the Task
inline BOOL CTRL_TASK_LIST_Send( int nPlayer, CONST struct CTRL_TASK_STRUCT *pTask )
{
	// βָƶ
	int nTail = CTRL_nTaskTail[nPlayer];
	nTail++;
	if( nTail == CTRL_TASK_LIST_MAX )
		nTail = 0;

	// ж϶Ƿ
	if( nTail == CTRL_nTaskHead[nPlayer] )
		return FALSE;

	// 洢񵽶
	struct CTRL_TASK_STRUCT *pTaskDest = &CTRL_TaskList[nPlayer][CTRL_nTaskTail[nPlayer]];
	CTRL_TASK_Copy( pTaskDest, pTask );
	CTRL_nTaskTail[nPlayer]=nTail;

	return TRUE;
}


// store contents to Task List
// nPlayer		:	player's ID, 1-4 are player  1-4, 0 is my Waiting List
// pTask		:	the Task you want to send
// return vlaue	:	TRUE if there is room for the Task
inline BOOL CTRL_TASK_LIST_SendEx( int nPlayer, CONST struct CTRL_TASK_STRUCT *pTask, int nIndex ,int	nTail)
{
	// 洢񵽶
	struct CTRL_TASK_STRUCT *pTaskDest = &CTRL_TaskList[nPlayer][nIndex];
	CTRL_TASK_Copy( pTaskDest, pTask );

	CTRL_nTaskTail[nPlayer]=nTail;
/////////////////////////////Donghai/////////////////////////////
//	char	test32[255];
//	wsprintf((char *)test32,"================================%d!!!================================\n",CB_Counter);
//	WriteLogFile("Test_Sendex.log",(char *)test32);
/////////////////////////////Donghai/////////////////////////////

	return TRUE;
}

// copy
// nFrom		:	ID for Task List to copy from
// nTo			:	ID for Task List to copy to
inline void CTRL_TASK_LIST_Copy( int nTo, int nFrom )
{
	memcpy( CTRL_TaskList[nTo], CTRL_TaskList[nFrom], sizeof(struct CTRL_TASK_STRUCT)*CTRL_TASK_LIST_MAX );
}

// clear list
// nList	: number of list to cleared
inline void CTRL_TASK_LIST_Clear( int nList )
{
	memset( CTRL_TaskList[nList], 0, sizeof(struct CTRL_TASK_STRUCT)*CTRL_TASK_LIST_MAX );
}
//////////////////////


//////////////////////
// Ĳ

#ifdef	_DEBUG
	// CTRL_TASK_LIST_Send()ʱнжʱ
	// һҪд֤ڴʱͬԡ
	// CTRL_TASK_Main()ʱFlag־Ϊ棬
	// CTRL_TASK_LIST_Send()ʱжϸñ־
	BOOL CTRL_TASK_Reading = FALSE;
#endif	// _DEBUG

// mouse hit result
// ļ
int	CTRL_nHitCounter=0;
// contains the units player want to send command to
// 
// ֻnID
struct CTRL_TASK_STRUCT CTRL_hitSrc[CTRL_TASK_LIST_MAX-1];

// the target unit
// Ŀ壬Ҳڴ
struct CTRL_TASK_STRUCT CTRL_hitDest;

// Set Task from Task List to unit
// task	:	Task to be set
void CTRL_TASK_SetToUnit( struct CTRL_TASK_STRUCT task );
//////////////////////

//////////////////////
// get soldier number that focus on 
// õڽ״̬ʿ
// return	:	soldier number, in person
int CTRL_GetFocusSoldierNumber()
{
	// õʿ
	int nCount=0;
	for( int i=0; i< CTRL_nHitCounter; i++ )
	{
		Assert( CTRL_hitSrc[i].nID != MAP_DATA_NONE );
		struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[i].nID );
		// ٳֵʿѾ׼ǻûдѡ
		if( EYE_IfUnitIsDead( pUnit ) )	
			break;
//		if( pUnit == NULL )
//			WriteLogFile( "Test.log", "CTRL_GetFocusSoldierNumber()\n" );
		Assert( pUnit );
		Assert( pUnit->nType != 0 );
		if( EYE_IfUnitIsSoldier( pUnit ) )
			nCount += pUnit->nLife;
		Assert( nCount >= 0 && nCount <= 99999 );
	}
	return nCount;
}

// clear assembling parameters
// CTRL_hitSrc
// bForce	:	ǿ
// bForce	:	Ϊʱǿен㣻
//              ֻиʱŻᱻա
void CTRL_TASK_ClearAssembleSrc( BOOL bForce /*=FALSE*/ )
{
	// clear Focus to units, clear hittest source objects
	int nCounter = CTRL_nHitCounter;
	for( int i=0; i< nCounter; i++ )
	{
		if( CTRL_hitSrc[i].bDone && !bForce )	continue;
		Assert( CTRL_hitSrc[i].nID != MAP_DATA_NONE );
		struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[i].nID );
		Assert(pUnit);
		pUnit->Draw.bUpdate = FALSE;	// ȥѡп
		// clear source objects
		CTRL_TASK_Clear( &CTRL_hitSrc[i] );
		CTRL_nHitCounter --;
	}

	// clear build drawings
	if( BUILD_IfEnable() )
		BUILD_Enable( FALSE );

//	CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_NONE;
//	CTRL_TASK_saveCmdUnit.Ex = 0xFFFFFFFF;
//	CTRL_TASK_saveCmdUnit.Busy = 0;

#ifdef	_DEBUG
	if( bForce )	Assert( CTRL_nHitCounter == 0 );
#endif
}

void CTRL_TASK_ClearAssembleDest()
{
	// clear command
	// clear hittest destination object and command
	CTRL_TASK_Clear( &CTRL_hitDest );
	// reset command unit array
/*	if( CTRL_TASK_saveCmdUnit.Busy == 1 )
	{
		FACE_ShowCommandUnit( COMMANDUNIT_CANCEL, 0xFFFF ); // clear command sets
	}
	else
	{
		FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
	}
*/
	// ״
	MOUSE_SetState( MOUSE_STATE_NONE );
}

// ý
//void CTRL_TASK_BuildCommand( int nFile )
void CTRL_TASK_BuildCommand( struct UNIT_STRUCT *pUnit )
{
	Assert( EYE_IfUnitIsBuild( pUnit ) );
	switch( pUnit->Draw.nFile )
	{
		case	0:	// ˧1
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_CHAO_MAINBUILDING;
			// 
			CTRL_TASK_saveCmdUnit.Ex = 0x0001;
			//if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 0
			if( pUnit->Build.dwUpgrade[0] == 0
				&& GAME.Players[GAME.nMe].nTechLvl >= 2 
				&& BuildPoint[GAME.nMe][MUCAICHANG].hPos == CBTRUE 
				&& BuildPoint[GAME.nMe][WUQICHANG].hPos == CBTRUE )
			{	// ǰȼ0ߵȼ1ľĳ
				CTRL_TASK_saveCmdUnit.Ex = 0x0003;	//0011
			}
			//else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 1
			else if( pUnit->Build.dwUpgrade[0] == 1
				&& GAME.Players[GAME.nMe].nTechLvl >= 3 
				&& BuildPoint[GAME.nMe][QIBINGSUO].hPos == CBTRUE 
				&& BuildPoint[GAME.nMe][CHEBINGSUO].hPos == CBTRUE )
			{	// ǰȼ1ߵȼ2г
				CTRL_TASK_saveCmdUnit.Ex = 0x0005;
			}
			//else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 2
			else if( pUnit->Build.dwUpgrade[0] == 2
				&& GAME.Players[GAME.nMe].nTechLvl >= 4 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] >= 2 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_GONGJIAN] >= 2 )
			{	// ľĳ33
				CTRL_TASK_saveCmdUnit.Ex = 0x0009;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	1:	// ˧2
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_LIU_MAINBUILDING;
			// 
			CTRL_TASK_saveCmdUnit.Ex = 0x0001;
			//if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 0
			if( pUnit->Build.dwUpgrade[0] == 0
				&& GAME.Players[GAME.nMe].nTechLvl >= 2 
				&& BuildPoint[GAME.nMe][MUCAICHANG].hPos == CBTRUE 
				&& BuildPoint[GAME.nMe][WUQICHANG].hPos == CBTRUE )
			{	// ǰȼ0ߵȼ1ľĳ
				CTRL_TASK_saveCmdUnit.Ex = 0x0003;	//0011
			}
			//else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 1
			else if( pUnit->Build.dwUpgrade[0] == 1
				&& GAME.Players[GAME.nMe].nTechLvl >= 3 
				&& BuildPoint[GAME.nMe][QIBINGSUO].hPos == CBTRUE 
				&& BuildPoint[GAME.nMe][CHEBINGSUO].hPos == CBTRUE )
			{	// ǰȼ1ߵȼ2г
				CTRL_TASK_saveCmdUnit.Ex = 0x0005;
			}
			//else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 2
			else if( pUnit->Build.dwUpgrade[0] == 2
				&& GAME.Players[GAME.nMe].nTechLvl >= 4 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] >= 2 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_GONGJIAN] >= 2 )
			{	// ľĳ33
				CTRL_TASK_saveCmdUnit.Ex = 0x0009;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	2:	// 1
		case	3:	// 2
			//GAME.Players[GAME.nMe].
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_WEAPONFACTORY;
			// 
			CTRL_TASK_saveCmdUnit.Ex = 0x0000;
			if( GAME.Players[GAME.nMe].nTechLvl >= 4 
				&& BuildPoint[GAME.nMe][DOGFACE].hPos == CBTRUE )
			{	// ߵȼ33
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] == 0 )
					CTRL_TASK_saveCmdUnit.Ex = 0x0001;
				else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] == 1 )
					CTRL_TASK_saveCmdUnit.Ex = 0x0002;
				else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] == 2 )
					CTRL_TASK_saveCmdUnit.Ex = 0x0004;
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_HUJIA] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0008;
				else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_HUJIA] == 1 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0010;
				else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_HUJIA] == 2 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0020;
			}
			else if( GAME.Players[GAME.nMe].nTechLvl >= 3 
				&& BuildPoint[GAME.nMe][DOGFACE].hPos == CBTRUE )
			{	// ߵȼ22
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] == 0 )
					CTRL_TASK_saveCmdUnit.Ex = 0x0001;
				else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] == 1 )
					CTRL_TASK_saveCmdUnit.Ex = 0x0002;
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_HUJIA] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0008;
				else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_HUJIA] == 1 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0010;
			}
			else if( GAME.Players[GAME.nMe].nTechLvl >= 2 
				&& BuildPoint[GAME.nMe][DOGFACE].hPos == CBTRUE )
			{	// ߵȼ1в
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] == 0 )
					CTRL_TASK_saveCmdUnit.Ex = 0x0001;
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_HUJIA] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0008;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	4:	// ľĳ1
		case	5:	// ľĳ2
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_LUMBER;
			// 
			CTRL_TASK_saveCmdUnit.Ex = 0x0000;
			if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_GONGJIAN] == 0
				&& GAME.Players[GAME.nMe].nTechLvl >= 2 
				&& BuildPoint[GAME.nMe][BOW].hPos == CBTRUE )
			{	// ǰȼ0ߵȼ1й
				CTRL_TASK_saveCmdUnit.Ex = 0x0001;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_GONGJIAN] == 1 
				&& GAME.Players[GAME.nMe].nTechLvl >= 3 )
			{	// ǰȼ1ߵȼ2ľĳ2
				CTRL_TASK_saveCmdUnit.Ex = 0x0002;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_GONGJIAN] == 2 
				&& GAME.Players[GAME.nMe].nTechLvl >= 4 )
			{	// ǰȼ2ߵȼ3ľĳ3
				CTRL_TASK_saveCmdUnit.Ex = 0x0004;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	6:	// 1
		case	7:	// 2
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_KNIGHTSCHOOL;
			if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 0 )
			{	// 
				CTRL_TASK_saveCmdUnit.Ex = 0x0001;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 1 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x0003;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 2 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x0007;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	8:	// 1
		case	9:	// 2
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_VEHICLEMANSCHOOL;
			// ˧ʣ
			CTRL_TASK_saveCmdUnit.Ex = 0x0001;
			if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 2 )
			{	// ˧ʣ
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_TOUSHICHE] == 0 )
					CTRL_TASK_saveCmdUnit.Ex = 0x0003;
				else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_TOUSHICHE] == 1 )
					CTRL_TASK_saveCmdUnit.Ex = 0x0005;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 1
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_TOUSHICHE] == 0 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x0003;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	10:	// 1
		case	11: // 1
			break;
		case	12:	// 1
		case	13: // 2
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_FOOTMANSCHOOL;
			if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 0 )
			{	// 
				CTRL_TASK_saveCmdUnit.Ex = 0x0001;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 1 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x0003;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 2 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x0007;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 3 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x000F;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	14:	// 1
		case	15: // 2
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_BOWMANSCHOOL;
			if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 0 )
			{	// 
				CTRL_TASK_saveCmdUnit.Ex = 0x0001;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 1 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x0003;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 2 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x0007;
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 3 )
			{	// ˧ʣ
				CTRL_TASK_saveCmdUnit.Ex = 0x000F;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	16: // 1
		case	17:	// 2
		case	18: // ¥1
		case	19:	// ¥2
			break;
		case	20: // 
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_SHIPYARD;
			// ˧ʣ
			if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 2 )
				CTRL_TASK_saveCmdUnit.Ex = 0x0007;
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] == 1 )
				CTRL_TASK_saveCmdUnit.Ex = 0x0003;
			else
				CTRL_TASK_saveCmdUnit.Ex = 0x0001;

			if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 2 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_GONGJIAN] == 3 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] == 3 )
			{	// ˧ʣľĳ
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_CHUAN1] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0008;
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_CHUAN2] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0010;
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_CHUAN3] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0020;
				if( GAME.nID > 17 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0040;	// ǲܲ٣
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 2 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_GONGJIAN] >= 2 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] >= 2 )
			{	// ˧ʣľĳ
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_CHUAN1] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0008;
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_CHUAN3] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0020;
				if( GAME.nID > 17 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0040;	// ǲܲ٣
			}
			else if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] >= 1
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_GONGJIAN] >= 1 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_BINGQI] >= 1 
				&& GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_CHUAN1] >= 0 )
			{	// ˧ʣľĳ
				if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_CHUAN1] == 0 )
					CTRL_TASK_saveCmdUnit.Ex |= 0x0008;
			}
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	21: // 
			break;
		case	22: // 
			break;
		case	23: // Ǯׯ
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_SHOP;
			CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			break;
		case	24: // 
			break;
	}
}

/*
// ѰĳԪǷѾڽѡ
BOOL CTRL_AssembleFindDuplicate( WORD nID )
{
	for ( int i=0; i<CTRL_nHitCouner; i++ )
	{
		if( CTRL_hitSrc[i].nID == nID )
			return TRUE;
	}
	return FALSE;
}
*/

// ϳĿǷԪ壩
// ֻCTRL_hitSrcnID, nLevel
// ⲽ裺
// 1ǷԼĲ
// 2òǷ񻹻
// 3ѡн죬ýʿѡ
// 4δĲӣֻδĲӱѡ
//		4.1ǹˣֻй˱ѡ
//		4.2Ǵֻдѡ
//		4.3һʿֻʿѡ
// 5Ĳӣѡ
// 6ǵ˵Ĳӣѡ
// 7ǽһѡ
// detect if mouse dragging rectangle contains units
// prcHit		:	rectangle mouse dragging
// wParam		:	Ӧʱ鿴ǷCtrlShift
// return value	:	TRUE if hit something
BOOL CTRL_TASK_AssembleSrc( CONST RECT *prcHit, WORD wParam )
{
	int i, j;
	WORD codeUEx;
	MOUSE_HITRESULT_STRUCT hit;

	// ⵽ʱָЧýָ
	struct UNIT_STRUCT *pGen = NULL;

	// ⵽һʱý
	WORD codeBuild = MAP_DATA_NONE;

	// ⵽ĳʿĳʱýID
	WORD codeGen = MAP_DATA_NONE;
	// ⵽ĳʿĳʱʿԼID
	WORD sArrayY[CTRL_TASK_LIST_MAX-1];
	// йʿ
	int nYCounter = 0;

	// ⵽ĳʿκνʱʿԼID
	WORD sArrayN[CTRL_TASK_LIST_MAX-1];
	// ޹ʿ
	int nNCounter = 0;

	// ⵽ĳ˲κνʱùԼID
	WORD sArrayNW[CTRL_TASK_LIST_MAX-1];
	// ޹ʿ
	int nNWCounter = 0;

	// ⵽ҷֻʱôֻID
	WORD sArrayNS[CTRL_TASK_LIST_MAX-1];
	// ֻ
	int nNSCounter = 0;

	// ѡе˵ĵԪʱΪ
	BOOL bEnemy = FALSE;
	// ֻһ˱ѡ
	int	nEPlayer = -1;
	// ѡе˵ʿʱʿID
	WORD sArrayE[CTRL_TASK_LIST_MAX-1];
	// ʿļ
	int nECounter = 0;

	if( IsRectEmpty( prcHit ) && prcHit->left == 0 )
		return FALSE;
	
	// if no rectangle, do it with point
	// ĳһЧ
	if( IsRectEmpty( prcHit ) )
	{
		POINT pt;
		pt.x = prcHit->left;
		pt.y = prcHit->top;
		
		if( MOUSE_HitTestU( pt, &hit ) )
		{
			// set single source object
			Assert( hit.nType == MOUSE_HITRESULT_UNIT );

			// set source objects
			codeUEx = hit.wCode;
			Assert( codeUEx != MAP_DATA_NONE );
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( codeUEx );

			Assert( pUnit );
			// 1ǷԼĵԪֻԼ˲ܱѡ
			// 2ԪΪʹMOUSE_HitTestU()Ԫһ
			// MOUSE_HitTestU()УԴ˽ж
			if( !EYE_IfUnitIsBuild( pUnit ) )
			{	// ʿ
				if( wParam == 4 && pUnit->Draw.bUpdate == TRUE )
				{
					// shift£ˣdo nothing
				}
				else if( EYE_IfUnitIsGen( pUnit ) )
				{	// ½
					pGen = pUnit;	//break;
				}
				else //if( EYE_IfUnitIsSoldier( pUnit ) )
				{	// ʿ
					if( EYE_IfSheIsMine( pUnit ) )
							bEnemy = FALSE;
					else	bEnemy = TRUE;
					if( bEnemy == FALSE )
					{
						if( pUnit->Soldier.nGenID != MAP_DATA_NONE )
						{
							sArrayY[nYCounter] = codeUEx;
							nYCounter++;
						}
						else if( EYE_IfUnitIsWorker( pUnit ) )
						{
							sArrayNW[nNWCounter] = codeUEx;
							nNWCounter++;
						}
						else if( EYE_IfUnitIsShip( pUnit ) )
						{
							sArrayNS[nNSCounter] = codeUEx;
							nNSCounter++;
						}
						else
						{
							sArrayN[nNCounter] = codeUEx;
							nNCounter++;
						}
					}
					else
					{
						if( nEPlayer == -1 )
						{
							nEPlayer = pUnit->Draw.nPlayer;
						}
						if( nEPlayer == pUnit->Draw.nPlayer )
						{
							sArrayE[nECounter] = codeUEx;
							nECounter ++;
						}
					}
				}// End of if( pUnit->nType == MAP_UNIT_TYPE_GEN )
			}// End of if( !EYE_IfUnitIsBuild( pUnit ) )
			else
			{	// ǽ
				codeBuild = codeUEx;
			}// End of if( EYE_IfUnitIsSoldier( pUnit ) )
		}// End of if( MOUSE_HitTestU( pt, &hit ) )
	}// End of if( IsRectEmpty( prcHit ) )
	else	// do with rectangle
	{
		for( j=DRAW_rcScreen.top; j<DRAW_rcScreen.bottom; j++ )
		for( i=DRAW_rcScreen.left; i<DRAW_rcScreen.right; i++ )
		{
			// 
			if( nYCounter >= CTRL_TASK_LIST_MAX-1 ) break;
			if( nNCounter >= CTRL_TASK_LIST_MAX-1 ) break;

			codeUEx = MAP_GetUnitDataEx( i, j );
			if( codeUEx == MAP_DATA_NONE )	continue;
			struct CTRL_FRAME_STRUCT stctCF;
			if( !MAP_GetUnitFrameData( i, j, &stctCF, FALSE ) )
				continue;
			RECT rcUnit = MAP_GetUnitRect( DRAW_ptScreenOffset, &stctCF );
			if( IntersectRect( &rcUnit, &rcUnit, prcHit ) )
			{
				// set source objects
				Assert( codeUEx != MAP_DATA_NONE );
				struct UNIT_STRUCT *pUnit = MAP_GetUnit( codeUEx );
				Assert( pUnit );
				// 0: Ӱס
				// 1ǷԼĵԪֻԼ˲ܱѡ
				// 2Ԫ
				if( SHADOW_IfEnabled() )
				{
					WORD codeR = MAP_GetRegionData( i, j );
					struct MAP_REGION_CODE_STRUCT stctR;
					MAP_RegionDeCode( codeR, &stctR );
					if( stctR.nShadow == MAP_SHADOW_NONE || stctR.nShadowEx == 1 )
					{
						continue;
					}
				}
				if( !EYE_IfUnitIsDead( pUnit ) )
				{	
					if( !EYE_IfUnitIsBuild( pUnit ) )
					{	
						if( wParam == 4 && pUnit->Draw.bUpdate == TRUE )
						{
							// shift£ˣdo nothing
						}
						// ʿ
						else if( EYE_IfUnitIsGen( pUnit ) )
						{	// ½
							if( !pGen || 
								(pGen && !EYE_IfSheIsMine( pGen ) ) )
							{	// ԭûнԼĽ
								pGen = pUnit;	
							}
							break;
						}
						else //if( EYE_IfUnitIsSoldier( pUnit ) )
						{	// ʿ
							if( EYE_IfSheIsMine( pUnit ) )
									bEnemy = FALSE;
							else	bEnemy = TRUE;
							if( bEnemy == FALSE )
							{
								if( pUnit->Soldier.nGenID != MAP_DATA_NONE )
								{
									sArrayY[nYCounter] = codeUEx;
									nYCounter++;
								}
								else if( EYE_IfUnitIsWorker( pUnit ) )
								{
									sArrayNW[nNWCounter] = codeUEx;
									nNWCounter++;
								}
								else if( EYE_IfUnitIsShip( pUnit ) )
								{
									sArrayNS[nNSCounter] = codeUEx;
									nNSCounter++;
								}
								else
								{
									sArrayN[nNCounter] = codeUEx;
									nNCounter++;
								}// End of if( pUnit->nType == MAP_UNIT_TYPE_GEN )
							}
							else
							{
								if( nEPlayer == -1 )
								{
									nEPlayer = pUnit->Draw.nPlayer;
								}
								if( nEPlayer == pUnit->Draw.nPlayer )
								{
									sArrayE[nECounter] = codeUEx;
									nECounter ++;
								}
							}
						}// End of if( pUnit->nType == MAP_UNIT_TYPE_GEN )
					}// End of if( !EYE_IfUnitIsBuild( pUnit ) )
					else
					{	// ǽ
						codeBuild = codeUEx;
					}
				}// End of if( pUnit->Draw.nPlayer == GAME.nMe 
			}// End of if( IntersectRect( &rcUnit, &rcUnit, prcHit ) )
		}// End of for()
	}// End of if( IsRectEmpty( prcHit ) )

	// ȼ⴦
	if( pGen != NULL 
		|| nNWCounter > 0
		|| nNSCounter > 0
		|| nNCounter > 0
		|| nYCounter > 0
		|| codeBuild != MAP_DATA_NONE
		|| nECounter > 0 )
	{
		BOOL bRefresh = TRUE;
		if( wParam == 8
			&& pGen == NULL 
			&& nNWCounter == 0 
			&& nNSCounter == 0
			&& nNCounter == 0
			&& nYCounter > 0 
			)	// Ctrl
		{	// CtrlѸʿѡ
			Assert( sArrayY[0] != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( sArrayY[0] );
			pGen = EYE_GetGeneral( pU );
			Assert( pGen );
			/*
			Assert( sArrayY[0] != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( sArrayY[0] );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) );
			pU = MAP_GetUnit( pU->Soldier.nGenID );
			Assert( pU );
			Assert( EYE_IfUnitIsGen( pU ) );
			pGen = pU;
			*/
		}
		else if( wParam == 4
			&& pGen == NULL 
			&& CTRL_nHitCounter > 0
			)	// ShiftShiftѡеĲӵеĲ
		{
			Assert( CTRL_hitSrc[0].nID != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[0].nID );
			if( EYE_IfUnitIsSoldier( pU ) )
			{
				if( pU->Soldier.nGenID == MAP_DATA_NONE )
				{	// ɢ
					if( EYE_IfUnitIsWorker( pU ) 
						&& nNWCounter > 0 )
					{	// ɢ
						bRefresh = FALSE;
					}
					else if( nNCounter > 0 )
					{	// ɢʿ
						nNWCounter = 0;
						bRefresh = FALSE;
					}
				}
				else if( nYCounter > 0 )
				{	// нʿ
					nNWCounter = 0;
					nNCounter = 0;
					bRefresh = FALSE;
				}
			}
		}

		// Ҫʱ
		if( bRefresh == TRUE )
			// clear Task assembling parameters
			CTRL_TASK_ClearAssembleSrc( TRUE );
	}
	else
	{	// ûЧĵԪѡ
		CTRL_TASK_ClearAssembleDest();
		return FALSE;
	}

	// initialize command units
	// 
	CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_NONE;
	CTRL_TASK_saveCmdUnit.Ex = 0xFFFFFFFF;
	CTRL_TASK_saveCmdUnit.Busy = 0;

	// 3ѡн죬ýʿѡ
	// ֻԼĽ챻ѡУûҷʿѡʱЧ
	if( pGen != NULL 
		&& ( EYE_IfSheIsMine( pGen )
			|| ( !EYE_IfSheIsMine(pGen) 
				&& nNWCounter == 0 
				&& nNCounter == 0 
				&& nYCounter == 0 ) ) )
	{
		Assert( EYE_IfUnitIsGen( pGen ) );
		//CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
		CTRL_hitSrc[CTRL_nHitCounter].nID = pGen->nID;
		CTRL_nHitCounter++;
		for( i = 0; i< GENERAL_TROOP_MAX; i++ )
		{
			if( pGen->Gen.wTroop[i] != MAP_DATA_NONE )
			{
				//CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
				CTRL_hitSrc[CTRL_nHitCounter].nID = pGen->Gen.wTroop[i];
				CTRL_nHitCounter++;
			}
		}

		// ýϢ
		struct	PROMPT_BLOCK	temp;
		temp.PromptBlockId = PROMPT_UNIT;
		DATA_GENERAL_STRUCT *pGenData = &DATA_Lib.Gen[pGen->Gen.nID];
		temp.PromptBlockUnion.Unit.GeneralBitmapId=pGen->Gen.nID;				// ͼƬ
		temp.PromptBlockUnion.Unit.GeneralPower=EYE_GetWuLi( pGen->Gen.nID )*100/120;
		temp.PromptBlockUnion.Unit.GeneralBlood=
			pGen->nLife*100/EYE_GetFullLife( pGen->Draw.nPlayer, pGen->Draw.nFile );			// ֵ200
		strcpy( temp.PromptBlockUnion.Unit.GeneralName, pGenData->strName );	// 

		// 
		EYE_GetLevelName( pGen->Gen.nID, temp.PromptBlockUnion.Unit.Office ); // 

		temp.PromptBlockUnion.Unit.Experience = pGenData->nJingYan;		// 
		temp.PromptBlockUnion.Unit.Ruse = pGenData->nMouLue;			// ı
		temp.PromptBlockUnion.Unit.UnitMorale = EYE_GetMorale( pGen );		// ʿ
		temp.PromptBlockUnion.Unit.UnitLineUp = pGen->Gen.nLineUp;		// 
		// õʿ
		temp.PromptBlockUnion.Unit.NumberOfSolider = CTRL_GetFocusSoldierNumber();

		FACE_ShowPromptBlock( temp );

		if( EYE_IfSheIsMine( pGen ) )
		{
			// sound effect,ԼЧ
			CTRL_SOUND_select( pGen->Draw.nFile );

			// ԼĹ˲
			// Ϊȡ
			if( pGen->Status.bIRQ == TRUE )
			{
				CTRL_TASK_saveCmdUnit.Busy = 2;	// ʱ2
			}
			if( EYE_IfUnitIsWorkerGen( pGen ) )
			{	// ݽýڻ⽨
				if( GAME.Players[GAME.nMe].nBuildType == 0 )
					CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_CHAO_PEASANT;
				else
					CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_LIU_PEASANT;
				CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			}
			// Լսù
			else
			{
				CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_FIGHTUNIT;
				//CTRL_TASK_saveCmdUnit.Ex = 0x00E3;
				CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			}
		}
	}
	// жǷʿѡ
	else if( nNWCounter > 0 || nNCounter > 0 
		|| nYCounter > 0 || nECounter > 0 
		|| nNSCounter > 0 )
	{
		// 4δĲӣֻδĲӱѡ
		// 4.1ǹˣֻй˱ѡ
		if( nNWCounter > 0 )
		{
			for( i=0; i< nNWCounter; i++ )
			{
				//CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
				CTRL_hitSrc[CTRL_nHitCounter].nID = sArrayNW[i];
//				CTRL_hitSrc[CTRL_nHitCounter].nTaskIDEx = MAP_UNIT_TYPE_WGEN;	// ˽
				CTRL_nHitCounter++;
			}
			// δʿ
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_SINGLESOLDIER;
			// ܻ
			CTRL_TASK_saveCmdUnit.Ex = 0x000F;

			// û
			if( nNWCounter == 1 )
			{
				struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[0].nID );
				Assert( pU );
				if( EYE_IfUnitIsWorker( pU ) )
				{
					if( pU->Soldier.nResType != QXZIYUAN 
						&& pU->Soldier.nResource > 0 )
					{	// л
						CTRL_TASK_saveCmdUnit.Ex |= 0x0010;
					}
				}
			}
		}
		//4.2Ǵֻдѡ
		else if( nNSCounter > 0 )
		{
			for( i=0; i< nNSCounter; i++ )
			{
				CTRL_hitSrc[CTRL_nHitCounter].nID = sArrayNS[i];
				CTRL_nHitCounter++;
			}

			// δĴ
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_SINGLESOLDIER;
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;

			// ûܻ
			CTRL_TASK_saveCmdUnit.Ex = 0x000F;
		}
		// 4.3һʿֻʿѡ
		else if( nNCounter > 0 )
		{
			for( i=0; i< nNCounter; i++ )
			{
				//CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
				CTRL_hitSrc[CTRL_nHitCounter].nID = sArrayN[i];
//				CTRL_hitSrc[CTRL_nHitCounter].nTaskIDEx = MAP_UNIT_TYPE_GEN;	// սӽ
				CTRL_nHitCounter++;
			}
			// δʿ
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_SINGLESOLDIER;
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			// ܻ
			CTRL_TASK_saveCmdUnit.Ex = 0x000F;
		}
		// 5Ĳӣѡ
		else if( nYCounter > 0 )
		{
			for( i=0; i< nYCounter; i++ )
			{
				//CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
				CTRL_hitSrc[CTRL_nHitCounter].nID = sArrayY[i];
//				CTRL_hitSrc[CTRL_nHitCounter].nTaskIDEx = MAP_UNIT_TYPE_GEN;	// սӽ
				CTRL_nHitCounter++;
			}

			// ʿ
			CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_REGIMENTSOLDIER;
			//CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			// ܻ
			CTRL_TASK_saveCmdUnit.Ex = 0x0007;

			// û
			if( nYCounter == 1 )
			{
				struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[0].nID );
				Assert( pU );
				if( EYE_IfUnitIsWorker( pU ) )
				{
					if( pU->Soldier.nResType != QXZIYUAN 
						&& pU->Soldier.nResource > 0 )
					{	// л
						CTRL_TASK_saveCmdUnit.Ex |= 0x000F;
					}
				}
			}
		}
		// 6ǵ˵Ĳӣѡ
		else if( nECounter > 0 )
		{
			for( i=0; i< nECounter; i++ )
			{
				//CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
				CTRL_hitSrc[CTRL_nHitCounter].nID = sArrayE[i];
				CTRL_nHitCounter++;
			}
		}

		// ʾϢ
		if( CTRL_nHitCounter == 1 )
		{	
			// 
			Assert( CTRL_hitSrc[0].nID != MAP_DATA_NONE );
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
			Assert( pUnit );
			Assert( EYE_IfUnitIsSoldier( pUnit ) );
			struct DATA_UNIT_STRUCT *pUnitData = &DATA_Lib.Unit[pUnit->Draw.nFile];
			
			// sound effect
			if( nECounter == 0 )	// ǵ
				CTRL_SOUND_select( pUnit->Draw.nFile );
		
			// 䴬
			if( nECounter == 0 && EYE_IfUnitIsTransport( pUnit ) )
			{
				CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_TRANSPORTSHIP;
				if( pUnit->Soldier.bOnBoard == TRUE )
				{	// ж
					CTRL_TASK_saveCmdUnit.Ex = 0x0003;
				}
				else
				{
					CTRL_TASK_saveCmdUnit.Ex = 0x0001;
				}

				// Ϣ䴬
				struct	PROMPT_BLOCK	temp;
				temp.PromptBlockId = PROMPT_TRANSPORT_SHIP;
				temp.PromptBlockUnion.Transport_Ship.SoldierBitmapId = pUnit->Draw.nFile;
				strcpy( temp.PromptBlockUnion.Transport_Ship.SoldierKind, DATA_Lib.Unit[pUnit->Draw.nFile].strName);			// the kind of this soldier
				temp.PromptBlockUnion.Transport_Ship.SoldierPower = 
					pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);				// power -->
				temp.PromptBlockUnion.Transport_Ship.NumberOfUnit = pUnit->Soldier.nOnBoard;
				temp.PromptBlockUnion.Transport_Ship.NumberOfSolider = pUnit->Soldier.nOnBoardSoldier;
				FACE_ShowPromptBlock( temp );
			}
			else
			{
				// Ϣ
				struct	PROMPT_BLOCK	temp;
				temp.PromptBlockId = PROMPT_SOLDIER_SINGLE;
				temp.PromptBlockUnion.Soldier_Single.SoldierBitmapId = pUnit->Draw.nFile;
				strcpy( temp.PromptBlockUnion.Soldier_Single.SoldierKind, pUnitData->strName );			// the kind of this soldier
				temp.PromptBlockUnion.Soldier_Single.SoldierPower = 
					pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);				// power -->
				if( EYE_IfUnitIsSoldier( pUnit ) 
					&& pUnit->Soldier.nGenID != MAP_DATA_NONE )
				{
					struct UNIT_STRUCT *pUG = MAP_GetUnit( pUnit->Soldier.nGenID );
					Assert( pUG );
					Assert( EYE_IfUnitIsGen( pUG ) );
					strcpy( temp.PromptBlockUnion.Soldier_Single.SoldierAscroption, DATA_Lib.Gen[pUG->Gen.nID].strName );		// ascroption --> 
				}
				else temp.PromptBlockUnion.Soldier_Single.SoldierAscroption[0] = 0;
				if( pUnitData->nFightRange == 1 )
				{
//					temp.PromptBlockUnion.Soldier_Single.SoldierAttack = pUnitData->nNearAttack;				// attack -->
//					temp.PromptBlockUnion.Soldier_Single.SoldierDefence = pUnitData->nNearDefend;				// defence -->
					temp.PromptBlockUnion.Soldier_Single.SoldierAttack = EYE_GetNearAttack( pUnit );				// attack -->
					temp.PromptBlockUnion.Soldier_Single.SoldierDefence = EYE_GetNearDefend( pUnit );				// defence -->
				}
				else
				{
//					temp.PromptBlockUnion.Soldier_Single.SoldierAttack = pUnitData->nFarAttack;				// attack -->
//					temp.PromptBlockUnion.Soldier_Single.SoldierDefence = pUnitData->nFarDefend;			// defence -->
					temp.PromptBlockUnion.Soldier_Single.SoldierAttack = EYE_GetFarAttack( pUnit );				// attack -->
					temp.PromptBlockUnion.Soldier_Single.SoldierDefence = EYE_GetFarDefend( pUnit );			// defence -->
				}
				temp.PromptBlockUnion.Soldier_Single.SoldierCarry = pUnitData->nFightRange;					// carry -->
				//temp.PromptBlockUnion.Soldier_Single.SoldierEyesight = pUnitData->nViewRange;				// eyesight -->Ұ
				temp.PromptBlockUnion.Soldier_Single.SoldierEyesight = EYE_GetViewRange( &pUnit->Draw );	// eyesight -->Ұ
				FACE_ShowPromptBlock( temp );
			}
		}
		else
		{	// 
			// Ϣ
			struct	PROMPT_BLOCK	temp;
			temp.PromptBlockId = PROMPT_SOLDIER_MORE;
			temp.PromptBlockUnion.Soldier_More.UnitNumber = CTRL_nHitCounter;		// һмλ
			// õʿ
			temp.PromptBlockUnion.Soldier_More.Amount = CTRL_GetFocusSoldierNumber();			// λ

			FACE_ShowPromptBlock( temp );
		}
	}
	// 7ǽһѡ
	else if( codeBuild != MAP_DATA_NONE )
	{
		//CTRL_hitSrc[CTRL_nHitCounter].nLevel = 0;
		CTRL_hitSrc[CTRL_nHitCounter].nID = codeBuild;
		CTRL_nHitCounter++;

		// 
		Assert( codeBuild != MAP_DATA_NONE );
		struct UNIT_STRUCT *pUnit = MAP_GetUnit( codeBuild );
		Assert( pUnit );
		Assert( EYE_IfUnitIsBuild( pUnit ) );
		if( EYE_IfSheIsMine( pUnit )		// ԼĽ
			|| pUnit->Draw.nFile == 22 )	// 
		{
			// sound effect
			CTRL_SOUND_select( pUnit->Draw.nFile );
		}

		if( EYE_IfSheIsMine( pUnit ) )
		{
			// Ϊȡ
			if( pUnit->Status.bIRQ == TRUE )
			{
				CTRL_TASK_saveCmdUnit.Busy = 1;
			}

			// ý
			// CTRL_TASK_saveCmdUnit.CmdCTRL_TASK_saveCmdUnit.Ex
			//CTRL_TASK_BuildCommand( pUnit->Draw.nFile );
			CTRL_TASK_BuildCommand( pUnit );
		
			// Ϣ
			if( CTRL_TASK_saveCmdUnit.Busy != 1)
			{	// 
				struct	PROMPT_BLOCK	temp;
				temp.PromptBlockId = PROMPT_CONSTRUCTION_IDLESS;	
				temp.PromptBlockUnion.Construction_Idless.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
				strcpy( temp.PromptBlockUnion.Construction_Idless.ConstructionName, 
						DATA_Lib.Unit[pUnit->Draw.nFile].strName );		// Լ
				if( pUnit->Draw.nFile == 22 )	// 
					temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.nResource;	// ԴĴ
				else
					temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.dwUpgrade[0];	// Լļ
				temp.PromptBlockUnion.Construction_Idless.Stone = 
					pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile );	// Լֵ
				FACE_ShowPromptBlock( temp );
			}
			else
			{
				if( pUnit->Status.nTaskID == JIANZAOZHONG )	// 
				{
					struct	PROMPT_BLOCK	temp;
					temp.PromptBlockId = PROMPT_CONSTRUCTION_BUILDING;
					temp.PromptBlockUnion.Construction_Building.ConstructionBitmapId = pUnit->Draw.nFile;
					strcpy( temp.PromptBlockUnion.Construction_Building.ConstructionName, 
							DATA_Lib.Unit[pUnit->Draw.nFile].strName );
					temp.PromptBlockUnion.Construction_Building.ConstructionGrade = pUnit->Build.dwUpgrade[0];
					temp.PromptBlockUnion.Construction_Building.Stone = 
						pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);
					FACE_ShowPromptBlock( temp );
				}
				else if( pUnit->Status.nTaskID == SHENGCHAN )	// 
				{
					struct	PROMPT_BLOCK	temp;	// ״̬ǹ
					temp.PromptBlockId = PROMPT_CONSTRUCTION_WORKING;
					temp.PromptBlockUnion.Construction_Working.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
					temp.PromptBlockUnion.Construction_Working.ConstructionGrade = pUnit->Build.dwUpgrade[0];	//???ļ
					temp.PromptBlockUnion.Construction_Working.Stone = 
						pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);	// Լֵ
					struct MAP_UNIT_CODE_STRUCT stctU;
					MAP_UnitDeCode( pUnit->Status.nTaskIDEx2, &stctU ); 
					temp.PromptBlockUnion.Construction_Working.ProductBitmapId = stctU.nFile;	// ʿļ
					strcpy( temp.PromptBlockUnion.Construction_Working.ConstructionName, 
						DATA_Lib.Unit[pUnit->Draw.nFile].strName );						// Լ
					temp.PromptBlockUnion.Construction_Working.Percent = pUnit->nCounter*100/pUnit->Status.nParam4;	// ɶ
					FACE_ShowPromptBlock( temp );
				}
				else if( pUnit->Status.nTaskID == TISHENG )	// У
				{
					struct	PROMPT_BLOCK	temp;	// ״̬ǹ
					temp.PromptBlockId = PROMPT_CONSTRUCTION_WORKING;
					temp.PromptBlockUnion.Construction_Working.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
					temp.PromptBlockUnion.Construction_Working.ConstructionGrade = pUnit->Build.dwUpgrade[0];	//???ļ
					temp.PromptBlockUnion.Construction_Working.Stone = 
						pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile);;	// Լֵ
					struct MAP_UNIT_CODE_STRUCT stctU;
					MAP_UnitDeCode( pUnit->Status.nTaskIDEx2, &stctU ); 
					temp.PromptBlockUnion.Construction_Working.ProductBitmapId = pUnit->Status.nTaskIDEx2;	// ϢID
					strcpy( temp.PromptBlockUnion.Construction_Working.ConstructionName, 
						DATA_Lib.Unit[pUnit->Draw.nFile].strName );						// Լ
					temp.PromptBlockUnion.Construction_Working.Percent = pUnit->nCounter*100/RUN_TIMEDELAY_UPGRADE;	// ɶ
					FACE_ShowPromptBlock( temp );
				}
			}
		}// End of if( EYE_IfSheIsMine( pUnit ) )
		else
		{	// ˵ԪϢǿ
			struct	PROMPT_BLOCK	temp;
			temp.PromptBlockId = PROMPT_CONSTRUCTION_IDLESS;	
			temp.PromptBlockUnion.Construction_Idless.ConstructionBitmapId = pUnit->Draw.nFile;	// Լļ
			strcpy( temp.PromptBlockUnion.Construction_Idless.ConstructionName, 
					DATA_Lib.Unit[pUnit->Draw.nFile].strName );		// Լ
			if( pUnit->Draw.nFile == 22 )	// 
				temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.nResource;	// ԴĴ
			else
				temp.PromptBlockUnion.Construction_Idless.ConstructionGrade = pUnit->Build.dwUpgrade[0];	// Լļ
			temp.PromptBlockUnion.Construction_Idless.Stone = 
				pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile );	// Լֵ
			FACE_ShowPromptBlock( temp );
		}
	}

	// 
	// һѡĳԪ
	if( CTRL_bDebugCommand == TRUE )
		CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;	// 
	if( CTRL_TASK_saveCmdUnit.Busy == 1 )
	{
		FACE_ShowCommandUnit( COMMANDUNIT_CANCEL, 0xFFFF ); // clear command sets
	}
	else if( CTRL_TASK_saveCmdUnit.Busy == 2 )	// ʱ2
	{
		CTRL_TASK_saveCmdUnit.Busy = 1;
		FACE_ShowCommandUnit( COMMANDUNIT_NONE, 0xFFFF ); // clear command sets
	}
	else
	{
		FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
	}

//	if( CTRL_TASK_saveCmdUnit.Cmd != COMMANDUNIT_NONE
//		|| CTRL_TASK_saveCmdUnit.Busy == 1)
		// CTRL_hitDestݣ
	CTRL_TASK_ClearAssembleDest();
//	else
//	{	// еĵԪû
//		FACE_ClearCommandUnitArea();
//	}

	// set focus to units
	// ѡеĵԪý״̬
	if( DRAW_BLINK_nID != MAP_DATA_NONE )
	{
		struct UNIT_STRUCT *pU = MAP_GetUnit( DRAW_BLINK_nID );
		Assert( pU );
		pU->Draw.bUpdate = FALSE;	// ȡԭ˸
	}
	DRAW_BLINK_nID = MAP_DATA_NONE;	// ˸Ч
	for( i=0; i< CTRL_nHitCounter; i++ )
	{
		Assert( CTRL_hitSrc[i].nID != MAP_DATA_NONE );
		struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[i].nID );
		Assert( pUnit );
		if( EYE_IfSheIsMine( pUnit ) )
			pUnit->Draw.bUpdate = 1;
		else if( EYE_PlayerIsAllied( GAME.nMe, pUnit->Draw.nPlayer ) )
		{
			pUnit->Draw.bUpdate = 3;	// ͬˣɫ
		}
		else
		{
			pUnit->Draw.bUpdate = 2;	// ˣɫ
		}
	}

	return TRUE;
}

void CTRL_TASK_WorkerCommand( DWORD *pnEx, DWORD *pnExx )
{
	// ʼΪе
	DWORD EX=0xFFFF, EXX=0xFFFF;
	if( BuildPoint[GAME.nMe][MAINBATTALION].hPos == CBNULL )
	{	// û˧ʣǮׯ
		EX &= (~0x0010);	
	}
	if( BuildPoint[GAME.nMe][LIANGCANG].hPos == CBNULL )
	{	// û֣첽룬
		EX &= (~0x0020);
		EX &= (~0x0080);
		EXX &= (~0x0001);
		EXX &= (~0x0002);
		EXX &= (~0x0004);
	}
	if( BuildPoint[GAME.nMe][MUCAICHANG].hPos == CBNULL )
	{	// ûľĳ¥룬
		EX &= (~0x0040);
		EX &= (~0x0080);
		EXX &= (~0x0001);
		EXX &= (~0x0002);
		EXX &= (~0x0010);
	}
	if( BuildPoint[GAME.nMe][WUQICHANG].hPos == CBNULL )
	{	// û쳵
		EXX &= (~0x0001);
		EXX &= (~0x0004);
	}
	if( GAME.Players[GAME.nMe].nGrade[PLAYER_GRADE_MAIN] < 1 )
	{	// ˧û2쳵
		EXX &= (~0x0001);
		EXX &= (~0x0002);
	}

	// ӣԶܽţҪȡ
	EXX &= (~0x0010);
	EXX &= (~0x0040);
	
	// Debugֵ
	if( CTRL_bDebugCommand == TRUE )
	{
		EX = 0xFFFF; EXX = 0xFFFF;
	}
	*pnEx = EX, *pnExx = EXX;
}

// õ
void CTRL_TASK_LineUpCommand( DWORD *pnEx, DWORD *pnExx )
{
	Assert( CTRL_hitSrc[0].nID != MAP_DATA_NONE );
	struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[0].nID );
	Assert( pU );
	Assert( EYE_IfUnitIsGen( pU ) );
	Assert( DATA_Lib.Gen[pU->Gen.nID].nLevel<10 );

	int nLineUp[10] = {0x07, 0x07, 0x07, 0x3F, 0x3F, 0xFF, 0x01FF, 0x01FF, 0x01FF, 0x01FF};
	int nLineUpEx[10] = {0,0,0,0,0,0,0x103, 0x103, 0x103, 0x103};

	// debug
//	DATA_Lib.Gen[pU->Gen.nID].nLevel=9;

	*pnEx = nLineUp[DATA_Lib.Gen[pU->Gen.nID].nLevel];
	*pnExx = nLineUpEx[DATA_Lib.Gen[pU->Gen.nID].nLevel];

	// Debugֵ
	if( CTRL_bDebugCommand == TRUE )
	{
		*pnEx = 0xFFFF; *pnExx = 0xFFFF;
	}
}

// õı
void CTRL_TASK_StrategemCommand( DWORD *pnEx, DWORD *pnExx )
{
	Assert( CTRL_hitSrc[0].nID != MAP_DATA_NONE );
	struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[0].nID );
	Assert( pU );
	Assert( EYE_IfUnitIsGen( pU ) );
	Assert( DATA_Lib.Gen[pU->Gen.nID].nLevel<10 );

	int nStrategy[10] = {0x00, 0x01, 0x0181, 0x01C1, 0x01C9, 0x01CF, 0x01EF, 0x01FF, 0x01FF, 0x01FF};

	// debug
//	DATA_Lib.Gen[pU->Gen.nID].nLevel = 6;

	*pnEx = nStrategy[DATA_Lib.Gen[pU->Gen.nID].nLevel];
	*pnExx = 0;

	// Debugֵ
	if( CTRL_bDebugCommand == TRUE )
	{
		*pnEx = 0xFFFF; *pnExx = 0xFFFF;
	}
}

// 귢
// ֻCTRL_hitDestnTaskID, nTaskIDEx, (nParam1)
// detect command message, set it and its attributes
// dwMessage	:	message ID
// return value	:	TRUE if detect it, and it is valid
BOOL CTRL_TASK_AssembleCmd( DWORD dwMessage, UINT lParam )
{
	// if no source object of TASK exists, exit
	if( CTRL_nHitCounter == 0 )	return FALSE;

	CTRL_TASK_ClearAssembleDest();

// only for control command message
	if( dwMessage == BUTTON_CANCEL )
	{	// ȡ
		if( BUILD_IfEnable() )
		{	// Ѱҽλõʱ
			// reset command unit array
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
			BUILD_Enable( FALSE );
		}
		else if( CTRL_nHitCounter > 1 )
		{// ʱʹ
		}
		else
		{
			Assert( CTRL_nHitCounter == 1 );
			Assert( CTRL_hitSrc[0].nID != MAP_DATA_NONE );
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
			Assert( pUnit );
			Assert( EYE_IfUnitIsBuild( pUnit ) );
			Assert( (pUnit->Status.bIRQ == TRUE && pUnit->Status.bDone == FALSE )
				|| (pUnit->Status.bDone == TRUE && pUnit->Status.bIRQ == FALSE) );
			if( pUnit->Status.nTaskID == JIANZAOZHONG )
			{
				// ֹٳֵһոɣδü
				if( pUnit->Status.bDone == FALSE )	
				{
					CTRL_hitDest.nTaskID = QXJIANZAO;
					CTRL_hitDest.nTaskIDEx = pUnit->Status.nTaskIDEx;
					CTRL_hitDest.bIRQ = TRUE;	// ǿж
					CTRL_hitDest.bDone = TRUE;	// 
				}
			}
			else if( pUnit->Status.nTaskID == SHENGCHAN )
			{
				// ֹٳֵһոɣδü
				if( pUnit->Status.bDone == FALSE )
				{
					CTRL_hitDest.nTaskID = QXSHENGCHAN;
					CTRL_hitDest.nTaskIDEx = pUnit->Status.nTaskIDEx;
					CTRL_hitDest.bIRQ = TRUE;	// ǿж
					CTRL_hitDest.bDone = TRUE;	// 
				}
			}
			else if( pUnit->Status.nTaskID == TISHENG )
			{
				// ֹٳֵһոɣδü
				if( pUnit->Status.bDone == FALSE )
				{
					CTRL_hitDest.nTaskID = QXTISHENG;
					CTRL_hitDest.nTaskIDEx = pUnit->Status.nTaskIDEx;
					CTRL_hitDest.bIRQ = TRUE;	// ǿж
					CTRL_hitDest.bDone = TRUE;	// 
				}
			}
		}
	}
	// ˧16030-16036
	else if( dwMessage >= BUTTON_MAIN_PEASANT
		&& dwMessage <= BUTTON_LIU_MAIN_UPGRADE3 )
	{
		if( dwMessage == BUTTON_MAIN_PEASANT )
		{
			CTRL_hitDest.nTaskID = SHENGCHAN;
			CTRL_hitDest.nTaskIDEx = 30;	// ˣ ļ
			CTRL_hitDest.bDone = TRUE; // 
		}
		else
		{
			CTRL_hitDest.nTaskID = TISHENG;	// 
			CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_CHAO_MAIN_UPGRADE1;
			//	-GAME.Players[GAME.nMe].nBuildType*3;
			Assert( CTRL_hitDest.nTaskIDEx < 6 );
			if( CTRL_hitDest.nTaskIDEx >= 3 )
				CTRL_hitDest.nTaskIDEx -= 3;
			CTRL_hitDest.nTaskIDEx2 = dwMessage;	// Ϣ
			Assert( CTRL_hitDest.nTaskIDEx < 3 );
			// ǷǮ
			if( RUN_UPGRADE_IfEnoughMoney( GAME.nMe, CTRL_hitDest.nTaskIDEx ) )
				CTRL_hitDest.bDone = TRUE;	// 
		}
	}
	// ľĳ16040-16042
	else if( dwMessage >= BUTTON_LUMBER_UPGRADEBOW1
		&& dwMessage <= BUTTON_LUMBER_UPGRADEBOW3 )
	{
		CTRL_hitDest.nTaskID = TISHENG;	// 
		CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_LUMBER_UPGRADEBOW1 + 3;
		CTRL_hitDest.nTaskIDEx2 = dwMessage;	// Ϣ
		// ǷǮ
		if( RUN_UPGRADE_IfEnoughMoney( GAME.nMe, CTRL_hitDest.nTaskIDEx ) )
			CTRL_hitDest.bDone = TRUE;	// 
	}
	// 16050-16055
	else if( dwMessage >= BUTTON_WEAPONFACTORY_UPGRADEWEAPON1
		&& dwMessage <= BUTTON_WEAPONFACTORY_UPGRADEARMOR3 )
	{
		CTRL_hitDest.nTaskID = TISHENG;	// ͷ
		CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_WEAPONFACTORY_UPGRADEWEAPON1 + 6;
		CTRL_hitDest.nTaskIDEx2 = dwMessage;	// Ϣ
		// ǷǮ
		if( RUN_UPGRADE_IfEnoughMoney( GAME.nMe, CTRL_hitDest.nTaskIDEx ) )
			CTRL_hitDest.bDone = TRUE;	// 
	}
	// Ǯׯ16060-16065
	else if( dwMessage >= BUTTON_SHOP_SALE100WOOD
		&& dwMessage <= BUTTON_SHOP_SALE1000IRON )
	{
		CTRL_hitDest.nTaskID = TISHENG;	// ԴǮ
		CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_SHOP_SALE100WOOD + 12;
		CTRL_hitDest.nTaskIDEx2 = dwMessage;	// Ϣ
		// ǷǮ
		if( RUN_UPGRADE_IfEnoughMoney( GAME.nMe, CTRL_hitDest.nTaskIDEx ) )
			CTRL_hitDest.bDone = TRUE;	// 
	}
	// 16070-16081
	else if( dwMessage >= BUTTON_FOOTMANSCHOOL_100
		&& dwMessage <= BUTTON_FOOTMANSCHOOL_1000 )
	{
		CTRL_hitDest.nTaskID = SHENGCHAN;	
		// 
		CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_FOOTMANSCHOOL_100 + 32;
		CTRL_hitDest.bDone = TRUE;	// 
	}
	// 16090-16093
	else if( dwMessage >= BUTTON_KNIGHTSCHOOL_100
		&& dwMessage <= BUTTON_KNIGHTSCHOOL_500 )
	{
		CTRL_hitDest.nTaskID = SHENGCHAN;
		// 
		CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_KNIGHTSCHOOL_100 + 36;
		CTRL_hitDest.bDone = TRUE;	// 
	}
	// 16101-16108
	else if( dwMessage >= BUTTON_BOWMANSCHOOL_200
		&& dwMessage <= BUTTON_BOWMANSCHOOL_100 )
	{
		CTRL_hitDest.nTaskID = SHENGCHAN;
		// 
		CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_BOWMANSCHOOL_200 + 39;
		CTRL_hitDest.bDone = TRUE;	// 
	}
	// 16110-16112
	else if( dwMessage >= BUTTON_VEHICLEMANSCHOOL_VEHICLEMAN
		&& dwMessage <= BUTTON_VEHICLEMANSCHOOL_UPGRADE2 )
	{
		if( dwMessage == BUTTON_VEHICLEMANSCHOOL_VEHICLEMAN )
		{
			CTRL_hitDest.nTaskID = SHENGCHAN;
			CTRL_hitDest.nTaskIDEx = 34;	// 
			CTRL_hitDest.bDone = TRUE;	// 
		}
		else
		{
			CTRL_hitDest.nTaskID = TISHENG;	// 
			CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_VEHICLEMANSCHOOL_UPGRADE1 + 18;
			CTRL_hitDest.nTaskIDEx2 = dwMessage;	// Ϣ
			// ǷǮ
			if( RUN_UPGRADE_IfEnoughMoney( GAME.nMe, CTRL_hitDest.nTaskIDEx ) )
				CTRL_hitDest.bDone = TRUE;	// 
		}
	}
	// 촬16120-16126
	else if( dwMessage >= BUTTON_SHIPYARD_DESTROYER
		&& dwMessage <= BUTTON_SHIPYARD_UPGRADESHIPARMOR )
	{
		if( dwMessage >= BUTTON_SHIPYARD_DESTROYER &&
			dwMessage <= BUTTON_SHIPYARD_GROUPSHIP )
		{
			CTRL_hitDest.nTaskID = SHENGCHAN;
			// 
			CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_SHIPYARD_DESTROYER + 46;
			CTRL_hitDest.bDone = TRUE;	// 
		}
		else
		{
			CTRL_hitDest.nTaskID = TISHENG;	// 
			CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_SHIPYARD_UPGRADEDESTROYER + 20;
			CTRL_hitDest.nTaskIDEx2 = dwMessage;	// Ϣ
			// ǷǮ
			if( RUN_UPGRADE_IfEnoughMoney( GAME.nMe, CTRL_hitDest.nTaskIDEx ) )
				CTRL_hitDest.bDone = TRUE;	// 
		}
	}
	// Ԫ16130-16145
	else if( dwMessage >= BUTTON_MOVE
		&& dwMessage <= BUTTON_BACK )
	{
		// set command
		// ʱ
//		OutputDebugString( "CTRL_TASK : Command received: " );
//		OutputString( dwMessage, "\n" );

		switch( dwMessage )
		{
		case	BUTTON_MOVE:	// ƶ
			CTRL_hitDest.nTaskID = YIDONG;
			break;
		case	BUTTON_ATTACK:	// 
			CTRL_hitDest.nTaskID = GONGJI;
			//״
			MOUSE_SetState( MOUSE_STATE_GONGJI );
			break;
		case	BUTTON_GUARD:	// 
			CTRL_hitDest.nTaskID = FANGYU;
			CTRL_hitDest.bDone = TRUE;	// 
			break;
		case	BUTTON_LINEUP:	// 
			{
				DWORD EX, EXX;
				CTRL_TASK_LineUpCommand( &EX, &EXX );
				FACE_ShowCommandUnit( COMMANDUNIT_LINEUP_PAGEONE, EX );
			}
			break;
		case	BUTTON_REST:	// Ϣ
			CTRL_hitDest.nTaskID = XIUXI;
			CTRL_hitDest.bDone = TRUE;	// 
			break;
		case	BUTTON_STRATAGEM:	// ı
			{
				DWORD EX, EXX;
				CTRL_TASK_StrategemCommand( &EX, &EXX );
				if( EX == 0 )
				{
					//𲻹ûпʹõļı
					FACE_ShowPromptInfor( 20 ) ;
				}
				else
					FACE_ShowCommandUnit( COMMANDUNIT_STRATAGEM, EX );
			}
			break;
		case	BUTTON_DISMISS:		// ɢ
			CTRL_hitDest.nTaskID = JIESAN;
			CTRL_hitDest.bDone = TRUE; // 
			break;
		case	BUTTON_SINGLE:		// 
			if( GAME_bNetwork == FALSE )	// ޵
			{
				struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
				Assert( pUnit );
				Assert( EYE_IfUnitIsGen( pUnit ) );
				if( pUnit->Draw.nFile == 52 )
				{
					//ˮ첻ܵ
					FACE_ShowPromptInfor( 21 ) ;
					break;	// ˮ죬ܵ
				}

				if( GAME.bFightEnabled == TRUE )	// Enable fight single
					CTRL_hitDest.nTaskID = DANTIAO;
				else
				{
					//عرˣܵ
					FACE_ShowPromptInfor( 23 ) ;
				}
			}
			break;
		case	BUTTON_TRANSPORT:	// 
			CTRL_hitDest.nTaskID = YUNSONG;
			//״
			MOUSE_SetState( MOUSE_STATE_YUNSONG );
			break;
		case	BUTTON_CHAO_BUILD:	// ܲٷ
			{
				DWORD EX, EXX;
				CTRL_TASK_WorkerCommand( &EX, &EXX );
				FACE_ShowCommandUnit( COMMANDUNIT_CHAO_BUILD_PAGEONE, EX );
			}
			break;
		case	BUTTON_LIU_BUILD:	// 
			{
				DWORD EX, EXX;
				CTRL_TASK_WorkerCommand( &EX, &EXX );
				FACE_ShowCommandUnit( COMMANDUNIT_LIU_BUILD_PAGEONE, EX );
			}
			break;
		case	BUTTON_REPAIR:		// 
			CTRL_hitDest.nTaskID = XIULI;
			break;
		case	BUTTON_SHIP:		// 
			CTRL_hitDest.nTaskID = YUNZAI;
			break;
		case	BUTTON_UNSHIP:		// ж
			CTRL_hitDest.nTaskID = XIEZAI;

			// ڰֱжأƶ
			{
				struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
				Assert( pUnit );
				Assert( CTRL_nHitCounter == 1 );
				Assert( EYE_IfUnitIsTransport( pUnit ) );
				if( EYE_IfNearBank( pUnit->Draw.nLayer, pUnit->Draw.nX,
					pUnit->Draw.nY, pUnit->Draw.nLocationSize ) )
				{
					CTRL_hitDest.nTaskIDEx2 = 1;
					CTRL_hitDest.bDone = TRUE;
				}
			}
			break;
/*
		case	BUTTON_ESTABLISH:	// 齨
			CTRL_hitDest.nTaskID = ZUJIAN;
			CTRL_hitDest.nTaskIDEx = 1;	// 
			CTRL_hitDest.nParam1 = lParam;
			CTRL_hitDest.bDone = TRUE;	// 
			break;
*/
		case	BUTTON_JOIN:		// 
			CTRL_hitDest.nTaskID = JIARU;
			//״
			MOUSE_SetState( MOUSE_STATE_JIARU );
			break;
		case	BUTTON_BACK:
			{
				struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[0].nID );
				Assert( pU );
				Assert( EYE_IfUnitIsWorker( pU ) );
				Assert( pU->Soldier.nResType != QXZIYUAN 
					&& pU->Soldier.nResource > 0 );
				Assert( CTRL_nHitCounter == 1 );

				CTRL_hitDest.nParam1 = TY_FindNearHome(GAME.nMe,pU->Draw.nX,pU->Draw.nY,pU->Soldier.nResType);
				if( CTRL_hitDest.nParam1 == MAP_DATA_NONE )
					break;// ûҵ
				
				CTRL_hitDest.nTaskID = HUISONG;
				CTRL_hitDest.nTaskIDEx = 2;	// MOUSE_HITRESULT_UNIT
				CTRL_hitDest.nTaskIDEx2 = pU->Soldier.nResType;	// ԴͣĿĵȥ
				if( pU->Soldier.nResType == 0 
					|| pU->Soldier.nResType == 1 )
				{	// Դ
					CTRL_hitDest.nParam2 = pU->Draw.nLayer;
					CTRL_hitDest.nParam3 = pU->Draw.nX;
					CTRL_hitDest.nParam4 = pU->Draw.nY;
				}
				else
				{	// Դ
					CTRL_hitDest.nParam4 = MAP_DATA_NONE;
				}
				CTRL_hitDest.bDone = TRUE;
			}
			break;
/*
			//case	BUTTON_
		case	16070:// 1
			CTRL_hitDest.nTaskID = SHENGCHAN;
			CTRL_hitDest.nTaskIDEx = MAP_Lib.Unit[36].nItems[0];
			break;
		case	16071:// 2
			CTRL_hitDest.nTaskID = SHENGCHAN;
			CTRL_hitDest.nTaskIDEx = MAP_Lib.Unit[42].nItems[0];
			break;
		case	16053:// ɾ
			CTRL_hitDest.nTaskID = SHANCHU;
			CTRL_hitDest.bDone = TRUE;
			break;
*/
		}
	}
	// 16150-16177
	else if( dwMessage >= BUTTON_CHAO_BUILD_MAIN
		&& dwMessage <= BUTTON_LIU_BUILD_FLAG )
	{
		CTRL_hitDest.nTaskID = JIANZAO;
		CTRL_hitDest.nTaskIDEx = MOUSE_HITRESULT_GROUND;
		CTRL_hitDest.nTaskIDEx2 = dwMessage - BUTTON_CHAO_BUILD_MAIN;
		DWORD codeU = MAP_Lib.Unit[CTRL_hitDest.nTaskIDEx2].nItems[0];
		if( RUN_CREATE_IfEnoughMoney( GAME.nMe, CTRL_hitDest.nTaskIDEx2 ) )
		{
			// 
			// class CDDCursor *pCursor = CURSOR_Get();
			// Assert( pCursor );
			// pCursor->Show( FALSE );

			// set build item
			extern RECT DRAW_rcClient;
			BUILD_Set( codeU );
			BUILD_Enable( TRUE );

			// reset command unit array
			FACE_ShowCommandUnit( COMMANDUNIT_CANCEL, 0xFFFF );
		}
		else
		{
			// 
			CTRL_TASK_ClearAssembleDest();
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
		}
	}
	// 16190-16199
	else if( dwMessage >= BUTTON_LINEUP_ONE
		&& dwMessage <= BUTTON_LINEUP_TEN )
	{
		CTRL_hitDest.nTaskID = ZHENXING;
		CTRL_hitDest.nTaskIDEx = dwMessage - BUTTON_LINEUP_ONE+1;
		CTRL_hitDest.bDone = TRUE;	// 
	}
	// ı16210-16219
	else if( dwMessage >= BUTTON_STRATAGEM_ENCOURAGE
		&& dwMessage <= BUTTON_STRATAGEM_FIRE )
	{
		CTRL_hitDest.nTaskID = JIMOU;
		CTRL_hitDest.nTaskIDEx2 = dwMessage - BUTTON_STRATAGEM_ENCOURAGE+1;
		struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[0].nID );
		Assert( pU );
		Assert( EYE_IfUnitIsGen( pU ) );
		// ıԵ㹻
		if( RUN_MOULUE_IfEnough( pU, CTRL_JIMOU(CTRL_hitDest.nTaskIDEx2) ) 
			|| CTRL_bDebugCommand == TRUE )
		{
			//״
			MOUSE_SetState( MOUSE_STATE_GONGJI );
		}
		else
		{	// Ǯ
			// 
			CTRL_TASK_ClearAssembleDest();
		}
	}
	else if( dwMessage == ESTABLISH_UNIT )	// 齨
	{
//		FILE*fp=fopen("list.log", "at" );
//		fprintf( fp,"a" );
//		fclose( fp );
		//???ԭ
		if( lParam != 0 )
		{
			CTRL_hitDest.nTaskID = ZUJIAN;
//			CTRL_hitDest.nTaskIDEx = CTRL_hitSrc[0].nTaskIDEx;
			CTRL_hitDest.nParam1 = lParam;
			CTRL_hitDest.bDone = TRUE;	// 
		}
	}
	else if( dwMessage == BUTTON_LINEUP_PAGEDOWN )
	{// һҳ
		DWORD EX, EXX;
		CTRL_TASK_LineUpCommand( &EX, &EXX );
		FACE_ShowCommandUnit( COMMANDUNIT_LINEUP_PAGETWO, EXX );
	}
	else if( dwMessage == BUTTON_LINEUP_PAGEUP )
	{// һҳ
		DWORD EX, EXX;
		CTRL_TASK_LineUpCommand( &EX, &EXX );
		FACE_ShowCommandUnit( COMMANDUNIT_LINEUP_PAGEONE, EX );
	}
	else if( dwMessage == BUTTON_LIU_BUILD_PAGEDOWN )
	{// һҳ
		DWORD EX, EXX;
		CTRL_TASK_WorkerCommand( &EX, &EXX );
		FACE_ShowCommandUnit(COMMANDUNIT_LIU_BUILD_PAGETWO, EXX);
	}
	else if( dwMessage == BUTTON_LIU_BUILD_PAGEUP )
	{// һҳ
		DWORD EX, EXX;
		CTRL_TASK_WorkerCommand( &EX, &EXX );
		FACE_ShowCommandUnit(COMMANDUNIT_LIU_BUILD_PAGEONE, EX);
	}
	else if( dwMessage == BUTTON_CHAO_BUILD_PAGEDOWN )
	{// ܲٽһҳ
		DWORD EX, EXX;
		CTRL_TASK_WorkerCommand( &EX, &EXX );
		FACE_ShowCommandUnit(COMMANDUNIT_CHAO_BUILD_PAGETWO, EXX);
	}
	else if( dwMessage == BUTTON_CHAO_BUILD_PAGEUP )
	{// ܲٽһҳ
		DWORD EX, EXX;
		CTRL_TASK_WorkerCommand( &EX, &EXX );
		FACE_ShowCommandUnit(COMMANDUNIT_CHAO_BUILD_PAGEONE, EX);
	}

	if( CTRL_hitDest.bDone == TRUE )
	{
		if( CTRL_hitDest.nTaskID == SHENGCHAN 
			&& !RUN_CREATE_IfEnoughMoney( GAME.nMe, CTRL_hitDest.nTaskIDEx ) )
		{	// ʧ
			// clear destinatioin control list
			// 
			CTRL_TASK_ClearAssembleDest();
//			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
			return FALSE;
		}
		// ´
		CTRL_TASK_DeployByHuman();

		// clear destinatioin control list
		// 
		CTRL_TASK_ClearAssembleDest();
		FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
		return TRUE;
	}
	return FALSE;
}

// ĿĵԪ壩
// detect single unit to be target
// nPosX, nPosY	:	mouse hit position in pixel
// return value	:	TRUE if detected, FALSE if cancel the command, -1 if need try again
int CTRL_TASK_AssembleDest( int nPosX, int nPosY )
{
	if( CTRL_hitDest.nTaskID == QUXIAO )	return FALSE;

	Assert( !CTRL_hitDest.bDone );
	Assert( CTRL_nHitCounter > 0 );

	BOOL ret;
	POINT pt;
	pt.x = nPosX, pt.y = nPosY;
	struct MOUSE_HITRESULT_STRUCT	hitDest;
	switch(	CTRL_hitDest.nTaskID )
	{
	case	YIDONG:	// ƶ
			ret = MOUSE_HitTestUG( pt, &hitDest );
			if( ret )
			{
				CTRL_hitDest.nTaskIDEx = hitDest.nType;				// ĸ
				CTRL_hitDest.bDone = TRUE;
			}
			break;
	case	GONGJI:	// 
			// ѡ, Sep.11.1997
			ret = MOUSE_HitTestU( pt, &hitDest, TRUE );
			if( !ret )
				ret = MOUSE_HitTestU( pt, &hitDest );
			if( ret )
			{
				CTRL_hitDest.nTaskIDEx = hitDest.nType;				// ĸ
				CTRL_hitDest.bDone = TRUE;
			}
			break;
/*
	case	SHENGCHAN:	// 
			ret = MOUSE_HitTestG( pt, &hitDest );
			CTRL_hitDest.bDone = TRUE;
			break;
*/
//	case	FANGYU:	// 
//		break;
//	case	XIUXI:	// Ϣ
//		break;
	case	JIMOU:	// ı
		if( CTRL_hitDest.nTaskIDEx2 == HUOGONG )	// 
		{
			ret = MOUSE_HitTestG( pt, &hitDest );
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
			Assert( pUnit );
			if( ret == TRUE && hitDest.nLayer == 0 // ڵ0
				// Ӱ򿪣30Χ
				&& !SHADOW_IfBlanked( hitDest.ptHit.x, hitDest.ptHit.y )	
				&&	(
					(hitDest.ptHit.x > pUnit->Draw.nX - 20
					&& hitDest.ptHit.y > pUnit->Draw.nY - 20
					&& hitDest.ptHit.x < pUnit->Draw.nX + 20
					&& hitDest.ptHit.y < pUnit->Draw.nY + 20)
					|| CTRL_bDebugCommand == TRUE 
					)
				)
			{
				CTRL_hitDest.nTaskIDEx = hitDest.nType;
				CTRL_hitDest.bDone = TRUE;
			}
			else
			{	// Ŀ겻Ұ10ڣʹ
				FACE_ShowPromptInfor( 16 );
				//---- Ч
				// noselect.wav
				DATA_WAVE_EffectPlay( 99 );
				//---- Ч
				break;
			}
		}
		else
		{
		// ıԵ㹻ˣǹľһڵ0
//			if( RUN_MOULUE_IfEnough( pU, CTRL_JIMOU(CTRL_hitDest.nTaskIDEx2) ) 
//				&& !(CTRL_hitDest.nTaskIDEx2 == GUNMU && pU->Draw.nLayer == 0) )
			ret = MOUSE_HitTestU( pt, &hitDest );
			if( ret == TRUE )
			{
				struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
				Assert( pUnit );
				Assert( EYE_IfUnitIsGen( pUnit ) );
				struct UNIT_STRUCT *pU = MAP_GetUnit( hitDest.wCode );
				Assert( pU );
				// Ŀ겻ǲӣʹ
				if( EYE_IfUnitIsBuild( pU ) )
				{
					//Ŀ겻ǲӣʹ
					FACE_ShowPromptInfor( 17 );
					//---- Ч
					// noselect.wav
					DATA_WAVE_EffectPlay( 99 );
					//---- Ч
					break;
				}
				if( CTRL_bDebugCommand == FALSE )
				{
					if( EYE_IfUnitIsInSight( pUnit->nID, pU->nID, 20 ) == -1 )
					{	// Ŀ겻Ұ10ڣʹ
						FACE_ShowPromptInfor( 16 );
						//---- Ч
						// noselect.wav
						DATA_WAVE_EffectPlay( 99 );
						//---- Ч
						break;
					}
				}
				if( EYE_PlayerIsAllied( pUnit->Draw.nPlayer, pU->Draw.nPlayer ) )
				{
					if( CTRL_hitDest.nTaskIDEx2 == JIANSU 
						|| CTRL_hitDest.nTaskIDEx2 == HUNLUAN )
					{	// ĿĵصԪѣԼҪʹõǻţʹ
						// ˼ıֻڵз
						FACE_ShowPromptInfor( 14 );
						//---- Ч
						// noselect.wav
						DATA_WAVE_EffectPlay( 99 );
						//---- Ч
						break;
					}
				}
				else
				{
					if( CTRL_hitDest.nTaskIDEx2 == JILI
						|| CTRL_hitDest.nTaskIDEx2 == JIASU
						|| CTRL_hitDest.nTaskIDEx2 == YUANSHI
						|| CTRL_hitDest.nTaskIDEx2 == GUNMU
						|| CTRL_hitDest.nTaskIDEx2 == MAIFU
						|| CTRL_hitDest.nTaskIDEx2 == HUIFU )
					{	// ĿĵصԪǵˣԼҪʹõǺţʹ
						//˼ıֻڼ
						FACE_ShowPromptInfor( 13 );
						//---- Ч
						// noselect.wav
						DATA_WAVE_EffectPlay( 99 );
						//---- Ч
						break;
					}
				}

				if( CTRL_hitDest.nTaskIDEx2 == HUNLUAN )
				{	// ڻҼıһʵָ
					BOOL bSet = FALSE;
					pU = EYE_GetGeneral( pU );
					if( pU )
					{
						int ra = (DATA_Lib.Gen[pUnit->Gen.nID].nZhiLi-DATA_Lib.Gen[pU->Gen.nID].nZhiLi+100);
						int all = getrandom( 0, 100 );
						if( all < ra )
							bSet = TRUE;
					}
					else
						bSet = TRUE;	// ޽ʱΪ1
					if( bSet = FALSE )
					{
						//Ҽıʹʧ
						FACE_ShowPromptInfor( 24 );
						//---- Ч
						// noselect.wav
						DATA_WAVE_EffectPlay( 99 );
						//---- Ч
						break;
					}
				}
				CTRL_hitDest.nTaskIDEx = hitDest.nType;
				CTRL_hitDest.bDone = TRUE;
			}
		}
		break;
//	case	JIESAN:	// ɢ
//		break;
	case	YUNSONG:// 
		ret = MOUSE_HitTestUG( pt, &hitDest );
		if( ret && hitDest.nType == MOUSE_HITRESULT_GROUND )
		{	// 
			int nRes = EYE_GetGResType( hitDest.nLayer, hitDest.ptHit.x, hitDest.ptHit.y );
			if( nRes != QXZIYUAN )
			{
				CTRL_hitDest.nTaskIDEx = hitDest.nType;
				// ĸ
				CTRL_hitDest.nTaskIDEx2 = nRes;	
				// żҵID
				//add by tian yue ;
				int nBType = 0;
//				if( GAME.nMe == 2 )	// 	
//					nBType = 0;
				//CTRL_hitDest.nParam4 = TY_FindNearObject(GAME.nMe,nBType,(WORD)hitDest.ptHit.x,(WORD)hitDest.ptHit.y);
				CTRL_hitDest.nParam4 = TY_FindNearHome(GAME.nMe,(WORD)hitDest.ptHit.x,(WORD)hitDest.ptHit.y,nRes);
				if( CTRL_hitDest.nParam4 != MAP_DATA_NONE )
				{
					CTRL_hitDest.bDone = TRUE;
				}
			}
		}
		else if( ret && hitDest.nType == MOUSE_HITRESULT_UNIT )
		{
			Assert( hitDest.wCode != MAP_DATA_NONE );
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( hitDest.wCode );
			Assert( pUnit );
			int nRes = EYE_GetUResType( pUnit, GAME.nMe );	// Ϸ
			if( nRes != QXZIYUAN )
			{	// 
				CTRL_hitDest.nTaskIDEx = hitDest.nType;
				// ĸ
				CTRL_hitDest.nTaskIDEx2 = nRes;	
				// żҵID
				//add by tian yue ;
				int nBType = 0;
//				if( GAME.nMe == 2 )	// 
//					nBType = 0;
				//CTRL_hitDest.nParam4 = TY_FindNearObject(GAME.nMe,nBType, pUnit->Draw.nX, pUnit->Draw.nY );
				CTRL_hitDest.nParam4 = TY_FindNearHome(GAME.nMe,pUnit->Draw.nX, pUnit->Draw.nY,nRes);
				if( CTRL_hitDest.nParam4 != MAP_DATA_NONE )
				{
					CTRL_hitDest.bDone = TRUE;
				}
			}
		}
		break;
	case	JIANZAO:// 
		if( BUILD_IfCan() == MAP_REGION_SUCCESS )
		{
			ret = MOUSE_HitTestG( pt, &hitDest, 0 );
			if( ret )
			{
				//CTRL_hitDest.nTaskIDEx = hitDest.nType;				// ĸ
				CTRL_hitDest.bDone = TRUE;
				// ʾ
				// class CDDCursor *pCursor = CURSOR_Get();
				// Assert( pCursor );
				// pCursor->Show( TRUE );
				// hide build surface
				BUILD_Enable( FALSE );

				//---- Ч
				// place.wav
				DATA_WAVE_EffectPlay( 100 );
				//---- Ч
			}
		}
		else
		{
			// βԣ޷
			FACE_ShowPromptInfor( 15 );
			//---- Ч
			// noselect.wav
			DATA_WAVE_EffectPlay( 99 );
			//---- Ч
			return -1;
		}
		break;
	case	XIULI:	// 
		ret = MOUSE_HitTestU( pt, &hitDest );
		if( ret )
		{
			Assert( hitDest.nType == MOUSE_HITRESULT_UNIT );
			Assert( hitDest.wCode != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( hitDest.wCode );
			Assert( pU );
			// ԼͬˣĽŷ
			if( EYE_IfUnitIsBuild( pU ) 
				&& EYE_PlayerIsAllied( pU->Draw.nPlayer, GAME.nMe ) )
			{
				CTRL_hitDest.nTaskIDEx = hitDest.nType;				// ĸ
				CTRL_hitDest.bDone = TRUE;
			}
		}
		break;
//	case	ZHENXING:// 
//		break;
	case	DANTIAO:// 
		// ѡ, Sep.11.1997
		ret = MOUSE_HitTestU( pt, &hitDest, TRUE );
		if( !ret )
			ret = MOUSE_HitTestU( pt, &hitDest );
		if( ret )
		{
			Assert( CTRL_nHitCounter > 0 );
			struct UNIT_STRUCT *pUMe = MAP_GetUnit( CTRL_hitSrc[0].nID );
			Assert( pUMe );
			Assert( EYE_IfUnitIsGen( pUMe ) );
			Assert( hitDest.nType == MOUSE_HITRESULT_UNIT );
			struct UNIT_STRUCT *pU = MAP_GetUnit( hitDest.wCode );
			Assert( pU );
			pU = EYE_GetGeneral( pU );
			if( pU != NULL && pU->Draw.nFile == 52 )	// ˮ죬ܵ
			{
				//ˮ첻ܵ
				FACE_ShowPromptInfor( 21 ) ;
				//---- Ч
				// noselect.wav
				DATA_WAVE_EffectPlay( 99 );
				//---- Ч
				break;
			}
			// ǵˣͬˣҵ˱Ұ10
			if( pU != NULL
				&& !EYE_PlayerIsAllied( pU->Draw.nPlayer, GAME.nMe ) )
			{
				if( CTRL_bDebugCommand == FALSE && EYE_IfUnitIsInSight( pUMe->nID, pU->nID, 20 )==-1 )
				{
					// Ŀ겻Ұ10ڣʹ
					FACE_ShowPromptInfor( 16 );
					//̫Զܵ
					//FACE_ShowPromptInfor( 22 ) ;
					//---- Ч
					// noselect.wav
					DATA_WAVE_EffectPlay( 99 );
					//---- Ч
					break;
				}
				CTRL_hitDest.nTaskIDEx = hitDest.nType;				// ĸ
				hitDest.wCode = pU->nID;		// зID
				if( GAME.bFightEnabled == TRUE )	// Enable fight single
					CTRL_hitDest.bDone = TRUE;
			}
			else
			{
				//ѡ˽
				FACE_ShowPromptInfor( 28 ) ;
				//---- Ч
				// noselect.wav
				DATA_WAVE_EffectPlay( 99 );
				//---- Ч
			}
		}
		break;
	case	YUNZAI:	// 
		ret = MOUSE_HitTestU( pt, &hitDest );
		if( ret )
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( hitDest.wCode );
			Assert( pU );
			// ԼͬˣĴ
			if( EYE_IfUnitIsTransport( pU ) 
				&& EYE_PlayerIsAllied( pU->Draw.nPlayer, GAME.nMe ) )
			{
				// 䴬
				if( pU->Task.nTaskID != YUNZAI )
				{	// Ŀ䴬Ҳͬ´ƶ
					Assert( CTRL_nHitCounter > 0 );
					Assert( CTRL_hitSrc[0].nID != MAP_DATA_NONE );
					struct UNIT_STRUCT *pUS = MAP_GetUnit( CTRL_hitSrc[0].nID );
					Assert( pUS );
					Assert( !EYE_IfUnitIsBuild( pUS ) );
					Assert( pUS->Draw.nPlayer == GAME.nMe );

					BOOL bNoMove = FALSE;
					POINT ptNew;
					if( EYE_IfNearBank( pU->Draw.nLayer, pU->Draw.nX,
						pU->Draw.nY, pU->Draw.nLocationSize ) )
					{
						ptNew.x = pUS->Draw.nX;
						ptNew.y = pUS->Draw.nY;
						bNoMove = TRUE;
					}
					else
					{
						ptNew = MAP_FindRegion( pU->Draw.nLayer, pU->Draw.nX, pU->Draw.nY, MAP_Lib.Unit[pUS->Draw.nFile].nItems[0], pUS->nID );
						if( ptNew.x == -1 )
						{
							ptNew.x = pUS->Draw.nX;
							ptNew.y = pUS->Draw.nY;
						}
					}
					CTRL_TASK_STRUCT Task;
					CTRL_TASK_Clear( &Task );
					// Ŀĵʿλ
					Task.nID = hitDest.wCode;
					Task.nTaskID = YUNZAI;
					Task.nTaskIDEx = 1;
					Task.nParam1 = 0;
					Task.nParam2 = (WORD)ptNew.x;
					Task.nParam3 = (WORD)ptNew.y;
					if( bNoMove == TRUE )
						Task.nTaskIDEx2 = 1;
					Task.bDone = TRUE;
					CTRL_TASK_DeployByComputer( pUS->Draw.nPlayer, &Task );
				}

				Assert( hitDest.nType == MOUSE_HITRESULT_UNIT );
				CTRL_hitDest.nTaskIDEx = hitDest.nType;				// ĸ
				CTRL_hitDest.nParam1 = hitDest.wCode;
				CTRL_hitDest.bDone = TRUE;
			}
			else
			{
				// ѡԼ䴬
				FACE_ShowPromptInfor( 25 ) ;
				//---- Ч
				// noselect.wav
				DATA_WAVE_EffectPlay( 99 );
				//---- Ч
			}
		}
		break;
	case	XIEZAI:	// ж
		ret = MOUSE_HitTestG( pt, &hitDest );
		if( ret == FALSE )	break;
		Assert( ret == TRUE );
		Assert( hitDest.nType == MOUSE_HITRESULT_GROUND );
		{
			struct MAP_GROUND_CODE_STRUCT stctG;
			MAP_GroundDeCode( hitDest.wCode, &stctG );
			Assert( hitDest.wCode != MAP_DATA_NONE );
			if( !(stctG.nFile == 3 && stctG.nCol == 12 ) )
			{	// һ½
				CTRL_hitDest.nTaskIDEx = hitDest.nType;				// ĸ
				//CTRL_hitDest.nTaskIDEx2 = 0;
				CTRL_hitDest.bDone = TRUE;
			}
		}
		break;
//	case	ZUJIAN:	// 齨
//		break;
	case	JIARU:	// 룬ĳеʿҲ԰ʿ뵽ò
		ret = MOUSE_HitTestU( pt, &hitDest );
		if( ret )
		{
			Assert( hitDest.wCode != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( hitDest.wCode );
			Assert( pU );
			if( !EYE_IfSheIsMine( pU ) )
			{
				// ʱѡԼĲ
				FACE_ShowPromptInfor( 27 ) ;
				//---- Ч
				// noselect.wav
				DATA_WAVE_EffectPlay( 99 );
				//---- Ч
				ret = FALSE;
			}
			else
			{
				pU = EYE_GetGeneral( pU );
				if( pU )
				{
					hitDest.wCode = pU->nID;
					CTRL_hitDest.bDone = TRUE;
				}
				else
				{
					// ʱѡһ֧
					FACE_ShowPromptInfor( 26 ) ;
					//---- Ч
					// noselect.wav
					DATA_WAVE_EffectPlay( 99 );
					//---- Ч
				}
			}				
		}
		break;
	case	HUISONG:
		ret = MOUSE_HitTestU( pt, &hitDest );
		Assert( CTRL_nHitCounter == 1 );
		if( ret )
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( hitDest.wCode );
			Assert( pU );
			if( !EYE_IfUnitIsBuild( pU ) || !EYE_IfSheIsMine( pU ) )
				break;
			Assert( CTRL_hitSrc[0].nID!= MAP_DATA_NONE );
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
			Assert( pUnit );
			Assert( EYE_IfUnitIsWorker( pUnit ) );
			int nRes = EYE_GetUResHome( pU );
			if( nRes == pUnit->Soldier.nResType || nRes == SUOYOUZY 
				|| (nRes == MAITIAN && pUnit->Soldier.nResType == LIANGCANG) ) 
			{
				CTRL_hitDest.nTaskIDEx = MOUSE_HITRESULT_UNIT;	//2
				CTRL_hitDest.nTaskIDEx2 = pUnit->Soldier.nResType;	// Դ
				if( pUnit->Soldier.nResType == 0 
					|| pUnit->Soldier.nResType == 1 )
				{	// Դ
					CTRL_hitDest.nParam2 = pUnit->Draw.nLayer;
					CTRL_hitDest.nParam3 = pUnit->Draw.nX;
					CTRL_hitDest.nParam4 = pUnit->Draw.nY;
				}
				else
				{	// Դ
					CTRL_hitDest.nParam4 = MAP_DATA_NONE;
				}
				CTRL_hitDest.nParam1 = hitDest.wCode;		// ĿĵԪID
				Assert( CTRL_hitDest.nParam1 != MAP_DATA_NONE );
				CTRL_hitDest.bDone = TRUE;
			}
		}
		break;
//	case	TISHENG:// 
//		break;
//	case	SHANCHU:// ɾ
//		break;
//	default:
//		ret = FALSE;
	}

	if( CTRL_hitDest.bDone == TRUE )
	{
		// Warning: ´ﵫûü
		// CTRL_TASK_Main()
		// ֮ԭ
		// Ҫס

		if( hitDest.nType == MOUSE_HITRESULT_GROUND )
		{
			CTRL_hitDest.nParam1 = hitDest.nLayer;			// Ŀĵز
			CTRL_hitDest.nParam2 = WORD(hitDest.ptHit.x);	// ĿĵX
			CTRL_hitDest.nParam3 = WORD(hitDest.ptHit.y);	// ĿĵY
			Assert( CTRL_hitDest.nParam1 <= 2 
				&& CTRL_hitDest.nParam1 >= 0 );

			// ۼ˵֮󣬳һָʾ
			CTRL_MOUSE_Clip( nPosX, nPosY );
		}
		else if( hitDest.nType == MOUSE_HITRESULT_UNIT )
		{
			CTRL_hitDest.nParam1 = hitDest.wCode;			// ĿĵԪ
			Assert( CTRL_hitDest.nParam1 != MAP_DATA_NONE );
		}

		// ´
		CTRL_TASK_DeployByHuman();
	}

	// 
	CTRL_TASK_ClearAssembleDest();
	FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
	return ret;
}

// ҼʱݵǰѡеĵԪ飬ƶӦѡĿ
// nPosX, nPosY :	mouse hit position in pixel
// return value	:	TRUE if detected, FALSE if cancel the command, -1 if need try again
// 岽裺
// 1Ѿȡ
// 2.1ǽ˳
// 2.2岻Լ˳
// 3λ
// 4ĿǵΣ
//		4.1ǹ˲ӣĿǵԴΪͣĿΪ
//		4.2ΪƶĿΪ
// 6ĿǽԪǹ˲ӣ
//		6.1ĿΪԴΪͣĿΪԪ
//		6.2Ϊ
//		6.3Ϊ
// 5Ŀǵ˵ĵԪ
//		5.1A䴬Ϊƶ
//		5.1BӣΪ
//		5.2˳
// 7ΪƶĿΪԪ
BOOL CTRL_TASK_AssembleCmdDest( int nPosX, int nPosY )
{
	BOOL ret;
	POINT pt;
	pt.x = nPosX, pt.y = nPosY;
	struct MOUSE_HITRESULT_STRUCT	hitDest;
	struct UNIT_STRUCT *pUnit, *pUnitD;
	static DWORD	timeLast = 0;
	// if no source object of TASK exists, exit
	if( CTRL_nHitCounter == 0 )	return FALSE;

	// ʱӳƣֹδظط
	DWORD timeNow = timeGetTime();
	if( (timeNow - timeLast) < CTRL_TIMEDELAY_COMMAND )	
		return FALSE;
	timeLast = timeNow;

	// 1Ѿȡ
	if( CTRL_hitDest.nTaskID != QUXIAO )
	{
		if( BUILD_IfEnable() )
		{
			BUILD_Enable( FALSE );
		}
		CTRL_TASK_ClearAssembleDest();
		FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
		return FALSE;
	}

	// get unit
	pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
	Assert( pUnit );

	// 2.1ǽ˳
	if( EYE_IfUnitIsBuild( pUnit ) )	return FALSE;

	// 2.2岻Լ˳
	if( !EYE_IfSheIsMine( pUnit ) )		return FALSE;

	// 3λ
	if( EYE_IfUnitIsMovable( pUnit ) )
	{
		ret = MOUSE_HitTestU( pt, &hitDest, TRUE );
	}
	if( ret == FALSE )
		ret = MOUSE_HitTestUG( pt, &hitDest );
	if( ret == FALSE )	return FALSE;
	Assert( ret == TRUE );

	// 4ĿǵΣ
	if( hitDest.nType == MOUSE_HITRESULT_GROUND )
	{
		BOOL bSet = FALSE;
		int nBType = 0;
		if( EYE_IfUnitIsWorkerGen( pUnit )
			&& EYE_GetGResType( hitDest.nLayer, hitDest.ptHit.x, hitDest.ptHit.y ) != QXZIYUAN )
		{
			//4.1ǹ˲ӣĿǵԴΪͣĿΪ
			int nRes = EYE_GetGResType( hitDest.nLayer, hitDest.ptHit.x, hitDest.ptHit.y );
			if ( nRes == QXZIYUAN )
			{
				CTRL_hitDest.nTaskID = YIDONG;
				bSet = TRUE;
			}
			else
			{	// 
				CTRL_hitDest.nTaskID = YUNSONG;
				// ĸ
				CTRL_hitDest.nTaskIDEx2 = nRes;
				// żҵID
				//add by tian yue ;
//				if( GAME.nMe == 2 )	// 	
//					nBType = 1;
				//CTRL_hitDest.nParam4 = TY_FindNearObject(GAME.nMe,nBType,(WORD)hitDest.ptHit.x,(WORD)hitDest.ptHit.y );
				CTRL_hitDest.nParam4 = TY_FindNearHome(GAME.nMe,(WORD)hitDest.ptHit.x,(WORD)hitDest.ptHit.y,nRes);
				bSet = TRUE;
/*
				if( CTRL_hitDest.nParam4 != MAP_DATA_NONE )
				{
					bSet = TRUE;
				}
*/
			}
			CTRL_hitDest.nTaskIDEx = hitDest.nType;
		}
		// 䴬Ҵʿ
		else if( EYE_IfUnitIsTransport( pUnit ) 
			&& pUnit->Soldier.bOnBoard == TRUE )
		{	// ΪжأĿΪ
			struct MAP_GROUND_CODE_STRUCT stctG;
			MAP_GroundDeCode( hitDest.wCode, &stctG );
			Assert( hitDest.wCode != MAP_DATA_NONE );
			if( !(stctG.nFile == 3 && stctG.nCol == 12 ) )
			{	// һ½
				CTRL_hitDest.nTaskID = XIEZAI;	// ж
			}
			else
			{
				CTRL_hitDest.nTaskID = YIDONG;	// ƶ
			}
			CTRL_hitDest.nTaskIDEx = hitDest.nType;			// ĸ
			bSet = TRUE;
		}
		else
		{
			//4.2ΪƶĿΪ
			CTRL_hitDest.nTaskIDEx = hitDest.nType;			// ĸ
			CTRL_hitDest.nTaskID = YIDONG;
			bSet = TRUE;
		}
		if( bSet == TRUE )
		{
			CTRL_hitDest.nParam1 = hitDest.nLayer;			// Ŀĵز
			Assert( CTRL_hitDest.nParam1 <= 2 
				&& CTRL_hitDest.nParam1 >= 0  );
			CTRL_hitDest.nParam2 = WORD(hitDest.ptHit.x);	// ĿĵX
			CTRL_hitDest.nParam3 = WORD(hitDest.ptHit.y);	// ĿĵY
			CTRL_hitDest.bDone = TRUE;
			Assert( CTRL_hitDest.nTaskIDEx == 1 
				&& CTRL_hitDest.nTaskIDEx2 < 2 );
			// ´
			CTRL_TASK_DeployByHuman();
			// 
			CTRL_TASK_ClearAssembleDest();
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets

			// ۼ˵֮󣬳һָʾ
			CTRL_MOUSE_Clip( nPosX, nPosY );
			return TRUE;
		}
		return FALSE;
	}

	// get destination unit
	pUnitD = MAP_GetUnit( hitDest.wCode );
	Assert( pUnitD );

	Assert( hitDest.nType == MOUSE_HITRESULT_UNIT );

	// 6ĿǽԪ
	if( EYE_IfUnitIsBuild( pUnitD ) )
	{
		BOOL bSet = FALSE;
		// ǹ˲
		if( EYE_IfUnitIsWorkerGen( pUnit ) )
		{
			int nBType=0;
			//		6.1ĿΪԴΪͣĿΪԪ
			int nRes = EYE_GetUResType( pUnitD, pUnit->Draw.nPlayer );
			if( nRes != QXZIYUAN )
			{	// Ԫ
				CTRL_hitDest.nTaskID = YUNSONG;
				// ĸ
				CTRL_hitDest.nTaskIDEx2 = nRes;
				Assert( CTRL_hitDest.nTaskIDEx2 > 1 );
				// żҵID
				//add by tian yue ;
	//			if( GAME.nMe == 2 )	// 	
	//				nBType = 0;
				//CTRL_hitDest.nParam4 = TY_FindNearObject(GAME.nMe,nBType, pUnitD->Draw.nX, pUnitD->Draw.nY );

				CTRL_hitDest.nParam4 = TY_FindNearHome(GAME.nMe,pUnitD->Draw.nX,pUnitD->Draw.nY,nRes);
				if( CTRL_hitDest.nParam4 != MAP_DATA_NONE )
				{
					bSet = TRUE;
				}
			}
			// Լ
			else if( EYE_IfSheIsMine( pUnitD ) )
			{
				//		6.2Ϊ
				CTRL_hitDest.nTaskID = XIULI;
				bSet = TRUE;
			}
		}
		if( bSet == TRUE )
		{
			CTRL_hitDest.nTaskIDEx = MOUSE_HITRESULT_UNIT;	//2
			CTRL_hitDest.nParam1 = hitDest.wCode;		// ĿĵԪID
			Assert( CTRL_hitDest.nParam1 != MAP_DATA_NONE );
			CTRL_hitDest.bDone = TRUE;

			// ´
			CTRL_TASK_DeployByHuman();
			// 
			CTRL_TASK_ClearAssembleDest();
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
			return TRUE;
		}
	}

	// 5ǵ˵ĵԪ, ͬ
	//if( !EYE_IfSheIsMine( pUnitD ) )
	if( !EYE_PlayerIsAllied( GAME.nMe, pUnitD->Draw.nPlayer ) )
	{
		//	5.1ǹӣΪ
		//	5.1A䴬ֻƶ
		if( EYE_IfUnitIsTransport( pUnit ) )
		{
			CTRL_hitDest.nTaskID = YIDONG;
			CTRL_hitDest.nTaskIDEx = hitDest.nType;		// ĸ
			CTRL_hitDest.nParam1 = hitDest.wCode;		// ĿĵԪID
			Assert( CTRL_hitDest.nParam1 != MAP_DATA_NONE );
			CTRL_hitDest.bDone = TRUE;
			// ´
			CTRL_TASK_DeployByHuman();
			// 
			CTRL_TASK_ClearAssembleDest();
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
			return TRUE;
		}
		// 5.1B Ӷܹ
		else
		{
			CTRL_hitDest.nTaskID = GONGJI;
			CTRL_hitDest.nTaskIDEx = hitDest.nType;		// ĸ
			CTRL_hitDest.nParam1 = hitDest.wCode;		// ĿĵԪID
			Assert( CTRL_hitDest.nParam1 != MAP_DATA_NONE );
			CTRL_hitDest.bDone = TRUE;
			// ´
			CTRL_TASK_DeployByHuman();
			// 
			CTRL_TASK_ClearAssembleDest();
			FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
			return TRUE;
		}
		//		5.2˳
		return FALSE;
	}
	else if( EYE_IfUnitIsTransport( pUnitD ) 
		&& !EYE_IfUnitIsTransport( pUnit ) )
	{
		// 䴬
		if( pUnitD->Task.nTaskID != YUNZAI )
		{	// Ŀ䴬Ҳͬ´ƶ
			Assert( CTRL_nHitCounter > 0 );
			Assert( CTRL_hitSrc[0].nID != MAP_DATA_NONE );
			Assert( pUnit->Draw.nPlayer == GAME.nMe );

			BOOL bNoMove = FALSE;
			POINT ptNew;
			if( EYE_IfNearBank( pUnitD->Draw.nLayer, pUnitD->Draw.nX,
				pUnitD->Draw.nY, pUnitD->Draw.nLocationSize ) )
			{
				ptNew.x = pUnit->Draw.nX;
				ptNew.y = pUnit->Draw.nY;
				bNoMove = TRUE;
			}
			else
			{
				ptNew = MAP_FindRegion( pUnitD->Draw.nLayer, pUnitD->Draw.nX, pUnitD->Draw.nY, MAP_Lib.Unit[pUnit->Draw.nFile].nItems[0], pUnit->nID );
				if( ptNew.x == -1 )
				{
					ptNew.x = pUnit->Draw.nX;
					ptNew.y = pUnit->Draw.nY;
				}
			}

			CTRL_TASK_STRUCT Task;
			CTRL_TASK_Clear( &Task );
			// Ŀĵʿλ
			Task.nID = hitDest.wCode;
			Task.nTaskID = YUNZAI;
			Task.nTaskIDEx = 1;
			Task.nParam1 = 0;
			Task.nParam2 = (WORD)ptNew.x;
			Task.nParam3 = (WORD)ptNew.y;
			if( bNoMove == TRUE )
				Task.nTaskIDEx2 = 1;
			Task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
		}

		// Լ䴬´
		CTRL_hitDest.nTaskID = YUNZAI;
		CTRL_hitDest.nTaskIDEx = hitDest.nType;		// ĸ
		CTRL_hitDest.nParam1 = hitDest.wCode;		// ĿĵԪID
		Assert( CTRL_hitDest.nParam1 != MAP_DATA_NONE );
		CTRL_hitDest.bDone = TRUE;
		// ´
		CTRL_TASK_DeployByHuman();
		// 
		CTRL_TASK_ClearAssembleDest();
		FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
		return TRUE;
	}

// 7ΪƶĿΪԪ
	CTRL_hitDest.nTaskID = YIDONG;
	CTRL_hitDest.nTaskIDEx = hitDest.nType;		// ĸ
	CTRL_hitDest.nParam1 = hitDest.wCode;		// ĿĵԪID
	Assert( CTRL_hitDest.nParam1 != MAP_DATA_NONE );
	CTRL_hitDest.bDone = TRUE;
	// ´
	CTRL_TASK_DeployByHuman();
	// 
	CTRL_TASK_ClearAssembleDest();
	FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
	return TRUE;
}

// Ļ󷽵ĲӰť
BOOL CTRL_TASK_NumberButton( WORD wParam, UINT lParam )
{
	int i;
	if( wParam >= BUTTON_NUMBER_1
		&& wParam <= BUTTON_NUMBER_20 )
	{
		struct UNIT_STRUCT *pU,*pGen;
		// 
		CTRL_TASK_ClearAssembleSrc();

		// ý
		int nGroup = wParam - BUTTON_NUMBER_1;
		WORD codeU = GAME.Players[GAME.nMe].wGroup[nGroup];
		Assert( codeU != MAP_DATA_NONE );
		Assert( CTRL_nHitCounter == 0 );
		CTRL_hitSrc[CTRL_nHitCounter].nID = codeU;
		CTRL_nHitCounter++;
		pGen = MAP_GetUnit( codeU );
		Assert( pGen );
		Assert( EYE_IfUnitIsGen( pGen ) );
		pGen->Draw.bUpdate = TRUE;	// ý

		//ADDED BY TIAN YUE
		AutoAttackClear();
		AutoAttack[1]=pGen->nID;
		WORD j=2;

		for( i = 0; i< GENERAL_TROOP_MAX; i++ )
		{
			if( pGen->Gen.wTroop[i] != MAP_DATA_NONE )
			{
				CTRL_hitSrc[CTRL_nHitCounter].nID = pGen->Gen.wTroop[i];
				CTRL_nHitCounter++;
				pU = MAP_GetUnit( pGen->Gen.wTroop[i] );
				Assert( pU );
				Assert( EYE_IfUnitIsSoldier( pU ) );
				pU->Draw.bUpdate = TRUE;

				//added by tian yue
				AutoAttack[j]=pGen->Gen.wTroop[i];
				j++;
			}
		}
		//added by tian yue
		AutoAttack[0]=(j-1);

		// ԸòΪƶĻ
		if( lParam == 1 )
		{
			POINT pt;
			pt.x = pGen->Draw.nX, pt.y = pGen->Draw.nY;
			DRAW_JumpScreen( pt );
		}

		// ýϢ
		struct	PROMPT_BLOCK	temp;
		temp.PromptBlockId = PROMPT_UNIT;
		DATA_GENERAL_STRUCT *pGenData = &DATA_Lib.Gen[pGen->Gen.nID];
		temp.PromptBlockUnion.Unit.GeneralBitmapId=pGen->Gen.nID;				// ͼƬ
		temp.PromptBlockUnion.Unit.GeneralPower=EYE_GetWuLi( pGen->Gen.nID )*100/120;
		temp.PromptBlockUnion.Unit.GeneralBlood=
			pGen->nLife*100/EYE_GetFullLife( pGen->Draw.nPlayer, pGen->Draw.nFile );			// ֵ200
		strcpy( temp.PromptBlockUnion.Unit.GeneralName, pGenData->strName );	// 

		// 
		EYE_GetLevelName( pGen->Gen.nID, temp.PromptBlockUnion.Unit.Office ); // 

		temp.PromptBlockUnion.Unit.Experience = pGenData->nJingYan;		// 
		temp.PromptBlockUnion.Unit.Ruse = pGenData->nMouLue;			// ı
		temp.PromptBlockUnion.Unit.UnitMorale = EYE_GetMorale( pGen );	// ʿ
		temp.PromptBlockUnion.Unit.UnitLineUp = pGen->Gen.nLineUp;		// 
		// õʿ
		temp.PromptBlockUnion.Unit.NumberOfSolider = CTRL_GetFocusSoldierNumber();

		FACE_ShowPromptBlock( temp );

		if( EYE_IfSheIsMine( pGen ) )
		{
			// ԼĹ˲
			// Ϊȡ
			if( pGen->Status.bIRQ == TRUE )
			{
				CTRL_TASK_saveCmdUnit.Busy = 1;
			}
			else
			{
				CTRL_TASK_saveCmdUnit.Busy = 0;
			}
			if( EYE_IfUnitIsWorkerGen( pGen ) )
			{	// ݽýڻ⽨
				if( GAME.Players[GAME.nMe].nBuildType == 0 )
					CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_CHAO_PEASANT;
				else
					CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_LIU_PEASANT;
				CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			}
			// Լսù
			else
			{
				CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_FIGHTUNIT;
				//CTRL_TASK_saveCmdUnit.Ex = 0x0067;
				CTRL_TASK_saveCmdUnit.Ex = 0xFFFF;
			}

			if( CTRL_TASK_saveCmdUnit.Busy == 1 )
			{
				FACE_ShowCommandUnit( COMMANDUNIT_NONE, 0xFFFF ); // clear command sets
			}
			else
			{
				FACE_ShowCommandUnit( CTRL_TASK_saveCmdUnit.Cmd, CTRL_TASK_saveCmdUnit.Ex ); // clear command sets
			}
		}
		CTRL_TASK_ClearAssembleDest();
		return TRUE;
	}
	else
		return FALSE;
}

// send the whole command set to TASK Current List
// also send this command to all the players over the network
// ´
// must be send by human player, computer uses another function
void CTRL_TASK_DeployByHuman()
{

	// УǷϷ
#ifdef	_DEBUG
	if( CTRL_TASK_Reading )
		OutputDebugString( "CTRL_TASK Warning(3): Send command while reading!\n" );
	
	struct CTRL_TASK_STRUCT *pTask = &CTRL_hitDest;

	if( pTask->nTaskIDEx == 2 )
	{
		Assert( pTask->nParam1 != MAP_DATA_NONE );
	}
	else if( pTask->nTaskIDEx == 1 ) 
	{
		Assert( pTask->nParam1 <= 2 );	// 
		Assert( pTask->nParam2 <= MAP_Lib.szNum.cx );	// 
		Assert( pTask->nParam3 <= MAP_Lib.szNum.cy );	// 
		Assert( pTask->nParam2 != 65535 );
	}

	pTask->nID = CTRL_hitSrc[0].nID;
	struct UNIT_STRUCT *pUMe = MAP_GetUnit( pTask->nID );
	Assert( pUMe );
	Assert( !EYE_IfUnitIsDead( pUMe ) );

	// ڽһҪж
	if( pUMe->nHasShadow == 0 )
	{
		Assert( pUMe->Status.bIRQ == TRUE );
	}

	switch( pTask->nTaskID )
	{
	case QUXIAO:
		Assert( pTask->nTaskID != QUXIAO );
		break;

	case	YUNSONG:
		// Ƿǹ˲
		Assert( EYE_IfUnitIsWorkerGen( pUMe ) );

		if( pTask->nTaskIDEx == 1 )
		{
			Assert( pTask->nTaskIDEx2 == 0
					|| pTask->nTaskIDEx2 == 1 );
			// ǷõصǵԴ
			Assert( EYE_GetGResType( pTask->nParam1, pTask->nParam2, pTask->nParam3 ) != QXZIYUAN );
		}
		else
		{
			Assert( pTask->nTaskIDEx == 2 );
			// ǷõԪǽԴ
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			Assert( pTask->nTaskIDEx2 == 2
					|| pTask->nTaskIDEx2 == 3 
					|| pTask->nTaskIDEx2 == 4 );
			Assert( !EYE_IfUnitIsDead( pU ) );
			Assert( EYE_GetUResType( pU, pUMe->Draw.nPlayer ) != QXZIYUAN );
		}
		{
			// Ƿм
			if( pTask->nParam4 != MAP_DATA_NONE )
			{
				Assert( pTask->nParam4 != MAP_DATA_NONE );
				struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam4 );
				Assert( pU );
				Assert( EYE_IfUnitIsBuild( pU ) );
				Assert( !EYE_IfUnitIsDead( pU ) );
			}
			//Assert( pU->Draw.nFile == 0 || pU->Draw.nFile == 1 );	// temp
		}
		break;
	case	HUISONG:
		// Ƿǹ˲
		Assert( EYE_IfUnitIsWorker( pUMe ) );
		Assert( CTRL_nHitCounter == 1 );

		Assert( pTask->nTaskIDEx == 2 );
		{
			// ǷмңҪĿĵؽ
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			Assert( !EYE_IfUnitIsDead( pU ) );
			Assert( EYE_IfUnitIsBuild( pU ) );
			//Assert( pU->Draw.nFile == 0 || pU->Draw.nFile == 1 );	// temp
		}
		
		if( pTask->nTaskIDEx2 == 0 
			|| pTask->nTaskIDEx2 == 1 )
		{	// Դ
			// Ƿ񱣴·
			Assert( pTask->nParam2 <= 2 );	// 
			Assert( pTask->nParam3 <= MAP_Lib.szNum.cx );	// 
			Assert( pTask->nParam4 <= MAP_Lib.szNum.cy );	// 
		}
		else if( pTask->nParam4 != MAP_DATA_NONE )	// м
		{	// Դ
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam4 );
			Assert( pU );
			Assert( !EYE_IfUnitIsDead( pU ) );
			Assert( EYE_GetUResType( pU, pUMe->Draw.nPlayer ) != QXZIYUAN );
		}
		break;
	case	GONGJI:
		Assert( !EYE_IfUnitIsBuild( pUMe )
			|| EYE_IfUnitIsTower( pUMe ) );
		Assert( pUMe->Draw.nFile != 47 
			&& pUMe->Draw.nFile != 27 
			&& pUMe->Draw.nFile != 28 );
		Assert( pTask->nTaskIDEx == 2);
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			Assert( !EYE_IfUnitIsDead( pU ) );
			//Assert( pTask->nParam1 != pTask->nID );
		}
		break;
	case	YIDONG:
		break;
	case	JIANZAO:
		// pTask->nTaskIDEx2ǽ͵ID
		// pTask->nParam1ǽID
		Assert( (pTask->nTaskIDEx == 1 && 
			pTask->nTaskIDEx2 >=0 && pTask->nTaskIDEx2 < 27) 
			|| (pTask->nTaskIDEx == 2 && pTask->nParam1 != MAP_DATA_NONE ) );
		break;
	case	SHENGCHAN:
		// ʿ͵ID
		Assert( pTask->nTaskIDEx >=27 && pTask->nTaskIDEx < 53 );
		break;
	case	SHANCHU:
		Assert( pTask->nTaskIDEx == 0 || pTask->nTaskIDEx == 1 );
		// ɾһҪǿִ
		Assert( pTask->bIRQ == TRUE );	
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nID );
			Assert( pU );
			Assert( pU->Status.nTaskID != SHANCHU );
			WORD codeG = MAP_GetUnitDataEx( pU->Draw.nX, pU->Draw.nY );
			Assert( codeG != MAP_DATA_NONE );
		}
		break;
	case	ZUJIAN:
		Assert( pTask->nParam1 != MAP_DATA_NONE );
		if( pUMe->nID != 0 )
			Assert( EYE_IfUnitIsSoldier( pUMe ) );
		break;
	case	JIARU:
		Assert( pTask->nParam1 != MAP_DATA_NONE );
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			Assert( EYE_IfUnitIsGen( pU ) );
			Assert( pU->Draw.nPlayer == pUMe->Draw.nPlayer );
		}
		break;
	case	JIESAN:
		break;
	case	YUNZAI:
		if( pTask->nTaskIDEx == 2 )
		{
			Assert( !EYE_IfUnitIsBuild( pUMe ) );
			Assert( pTask->nParam1 != MAP_DATA_NONE );
			{
				struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
				Assert( pU );
				Assert( EYE_IfUnitIsTransport( pU ) );
			}
		}
		else
		{
			Assert( EYE_IfUnitIsTransport( pUMe ) );
			Assert( pTask->nParam1 != MAP_DATA_NONE );
			{
				struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
				Assert( pU );
				Assert( !EYE_IfUnitIsBuild( pU ) );
			}
		}
/*
		if( !EYE_IfUnitIsTransport( pUMe ) )
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) 
				|| EYE_IfUnitIsGen( pU ) );
		}
*/
		break;
	case	XIEZAI:
		Assert( EYE_IfUnitIsTransport( pUMe ) );

		if( pTask->nTaskIDEx2 == 0 )
		{
			Assert( pTask->nTaskIDEx == 1 );
		}
		break;
	case	TISHENG:
		Assert( EYE_IfUnitIsBuild( pUMe ) );
		Assert( pTask->nTaskIDEx >= 0 && pTask->nTaskIDEx < 23 );
		break;
	case	ZHENXING:
		Assert( EYE_IfUnitIsGen( pUMe ) );
		Assert( pTask->nTaskIDEx >=0 && pTask->nTaskIDEx < 10 );
		break;
	case	JIMOU:
		Assert( EYE_IfUnitIsGen( pUMe ) );
		Assert( pTask->nTaskIDEx >=0 && pTask->nTaskIDEx < 10 );
		break;
	}
#endif	//_DEBUG

	// 
	struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
	Assert( pUnit );
	Assert( !EYE_IfUnitIsDead( pUnit ) );
	CTRL_SOUND_doIt( pUnit->Draw.nFile );

	// ˸Ч
	if( CTRL_hitDest.nTaskIDEx == 2 )	// ĿĵǵԪ
	{
		// õID
		Assert( CTRL_hitDest.nParam1 != MAP_DATA_NONE );
		struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitDest.nParam1 );
		Assert( pU );
		if( DRAW_BLINK_nID != MAP_DATA_NONE )
		{	// ѾɵĵԪȡ
			struct UNIT_STRUCT *pU = MAP_GetUnit( DRAW_BLINK_nID );
			Assert( pU );
			pU->Draw.bUpdate = DRAW_BLINK_nSave;
			DRAW_BLINK_nID = MAP_DATA_NONE;
		}
		DRAW_BLINK_nSave = pU->Draw.bUpdate;	// ԭ״̬
		if( EYE_IfSheIsMine( pU ) )
			pU->Draw.bUpdate = 6;	// ñ־
		else if( EYE_PlayerIsAllied( GAME.nMe, pU->Draw.nPlayer ) )
			pU->Draw.bUpdate = 8;
		else
			pU->Draw.bUpdate = 7;
		DRAW_BLINK_nID = CTRL_hitDest.nParam1;
		DRAW_BLINK_nCounter = 0;
		DRAW_BLINK_nDelay = 0;
		DRAW_BLINK_bDraw = TRUE;
	}

	CTRL_hitDest.nLevel = 5;// ˷Ƚϸ

	// ƶӵƶҪĿĵ
	if( CTRL_hitDest.nTaskID == YIDONG 
		&& CTRL_hitDest.nTaskIDEx == 1
		&& EYE_IfUnitIsGen( pUnit ) )
	{
		int nEndx =	CTRL_hitDest.nParam2;
		int nEndy = CTRL_hitDest.nParam3;
		for( int i=CTRL_nHitCounter-1; i>=0; i-- )
		{
			CTRL_hitDest.nID = CTRL_hitSrc[i].nID;
			struct UNIT_STRUCT *pU = MAP_GetUnit( CTRL_hitSrc[i].nID );
			Assert( pU );
			int x = nEndx + pU->ptZhenFa.x;
			int y = nEndy + pU->ptZhenFa.y;
			if( x<3 )	 x = 3;
			if( x >= MAP_Lib.szNum.cx-2 ) x = MAP_Lib.szNum.cx-4;
			if( y<3 )	 y = 3;
			if( y >= MAP_Lib.szNum.cy-2 ) y = MAP_Lib.szNum.cy-3;
			CTRL_hitDest.nParam2 = WORD(x);
			CTRL_hitDest.nParam3 = WORD(y);
			// set to Current List
			CTRL_TASK_LIST_Send( GAME.nMe, &CTRL_hitDest );
//			if(GAME_bNetwork!=0)
//				{CB_SendTaskMessage(  GAME.nMe, &CTRL_hitDest );}
		}
		return;
	}

	int nSaveCounter = CTRL_nHitCounter;
	// ıֻ
	if( CTRL_hitDest.nTaskID == JIMOU 
		|| CTRL_hitDest.nTaskID == ZHENXING 
		|| CTRL_hitDest.nTaskID == DANTIAO )
		CTRL_nHitCounter = 1;

	for( int i=CTRL_nHitCounter-1; i>=0; i-- )
	{
		CTRL_hitDest.nID = CTRL_hitSrc[i].nID;

		if( (CTRL_hitDest.nTaskID == YIDONG || CTRL_hitDest.nTaskID == GONGJI)
			&& CTRL_hitDest.nTaskIDEx == 2 
			&& CTRL_hitDest.nParam1 == CTRL_hitDest.nID )
		{	// ڹƶĿĵزԼ
			return;
		}

		// set to Current List
		CTRL_TASK_LIST_Send( GAME.nMe, &CTRL_hitDest );
//		if(GAME_bNetwork!=0)
//			{CB_SendTaskMessage(  GAME.nMe, &CTRL_hitDest );}
	}

	CTRL_nHitCounter = nSaveCounter;
//	OutputDebugString( "CTRL_TASK : Deploy Counter: " );
//	OutputString( CTRL_nHitCounter, "\n" );

}

// send the whole command set to TASK List
// do not spread this command to other computers
// only used by computer
// nPlayer		:	player's ID, 0-4 are player  0-4
// pTask		:	the Task you want to send
// return vlaue	:	TRUE if there is room for the Task
void CTRL_TASK_DeployByComputer( int nPlayer, CONST struct CTRL_TASK_STRUCT *pTask )
{
	
	
	if( pTask->nTaskIDEx == 1 ) 
	{
		if( pTask->nParam1 >= 2						// 
		|| pTask->nParam2 >= MAP_Lib.szNum.cx		// X
		|| pTask->nParam3 >= MAP_Lib.szNum.cy )		// Y
		//  ƶΧ磬
		return;
	}
#ifdef	_DEBUG
	if( CTRL_TASK_Reading )
		OutputDebugString( "CTRL_TASK Warning(4): Send command while reading!\n" );

	if( pTask->nTaskIDEx == 2 )
	{
		Assert( pTask->nParam1 != MAP_DATA_NONE );
	}
	else if( pTask->nTaskIDEx == 1 ) 
	{
		Assert( pTask->nParam1 <= 2 );	// 
		Assert( pTask->nParam2 <= MAP_Lib.szNum.cx );	// X
		Assert( pTask->nParam3 <= MAP_Lib.szNum.cy );	// Y
	}

	struct UNIT_STRUCT *pUMe = MAP_GetUnit( pTask->nID );
	Assert( pUMe );

	if( EYE_IfUnitIsDead( pUMe ) )
		goto DEBUG_END;
	// ڽһҪж
	if( pUMe->nHasShadow == 0 )
	{
		Assert( pUMe->Status.bIRQ == TRUE );
	}

	switch( pTask->nTaskID )
	{
	case	YUNSONG:
		// Ƿǹ˲
		Assert( EYE_IfUnitIsWorker( pUMe )
			|| EYE_IfUnitIsWorkerGen( pUMe ) );

		if( pTask->nTaskIDEx == 1 )
		{
			Assert( pTask->nTaskIDEx2 == 0
					|| pTask->nTaskIDEx2 == 1 );
			// ǷõصǵԴ
//			Assert( EYE_GetGResType( pTask->nParam1, pTask->nParam2, pTask->nParam3 ) != QXZIYUAN );
		}
		else
		{
			Assert( pTask->nTaskIDEx == 2 );
			// ǷõԪǽԴ
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			Assert( pTask->nTaskIDEx2 == 2
					|| pTask->nTaskIDEx2 == 3
					|| pTask->nTaskIDEx2 == 4 );
//			if( !EYE_IfUnitIsDead( pU ) ) 
//				Assert( EYE_GetUResType( pU ) != QXZIYUAN );
		}
		{
			// Ƿм
//			Assert( pTask->nParam4 != MAP_DATA_NONE );
//			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam4 );
//			Assert( pU );
//			Assert( EYE_IfUnitIsBuild( pU ) );
//			Assert( !EYE_IfUnitIsDead( pU ) );
			//Assert( pU->Draw.nFile == 0 || pU->Draw.nFile == 1 );	// temp
		}
		break;
	case	HUISONG:
		// Ƿǹ˲
		Assert( EYE_IfUnitIsWorker( pUMe )
			|| EYE_IfUnitIsWorkerGen( pUMe ) );

		Assert( pTask->nTaskIDEx == 2 );
		{
			// Ƿм
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
//			Assert( EYE_IfUnitIsBuild( pU ) );
//				Assert( !EYE_IfUnitIsDead( pU ) );
			//Assert( pU->Draw.nFile == 0 || pU->Draw.nFile == 1 );	// temp
		}
		
		if( pTask->nTaskIDEx2 == 0 
			|| pTask->nTaskIDEx2 == 1 )
		{	// Դ
			// Ƿ񱣴·
			Assert( pTask->nParam2 <= 2 );	// 
			Assert( pTask->nParam3 <= MAP_Lib.szNum.cx );	// 
			Assert( pTask->nParam4 <= MAP_Lib.szNum.cy );	// 
		}
		else if( pTask->nParam4 != MAP_DATA_NONE )	// м
		{	// Դ
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam4 );
			Assert( pU );
			if( EYE_IfUnitIsDead( pU ) ) 
				Assert( EYE_GetUResType( pU, pUMe->Draw.nPlayer ) != QXZIYUAN );
		}
		break;
	case	GONGJI:
		Assert( !EYE_IfUnitIsBuild( pUMe )
			|| EYE_IfUnitIsTower( pUMe ) );
		Assert( pUMe->Draw.nFile != 47 
			&& pUMe->Draw.nFile != 27 
			&& pUMe->Draw.nFile != 28 );
		Assert( pTask->nTaskIDEx == 2);
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			//Assert( !EYE_IfUnitIsDead( pU ) );
		}
		Assert( pTask->nParam1 != pTask->nID );
		break;
	case	YIDONG:
		break;
	case	JIANZAO:
		// pTask->nTaskIDEx2ǽ͵ID
		// pTask->nParam1ǽID
		Assert( (pTask->nTaskIDEx == 1 && 
			pTask->nTaskIDEx2 >=0 && pTask->nTaskIDEx2 < 27) 
			|| (pTask->nTaskIDEx == 2 && pTask->nParam1 != MAP_DATA_NONE ) );
		break;
	case	SHENGCHAN:
		// ʿ͵ID
		Assert( pTask->nTaskIDEx >=27 && pTask->nTaskIDEx < 53 );
		break;
	case	SHANCHU:
		Assert( pTask->nTaskIDEx == 0 || pTask->nTaskIDEx == 1 );
		// ɾһҪǿִ
		Assert( pTask->bIRQ == TRUE );
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nID );
			Assert( pU );
			Assert( pU->Status.nTaskID != SHANCHU );
			WORD codeG = MAP_GetUnitDataEx( pU->Draw.nX, pU->Draw.nY );
			Assert( codeG != MAP_DATA_NONE );
		}
		break;
	case	ZUJIAN:
		Assert( pTask->nParam1 != MAP_DATA_NONE );
		Assert( EYE_IfUnitIsSoldier( pUMe ) );
		break;
	case	JIARU:
		Assert( pTask->nParam1 != MAP_DATA_NONE );
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			Assert( EYE_IfUnitIsGen( pU ) );
			Assert( pU->Draw.nPlayer == pUMe->Draw.nPlayer );
		}
		break;
	case	JIESAN:
		break;
	case	YUNZAI:
		if( pTask->nTaskIDEx == 2 )
		{
			Assert( !EYE_IfUnitIsBuild( pUMe ) );
			Assert( pTask->nParam1 != MAP_DATA_NONE );
			{
				struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
				Assert( pU );
				Assert( EYE_IfUnitIsTransport( pU ) );
			}
		}
		else
		{
			Assert( EYE_IfUnitIsTransport( pUMe ) );
//			Assert( pTask->nParam1 != MAP_DATA_NONE );
//			{
//				struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
//				Assert( pU );
//				Assert( !EYE_IfUnitIsBuild( pU ) );
//			}
		}
/*
		if( !EYE_IfUnitIsTransport( pUMe ) )
		{
			struct UNIT_STRUCT *pU = MAP_GetUnit( pTask->nParam1 );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) 
				|| EYE_IfUnitIsGen( pU ) );
		}
*/
		break;
	case	XIEZAI:
		Assert( EYE_IfUnitIsTransport( pUMe ) );

		if( pTask->nTaskIDEx2 == 0 )
		{
			Assert( pTask->nTaskIDEx == 1 );
		}
		break;
	case	TISHENG:
		Assert( EYE_IfUnitIsBuild( pUMe ) );
		Assert( pTask->nTaskIDEx >= 0 && pTask->nTaskIDEx < 23 );
		break;
	case	ZHENXING:
		Assert( EYE_IfUnitIsGen( pUMe ) );
		Assert( pTask->nTaskIDEx >=0 && pTask->nTaskIDEx < 10 );
		break;
	case	JIMOU:
		Assert( EYE_IfUnitIsGen( pUMe ) );
		Assert( pTask->nTaskIDEx >=0 && pTask->nTaskIDEx < 10 );
		break;
	}
DEBUG_END:
#endif	//_DEBUG

	if( (pTask->nTaskID == YIDONG || pTask->nTaskID == GONGJI)
		&& pTask->nTaskIDEx == 2 
		&& pTask->nParam1 == pTask->nID )
	{	// ڹƶĿĵزԼ
		return;
	}

	// set to Current List
	CTRL_TASK_LIST_Send( nPlayer, pTask );
}

// ۼ˵֮󣬳һָʾ
extern int	DRAW_OTHER_nMouseID;	// declared in CBDraw.cpp
void CTRL_MOUSE_Clip( int nX, int nY )
{
	//------------ۼ
	if( DRAW_OTHER_nMouseID != -1 )
	{	// ɾɵۼ
		OTHER_DestroyData( DRAW_OTHER_nMouseID );
		DRAW_OTHER_nMouseID = -1;
	}

	struct OTHER_STRUCT other;
	OTHER_ClearData( &other );

	other.nFile = 8;
	other.nType = OTHER_TYPE_MOUSE;
	other.nDelay = CTRL_TIMEDELAY_MOUSE;
	
	other.ptBegin.x = nX - 26 + DRAW_ptScreenOffset.x,
	other.ptBegin.y = nY - 29 + DRAW_ptScreenOffset.y;
	other.szItem.cx = MAP_Lib.Other[8].szItem.cx;
	other.szItem.cy = MAP_Lib.Other[8].szItem.cy;
	for( int i=0; i<8; i++ )
	{
		other.nCol[i] = i;
	}
	other.nMaxFrame = 8;
	DRAW_OTHER_nMouseID = OTHER_CreateDataEx( &other );
	//------------ۼ
}
//////////////////////


//////////////////////
// ʼ
// initialize
void CTRL_InitCtrl()
{
	// clear Task Lists
	for( int i=0; i< GAME_PLAYER_MAX; i++ )
	{
		CTRL_TASK_LIST_Clear( i );
		CTRL_nTaskHead[i] = 0;
		CTRL_nTaskTail[i] = 0;
	}
	// clear source objects
	for( i=0; i<CTRL_TASK_LIST_MAX-1; i++ )
		CTRL_TASK_Clear( &CTRL_hitSrc[i] );
	CTRL_nHitCounter = 0;
	// clear desination object
	CTRL_TASK_Clear( &CTRL_hitDest );
}
//////////////////////

// copy from source task to destination task
// pTo		:	Task to be copied to
// pFrom	:	Task to copying from
inline void CTRL_TASK_Copy( struct CTRL_TASK_STRUCT *pTo, CONST struct CTRL_TASK_STRUCT *pFrom )
{
	memcpy( pTo, pFrom, sizeof(struct CTRL_TASK_STRUCT) );
}

// clear Task
// pTask	:	Task to be cleared
inline void CTRL_TASK_Clear( struct CTRL_TASK_STRUCT *pTask )
{
	memset( pTask, 0, sizeof(struct CTRL_TASK_STRUCT) );
}

//////////////////////
// Set Task from Task List to unit
// task	:	Task to be set
void CTRL_TASK_SetToUnit( struct CTRL_TASK_STRUCT task )
{
	// set
	Assert( task.nID != MAP_DATA_NONE );
	struct UNIT_STRUCT *pUnit = MAP_GetUnit( task.nID );
	Assert( pUnit );

	// õԪѾκβ
	if( pUnit->nType == MAP_UNIT_TYPE_NONE )
		return;

	// ԭ״̬ǿжϵ,ҸõԪûδִе
	// ǿжϵ
	// ´Ԫ
	// Aug.6, ޸˵ֻҪԭ״̬жϻǿжϵ
	// ´Ԫ
	// ⽨콨ʱ˽ȥ
	// ȴ˼¥ڵ˹ʱǰ깤
//	if( (pUnit->Status.bIRQ == FALSE && pUnit->Task.bDone == FALSE )
//		|| task.bIRQ == TRUE )

	// ʹTaskStatus֪ʲôͬ
	// ȴһBug: ʿ˲䣬ͬһ˹
	// ܵ´ɸʿûȻѪǸ
//	if( pUnit->Status.bIRQ == FALSE || task.bIRQ == TRUE )
	if( (pUnit->Task.bIRQ == FALSE 
		&& pUnit->Status.bIRQ == FALSE)
		|| task.bIRQ == TRUE )
	{
#ifdef	_DEBUG
		// һԽ
		if( pUnit->Status.bIRQ == FALSE )
			Assert( pUnit->nHasShadow == 1 );
#endif
		CTRL_TASK_Copy( &pUnit->Task, &task );
	}
//	else
//		OutputDebugString( "cannot be terminated!\n" );
}
//////////////////////

//////////////////////
// read Task from Task List, and set it to unit
// жȡ´ӦԪ
extern void CTRL_TASK_Main()
{
#ifdef	_DEBUG
	// set flag
	CTRL_TASK_Reading = TRUE;
#endif	//_DEBUG

	// deal with the contents in the Waiting Task Lists of all the players
	struct CTRL_TASK_STRUCT task;
	for( int i=0; i< GAME_PLAYER_MAX; i++ )
	{
		while( CTRL_TASK_LIST_Peek( i, &task ) )
		{
			// got one, make Task become status
			// Model 2.1
			CTRL_TASK_SetToUnit( task );
		}
	}

#ifdef	_DEBUG
	// clear flag
	CTRL_TASK_Reading = FALSE;
#endif	//_DEBUG
}
//////////////////////

//////////////////////
// Ч
// ѡĳԪ
void CTRL_SOUND_select( int nFile )
{
	int nID=-1;
	switch( nFile )
	{
	case	0:
	case	1:// ˧
		break;
	case	2:
	case	3:// 
		// hitiron.wav
		nID = 97;
		break;
	case	4:
	case	5:// ľĳ
		// woodcut3.wav
		nID = 29;
		break;
	case	6:
	case	7:// 
		// horses03.wav
		nID = 23;
		break;
	case	8:
	case	9:// 
		// horse4.wav
		nID = 19;
		break;
	case	10:
	case	11:// 
		// rice.wav
		nID = 102;
		break;
	case	12:
	case	13:// 
		break;
	case	14:
	case	15:// 
		// arrow03.wav
//		nID = 2;
		break;
	case	16:
	case	17:// 
		break;
	case	18:
	case	19:// ¥
		break;
	case	20:// 
		// shipyard.wav
		nID = 103;
		break;
	case	22:// 
		//gstone01.wav
		nID = 15;
		break;
	case	23:// Ǯׯ
		// money.wav
		nID = 98;
		break;
	case	24:// 
	case	25:
		break;
	case	26:// 
		break;

	case	27:// Ůƽ
	case	28:// ƽ
		break;
	case	29:// Ľ
		// XG4c-4d.wav
		nID = getrandom(73,74);
		break;
	case	30:// 
		// XB4a-4d.wav
		nID = getrandom(42,45);
		break;
	case	31:// 
		// XG1c-1d.wav
		nID = getrandom(52,53);
		break;
	case	32:// 100
	case	38:// 200
	case	41:// 500
	case	43:// 1000
		// XB1a-1d.wav
		nID = getrandom(30,33);
		break;
	case	34:// 
		// XB5a-5d.wav
		nID = getrandom(46,49);
		break;
	case	35:// ｫ
		// XG3c-3d.wav
		nID = getrandom(66,67);
		break;
	case	36:// 100
	case	37:// 200
	case	40:// 500
		// XB3a-3d.wav
		nID = getrandom(38,41);
		break;
	case	33:// 
		// XG2c-2d.wav
		nID = getrandom(59,60);
		break;
	case	45:// 100
	case	39:// 200
	case	42:// 500
	case	44:// 1000
		// XB2a-2d.wav
		nID = getrandom(34,37);
		break;
	case	46:// Сս
	case	47:// 䴬
	case	48:// ս
		// boating.wav
		nID = 8;
		break;
	case	49:// 
		// boating1.wav
		nID = 89;
		break;
	case	50:// 
	case	51:// 
		break;
	case	52:// ˮ
		// XG1c-1d.wav
		nID = getrandom(52,53);
		break;
	}
	if( nID != -1 )
	{
		DATA_WAVE_EffectPlay( nID );
	}
}
// ĳԪ´
// nFile	:	Ԫļ
void CTRL_SOUND_doIt( int nFile )
{
	int nID = -1;
	switch( nFile )
	{
	case	27:// Ůƽ
	case	28:// ƽ
		break;
	case	29:// Ľ
		// XG4a-4b.wav
		nID = getrandom(71,72);
		break;
	case	30:// 
		break;
	case	31:// 
		// XG1a-1b.wav
		nID = getrandom(50,51);
		break;
	case	32:// 100
	case	38:// 200
	case	41:// 500
	case	43:// 1000
		//pmove01.wav
		nID = 25;
		break;
	case	34:// 
		// horse5.wav
		nID = 20;
		break;
	case	35:// ｫ
		// XG3a-3b.wav
		nID = getrandom(64,65);
		break;
	case	36:// 100
	case	37:// 200
	case	40:// 500
		// horses01,02.wav
		nID = getrandom(21,22);
		break;
	case	33:// 
		// XG2a-2b.wav
		nID = getrandom(57,58);
		break;
	case	45:// 100
	case	39:// 200
	case	42:// 500
	case	44:// 1000
		// pmove02.wav
		nID = 26;
		break;
	case	46:// Сս
	case	47:// 䴬
	case	48:// ս
	case	49:// 
		// boating.wav
		nID = 8;
		break;
	case	50:// 
	case	51:// 
		break;
	case	52:// ˮ
		// XG1a-1b.wav
		nID = getrandom(50,51);
		break;
	}
	if( nID != -1 )
	{
//		char tmp[32];
//		itoa( nID, tmp, 10 );
//		strcat( tmp, "\n" );
//		WriteLogFile( "sound.log", tmp );
		DATA_WAVE_EffectPlay( nID );
	}
}

// July 18. 1997
// defined in CBCTRl.cpp, debug for upgrade general for one level
// if no current general selected, do nothing
// nUp		:	1, increase the general for one level
//			:	0, decrease the general for one level
//			:	else, no effect
void CTRL_DebugGeneral( int nUp )
{
	// ûеԪѡ
	if( CTRL_nHitCounter == 0 )	
		return;
	struct UNIT_STRUCT *pUnit = MAP_GetUnit( CTRL_hitSrc[0].nID );
	Assert( pUnit );
	// ǽ
	if( !EYE_IfUnitIsGen( pUnit ) )
		return;

	if( nUp==1 && DATA_Lib.Gen[pUnit->Gen.nID].nLevel<9 )
		DATA_Lib.Gen[pUnit->Gen.nID].nLevel++;
	else if( nUp==0 && DATA_Lib.Gen[pUnit->Gen.nID].nLevel>0 )
		DATA_Lib.Gen[pUnit->Gen.nID].nLevel--;
	else	
		return;	// 

	//¼ƣֵʿ
	char strLvl[32];
	EYE_GetLevelName( pUnit->Gen.nID, strLvl );
	FACE_UpdateOffice( strLvl );

	//ҽսӢ£ն࣬һ
	if( EYE_IfSheIsMine( pUnit ) )
	{
		FACE_ShowPromptInfor( 12 );
		//---- ϶Ч
		// victory.wav
		DATA_WAVE_EffectPlay( 106 );
		//---- ϶Ч
	}
}


//////////////////////
/*int		CB_SendTaskMessage(int nPlayer, CONST struct CTRL_TASK_STRUCT *pTask)
{

	BYTE	* Temp=DP_SendMessageBuff;

	memset(DP_SendMessageBuff,0,BUFFER_MAX_BYTE-1);
	wsprintf((char *)DP_SendMessageBuff,"%d %d %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld",DP_MESSAGE,nPlayer,pTask->bDone,pTask->nID,pTask->nLevel,pTask->bIRQ,pTask->nTaskID,pTask->nTaskIDEx,pTask->nTaskIDEx2,pTask->nParam1,pTask->nParam2,pTask->nParam3,pTask->nParam4);//,(char *)pTask);
/*	i=DP_MESSAGE;
	memcpy( Temp, (void *)&i, sizeof(int) );
	Temp+= sizeof(int);

	memcpy( Temp,(void *)" ", 1 );
	Temp+=1;

	memcpy( Temp, (void *)&nPlayer, sizeof(nPlayer) );
	Temp+= sizeof( nPlayer );

	memcpy( Temp,(void *)" ", 1 );
	Temp+=1;*/

//	Temp+= 6;
//	memcpy(Temp,(void *)pTask, sizeof( CTRL_TASK_STRUCT ));

/*	if(DP_NetworkInterface(DP_SEND_MESSAGE,NULL)!=OK)
		{
			#ifdef	NETWORK
			MessageBox(NULL,"Send Counter message error!!!","Error",MB_OK);
			#endif
		}
//	WriteLogFile("test1.log",(char *)DP_SendMessageBuff);
	return(OK);

}*/
