/////////////////
// CBCtrlS.cpp	:	<< chibi >> global contral data structure
// v0014		:	Feb.16.1997,devided from CBCTRL.cpp
// v0020		:	Mar.29.1997,add most controls
// written by	:	Liu Gang
// Compiler		:	Visual C++ 4.2
// Copyright	:	WayAhead Co.Ltd.		1996-1997
/////////////////
// ļϷԿƽṹ״̬֡Ĵ
#include "stdafx.h"
#include "Assert.h"

#include "CBCTRL.h"
#include "CBShadow.h"
#include "CBMini.h"
#include "CBDATA.h"

#include "CBEyes.h"
//////////////////////
// Dong hai, о㷨
#include "March_n.h"
extern	BYTE		MARCH_TrackForward[NUMBER_OF_TRACK];//Ϊ洢о켣о·ߵķ仯
extern short		MARCH_Track[NUMBER_OF_TRACK][3];//Ϊ洢о켣

//////////////////////
// LHJ
#include "marco.h"		// BUTTON_UP BUTTON_DISABLE
#include "interfac.h"	// FACE_SetNumberButtonState(int number, int state);
#include "cbprompt.h"	// FACE_UpdateExperience(), FACE_UpdateSoldierNumber()
// LHJ
//////////////////////

//////////////////////
// externals
extern int MAP_nLocationNum[4];						// defined in CBMap.cpp
extern POINT MAP_ptLocation[2][MAP_LOCATION_MAX];	// defined in CBMap.cpp
extern int MAP_nDrawNum[4];							// defined in CBMap.cpp
//////////////////////

//////////////////////
// local functions
// ڸոմԪʹô˺ԸõԪֵ
void CTRL_SetUnitAttribute( struct UNIT_STRUCT *pUnit );
//////////////////////

//////////////////////
// ״̬
// Status
//////////////////////
// check each unit if should change Status
void CTRL_STATUS_Main()
{
	for( int i=0; i<GAME_PLAYER_MAX; i++ )
	{
#ifdef	_DEBUG
		int nCounter=0;
#endif
		for( int j=0; j<PLAYER_UNIT_MAX; j++ )
		{
			if( GAME.Players[i].Unit[j].nType != MAP_UNIT_TYPE_NONE )
			{
				CTRL_STATUS_Change( &GAME.Players[i].Unit[j] );
#ifdef	_DEBUG
				nCounter++;
#endif
			}
		}
#ifdef	_DEBUG
		if( GAME.Players[i].wUnitCounter!= nCounter )
			OutputDebugString( "CTRL_STATUS_Main Error(0): Unit number check error!\n" );
#endif
	}
}

// change the Status of the unit
// pUnit	:	the unit to be changed to
inline void CTRL_STATUS_Change( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit->nType != MAP_UNIT_TYPE_NONE );

	// ʱӦκ
	if( EYE_IfUnitIsDead( pUnit ) )	return;	// has dead

#ifdef	_DEBUG
		// ǷҪӽ
		if( pUnit->nHasShadow == 0 )
		{
			Assert( pUnit->Status.bIRQ == TRUE );
			pUnit->Status.bIRQ = TRUE;
		}
#endif

	if( pUnit->Task.nTaskID == QUXIAO )	return;	// no command at all

////////////////////////////
	// Bug!!!
	// 뵱Ԫһ󣬲ܽµ
	if( pUnit->Draw.ptOff.x != 0 || pUnit->Draw.ptOff.y != 0 )
		return;
////////////////////////////

	// new command
	// TASKnTaskIDΪQUXIAObDoneΪTRUE
	if( pUnit->Task.bDone )
	{
		Assert( pUnit->Draw.ptOff.x == 0 || pUnit->Draw.ptOff.y == 0 );
#ifdef	_DEBUG_OFFSET_
		if( pUnit->Draw.ptOff.x != 0 || pUnit->Draw.ptOff.y != 0 )
		{
//			WriteLogFile( "off.log", "change0\n" );
		}
#endif //_DEBUG_OFFSET_

		// ĳЩҪһЩĲ
		if( pUnit->Status.nTaskID == GONGJI )
		{
			Assert( pUnit->Status.nTaskIDEx == 2 );
			Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
			struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
			Assert( pU );
			pU->nIDAttackMe = MAP_DATA_NONE;
		}
		pUnit->nIDAttackMe = MAP_DATA_NONE;

		if( pUnit->Status.nTaskID == YUNSONG
			&& pUnit->Status.nTaskIDEx == 1
			&& EYE_IfUnitIsWorker( pUnit ) 
			&& pUnit->Status.bDone == FALSE )
		{
			int nDir;
			nDir = pUnit->Draw.nDir;
			int bOdd = pUnit->Draw.nY&1;
			int nX = pUnit->Draw.nX + MAP_ptSenser[bOdd][0][nDir].x;
			int nY = pUnit->Draw.nY + MAP_ptSenser[bOdd][0][nDir].y;
			WORD codeG = MAP_GetGroundData( pUnit->Draw.nLayer, nX, nY );
			if( codeG != MAP_DATA_NONE )
			{
				struct MAP_GROUND_CODE_STRUCT stctG;
				MAP_GroundDeCode( codeG, &stctG );
				Assert( stctG.nAttr != MAP_SPECIAL_NONE );
				Assert( stctG.nAttr == pUnit->Soldier.nResType+4 );	// 
				stctG.nAttr -= 4;	// Ϊɼ
				codeG = MAP_GroundEnCode( stctG );
				MAP_SetGroundData( pUnit->Draw.nLayer, nX, nY, codeG );
			}
		}

		if( pUnit->Status.nTaskID == MFU )
		{
			CTRL_SetSTG( &pUnit->Draw, MAIFU, FALSE );
		}

		// Ѿ򿪵ţִд
		// Aug.8, 1997, Liu Gang
		if( pUnit->Status.nTaskID == KAIMEN 
			&& pUnit->nCounter != 0 )
		{
			pUnit->Task.bDone = FALSE;
			// Ϊ0
			//pUnit->nCounter = 0;
			return;
		}

//		OutputDebugString( "CTRL_TASK : New Command: " );
//		OutputString( pUnit->Task.nID, "," );
//		OutputString( pUnit->Task.nTaskID, "," );
//		OutputString( pUnit->Task.nTaskIDEx, "\n" );
		// set TASK to "doing"
		// ״̬bDoneΪFALSE
		pUnit->Task.bDone = FALSE;
		pUnit->nCounter = 0;

		// 񣬵ǴʱõԪѾЯԴ
		if( pUnit->Task.nTaskID == YUNSONG
			&& EYE_IfUnitIsWorker( pUnit ) 
			&& pUnit->Soldier.nResource > 0 )
		{
			// øʿΪ͵
			struct CTRL_TASK_STRUCT Task;
			CTRL_TASK_Clear( &Task );
			Task.nID = pUnit->nID;
			// ĿĵԴļ
			Task.nParam1 = TY_FindNearHome(pUnit->Draw.nPlayer,pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Soldier.nResType);
			if( Task.nParam1 == MAP_DATA_NONE )
			{	// ûϼң
				Task.nTaskID = JIESHU;
			}
			else
			{
				Task.nTaskID = HUISONG;
				Task.nTaskIDEx = 2;	// MOUSE_HITRESULT_UNIT
				Task.nTaskIDEx2 = pUnit->Task.nTaskIDEx2;	// Դ
				if( pUnit->Task.nTaskIDEx == 1 )	// MOUSE_HITRESULT_GROUND
				{
					Task.nParam2 = pUnit->Task.nParam1;		// ԭԴλZ
					Task.nParam3 = pUnit->Task.nParam2;		// ԭԴλX
					Task.nParam4 = pUnit->Task.nParam3;		// ԭԴλY
				}
				else
				{
					Task.nParam4 = pUnit->Task.nParam1;		// ԭԴID
				}
				Assert( Task.nParam1 != MAP_DATA_NONE );
			}
			Task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
			return;
		}

		if( (pUnit->Task.nTaskID == XIULI
			|| (pUnit->Task.nTaskID == YIDONG && pUnit->Task.nTaskIDEx == 2) )
			&& EYE_IfUnitIsWorker( pUnit ) 
			&& pUnit->Soldier.nResType != QXZIYUAN
			&& pUnit->Soldier.nResource > 0 )
		{	// ѹΪ
			struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Task.nParam1 );
			Assert( pU );
			if( !EYE_IfUnitIsDead( pU ) 
				&& EYE_IfUnitIsBuild( pU ) && (pU->Draw.nPlayer == pUnit->Draw.nPlayer) )
			{
				int nRes = EYE_GetUResHome( pU );
				if( nRes == pUnit->Soldier.nResType || nRes == SUOYOUZY 
					|| (nRes == MAITIAN && pUnit->Soldier.nResType == LIANGCANG) ) 
				{
					struct CTRL_TASK_STRUCT Task;
					CTRL_TASK_Clear( &Task );
					Task.nID = pUnit->nID;
					Task.nTaskID = HUISONG;
					Task.nTaskIDEx = 2;
					Task.nTaskIDEx2 = pUnit->Soldier.nResType;	// Դ
					if( pUnit->Soldier.nResType == 0 
						|| pUnit->Soldier.nResType == 1 )
					{	// Դ
						Task.nParam2 = pUnit->Draw.nLayer;
						Task.nParam3 = pUnit->Draw.nX;
						Task.nParam4 = pUnit->Draw.nY;
					}
					else
					{	// Դ
						Task.nParam4 = MAP_DATA_NONE;
					}
					Task.nParam1 = pUnit->Task.nParam1;		// ĿĵԪID
					Assert( Task.nParam1 != MAP_DATA_NONE );
					Task.bDone = TRUE;

					// 
					CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &Task );
					return;
				}
			}
		}

		// set status to unit
		CTRL_TASK_Copy( &pUnit->Status, &pUnit->Task );

		// change status if needed
		// ڶ״̬һ״̬Ϊƶ
//		if( pUnit->Status.nTaskID == JIANZAO )	// 
//			pUnit->Status.nTaskIDEx = 1; //MOUSE_HITRESULT_GROUND,Ŀĵ

		if( pUnit->Status.nTaskID == XIULI )	// 
			Assert( pUnit->Status.nTaskIDEx == 2 );
//			pUnit->Status.nTaskIDEx = 2; //MOUSE_HITRESULT_GROUND,Ŀĵ

		// жأnTaskIDEx2Ϊ0ʱҪƶж
		if( pUnit->Status.nTaskID == XIEZAI 
			&& pUnit->Status.nTaskIDEx2 == 0 )
		{
			pUnit->Status.nTaskID = YIDONG;
		}
		if( pUnit->Status.nTaskID == YUNZAI
			&& !(EYE_IfUnitIsTransport( pUnit ) 
				&& pUnit->Status.nTaskIDEx2 == 1) )
		{
			pUnit->Status.nTaskID = YIDONG;
		}

		if( !EYE_IfUnitIsBuild( pUnit ) )
		{
			switch( pUnit->Status.nTaskID )
			{
			case	JIANZAO:	// 
			case	GONGJI:		// 
			case	YUNSONG:	// 
			case	XIULI:		// 
			//case	ZHENXING:	// 
			//case	DANTIAO:	// 
			case	HUISONG:	// 
				pUnit->Status.nTaskID = YIDONG;
				break;
			}
		}

		// ö֡״̬
		if( pUnit->Status.nTaskID == YIDONG
			&& EYE_IfUnitIsWorker( pUnit ) 
			&& pUnit->Soldier.nResource > 0 )
		{
			if( pUnit->Soldier.nResType == SHULIN )	// 
			{
				pUnit->Draw.nState = pUnit->Draw.nDir+
					MAP_Lib.AniSeq[pUnit->Draw.nFile].nEventBegin[3];
			}
			else if( pUnit->Soldier.nResType == MAITIAN		// 
				|| pUnit->Soldier.nResType == LIANGCANG )	// 
			{
				pUnit->Draw.nState = pUnit->Draw.nDir+
					MAP_Lib.AniSeq[pUnit->Draw.nFile].nEventBegin[5];
			}
			else if( pUnit->Soldier.nResType == TIEKUANG )	// 
			{
				pUnit->Draw.nState = pUnit->Draw.nDir+
					MAP_Lib.AniSeq[pUnit->Draw.nFile].nEventBegin[4];
			}
			else	// һ״̬
			{
				pUnit->Draw.nState = pUnit->Draw.nDir;
			}
		}
		else	pUnit->Draw.nState = pUnit->Draw.nDir;
		if( !EYE_IfUnitIsBuild( pUnit ) )
		{
			pUnit->Draw.nFrame = 1;
			pUnit->Draw.nCol = MAP_Lib.AniSeq[pUnit->Draw.nFile].nAniSeq[pUnit->Draw.nState][pUnit->Draw.nFrame]+
				MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
		}
		// ƶ״̬о㷨
		if( pUnit->Status.nTaskID == YIDONG )
		{
			int nEndx, nEndy, nEndZ;
			WORD codeG;

			Assert( pUnit->Status.nParam2 <= MAP_Lib.szNum.cx );	// 
			Assert( pUnit->Status.nParam3 <= MAP_Lib.szNum.cy );	// 

			// Ŀĵغͳһ״̬ṹ
			if( pUnit->Draw.nX == pUnit->Status.nParam2 && pUnit->Draw.nY == pUnit->Status.nParam3 )
			{
				pUnit->Status.bDone = TRUE;
				return;
			}

			BOOL bShouldDuSe = TRUE;	// ĿĵصﲻʱǷö־
			if( pUnit->Status.nTaskIDEx == 1 )	// hit ground
			{
				POINT ptNew = MAP_FindRegion( pUnit->Status.nParam1, pUnit->Status.nParam2,pUnit->Status.nParam3, MAP_Lib.Unit[pUnit->Draw.nFile].nItems[0], pUnit->nID );
				//Assert( ptNew.x!=-1 && ptNew.y!=-1 );
				if( ptNew.x == -1 || ptNew.y == -1 )
				{
					ptNew.x = pUnit->Status.nParam2,
					ptNew.y = pUnit->Status.nParam3;
					bShouldDuSe = FALSE;// ûڸҵԵĿĵأԤ
				}
				nEndZ = pUnit->Status.nParam1;
				nEndx = ptNew.x,
				nEndy = ptNew.y;

				// ޸Ĳ
				for(;;)
				{	

					codeG = MAP_GetGroundData( nEndZ, nEndx, nEndy );
					if( codeG != MAP_DATA_NONE )
						break;
					if( nEndZ == 0 && codeG == MAP_DATA_NONE )
					{
						Assert(0);
						break;
					}
					nEndZ--;
				}
			}
			else if( pUnit->Status.nTaskIDEx == 2 )	//hit unit
			{
				Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
				struct UNIT_STRUCT *pUnitE = MAP_GetUnit( pUnit->Status.nParam1 );
				POINT ptNew = MAP_FindRegion( pUnitE->Draw.nLayer, pUnitE->Draw.nX, pUnitE->Draw.nY, MAP_Lib.Unit[pUnit->Draw.nFile].nItems[0], pUnit->nID );
				//Assert( ptNew.x!=-1 && ptNew.y!=-1 );
				if( ptNew.x == -1 )
				{
					ptNew.x = pUnit->Status.nParam2,
					ptNew.y = pUnit->Status.nParam3;
					bShouldDuSe = FALSE;// ûڸҵԵĿĵأԤ
				}
				nEndZ = pUnitE->Draw.nLayer;
				nEndx = ptNew.x, 
				nEndy = ptNew.y;

				// ޸Ĳ
				for(;;)
				{	
					codeG = MAP_GetGroundData( nEndZ, nEndx, nEndy );
					if( codeG != MAP_DATA_NONE )
						break;
					if( nEndZ == 0 && codeG == MAP_DATA_NONE )
					{
						Assert(0);
						break;
					}
					nEndZ--;
				}
			}
			int	MARCH_Status;
			Assert( nEndZ>=0&&nEndZ<3 );

			MARCH_Status=March_Interface( pUnit->Draw.nX, pUnit->Draw.nY,pUnit->Draw.nLayer, nEndx, nEndy, nEndZ );

			if( bShouldDuSe == TRUE&& MARCH_Status==MARCH_ERROR_MARCH_TRACK )
			{
				if(MARCH_TrackForward[0]==255)
				{	// Ӧöûҵ·϶
					OutputDebugString( "CTRL_TASK : Find no way there!\n" );
					pUnit->Status.nTaskID = DUSE;	// ֱӶ
					return;
				}
				else
				{	// Ӧö·Ԥ
					OutputDebugString( "not reached!\n" );	
					pUnit->Status.nParam4 = DUSE;	// Ԥ
				}
			}
			else if( bShouldDuSe == TRUE )
			{
				if(MARCH_TrackForward[128]!=255)
				{	// ·߳ˣԤ
					OutputDebugString( "not reached!\n" );	
					pUnit->Status.nParam4 = DUSE;	// Ԥ
				}
			}
			else if( bShouldDuSe == FALSE && MARCH_TrackForward[0]==255 )
			{	// Ӧöûҵ·϶
				OutputDebugString( "CTRL_TASK : Find no way there!\n" );
				pUnit->Status.nTaskID = DUSE;	// ֱӶ
				return;
			}
			memcpy( &pUnit->MarchTrack, &MARCH_TrackForward, sizeof(pUnit->MarchTrack) );
			pUnit->StepNum=0;
		}
	}


	// ״̬StatusnTaskIDΪQUXIAObDoneΪTRUE
	// Զһ״̬
	if( pUnit->Status.nTaskID != QUXIAO && pUnit->Status.bDone )
	{
		Assert( pUnit->Draw.ptOff.x == 0 || pUnit->Draw.ptOff.y == 0 );

#ifdef	_DEBUG_OFFSET_
		if( pUnit->Draw.ptOff.x != 0 || pUnit->Draw.ptOff.y != 0 )
		{
//			WriteLogFile( "off.log", "change\n" );
		}
#endif //_DEBUGS_OFFSET_

		// ע⣺ܲ״̬
		// ö֡״̬
		if( EYE_IfUnitIsWorker( pUnit ) 
			&& pUnit->Soldier.nResource != 0 )
		{
			if( pUnit->Soldier.nResType == SHULIN )	// 
			{
				pUnit->Draw.nState = pUnit->Draw.nDir+
					MAP_Lib.AniSeq[pUnit->Draw.nFile].nEventBegin[3];
			}
			else if( pUnit->Soldier.nResType == MAITIAN		// 
				|| pUnit->Soldier.nResType == LIANGCANG )	// 
			{
				pUnit->Draw.nState = pUnit->Draw.nDir+
					MAP_Lib.AniSeq[pUnit->Draw.nFile].nEventBegin[5];
			}
			else if( pUnit->Soldier.nResType == TIEKUANG )	// 
			{
				pUnit->Draw.nState = pUnit->Draw.nDir+
					MAP_Lib.AniSeq[pUnit->Draw.nFile].nEventBegin[4];
			}
			else	// һ״̬
			{
				pUnit->Draw.nState = pUnit->Draw.nDir;	
			}
		}
		else	pUnit->Draw.nState = pUnit->Draw.nDir;
		if( !EYE_IfUnitIsBuild( pUnit ) )
		{
			pUnit->Draw.nFrame = 1;
			pUnit->Draw.nCol = MAP_Lib.AniSeq[pUnit->Draw.nFile].nAniSeq[pUnit->Draw.nState][pUnit->Draw.nFrame]+
				MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
		}

		if( pUnit->Status.nTaskID == pUnit->Task.nTaskID )
		{	// ڵ״̬״̬״̬ĵڶ״̬
			// 
			Assert( pUnit->nHasShadow == 1 );
			pUnit->Status.nTaskID = QUXIAO;
			pUnit->Task.nTaskID = QUXIAO;
			pUnit->Task.bDone = FALSE;
			pUnit->Task.bIRQ = FALSE;
			pUnit->nCounter = 0;

/*
			pUnit->Draw.nState = pUnit->Draw.nDir+MAP_Lib.AniSeq[pUnit->Draw.nFile].nEventBegin[0];
			pUnit->Draw.nCol = MAP_Lib.AniSeq[pUnit->Draw.nFile].nAniSeq[pUnit->Draw.nState][pUnit->Draw.nFrame]+
				MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
			pUnit->Draw.nRow = 0;
*/
//			OutputDebugString( "CTRL_TASK : Done!\n" );
		}
		else
		{	// ڶ״̬ĵһ״̬һ״̬
			CTRL_TASK_Copy( &pUnit->Status, &pUnit->Task );
			pUnit->Status.bDone = FALSE;
			pUnit->nCounter = 0;
		}
	}
}
//////////////////////

//////////////////////
// basic functions
// 

// ԪӰ⴦
// Ԫʱ,SHADOW_Draw()ͬʱӰ.
// codeU		:	unit code to identifies the type of the unit
// nZ, nX, nY	:	position to locateλ
// return		:	unit ID extended code if successful,
//					MAP_DATA_NONE if failed
WORD CTRL_UNIT_Create( int nZ, int nX, int nY, DWORD codeU, BOOL bFind/*=TRUE*/ )
{
	// ѰҸһʵĵطõԪ
	if( bFind )
	{
		POINT pt;
		pt = MAP_FindRegion( nZ, nX, nY, codeU );
		if( pt.x == -1 )
		{
			OutputDebugString( "CTRL_UNIT_Create Error(0): Cannot find a place to set general!\n" );
			return MAP_DATA_NONE;
		}
		nX = pt.x, nY = pt.y;
	}

	// Ԫ
	WORD codeUEx = MAP_SetUnitData( nZ, nX, nY, codeU );
	if( codeUEx == MAP_DATA_NONE )
	{
		OutputDebugString( "CTRL_UNIT_Create Error(1): Cannot create unit!\n" );
		//	սϵ࣬
		FACE_ShowPromptInfor( 18 );
		return codeUEx;
	}

	// õԪϢ
	struct UNIT_STRUCT *pUnit = MAP_GetUnit( codeUEx );
	Assert( pUnit->nType != MAP_UNIT_TYPE_NONE );
	Assert( nX == pUnit->Draw.nX && nY == pUnit->Draw.nY );

	// ֵ
	pUnit->nLife = EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile );

	pUnit->nIDAttackMe = MAP_DATA_NONE;

	if( !EYE_IfUnitIsBuild( pUnit ) )
	{
		pUnit->Draw.nFrame = 1;
#ifdef	_MAP_COMPRESS_
		pUnit->Draw.nCol = MAP_Lib.AniSeq[pUnit->Draw.nFile].nAniSeq[pUnit->Draw.nState][pUnit->Draw.nFrame]+MAP_Lib.AniSeq[pUnit->Draw.nFile].nOffset;
		pUnit->Draw.nRow = 0;
#else
		pUnit->Draw.nRow = stct.nRow;
		pUnit->Draw.nCol = stct.nCol;
#endif
	}


	// ˧ʻ֣ӱFoodStore
	if( pUnit->Draw.nFile == 0
		|| pUnit->Draw.nFile == 1
		|| pUnit->Draw.nFile == 10
		|| pUnit->Draw.nFile == 11 )
	{
		GAME.Players[pUnit->Draw.nPlayer].nFoodStore++;
	}

	if( EYE_IfUnitIsSoldier( pUnit ) )
	{
		pUnit->Soldier.nGenID = MAP_DATA_NONE;
		pUnit->Soldier.nResType = QXZIYUAN;	// ʼ˵ԴΪ
	}
	else if( EYE_IfUnitIsGen( pUnit ) )
	{
		// սµʿ
		memset( pUnit->Gen.wTroop, MAP_DATA_NONE, sizeof(WORD)*GENERAL_TROOP_MAX );
	}

// draw shadow
	// ֻҷӰı
	if( GAME.nMe == pUnit->Draw.nPlayer )
	{
		// Ұ
		int nVRange = EYE_GetViewRange( &pUnit->Draw );
		SHADOW_Draw0( pUnit->Draw.nX, pUnit->Draw.nY, 
			pUnit->Draw.nXLast, pUnit->Draw.nYLast, nVRange );// Draw solid shadow

		//lwc
		//
		Assert( pUnit->nHasShadow == 0 );
        SHADOW_existent(pUnit->Draw.nX,pUnit->Draw.nY,nVRange);
		//lwc
	}
	pUnit->nHasShadow++;
	// draw to minimap
	MINI_SetUnitData( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nPlayer, pUnit->Draw.nLocationSize );	// for minimap

	return codeUEx;
}

// ɾԪӰ⴦
// pUnit	:	unit pointer to be destroyed
// return	:	TRUE if successful
BOOL CTRL_UNIT_Destroy( struct UNIT_STRUCT *pUnit )
{
	WORD codeUEx;

	// draw shadow
#ifdef	_DEBUG
	if( !pUnit )	
	{
		OutputDebugString( "CTRL_UNIT_Create Error(2): Cannot find unit!\n" );
		return FALSE;
	}
#endif

	// ˧ʻ֣ٱFoodStore
	if( pUnit->Draw.nFile == 0
		|| pUnit->Draw.nFile == 1
		|| pUnit->Draw.nFile == 10
		|| pUnit->Draw.nFile == 11 )
	{
		GAME.Players[pUnit->Draw.nPlayer].nFoodStore--;
	}

	if( pUnit->nHasShadow > 0 )
	{	// ڽУҪɾӰ
		// erase from minimap
		MINI_SetGroundData( pUnit->Draw.nXLast, pUnit->Draw.nYLast, pUnit->Draw.nLocationSize );	// for minimap

		// ֻҷӰı
		if( GAME.nMe == pUnit->Draw.nPlayer )
		{
			//lwc
			// ʧ
			int nVRange = EYE_GetViewRange( &pUnit->Draw );
			Assert( pUnit->nHasShadow == 1 );
			SHADOW_death (pUnit->Draw.nX,pUnit->Draw.nY,nVRange);
			//lwc
		}
		pUnit->nHasShadow--;
		codeUEx = MAP_SetUnitData( pUnit->Draw.nLayer, pUnit->Draw.nX, pUnit->Draw.nY, MAP_DATA_NONE );
	}
	else
	{
		GAME.Players[pUnit->Draw.nPlayer].wUnitCounter--;
		pUnit->nType = MAP_UNIT_TYPE_NONE;
	}

	// ûҵ֮ǰ
	Assert( pUnit->nType == MAP_UNIT_TYPE_NONE );
#ifndef	_DEBUG
	pUnit->nType = 0;
#endif

	if( codeUEx != MAP_DATA_NONE )
	{
		OutputDebugString( "CTRL_UNIT_Destroy Error(1): Error when destroying unit!\n" );
		return FALSE;
	}
	return TRUE;
}
///////////////////

//////////////////
// only used by CTRL_UNIT_Move()
void CTRL_UNIT_MoveShadow( struct CTRL_FRAME_STRUCT *pDraw );

// ƶԪ,ÿƶһӺ,޸Ӱ
// pDraw	:	unit to be moved
// nType	:	type of unit
// 	0ס1ߣ2>2ţسŵID
int CTRL_UNIT_Move( struct CTRL_FRAME_STRUCT *pDraw, int nType )
{
	BOOL ret;
	
	ret = MAP_MoveUnit( pDraw, nType );
	if( ret == FALSE )	
	{
		int nNum = MAP_nLocationNum[pDraw->nLocationSize];
		int nX[16], nY[16];
		BOOL bOdd = pDraw->nY&1;
		for( int i=0; i<nNum; i++ )
		{
			nX[i] = pDraw->nX+MAP_ptLocation[bOdd][i].x;
			nY[i] = pDraw->nY+MAP_ptLocation[bOdd][i].y;
			Assert( !EYE_IfOutOfRange( nX[i], nY[i] ) );
			struct UNIT_STRUCT *pU = MAP_GetUnit( nX[i], nY[i] );
			if( pU != NULL )
			{
				if( EYE_IfUnitIsDoor( pU )
					&& pU->Draw.nPlayer == pDraw->nPlayer )	// Լĳ
				{
					return pU->nID;
				}
			}
		}
		return 0;
	}

	// ƶӰ
	CTRL_UNIT_MoveShadow( pDraw );

	// Ƿõ
	WORD codeG = MAP_GetGroundData( pDraw->nLayer, pDraw->nX, pDraw->nY );
	Assert( codeG != MAP_DATA_NONE );
	struct MAP_GROUND_CODE_STRUCT stctG;
	MAP_GroundDeCode( codeG, &stctG );
	if( stctG.nFile == 4 )	// 
		return 2;
	return 1;
}

void CTRL_UNIT_MoveShadow( struct CTRL_FRAME_STRUCT *pDraw )
{
	// ֻҷӰı
	if( GAME.nMe == pDraw->nPlayer )
	{
		// Ұ
		int nVRange = EYE_GetViewRange( pDraw );
		SHADOW_Draw( pDraw->nX, pDraw->nY, 
			pDraw->nXLast, pDraw->nYLast,
			nVRange );	// Draw solid shadow
	}

	// Ҳ
	// erase from minimap
	MINI_SetGroundData( pDraw->nXLast, pDraw->nYLast, pDraw->nLocationSize );	// for minimap
	// draw to minimap
	MINI_SetUnitData( pDraw->nX, pDraw->nY, pDraw->nPlayer, pDraw->nLocationSize );	// for minimap
}
///////////////////

///////////////////
/*
// жǷýӦóսڽɢӺ
BOOL CTRL_UNIT_ToDisapear( struct UNIT_STRUCT *pUnitG )
{
	int i;

	Assert( EYE_IfUnitIsGen( pUnitG ) );

	// ֱɾ´
	// 鿴Ƿɾ죨ʿΪ0ʱ
	int bYes = TRUE;
	for( i=0; i<GENERAL_TROOP_MAX; i++ )
	{
		if( pUnitG->Gen.wTroop[i] != MAP_DATA_NONE )
		{
			bYes = FALSE; break;
		}
	}

	if( bYes )
	{
		struct CTRL_TASK_STRUCT Task;
		CTRL_TASK_Clear( &Task );
		Task.nLevel = 0;		// ļ,0 is the highest, 5 is the lowest
		Task.nID = pUnitG->nID;
		Task.nTaskID = SHANCHU;	// 
		Task.nTaskIDEx = 1;		// ֻɾ
		Task.bDone = TRUE;

		// ´񵽶
		CTRL_TASK_DeployByComputer( pUnitG->Draw.nPlayer, &Task );
		return TRUE;
	}
	return FALSE;
}
*/
//////////////////////

//////////////////////
// local functions
// ڸոմԪʹô˺ԸõԪֵ
void CTRL_SetUnitAttribute( struct UNIT_STRUCT *pUnit )
{
	//switch( pUnit->nType 
}
//////////////////////

// 
//////////////////////
// ݽıŲ
// nZ, nX, nY	:	position to locateλ
// nGenNum		:	general index number in DATA_Lib
// nPlayer		:	player to be added to
// nType		:	troop type
// return		:	general ID extended code if successful,
//					MAP_DATA_NONE if failed
WORD CTRL_GROUP_Create( int nZ, int nX, int nY, DWORD nGenNum, int nPlayer, int nType )
{
	// ӽ͵õԪ
	int nGenFile[4]={35,31,33,29};
	if( nGenNum <= 0 || nGenNum > 118 )	return MAP_DATA_NONE;	// Χ
	DWORD codeU = MAP_Lib.Unit[nGenFile[DATA_Lib.Gen[nGenNum].nType-1]].nItems[0];

	// Ϸ
	struct MAP_UNIT_CODE_STRUCT stctU;
	MAP_UnitDeCode( codeU, &stctU );
	stctU.nPlayer = nPlayer;
	if( nType == MAP_UNIT_TYPE_SGEN )
		stctU.nFile = 52;	// ˮ죬Ϊս
	codeU = MAP_UnitEnCode( stctU );

	// Ԫ
	WORD codeUEx = CTRL_UNIT_Create( nZ, nX, nY, codeU );
	if( codeUEx == MAP_DATA_NONE )
	{
		OutputDebugString( "CTRL_GROUP_Create Error(1): Cannot create unit!\n" );
		return codeUEx;
	}
	struct UNIT_STRUCT *pUnit = MAP_GetUnit( codeUEx );
	Assert( pUnit );

	// Ѹýڽ
	BOOL bSuccess = FALSE;
	for( int i=0; i< PLAYER_GROUP_MAX; i++ )
	{
		if( GAME.Players[nPlayer].wGroup[i] == MAP_DATA_NONE )
		{
			GAME.Players[nPlayer].wGroup[i] = codeUEx;
			GAME.Players[nPlayer].wGroupCounter++;
			bSuccess = TRUE;
			break;
		}
	}
	if( !bSuccess )	
	{
		CTRL_UNIT_Destroy( pUnit );
		//ܳ20޷齨
		FACE_ShowPromptInfor( 19 ) ;
		return MAP_DATA_NONE;
	}

	// 
	//pUnit->nType = MAP_UNIT_TYPE_GEN;
	pUnit->nType = nType;
	pUnit->Gen.nID = (WORD)nGenNum;
	pUnit->Gen.nType = DATA_Lib.Gen[nGenNum].nType;		// 
	DATA_Lib.Gen[nGenNum].bOnBattle = TRUE;				// ս

	// ֵ
	pUnit->nLife = DATA_Lib.Gen[nGenNum].dwLife;		// ֵ
	
	// 
//	pUnit->Gen.nHealth = DATA_Lib.Gen[nGenNum].nHealth;	// 
	pUnit->Gen.nMorale = 70;	// ĳʼʿ
	pUnit->Gen.nLineUp = 0;	//
//	pUnit->Gen.nTactic = 0;	// ı
//	pUnit->Gen.nLevel = DATA_Lib.Gen[nGenNum].nLevel;	// ļ

	// Լˣý״̬
//	if( EYE_IfSheIsMine( pUnit ) )
//		pUnit->Draw.bUpdate = TRUE;

	// ʿ飬CTRL_UNIT_Create()
	// memset( pUnit->Gen.wTroop, MAP_DATA_NONE, sizeof( WORD )*GENERAL_TROOP_MAX );

	if( GAME.nMe == nPlayer )
	{
		// òӰť
		// LHJ
		FACE_SetNumberButtonState( i, BUTTON_UP, TRUE );
		// LHJ
	}

	return codeUEx;
}

// ɾӣɢӣɾ쵥Ԫ
// pUnit	:	unit pointer to be destroyed
// return	:	TRUE if successful
BOOL CTRL_GROUP_Destroy( struct UNIT_STRUCT *pUnit )
{
	int nPlayer;
	WORD codeUEx;
	
#ifdef	_DEBUG
	{
		Assert( pUnit );
		Assert( EYE_IfUnitIsGen( pUnit ) );
		for( int i=0; i<GENERAL_TROOP_MAX; i++ )
		{
			if( pUnit->Gen.wTroop[i] != MAP_DATA_NONE )
			{
				OutputDebugString( "CTRL_DestroyGrup Warning: Destroy general before release troops!\n" );
			}
		}
	}
#endif

	// ѽӽԶɾ
	if( pUnit->nLife <= 0 )
		DATA_Lib.Gen[pUnit->Gen.nID].nID = 0;
	DATA_Lib.Gen[pUnit->Gen.nID].bOnBattle = FALSE;	// ÷غ̨ı־
	if( pUnit->nLife < 0 )	pUnit->nLife = 0;

	// ֵ
	DATA_Lib.Gen[pUnit->Gen.nID].dwLife = pUnit->nLife;	// ֵ

	nPlayer = pUnit->Draw.nPlayer;
	codeUEx = pUnit->nID;

	// changed on July 31, 1997
	// ӽɾý
	BOOL bSuccess = FALSE;
	for( int i=0; i< PLAYER_GROUP_MAX; i++ )
	{
		if( GAME.Players[nPlayer].wGroup[i] == codeUEx )
		{
			GAME.Players[nPlayer].wGroup[i] = MAP_DATA_NONE;
			GAME.Players[nPlayer].wGroupCounter--;
			bSuccess = TRUE;
			break;
		}
	}

	if( !bSuccess )
	{
		OutputDebugString( "Cannot find general in general list!\n" );
	}
	else if( GAME.nMe == nPlayer )
	{
		// òӰťر
		// LHJ
		FACE_SetNumberButtonState( i, BUTTON_DISABLE, TRUE );
		// LHJ
	}

	// ֱɾ
	if( !CTRL_UNIT_Destroy( pUnit ) )
		return FALSE;

	return TRUE;
}

// ͨıѰҽID
// nPlayer	:	player to search in
// nGenNum	:	Index number of general in DATA_Libı
// return	:	general ID extended code if successful,
//				MAP_DATA_NONE if failed
WORD CTRL_GROUP_Find( int nPlayer, WORD nGenNum )
{
	for( int i=0; i<PLAYER_GROUP_MAX; i++ )
	{
		WORD codeUEx = GAME.Players[nPlayer].wGroup[i];
		if( codeUEx != MAP_DATA_NONE )
		{
			struct UNIT_STRUCT *pUnit = MAP_GetUnit( codeUEx );
			Assert( pUnit );
			if( pUnit->Gen.nID == nGenNum )
			{
				return codeUEx;
			}
		}
	}
	return MAP_DATA_NONE;
}

// ѵԪֱӼ뵽
// pUnitG	:	pointer of the general to be added to
// pUnit	:	unit pointer to be added
// return	:	TRUE if successful
BOOL CTRL_GROUP_Add( struct UNIT_STRUCT *pUnitG, struct UNIT_STRUCT *pUnit )
{
	for( int i=0; i<GENERAL_TROOP_MAX; i++ )
	{
		if( pUnitG->Gen.wTroop[i] == MAP_DATA_NONE )
		{	// set relationship
			// ѽʶӵʿ
			pUnit->Soldier.nGenID = pUnitG->nID;
			// ʿIDӵʿ
			pUnitG->Gen.wTroop[i] = pUnit->nID;
			return TRUE;
		}
	}
	OutputDebugString( "CTRL_GROUP_Add Warning(10): Troop list is full!\n" );
	return FALSE;
}

// ӲֱӽɢԪ
// pUnit	:	unit pointer to be subedҪɢĲ
// return	:	TRUE if successful
BOOL CTRL_GROUP_Sub( struct UNIT_STRUCT *pUnit )
{
	struct UNIT_STRUCT *pUnitG;
	BOOL bDone = FALSE;

	// ӽʿɾʿıʶ
	Assert( pUnit->Soldier.nGenID != MAP_DATA_NONE );

	pUnitG = MAP_GetUnit( pUnit->Soldier.nGenID );
	Assert( pUnitG );
	Assert( EYE_IfUnitIsGen( pUnitG ) );
	for( int i=0; i<GENERAL_TROOP_MAX; i++ )
	{
		if( pUnitG->Gen.wTroop[i] == pUnit->nID )
		{
			// ʿɾıʶ
			pUnit->Soldier.nGenID = MAP_DATA_NONE;
			// ʿɾʿ
			pUnitG->Gen.wTroop[i] = MAP_DATA_NONE;
			bDone = TRUE;
			break;
		}
	}

	if( !bDone )
	{
		OutputDebugString( "CTRL_GROUP_Sub Error(10): Not found itself in its general list!\n" );
		return FALSE;// ɾʧܣԼĲûҵԼ
	}
	return TRUE;
}

// Ӳнɢµʿ
// pUnit	:	general pointer to sub soldiers from
// return	:	TRUE if successful
void CTRL_GROUP_ToSubAll( struct UNIT_STRUCT *pUnit )
{
	struct UNIT_STRUCT *pU;
	Assert( pUnit );
	Assert( EYE_IfUnitIsGen( pUnit ) );

	// ѽǷսϵı־û
	DATA_Lib.Gen[pUnit->Gen.nID].bOnBattle = FALSE;

	for( int i=0; i<GENERAL_TROOP_MAX; i++ )
	{
		if( pUnit->Gen.wTroop[i] != MAP_DATA_NONE )
		{
			pU = MAP_GetUnit( pUnit->Gen.wTroop[i] );
			Assert( pU );
			Assert( EYE_IfUnitIsSoldier( pU ) );
			pU->Soldier.nGenID = MAP_DATA_NONE;
			pUnit->Gen.wTroop[i] = MAP_DATA_NONE;
		}
	}
}
//////////////////////

// 
//////////////////////
// һԪ߽ϴ
// bCheck	:	ΪʱҪǷԼǣԼӵɾ
void CTRL_UNIT_InUnit( struct UNIT_STRUCT *pUnit, BOOL bCheck/* = FALSE*/ )
{

	Assert( pUnit->Status.bIRQ == FALSE );
	Assert( pUnit->nHasShadow == 1 );
	Assert( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0 );

	// ˭ȥ
	pUnit->nIDAttackMe = MAP_DATA_NONE;

	int bOdd = pUnit->Draw.nY&1;
	int nXNext, nYNext;
	if( bCheck )
	{
		for( int i=0; i<MAP_nLocationNum[pUnit->Draw.nLocationSize]; i++ )
		{
			nXNext = pUnit->Draw.nX + MAP_ptLocation[bOdd][i].x;
			nYNext = pUnit->Draw.nY + MAP_ptLocation[bOdd][i].y;
			if( MAP_GetUnitDataEx( nXNext, nYNext ) == pUnit->nID )
				MAP_SetUnitDataEx( nXNext, nYNext, MAP_DATA_NONE );
		}
	}
	else
	{
		for( int i=0; i<MAP_nLocationNum[pUnit->Draw.nLocationSize]; i++ )
		{
			nXNext = pUnit->Draw.nX + MAP_ptLocation[bOdd][i].x;
			nYNext = pUnit->Draw.nY + MAP_ptLocation[bOdd][i].y;
			Assert( MAP_GetUnitDataEx( nXNext, nYNext ) == pUnit->nID );
			MAP_SetUnitDataEx( nXNext, nYNext, MAP_DATA_NONE );
		}
	}

	// Ӱ
	if( GAME.nMe == pUnit->Draw.nPlayer )
	{
		int nSight = EYE_GetViewRange( &pUnit->Draw );
		Assert( pUnit->nHasShadow == 1 );
		SHADOW_death( pUnit->Draw.nX, pUnit->Draw.nY, nSight );
	}
	pUnit->nHasShadow--;

	// erase from minimap
	MINI_SetGroundData( pUnit->Draw.nXLast, pUnit->Draw.nYLast, pUnit->Draw.nLocationSize );	// for minimap
}

// һԪӽ߳
// return	:	TRUE if successful
BOOL CTRL_UNIT_OutUnit( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit->Status.bIRQ == TRUE );
	Assert( pUnit->nHasShadow == 0 );
	Assert( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0 );

#ifdef	_DEBUG_OFFSET_
	if( !(pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0) )
	{
		pUnit->Draw.ptOff.x = pUnit->Draw.ptOff.y = 0;
//		WriteLogFile( "off.log", "outunit\n" );
	}
#endif	//_DEBUG_OFFSET_

	POINT ptNew = MAP_FindRegion( 0, pUnit->Draw.nX, pUnit->Draw.nY, MAP_Lib.Unit[pUnit->Draw.nFile].nItems[0] );
	Assert( MAP_GetUnitDataEx( ptNew.x, ptNew.y ) == MAP_DATA_NONE );
//	Assert( ptNew.x != -1 && ptNew.y != -1 );
	if( ptNew.x==-1 || ptNew.y==-1 )
		return FALSE;
	pUnit->Draw.nXLast = pUnit->Draw.nX, 
	pUnit->Draw.nYLast = pUnit->Draw.nY;
	pUnit->Draw.nX = (WORD)ptNew.x, pUnit->Draw.nY = (WORD)ptNew.y;
	// set display position
	int bOdd = pUnit->Draw.nY&1;
	pUnit->Draw.nDrawX = pUnit->Draw.nX + (WORD)MAP_ptLocation[bOdd][MAP_nDrawNum[pUnit->Draw.nLocationSize]].x;
	pUnit->Draw.nDrawY = pUnit->Draw.nY + (WORD)MAP_ptLocation[bOdd][MAP_nDrawNum[pUnit->Draw.nLocationSize]].y;

	int nXNext, nYNext;
	for( int i=0; i<MAP_nLocationNum[pUnit->Draw.nLocationSize]; i++ )
	{
		nXNext = pUnit->Draw.nX + MAP_ptLocation[bOdd][i].x;
		nYNext = pUnit->Draw.nY + MAP_ptLocation[bOdd][i].y;
		Assert( MAP_GetUnitDataEx( nXNext, nYNext ) == MAP_DATA_NONE );
		MAP_SetUnitDataEx( nXNext, nYNext, pUnit->nID );
	}

	// Ӱ
	if( GAME.nMe == pUnit->Draw.nPlayer )
	{
		int nSight = EYE_GetViewRange( &pUnit->Draw );
		Assert( pUnit->nHasShadow == 0 );
		SHADOW_existent( pUnit->Draw.nX, pUnit->Draw.nY, nSight );
	}
	pUnit->nHasShadow++;
	// draw to minimap
	MINI_SetUnitData( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nPlayer, pUnit->Draw.nLocationSize );	// for minimap
	return TRUE;
}
//////////////////////

//////////////////////
// ı
// ĳԪüıֵʹõԪм
// pDraw	:	ԪĿƽṹ
// JiMou	:	ıID
inline void CTRL_SetSTG( CTRL_FRAME_STRUCT *pDraw, CTRL_JIMOU JiMou, BOOL bSet/*=TRUE*/ )
{
	Assert( pDraw );
	pDraw->nSTG[JiMou] = bSet;
	pDraw->wSTGCounter[JiMou] = 0;
}

// ȡĳԪǷĳı
// pDraw	:	ԪĿƽṹ
// JiMou	:	ıID
inline BOOL CTRL_GetSTG( CTRL_FRAME_STRUCT *pDraw, CTRL_JIMOU JiMou )
{
	Assert( pDraw );
	return pDraw->nSTG[JiMou];
}
//////////////////////
