/////////////////
// CBData.h		:	ڡȫݽṹ
// CBData.h		:	<< chibi >> global data type structure
//
// 汾0010		:	һžʮ
// v0010		:	Sep.12.1996
// v0011		:	Oct.18.1996
// v0020		:	Feb.28.1997
//
// д			:	
// written by	:	Liu Gang
//
// 		:	Visual C++ 4.2
// Compiler		:	Visual C++ 4.2
//
// Ȩ			:	ǰ޹˾	1996-1997
// Copyright	:	WayAhead Co.Ltd.		1996-1997
/////////////////
// ļȡʹеԪ졢ʿ

#ifndef	__CBDATA_H__
#define	__CBDATA_H__
///////////

#include "DsApi.h"

#define	DATA_ERROR_ID	700

/////////
/////////
// General_Type
#define	DATA_MOULUE_MAX	255
struct	DATA_GENERAL_STRUCT
{
	// 
	BYTE	nID;		// ͣID
	DWORD	dwLife;		// ֵ
	char	strName[16];// 
	BYTE	nJunZhu;	// ıţϷ 

	// 
	BYTE	nWuLi;		// 
	BYTE	nZhiLi;		// 
	BYTE	nType;		// ͣ1234
	BYTE	nLevel;		// 켶𣨳ʼ
	BYTE	nMouLue;	// ı
	BYTE	nJiMou;		// ʹõļı
	int		nJingYan;	// 
	BYTE	nHealth;	// 

	// 
	BOOL	bOnBattle;	// ѾѡսΪ
						// ߳ʼʱⲻøýڱس
};
/////////

/////////
// ԪUnit_Type
#define		DATA_UNIT_NONE		0
struct	DATA_UNIT_STRUCT
{
	// 
	BYTE	nID;	// ͣIDļ
	char	strName[16];		// 
	BYTE	nLevel;	// 
	DWORD	dwLife;	// ֵ

	// ͷ
	BYTE	nNearAttack;	// ̹
	BYTE	nFarAttack;		// Զ̹
	BYTE	nNearDefend;	// ̷
	BYTE	nFarDefend;		// Զ̷
	BYTE	nViewRange;		// Ұ
	BYTE	nFightRange;	// 
	BYTE	nMoveSpeed;		// ƶٶ
	BYTE	nFightSpeed;	// ٶ

	// 
	int		nCreateIron;	// õԪʱԴ
	int		nCreateFood;
	int		nCreateWood;
	int		nCreateGold;
	int		nCreateSpeed;

	// 
	BYTE	nAddExp;		// ٺԷֵ
	BYTE	nAddMorale;		// ٺԷʿӣԼʿ
};

// ְGrade
struct DATA_GRADE_STRUCT
{
	char	strName[16];
	BYTE	nAddWuLi;
	BYTE	nAddZhiLi;
	BYTE	nGrade;
};

struct DATA_UPGRADE_STRUCT
{
	int nGold;
	int nWood;
	int nIron;
	int nFood;

	DWORD dwParam1;
	DWORD dwParam2;
	DWORD dwParam3;
	DWORD dwParam4;
};

#define	DATA_UNIT_GRADE_MAX		29
#define	DATA_UNIT_GENERAL_MAX	118
#define	DATA_UNIT_MAX			56
#define	DATA_UPGRADE_MAX	24
struct DATA_STRUCT
{
	char strDATA[_MAX_FNAME];	// ݵļ
	struct DATA_GRADE_STRUCT	Grade[DATA_UNIT_GRADE_MAX];
	struct DATA_GENERAL_STRUCT	Gen[DATA_UNIT_GENERAL_MAX];
	struct DATA_UNIT_STRUCT	Unit[DATA_UNIT_MAX];
	struct DATA_UPGRADE_STRUCT Upgrade[DATA_UPGRADE_MAX];
};

extern struct DATA_STRUCT DATA_Lib;
/////////

/////////
#define	DATA_EFFECT_MAX	128	// еЧļ
#define	DATA_MUSIC_MAX	32	// еıļ
struct DATA_WAVE_STRUCT
{
	char	strName[_MAX_FNAME];
};

struct DATA_WAVE_LIB_STRUCT
{
	char strWAVFile[_MAX_FNAME];	// ݵļ
	struct DATA_WAVE_STRUCT Music[DATA_MUSIC_MAX];
	struct DATA_WAVE_STRUCT Effect[DATA_EFFECT_MAX];	// WAVЧ
};
extern struct DATA_WAVE_LIB_STRUCT DATA_WAVE_Lib;
/////////


BOOL DATA_ReadDATAFile( HWND hwnd, LPCTSTR filename, LPCTSTR path );
BOOL DATA_ReloadDATAFile( HWND hwnd );

//////////////////////
// ļ
// ȡļ
// hwnd		:	window handle if error 
// filname	:	wave data file name
// path		:	wave data file path
// pathWAV	:	wave source file path
// return	:	TRUE if read successful
BOOL DATA_ReadWAVEFile( HWND hwnd, LPCTSTR filename, LPCTSTR path, LPCTSTR pathWAV );

// play sound effects
// nIndex	:	index number from DATA_WAVE_Lib for play source
// bLoop	:	TRUE for loop
void DATA_WAVE_EffectPlay( int nIndex, BOOL bLoop=TRUE );
void DATA_WAVE_EffectPlayLow( int nIndex );	// in a low voice

// play background music
// nIndex	:	index number from DATA_WAVE_Lib for play source
void DATA_WAVE_MusicPlay( int nIndex );

// play background music
// filename		:	file name to be played
void DATA_WAVE_MusicPlayS( LPCTSTR filename );

// stop background music
void DATA_WAVE_MusicStop();

// replay the background music
void DATA_WAVE_MusicReplay();

// Close background music
void DATA_WAVE_MusicClose();
//////////////////////

/////////
#endif
