/////////////////
// CBGame.cpp	:	ڡȫݽṹ
// CBGame.cpp	:	<< chibi >> global data structure
//
// v0011		:	Oct.18.1996
// v0012		:	Nov.28.1996
// v0013		:	Feb.5.1997, changed setunitdata() part in GAME_ReadMedFile()
//								add function GAME_ReadMedHeader()
// v0020		:	Feb.28.1997, add function named DATA_ReadDATAFile()
//
// v0030		:	May.2.1997, add save&load file, read&write option file functions
// v0031		:	May.14.1997, add some values in main structure: nBuildType, nMusicID
//
// д			:	
// written by	:	Liu Gang
//
// 		:	Visual C++ 4.2
// Compiler		:	Visual C++ 4.2
//
// Ȩ			:	ǰ޹˾	1996-1997
// Copyright	:	WayAhead Co.Ltd.		1996-1997
/////////////////
// ļȡϷãͼݣжԵԪ졢ʿ
// Ĳ

#include "stdafx.h"
#include <stdio.h>
#include "Assert.h"

#include "CBGame.h"
#include "CBMap.h"
#include "CBEyes.h"
#include "CBMini.h"

#ifdef	_GAME_
	#include "CBData.h"
	#include "CBDraw.h"
	#include "CBCtrl.h"
	#include "CBOther.h"
	#include "CBMouse.h"
	#include "CBShadow.h"
	#include "CBeyes.h"
	#include "CBEvent.h"
	#include "CBRun.h"

// TY
	#include "Temperor.h"

// LWC
	#include "l_save.h"		// GAME_Save(), GAME_Load()
	#include "l_scan.h"

// LHJ
	#include "cbprompt.h"	// PROMPT_BLOCK
	#include "marco.h"		// BUTTON_UP BUTTON_DISABLE
	#include "interfac.h"	// FACE_SetNumberButtonState()
	#include "interfa1.h"	// FACE_ShowCommandUnit()

// end
	#include "ddcompo.h"
	#include "mciapi.h"
	#include "dsapi.h"
#endif
///////////
// ȫ
//DH
// 磬Nov.4.1997, LG & LHJ
BOOL	GAME_bNetwork=FALSE;
BOOL	GAME_bNetPlayerOK[GAME_PLAYER_MAX];// ȷ
//DH

// Nov.7.1997
// CBData.cpp
extern BOOL MUSIC_bEnable;	// Ƿ񲥷CD
extern BOOL EFFECT_bEnable;	// Ƿ񲥷Ч

// Nov.9.1997
// CbCtrl.cpp
// ָʾеβλ
// points to the Task List's tail
extern int	CTRL_nTaskTail[GAME_PLAYER_MAX];

// ָһЧλ
extern int CTRL_nTaskHead[GAME_PLAYER_MAX];


struct GAME_STRUCT	GAME;

// ȱʡʱıݵĴ
int GAME_nSlot = 99;

// Nov.7.1997
// ϷǺʱA̺B
// 0֣1ΪẠ2ΪB
int GAME_nDisk = 0;

// Nov.7.1997
// õļ
void GAME_MakeSaveName( int nSlot, LPCTSTR tail, LPSTR filename );

char	GAME_strSetupDirectory[_MAX_PATH];	// Ϸװ·
BOOL GAME_bBegin = FALSE;
BOOL GAME_bDebugStage = FALSE;

struct GAME_TIME_STRUCT	GAME_Time;

SYSTEMTIME TimeSub( SYSTEMTIME time1, SYSTEMTIME time2 );
///////////

#define	GAME_INIT_GOLD		20000
#define	GAME_INIT_FOOD		10000
#define	GAME_INIT_WOOD		10000
#define	GAME_INIT_IRON		10000

///////////
//	ⲿ
// ͼ
extern WORD MAP_wGroundData[MAP_DATA_THICK][MAP_DATA_WIDTH][MAP_DATA_HEIGHT];
// 浥Ԫͼ
extern WORD MAP_wUnitData[MAP_DATA_WIDTH][MAP_DATA_HEIGHT];
// 
extern WORD MAP_wRegionData[MAP_DATA_WIDTH][MAP_DATA_HEIGHT];

// defined in CBCtrl.cpp
// mouse hit result
// ļ
extern int	CTRL_nHitCounter;
// contains the units player want to send command to
// 
// ֻnID
extern struct CTRL_TASK_STRUCT CTRL_hitSrc[CTRL_TASK_LIST_MAX-1];

// the target unit
// Ŀ壬Ҳڴ
extern struct CTRL_TASK_STRUCT CTRL_hitDest;

// սĵɫ
extern CDDPalette palMain;	// defiend in CbMain.cpp

// LHJ
// declared in CBprompt.cpp
//	the current prompt block
extern struct	PROMPT_BLOCK	FACE_CURRENT_PROMPT_BLOCK;

// declared in Interfa1.cpp
// to store these value for the command unit when save and load 
extern int		FACE_CurrentCommandUnitID;
extern DWORD	FACE_CurrentCommandUnitFlag;
// LHJ
///////////
// 浱ǰ
extern struct CTRL_TASK_SAVE_CMDUNIT CTRL_TASK_saveCmdUnit;	// defined in CBCtrl.cpp

// ǷԶоĲ
extern BOOL RUN_bAUTO;		// declared in CBRun.cpp

///////////
// declared in CBRun.cpp, location function
// ǰ״̬ZUJIANJIARUʱ
void RUN_GroupUnit( struct UNIT_STRUCT *pUnit );
///////////

///////////
// ʼ
void GAME_InitGame()
{
	memset( &GAME, 0, sizeof(struct GAME_STRUCT ) );
	for( int i=0; i< GAME_PLAYER_MAX; i++ )
	{
		//òΪ
		memset( GAME.Players[i].wGroup, MAP_DATA_NONE, sizeof( WORD)*PLAYER_GROUP_MAX );
	}
}

void GAME_InitGamePlayers()
{
	for( int i=0; i< GAME_PLAYER_MAX; i++ )
	{
		memset( &GAME.Players[i], 0, sizeof(struct PLAYER_STRUCT ) );
		//òΪ
		memset( GAME.Players[i].wGroup, MAP_DATA_NONE, sizeof( WORD)*PLAYER_GROUP_MAX );
	}
}
///////////

///////////
// ȡļ
// hwnd		:	window to receive error message
// return	:	TRUE if successful
BOOL GAME_ReadCBSetFile( HWND hwnd )
{
	char	fname[65];

#ifdef	_MAP_COMPRESS_
	strcpy( fname, "CB.set" );
#else
	strcpy( fname, "CB.set" );
#endif
	FILE * fp = fopen( fname, "rb" );
	if( !fp )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+0,"Cannot open Chi Bi set file: ", fname );
		return FALSE;
	}

	// read item size
	fscanf( fp, "%d,%d,", &MAP_Lib.szItem.cx, &MAP_Lib.szItem.cy );
	if( MAP_Lib.szItem.cx>MAP_ITEM_WIDTH || MAP_Lib.szItem.cy>MAP_ITEM_HEIGHT )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+1, "Map item is too large, change setup again." );
		MAP_Lib.szItem.cx = MAP_ITEM_WIDTH, MAP_Lib.szItem.cy = MAP_ITEM_WIDTH;
	}
	
	// read item heights
	fscanf(fp,"%d,%d,%d,%d\n",&MAP_Lib.nHeight[0],&MAP_Lib.nHeight[1],&MAP_Lib.nHeight[2],&MAP_Lib.nHeight[3]);

	// read game options
	// ٶ
	// ٶ
	// ЧСrange from 0 to -50001ʱر
	// ֵСrange from 0 to -50001ʱر
	// AVIĿ
//	fscanf(fp,"%d,%d,%d,%d,%d\n",
//		&GAME.nSpeed, &GAME.nSpeedScroll, &GAME.nVolume, &GAME.nVolumeCD, &GAME.bFightEnabled );

	// read path of each kind of data file
	char file[_MAX_PATH];
	fscanf(fp,"%s\n", GAME.strPathMED );
	fscanf(fp,"%s\n", GAME.strPathDAT );
	fscanf(fp,"%s\n", GAME.strPathBMP );
	fscanf(fp,"%s\n", GAME.strPathAVI );
	fscanf(fp,"%s\n", GAME.strPathWAV );

	// read ground map item data file
	fscanf( fp, "%s\n", file );
	if( !::MAP_ReadGroundFile( hwnd, file, GAME.strPathDAT, GAME.strPathBMP ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(0): read ground file error!\n" );
		return FALSE;
	}

	// read unit map item data file
	fscanf( fp, "%s\n", file );

	if( !::MAP_ReadUnitFile( hwnd, file, GAME.strPathDAT, GAME.strPathBMP ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(1): read Unit file error!\n" );
		return FALSE;
	}

	// read special ground data file
	fscanf( fp, "%s\n", file );
	if( !::MAP_ReadSpecFile( hwnd, file, GAME.strPathDAT ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(2): read special file error!\n" );
		return FALSE;
	}
	

	// read senser file
	fscanf( fp, "%s\n", file );
	if( !::MAP_ReadSenserFile( hwnd, file, GAME.strPathDAT ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(3): read senser file error!\n" );
		return FALSE;
	}

	// read BTL initialization file name
	// in order to be compatible with MapEditer, cannot read med file directly
	fscanf( fp, "%s\n", GAME.strNameBTL );

	// read Animation data file
	fscanf( fp, "%s\n", file );
	if( !::MAP_ReadAniSeqFile( hwnd, file, GAME.strPathDAT ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(4): read animation sequency file error!\n" );
		return FALSE;
	}

	// read animation data file extensional
	fscanf( fp, "%s\n", file );
	if( !::MAP_ReadAniSeqFileEx( hwnd, file, GAME.strPathDAT ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(8): read animation sequency extension file error!\n" );
		return FALSE;
	}

	// read wave data file
	fscanf( fp, "%s\n", file );
	if( !::DATA_ReadWAVEFile( hwnd, file, GAME.strPathDAT, GAME.strPathWAV ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(11): read wave file error!\n" );
		return FALSE;
	}

	// read game option data file
	fscanf( fp, "%s\n", GAME.strNameOPT );
	if( !GAME_ReadOptionFile( hwnd, GAME.strNameOPT, GAME.strPathDAT ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(12): read game option error!\n" );
		return FALSE;
	}

	// read others file
	fscanf( fp, "%s\n", file );
	if( !::MAP_ReadOtherFile( hwnd, file, GAME.strPathDAT, GAME.strPathBMP ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(9): read cover file error!\n" );
		return FALSE;
	}

	// read Cover data file
	fscanf( fp, "%s\n", file );
	if( !::DRAW_ReadCoverFile( hwnd, file, GAME.strPathDAT ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(5): read cover file error!\n" );
		return FALSE;
	}

	// read mini map data file
	fscanf( fp, "%s\n", file );
	if( !::MAP_ReadMiniFile( hwnd, file, GAME.strPathDAT ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(6): read minimap file error!\n" );
		return FALSE;
	}

	// read data file
	fscanf( fp, "%s\n", file );
	if( !::DATA_ReadDATAFile( hwnd, file, GAME.strPathDAT ) )
	{
		OutputDebugString( "GAME_ReadCBSetFile Error(7): read data file error!\n" );
		return FALSE;
	}

	// read if debug each stage
	fscanf( fp, "%d\n", &GAME_bDebugStage );

	fclose( fp );
	return TRUE;
} // end of GAME_ReadCBSetFile()
///////////

///////////
// ȡսʼļ
// hwnd		:	window to receive error message
// nBattle	:	battle number
// filename	:	battle field data file name
// path		:	battle field data file path
// return	:	TRUE if successful
BOOL GAME_ReadBTLFile( HWND hwnd, int nBattle, LPCTSTR filename, LPCTSTR path )
{
	char fname[65];
//	FILE * fp;
	int i, j, k;
	int nNum, nNum2, nNum3, nNum4, nNum5, nNum6;
	CScan_read FSCAN;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FSCAN.scan_open (fname);
	/*
	fp = fopen( fname, "rt" );
	if( !fp )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+2,"Cannot open Med file: ", fname );
		return FALSE;
	}
	*/
//	if( GAME.nMe == 3 )	// ܲ
//		nBattle += 17;
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d\n", &nNum ));
	//fscanf( fp, "%d\n", &nNum );
	Assert( nBattle < nNum );
	if( nBattle >= nNum )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+4,"battle ID is out of range! ", fname );
		return FALSE;
	}

	// Ԥǰݣ
	int nTemp;
	char	strTemp[65];
	for( i=0; i<nBattle; i++ )
	{
		// ȡID;رID
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d\n", &nNum2, &nNum3, &nTemp ));
		//fscanf( fp, "%d,%d,%d\n", &nNum2, &nNum3, &nTemp );
		// ȡսͼļAVIļ
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%s %s\n", &strTemp, strTemp ));
		//fscanf( fp, "%s %s\n", &strTemp, strTemp );
		for( j=0; j<nNum3; j++ )
		{
			// ȡIDսͣ
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nNum4 ));
			//fscanf( fp, "%d,", &nNum4 );
			// nThink:	0Ϊ½ս1Ϊˮս2Ϊ޻
			// nTechLvl:	
			// nBuildType:	0Ϊڽ1Ϊ⽨
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d\n", 
				&nTemp, &nTemp, &nTemp )); 
			//fscanf( fp, "%d,%d,%d\n", 
			//	&nTemp, &nTemp, &nTemp ); 
			// ȡʼԴǮľ
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d, %d, %d, %d\n", 
				&nTemp, &nTemp, &nTemp, &nTemp )); 
			//fscanf( fp, "%d, %d, %d, %d\n", 
			//	&nTemp, &nTemp, &nTemp, &nTemp ); 
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d, ", &nNum5 ));
			//fscanf( fp, "%d, ", &nNum5 );
			for( k=0; k<nNum5; k++ )
			{
				FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nNum6 ));
				//fscanf( fp, "%d,", &nNum6 );
			}
			for( k=0; k<nNum5; k++ )
			{
				FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nNum6 ));
				//fscanf( fp, "%d,", &nNum6 );
			}
		}
	}

	// ȡID;رID
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d\n", &nNum2, &nNum3, &GAME.nMusicID ));
	if( GAME_nDisk != 0 )
	{
		GAME.nMusicID=getrandom( 3, 15 );//ID,Ը
	}

	//fscanf( fp, "%d,%d,%d\n", &nNum2, &nNum3, &GAME.nMusicID );
	Assert( nNum2 == i );
	GAME.nID = nNum2;

	// ȡսͼļAVIļ
	char strAVI[_MAX_FNAME];
	FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%s %s\n", GAME.strNameMED, strAVI ));
	strcpy( GAME.strNameAVI, GAME_strSetupDirectory );
	strcat( GAME.strNameAVI, "\\avi\\" );
	strcat( GAME.strNameAVI, strAVI );

	//fscanf( fp, "%s %s\n", GAME.strNameMED, GAME.strNameAVI );
	for( j=0; j<nNum3; j++ )
	{
		// ȡIDսͣ
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nNum4 ));
		//fscanf( fp, "%d,", &nNum4 );
		int nPlayer = 0;
		if(GAME_bNetwork==2)
			{nPlayer = 1;}
		if( j==nPlayer )
		{
			GAME.nMe = nNum4;
			GAME.Players[nNum4].nType = PLAYER_TYPE_HUMAN;
		}
		else
		{
			GAME.Players[nNum4].nType = PLAYER_TYPE_COMPUTER;
		}
		// nThink:	0Ϊ½ս1Ϊˮս2Ϊ޻
		// nTechLvl:	
		// nBuildType:	0Ϊڽ1Ϊ⽨
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,%d,%d\n", 
			&GAME.Players[nNum4].nThink, 
			&GAME.Players[nNum4].nTechLvl,
			&GAME.Players[nNum4].nBuildType )); 
		/*
		fscanf( fp, "%d,%d,%d\n", 
			&GAME.Players[nNum4].nThink, 
			&GAME.Players[nNum4].nTechLvl,
			&GAME.Players[nNum4].nBuildType ); 
		*/
		GAME.Players[nNum4].nID=nNum4;
		
		// ȡʼԴǮľ
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d, %d, %d, %d\n", 
			&GAME.Players[nNum4].nGold, 
			&GAME.Players[nNum4].nFood, 
			&GAME.Players[nNum4].nWood, 
			&GAME.Players[nNum4].nIron )); 
		/*
		fscanf( fp, "%d, %d, %d, %d\n", 
			&GAME.Players[nNum4].nGold, 
			&GAME.Players[nNum4].nFood, 
			&GAME.Players[nNum4].nWood, 
			&GAME.Players[nNum4].nIron ); 
		*/
		FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d, ", &nNum5) );
		//fscanf( fp, "%d, ", &nNum5 );
		for( k=0; k<DATA_UNIT_GENERAL_MAX; k++ )
		{
			if( DATA_Lib.Gen[k].nJunZhu == nNum4 )
			{
				DATA_Lib.Gen[k].bOnBattle = TRUE;
			}
		}
		int nSaveGen[32];
		for( k=0; k<nNum5; k++ )
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nNum6 ));
			//fscanf( fp, "%d,", &nNum6 );
			DATA_Lib.Gen[nNum6].bOnBattle = FALSE;
			//Assert( DATA_Lib.Gen[nNum6].nJunZhu == nNum4 );
			DATA_Lib.Gen[nNum6].nJunZhu = nNum4;

			// ʼһЩ
//			DATA_Lib.Gen[nNum6].nID = nNum6;
			
			nSaveGen[k] = nNum6;
		}
		for( k=0; k<nNum5; k++ )
		{
			FSCAN.l_scan (sscanf (FSCAN.expand_buf,"%d,", &nNum6 ));
			if( nNum6 != 0 )
			{
				DATA_Lib.Gen[nSaveGen[k]].nLevel = nNum6-1;
			}
			else if( nSaveGen[k] >= 1 && nSaveGen[k] <= 33 
				&& DATA_Lib.Gen[nSaveGen[k]].nLevel == 0 )
			{
				DATA_Lib.Gen[nSaveGen[k]].nLevel = 5;	// ȨˣʼΪ5
			}
		}
	}

	Assert( GAME.Players[GAME.nMe].nType == PLAYER_TYPE_HUMAN );
	FSCAN.scan_close ();
	//fclose( fp );
	return TRUE;
}

// ȡսļ
// hwnd		:	window to receive error message
// filename	:	battle field data file name
// path		:	battle field data file path
// return	:	TRUE if successful
BOOL GAME_ReadMEDFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[65];
	FILE *fp;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	fp = fopen( fname, "rb" );
	if( !fp )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+2,"Cannot open Med file: ", fname );
		return FALSE;
	}

	// read MED file version
	fread( &GAME.lVerMED, sizeof(long), 1, fp );
	if( GAME.lVerMED<100 )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+5,"Cannot read old version of MED file: ", fname );
		return FALSE;
	}

	// read MED file( Map Editer Data file )
	char strTemp[65];
	// read name of the battlefield
	int nName=0;
	fread( &nName, sizeof(BYTE), 1, fp );
	fread( GAME.strName, nName, 1, fp );
	GAME.strName[nName] = 0;
	
	// read size of the battlefield
	fread( &MAP_Lib.szNum.cx, sizeof(DWORD), 1, fp );
	fread( &MAP_Lib.szNum.cy, sizeof(DWORD), 1, fp );

	// read something not used
	fread( strTemp, sizeof(long)*(MAP_DATA_THICK+2), 1, fp );

	// initialize data
	::MAP_ResetGround();
	::MAP_ResetRegion();
	::MAP_ResetUnit();


	// set allies
	// Aug. 28. 1997
	GAME_SetAlly( 0, 1 );
	GAME_SetAlly( 0, 2 );
	GAME_SetAlly( 0, 3 );
	GAME_SetAlly( 0, 4 );

	// read ground data
	for( int i=0; i<MAP_DATA_THICK; i++ )
	for( int j=0; j<MAP_Lib.szNum.cx; j++ )
		fread( MAP_wGroundData[i][j], sizeof(WORD)*MAP_Lib.szNum.cy, 1, fp );

	// read starting points
	for( int k=0; k<GAME_PLAYER_MAX; k++ )
	{
		fread( &GAME.ptStart[k], sizeof(POINT), 1, fp );
	}

	// read unit data
	DWORD codeU;
	WORD wCounter;
	for( int x=0; x< GAME_PLAYER_MAX; x++ )
	{
		fread( &wCounter, sizeof(WORD), 1, fp );
		for( int y=0; y<wCounter; y++ )
		{
			struct UNIT_STRUCT Unit;
			fread( &Unit.nType, sizeof(BYTE), 1, fp );
			if( Unit.nType == MAP_UNIT_TYPE_NONE ) continue;
			fread( &Unit.Draw.nX, sizeof(WORD), 1, fp );
			fread( &Unit.Draw.nY, sizeof(WORD), 1, fp );
			fread( &Unit.Draw.nLayer, sizeof(WORD), 1, fp );
			fread( &codeU, sizeof(codeU), 1, fp );
			WORD codeUEx;
			if( (codeUEx = ::CTRL_UNIT_Create( Unit.Draw.nLayer, Unit.Draw.nX, Unit.Draw.nY, codeU )) == MAP_DATA_NONE )
			{
				OutputDebugString( "GAME_ReadMedFile Error(0): Read Med file error!\n" );
				ErrorMessage( hwnd, GAME_ERROR_ID+4,"Read Med file error: ", fname );
				return FALSE;
			}

			struct UNIT_STRUCT *pUnit = ::MAP_GetUnit( codeUEx );
			Assert( pUnit );
			Assert( EYE_IfUnitIsUnit( pUnit ) );
			Assert( pUnit->nID == codeUEx );
			if( EYE_IfUnitIsBuild( pUnit ) )
			{
				// սǷ
				RUN_CountDown[pUnit->Draw.nPlayer].nBuildings ++;

				if( EYE_IfUnitIsRes( pUnit ) )
				{
					fread( &pUnit->Build.nResource, sizeof(DWORD), 1, fp );
				}
				else
				{	// added by Liu Gang
					TY_IDProcess(pUnit->nID,JZFINISH,CBNULL);
				}
			}
			else if( EYE_IfUnitIsSoldier( pUnit ) )
			{
				// սǷ
				RUN_CountDown[pUnit->Draw.nPlayer].nSoldiers += EYE_GetFullLife( -1, pUnit->Draw.nFile );

				WORD nGenNum;
				fread( &nGenNum, sizeof(WORD), 1, fp );
				if( nGenNum != 0 )
				{
					Assert( nGenNum > 0 && nGenNum <= 118 );	// temp
					pUnit->Status.nID = codeUEx;
					pUnit->Status.nTaskID = ZUJIAN;
					if( EYE_IfUnitIsWorker( pUnit ) )
						pUnit->Status.nTaskIDEx = MAP_UNIT_TYPE_WGEN;		//ǹ˲
					else
						pUnit->Status.nTaskIDEx = MAP_UNIT_TYPE_GEN;		//ս
					Assert( nGenNum != MAP_DATA_NONE );
					pUnit->Status.nParam1 = nGenNum;	// 
					pUnit->Status.bDone = FALSE;
					RUN_GroupUnit( pUnit );
					pUnit->Status.nTaskID = QUXIAO;
					Assert( pUnit->nHasShadow == 1 );
				}
			}
		}
	}

	fclose( fp );
	return TRUE;
} // end of GAME_ReadMedFile()

// Nov.6.1997, Liu Gang
// ȡսļ
// hwnd		:	window to receive error message
// filename	:	battle field data file name
// path		:	battle field data file path
// return	:	TRUE if successful
BOOL GAME_ReadMEDFileNet( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[65];
	FILE *fp;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	fp = fopen( fname, "rb" );
	if( !fp )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+2,"Cannot open Med file: ", fname );
		return FALSE;
	}

	// read MED file version
	fread( &GAME.lVerMED, sizeof(long), 1, fp );
	if( GAME.lVerMED<100 )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+5,"Cannot read old version of MED file: ", fname );
		return FALSE;
	}

	// read MED file( Map Editer Data file )
	char strTemp[65];
	// read name of the battlefield
	int nName=0;
	fread( &nName, sizeof(BYTE), 1, fp );
	fread( GAME.strName, nName, 1, fp );
	GAME.strName[nName] = 0;
	
	// read size of the battlefield
	fread( &MAP_Lib.szNum.cx, sizeof(DWORD), 1, fp );
	fread( &MAP_Lib.szNum.cy, sizeof(DWORD), 1, fp );

	// read something not used
	fread( strTemp, sizeof(long)*(MAP_DATA_THICK+2), 1, fp );

	// initialize data
	::MAP_ResetGround();
	::MAP_ResetRegion();
	::MAP_ResetUnit();


	// set allies
	// Aug. 28. 1997
	GAME_SetAlly( 0, 1 );
	GAME_SetAlly( 0, 2 );
	GAME_SetAlly( 0, 3 );
	GAME_SetAlly( 0, 4 );

	// read ground data
	for( int i=0; i<MAP_DATA_THICK; i++ )
	for( int j=0; j<MAP_Lib.szNum.cx; j++ )
		fread( MAP_wGroundData[i][j], sizeof(WORD)*MAP_Lib.szNum.cy, 1, fp );

	// read starting points
	for( int k=0; k<GAME_PLAYER_MAX; k++ )
	{
		fread( &GAME.ptStart[k], sizeof(POINT), 1, fp );
	}

	// read unit data
	DWORD codeU;
	WORD wCounter;
	for( int x=0; x< GAME_PLAYER_MAX; x++ )
	{
		// ҪûõϷ
		if( GAME.Players[x].nType == PLAYER_TYPE_NONE && x!= 0 )
		{
			fread( &wCounter, sizeof(WORD), 1, fp );
			for( int y=0; y<wCounter; y++ )
			{
				struct UNIT_STRUCT Unit;
				fread( &Unit.nType, sizeof(BYTE), 1, fp );
				fread( &Unit.Draw.nX, sizeof(WORD), 1, fp );
				fread( &Unit.Draw.nY, sizeof(WORD), 1, fp );
				fread( &Unit.Draw.nLayer, sizeof(WORD), 1, fp );
				fread( &codeU, sizeof(codeU), 1, fp );
				if( Unit.nType == MAP_UNIT_TYPE_RESOURCE )// Դ
				{
					DWORD dwTemp;
					fread( &dwTemp, sizeof(DWORD), 1, fp );
				}
				else if( Unit.nType == MAP_UNIT_TYPE_SOLDIER	// ʿ
					|| Unit.nType == MAP_UNIT_TYPE_SHIP 		// ս
					|| Unit.nType == MAP_UNIT_TYPE_LADDER 		// 
					|| Unit.nType == MAP_UNIT_TYPE_WORKER		// 
					|| Unit.nType == MAP_UNIT_TYPE_MAN			// ƽ
				)
				{
					WORD wTemp;
					fread( &wTemp, sizeof(WORD), 1, fp );
				}
			}
		}
		else
		{
			fread( &wCounter, sizeof(WORD), 1, fp );
			for( int y=0; y<wCounter; y++ )
			{
				struct UNIT_STRUCT Unit;
				fread( &Unit.nType, sizeof(BYTE), 1, fp );
				if( Unit.nType == MAP_UNIT_TYPE_NONE ) continue;
				fread( &Unit.Draw.nX, sizeof(WORD), 1, fp );
				fread( &Unit.Draw.nY, sizeof(WORD), 1, fp );
				fread( &Unit.Draw.nLayer, sizeof(WORD), 1, fp );
				fread( &codeU, sizeof(codeU), 1, fp );
				WORD codeUEx;
				if( (codeUEx = ::CTRL_UNIT_Create( Unit.Draw.nLayer, Unit.Draw.nX, Unit.Draw.nY, codeU )) == MAP_DATA_NONE )
				{
					OutputDebugString( "GAME_ReadMedFile Error(0): Read Med file error!\n" );
					ErrorMessage( hwnd, GAME_ERROR_ID+4,"Read Med file error: ", fname );
					return FALSE;
				}

				struct UNIT_STRUCT *pUnit = ::MAP_GetUnit( codeUEx );
				Assert( pUnit );
				Assert( EYE_IfUnitIsUnit( pUnit ) );
				Assert( pUnit->nID == codeUEx );
				if( EYE_IfUnitIsBuild( pUnit ) )
				{
					// սǷ
					RUN_CountDown[pUnit->Draw.nPlayer].nBuildings ++;

					if( EYE_IfUnitIsRes( pUnit ) )
					{
						fread( &pUnit->Build.nResource, sizeof(DWORD), 1, fp );
					}
					else
					{	// added by Liu Gang
						TY_IDProcess(pUnit->nID,JZFINISH,CBNULL);
					}
				}
				else if( EYE_IfUnitIsSoldier( pUnit ) )
				{
					// սǷ
					RUN_CountDown[pUnit->Draw.nPlayer].nSoldiers += EYE_GetFullLife( -1, pUnit->Draw.nFile );

					WORD nGenNum;
					fread( &nGenNum, sizeof(WORD), 1, fp );
					if( nGenNum != 0 )
					{
						Assert( nGenNum > 0 && nGenNum <= 118 );	// temp
						pUnit->Status.nID = codeUEx;
						pUnit->Status.nTaskID = ZUJIAN;
						if( EYE_IfUnitIsWorker( pUnit ) )
							pUnit->Status.nTaskIDEx = MAP_UNIT_TYPE_WGEN;		//ǹ˲
						else
							pUnit->Status.nTaskIDEx = MAP_UNIT_TYPE_GEN;		//ս
						Assert( nGenNum != MAP_DATA_NONE );
						pUnit->Status.nParam1 = nGenNum;	// 
						pUnit->Status.bDone = FALSE;
						RUN_GroupUnit( pUnit );
						pUnit->Status.nTaskID = QUXIAO;
						Assert( pUnit->nHasShadow == 1 );
					}
				}
			}
		}
	}

	fclose( fp );
	return TRUE;
} // end of GAME_ReadMedFileNet()
///////////

///////////
// ȡսļͷMINI_Load()ͼʹ
// hwnd		:	window to receive error message
// filename	:	battle field data file name
// path		:	battle field data file path
// return	:	TRUE if successful
BOOL GAME_ReadMEDHeader( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[65];
	
	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	FILE * fp = fopen( fname, "rb" );
	if( !fp )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+3,"Cannot open Med file header: ", fname );
		return FALSE;
	}

	// read MED file version
	fread( &GAME.lVerMED, sizeof(long), 1, fp );

	// read MED file( Map Editer Data file )
	char strTemp[65];
	// read name of the battlefield
	int nName=0;
	fread( &nName, sizeof(BYTE), 1, fp );
	fread( GAME.strName, nName, 1, fp );
	GAME.strName[nName] = 0;
	
	// read size of the battlefield
	fread( &MAP_Lib.szNum.cx, sizeof(DWORD), 1, fp );
	fread( &MAP_Lib.szNum.cy, sizeof(DWORD), 1, fp );

	// read something not used
	fread( strTemp, sizeof(long)*(MAP_DATA_THICK+2), 1, fp );

	fclose( fp );
	return TRUE;

} // end of GAME_ReadMedHeader()


// ͷϷвĵԪ
void GAME_ReleaseAllUnits()
{
	int i,j;
	int nCounter, nMax;

	nCounter = 0;
	for( j=0; j<GAME_PLAYER_MAX; j++ )
	{
		nMax = GAME.Players[j].wUnitCounter;
		for( i=0; i<PLAYER_UNIT_MAX; i++ )
		{
			if( GAME.Players[j].Unit[i].nType != MAP_UNIT_TYPE_NONE )
			{
				CTRL_UNIT_Destroy( &GAME.Players[j].Unit[i] );
				nCounter++;
				if( nCounter >= nMax )
					break;
			}
		}
	}

	nCounter = 0;
	nMax = OTHER_nCounter;
	for( i=0; i<OTHER_MAX; i++ )
	{
		if( OTHER[i].nType != OTHER_TYPE_NONE )
		{
			OTHER_DestroyData( i );
			nCounter++;
			if( nCounter >= nMax )
				break;
		}
	}
}
///////////



///////////
// First demension: 0-4 are the Waiting List of player 0-4
// һ±꣺0-4Ϸ0-4ĵȴ
// defined in CBCtrl.cpp
extern struct CTRL_TASK_STRUCT	CTRL_TaskList[GAME_PLAYER_MAX][CTRL_TASK_LIST_MAX+CTRL_TASK_LIST_MAX];
extern RECT DRAW_rcScreen;

// defined in CBMap.cpp
// ͼ
extern WORD MAP_wGroundData[MAP_DATA_THICK][MAP_DATA_WIDTH][MAP_DATA_HEIGHT];
// 飬ڲʹ
// ǲҪֱӷʣʹMAP_GetRegionData()رҪٶȵĵطƵõĵط
extern WORD MAP_wRegionData[MAP_DATA_WIDTH][MAP_DATA_HEIGHT];	

// defined in CBShadow.cpp
// array for second layer of shadow
extern char	cMap_shadowEx [MAP_DATA_WIDTH][MAP_DATA_HEIGHT]; //lwc¼ǷӰ

// defined in TEmperor.cpp
// save AI
extern WORD SaveArr[70000];
///////////

///////////
// Ϸļ
#define	GAME_SOUND_STEP0	1
#define	GAME_SOUND_STEP1	-2500
#define	GAME_SOUND_STEP2	-1500
#define	GAME_SOUND_STEP3	-800
#define	GAME_SOUND_STEP4	-300
#define	GAME_SOUND_STEP5	0

// defined in CBMain.cpp
BOOL GAME_ReadOptionFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[65];
	FILE *fp;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	fp = fopen( fname, "rt" );
	if( !fp )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+10,"Cannot open Option file: ", fname );
		return FALSE;
	}

	// 
	fscanf( fp, "%d %d %d %d %d\n", 
		&GAME.nSpeed,				// ٶȣÿ֡1000
		&GAME.nSpeedScroll,			// ٶ
		&GAME.nVolume,				// ЧСrange from 0 to -50001ʱر
		&GAME.nVolumeCD,			// ֵСrange from 0 to -50001ʱر
		&GAME.bFightEnabled );		// AVIĿ
		//&GAME.bFogOfWar );			// Ӱ

	// ֱЧС
	int nVolume;
	switch( GAME.nVolume )
	{
	case	0:
		nVolume = GAME_SOUND_STEP0;		break;
	case	1:
		nVolume = GAME_SOUND_STEP1;		break;
	case	2:
		nVolume = GAME_SOUND_STEP2;		break;
	case	3:
		nVolume = GAME_SOUND_STEP3;		break;
	case	4:
		nVolume = GAME_SOUND_STEP4;		break;
	case	5:
		nVolume = GAME_SOUND_STEP5;		break;
	default:
		nVolume = 0;
	}
	DS_VolumeSound( nVolume );
	if( nVolume > 0 )
	{
		EFFECT_bEnable = FALSE;
		DS_EnableSound( FALSE );
	}
	else if( DS_IfSoundEnable() == FALSE )
	{
		EFFECT_bEnable = TRUE;
		DS_EnableSound( TRUE );
		//-------------
//		DATA_WAVE_MusicPlay( GAME.nMusicID );
		//-------------
	}

	if( GAME_nDisk == 0 )
	{// ׼ǿ
		GAME.nVolumeCD = GAME.nVolume;	// ĿǰֺЧһ
	}

	// ЧִС
	//MCI_DGV_SETAUDIO_VOLUME 
	// ֱCDִС
	switch( GAME.nVolumeCD )
	{
	case	0:
		if( MUSIC_bEnable == TRUE )
		{
			DATA_WAVE_MusicStop();
			MUSIC_bEnable = FALSE;
		}
		break;
	case	1:
	case	2:
	case	3:
	case	4:
	case	5:
		if( MUSIC_bEnable == FALSE )
		{
			MUSIC_bEnable = TRUE;
			DATA_WAVE_MusicReplay();
		}
		break;
	}

	fclose( fp );
	return TRUE;
}

// дϷļ
BOOL GAME_WriteOptionFile( HWND hwnd, LPCTSTR filename, LPCTSTR path )
{
	char fname[65];
	FILE *fp;

	if( path != 0 )
	{
		strcpy( fname, path );
		strcat( fname, filename );
	}
	else	strcpy( fname, filename );
	fp = fopen( fname, "wt" );
	if( !fp )
	{
		ErrorMessage( hwnd, GAME_ERROR_ID+11,"Cannot open Option file: ", fname );
		return FALSE;
	}

	// д
	fprintf( fp, "%d %d %d %d %d\n", 
		GAME.nSpeed,				// ٶ
		GAME.nSpeedScroll,			// ٶ
		GAME.nVolume,				// ЧСrange from 0 to -50001ʱر
		GAME.nVolumeCD,				// ֵСrange from 0 to -50001ʱر
		GAME.bFightEnabled );			// AVIĿ
		//GAME.bFogOfWar );			// Ӱ

	// ֱЧС
	int nVolume;
	switch( GAME.nVolume )
	{
	case	0:
		nVolume = GAME_SOUND_STEP0;		break;
	case	1:
		nVolume = GAME_SOUND_STEP1;		break;
	case	2:
		nVolume = GAME_SOUND_STEP2;		break;
	case	3:
		nVolume = GAME_SOUND_STEP3;		break;
	case	4:
		nVolume = GAME_SOUND_STEP4;		break;
	case	5:
		nVolume = GAME_SOUND_STEP5;		break;
	default:
		nVolume = 0;
	}
	DS_VolumeSound( nVolume );
	if( nVolume > 0 )
	{
		EFFECT_bEnable = FALSE;
		DS_EnableSound( FALSE );
	}
	else if( DS_IfSoundEnable() == FALSE )
	{
		EFFECT_bEnable = TRUE;
		DS_EnableSound( TRUE );
		//-------------
//		DATA_WAVE_MusicPlay( GAME.nMusicID );
		//-------------
	}

	if( GAME_nDisk == 0 )
	{// ׼ǿ
		GAME.nVolumeCD = GAME.nVolume;	// ĿǰֺЧһ
	}

	// ЧִС
	//MCI_DGV_SETAUDIO_VOLUME 
	// ֱCDִС
	switch( GAME.nVolumeCD )
	{
	case	0:
		if( MUSIC_bEnable == TRUE )
		{
			DATA_WAVE_MusicStop();
			MUSIC_bEnable = FALSE;
		}
		break;
	case	1:
	case	2:
	case	3:
	case	4:
	case	5:
		if( MUSIC_bEnable == FALSE )
		{
			MUSIC_bEnable = TRUE;
			DATA_WAVE_MusicReplay();
		}
		break;
	}

	fclose( fp );
	return TRUE;
}
///////////

///////////
// 

// Oct.6.1997
// defined in CBEvent.cpp, ¼
extern WORD EventPos[34][5];
// defined in CBDraw.cpp
// ѡΪĿĵصĵԪҪ˸ʾı߽
extern int DRAW_BLINK_nCounter;
extern int DRAW_BLINK_nDelay;
extern BOOL DRAW_BLINK_bDraw;
extern WORD DRAW_BLINK_nID;
extern int DRAW_BLINK_nSave;

// 
// nSlot	:	ļ
//#define		_L_DEBUG
#ifdef	_L_DEBUG
char *game_lwc;
char * map_lib_lwc;
char * data_lib_lwc;
char * other_ncounter_lwc ;
char * other_lwc;
char * ctrl_tasklist_lwc;
char * ctrl_nhitcounter_lwc;
char * ctrl_hitsrc_lwc;
char * byte_lwc;
char * strnamemed_lwc;
char * map_wregiondata_lwc;
char * cmap_shadowex_lwc;
char * map_wunitdata_lwc;
char * map_wgrounddata_lwc;
char * savearr_lwc;
char * noffx_lwc;
char * noffy_lwc;
char * face_current_prompt_block_lwc;
char * face_currentcommandunitid_lwc;
char * face_currentcommandunitflag_lwc;
char * ctrl_task_savecmdunit_lwc;
#endif
BOOL GAME_Save( int nSlot )
{
	char name[32];
	GAME_MakeSaveName( nSlot, ".SAV", name );

	FILE *fp;

	fp = fopen( name, "wb" );
	if( !fp )
	{
		OutputDebugString( "GAME_Save Error: Cannot open file!\n" );
		return FALSE;
	}

	// дͷϢ
	char strInfo[64];
	GAME_CalcSaveInfo( strInfo );
	BYTE nLen = strlen( strInfo );
	fwrite( &nLen, sizeof(BYTE), 1, fp );
	fwrite( strInfo, nLen, 1, fp );

	//lwc1
	// GAMEṹ(char *)&
	Lgame_save ( fp ,sizeof ( GAME ) ,(char *)&GAME );
	#ifdef	_L_DEBUG
	//fwrite( &GAME, sizeof( GAME ), 1, fp );
	if ((game_lwc=new char [sizeof(GAME)]) == NULL )
	{
		return ( 0 );
	}
	test (game_lwc ,sizeof ( GAME ) , (char *)&GAME );
	#endif

	// MAP_Libṹ
	Lgame_save ( fp ,sizeof ( MAP_Lib ) ,(char *)&MAP_Lib );
	#ifdef	_L_DEBUG
	if ((map_lib_lwc=new char [sizeof (MAP_Lib)]) == NULL )
	{
		return ( 0 );
	}
	test ( map_lib_lwc ,sizeof ( MAP_Lib ) ,(char *)&MAP_Lib );
	//fwrite( &MAP_Lib, sizeof( MAP_Lib ), 1, fp );
	#endif

	// DATAṹ
	Lgame_save ( fp ,sizeof ( DATA_Lib ) ,(char *)&DATA_Lib );
	#ifdef	_L_DEBUG
	if (( data_lib_lwc=new char [ sizeof(DATA_Lib)]) == NULL )
	{
		return ( 0 );
	}
	test ( data_lib_lwc,sizeof ( DATA_Lib ) ,(char *)&DATA_Lib );
	//fwrite( &DATA_Lib, sizeof( DATA_Lib ), 1, fp );
	#endif

	// OTHERṹ
	Lgame_save ( fp ,sizeof ( OTHER_nCounter ) ,(char *)&OTHER_nCounter );
	#ifdef	_L_DEBUG
	if (( other_ncounter_lwc=new char [sizeof ( OTHER_nCounter) ]) == NULL )
	{
		return ( 0 );
	}
	test ( other_ncounter_lwc ,sizeof ( OTHER_nCounter ) ,(char *)&OTHER_nCounter );
	#endif

	Lgame_save ( fp ,sizeof ( OTHER ) ,(char *)&OTHER );
	#ifdef	_L_DEBUG
	if ((other_lwc =new char [sizeof (OTHER) ]) == NULL )
	{
		return ( 0 );
	}
	test ( other_lwc ,sizeof ( OTHER ) ,(char *)&OTHER );
	//fwrite( &OTHER_nCounter, sizeof( int ), 1, fp );
	//fwrite( &OTHER, sizeof( OTHER ), 1, fp );
	#endif

	// 
	Lgame_save ( fp ,sizeof ( CTRL_TaskList ) ,(char *)&CTRL_TaskList );
	#ifdef	_L_DEBUG
	if (( ctrl_tasklist_lwc=new char [sizeof (CTRL_TaskList ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( ctrl_tasklist_lwc ,sizeof ( CTRL_TaskList ) ,(char *)&CTRL_TaskList );
	//fwrite( &CTRL_TaskList, sizeof( CTRL_TaskList ), 1, fp );
	#endif

	// 潹
	Lgame_save ( fp ,sizeof ( CTRL_nHitCounter ) ,(char *)&CTRL_nHitCounter );
	#ifdef	_L_DEBUG
	if ((ctrl_nhitcounter_lwc =new char [sizeof (CTRL_nHitCounter) ]) == NULL )
	{
		return ( 0 );
	}
	test ( ctrl_nhitcounter_lwc ,sizeof ( CTRL_nHitCounter ) ,(char *)&CTRL_nHitCounter );
	#endif

	Lgame_save ( fp ,sizeof ( CTRL_hitSrc ) ,(char *)&CTRL_hitSrc );
	#ifdef	_L_DEBUG
	if (( ctrl_hitsrc_lwc=new char [sizeof (CTRL_hitSrc ) ]) == NULL )
	{
		return ( 0 );
	}
	test( ctrl_hitsrc_lwc ,sizeof ( CTRL_hitSrc ) ,(char *)&CTRL_hitSrc );
	//fwrite( &CTRL_nHitCounter, sizeof( CTRL_nHitCounter ), 1, fp );
	//fwrite( &CTRL_hitSrc, sizeof( CTRL_hitSrc ), 1, fp );
	#endif

	// սͼļ
	nLen = strlen( GAME.strNameMED );
	Lgame_save ( fp ,sizeof ( BYTE ) ,(char *)&nLen );
	#ifdef	_L_DEBUG
	if ((byte_lwc =new char [sizeof (BYTE ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( byte_lwc ,sizeof ( BYTE ) ,(char *)&nLen );
	#endif

	Lgame_save ( fp ,sizeof ( nLen ) ,GAME.strNameMED );
	#ifdef	_L_DEBUG
	if (( strnamemed_lwc=new char [sizeof (nLen ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( strnamemed_lwc ,sizeof ( nLen ) ,GAME.strNameMED );
	//fwrite( &nLen, sizeof( BYTE ), 1, fp );
	//fwrite( GAME.strNameMED, nLen, 1, fp );
	#endif

	// Ӱ
	Lgame_save ( fp ,sizeof ( MAP_wRegionData ) ,(char *)MAP_wRegionData );
	#ifdef	_L_DEBUG
	if (( map_wregiondata_lwc=new char [sizeof ( MAP_wRegionData) ]) == NULL )
	{
		return ( 0 );
	}
	test ( map_wregiondata_lwc,sizeof ( MAP_wRegionData ) ,(char *)MAP_wRegionData );
	#endif

	Lgame_save ( fp ,sizeof (cMap_shadowEx ) ,(char *)cMap_shadowEx );
	#ifdef	_L_DEBUG
	if (( cmap_shadowex_lwc=new char [sizeof (cMap_shadowEx ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( cmap_shadowex_lwc ,sizeof (cMap_shadowEx ) ,(char *)cMap_shadowEx );
	//fwrite( MAP_wRegionData, sizeof( MAP_wRegionData ), 1, fp );
	//fwrite( cMap_shadowEx, sizeof( cMap_shadowEx ), 1, fp );
	#endif

	// UNIT
	Lgame_save ( fp ,sizeof (MAP_wUnitData ) ,(char *)MAP_wUnitData );
	#ifdef	_L_DEBUG
	if ((map_wunitdata_lwc =new char [sizeof (MAP_wUnitData ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( map_wunitdata_lwc ,sizeof (MAP_wUnitData ) ,(char *)MAP_wUnitData );
	//fwrite( MAP_wUnitData, sizeof( MAP_wUnitData ), 1, fp );
	#endif

	// 飨һ㼴ɣ
	Lgame_save ( fp ,sizeof ( MAP_wGroundData ) ,(char *)MAP_wGroundData );
	#ifdef	_L_DEBUG
	if ((map_wgrounddata_lwc =new char [sizeof (MAP_wGroundData ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( map_wgrounddata_lwc ,sizeof ( MAP_wGroundData ) ,(char *)MAP_wGroundData );
	//fwrite( MAP_wGroundData, sizeof( MAP_wGroundData ), 1, fp );
	#endif

	// 
	SaveAIPos();
	Lgame_save ( fp ,sizeof ( SaveArr ) ,(char *)SaveArr );
	#ifdef	_L_DEBUG
	if (( savearr_lwc=new char [sizeof (SaveArr ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( savearr_lwc ,sizeof ( SaveArr ) ,(char *)SaveArr );
	//fwrite( SaveArr, sizeof( SaveArr ), 1, fp );
	#endif

	// 浱ǰĻλ
	int width = DRAW_rcScreen.right - DRAW_rcScreen.left;
	int height = DRAW_rcScreen.bottom - DRAW_rcScreen.top;
	int nOffX = DRAW_rcScreen.left + (width>>1);
	int nOffY = DRAW_rcScreen.top + (height>>2)+12;
	Lgame_save ( fp ,sizeof ( int ) ,(char *)&nOffX );
	#ifdef	_L_DEBUG
	if ((noffx_lwc =new char [sizeof (int ) ]) == NULL )
	{
		return ( 0 );
	}
	test( noffx_lwc ,sizeof ( int ) ,(char *)&nOffX );
	#endif

	Lgame_save ( fp ,sizeof ( int ) ,(char *)&nOffY );
	#ifdef	_L_DEBUG
	if ((noffy_lwc =new char [sizeof ( int ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( noffy_lwc ,sizeof ( int ) ,(char *)&nOffY );
	//fwrite( &nOffX, sizeof( int ), 1, fp );
	//fwrite( &nOffY, sizeof( int ), 1, fp );
	#endif

	// Ϣʾ
	Lgame_save ( fp, sizeof ( FACE_CURRENT_PROMPT_BLOCK ), (char *)&FACE_CURRENT_PROMPT_BLOCK);
	#ifdef	_L_DEBUG
	if ((face_current_prompt_block_lwc =new char [sizeof ( FACE_CURRENT_PROMPT_BLOCK) ]) == NULL )
	{
		return ( 0 );
	}
	test ( face_current_prompt_block_lwc ,sizeof ( FACE_CURRENT_PROMPT_BLOCK ), (char *)&FACE_CURRENT_PROMPT_BLOCK);
	//fwrite(	&FACE_CURRENT_PROMPT_BLOCK, sizeof( PROMPT_BLOCK ), 1, fp );
	#endif
	// 
	Lgame_save ( fp ,sizeof ( int ) ,(char *)&FACE_CurrentCommandUnitID );
	#ifdef	_L_DEBUG
	if ((face_currentcommandunitid_lwc =new char [sizeof ( int ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( face_currentcommandunitid_lwc ,sizeof ( int ) ,(char *)&FACE_CurrentCommandUnitID );
	#endif

	Lgame_save ( fp ,sizeof ( DWORD ) ,(char *)&FACE_CurrentCommandUnitFlag );
	#ifdef	_L_DEBUG
	if (( face_currentcommandunitflag_lwc=new char [sizeof ( DWORD ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( face_currentcommandunitflag_lwc ,sizeof ( DWORD ) ,(char *)&FACE_CurrentCommandUnitFlag );
	//fwrite( &FACE_CurrentCommandUnitID, sizeof( int ), 1, fp );
	//fwrite(	&FACE_CurrentCommandUnitFlag, sizeof( DWORD ), 1, fp );
	#endif

	// 浱ǰ
	Lgame_save ( fp ,sizeof ( CTRL_TASK_saveCmdUnit ) ,(char *)&CTRL_TASK_saveCmdUnit );
	#ifdef	_L_DEBUG
	if ((ctrl_task_savecmdunit_lwc =new char [sizeof (CTRL_TASK_saveCmdUnit ) ]) == NULL )
	{
		return ( 0 );
	}
	test ( ctrl_task_savecmdunit_lwc ,sizeof ( CTRL_TASK_saveCmdUnit ) ,(char *)&CTRL_TASK_saveCmdUnit );
	#endif

	//fwrite( &CTRL_TASK_saveCmdUnit, sizeof( CTRL_TASK_saveCmdUnit ), 1, fp );
	// ǷִоAI԰Ч
	Lgame_save ( fp, sizeof( RUN_bAUTO ), (char *)&RUN_bAUTO );

	// ʱ
	GetSystemTime( &GAME_Time.Now );
	GAME_Time.Sub = TimeSub( GAME_Time.Now, GAME_Time.Start );
	Lgame_save( fp, sizeof( GAME_Time ), (char*)&GAME_Time );

	// ¼ݣOct.6.1997
	fwrite( EventPos, sizeof( EventPos ), 1, fp );

	// ˸
	fwrite( &DRAW_BLINK_nCounter, sizeof( DRAW_BLINK_nCounter ), 1, fp );
	fwrite( &DRAW_BLINK_nDelay, sizeof( DRAW_BLINK_nDelay ), 1, fp );
	fwrite( &DRAW_BLINK_bDraw, sizeof( DRAW_BLINK_bDraw ), 1, fp );
	fwrite( &DRAW_BLINK_nID, sizeof( DRAW_BLINK_nID ), 1, fp );
	fwrite( &DRAW_BLINK_nSave, sizeof( DRAW_BLINK_nSave ), 1, fp );

	fclose( fp );

	#ifdef	_L_DEBUG
	GAME_Load( nSlot );
	#endif

	return TRUE;
}

// ȡ
// nSlot	:	ļ
BOOL GAME_Load( int nSlot )
{
	char name[32];
	GAME_MakeSaveName( nSlot, ".SAV", name );

	FILE *fp;

	// Ϸ
	if( GAME_bBegin == TRUE )
		GAME_End( -1 );

	Assert( GAME_bBegin == FALSE );

	// ȡļ
	fp = fopen( name, "rb" );
	if( !fp )
	{
		OutputDebugString( "GAME_Load Error: Cannot open file!\n" );
		return FALSE;
	}

	// Ԫ
	//FACE_ShowCommandUnit( COMMANDUNIT_NONE, 0xFFFF );

//	GAME_ReleaseAllUnits();

	// ͷϢ
	char strInfo[64];
	BYTE nLen;
	
	fread( &nLen, sizeof(BYTE), 1, fp );
	fread( strInfo, nLen, 1, fp );

	// ȡGAMEṹ
	Lgame_load ( fp, sizeof ( GAME ), (char *)&GAME );
	#ifdef	_L_DEBUG
	short ijk ;
	ijk=testcmp (game_lwc ,sizeof ( GAME ), (char *)&GAME );
	delete (game_lwc);
	//fread( &GAME, sizeof( GAME ), 1, fp );
	#endif

	// set allies
	// Aug. 28. 1997
	GAME_SetAlly( 0, 1 );
	GAME_SetAlly( 0, 2 );
	GAME_SetAlly( 0, 3 );
	GAME_SetAlly( 0, 4 );

	// ȡMAP_Libṹ
	Lgame_load ( fp, sizeof ( MAP_Lib ), (char *)&MAP_Lib );
	#ifdef	_L_DEBUG
	ijk=testcmp (map_lib_lwc,sizeof ( MAP_Lib ), (char *)&MAP_Lib );
	delete (map_lib_lwc);
	#endif
	//fread( &MAP_Lib, sizeof( MAP_Lib ), 1, fp );

	// ȡDATAṹ
	Lgame_load ( fp, sizeof ( DATA_Lib ), (char *)&DATA_Lib );
	#ifdef	_L_DEBUG
	ijk=testcmp (data_lib_lwc,sizeof ( DATA_Lib ), (char *)&DATA_Lib );
	delete (data_lib_lwc);
	//fread( &DATA_Lib, sizeof( DATA_Lib ), 1, fp );
	#endif

	// ȡOTHERṹ
	Lgame_load ( fp, sizeof ( int ), (char *)&OTHER_nCounter );
	#ifdef	_L_DEBUG
	ijk=testcmp (other_ncounter_lwc,sizeof ( int ), (char *)&OTHER_nCounter );
	delete (other_ncounter_lwc);
	#endif

	Lgame_load ( fp, sizeof ( OTHER ), (char *)&OTHER );
	#ifdef	_L_DEBUG
	ijk=testcmp (other_lwc,sizeof ( OTHER ), (char *)&OTHER );
	delete (other_lwc);
	//fread( &OTHER_nCounter, sizeof( int ), 1, fp );
	//fread( &OTHER, sizeof( OTHER ), 1, fp );
	#endif	

	// ȡ
	Lgame_load ( fp, sizeof ( CTRL_TaskList ), (char *)&CTRL_TaskList );
	#ifdef	_L_DEBUG
	ijk=testcmp (ctrl_tasklist_lwc,sizeof ( CTRL_TaskList ), (char *)&CTRL_TaskList );
	delete (ctrl_tasklist_lwc);
	//fread( &CTRL_TaskList, sizeof( CTRL_TaskList ), 1, fp );
	#endif

	// Nov.9.1997
	// Ϊ̵ִļԣҪͷָβָ
	for( int i=0; i<GAME_PLAYER_MAX; i++ )
	{
		CTRL_nTaskHead[i] = 0;
		CTRL_nTaskTail[i] = 0;
	}

	// ȡ
	Lgame_load ( fp, sizeof ( CTRL_nHitCounter ), (char *)&CTRL_nHitCounter );
	#ifdef	_L_DEBUG
	ijk=testcmp (ctrl_nhitcounter_lwc,sizeof ( CTRL_nHitCounter ), (char *)&CTRL_nHitCounter );
	delete (ctrl_nhitcounter_lwc);
	#endif

	Lgame_load ( fp, sizeof ( CTRL_hitSrc ), (char *)&CTRL_hitSrc );
	#ifdef	_L_DEBUG
	ijk=testcmp (ctrl_hitsrc_lwc,sizeof ( CTRL_hitSrc ), (char *)&CTRL_hitSrc );
	delete (ctrl_hitsrc_lwc);
	//fread( &CTRL_nHitCounter, sizeof( CTRL_nHitCounter ), 1, fp );
	//fread( &CTRL_hitSrc, sizeof( CTRL_hitSrc ), 1, fp );
	#endif
	CTRL_TASK_Clear( &CTRL_hitDest );

	// ȡսͼļ
	Lgame_load ( fp, sizeof ( BYTE ), (char *)&nLen );
	#ifdef	_L_DEBUG
	ijk=testcmp (byte_lwc,sizeof ( BYTE ), (char *)&nLen );
	delete (byte_lwc);
	#endif

	Lgame_load ( fp, sizeof ( nLen ), GAME.strNameMED );
	#ifdef	_L_DEBUG
	ijk=testcmp (strnamemed_lwc,sizeof ( nLen ), GAME.strNameMED );
	delete (strnamemed_lwc);
	//fread( &nLen, sizeof( BYTE ), 1, fp );
	//fread( GAME.strNameMED, nLen, 1, fp );
	#endif

	// ȡӰ
	Lgame_load ( fp, sizeof ( MAP_wRegionData ), (char *)MAP_wRegionData );
	#ifdef	_L_DEBUG
	ijk=testcmp (map_wregiondata_lwc,sizeof ( MAP_wRegionData ), (char *)MAP_wRegionData );
	delete (map_wregiondata_lwc);
	#endif

	Lgame_load ( fp, sizeof ( cMap_shadowEx ), (char *)cMap_shadowEx );
	#ifdef	_L_DEBUG
	ijk=testcmp (cmap_shadowex_lwc,sizeof ( cMap_shadowEx ), (char *)cMap_shadowEx );
	delete (cmap_shadowex_lwc);
	//fread( MAP_wRegionData, sizeof( MAP_wRegionData ), 1, fp );
	//fread( cMap_shadowEx, sizeof( cMap_shadowEx ), 1, fp );
	#endif

	// ȡUNIT
	Lgame_load ( fp, sizeof ( MAP_wUnitData ), (char *)MAP_wUnitData );
	#ifdef	_L_DEBUG
	ijk=testcmp (map_wunitdata_lwc,sizeof ( MAP_wUnitData ), (char *)MAP_wUnitData );
	delete (map_wunitdata_lwc);
	//fread( MAP_wUnitData, sizeof( MAP_wUnitData ), 1, fp );
	#endif

	// ȡ飨һ㼴ɣ
	Lgame_load ( fp, sizeof ( MAP_wGroundData ), (char *)MAP_wGroundData);
	#ifdef	_L_DEBUG
	ijk=testcmp (map_wgrounddata_lwc,sizeof ( MAP_wGroundData ), (char *)MAP_wGroundData);
	delete (map_wgrounddata_lwc);
	//fread( MAP_wGroundData, sizeof( MAP_wGroundData ), 1, fp );
	#endif

	// ȡ
	Lgame_load ( fp, sizeof ( SaveArr ), (char *)SaveArr );
	#ifdef	_L_DEBUG
	ijk=testcmp (savearr_lwc,sizeof ( SaveArr ), (char *)SaveArr );
	delete (savearr_lwc);
	#endif
	//fread( SaveArr, sizeof( SaveArr ), 1, fp );
	LoadAIPos();

	// ¶ȡͼ
	MINI_Load();
	MINI_DrawAll( TRUE );

	// ȡǰĻλ
	POINT ptStart;	
	Lgame_load ( fp, sizeof ( int ), (char *)&ptStart.x );
	#ifdef	_L_DEBUG
	ijk=testcmp (noffx_lwc,sizeof ( int ), (char *)&ptStart.x );
	delete (noffx_lwc);
	#endif

	Lgame_load ( fp, sizeof ( int ), (char *)&ptStart.y );
	#ifdef	_L_DEBUG
	ijk=testcmp (noffy_lwc,sizeof ( int ), (char *)&ptStart.y );
	delete (noffy_lwc);	
	//fread( &ptStart.x, sizeof( int ), 1, fp );
	//fread( &ptStart.y, sizeof( int ), 1, fp );
	#endif
	DRAW_JumpScreen( ptStart );

	// Ļ߲Ӱť
	for( i=0; i<PLAYER_GROUP_MAX-1; i++ )
	{
		if( GAME.Players[GAME.nMe].wGroup[i] != MAP_DATA_NONE )
			FACE_SetNumberButtonState( i, BUTTON_UP, FALSE );
		else
			FACE_SetNumberButtonState( i, BUTTON_DISABLE, FALSE );
	}
	if( GAME.Players[GAME.nMe].wGroup[i] != MAP_DATA_NONE )
		FACE_SetNumberButtonState( i, BUTTON_UP, TRUE );
	else
		FACE_SetNumberButtonState( i, BUTTON_DISABLE, TRUE );

	// ȡϢʾ
	struct	PROMPT_BLOCK	temp;
	Lgame_load ( fp, sizeof ( PROMPT_BLOCK ), (char *)&temp );
	#ifdef	_L_DEBUG
	ijk=testcmp (face_current_prompt_block_lwc,sizeof ( PROMPT_BLOCK ), (char *)&temp );
	delete (face_current_prompt_block_lwc);
	//fread(	&temp, sizeof( PROMPT_BLOCK ), 1, fp );
	#endif
	// ȡϢʾ
	FACE_SetCurrentPromptBlock( temp );

	// ȡ
	int nUnitID;
	DWORD dwFlag;
	Lgame_load ( fp, sizeof ( int ), (char *)&nUnitID );
	#ifdef	_L_DEBUG
	ijk=testcmp (face_currentcommandunitid_lwc,sizeof ( int ), (char *)&nUnitID );
	delete (face_currentcommandunitid_lwc);
	#endif

	Lgame_load ( fp, sizeof ( DWORD ), (char *)&dwFlag );
	#ifdef	_L_DEBUG
	ijk=testcmp (face_currentcommandunitflag_lwc ,sizeof ( DWORD ), (char *)&dwFlag );
	delete (face_currentcommandunitflag_lwc );	
	//fread( &nUnitID, sizeof( int ), 1, fp );
	//fread(	&dwFlag, sizeof( DWORD ), 1, fp );
	#endif
	FACE_ShowCommandUnit( nUnitID, dwFlag );

	// ȡǰ
	Lgame_load ( fp, sizeof ( CTRL_TASK_saveCmdUnit ), (char *)&CTRL_TASK_saveCmdUnit );
	//	fread( &CTRL_TASK_saveCmdUnit, sizeof( CTRL_TASK_saveCmdUnit ), 1, fp );

	// ȡǷִоAI԰Ч
	Lgame_load ( fp, sizeof( RUN_bAUTO ), (char *)&RUN_bAUTO );
	
	// ȡʱ
	Lgame_load ( fp, sizeof( GAME_Time ), (char*)&GAME_Time );
	GetSystemTime( &GAME_Time.Now );
	GAME_Time.Start = TimeSub( GAME_Time.Now, GAME_Time.Sub );

	// ȡ¼ݣOct.6.1997
	fread( EventPos, sizeof( EventPos ), 1, fp );

	// ȡ˸
	fread( &DRAW_BLINK_nCounter, sizeof( DRAW_BLINK_nCounter ), 1, fp );
	fread( &DRAW_BLINK_nDelay, sizeof( DRAW_BLINK_nDelay ), 1, fp );
	fread( &DRAW_BLINK_bDraw, sizeof( DRAW_BLINK_bDraw ), 1, fp );
	fread( &DRAW_BLINK_nID, sizeof( DRAW_BLINK_nID ), 1, fp );
	fread( &DRAW_BLINK_nSave, sizeof( DRAW_BLINK_nSave ), 1, fp );

	fclose( fp );

	// read general information
	// õǰݺ
	GAME_nSlot = nSlot;

	// 
	DATA_WAVE_MusicPlay( GAME.nMusicID );

	GAME_bBegin = TRUE;	// set flag
	return TRUE;
}
///////////

///////////
// õϢ
// nSlot	:	ļ
// strInfo	:	ӴļõĴϢ
BOOL GAME_GetSaveInfo( int nSlot, LPSTR strInfo )
{
	char name[32];
	GAME_MakeSaveName( nSlot, ".SAV", name );

	FILE *fp;

	fp = fopen( name, "rb" );
	if( !fp )
	{
		OutputDebugString( "GAME_GetSaveInfo Error: Cannot open file!\n" );
		return FALSE;
	}

	BYTE nLen;
	fread( &nLen, sizeof(BYTE), 1, fp );
	fread( strInfo, nLen, 1, fp );
	strInfo[nLen] = 0;

	fclose( fp );
	return TRUE;
}

// ôϢ
// strInfo	:	ĴϢϢý洢ļ
BOOL GAME_CalcSaveInfo( LPSTR strInfo )
{
	//strcpy( strInfo, "This is a Save file test!" );
	strcpy( strInfo, " " );
	if( GAME_nDisk == 1 )
	{
		strcat( strInfo, "A " );
	}
	else if( GAME_nDisk == 2 )
	{
		strcat( strInfo, "B " );
	}
	else
	{
		strcat( strInfo, " " );
	}
	strcat( strInfo, GAME.strName );
	strcat( strInfo, "  " );
	GetSystemTime( &GAME_Time.Now );
	GAME_Time.Sub = TimeSub( GAME_Time.Now, GAME_Time.Start );
	if( GAME_Time.Sub.wHour >= 24 )
	{
		OutputDebugString( "GAME Calc save info error, Hour!\n" );
	}
	else if( GAME_Time.Sub.wHour > 0 )
	{
		char tmp[4];
		wsprintf( tmp, "%02d", GAME_Time.Sub.wHour );
		strcat( strInfo, tmp );
		strcat( strInfo, ":" );
	}
	if( GAME_Time.Sub.wMinute >= 60 )
	{
		OutputDebugString( "GAME Calc save info error, Minute\n" );
	}
	else if( GAME_Time.Sub.wMinute >= 0 )
	{
		char tmp[4];
		//itoa( GAME_Time.Sub.wMinute, tmp, 10 );
		wsprintf( tmp, "%02d", GAME_Time.Sub.wMinute );
		strcat( strInfo, tmp );
		strcat( strInfo, ":" );
	}
	if( GAME_Time.Sub.wSecond >= 60 )
	{
		OutputDebugString( "GAME Calc save info error, Second\n" );
	}
	else if( GAME_Time.Sub.wSecond >= 0 )
	{
		char tmp[4];
		//itoa( GAME_Time.Sub.wSecond, tmp, 10 );
		wsprintf( tmp, "%02d", GAME_Time.Sub.wSecond );
		strcat( strInfo, tmp );
	}

	return TRUE;
}
///////////

///////////
// Ϸʼ
BOOL GAME_Begin( int nGameID )
{

	if( GAME_bBegin == TRUE )
	{
		GAME_End( nGameID );
	}

	Assert( GAME_bBegin == FALSE );

// ʼ
	// initialize game players data
	GAME_InitGamePlayers();

	// initialize battle map data, ground, unit, region
	MAP_InitGUR();
	SHADOW_Clear();

	// reset mouse state
	MOUSE_SetState( MOUSE_STATE_NONE, TRUE );

	// reset control
	CTRL_InitCtrl();

	// reset other
	OTHER_InitOther();

	// ʼ¼,Oct.7.1997
	void EVENT_Init();

	// -- TY
	//AIʼ
	TY_EmprerorAIPosClear();
	// -- TY

	// 
	FACE_ShowCommandUnit( COMMANDUNIT_NONE, 0xFFFF );
	// initialize command units
	CTRL_TASK_saveCmdUnit.Cmd = COMMANDUNIT_NONE;
	CTRL_TASK_saveCmdUnit.Ex = 0xFFFFFFFF;
	CTRL_TASK_saveCmdUnit.Busy = 0;
	CTRL_TASK_ClearAssembleSrc( TRUE );
	CTRL_TASK_ClearAssembleDest();

	// Ϣ
	struct	PROMPT_BLOCK	temp;
	temp.PromptBlockId = PROMPT_NONE;	
	FACE_ShowPromptBlock( temp );

	// ʼսǷ֣Nov.6.1997
	memset( &RUN_CountDown, 0, sizeof( RUN_CountDown ) );

	// read files

// ȡսļ
	if( GAME_bDebugStage == TRUE )
	{
		FILE *fp = fopen( "stage.set", "rt" );
		if( fp )
		{
			fscanf( fp, "%d", &GAME.nID );
			fclose( fp );
		}
		GAME_bDebugStage = FALSE;
	}
	else
	{
		GAME.nID = nGameID;
	}

	// ¶ȡ̶
	DATA_ReloadDATAFile( hwndGame );
	if( nGameID != 0 && nGameID != 17 )	// ǵһ򲻶ԭĽá
	{	// ½ĸıݣ;
		GAME_GetGenInfo( GAME_nSlot );
	}
	else
	{
		GAME_nSlot = 99;
	}

	// load Game data, must after load shadow surfaces
	if( ! ::GAME_ReadBTLFile( hwndGame, GAME.nID, GAME.strNameBTL, GAME.strPathDAT ) ) 
	{
		OutputDebugString( "DRAW_LoadMaps Error(8): Read Battle data file error!\n" );
		return FALSE;
	}
	// load Game data header, must before load minimap surfaces
	if( ! ::GAME_ReadMEDHeader( hwndGame, GAME.strNameMED, GAME.strPathMED ) ) 
	{
		OutputDebugString( "DRAW_LoadMaps Error(10): Read med file error!\n" );
		return FALSE;
	}

	// Load minimap surfaces, must after read med header, before read med file
	// ͼҪ֪սͼĴСڶȡMEDļʱҪͼʾ
	OutputDebugString( "MiniMap Load:\n" );
	if( !MINI_Load() )
	{
		OutputDebugString( "DRAW_LoadMaps Error(6): Error when loading minimap surfaces!\n" );
		return FALSE;
	}

	if( ! ::GAME_ReadMEDFile( hwndGame, GAME.strNameMED, GAME.strPathMED ) ) 
	{
		OutputDebugString( "DRAW_LoadMaps Error(1): Read med file error!\n" );
		return FALSE;
	}

	// Ļ߲Ӱť
	for( int i=0; i<PLAYER_GROUP_MAX-1; i++ )
	{
		if( GAME.Players[GAME.nMe].wGroup[i] != MAP_DATA_NONE )
			FACE_SetNumberButtonState( i, BUTTON_UP, FALSE );
		else
			FACE_SetNumberButtonState( i, BUTTON_DISABLE, FALSE );
	}
	if( GAME.Players[GAME.nMe].wGroup[i] != MAP_DATA_NONE )
		FACE_SetNumberButtonState( i, BUTTON_UP, TRUE );
	else
		FACE_SetNumberButtonState( i, BUTTON_DISABLE, TRUE );

	// draw shadow
//	SHADOW_DrawAll();
	// draw minimap
	MINI_DrawAll();

	GAME_bBegin = TRUE;	// set flag
	//palMain.SetPalette();

	// play background music
//	DATA_WAVE_MusicPlay( GAME.nMusicID );

	// get system time
	GetSystemTime( &GAME_Time.Start );

	// jump screen
	DRAW_JumpScreen( GAME.ptStart[GAME.nMe] );
	return TRUE;
}

// Ϸ
void GAME_End( int nGameID )
{
	Assert( GAME_bBegin == TRUE );

	// release minimap surfaces
	MINI_Release();
	GAME_bBegin = FALSE;	// set flag
}

// ļõϢ飬õȫֽṹDATA_Lib.Gen
// nSlot	:	ļ
BOOL GAME_GetGenInfo( int nSlot )
{
	char name[32];
	GAME_MakeSaveName( nSlot, ".GEN", name );

	FILE *fp;

	// ȡļ
	fp = fopen( name, "rb" );
	if( !fp )
	{
		OutputDebugString( "GAME_GetGenInfo Error: Cannot open file!\n" );
		return FALSE;
	}

	//struct DATA_GENERAL_STRUCT	Gen[DATA_UNIT_GENERAL_MAX];
	//fread( DATA_Lib.Gen, sizeof( DATA_Lib.Gen ), 1, fp );
	for( int i=0; i<DATA_UNIT_GENERAL_MAX; i++ )
	{
		fread( &DATA_Lib.Gen[i].nLevel, sizeof(DATA_Lib.Gen[i].nLevel), 1, fp );
		fread( &DATA_Lib.Gen[i].nJingYan, sizeof(DATA_Lib.Gen[i].nJingYan), 1, fp );
	}


	fclose( fp );
	return TRUE;
}

// ѽϢ飬ȫֽṹDATA_Lib.Genдļ
// nSlot	:	ļ
void GAME_SetGenInfo( int nSlot )
{
	char name[32];
	GAME_MakeSaveName( nSlot, ".GEN", name );

	FILE *fp;

	// ȡļ
	fp = fopen( name, "wb" );
	if( !fp )
	{
		OutputDebugString( "GAME_SetGenInfo Error: Cannot open file!\n" );
		return;
	}

	//struct DATA_GENERAL_STRUCT	Gen[DATA_UNIT_GENERAL_MAX];
	//fwrite( DATA_Lib.Gen, sizeof( DATA_Lib.Gen ), 1, fp );
	for( int i=0; i<DATA_UNIT_GENERAL_MAX; i++ )
	{
		fwrite( &DATA_Lib.Gen[i].nLevel, sizeof(DATA_Lib.Gen[i].nLevel), 1, fp );
		fwrite( &DATA_Lib.Gen[i].nJingYan, sizeof(DATA_Lib.Gen[i].nJingYan), 1, fp );
	}

	fclose( fp );
}
///////////

///////////
// õװ·
// filename		:	Űװ·ļ
// strSrcPath	:	صİװ·
// nSize		:	·ַĴС
BOOL GAME_GetSrcPath( LPCTSTR filename, LPSTR strSrcPath, int nSize )
{
	FILE *fp;
	fp = fopen( filename, "rb" );
	if( !fp )
	{
//		ErrorMessage( hwndGame, GAME_ERROR_ID+31, "Cannot source path file!" );
		OutputDebugString( "Cannot source path file named: WayAhead.dat!\n" );
		return FALSE;
	}
	memset( strSrcPath, 0, nSize );
	int i=0;
	char c = fgetc( fp );
	while( feof( fp ) == 0 )
	{
		strSrcPath[i] = (char )(c^34);
		i++;
		if( i == nSize-1 ) break;
		c = fgetc( fp );
	}
	strSrcPath[i]=0;
	fclose( fp );
	return TRUE;
}
///////////

SYSTEMTIME TimeSub( SYSTEMTIME time1, SYSTEMTIME time2 )
{
	SYSTEMTIME timeSub;
	if( time1.wSecond<time2.wSecond )
	{
		time1.wMinute--;
		timeSub.wSecond = time1.wSecond+60-time2.wSecond;
	}
	else
	{
		timeSub.wSecond = time1.wSecond-time2.wSecond;
	}
	if( time1.wMinute<time2.wMinute )
	{
		time1.wHour--;
		timeSub.wMinute = time1.wMinute+60-time2.wMinute;
	}
	else
	{
		timeSub.wMinute = time1.wMinute-time2.wMinute;
	}
	if( time1.wHour<time2.wHour )
	{
		time1.wDay--;
		timeSub.wHour = time1.wHour+12-time2.wHour;
	}
	else
	{
		timeSub.wHour = time1.wHour-time2.wHour;
	}
	timeSub.wDay = time1.wDay-time2.wDay;
	return timeSub;
}

///////////
// ϷŽβȺ
// nType	:	
void GAME_Ending( int nType )
{
	char *strEnd[4]={ "liuwin", "liuwin1", "caowin","caowin1" };
	char *strPath="\\End\\";

	Assert( nType >=0 && nType < 4 );
/*
	char fullname[_MAX_FNAME];
	char fullpath[_MAX_PATH];
	strcpy( fullname, GAME_strSetupDirectory );
	strcat( fullname, strPath );
	strcpy( fullpath, fullname ); 
	strcat( fullname, strEnd[nType] );
	WinExec( fullname, SW_SHOWMAXIMIZED );
*/
	// to stop the music before play the end avi
//	WriteLogFile( "dead.log","1\n" );
//	DD_QuitGraph();
//	WriteLogFile( "dead.log","2\n" );
	DATA_WAVE_MusicStop();

	// İװ
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	memset(&si, 0, sizeof(si));
	si.cb=sizeof(si);
	si.dwFlags = STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_MAXIMIZE|SW_SHOW;
	char fullname[_MAX_FNAME];
	char fullpath[_MAX_PATH];
	strcpy( fullname, GAME_strSetupDirectory );
	strcat( fullname, strPath );
	strcpy( fullpath, fullname ); 
	strcat( fullname, strEnd[nType] );
	if(CreateProcess(NULL, fullname, 
			NULL, NULL, TRUE, 0, NULL, NULL, &si, &pi))
	{
		::ShowWindow( hwndGame, SW_HIDE );
		::UpdateWindow( hwndGame );

		WaitForInputIdle( pi.hProcess, INFINITE );
		//DWORD ret = WaitForSingleObject( pi.hProcess, INFINITE );
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
	}

}

///////////


///////////
// ͬˣ
// Aug. 20. 1997
// nPlayer1, nPlayer2	:	Ϸ
// bSet					:	TRUEʱΪͬˣΪͬ	
void GAME_SetAlly( int nPlayer1, int nPlayer2, BOOL bSet/*=TRUE*/ )
{
	if( nPlayer1 == nPlayer2 )
		return;
	GAME.Players[nPlayer1].nAllies[nPlayer2] = bSet;
	GAME.Players[nPlayer2].nAllies[nPlayer1] = bSet;
}


// Nov.10.1997
// CBAvi.cpp
extern int nCurrentVideoID;

// nType :	-1, continue the end procedure
//			0-3, begin some kind of ending, must used in the frist call
//			-2, jump to the last procedure
//			-3, shut down the program immediatly
BOOL GAME_EndingEx( int nType/*=-1*/ )
{
	static int nStep=0;
	static int nSType = -1;
	int i;
	char *strAVI[4][3]={ 
		{"liu1.avi","liu2.avi","liu3.avi"},
		{"liu11.avi","liu22.avi","liu33.avi"},
		{"cao1.avi","cao2.avi","cao3.avi"},
		{"cao11.avi","cao22.avi","cao33.avi"} };
	char *strBMP[4][3]={
		{"liu1.bmp","liu2.bmp","liu3.bmp"},
		{"liu4.bmp","liu5.bmp","liu6.bmp"},
		{"cao1.bmp","cao2.bmp","cao3.bmp"},
		{"cao4.bmp","cao5.bmp","cao6.bmp"} };
	char *strBMP2[18]={
		"cbname01.bmp", "cbname02.bmp", "cbname03.bmp", 
		"cbname04.bmp", "cbname05.bmp", "cbname06.bmp", 
		"cbname07.bmp", "cbname08.bmp", "cbname09.bmp", 
		"cbname10.bmp", "cbname11.bmp", "cbname12.bmp", 
		"cbname13.bmp", "cbname14.bmp", "cbname15.bmp", 
		"cbname16.bmp", "cbname17.bmp" };
	char fullpath[_MAX_PATH];
	char *strPath="\\End";
	//char *strPath="";
	POINT ptOne = { 343, 232 };
	RECT rcAVI = {45,69,285,249};
	static int bHighColor = FALSE;
	static WAVEDYNAMIC wave;
	static int nVideoID = -1;


	// ִйһ飬ִ
	if( nStep > 21 ) return TRUE;

	strcpy( fullpath, GAME_strSetupDirectory );
	strcat( fullpath, strPath );

	// ǷĻΪ640x480x16
	// the first time
	if( nStep == 0 )
	{
		// must add this function
		FACE_SetProgramState( PROGRAM_STATE_NONE );
		FACE_SetCommandState( COMMAND_STATE_NONE );
		CURSOR_Set( NULL );
		DD_EraseBackScreen();
		DDC_UpdateScreen();
		DATA_WAVE_MusicStop();
		DS_QuitSound();
		DD_QuitGraph();
		if( DD_InitGraph( hwndGame, 640, 480, 16, FALSE ) == FALSE )
	//	if( 1 )
		{	// ʧܣ򷵻
			bHighColor = FALSE;
			if( DD_InitGraph( hwndGame, 640, 480, 8, FALSE ) == FALSE )
			{
				ErrorMessage( hwndGame, 2000, "Cannot initialize graph mode\n" );
				return FALSE;
			}
		}
		else
		{
			bHighColor = TRUE;
		}

		DS_InitSound( hwndGame );
		// play background music
		strcpy( wave.strFileName, fullpath );
		strcat( wave.strFileName, "\\" );
		strcat( wave.strFileName, "vend.wav" );
		wave.Play();
	}
	// jump to game end
	if( nType == -2 )
	{
		if( bHighColor == TRUE 
			&& nVideoID != -1 )
		{
			MCI_AVI_Stop( hwndGame, nVideoID );
			MCI_AVI_Close( nVideoID );
			nVideoID = -1;
		}
		else if( nVideoID != -1 )
		{
			KillTimer( hwndGame, 0 );
			PostMessage( hwndGame, MM_MCINOTIFY, 99, nCurrentVideoID );
			nVideoID = -1;
		}
		nStep = 21;
		return TRUE;
	}
	if( nType == -3 )
	{
		if( bHighColor == TRUE 
			&& nVideoID != -1 )
		{
			MCI_AVI_Stop( hwndGame, nVideoID );
			MCI_AVI_Close( nVideoID );
			nVideoID = -1;
		}
		else if( nVideoID != -1 )
		{
			KillTimer( hwndGame, 0 );
			PostMessage( hwndGame, MM_MCINOTIFY, 99, nCurrentVideoID );
			nVideoID = -1;
		}
		return 2;
	}
	// game turly end
	if( nStep == 21 )
	{
		if( bHighColor == TRUE 
			&& nVideoID != -1 )
		{
			MCI_AVI_Close( nVideoID );
			nVideoID = -1;
		}

		Sleep( 2000 );
		RECT rcTop, rcBottom;
		rcTop.left=rcBottom.left=0;
		rcTop.right=rcBottom.right=640;
		rcTop.top=0;rcBottom.bottom=480;
		for( i=1; i<240; i++ )
		{
			rcTop.bottom=rcTop.top+i;
			rcBottom.top=rcBottom.bottom-i;
			DD_EraseBackScreen( 0, &rcTop );
			DD_EraseBackScreen( 0, &rcBottom );
			DDC_UpdateScreen();
		}
		DD_EraseBackScreen( 0 );
		DDC_UpdateScreen();
		nStep ++;
		return 2;
	}

    SetCursor(NULL);

	if( nType != -1 )
		nSType = nType;

	CDDSurface sBack;
	char backname[_MAX_FNAME];
	strcpy( backname, fullpath );
	if( nSType == 0 || nSType == 1 )
	{
		strcat( backname, "\\cbend2.bmp" );
	}
	else
	{
		strcat( backname, "\\cbend1.bmp" );
	}

	CDDPalette pal;
	if( bHighColor == FALSE )
	{	// load and set palette
		if( pal.LoadPalette( backname, TRUE ) == FALSE )
		{
			ErrorMessage( hwndGame, 2006, "load palette file when ending!\n", backname );
			return FALSE;
		}
	}

	if( sBack.LoadBitmap( backname, FALSE, FALSE ) == FALSE )
	{
		ErrorMessage( hwndGame, 2002, "Cannot load background file when ending!\n", backname );
		return FALSE;
	}

	CDDSurface sOne;
	if( nStep < 3 )
	{
		char onename[_MAX_FNAME];
		strcpy( onename, fullpath );
		strcat( onename, "\\" );
		strcat( onename, strBMP[nSType][nStep] );
		if( sOne.LoadBitmap( onename, FALSE, FALSE ) == FALSE )
		{
			ErrorMessage( hwndGame, 2003, "Cannot load front image file when ending!\n", onename );
			return FALSE;
		}
	}
	POINT pt={0,0};

	if( nStep == 0 )
	{
		// Draw background to back buffer andupdate
		sBack.BltToBack( pt, NULL );
		DDC_UpdateScreen();

		// draw front screen
		RECT rcSrc={0,0,0,0};
		rcSrc.right = sOne.GetSize().cx;
		rcSrc.bottom = sOne.GetSize().cy;
		POINT ptDest={0,0};
		ptDest.y = ptOne.y;
		for( i=1; i<sOne.GetSize().cx; i+=2 )
		{
			rcSrc.left = rcSrc.right - i;
			ptDest.x = ptOne.x+rcSrc.left;
			sOne.BltToBack( ptDest, &rcSrc );
			DDC_UpdateScreen();
		}

		if( bHighColor == TRUE )
		{
			// open and play avi
			char aviname[_MAX_FNAME];
			strcpy( aviname, fullpath );
			strcat( aviname, "\\" );
			strcat( aviname, strAVI[nSType][0] );
			if( (nVideoID = MCI_AVI_Open( hwndGame, aviname, &rcAVI )) == -1 )
			{
				ErrorMessage( hwndGame, 2004, "Cannot load avi file when ending!\n", aviname );
				return FALSE;
			}
			nCurrentVideoID = nVideoID;
			MCI_AVI_Play( hwndGame, nVideoID, MCI_NOTIFY );
		}
		else
		{
			SetTimer( hwndGame, 0, 18000, NULL );
			nCurrentVideoID = 99;
			nVideoID = 99;
		}
	}	
	else if( nStep == 1 )
	{
		if( bHighColor == TRUE 
			&& nVideoID != -1 )
		{
			MCI_AVI_Close( nVideoID );
			nVideoID = -1;
			nCurrentVideoID = nVideoID;
		}

		// erase front of screen
		RECT rcSrc={0,0,0,0};
		rcSrc.right = ptOne.x + sOne.GetSize().cx;
		rcSrc.top = ptOne.y;
		rcSrc.bottom = ptOne.y+sOne.GetSize().cy;
		POINT ptDest={0,0};
		ptDest.y = ptOne.y;
		for(i=1; i<sOne.GetSize().cx; i+=2 )
		{
			rcSrc.left = rcSrc.right - i;
			ptDest.x = rcSrc.left;
			sBack.BltToBack( ptDest, &rcSrc );
			DDC_UpdateScreen();
		}

		// Draw background to back buffer andupdate
		sBack.BltToBack( pt, NULL );
		DDC_UpdateScreen();
		Sleep( 1000 );

		// draw front screen
		rcSrc.top = 0;
		rcSrc.right = sOne.GetSize().cx;
		rcSrc.bottom = sOne.GetSize().cy;
		ptDest.y = ptOne.y;
		for( i=1; i<sOne.GetSize().cx; i+=2 )
		{
			rcSrc.left = rcSrc.right - i;
			ptDest.x = ptOne.x+rcSrc.left;
			sOne.BltToBack( ptDest, &rcSrc );
			DDC_UpdateScreen();
		}

		if( bHighColor == TRUE )
		{
			// open and play avi
			char aviname[_MAX_FNAME];
			strcpy( aviname, fullpath );
			strcat( aviname, "\\" );
			strcat( aviname, strAVI[nSType][1] );
			if( (nVideoID = MCI_AVI_Open( hwndGame, aviname, &rcAVI )) == -1 )
			{
				ErrorMessage( hwndGame, 2005, "Cannot load avi file when ending!\n", aviname );
				return FALSE;
			}
			nCurrentVideoID = nVideoID;
			MCI_AVI_Play( hwndGame, nVideoID, MCI_NOTIFY );
		}
		else
		{
			SetTimer( hwndGame, 0, 18000, NULL );
			nCurrentVideoID = 99;
			nVideoID = 99;
		}
	}
	else if( nStep == 2 )
	{
		if( bHighColor == TRUE 
			&& nVideoID != -1 )
		{
			MCI_AVI_Close( nVideoID );
			nVideoID = -1;
			nCurrentVideoID = nVideoID;
		}

		// erase front of screen
		RECT rcSrc={0,0,0,0};
		rcSrc.right = ptOne.x + sOne.GetSize().cx;
		rcSrc.top = ptOne.y;
		rcSrc.bottom = ptOne.y+sOne.GetSize().cy;
		POINT ptDest={0,0};
		ptDest.y = ptOne.y;
		for(i=1; i<sOne.GetSize().cx; i+=2 )
		{
			rcSrc.left = rcSrc.right - i;
			ptDest.x = rcSrc.left;
			sBack.BltToBack( ptDest, &rcSrc );
			DDC_UpdateScreen();
		}

		// Draw background to back buffer andupdate
		sBack.BltToBack( pt, NULL );
		DDC_UpdateScreen();
		Sleep( 1000 );

		// draw front screen
		rcSrc.top = 0;
		rcSrc.right = sOne.GetSize().cx;
		rcSrc.bottom = sOne.GetSize().cy;
		ptDest.y = ptOne.y;
		for( i=1; i<sOne.GetSize().cx; i+=2 )
		{
			rcSrc.left = rcSrc.right - i;
			ptDest.x = ptOne.x+rcSrc.left;
			sOne.BltToBack( ptDest, &rcSrc );
			DDC_UpdateScreen();
		}

		if( bHighColor == TRUE )
		{
			// open and play avi
			char aviname[_MAX_FNAME];
			strcpy( aviname, fullpath );
			strcat( aviname, "\\" );
			strcat( aviname, strAVI[nSType][2] );
			if( (nVideoID = MCI_AVI_Open( hwndGame, aviname, &rcAVI )) == -1 )
			{
				ErrorMessage( hwndGame, 2006, "Cannot load avi file when ending!\n", aviname );
				return FALSE;
			}
			nCurrentVideoID = nVideoID;
			MCI_AVI_Play( hwndGame, nVideoID, MCI_NOTIFY );
		}
		else
		{
			SetTimer( hwndGame, 0, 18000, NULL );
			nCurrentVideoID = 99;
			nVideoID = 99;
		}
	}
	else if( nStep < 20 )
	{
		CDDSurface sBack2;
		char strBack2[_MAX_FNAME];
		strcpy( strBack2, fullpath );
		strcat( strBack2, "\\" );
		strcat( strBack2, strBMP2[nStep-3] );
		sBack2.LoadBitmap( strBack2, FALSE, FALSE );
		sBack2.BltToBack( pt, NULL );

		RECT rcBack2;
		rcBack2.right = 640;
		rcBack2.top = 0;
		rcBack2.bottom = 480;
		for( i=0;i<640;i++ )
		{
			rcBack2.left = 640-i;
			DDC_UpdateScreen( &rcBack2 );
		}
		SetTimer( hwndGame, 0, 1000, NULL );
	}
	nStep ++;
	return TRUE;
}
////////////

////////////
// õABϢ
// nSlot	:	ļ
// 0Ϊ޴AB̵Ϣ1ΪẠ2ΪB
int GAME_GetSaveInfoAB( int nSlot )
{
	char strInfo[64];
	char name[32];
	GAME_MakeSaveName( nSlot, ".SAV", name );

	FILE *fp;

	fp = fopen( name, "rb" );
	if( !fp )
	{
		OutputDebugString( "GAME_GetSaveInfo Error: Cannot open file!\n" );
		return FALSE;
	}

	BYTE nLen;
	fread( &nLen, sizeof(BYTE), 1, fp );
	fread( strInfo, nLen, 1, fp );
	strInfo[nLen] = 0;
	fclose( fp );

	if( strInfo[1] == 'A' )
		return 1;
	else if( strInfo[1] == 'B' )
		return 2;

	return 0;
}

// Nov.7.1997
// õļ
void GAME_MakeSaveName( int nSlot, LPCTSTR tail, LPSTR filename )
{
	char temp[16];
	char name[32]="SAVE\\GAME";
	if( GAME_nDisk == 0 )
	{
		wsprintf( temp, "%d", nSlot );
	}
	else if( GAME_nDisk == 1 )
	{
		wsprintf( temp, "A%02d", nSlot+1 );
	}
	else if( GAME_nDisk == 2 )
	{
		wsprintf( temp, "B%02d", nSlot+1 );
	}
	else
	{
		wsprintf( temp, "%d", nSlot );
	}
	strcat( name, temp );
	strcat( name, tail );
	strcpy( filename, name );
}
////////////
