/////////////////
// CBGame.h		:	ڡȫݽṹ
// CBGame.h		:	<< chibi >> global data structure
//
// v0011		:	Oct.18.1996
// v0012		:	Nov.28.1996
// v0013		:	Feb.5.1997, changed setunitdata() part in GAME_ReadMedFile()
//								add function GAME_ReadMedHeader()
// v0020		:	Feb.28.1997, add function named DATA_ReadDATAFile()
//
// v0030		:	May.2.1997, add save&load file, read&write option file functions
// v0031		:	May.14.1997, add some values in main structure: nBuildType, nMusicID
//
// д			:	
// written by	:	Liu Gang
//
// 		:	Visual C++ 4.2
// Compiler		:	Visual C++ 4.2
//
// Ȩ			:	ǰ޹˾	1996-1997
// Copyright	:	WayAhead Co.Ltd.		1996-1997
/////////////////
// ļȡϷãͼݣжԵԪ졢ʿ
// Ĳ

#ifndef	__CBGAME_H__
#define	__CBGAME_H__

#include "CBCtrl.h"
//#include "CBData.h"

#define	GAME_ERROR_ID	800

// Ϸߵ
#define	GAME_PLAYER_MAX			5

/////////
// General
// Ҵвӵ
#define	GENERAL_TROOP_MAX	15
#define	GENERAL_SHIQI_MAX	200
struct	GENERAL_STRUCT
{
	// 
	WORD	nID;		// ı
	BYTE	nType;		// ӵͣMAP_UNIT_TYPE_GEN or MAP_UNIT_TYPE_WGEN
	
	// 
//	BYTE	nHealth;	// 
//	BYTE	nTactic;	// ı
//	BYTE	nLevel;		// ļ
//	WORD	nExperience;	// ľ

	// 
	//WORD	wTroopNum;					// ʿĸ
	WORD	wTroop[GENERAL_TROOP_MAX];	// ʿID
	BYTE	nLineUp;	// 
	BYTE	nMorale;	// ӵʿ
	
//	struct CTRL_TASK_STRUCT	Task;		// ӵ
//	struct CTRL_TASK_STRUCT	Status;		// ӵ״̬
};
/////////

/////////
// Building
struct	BUILDING_STRUCT
{
	// 
	DWORD 	dwUpgrade[3];	// 

	int		nResource;	// Դ

	int		nFireLvl;			// ļ
	int		nFireID[3];			// ӵеĻID
};
/////////

/////////
// ʿSoldier
#define	SOLDIER_ONBOARD_MAX		16
struct	SOLDIER_STRUCT
{
	// 
	WORD	nGenID;		// ID	
	BYTE	nHealth;		// ʿ
	BYTE	nMorale;		// ʿʿ
	BYTE	nThinkModal;	// ʿ˼ģ
	DWORD	dwBuild;		// 

	// ֻйЧ
	int		nResType;		// Դͣ0ľ123Ǯ
	int		nResource;		// ѲɼԴ

	// ֻ䴬Ч
	BOOL	bOnBoard;		// Ϊʱвڴ
	int		nOnBoard;		// ڴϵĲ
	int		nOnBoardSoldier;// ڴϵĲ
};
/////////
/////////
// 䴬Ship
/////////
struct SHIP_STRUCT
{
	int		nNum;			// 䴬ϵʿĸ
	int		nSoldier;		// 䴬ϵʿ
};
/////////


/////////
// Ԫṹ
#define	GAME_MARCH_MAX	128
struct	UNIT_STRUCT
{
	// basic attributes 
	BYTE	nType;		// Ԫ,궨MAP_UNIT_TYPE_
	WORD	nID;		// ԪID

	WORD	nIDAttackMe;	// ҹĵԪID
	int		nLife;		// ֵ

	// ֡ÿ֡ͼؿеλãУУ
	struct CTRL_FRAME_STRUCT Draw;
	int nCounter;	// нļ

	// ״̬
	struct CTRL_TASK_STRUCT	Status;

	// 
	struct CTRL_TASK_STRUCT Task;

	// о·
	BYTE MarchTrack[GAME_MARCH_MAX];
	int	StepNum;

	// 
	POINT ptZhenFa;	// еλ
	int	  nZhenFa;	// ͱţCBCtrl.hеenum CTRL_ZHENXING

	int bPause;		// ֻͣͣһ

	// ͷ
	BYTE nFarAttack;
	BYTE nNearAttack;
	BYTE nFarDefend;
	BYTE nNearDefend;

	// test only
	int nHasShadow;
	
	// ֻͶʯ͹Ч, not used now
//	BOOL	bHasStone;		// ΪʱͶһʯͷ

	//ADDED BY TIAN YUE.
	WORD   nPos;          //¼ӱܹеı־
	WORD   nBloodPos;     //¼ܵʱѪı־  

	union	
	{
		struct	GENERAL_STRUCT	Gen;
		struct	BUILDING_STRUCT	Build;
		struct	SOLDIER_STRUCT	Soldier;
		struct	SHIP_STRUCT		Ship;
	};
};
/////////

/////////
// ϷߣPlayer
#define		PLAYER_UNIT_MAX		200
#define		PLAYER_NONE		0
#define		PLAYER_1		1
#define		PLAYER_2		2
#define		PLAYER_3		3
#define		PLAYER_4		4

#define		PLAYER_TYPE_NONE		0
#define		PLAYER_TYPE_HUMAN		1
#define		PLAYER_TYPE_COMPUTER	2
#define		PLAYER_TYPE_REMOTE		3

#define		PLAYER_RELATION_ME		0
#define		PLAYER_RELATION_ALLY	1
#define		PLAYER_RELATION_ENEMY	2

#define		PLAYER_GROUP_MAX	20

#define		PLAYER_GRADE_MAIN		0
#define		PLAYER_GRADE_GONGJIAN	1
#define		PLAYER_GRADE_BINGQI		2
#define		PLAYER_GRADE_HUJIA		3
#define		PLAYER_GRADE_TOUSHICHE	4
#define		PLAYER_GRADE_CHUAN1		5
#define		PLAYER_GRADE_CHUAN2		6
#define		PLAYER_GRADE_CHUAN3		7

struct PLAYER_STRUCT
{
	// 
	BYTE	nID;			// ϷID
	int		nType;			// Ϸ
	int		nBuildType;		// ͣ0Ϊڽ1Ϊ⽨
	int		nThink;			// ؼ˼ģͣ0Ϊ½ս1Ϊˮս2Ϊ޻
	int		nTechLvl;		// Ϸ߿Դﵽļ,1-4
	//int		nRelation;	// ϷߺԼĹϵ
	char	strName[34];	// Ϸ

	// ͬ˿
	int nAllies[GAME_PLAYER_MAX];// ͬϷߵıţûԼ

	// Դ
	//DWORD	dwSoldier;		// Ԥ
	int		nFood;			// Ѳɼʳ
	int		nWood;			// Ѳɼľ
	int		nIron;			// Ѳɼ
	int		nGold;			// ֽ

	// ڲ
	DWORD	dwLifeUp;			// ֵӵ
	char	nAddNearAttack[4];	// ̹仯ΪֱӦ100,200,500,1000˲
	char	nAddFarAttack[4];	// Զ̹仯Ϊ
	char	nAddNearDefend[4];	// ̷仯Ϊ
	char	nAddFarDefend[4];	// Զ̷仯Ϊ
	char	nAddSFarAttack;		// 仯
	char	nAddWaterAttack[2];	// ˮĹ仯
	char	nAddWaterDefend[2];	// ˮķ仯
	char	nAddViewRange;	// Ұ仯Ϊ
	char	nAddFightRange;	// ̱仯Ϊ
	char	nAddMoveSpeed;	// ƶٶȱ仯Ϊ
	char	nAddFightSpeed;	// ٶȱ仯Ϊ
	BYTE	nGrade[8];			// 
								// ľĳ
								// 
								// ׼
								// 
								// 뼶

	int		nFoodStore;			// ֺ˧ʵ

	// ʿͽĿ
	WORD	wUnitCounter;	// ӵԪʱ
	WORD	wLastUnit;		// һԪ
	struct	UNIT_STRUCT	Unit[PLAYER_UNIT_MAX];

	// ӵĿ
	WORD	wGroupCounter;
	WORD	wGroup[PLAYER_GROUP_MAX];
};
/////////

/////////
// ȫGame
struct GAME_STRUCT
{
	// 
	long	lVersion;		// ųİ汾
	long	lVerMED;		// MEDļİ汾

	char	strPath[_MAX_PATH];		// ų·
	char	strPathMED[_MAX_PATH];	// MEDļ·ڳ·֮
	char	strPathDAT[_MAX_PATH];	// DATļ·ڳ·֮
	char	strPathBMP[_MAX_PATH];	// BMPļ·ڳ·֮
	char	strPathAVI[_MAX_PATH];	// AVIļ·ڳ·֮
	char	strPathWAV[_MAX_PATH];	// WAVļ·ڳ·֮

	char	strNameMED[_MAX_FNAME];	// MED
	char	strNameBTL[_MAX_FNAME];	// սʼļ
	char	strNameAVI[_MAX_FNAME];	// ؽӦòŵAVIļ
	char	strNameOPT[_MAX_FNAME];	// Ϸļ

	char	strStartAVI[_MAX_FNAME];// ϷʼƬͷ
	char	strStartWAV[_MAX_FNAME];// Ϸʼ汳

	// game control
	BOOL	bNetwork;				// ΪʱΪģʽ, ЧNov.4.1997
	int		nProgramState;			// ״̬궨PROGRAM_STATUS_
	int		nProgramStateLast;		// һ״̬궨PROGRAM_STATUS_
	int		nCommandState;			// ״̬궨COMMAND_STATUS_
	int		nCommandStateLast;		// һ״̬궨COMMAND_STATUS_

	// game options
	UINT	nSpeed;			// ٶ
	UINT	nSpeedScroll;	// ٶ
	int		nVolume;		// ЧСrange from 0 to -50001ʱر
	int		nVolumeCD;		// ֵСrange from 0 to -50001ʱر
	BOOL	bFightEnabled;	// AVIĿ
	BOOL	bFogOfWar;		// Ӱ

	// 
	int		nID;			// صID
	char	strName[_MAX_PATH];	// ص
	POINT	ptStart[GAME_PLAYER_MAX];	// Ϸ߿ʼλ
	int		nMusicID;		// رֵID

	WORD	wWeather;		// 磬꣬ѩ
	WORD	wTime;			// ʱ䣬8λΪڣ8λΪСʱ
	WORD	wWind;			// 磬8λΪ򣬵8λΪ

	// ڲ
	BYTE	nRatioSoldier;	// ʿϵ
	BYTE	nRatioBuilding;	// ϵ
	BYTE	nRatioGeneral;	// 칥ϵ

	// ϽPlayer
	int		nMe;			// ǵڼϷ
	struct	PLAYER_STRUCT	Players[GAME_PLAYER_MAX];
};
/////////

struct GAME_TIME_STRUCT	
{
	SYSTEMTIME Start;
	SYSTEMTIME Now;
	SYSTEMTIME Sub;
};


////////////
// ȫ
extern struct GAME_STRUCT	GAME;

// Ϸװ·
extern char	GAME_strSetupDirectory[_MAX_PATH];

extern int GAME_nSlot;

// ϷǺʱA̺B
// 0֣1ΪẠ2ΪB
extern int GAME_nDisk;

// 磬Nov.4.1997, LG & LHJ
extern BOOL	GAME_bNetwork;
extern BOOL	GAME_bNetPlayerOK[GAME_PLAYER_MAX];// ȷ

// սǷ
extern struct RUN_COUNTDOWN RUN_CountDown[GAME_PLAYER_MAX];
////////////
// 
// ʼ
void GAME_InitGame();
void GAME_InitGamePlayers();

//- Tian Yue
#ifndef	TNEBUG

// ȡļ
// hwnd		:	window to receive error message
// return	:	TRUE if successful
BOOL GAME_ReadCBSetFile( HWND hwnd );

// ȡսļ
// hwnd		:	window to receive error message
// filename	:	battle field data file name
// path		:	battle field data file path
// return	:	TRUE if successful
BOOL GAME_ReadMEDFile( HWND hwnd, LPCTSTR filename, LPCTSTR path );

// Nov.6.1997, Liu Gang
// ȡսļ
// hwnd		:	window to receive error message
// filename	:	battle field data file name
// path		:	battle field data file path
// return	:	TRUE if successful
BOOL GAME_ReadMEDFileNet( HWND hwnd, LPCTSTR filename, LPCTSTR path );

// ȡսļͷMINI_Load()ͼʹ
// hwnd		:	window to receive error message
// filename	:	battle field data file name
// path		:	battle field data file path
// return	:	TRUE if successful
BOOL GAME_ReadMEDHeader( HWND hwnd, LPCTSTR filename, LPCTSTR path );

// ȡսʼļ
// hwnd		:	window to receive error message
// nBattle	:	battle number
// filename	:	battle field data file name
// path		:	battle field data file path
// return	:	TRUE if successful
BOOL GAME_ReadBTLFile( HWND hwnd, int nBattle, LPCTSTR filename, LPCTSTR path );

// ͷϷвĵԪ
void GAME_ReleaseAllUnits();
////////////

////////////
// Ϸʼ
BOOL GAME_Begin( int nGameID );
// Ϸ
void GAME_End( int nGameID );

// 
// nSlot	:	ļ
BOOL GAME_Save( int nSlot );

// ȡ
// nSlot	:	ļ
BOOL GAME_Load( int nSlot );

// õϢ
// nSlot	:	ļ
// strInfo	:	ӴļõĴϢ
BOOL GAME_GetSaveInfo( int nSlot, LPSTR strInfo );

// ôϢ
// strInfo	:	ĴϢϢý洢ļ
BOOL GAME_CalcSaveInfo( LPSTR strInfo );

// ļõϢ飬õȫֽṹDATA_Lib.Gen
// nSlot	:	ļ
BOOL GAME_GetGenInfo( int nSlot );

// ѽϢ飬ȫֽṹDATA_Lib.Genдļ
// nSlot	:	ļ
void GAME_SetGenInfo( int nSlot );
////////////

////////////
// Ϸļ
BOOL GAME_ReadOptionFile( HWND hwnd, LPCTSTR filename, LPCTSTR path );

// дϷļ
BOOL GAME_WriteOptionFile( HWND hwnd, LPCTSTR filename, LPCTSTR path );
////////////

////////////
// õװ·
// filename		:	Űװ·ļ
// strSrcPath	:	صİװ·
// nSize		:	·ַĴС
BOOL GAME_GetSrcPath( LPCTSTR filename, LPSTR strSrcPath, int nSize );
////////////

////////////
// ϷŽβȺ
// nType	:	
void GAME_Ending( int nType );

// nType :	-1, continue the end procedure
//			0-3, begin some kind of ending, must used in the frist call
//			-2, jump to the last procedure
BOOL GAME_EndingEx( int nType=-1 );
////////////


////////////
// ͬˣ
// Aug. 20. 1997
// nPlayer1, nPlayer2	:	Ϸ
// bSet					:	TRUEʱΪͬˣΪͬ	
void GAME_SetAlly( int nPlayer1, int nPlayer2, BOOL bSet=TRUE );
////////////

// Nov.7.1997
// õABϢ
// nSlot	:	ļ
// 0Ϊ޴AB̵Ϣ1ΪẠ2ΪB
int GAME_GetSaveInfoAB( int nSlot );

//- Tian Yue
#endif // TNEBUG

#endif // __CBGAME_H__