
/////////////
//	CBMain.cpp		:	v0010
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.0 & DirectX
//	Library			:	DDraw.Lib & Winmm.lib & dxguid.lib
//	Copyright (C)	:	1996 WayAhead Corporation 
//	v0010			:	Sep.20.1996
//  v0090			:	Sep.11.1997
/////////////
// implementation file

// This file is the major file of the game, includes WinMain()
// and WindowProc(), for entering graph mode and processing main 
// programe cricle.

#include "stdafx.h"	// compatible with MFC
#include <stdio.h>
#include <mmsystem.h>	// timeGetTime()
#include "resource.h"
#include "Assert.h"	// ErrorMessage(), Assert()
#include <stdio.h>
#include <imm.h>

//#include "DDApi.h"	// direct draw object
#include "DDCompo.h"	// Direct Draw objects and components


#include "CBData.h"	// game data, ReadCBSetFile(), ReadMedFile()
#include "CBMap.h"	// game map data
#include "CBGame.h"	// readcbsetfile, readmedfile

#include "cbavi.h"	// FACE_AVI_PLAY() , FACE_AVI_CLOSE()

#include "CBDraw.h"	// DrawMaps(), LoadMaps()
#include "CBMouse.h"	// MOUSE_
#include "CBShadow.h"	// for shadow
#include "puthz.h"

#include "CBMain.h"	

//---------sound
#include "DSApi.h"
//WAVEDYNAMIC	waveBack;
//---------

#include "CBRun.h"
extern	BOOL	RUN_bAUTO;			//declared in CBRun.cpp
extern  BOOL	RUN_DEBUG_bEndGame;	//declared in CBRun.cpp
extern  void RUN_EndGame( int bWin );		// defined in CBRun.cpp

// defined in CBCTRl.cpp, debug for do not die
extern BOOL CTRL_bDebugDie;
// defined in CBCTRl.cpp, debug for upgrade general for one level
extern void CTRL_DebugGeneral( int nUp );

//added by tian yue
#include "Tbnbase.h"
#include "Temperor.h"
extern POINT ThinkDead(WORD Player);	// declared in Temperor.h

//----------LHJ
#include "Marco.h"
#include "DDButton.h"
#include "DDMenu.h"
#include "interfac.h"
#include "interfa1.h"
#include "interfa2.h"

extern	BOOL	FACE_bMessageBox;
extern	CDDMenu		* CurrentMenu;

//////////////////////////////////////////
// to set this flag for DH	Nov.8.1997
extern BOOL IsInSetNetMenu ;
//////////////////////////////////////////

//----------

//#define	_MAIN_DEBUG
extern GFWI_bUpdate;
// debug commandunit, defined in CBCTRl.cpp
extern BOOL CTRL_bDebugCommand;

// Copyright info
char	strCopyright[65];

BOOL        bActive=FALSE;        // is application active?
BOOL		MAIN_bFirst = TRUE;	  // ƹBug
BOOL		MAIN_bInitGraph = FALSE;

// palettes
class CDDPalette	pal, palMain;

//added by tian yue
extern PALETTEENTRY	pe[256];
extern PALETTEENTRY	peFadeSave[256];

// DDAPI.h
extern int DD_nSurfaceCounter;			// stores for the number of surfaces have been loaded

BOOL MAIN_AVI_bFullScreen = FALSE;
BOOL MAIN_bRelease = FALSE;
extern int FACE_AVI_FLAG;	// defined in CBAVI.cpp

// ǷѾбϷʵ̣
// У򷵻
BOOL MAIN_TestInstance( char *wndname );

// ԭʼİ취
BOOL MAIN_TestCD();
///////////////////////
// MMX tech
// ʹMMXĿ
BOOL MAIN_bMMX = FALSE;

// MMXƬͷ
#ifndef	_DEBUG
#define	_MMX_SPLASH_
#endif
#ifdef	_MMX_SPLASH_
	extern "C" BOOL WINAPI IntelSplashInit();
	extern "C" BOOL WINAPI IntelSplash();
//#include "CPUID.h"
	#include "splshapi.h"
	#include "errorapi.h"
	extern int MMXCPUID();
#endif
///////////////////////

///////////////////////
// AVIź
#include "MciApi.h"
#include "VCMApi.h"
///////////////////////

///////////////////////
#define MAIN_CURSOR_WAIT	33
class CDDCursor MAIN_Cursors[4];	// all the cursors
class CDDCursor DDC_Cursor;
// defined in CBFile.cpp
BOOL MAIN_LoadCursors( HWND hwnd, LPCTSTR filename , LPCTSTR path );

BOOL MAIN_InitOthers();
///////////////////////

///////////////////////
// move screen ex
extern BOOL DRAW_bMoveScreenEx;
extern BOOL DRAW_bShowScrollBorder;

// mouse hit test
extern RECT DRAW_rcClient;			// declared in CBDraw.cpp
extern POINT DRAW_ptScreenOffset;	// declared in CBDraw.cpp
//extern int MOUSE_nHitCounter;
//extern struct MOUSE_HITRESULT_STRUCT MOUSE_hitResult[CTRL_TASK_LIST_MAX];

#ifdef	_DEBUG
// for debug only, to confirm that message processes must be done outside run circle
BOOL bInRun=FALSE;
#endif

// Nov.7.1997
// CBAvi.cpp
extern int nCurrentVideoID;	// Video ľ
// CBData.cpp
extern int MUSIC_hCDHandle;	// CD Audio ľ
// CBData.cpp
extern BOOL MUSIC_bEnable;	// Ƿ񲥷CD
extern BOOL EFFECT_bEnable;	// Ƿ񲥷Ч
///////////////////////

///////////////////////////////Donghai/////////////////////////////////////
#include "network.h"
#include "net_face.h"
extern	int		DP_NetworkInterface(int	Action, HWND   MainWndHandle);
extern	int		DH_ReceiveMessage();
extern	int		DP_ReceiveGameMessages( void );
extern	int		DP_SendGameMessages(/*DWORD to*/);
extern  BOOL	CTRL_TASK_LIST_Send( int nPlayer, CONST struct CTRL_TASK_STRUCT *pTask );	// 񷵻
extern	BOOL	GAME_Network_Begin(void);//Ϸʼʱĳʼ
int	DH_ServerInit();
int	DH_ClientInit();
void DH_NetworkReceive();
void DH_NetworkInit();
void DH_ReceiveInit();

int		CB_Counter=0;//ڽս֮ǰӦֻ0
int		DH_ComputerTaskNum[CTRL_TASK_LIST_MAX+CTRL_TASK_LIST_MAX];
//int		Games_Status[MAX_PLAYERS+1];//ʼʱӦΪ-1
extern	BYTE                    DP_SendMessageBuff[BUFFER_MAX_BYTE];//ڴ洢Ҫ͵Ϣ
extern	BYTE					DP_ReadMessage[BUFFER_MAX_BYTE];//ڽϢеϢ
extern	int						DP_ProviderNO;//ڷҶѡ
extern	int						DP_SessionNO;//ڷҶѾϷSessionѡ
extern	LPSTR					DP_FullName;//ҸSession
extern	LPSTR					DP_NickName;//ҸϷе
extern	PlayerInfo				DP_PlayerInformation[MAX_PLAYERS];
extern	DPID                    DP_dcoID;        // ڴ洢IDֵ
extern	BOOL					GAME_bNetwork;
extern	struct CTRL_TASK_STRUCT	CTRL_TaskList[GAME_PLAYER_MAX][CTRL_TASK_LIST_MAX+CTRL_TASK_LIST_MAX];
///////////////////////////////Donghai/////////////////////////////////////

/*
        The following code is added by Bill 
        The MMXCPUID detected program
        Usage:  BOOL MMXCPUID();
*/
unsigned long MMXFLAG;
#define CPU_MMX                 (MMXFLAG & (unsigned long)(0x01 << 23))

BOOL MMXCPUID()
{
        unsigned int  cpu_type = 0;
        unsigned long cpuIdCount = 0l;
        unsigned long tmp1 = 0l;
        unsigned long tmp2 = 0l;
        unsigned long tmp3 = 0l;
        unsigned long tmp4 = 0l;

        MMXFLAG = 0l;
        _asm {

// CHECK_8086:
                                // 8086 ?
						pushf                   ; push original FLAGS
						pop     ax              ; get original FLAGS
						mov     cx, ax          ; save original FLAGS
						and     ax, 0fffh       ; clear bits 12-15 in FLAGS
						push    ax              ; save new FLAGS value on stack
						popf                    ; replace current FLAGS value
						pushf                   ; get new FLAGS
						pop     ax              ; store new FLAGS in AX
						and     ax, 0f000h      ; if bits 12-15 are set, then
						cmp     ax, 0f000h      ;   processor is an 8086/8088
												; turn on 8086/8088 flag
						je     EXIT_8086        ; jump if processor is 8086/8088
                        jmp             CHECK_80286

EXIT_8086:      
                        mov             cpu_type, 1
                        jmp     EXIT

CHECK_80286:
                        // 80286 ?
						or      cx, 0f000h      ; try to set bits 12-15
						push    cx              ; save new FLAGS value on stack
						popf                    ; replace current FLAGS value
						pushf                   ; get new FLAGS
						pop     ax              ; store new FLAGS in AX
						and     ax, 0f000h      ; if bits 12-15 are clear
												; processor=80286, turn on 80286 flag
						jz      END_80286       ; if no bits set, processor is 80286
                        jmp             CHECK_80386

END_80286:
                        mov     cpu_type, 2
                        jmp             EXIT

CHECK_80386:
                        // 80386 ?
                        pushfd                  ; push original EFLAGS
                        pop     eax             ; get original EFLAGS
                        mov     ecx, eax        ; save original EFLAGS
						xor     eax, 40000h     ; flip AC bit in EFLAGS
						push    eax             ; save new EFLAGS value on stack
						popfd                   ; replace current EFLAGS value
						pushfd                                  ; get new EFLAGS
						pop     eax             ; store new EFLAGS in EAX
						xor     eax, ecx        ; can't toggle AC bit, processor=80386
																		; turn on 80386 processor flag
						jz     END_80386        ; jump if 80386 processor
                        jmp             CHECK_80486

END_80386:
                        mov     cpu_type, 3 
                        jmp     EXIT

CHECK_80486:
                        // 80486 ?
                        push    ecx
                popfd                          
                        mov     eax, ecx
                        xor     eax, 0200000h
                        push    eax
                        popfd
                        pushfd
                        pop     eax
                        xor     eax, ecx
                        je              END_80486
                        jmp     CHECK_PENTIUM
END_80486:
						mov     cpu_type, 4    
						jmp             EXIT

CHECK_PENTIUM:
						xor     eax, eax        ; set up for CPUID instruction
						xor     ebx, ebx
						xor     ecx, ecx
						xor     edx, edx

						inc     eax
						_emit   0x0F 
						_emit   0xA2 ;CPU_ID 

						mov     cpuIdCount, eax

						mov tmp1, eax
						mov tmp2, ebx
						mov tmp3, ecx
						mov tmp4, edx

                        }

        _asm {

EXIT:
        }
        MMXFLAG = tmp4;
        if ( CPU_MMX )
                return TRUE;
        else
                return FALSE;

}
///////////////////////

///////////////////////
// change program state
// returns old state
int	 ChangeProgramState( int nState, int nButtonID )
{
	int OldProgramState = 0;

	switch( nButtonID )
	{
		case BUTTON_PAUSE :
			{
				if( nState == PROGRAM_STATE_PAUSE )
				{
					// to set all button to disable state when you show a menu or dialog
					FACE_SetAllButtonState( BUTTON_DISABLE );
					FACE_SetPauseButtonActive();
					FACE_SetProgramState( PROGRAM_STATE_PAUSE );
				}
				else
				{
					FACE_RestoreAllButtonState();
					FACE_SetProgramState( PROGRAM_STATE_PLAY );
				}
			}
			break;
		case BUTTON_MENU_MAIN_NEWGAME_OK :
			{
#ifdef	_DEBUG
				DWORD timeBegin, timeEnd;
				timeBegin = timeGetTime();
#endif

				// 
				CURSOR_Set( &MAIN_Cursors[0] );

			//---------------
				// load interface
				if( !FACE_LoadAllBmp() )  // to load all bitmap and set the destination surface to blit
										  // all button on---->sBack
				{
					OutputDebugString( "FACE_LoadMaps: Load Interface bitmap failure!\n" );
					return PROGRAM_STATE_ERROR;
				}
#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin, "\n" );
				timeBegin = timeEnd;
#endif
				FACE_ShowAllBmp();

#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin,"\n" );
				timeBegin = timeEnd;
#endif
			//---------------
				// load other maps
				if( !::DRAW_LoadMaps() )
				{
					OutputDebugString( "DRAW_LoadMaps: Load battlefield bitmaps failure!\n" );
					return PROGRAM_STATE_ERROR;
				}

				DD_FadeOutScreen( 5, 10 );


				if( GAME.nMe == 2 )	// 
					GAME_Begin( 0 );
				else				// ܲ
					GAME_Begin( 17 );

#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin,"\n" );
				timeBegin = timeEnd;
#endif
				DRAW_UpdateScreen( FALSE );

				FACE_SetCommandState(COMMAND_STATE_PLAY);

#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin,"\n" );
				timeBegin = timeEnd;
#endif
			}
			break;
		case BUTTON_MENU_MAIN_NETWORK_NEWGAME_OK :
			{
//				WriteLogFile( "Dead.log", "UUU" );
#ifdef	_DEBUG
				DWORD timeBegin, timeEnd;
				timeBegin = timeGetTime();
#endif

//				WriteLogFile( "Dead.log", "LLL" );
				// 
				CURSOR_Set( &MAIN_Cursors[0] );

//				WriteLogFile( "Dead.log", "WWW" );
			//---------------
				// load interface
				if( !FACE_LoadAllBmp() )  // to load all bitmap and set the destination surface to blit
										  // all button on---->sBack
				{
					OutputDebugString( "FACE_LoadMaps: Load Interface bitmap failure!\n" );
					return PROGRAM_STATE_ERROR;
				}
#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin, "\n" );
				timeBegin = timeEnd;
#endif
				FACE_ShowAllBmp();

#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin,"\n" );
				timeBegin = timeEnd;
#endif
			//---------------
				// load other maps
				if( !::DRAW_LoadMaps() )
				{
					OutputDebugString( "DRAW_LoadMaps: Load battlefield bitmaps failure!\n" );
					return PROGRAM_STATE_ERROR;
				}

				DD_FadeOutScreen( 5, 10 );

				// Ϸʼ
				GAME_Network_Begin();

#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin,"\n" );
				timeBegin = timeEnd;
#endif
				DRAW_UpdateScreen( FALSE );

				FACE_SetCommandState(COMMAND_STATE_PLAY);

#ifdef	_DEBUG
				timeEnd = timeGetTime();
				OutputString( timeEnd-timeBegin,"\n" );
				timeBegin = timeEnd;
#endif
			}
			break;

	}
	
	return 	OldProgramState;
}

/*
 * updateFrame
 * 
 * Decide what needs to be blitted next, wait for flip to complete,
 * then flip the buffers.
 */
//BOOL bFirst=TRUE;
void updateFrame( void )
{
	int	j;

	if(GAME_bNetwork!=0)
	{
			DH_NetworkReceive();
	
/*	char	test32[255];
	wsprintf((char *)test32,"================================%d================================\n",CB_Counter);
	WriteLogFile("Test_task.log",(char *)test32);
	for(i=0;i<GAME_PLAYER_MAX;i++)
		{
			for(j=0;j<CTRL_TASK_LIST_MAX+CTRL_TASK_LIST_MAX;j++)
				{
					if(CTRL_TaskList[i][j].nTaskID==0)
						{continue;}
//					char	test32[255]; 
					wsprintf((char *)test32,"%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld\n",CTRL_TaskList[i][j].bDone,
																						  CTRL_TaskList[i][j].nID,
																						  CTRL_TaskList[i][j].nLevel,
																						  CTRL_TaskList[i][j].bIRQ,
																						  CTRL_TaskList[i][j].nTaskID,
																						  CTRL_TaskList[i][j].nTaskIDEx,
																						  CTRL_TaskList[i][j].nTaskIDEx2,
																						  CTRL_TaskList[i][j].nParam1,
																						  CTRL_TaskList[i][j].nParam2,
																						  CTRL_TaskList[i][j].nParam3,
																						  CTRL_TaskList[i][j].nParam4);//,(char *)pTask);
					WriteLogFile("Test_task.log",(char *)test32);
				}
		}*/

	// run
/*	struct UNIT_STRUCT *p41=MAP_GetUnit(16470);
	struct UNIT_STRUCT *p42=MAP_GetUnit(16469);
	struct UNIT_STRUCT *p43=MAP_GetUnit(16468);
	struct UNIT_STRUCT *p44=MAP_GetUnit(16467);
	struct UNIT_STRUCT *p45=MAP_GetUnit(16466);
	struct UNIT_STRUCT *p46=MAP_GetUnit(16465);
	struct UNIT_STRUCT *p47=MAP_GetUnit(16464);
	struct UNIT_STRUCT *p48=MAP_GetUnit(16463);
	struct UNIT_STRUCT *p49=MAP_GetUnit(16462);
	struct UNIT_STRUCT *p40=MAP_GetUnit(16460);
	struct UNIT_STRUCT *p411=MAP_GetUnit(16461);

	struct UNIT_STRUCT *p21=MAP_GetUnit(8224);
	struct UNIT_STRUCT *p22=MAP_GetUnit(8223);
	struct UNIT_STRUCT *p23=MAP_GetUnit(8222);
	struct UNIT_STRUCT *p24=MAP_GetUnit(8221);
	struct UNIT_STRUCT *p25=MAP_GetUnit(8220);
	struct UNIT_STRUCT *p26=MAP_GetUnit(8219);
	struct UNIT_STRUCT *p27=MAP_GetUnit(8218);
	struct UNIT_STRUCT *p28=MAP_GetUnit(8217);
	struct UNIT_STRUCT *p29=MAP_GetUnit(8216);
	struct UNIT_STRUCT *p20=MAP_GetUnit(8214);
	struct UNIT_STRUCT *p211=MAP_GetUnit(8215);
	wsprintf((char *)test32,"================================%d================================\n",CB_Counter);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16470's X=%d,Y=%d\n",p41->Draw.nX,p41->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16469's X=%d,Y=%d\n",p42->Draw.nX,p42->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16468's X=%d,Y=%d\n",p43->Draw.nX,p43->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16467's X=%d,Y=%d\n",p44->Draw.nX,p44->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16466's X=%d,Y=%d\n",p45->Draw.nX,p45->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16465's X=%d,Y=%d\n",p46->Draw.nX,p46->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16464's X=%d,Y=%d\n",p47->Draw.nX,p47->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16463's X=%d,Y=%d\n",p48->Draw.nX,p48->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16462's X=%d,Y=%d\n",p49->Draw.nX,p49->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16460's X=%d,Y=%d\n",p40->Draw.nX,p40->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"16461's X=%d,Y=%d\n",p411->Draw.nX,p411->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);

	wsprintf((char *)test32,"8224's X=%d,Y=%d\n",p21->Draw.nX,p21->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8223's X=%d,Y=%d\n",p22->Draw.nX,p22->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8222's X=%d,Y=%d\n",p23->Draw.nX,p23->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8221's X=%d,Y=%d\n",p24->Draw.nX,p24->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8220's X=%d,Y=%d\n",p25->Draw.nX,p25->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8219's X=%d,Y=%d\n",p26->Draw.nX,p26->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8218's X=%d,Y=%d\n",p27->Draw.nX,p27->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8217's X=%d,Y=%d\n",p28->Draw.nX,p28->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8216's X=%d,Y=%d\n",p29->Draw.nX,p29->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8214's X=%d,Y=%d\n",p20->Draw.nX,p20->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
	wsprintf((char *)test32,"8215's X=%d,Y=%d\n",p211->Draw.nX,p211->Draw.nY);
	WriteLogFile("Test_x_y.log",(char *)test32);
*/
	}
	::RUN_RunUnits();
	memset(DH_ComputerTaskNum,0,sizeof(DH_ComputerTaskNum));
	for(j=0;j<CTRL_TASK_LIST_MAX+CTRL_TASK_LIST_MAX;j++)
		{
			if(CTRL_TaskList[GAME.nMe][j].nTaskID==0)
				{continue;}
			else{DH_ComputerTaskNum[j]=-1;}
		}




	CB_Counter++;



	// draw sprites
	::DRAW_DrawMaps();

	// display frame rate
	DDC_DisplayFrameRate();
} /* updateFrame */

// replay stoped music, CBDATA.cpp
void DATA_WAVE_Replay();
BOOL MAIN_bNotify = FALSE;
BOOL MAIN_bReplay = FALSE;
BOOL MAIN_bEnding = FALSE;
// declared in file DDAPI.h
long FAR PASCAL DD_WindowProc( HWND hWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam )
{
#ifdef	_DEBUG
	if( bInRun == TRUE ) 
		OutputDebugString( "WindowProc Error: Do with messages when running !\n" );
#endif

	//---- for cheat code 
	static int CHEAT_bEnable = FALSE;
	static DWORD CHEAT_nCompare = 0;
	static char CHEAT_str[]="eternal";
	//---- for cheat code 
    switch( message )
    {
    case WM_ACTIVATEAPP:
        bActive = wParam;
		if( bActive == FALSE )
		{
			// 棬Nov.7.1997
			if( MUSIC_bEnable == TRUE )
			{
				DATA_WAVE_MusicStop();
			}
			if( EFFECT_bEnable == TRUE )
			{
				DS_QuitSound();
			}
			MAIN_bReplay = TRUE;
			if( FACE_GetProgramState() == PROGRAM_STATE_AVI )
			{
				PostMessage( hWnd, MM_MCINOTIFY, 0, nCurrentVideoID );
			}
			else if( FACE_GetProgramState() == PROGRAM_STATE_NONE
				&& MAIN_bEnding == TRUE )
			{	// ڲƬβʱʧȥ״̬Ϸ
				// game ending
				GAME_EndingEx( -3 );
				MAIN_bEnding = FALSE;
				DD_QuitGraph();
				PostQuitMessage( 0 );
			}
		}
		else if( bActive == TRUE )
		{
			if( MAIN_bReplay == TRUE )
			{
				if( EFFECT_bEnable == TRUE )
				{
					DS_InitSound( hwndGame );
				}
				if( MUSIC_bEnable == TRUE )
				{
					DATA_WAVE_MusicReplay();
				}
				MAIN_bReplay = FALSE;
			}
			if( MAIN_bNotify == TRUE )
			{
				SetCursor( NULL );
				if( FACE_GetProgramState() == PROGRAM_STATE_AVI ) 
				{
					FACE_Avi_Close2();
				}
				MAIN_bNotify = FALSE;
			}
			if( MAIN_bInitGraph == TRUE )
				FACE_SurfaceLost();
		}
        break;

    case WM_SETCURSOR:
        SetCursor(NULL);
		//LoadCursor(IDC_ARROW);
		return TRUE;

    case WM_CREATE:
        break;

	case	WM_ACTIVATE:
		// ֻҪһͿ
		/*		
		if( LOWORD(wParam) == WA_INACTIVE
			&& FACE_GetProgramState() == PROGRAM_STATE_AVI ) 
		{
			PostMessage( hWnd, MM_MCINOTIFY, 0, 0 );
		}
		*/		
		break;

	case	WM_NCACTIVATE:
		// ֻҪһͿ
		/*
		if( wParam == FALSE 
			&& FACE_GetProgramState() == PROGRAM_STATE_AVI ) 
		{
			PostMessage( hWnd, MM_MCINOTIFY, 0, 0 );
		}
		*/
		break;

	// ¼ʾ
	// Nov.21.1997
	case	WM_SHOW_EVENT:
		FACE_ShowEvent( wParam );
		break;

	case WM_DD_SURFACELOST:
//WriteLogFile("lhj.log", "\n Have receive the message WM_DD_SURFACELOST") ;
		{
			// move ime window (RU_LI) outside main window rectangle
			HIMC himc = ImmGetContext( hwndGame );
			POINT pt={800,600};
			ImmSetStatusWindowPos( himc, &pt );
		}
		if( FACE_GetProgramState() == PROGRAM_STATE_PLAY )
		{
			DRAW_UpdateScreen( FALSE );
			DDC_UpdateScreen();
		}
		else
		{
			FACE_SurfaceLost();
//WriteLogFile("lhj.log", "\n Have exit the function FACE_SurfaceLost()") ;
		}
		break;
	case	WM_CHAR:

		if( FACE_GetProgramState() == PROGRAM_STATE_NONE )
		{
			break;
		}

		if( (CHEAT_bEnable == TRUE) &&
			(FACE_GetCommandState() == COMMAND_STATE_PLAY)
		  )
		{
			if( wParam == 46 || wParam == 93 )	//"." "]"
			{	// һأһ֧
				RUN_DEBUG_bEndGame = 1;
				break;
			}
			else if( wParam == 61 )			//"=" 
			{	// һأڶ֧
				RUN_DEBUG_bEndGame = 2;
				break;
			}
			else if( wParam == 44 || wParam == 45 || wParam == 91 )	//"," "-" "["
			{	// һ
				RUN_EndGame( -2 );
				break;
			}
		}

		// Ѱҵ˵ʣಿ
		if ( FACE_GetCommandState() == COMMAND_STATE_PLAY
				&& (wParam == 112 || wParam == 80)	)//"p" "P"
		{
			// ԸòΪƶĻ
			POINT px={-1,-1};

			for( int x = 0; x<GAME_PLAYER_MAX; x ++ )
			{
				if( !EYE_PlayerIsAllied( x, GAME.nMe ) )
				{
					px=DisplayEnemy( x );
					if( px.x != -1 )
						break;
				}
				//px=DisplayEnemy(GAME.nMe);
			}
			DRAW_JumpScreen(px);
		}

		// to hadle the hot-key and set it down
		if( FACE_GetCommandState() == COMMAND_STATE_PLAY )
		{
			FACE_HotKeyDown((int)wParam, lParam) ; 
			FACE_NumKey( (int)wParam, lParam ) ;
		}

		FACE_IsInputString( hWnd, message, wParam, lParam);

		//--- for cheat code
		if( (char)wParam == CHEAT_str[CHEAT_nCompare] )
		{
			CHEAT_nCompare++;
			if( CHEAT_nCompare == 5 )
			{
				CHEAT_bEnable = 1-CHEAT_bEnable;
			}
		}
		else CHEAT_nCompare = 0;
		//--- for cheat code
		break;

	case WM_SYSCHAR:
		{
			char key = (char)wParam ;
			char HExt = (char)HIWORD(lParam) ;
			char LExt = (char)LOWORD(lParam) ;
		}
		break;

	case WM_KEYUP:
		if( FACE_GetProgramState() != PROGRAM_STATE_NONE )
		{
			// to hadle the hot-key and post message to Liu Gang
			FACE_HotKeyUp((int)wParam, lParam) ; 
		}
		break;

	case	WM_TIMER:
		PostMessage( hWnd, MM_MCINOTIFY, 0, nCurrentVideoID );
		break;
	case	MM_MCINOTIFY:
		// changed a lot, to fix a bug
		// If the current program is not in active, and AVI file meet the end,
		// we could not just close AVI file and load other DirectDraw objects,
		// we must only close AVI first, and, after activate the current window,
		// then load other DirectDraw objects.
		if( lParam == MUSIC_hCDHandle && wParam == 1 )
		{// ֻΪڲCD AudioҲһ
			DATA_WAVE_MusicReplay();
		}
		else if( nCurrentVideoID != -1
			&& lParam == nCurrentVideoID )
		{
			if( bActive == TRUE )
			{
				if( FACE_GetProgramState() == PROGRAM_STATE_AVI ) 
				{
					FACE_Avi_Close();
				}
				else if( FACE_GetProgramState() == PROGRAM_STATE_NONE
					&& MAIN_bEnding == TRUE )
				{	// game ending
					if( GAME_EndingEx() == 2 )
					{
						MAIN_bEnding = FALSE;
						DATA_WAVE_MusicStop();
						DS_QuitSound();
						DD_QuitGraph();
						PostQuitMessage( 0 );
					}
					MAIN_bFirst = TRUE;
				}
			}
			else if( MAIN_bNotify == FALSE )
			{
				FACE_Avi_Close1();
				MAIN_bNotify = TRUE;
			}
		}
		break;

    case WM_KEYDOWN:

		if( FACE_GetProgramState() == PROGRAM_STATE_AVI ) 
		{
			if( FACE_Avi_Close() == TRUE )
				break;
		}
		else if( FACE_GetProgramState() == PROGRAM_STATE_NONE 
			&& MAIN_bEnding == TRUE )
		{
			// game ending
			GAME_EndingEx( -2 );
			MAIN_bFirst = TRUE;
			break;
		}

		// Կ
		// July 18. 1997
        switch( wParam )
        {
/*
		case	VK_F1:
			GAME_EndingEx( 0 );
			MAIN_bFirst = TRUE;
			break;
*/
		case	VK_F2:
			if( CHEAT_bEnable == TRUE )
			{
				RUN_bAUTO = 1-RUN_bAUTO;
			}
			break;

		case VK_F3:
			// ǰ콵һ
			if( CHEAT_bEnable == TRUE 
				&& GAME_bNetwork == FALSE )
			{
				CTRL_DebugGeneral(0);
			}
			break;

		case VK_F4:
			// ǰһ
			if( CHEAT_bEnable == TRUE 
				&& GAME_bNetwork == FALSE )
			{
				CTRL_DebugGeneral(1);
			}
			break;

        case VK_F5:
			// ʾˢ
			if( CHEAT_bEnable == TRUE )
			{
				static BOOL bShowFrameCount=TRUE;
				DDC_ShowFrameRate( bShowFrameCount );
				bShowFrameCount = !bShowFrameCount;
				DRAW_bShowScrollBorder = !DRAW_bShowScrollBorder;
			}
            break;

		case	VK_F6:
			// ʾ
			if( CHEAT_bEnable == TRUE )
			{
				CTRL_bDebugCommand = 1-CTRL_bDebugCommand;
			}
			break;

		case	VK_F7:
			// Բ
			// July.17.1997
			if( CHEAT_bEnable == TRUE 
				&& GAME_bNetwork == FALSE )
			{
				CTRL_bDebugDie = 1-CTRL_bDebugDie;
			}
			break;

		case	VK_F8:
			// ԴӰ
			// enable or disable shadow
			if( CHEAT_bEnable == TRUE )
			{
				SHADOW_Enable( 1-SHADOW_IfEnabled() );
			}
			break;
		case	VK_F9:
			// ԼǮ
			if( CHEAT_bEnable == TRUE 
				&& GAME_bNetwork == FALSE )
			{
				GAME.Players[GAME.nMe].nGold+=10000;
				GAME.Players[GAME.nMe].nFood+=10000;
				GAME.Players[GAME.nMe].nWood+=10000;
				GAME.Players[GAME.nMe].nIron+=10000;
				GFWI_bUpdate = TRUE;
			}
			break;
		case	VK_F11:
			// ǰĻ
			DRAW_CopyScreen();
			break;
/*        case VK_F12:
			if( CHEAT_bEnable )
			{
				RUN_DEBUG_bEndGame = 1 - RUN_DEBUG_bEndGame;
			}
            break;		
*/

        case VK_ESCAPE:
			{
				FACE_EscKey(FALSE) ;
			}
			break;
		case	VK_PAUSE:
			{
				if( (FACE_GetCommandState() == COMMAND_STATE_PLAY)||
					(FACE_GetCommandState() == COMMAND_STATE_PAUSE)
				  )
					PostMessage(hwndGame, WM_COMMAND, BUTTON_PAUSE, 0);
			}
			break;
/*		case	VK_ADD:
			{
			GAME.nSpeed += 5;
			char tmp[129];
			itoa( GAME.nSpeed, tmp, 10 );
			OutputDebugString( tmp );
			OutputDebugString( "\t" );
			}
			break;
		case	VK_SUBTRACT:
			{
			if( GAME.nSpeed <= 0 )	break;
			GAME.nSpeed -= 5;
			char tmp[129];
			itoa( GAME.nSpeed, tmp, 10 );
			OutputDebugString( tmp );
			OutputDebugString( "\t" );
			}
			break;		*/
//------LHJ-------------------------------
		case VK_RETURN:
			{
				FACE_EscKey(TRUE) ;

				if( FACE_GetCommandState() == COMMAND_STATE_PLAY )
				{
					if( FACE_bMessageBox == FALSE )
					{
						FACE_bMessageBox = TRUE;
						FACE_SetMessage();
						FACE_Echo_prompt(hWnd);
					}
					else
					{
						FACE_bMessageBox = FALSE;
						FACE_UpdateMessageRect();
					}
				}
			}
			break;

		default:
			break;
//----LHJ---------------------------------
        }
        break;

//------------

    case WM_SYSKEYDOWN:
		{
			switch( wParam )
			{
			case	VK_F10:
				{
					PostMessage(hwndGame, WM_COMMAND, BUTTON_SYSTEMENU, 0);
				}
				break;
			default:
				break;
			}
		}
		break;

	////////////////////////////////////////////////////////
	//	to end the mession of a section or all of this game
	////////////////////////////////////////////////////////
	case WM_GAME_END :
		{
			if( DD_nSurfaceCounter != 210 )
				OutputDebugString("");
			class CDDPalette	pal;
			if( GAME.nID == 16 && lParam == -1 )
			{	// ʤ
  				DD_FadeOutScreen( 5, 10 );
				DD_EraseFrontScreen();
				//FACE_ShowABitmapPicture( PICTURE_END );
				//DD_EraseFrontScreen();
				//pal.LoadPalettePAL( "res\\ending.pal", TRUE );
				//pal.LoadPalettePAL( "res\\end.pal", TRUE );
				GAME_EndingEx( 0 );
				MAIN_bEnding = TRUE;
				MAIN_bFirst = TRUE;
				//DS_QuitSound();
		        //DD_QuitGraph();
				//PostQuitMessage( 3 );
				//PostMessage( hWnd, WM_CLOSE, 0, 0 );
				break;
			}
			if( (GAME.nID == 16 || GAME.nID == 15) && lParam == 1 )
			{	// ʤ
  				DD_FadeOutScreen( 5, 10 );
				DD_EraseFrontScreen();
				//FACE_ShowABitmapPicture( PICTURE_END );
				//DD_EraseFrontScreen();
				//DS_QuitSound();
		        //DD_QuitGraph();
				//pal.LoadPalettePAL( "res\\end.pal", TRUE );
				if( GAME.nID == 15 )
					GAME_EndingEx( 0 );
				else
					GAME_EndingEx( 1 );
				MAIN_bEnding = TRUE;
				MAIN_bFirst = TRUE;
				//PostQuitMessage( 4 );
				//PostMessage( hWnd, WM_CLOSE, 0, 0 );
				break;
			}
			if( GAME.nID == 33 && lParam == -1 )
			{	// ܲٷʤ
  				DD_FadeOutScreen( 5, 10 );
				DD_EraseFrontScreen();
				//FACE_ShowABitmapPicture( PICTURE_END );
				//DD_EraseFrontScreen();
				//pal.LoadPalettePAL( "res\\end.pal", TRUE );
				GAME_EndingEx( 3 );
				MAIN_bEnding = TRUE;
				MAIN_bFirst = TRUE;
				//DS_QuitSound();
		        //DD_QuitGraph();
				//PostQuitMessage( 5 );
				//PostMessage( hWnd, WM_CLOSE, 0, 0 );
				break;
			}
			if( (GAME.nID == 33 || GAME.nID == 31) && lParam == 1 )
			{	// ܲٷʤ
  				DD_FadeOutScreen( 5, 10 );
				DD_EraseFrontScreen();
				//FACE_ShowABitmapPicture( PICTURE_END );
				//DD_EraseFrontScreen();
				//DS_QuitSound();
		        //DD_QuitGraph();
				//pal.LoadPalettePAL( "res\\end.pal", TRUE );
				if( GAME.nID == 31 )
					GAME_EndingEx( 2 );
				else
					GAME_EndingEx( 3 );
				MAIN_bEnding = TRUE;
				MAIN_bFirst = TRUE;
				//PostQuitMessage( 2 );
				//PostMessage( hWnd, WM_CLOSE, 0, 0 );
				break;
			}
			if( GAME.nID == 0 && lParam == -2 )
			{	// ٵ0
				FACE_SetCommandState( COMMAND_STATE_PLAY );
				break;
			}
			if( GAME.nID == 17 && lParam == -2 )
			{	// ٵ0
				FACE_SetCommandState( COMMAND_STATE_PLAY );
				break;
			}

			if( lParam == 1 )
			{	// ʤ
  				DD_FadeOutScreen( 5, 10 );
				// ֧
				if( GAME.nID == 5 || GAME.nID == 14 
					|| GAME.nID == 6 || GAME.nID == 15 )
				{
					PostMessage(hwndGame, WM_COMMAND, NEW_MESSION, wParam+2 );
				}
				// ܲٷһ֧
				else if( GAME.nID == 29 )
				{
					PostMessage(hwndGame, WM_COMMAND, NEW_MESSION, wParam+3 );
				}
				// 
				else 
				{
					PostMessage(hwndGame, WM_COMMAND, NEW_MESSION, wParam+1 );
				}
				GAME_SetGenInfo( GAME_nSlot );
			}
			else if( lParam == 2 )
			{
				// ֧Ľ
				Assert( GAME.nID == 5 || GAME.nID == 14 || GAME.nID == 29 );
				PostMessage(hwndGame, WM_COMMAND, NEW_MESSION, wParam+1 );
				GAME_SetGenInfo( GAME_nSlot );
			}
			else if( lParam == 0 )
			{	// ʧ
				DD_FadeOutScreen( 5, 10 );
				// to show the fail picture
				FACE_ShowABitmapPicture( PICTURE_FAIL ) ;	// flag -> to indentify which bitmap picture to show
//				PostMessage(hwndGame, WM_COMMAND, BUTTON_SYSTEMENU_EXIT_TOMAINMENU, NONE );
				PostMessage(hwndGame, WM_COMMAND, NEW_MESSION, wParam );
			}
			else if( lParam == -1 )
			{	// ԣһ
  				DD_FadeOutScreen( 5, 10 );
				GAME_SetGenInfo( GAME_nSlot );
				PostMessage(hwndGame, WM_COMMAND, NEW_MESSION, wParam+1 );
			}
			else if( lParam == -2 )
			{	// ԣһ
  				DD_FadeOutScreen( 5, 10 );
				PostMessage(hwndGame, WM_COMMAND, NEW_MESSION, wParam-1 );
			}
		}
		break;

	case WM_COMMAND:
		{
			char	message[50];
			wsprintf(message,"Get number %d", wParam);
		//	MessageBox(hwndGame,message,NULL,MB_OK);
			FACE_ButtonCommand( hWnd, wParam, lParam );

			if( wParam == ESTABLISH_UNIT )
			{
				int tmp1=0;
				int tmp2 =0;

				tmp1 = wParam;
				tmp2 = lParam;
				char mes[50];
				sprintf(mes, " nID -> %d, COMMAND -> %d.\n", tmp2, tmp1);
//				MessageBox(hwndGame, mes, NULL, MB_OK);
			}
			// Liu
			if( FACE_GetCommandState() == COMMAND_STATE_PLAY )
			{
				if( CTRL_TASK_AssembleCmd( wParam, lParam ) == FALSE )
					CTRL_TASK_NumberButton( wParam, lParam );
			}
		}
		break;
	case WM_MOUSEMOVE:
		{	
			static int xPosSave=0, yPosSave=0;
			UINT	fwKeys = wParam;
			int		xPos = LOWORD(lParam);
			int		yPos = HIWORD(lParam);
			if( xPosSave == xPos && yPosSave == yPos )
			{
				OutputDebugString( "S" );
				break;
			}
			// LHJ. Oct.31.1996
			FACE_MouseMove(wParam, xPos, yPos);
			// LHJ

			// Liu
			if( FACE_GetCommandState() == COMMAND_STATE_PLAY )
			{	// ĻΧ
				MOUSE_IsLeftDown( xPos, yPos );
			}
		}
		//return TRUE;
		break;
		
	case WM_LBUTTONDOWN:
		{
			UINT	fwKeys = wParam;
			int		xPos = LOWORD(lParam);
			int		yPos = HIWORD(lParam);
			
			if(FACE_GetProgramState() == PROGRAM_STATE_AVI)
			{
				if(FACE_Avi_Close() == TRUE)
					break;
			}
			if( FACE_GetCommandState() == COMMAND_STATE_PLAY )
			{
				if( DRAW_rcClient.left < xPos &&
					DRAW_rcClient.top < yPos &&
					DRAW_rcClient.right >= xPos &&
					DRAW_rcClient.bottom >= yPos )
				{	// ͻ
					// Liu
					if( CTRL_TASK_AssembleDest( xPos, yPos ) == FALSE )
						MOUSE_LeftDown( xPos, yPos );
				}
				else
					DRAW_JumpScreen( MOUSE_InMiniMap( xPos, yPos ) );
			}
			if( FACE_GetCommandState() != COMMAND_STATE_NONE )
			{
				// LHJ.Oct.31.1996
				FACE_LeftButtonDown(xPos, yPos);
				// LHJ
			}
		}
		break;
	case WM_LBUTTONUP:
		{
			UINT	fwKeys = wParam;
			int		xPos = LOWORD(lParam);
			int		yPos = HIWORD(lParam);

			// LHJ.Oct.31.1996
			FACE_LeftButtonUp(xPos, yPos);
			// LHJ

			// Liu 
			if( FACE_GetCommandState() == COMMAND_STATE_PLAY )
			{	// һڿͻ
				if( CTRL_TASK_AssembleSrc( &MOUSE_LeftUp( xPos, yPos ), wParam ) )
				{
					//OutputString( MOUSE_nHitCounter, "\n" );
				}
			}
		}
		break;
	case WM_LBUTTONDBLCLK:
		{
			UINT	fwKeys = wParam;
			int		xPos = LOWORD(lParam);
			int		yPos = HIWORD(lParam);
			
//			if( xPos>470 )
			if( FACE_GetCommandState() != COMMAND_STATE_NONE )
			{
				FACE_LeftButtonDoubleClick(fwKeys, xPos, yPos);
			}
		}
		break;
//------------
	
	case WM_RBUTTONDOWN:
		{
			UINT	fwKeys = wParam;
			int		xPos = LOWORD(lParam);
			int		yPos = HIWORD(lParam);
			if( FACE_GetCommandState() == COMMAND_STATE_PLAY )
			{	// һڿͻ
				if( DRAW_rcClient.left < xPos &&
					DRAW_rcClient.top < yPos &&
					DRAW_rcClient.right >= xPos &&
					DRAW_rcClient.bottom >= yPos )
				{
					CTRL_TASK_AssembleCmdDest( xPos, yPos );
				}
				else
				{	// Ҽͼƶõص
					POINT pt = MOUSE_InMiniMap( xPos, yPos );
					if( pt.x != -1 )
						CTRL_TASK_AssembleCmdDest( (pt.x*MAP_Lib.szItem.cx)-DRAW_ptScreenOffset.x, 
						(pt.y*MAP_Lib.szItem.cy>>1)-DRAW_ptScreenOffset.y );
				}
			}
			// to cancel the current menu if the current menu if select_general 
			else if( FACE_GetCommandState() != COMMAND_STATE_NONE )
			{
				FACE_RightButtonDown(fwKeys, xPos, yPos) ;
			}
		}
		break;

    case WM_DESTROY:
		DATA_WAVE_MusicClose();
		DS_QuitSound();
	        DD_QuitGraph();
		HZ_CloseLib();
		PostQuitMessage(1);
        break;

    }

    return DefWindowProc(hWnd, message, wParam, lParam);

} /* WindowProc */

/*
 * doInit - do work required for every instance of the application:
 *                create the window, initialize data
 */
static BOOL doInit( HANDLE hInstance, int nCmdShow )
{
	char	wndname[33];	// file name of the major window
	char	stpname[33];	// file name of stores the setup directory
	char	frname[33];		// file name of frame rate
	char	csname[33];		// file name of cursor
	char	cspath[33];		// path of cursor
	char	btlname[33];	// file name of palette in battle field
	char	facename[33];	// file name of main back-ground palette
	int		bTestIns=TRUE;  // TRUE for test instance

	// open game setup file
	FILE * fp = fopen( "CBGame.set" , "rt");
	if( fp == NULL )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+0, "Cannot open game set file:", "CBGame.set" );
		return FALSE;
	}
	fscanf( fp, "%s\n", strCopyright );
	fscanf( fp, "%s\n", wndname );
	fscanf( fp, "%s\n", stpname );
	fscanf( fp, "%s\n", frname );
	fscanf( fp, "%s %s\n", csname, cspath );
	fscanf( fp, "%s\n", btlname );
	fscanf( fp, "%s\n", facename );
	fscanf( fp, "%d\n", &MAIN_AVI_bFullScreen );	// ǷȫAVI
	fscanf( fp, "%d\n", &MAIN_bRelease );	// ǷΪа
	fscanf( fp, "%d\n", &FACE_AVI_FLAG );		// Ƿ񲥷AVI
	fscanf( fp, "%d\n", &bTestIns );		// Ƿʵ̣ȱʡǼ
	fclose( fp );

	// ǷѾбϷʵ̣
	// У򷵻
	if( bTestIns == TRUE )
	{
		if( MAIN_TestInstance( wndname ) == TRUE )
			return FALSE;
	}

	/*
	 * create major window
	 */

	if( !DD_InitWindow( hInstance, nCmdShow, wndname ) )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+1, "Error creating window!" );
		return FALSE;
	}


	// Ϸװ·
	if( !GAME_GetSrcPath( stpname, GAME_strSetupDirectory, strlen(GAME_strSetupDirectory) ) )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+9, "Install game first please!\n" );
		return FALSE;
	}

	// ʽҪCD
	if( MAIN_bRelease == TRUE && MAIN_TestCD() == FALSE )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+11, "Insert game CD please!\n" );
		return FALSE;
	}

    /*
     * create the main DirectDraw object
     */

	if( !DD_InitGraph( hwndGame, 640, 480, 8, FALSE ) )	
	{
		return FALSE;
	}
	MAIN_bInitGraph = TRUE;

#ifdef	_MMX_SPLASH_
	// detect if CPU supports MMX, and initialize splash
	MAIN_bMMX = MMXCPUID();
	//MAIN_bMMX = FALSE;
	OutputDebugString( "CBMAIN: MMX Compatible:" );
	OutputString( MAIN_bMMX, "\n" );
	if( IntelSplashInit() == TRUE );
//		IntelSplash();
#endif

	// AVI
//	FACE_SetProgramState ( PROGRAM_STATE_AVI );
	
	char avifile[_MAX_PATH];
	strcpy( avifile, GAME_strSetupDirectory );
	strcat( avifile, "\\avi\\" );
	strcat( avifile, "Start.avi" );
	strcpy( GAME.strStartAVI, avifile );
	FACE_Avi_Play( avifile, COMMAND_STATE_AVI_BEGIN );

	strcpy( avifile, GAME_strSetupDirectory );

    return TRUE;
} /* doInit */


BOOL MAIN_InitOthers()
{
	char	wndname[33];	// file name of the major window
	char	stpname[33];	// file name of stores the setup directory
	char	frname[33];		// file name of frame rate
	char	csname[33];		// file name of cursor
	char	cspath[33];		// path of cursor
	char	btlname[33];	// file name of palette in battle field
	char	facename[33];	// file name of main back-ground palette

	// open game setup file
	FILE * fp = fopen( "CBGame.set" , "rt");
	if( fp == NULL )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+0, "Cannot open game set file:", "CBGame.set" );
		return FALSE;
	}
	fscanf( fp, "%s\n", strCopyright );
	fscanf( fp, "%s\n", wndname );
	fscanf( fp, "%s\n", stpname );
	fscanf( fp, "%s\n", frname );
	fscanf( fp, "%s %s\n", csname, cspath );
	fscanf( fp, "%s\n", btlname );
	fscanf( fp, "%s\n", facename );
	fclose( fp );

	/*
	 * create sound object
	 */
	DS_InitSound( hwndGame );

	// initialize game data
	::GAME_InitGame();
	::MAP_InitMap();
	if( ! ::GAME_ReadCBSetFile( hwndGame ) ) 
		return FALSE;
	// to init all pointer array of interface
	FACE_InitInterface();
	// to show the begin bitmap file
	FACE_ShowABitmapPicture( PICTURE_BEGIN );
	// create and set the palette
	if( !pal.LoadPalettePAL( facename, FALSE ) )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID
			+3, " Cannot load Palette file", facename );
		return FALSE;
	}

	if( !palMain.LoadPalettePAL( btlname, FALSE ) )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+6, " Cannot load Main Palette file", btlname );
		return FALSE;
	}

    // create and set the cursor
	if( !MAIN_LoadCursors( hwndGame, csname, cspath ) )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+4, " Cannot load cursor files", csname );
		return FALSE;
	}
//	CURSOR_Set( &MAIN_Cursors[0] );

	// create and set the frame rate
	if( !DDC_LoadFrameRate( frname ) )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+5, " Cannot load FRate bitmap", frname );
		return FALSE;
	}

	if( !HZ_OpenLib( "hzk\\simple.exp" ) )
	{
		ErrorMessage( hwndGame, MAIN_ERROR_ID+15, "No HZ Library at all", frname );
		return FALSE;
	}
	return TRUE;
}

/*
 * WinMain - initialization, message loop
 */
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                        LPSTR lpCmdLine, int nCmdShow)
{
    MSG         msg;

    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;

    if( !doInit( hInstance, nCmdShow ) )
    {
		OutputDebugString( "WinMain: Do Init failure!\n" );
        return FALSE;
    }

	// load other maps
#ifdef	_MAIN_DEBUG
	if( ChangeProgramState( PROGRAM_STATE_PLAY, BUTTON_MENU_MAIN_NEWGAME_OK ) == PROGRAM_STATE_ERROR )
		return FALSE;
#else

#endif

	// play background wave
//	strcpy( waveBack.strFileName, GAME.strPathWAV );
//	strcat( waveBack.strFileName, "one.wav" );
//	waveBack.Play();

	DWORD dwTimeBegin;
	DWORD dwTimeEnd;
	dwTimeBegin = timeGetTime();

	DWORD dwTimeBeginCursor;
	DWORD dwTimeEndCursor;
	dwTimeBeginCursor = timeGetTime();

	//---- DH
//	DH_NetworkInit();
	//---- DH

	// counter for moving screen
    while( 1 )
    {
		if( CurrentMenu != NULL )
		{
//			if( (FACE_GetProgramState() == PROGRAM_STATE_MENU)&&
//				(CurrentMenu->GetID() == MENU_MAIN_NETWORK_SETNET)
//			)
			if( (FACE_GetProgramState() == PROGRAM_STATE_MENU) && (IsInSetNetMenu == TRUE) )
			{	// to receive the network message when you are in the Menu_NetWork_SetNet menu
				DH_ReceiveMessage();
	//			if(GAME.nMe<=0)
					{
						int	j;
						for(j=0;j<MAX_PLAYERS;j++)
							{
								if((DP_PlayerInformation[j].DP_dcoID==DP_dcoID)&&(DP_dcoID!=0))
									{
										GAME.nMe=j+1;
										GAME.Players[GAME.nMe].nType=PLAYER_TYPE_HUMAN;
									}
								else
								{
										if(DP_PlayerInformation[j].DP_dcoID!=0)
											{GAME.Players[j+1].nType=PLAYER_TYPE_REMOTE;}
								}
							}
						if(GAME.nMe!=0 && GAME.nMe!=1)
							{
								//Ϣlihaijun
	//							SendMessage( hwndGame, WM_COMMAND, SHOW_MENU_MAIN_NETWORK_IPX_JOIN, GAME.nMe );
								SendMessage( hwndGame, WM_COMMAND, BACKTO_BUTTON_MENU_MAIN_NETWORK_IPX_CREATE, 0 );
							}
					}
	//			else{
	//					GAME.Players[GAME.nMe].nType=PLAYER_TYPE_HUMAN;
	//				}
			}
		}

        while( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
        {
            if( !GetMessage( &msg, NULL, 0, 0 ) )
                return msg.wParam;
            TranslateMessage(&msg); 
            DispatchMessage(&msg);
        }
        if( bActive )
        {
#ifdef	_DEBUG
			bInRun = TRUE;
#endif
			// game core loop
			// draw cursor
			if( MAIN_bFirst )
			{
				// move ime window (RU_LI) outside main window rectangle
				HIMC himc = ImmGetContext( hwndGame );
				POINT pt={800,600};
				ImmSetStatusWindowPos( himc, &pt );
				DDC_UpdateScreen();
			}
			MAIN_bFirst = FALSE;

			// update cursor
			dwTimeEndCursor = timeGetTime();
			if( dwTimeEndCursor - dwTimeBeginCursor >= MAIN_CURSOR_WAIT )
			{
				dwTimeBeginCursor = dwTimeEndCursor;
				// perform animate cursor, 
				// only change the current frame of the curosr, do not draw it
				CURSOR_Animate();
			}

			// main circle of the game
			dwTimeEnd = timeGetTime();
			int nAdd = 0;
			if( MAIN_bMMX == FALSE )
				nAdd = 15;
			if( dwTimeEnd - dwTimeBegin >= GAME.nSpeed+nAdd )
			{
				dwTimeBegin = dwTimeEnd;
				if( FACE_GetProgramState() == PROGRAM_STATE_PLAY )
				{
					//---- DH
//					DH_ReceiveInit();
					//---- DH

					updateFrame();

					// test if should move screen
					::DRAW_MoveScreen();
				}
			}
#ifdef	_DEBUG
			bInRun = FALSE;
#endif

        }
        else
        {
            // make sure we go to sleep if we have nothing else to do
            WaitMessage();
        }
    }
} /* WinMain */
////////////////////////						

// ԭʼİ취
BOOL MAIN_TestCD()
{
	char tmp[128];

	// test 1
	strcpy( tmp, GAME_strSetupDirectory );
	strcat( tmp, "\\TestCD.log" );
	FILE *fp = fopen( tmp, "wb" );
	if( fp != NULL )
	{
		char test[64];
		strcpy( test, GAME_strSetupDirectory );
		if( fwrite( test, strlen(test), 1, fp ) == 1 )
		{
			fclose( fp );
			return FALSE;
		}
		fclose( fp );
	}

	// test 2
	strcpy( tmp, GAME_strSetupDirectory );
	strcat( tmp, "\\CB.EXE" );
	fp = fopen( tmp, "rb" );
	if( fp == NULL )
	{
		return FALSE;
	}
	fclose( fp );

	// test 3
	// Nov.7.1997
	// ʵʲǼ̣ǶȡǷǺϢ
	// Ҳʵǿͱ׼ж
	strcpy( tmp, GAME_strSetupDirectory );
	strcat( tmp, "\\Disk.no" );
	fp = fopen( tmp, "rb" );
	if( fp == NULL )
	{	// ǿ
		return FALSE;
	}
	fscanf( fp, "%d\n", &GAME_nDisk );		// ǷǺ棬0Ϊǣ1ΪǺẠ2ΪǺB̡
	fclose( fp );
	return TRUE;
}

// ǷѾбϷʵ̣
// У򷵻
BOOL MAIN_TestInstance( char *wndname )
{
	HWND hWndFirst, hWndFirstChild;
	static char title[_MAX_FNAME];

	strcpy( title, wndname );

	if(hWndFirst = FindWindow(NULL, title))
	{
		hWndFirstChild = GetLastActivePopup(hWndFirst);
		BringWindowToTop(hWndFirst);

		if(hWndFirst != hWndFirstChild)
			BringWindowToTop(hWndFirstChild);

		ShowWindow(hWndFirst, SW_SHOWNORMAL);

		return TRUE;
	}
	return FALSE;
}