/////////////////
// CBMap.h		:	ڡͼͼȫݽṹ
// CBMap.h		:	<< chibi >> global map data structure
//
// v0010		:	Sep.18.1996
// v0011		:	Oct.16.1996
// v0012		:	Nov.7.1996
// v0013		:	Nov.22.1996
// v0014		:	Feb.5.1997
// v0020		:	Feb.28.1997
// v0030		:	May.14.1997, changed so many things, especialy for testregion
//
// д			:	
// written by	:	Liu Gang
//
// 		:	Visual C++ 4.2
// Compiler		:	Visual C++ 4.2
//
// Ȩ			:	ǰ޹˾		1996-1997
// Copyright	:	WayAhead Software Co.Ltd.	1996-1997
/////////////////
// ļжԵκ͵ԪͼصĲ

#ifndef	__CBMAP_H__
#define	__CBMAP_H__

#include "CBGame.h"	// for struct UNIT_STRUCT and struct CTRL_FRAME_STRUCT (in CBCTrl.h)

///////////
// 궨
// ȫID
#define	MAP_ERROR_ID	500

#define	_MAP_COMPRESS_

// սͼĲ
#define	MAP_DATA_THICK	3
// սͼĿ
#define	MAP_DATA_WIDTH	120
// սͼĸ
#define	MAP_DATA_HEIGHT	360
// Чͼر
#define	MAP_DATA_NONE	0xFFFF
// ͼصĿ
#define	MAP_ITEM_WIDTH	44
// ͼصĸ
#define	MAP_ITEM_HEIGHT	22
///////////

///////////
// 
// ͼؿ
#define	MAP_GROUND_LIB_NUM		16
// Ч
#define	MAP_GROUND_TYPE_NONE	0
// һ
#define	MAP_GROUND_TYPE_GENERAL	1
// Сɽ
#define	MAP_GROUND_TYPE_HILL	2
// ǳǽ
#define	MAP_GROUND_TYPE_CITY	3
// 
#define	MAP_GROUND_TYPE_OTHER	4

// ͼڿе
#define MAP_GROUND_ITEM_COL	16
// ͼڿе
#define MAP_GROUND_ITEM_ROW	8

// ͼشṹչ
struct MAP_GROUND_CODE_STRUCT	// ͼش洢ʽ
{
	int	nAttr;	// ͼص
	int	nFile;	// ͼصļ
	int nCol;	// ͼļе
	int	nRow;	// ͼļе
};

//- Tian Yue
#ifndef	TNEBUG

// ͼؿṹ
struct MAP_GROUND_LIB_STRUCT
{
	char strWnd[33];		// ͼؿⴰ
	RECT rcWnd;				// ͼؿⴰڵľ
	SIZE szView;			// ͼؿĵС=ÿһͼصĵС*ͼص

	int  nID;				// ͼؿIDͼ༭Ч
	char strFile[33];		// ͼؿԴļ
	char strMaskFile[33];	// ͼؿļ

	SIZE szItem;		// ͼصĵС
	int nHeight;		// ͼصĵ߶
	SIZE szNum;		// ͼؿڷõͼص

	int nFile;			// ͼصļ
	int nLayer;			// ͼصĲ
	int nType;			// ͼصͣ0ã1һ㣬2ɽ3ǣ
	int	nItemHeights[MAP_GROUND_ITEM_COL];			// ÿһͼصĸ
	WORD nItems[MAP_GROUND_ITEM_COL][MAP_GROUND_ITEM_ROW];	// ͼؿ
};
///////////

//- Tian Yue
#endif // TNEBUG

///////////
// Ԫ
// Ԫͼؿ
#define	MAP_UNIT_LIB_NUM		56

// ЧԪ
#define	MAP_UNIT_TYPE_NONE		0
// Ԫǽ
#define	MAP_UNIT_TYPE_BUILDING	1
// ԪԴ
#define	MAP_UNIT_TYPE_RESOURCE	2
// Ԫʿ
#define	MAP_UNIT_TYPE_SOLDIER	3
// Ԫͼ
#define	MAP_UNIT_TYPE_SPECIAL	4
// ԪǴ
#define	MAP_UNIT_TYPE_FLAG		5
// ԪǴ
#define	MAP_UNIT_TYPE_SHIPYARD	6
// ԪǴֻ
#define	MAP_UNIT_TYPE_SHIP		7
// Ԫ
#define	MAP_UNIT_TYPE_LADDER	8
// Ԫսӽ
#define	MAP_UNIT_TYPE_GEN		9
/*
 * --- ADDED BY TIAN YUE ---
 */

// 
#define MAP_UNIT_TYPE_WORKER	10
// ƽ
#define MAP_UNIT_TYPE_MAN		11
// Ԫǹ˽죬Ľ
#define	MAP_UNIT_TYPE_WGEN		12
// Ԫˮ
#define	MAP_UNIT_TYPE_SGEN		13




// Ԫͼص
#define	MAP_UNIT_ITEM_ROW	64
// Ԫͼص
#define	MAP_UNIT_ITEM_COL	20
// Ԫͼص״̬
#define	MAP_UNIT_STATE_MAX	48
// Ԫͼص
#define	MAP_UNIT_ITEM_MAX	24

// Ԫͼشṹչ
struct MAP_UNIT_CODE_STRUCT
{
	// nearly same as CTRL_FRAME_STRUCT
	int	nPlayer;	// ͼصĹ
	int nFile;		// ļ
	int nCol;		// ĳ֡꣨УУ
	int nRow;
	int nLayer;		// ͼ
	int nFrame;		// ǰ֡Ϊͼ׼
};

//- Tian Yue
#ifndef	TNEBUG

// Ԫͼؿṹ
struct MAP_UNIT_LIB_STRUCT
{
	SIZE szView;			// ͼؿĵС=ÿһͼصĵС*ͼص

	int	 nID;				// ͼؿID, ͼ༭Ч

	char strFile[33];		// ͼؿԴļ
	char strMaskFile[33];	// ͼؿļ

	SIZE szItem;		// ͼصĵС
	//int nHeight;		// ͼصĵ߶
	SIZE szNum;			// ͼؿʵʷõͼص

	int nFile;			// ͼصļ
	//int nLayer;		// ͼصĲ
	int nType;			// 
	int nLocationSize;	// ͼصĴС1469
	int	nItemWidths[MAP_UNIT_ITEM_ROW];	// ÿһͼصĸ֡
	DWORD nItems[MAP_UNIT_ITEM_ROW];	// ͼؿ
};

// Ԫݽṹ
struct MAP_ANISEQ_STRUCT2
{
	int nMaxState;
	int nMaxSequence[MAP_UNIT_STATE_MAX];
	// 
	POINT ptAniSeq[MAP_UNIT_STATE_MAX][MAP_UNIT_ITEM_COL];
};

// ¼
#define MAP_UNIT_ANI_EVENT_MAX	6
// Ԫݽṹ
struct MAP_ANISEQ_STRUCT
{
	// ״̬
	int nMaxState;
	// ÿ״̬֡
	int nMaxSequence[MAP_UNIT_STATE_MAX];
#ifdef	_MAP_COMPRESS_
	int nOffset;	// ѹеƫ
	// ֡
	BYTE nAniSeq[MAP_UNIT_STATE_MAX][MAP_UNIT_ITEM_MAX];
	// ¼Ŀʼ״̬
	int nEventBegin[MAP_UNIT_ANI_EVENT_MAX];
	// ķˮķ8һ
	int nDeadDir;
#else
	// ֡
	POINT ptAniSeq[MAP_UNIT_STATE_MAX][MAP_UNIT_ITEM_COL];
#endif
};
////////////


///////////
// 
// ЧϷ߱
#define	MAP_PLAYER_NONE	0x00
// Ӱ
#define	MAP_SHADOW_NONE	0x0F
// ṹչ
struct MAP_REGION_CODE_STRUCT
{
	WORD nPlayer;	// ռиõľ
	BYTE nShadow;	// õϵӰ1ʵӰ
	BYTE nShadowEx;	// õϵӰ2״Ӱ
};
///////////

// 
///////////
// ͼص
#define	MAP_SPECIAL_MAX		4
// Чͼش
#define	MAP_SPECIAL_NONE		0x0F
#define	MAP_SPECIAL_WOOD		0
#define	MAP_SPECIAL_WHEAT		1
#define	MAP_SPECIAL_TRAP		2
#define	MAP_SPECIAL_DO_WOOD		4
#define	MAP_SPECIAL_DO_WHEAT	5
#define	MAP_SPECIAL_DO_TRAP		6
#define	MAP_SPECIAL_CUT_WOOD	8
#define	MAP_SPECIAL_CUT_WHEAT	9
#define	MAP_SPECIAL_CUT_TRAP	10
///////////

// ͼ
///////////
#define	MAP_MINI_TYPE_MAX	6
#define MAP_MINI_COLOR_MAX	24
struct MAP_MINI_LIB_STRUCT
{
	// ǰͼ
	int	 nType;							// type of minimap, always be 0,1,2
	// ͼĴСλ
	RECT rcMap[MAP_MINI_TYPE_MAX];	// minimap size and position
	// ͼɫ
	int nColorTable[MAP_MINI_COLOR_MAX];	// minimap color table
	// սʾĴСλ
	RECT rcScreen;						// rectangle of the battlefield window
};

// ͼ
#define	MAP_OTHER_NUM	16
struct MAP_OTHER_STRUCT
{
	int nID;			// ͼؿID
	int nMaxFrame;		// ,Ҳ֡
	SIZE szItem;		// ͼصĴС
	char strFile[33];	// ļ
	int nFrame;			// ǰ֡
};

///////////
// ȫ
// ͼؿṹ
struct MAP_LIB_STRUCT	// ͼر༭ȱʡõĽṹ
{
	RECT rcMain;	// ڵľ
	SIZE szItem;	// ÿһͼصĵС
	SIZE szNum;		// ͼڿɷõͼص
	SIZE szView;	// ͼĵС=ÿһͼصĵС*ͼص
	int nHeight[MAP_DATA_THICK+1];	// ÿͼؾĸ߶
	float fVersion;	// ͼİ汾

	int	nGLibNum;	// ͼؿļĸ
	struct MAP_GROUND_LIB_STRUCT Ground[MAP_GROUND_LIB_NUM];// ͼؿṹ

	int	nULibNum;	// Ԫͼؿļĸ
	struct MAP_UNIT_LIB_STRUCT Unit[MAP_UNIT_LIB_NUM];// Ԫͼؿṹ
	// Ԫ
	struct MAP_ANISEQ_STRUCT AniSeq[MAP_UNIT_LIB_NUM];
 
	// ͼأͼԵԪʽ洢ģ
	int nSpec;
	DWORD Special[MAP_SPECIAL_MAX];

	// ͼ
	int nOtherNum;	// ͼļĸ
	struct MAP_OTHER_STRUCT Other[MAP_OTHER_NUM];	// ͼļ

	// Ӱļ
//	char strShadow[_MAX_FNAME];
	// ļ
// 	char strBuild[_MAX_FNAME];
	// ͼѹļѹ״̬еԪͼ
	char strBMP[_MAX_FNAME];
};

///////////

// ȫ
///////////
// ͼܿ
extern struct MAP_LIB_STRUCT	MAP_Lib;
///////////

//- Tian Yue
#endif	// TNEBUG

// ʼ
///////////
// ʼͼݣUnit, Ground, Region
// initialize ground, unit, region data and map library
void MAP_InitMap();
// initialize ground, unit, region data
void MAP_InitGUR();
// initialize map library
void MAP_InitMapLib();

// ʼͼ
void MAP_ResetGround();

// ʼԪͼ
void MAP_ResetUnit();

// ʼͼ
void MAP_ResetRegion();
///////////

//- Tian Yue
#ifndef	TNEBUG

// ͼ
///////////
// ͼļ
// defined in file CBFile.cpp
// hwnd			:	ʱھ
// filename		:	ͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadGroundFile( HWND hwnd, LPCTSTR filename, LPCTSTR pathDAT, LPCTSTR pathBMP );

// Եͼؽ
// ڵô˺֮ǰӦжcodeֵǷΪMAP_DATA_NONE
// codeG	:	ͼش루ѹڣ
// pstctG	:	ͼش루չڣ
extern void MAP_GroundDeCode(WORD codeG, struct MAP_GROUND_CODE_STRUCT * pstctG);

// Եͼؼ
// stctG		:	ͼش루չڣ
// return value	:	ͼش루ѹڣ
extern WORD MAP_GroundEnCode(struct MAP_GROUND_CODE_STRUCT stctG);

// ȡõͼ
// nLayer		:	
// nCol			:	к
// nRow			:	к
// return value	:	ͼش루ѹ
extern WORD MAP_GetGroundData( int nLayer, int nCol, int nRow );

// õͼ
// nLayer	:	
// nCol		:	к
// nRow		:	к
// codeG	:	ͼش루ѹ
extern void MAP_SetGroundData( int nLayer, int nCol, int nRow, WORD codeG );

// õͼĻλúʹС㣩
// lprcS		:	Ļڸӵָ루ڣ
// nLayer		:	
// nCol			:	к
// nRow			:	к
// nFile		:	ļ
// return value	:	ͼĻλúʹС㣩
RECT MAP_GetGroundRect( CONST POINT ptOff, int nLayer, int nCol, int nRow, int nFile );
///////////

// Ԫͼ
///////////
// Ԫͼݶļ
// defined in file CBFile.cpp
// hwnd			:	ʱھ
// filename		:	Ԫͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadUnitFile( HWND hwnd, LPCTSTR filename, LPCTSTR pathDAT, LPCTSTR pathBMP );

// ԵԪͼؽ
// ڵô˺֮ǰӦжcodeֵǷΪMAP_DATA_NONE
// codeU	:	Ԫͼش루ѹڣ
// pstctU	:	Ԫͼش루չڣ
extern void MAP_UnitDeCode(DWORD codeU, struct MAP_UNIT_CODE_STRUCT * pstctU);

// ԵԪͼؼ
// stctU		:	Ԫͼش루չڣ
// return value	:	Ԫͼش루ѹڣ
extern DWORD MAP_UnitEnCode(struct MAP_UNIT_CODE_STRUCT stctU);

// ԵԪͼݽв
// õԪݣѹ
// nCol			:	к
// nRow			:	к
// return value	:	Ԫݣѹ
DWORD MAP_GetUnitData( int nCol, int nRow );

// õʾ/ݣѹ
// ԪݺɾԪݣһ
// ֻCTRL_UNIT_Create()CTRL_UNIT_Destroy()
// ⲿڲɾԪʱֱʹ
// nLayer		:	ţĿλ
// nCol			:	кţĿλ
// nRow			:	кţĿλ
// codeU		:	Ԫݣѹ
// return value	:	ĵԪѹExcodeUEx
WORD MAP_SetUnitData( int nLayer, int nCol, int nRow, DWORD codeU );

// ֱӵõ
// nCol			:	к
// nRow			:	к
// return value	:	Ԫݣѹ룩
extern WORD MAP_GetUnitDataEx( int nCol, int nRow );

// ֱ
// nCol			:	к
// nRow			:	к
// wCode		:	Ԫݣѹ룩
extern void MAP_SetUnitDataEx( int nCol, int nRow, WORD wCode );

// õʾͼݣ˺רʾ
// кŲڸõԪʾλʱ򷵻ʧ
// nCol			:	к
// nRow			:	к
// pstctCF		:	֡ݽṹڣ
// reutrn value	:	TRUE if succeeded
BOOL MAP_GetUnitFrameData( int nCol, int nRow, struct CTRL_FRAME_STRUCT *pstctCF, BOOL bDone=TRUE );

// ƶԪ
// ĿλñԪռʱʧ
// ֻCTRL_UNIT_Move()ã˲ֱӵô˺
// only used by CTRL_UNIT_Move()
// pDraw		:	unit control frame struct Ԫ֡ƽṹ
// return value	:	TRUE if succeeded
BOOL MAP_MoveUnit( struct CTRL_FRAME_STRUCT *pDraw, int nType );

//- Tian Yue
#endif	// TNEBUG

// õԪṹ
// nCol			:	к
// nRow			:	к
// return value	:	Ԫṹָ
extern struct UNIT_STRUCT *MAP_GetUnit( int nCol, int nRow );

// õԪṹ
// dwCode		:	Ԫѹ
// return value	:	Ԫṹָ
extern struct UNIT_STRUCT *MAP_GetUnit( WORD wCode );

//- Tian Yue
#ifndef	TNEBUG

// õԪͼĻλúʹС㣩
// lprcS		:	Ļڸӵָ루ڣ
// pstctCF		:	֡ṹָ루ڣ
// return value	:	ԪͼĻλúʹС㣩
RECT MAP_GetUnitRect( CONST POINT ptOff, CONST struct CTRL_FRAME_STRUCT *pstctCF );

// õԪľλúʹСھλϲõԪ
// lprcS		:	Ļڸӵָ
// pstctCF		:	֡ṹָ루ڣ
// return value	:	ԪͼĻһλõλúʹС㣩
RECT MAP_GetUnitRectLast( CONST POINT ptOff, CONST struct CTRL_FRAME_STRUCT *stctCF );
///////////

// ͼ
///////////
// ȡͼ
// defined in file CBFile.cpp
// hwnd			:	ʱھ
// filename		:	ͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadSpecFile( HWND hwnd, LPCTSTR filename , LPCTSTR path );

// õʾͼݣreturn not null for pstct is valid
// nLayer		:	
// nCol			:	к
// nRow			:	к
// nAttr		:	
// pstctCF		:	֡ṹָ루ڣ
// reutrn value	:	TRUE if succeeded
BOOL MAP_GetSpecFrameData( int nLayer, int nCol, int nRow, int nAttr, struct CTRL_FRAME_STRUCT *pstctCF );
///////////

// ͼ
///////////
// ͼؽ
// ڵô˺֮ǰӦжcodeֵǷΪMAP_DATA_NONE
// codeR	:	ͼأѹڣ
// pstctR	:	ͼأչڣ
extern void MAP_RegionDeCode(WORD codeR, struct MAP_REGION_CODE_STRUCT * pstctR);

// ͼؼ
// stctR		:	ͼأչڣ
// return value	:	ͼأѹڣ
extern WORD MAP_RegionEnCode(struct MAP_REGION_CODE_STRUCT stctR);

// ݵĲ
// , ݹ麯
// pt		:	ӣΪλ
// nPlayer	:	ݣϷ߱
void MAP_FillRegion( POINT pt, int nPlayer );

// 
// pt	:	ӣΪλ
void MAP_ClearRegion( POINT pt );

// ֱӽѹĴõ
// nCol		:	к
// nRow		:	к
// codeR	:	ݴ루ѹ
extern void MAP_SetRegionData( int nCol, int nRow, int codeR );

// ֱӴȡ
// nCol			:	к
// nRow			:	к
// return value	:	ݴ루ѹ
extern WORD MAP_GetRegionData( int nCol, int nRow );

#define	MAP_REGION_ERROR_CANNOT		3
#define	MAP_REGION_ERROR_UNDER		4
#define	MAP_REGION_ERROR_TUDI		0
#define	MAP_REGION_ERROR_SHIPYARD	2
#define	MAP_REGION_ERROR_FLAG		1
#define	MAP_REGION_ERROR_SHORT		5
#define	MAP_REGION_ERROR_SHIP		6
#define	MAP_REGION_ERROR_OUT		7
#define	MAP_REGION_ERROR_RES		8
#define	MAP_REGION_ERROR_SHADOW		9
#define	MAP_REGION_ERROR_WATER		10
#define	MAP_REGION_ERROR_BANK		11
#define	MAP_REGION_SUCCESS			20
// ǷڴƬ޽return 10 if successful
// nLayer		:	
// pt			:	Ե㣬Ϊλ
// codeU		:	루ѹ
// codeUEx		:	ĵԪʱȡô˵㣬MAP_DATA_NONEʱЧ
// return value	:	룬
int MAP_TestRegion( int nLayer, POINT pt, DWORD codeU, WORD codeUEx=MAP_DATA_NONE );

// ԶҵһԷøõԪλã10ΧѰ
// nZ, nX, nY	:	ʼ
// codeU		:	õԪѹ
// codeUEx		:	ĵԪʱȡô˵㣬MAP_DATA_NONEʱЧ
// return		:	(-1,-1)ʱΪûҵ
POINT MAP_FindRegion( int nZ, int nX, int nY, DWORD codeU, WORD codeUEx=MAP_DATA_NONE );

// ֻCBBuild.cppʹã콨ʱ
// ǷڴƬ޽
// nLayer		:	
// pt			:	Ե㣬Ϊλ
// codeU		:	루ѹ
// pnRet		:	ֵ
// nRetNum		:	ĸ
void MAP_TestRegionBuild( int nLayer, POINT pt, DWORD codeU, int *pnRet, int nRetNum );
///////////

// ̽⸽
///////////
#define	MAP_LOCATION_MAX	16
// ѯ̽⸽ĵԪ͵
// Ϊ10
//    0
//  7   1
//6       2
//  5   3
//    4
#define	MAP_SENSER_MAX	10
// Լ10
// First Dimension:		Even or Odd
// Second Dimension:	Distance from center
// Third Dimension:		max senser items
extern POINT MAP_ptSenser[2][MAP_SENSER_MAX][8*MAP_SENSER_MAX]; // Ϊżʱʹ

// read senser file, defined in CBFile.cpp
// ȡ̽
// hwnd			:	ʱھ
// filename		:	̽ļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadSenserFile( HWND hwnd, LPCTSTR filename, LPCTSTR path );
///////////

///////////
// Ԫͼضݶļ
// defined in file CBFile.cpp
// hwnd			:	ʱھ
// filename		:	Ԫͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadAniSeqFile( HWND hwnd, LPCTSTR filename, LPCTSTR path );

// ĵԪͼضݶļ
// defined in file CBFile.cpp
// hwnd			:	ʱھ
// filename		:	Ԫͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadAniSeqFileEx( HWND hwnd, LPCTSTR filename, LPCTSTR path );
///////////

///////////
// ȡͼļ
// defined in file CBFile.cpp
// hwnd			:	ʱھ
// filename		:	Ԫͼļ
// path			:	ļ·
// reutrn value	:	TRUE if succeeded
BOOL MAP_ReadMiniFile( HWND hwnd, LPCTSTR filename, LPCTSTR path );
///////////

///////////
// ȡ
BOOL MAP_ReadOtherFile( HWND hwnd, LPCTSTR filename, LPCTSTR pathDAT, LPCTSTR pathBMP );

// ݵľ
// ptOff	:	ĻϽս
// nLayer, nCol, nRow	:	սά
// nFile	:	ݽṹļ
// return	:	ĻĵͷΧ
RECT MAP_GetOtherRect( CONST POINT ptOff, int nLayer, int nCol, int nRow, int nFile );
///////////

//- Tian Yue
#endif	// TNEBUG
#endif	// __CBMAP_H__