/////////////////
// CBOther.cpp	:	v0020
// v0010		:	Mar.21.1997
// v0020		:	May.16.1997, add stone, fixed some bugs
// written by	:	Liu Gang
// Compiler		:	Visual C++ 4.2
// Copyright	:	WayAhead Software Co.Ltd.	1996-1997
/////////////////
// implementation file
// 𣬹ľʯͶʯѪը𹥣꣬ѩȵݽṹ
#include "stdafx.h"
#include "CBOther.h"
#include "Assert.h"

// only used by OTHER_Hit()
#include "CBMap.h"
#include "CBGame.h"
#include "CBCtrl.h"
#include "CBMouse.h"
#include "CBEYEs.h"
#include "CBData.h"
#include "CBMini.h"	// MINI_SetBlink()


//added by tian yue
#include "tbnbase.h"


// LHJ
#include "Cbprompt.h"
// LHJ

// globals
/////////////////
struct OTHER_STRUCT OTHER[OTHER_MAX];
int OTHER_nCounter = 0;

#define	OTHER_HUOGONG_RAND	300
/////////////////

// externals
/////////////////
extern POINT DRAW_ptScreenOffset;			// defined in CBDraw.cpp
extern int CTRL_nHitCounter;				// defined in CBCtrl.cpp
extern RECT DRAW_rcScreen;					// defined in CBDraw.cpp

extern int CB_Counter;

// жԪС0ԸõԪ´ɾ
// ֻеʾȫ󣬲CTRL_UNIT_Detroy()ɾ
extern void RUN_UNIT_ToDie( struct UNIT_STRUCT *pUnit );

// defined in CBRunOT.cpp
// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
extern void RUN_SOUND_Wounded( int nX, int nY, int nFile );

// defined in CBRunOT.cpp
// Чÿһʱÿش򿪣ĻҷԪ/
// ܵʱɻϷWe are under attack!
// nX, nY	:	Ԫλ
// nFile	:	Ԫļ
extern void RUN_SOUND_UnderAttack( int nX, int nY, int nFile );

// defined in CBCTRl.cpp, debug for do not die
extern BOOL CTRL_bDebugDie;
/////////////////

/////////////////
// initialize
void OTHER_InitOther()
{
	OTHER_nCounter = 0;
	memset( OTHER, 0, sizeof(OTHER_STRUCT)*OTHER_MAX );
}
/////////////////

/////////////////
// 
#define	OTHER_MOUSE_MAX	20
// õ
// pOther	:	source structure
// return	:	index in array, -1 if failed
int OTHER_CreateData( struct OTHER_STRUCT *pOther )
{
	BOOL bSuccess = FALSE;
	for( int i=0; i<OTHER_MAX-OTHER_MOUSE_MAX; i++ )
	{
		if( OTHER[i].nType == OTHER_TYPE_NONE )
		{
			bSuccess = TRUE;	break;
		}
	}
	if( bSuccess == TRUE )
	{
		memcpy( &OTHER[i], pOther, sizeof( OTHER_STRUCT ) );
		OTHER[i].ptCur.x = OTHER[i].ptBegin.x, 
		OTHER[i].ptCur.y = OTHER[i].ptBegin.y;
		OTHER_nCounter++;
#ifdef	_DEBUG
//		OutputDebugString( "OTHER_CreateData() Message:" );
//		OutputString( OTHER_nCounter, "\n" );
#endif
/*
		if( pOther->nType == OTHER_TYPE_HUOGONG )
		{
			char temp[128];
			wsprintf( temp, "//---------------%d------------------//\n", CB_Counter );
			WriteLogFile( "Net.log", temp );
			WriteErrorFile( "Net.log", i );
		}
*/
		return i;
	}
	else	return -1;
}

// õ
// רΪãDec.8.1997
// pOther	:	source structure
// return	:	index in array, -1 if failed
int OTHER_CreateDataEx( struct OTHER_STRUCT *pOther )
{
	BOOL bSuccess = FALSE;
	for( int i=OTHER_MAX-1; i>=OTHER_MAX-OTHER_MOUSE_MAX; i-- )
	{
		if( OTHER[i].nType == OTHER_TYPE_NONE )
		{
			bSuccess = TRUE;	break;
		}
	}
	if( bSuccess == TRUE )
	{
		memcpy( &OTHER[i], pOther, sizeof( OTHER_STRUCT ) );
		OTHER[i].ptCur.x = OTHER[i].ptBegin.x, 
		OTHER[i].ptCur.y = OTHER[i].ptBegin.y;
		OTHER_nCounter++;
#ifdef	_DEBUG
//		OutputDebugString( "OTHER_CreateData() Message:" );
//		OutputString( OTHER_nCounter, "\n" );
#endif
/*
		if( pOther->nType == OTHER_TYPE_HUOGONG )
		{
			char temp[128];
			wsprintf( temp, "//---------------%d------------------//\n", CB_Counter );
			WriteLogFile( "Net.log", temp );
			WriteErrorFile( "Net.log", i );
		}
*/
		return i;
	}
	else	return -1;
}

// ɾݣCreateDataӦ
// nIndex	:	index in OTHER array
void OTHER_DestroyData( int nIndex )
{

#ifdef	_DEBUG
	if( nIndex < 0 )
	{
		OutputDebugString( "OTHER_DestroyData Error: index is less than 0!\n" );
		return;
	}
#endif

	struct OTHER_STRUCT *pOther = &OTHER[nIndex];
#ifdef	_DEBUG
	if( pOther->nType == OTHER_TYPE_NONE )
		OutputDebugString( "OTHER_DestroyData Warning: has been cleared!\n" );
#endif
	OTHER_nCounter--;
	memset( pOther, 0, sizeof( OTHER_STRUCT ) );
}

// ʼṹ
// pOther	:	source structure
void OTHER_ClearData( struct OTHER_STRUCT *pOther )
{
	memset( pOther, 0, sizeof( OTHER_STRUCT ) );
}
/////////////////

/////////////////
// ƶ
// index	:	index in array
// return	:	TRUE if hit
BOOL OTHER_Move( int nIndex )
{

#ifdef	_DEBUG
	if( nIndex < 0 )
	{
		OutputDebugString( "OTHER_Move Error: index is less than 0!\n" );
		return FALSE;
	}
#endif

	struct OTHER_STRUCT *pOther = &OTHER[nIndex];
	switch( pOther->nType )
	{
	case	OTHER_TYPE_FIRE:
		// ڻҪȼգֱⲿɾ
		if( pOther->nCounter>=pOther->nDelay )
		{
			pOther->nCounter = 0;
			Assert( pOther->nMaxFrame );
			pOther->nFrame = (pOther->nFrame+1)%pOther->nMaxFrame;
		}
		pOther->nCounter++;
		break;
	case	OTHER_TYPE_ARROW:
		// ڹĿĵغɾԼ
		if( pOther->nCounter >= pOther->nDelay )
		{	// Ŀĵ
			OTHER_HitArrow( nIndex );
			OTHER_DestroyData( nIndex );
		}
		else
		{
			pOther->nCounter += pOther->nSpeed;
			pOther->ptCur.x = pOther->ptBegin.x + (int)(pOther->nCounter*pOther->fCos);
			pOther->ptCur.y = pOther->ptBegin.y + (int)(pOther->nCounter*pOther->fSin);
		}
		break;
	case	OTHER_TYPE_GUNMU:
	case	OTHER_TYPE_STONE:
		// ͶʯĿĵغɾԼ
		if( pOther->nCounter >= pOther->nDelay )
		{	// Ŀĵ
			OTHER_HitStone( nIndex );
			OTHER_DestroyData( nIndex );
		}
		else
		{
			pOther->nCounter += pOther->nSpeed;
			pOther->ptCur.x = pOther->ptBegin.x + (int)(pOther->nCounter*pOther->fCos);
			pOther->ptCur.y = pOther->ptBegin.y + (int)(pOther->nCounter*pOther->fSin);
		}
		break;
	case	OTHER_TYPE_BLOOD:
		// DOWNͣڶ֡Ҫɾ
	case	OTHER_TYPE_BOMB:
		// ڱըڶ֡Ҫɾ
	case	OTHER_TYPE_MOUSE:
		// ꣬ڶ֡Ҫɾ
		if( pOther->nCounter >= pOther->nDelay )
		{
			pOther->nFrame++;
			pOther->nCounter = 0;
			if( pOther->nFrame >= pOther->nMaxFrame )
			{
				pOther->nFrame = 0;
				//OTHER_Hit( nIndex );
				OTHER_DestroyData( nIndex );
				return TRUE;
			}
		}
		pOther->nCounter++;
		break;
	case	OTHER_TYPE_HUOGONG:
		// Dec.6.1997, Liu Gang
		// ڻ𹥣һʱɾԼ
		if( pOther->nCounter>=pOther->nDelay )
		{
			pOther->nCounter = 0;
			Assert( pOther->nMaxFrame );
			pOther->nFrame = (pOther->nFrame+1)%pOther->nMaxFrame;
			OTHER_HUOGONG_Hit( nIndex );
		}
		pOther->nCounter++;
		pOther->nSpeed++;
		if( pOther->nSpeed == (pOther->nTargetID>>1) )
		{
			if( OTHER_HUOGONG_Hit( nIndex ) == TRUE )
			{
				// ˻𹥵ĳʱ䣬Aug 29, 1997
				if( pOther->nOwnerID < 2 )
					pOther->nOwnerID+=2;
			}
			// ʱ䳬һʱһЩ
			// ĴΪ0ʱ
			// ĸ19
			WORD codeG = MAP_GetGroundData( 0, pOther->ptEnd.x, pOther->ptEnd.y );
			int nNum = 4;
			if( codeG != MAP_DATA_NONE )
			{	// ŵôһЩ
				struct MAP_GROUND_CODE_STRUCT stctG;
				MAP_GroundDeCode( codeG, &stctG );
				if( stctG.nAttr != MAP_SPECIAL_NONE && stctG.nAttr < 4 )
				{
					nNum = 8;
					// ˻𹥵ĳʱ䣬Aug 29, 1997
					// pOther->nOwnerID++;
				}
			}
			OTHER_HUOGONG_Set( pOther->ptEnd.x, pOther->ptEnd.y, pOther->nTargetID, pOther->nOwnerID-1, nNum );
		}
		if( pOther->nSpeed >= pOther->nTargetID )
		{	// ʱɾ
			OTHER_HUOGONG_Die( nIndex );
			OTHER_DestroyData( nIndex );
		}
		break;
	}
	return FALSE;
}

// õĻϵľ
// ptScreenOff	:	offset of screen relative to the whole map
// nIndex		:	index in array
// return		:	rectangle on screen
RECT OTHER_GetRect( POINT ptScreenOff, int nIndex )
{
	RECT rect={0,0,0,0};

#ifdef	_DEBUG
	if( nIndex < 0 )
	{
		OutputDebugString( "OTHER_GetRect Error: index is less than 0!\n" );
		return rect;
	}
#endif

	struct OTHER_STRUCT *pOther = &OTHER[nIndex];
	rect.left = pOther->ptCur.x - ptScreenOff.x,
	rect.top = pOther->ptCur.y - ptScreenOff.y;
	rect.right = rect.left + pOther->szItem.cx,
	rect.bottom = rect.top + pOther->szItem.cy;

	return rect;
}

// Ŀĵغ󣬶ԸõϵĵԪʧ
// nIndex	:	index in array
// return	:	TRUE if hit someone
BOOL OTHER_HitStone( int nIndex )
{
	struct OTHER_STRUCT *pOther;
	struct UNIT_STRUCT *pUnit, *pU;	//ֱʯ˺Ͷʯ
	
#ifdef	_DEBUG
	if( nIndex < 0 )
	{
		OutputDebugString( "OTHER_HitStone Error: index is less than 0!\n" );
		return FALSE;
	}
#endif

	pOther = &OTHER[nIndex];

	// ñըЧ
	struct OTHER_STRUCT otherBomb;
	OTHER_ClearData( &otherBomb );

	otherBomb.nFile = 2;
	otherBomb.nType = OTHER_TYPE_BOMB;
	otherBomb.nDelay = 5;	//RUN_TIMEDELAY_BOMB

	otherBomb.ptBegin.x = pOther->ptCur.x-23;	// ƫ
	otherBomb.ptBegin.y = pOther->ptCur.y-32;
	otherBomb.szItem.cx = MAP_Lib.Other[otherBomb.nFile].szItem.cx;
	otherBomb.szItem.cy = MAP_Lib.Other[otherBomb.nFile].szItem.cy;
	for( int i=0; i<4; i++ )
	{
		otherBomb.nCol[i] = i;
	}
	otherBomb.nMaxFrame = 4;
	OTHER_CreateData( &otherBomb );

	// ĿĵѰ
	pUnit = MAP_GetUnit( pOther->ptEnd.x, pOther->ptEnd.y );

	// July 31. 1997, Liu Gang
	if( pUnit && EYE_IfUnitIsDead( pUnit ) ) return FALSE;

	if( pUnit && !EYE_IfUnitIsDead( pUnit ) )
	{
		// 㹥Ч

		//----------------------------------------
		int nHit, nDefend;
		nDefend = EYE_GetFarDefend( pUnit );
		nHit = pOther->nHit-nDefend;
		if( nHit <= 0 ) nHit = 1;

		// Բ״̬
		// July.17.1997, Liu Gang
		if( CTRL_bDebugDie == TRUE 
			&& GAME.nMe == pUnit->Draw.nPlayer )
			nHit = 0;

		// Ѫڱǰֵһ룬ֵһ룬
		// 򷢳
		BOOL bWounded = FALSE;
		if( pUnit->nLife>=(EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile )>>1) )
			bWounded = TRUE;
		// 
		pUnit->nLife -= nHit;
		if( pUnit->nLife>=(EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile )>>1) 
			|| bWounded == FALSE )
			bWounded = FALSE;
		if( bWounded == TRUE )
			// Ч
			RUN_SOUND_Wounded( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
			// Ч
		//----------------------------------------

		// ˭Լ
		// õͶʯĵԪ
		Assert( pOther->nOwnerID != MAP_DATA_NONE );
		pU = MAP_GetUnit( pOther->nOwnerID );
		Assert( pU );
		if( !EYE_IfUnitIsDead( pU )
			&& pU->Draw.nPlayer != pUnit->Draw.nPlayer )
		{
			Assert( EYE_IfUnitIsCatapult( pU ) 
				|| pU->Draw.nFile == 32 || pU->Draw.nFile == 45 );
			pUnit->nIDAttackMe = pOther->nOwnerID;			// ID
			if( pUnit->Draw.nPlayer == GAME.nMe )	// Ϸ
			{
				MINI_SetBlink( pUnit->Draw.nDrawX, pUnit->Draw.nDrawY );
				RUN_SOUND_UnderAttack( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
			}
		}

		//--Ч
		// 24: obreak04.wavը
		POINT pt;
		pt.x = pUnit->Draw.nX, pt.y = pUnit->Draw.nY;
		if( PtInRect( &DRAW_rcScreen, pt ) )
		{
			DATA_WAVE_EffectPlay( 24 );
		}
		//--Ч

		// 
		if( pUnit->nLife <= 0 )
		{
			RUN_UNIT_ToDie( pUnit );
			return TRUE;
		}

		// Ѫ
		if( EYE_IfFocusOnUnit( pUnit ) )
		{
			// Ѫ
			if( EYE_IfUnitIsGen( pUnit ) )
			{
				FACE_ShowProcessBar( PROCESSBAR_BLOOD, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile ) );
			}
			else if( CTRL_nHitCounter == 1 )
				FACE_ShowProcessBar( PROCESSBAR_STONE, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile ) );
		}
		return TRUE;
	}
	return FALSE;
}

// Ŀĵغ󣬶Ŀ굥Ԫʧ
// nIndex	:	index in array
// return	:	TRUE if hit someone
BOOL OTHER_HitArrow( int nIndex )
{
	struct OTHER_STRUCT *pOther;
	struct UNIT_STRUCT *pUnit, *pU;	//ֱм˺
	
#ifdef	_DEBUG
	if( nIndex < 0 )
	{
		OutputDebugString( "OTHER_HitArrow Error: index is less than 0!\n" );
		return FALSE;
	}
#endif

	pOther = &OTHER[nIndex];
	Assert( pOther->nTargetID != MAP_DATA_NONE );
	pUnit = MAP_GetUnit( pOther->nTargetID );
	Assert( pUnit );

	// July 31. 1997, Liu Gang
	if( EYE_IfUnitIsDead( pUnit ) ) return FALSE;

//--------------
	// Ѫڱǰֵһ룬ֵһ룬
	// 򷢳
	BOOL bWounded = FALSE;
	if( pUnit->nLife>=(EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile )>>1) )
		bWounded = TRUE;
	// 
	// ǽжʱѪ
	if( pUnit->Status.bIRQ == FALSE 
		|| EYE_IfUnitIsBuild( pUnit ) )
		pUnit->nLife -= pOther->nHit;

	if( pUnit->nLife>=(EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile )>>1) 
		|| bWounded == FALSE )
		bWounded = FALSE;
	if( bWounded == TRUE )
		// Ч
		RUN_SOUND_Wounded( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
		// Ч
//--------------

//	pU->bHasStone = FALSE;	// Ͷʯ־

	// ˭Լ
	Assert( pOther->nOwnerID != MAP_DATA_NONE );
	pU = MAP_GetUnit( pOther->nOwnerID );
	Assert( pU );
	if( !EYE_IfUnitIsDead( pU )// ߻û
		&& pU->Draw.nPlayer != pUnit->Draw.nPlayer )
	{
		pUnit->nIDAttackMe = pOther->nOwnerID;			// ID
		if( pUnit->Draw.nPlayer == GAME.nMe )	// Ϸ
		{
			MINI_SetBlink( pUnit->Draw.nDrawX, pUnit->Draw.nDrawY );
			RUN_SOUND_UnderAttack( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
		}
	}

	Assert( EYE_IfUnitIsDead( pU )
		|| EYE_IfUnitIsArcher( pU ) 
		|| EYE_IfUnitIsTower( pU ) 
		|| EYE_IfUnitIsBattleShip( pU ) );

	// 
	if( pUnit->nLife <= 0 )
	{
		RUN_UNIT_ToDie( pUnit );
		return TRUE;
	}

	// Ѫ
	if( EYE_IfFocusOnUnit( pUnit ) )
		//&& EYE_IfSheIsMine( pU )
	{
		// Ѫ
		if( EYE_IfUnitIsGen( pUnit ) )
		{
			FACE_ShowProcessBar( PROCESSBAR_BLOOD, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile ) );
		}
		else if( CTRL_nHitCounter == 1 )
			FACE_ShowProcessBar( PROCESSBAR_STONE, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile ) );
	}

	return TRUE;
}


// CBRun.cpp
extern RUN_nCounter;	// м

// 𹥵Ļ
// nX, nY	:	Żλãӣ
// nLife	:	ʱ䣨֣
// nDai		:	ĴΪ0ʱ
// nNum		:	ĸ19
inline void OTHER_HUOGONG_Set( int nX, int nY, int nLife, int nDai, int nNum )
{
	if( nDai <= 0 ) return;

	int DIR8[8]={0, 1, 7, 2, 6, 3, 5, 4};
	int DIR4[4]={0, 2, 4, 6};

	if( nNum > 1 )
	{
		if( nNum == 4 )
		{
			for( int i=0; i<nNum; i++ )
			{
				BOOL bOdd = nY&1;
				int nXNext = nX+MAP_ptSenser[bOdd][0][DIR4[i]].x;
				int nYNext = nY+MAP_ptSenser[bOdd][0][DIR4[i]].y;
				OTHER_HUOGONG_Set( nXNext, nYNext, nLife, nDai, 1 );
			}
		}
		else if( nNum == 8 )
		{
			for( int i=0; i<nNum; i++ )
			{
				BOOL bOdd = nY&1;
				int nXNext = nX+MAP_ptSenser[bOdd][0][DIR8[i]].x;
				int nYNext = nY+MAP_ptSenser[bOdd][0][DIR8[i]].y;
				OTHER_HUOGONG_Set( nXNext, nYNext, nLife, nDai, 1 );
			}
		}
		return;
	}

	struct OTHER_STRUCT other;
	OTHER_ClearData( &other );
	other.nType = OTHER_TYPE_HUOGONG;
	other.nFile = 3;
	other.nCol[0] = 0;
	other.nCol[1] = 1;
	other.nCol[2] = 2;
	other.nCol[3] = 3;
	other.nMaxFrame = 4;
	other.nDelay = 4;
	other.szItem.cx = MAP_Lib.Other[other.nFile].szItem.cx;
	other.szItem.cy = MAP_Lib.Other[other.nFile].szItem.cy;
	RECT rect = MAP_GetGroundRect( DRAW_ptScreenOffset,	0, nX, nY, 0 );
	other.ptBegin.x = (rect.right+rect.left)/2 - other.szItem.cx/2+DRAW_ptScreenOffset.x;
	other.ptBegin.y = rect.bottom+DRAW_ptScreenOffset.y-other.szItem.cy;

	other.nHit = 10;				// 
	other.ptEnd.x = nX;			// ڸλ
	other.ptEnd.y = nY;
	other.nOwnerID = nDai;		// Ĵ
	other.nTargetID = nLife;	// ֵ

	// Dec.6.1997, Liu Gang
	other.nFrame = RUN_nCounter %other.nMaxFrame;	// ǰ֡

	WORD codeG = MAP_GetGroundData( 0, nX, nY );
	if( codeG != MAP_DATA_NONE )
	{
		struct MAP_GROUND_CODE_STRUCT stctG;
		MAP_GroundDeCode( codeG, &stctG );
		switch( stctG.nFile )
		{
		case	0:
		case	5:
			break;
		case	1:
		case	2:
			if( other.nOwnerID >= 1 )
				other.nOwnerID -= 1;		// Ĵ
			else
				other.nOwnerID = 0;
			break;
		case	3:
		case	4:
			if( other.nOwnerID >= 2 )
				other.nOwnerID -= 2;		// Ĵ
			else
				other.nOwnerID = 0;
			break;
		}
	}

	// жǷѾлˣУ˳
	WORD codeR = MAP_GetRegionData( nX, nY );
	struct MAP_REGION_CODE_STRUCT stctR;
	MAP_RegionDeCode( codeR, &stctR );
	if( stctR.nPlayer == 1 )
		return;
	// ڸõŻı־Ż
	stctR.nPlayer = 1;
	codeR = MAP_RegionEnCode( stctR );
	MAP_SetRegionData( nX, nY, codeR );
	OTHER_CreateData( &other );
}

// Ч
// nIndex	:	index in array
// return	:	TRUE if hit someone
BOOL OTHER_HUOGONG_Hit( int nIndex )
{
	OTHER_STRUCT *pOther = &OTHER[nIndex];
	struct UNIT_STRUCT *pUnit = NULL;

	WORD codeUEx = MAP_GetUnitDataEx( pOther->ptEnd.x, pOther->ptEnd.y );
	if( codeUEx == MAP_DATA_NONE )
		return FALSE;

	pUnit = MAP_GetUnit( codeUEx );
	Assert( pUnit );

	if( pUnit->nLife < 0 ) return FALSE;

//--------------
	// Ѫڱǰֵһ룬ֵһ룬
	// 򷢳
	BOOL bWounded = FALSE;
	if( pUnit->nLife>=(EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile )>>1) )
		bWounded = TRUE;
	// 
	// ǽжʱѪ
	if( pUnit->Status.bIRQ == FALSE 
		|| EYE_IfUnitIsBuild( pUnit ) )
	{
		pUnit->nLife -= pOther->nHit;
		pUnit->nBloodPos=1;;
	}
	
	if( pUnit->nLife>=(EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile )>>1) 
		|| bWounded == FALSE )
		bWounded = FALSE;
	if( bWounded == TRUE )
		// Ч
		RUN_SOUND_Wounded( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
		// Ч
//--------------

//	pU->bHasStone = FALSE;	// Ͷʯ־

	// ܵı־
	if( pUnit->Draw.nPlayer == GAME.nMe )	// Ϸ
	{
		MINI_SetBlink( pUnit->Draw.nDrawX, pUnit->Draw.nDrawY );
		RUN_SOUND_UnderAttack( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
	}

	// 
	if( pUnit->nLife <= 0 )
	{
		/*
		char temp[128];
		wsprintf( temp, "//-----------%d--------------//\n", CB_Counter );
		WriteLogFile( "NetErr.log", temp );
		WriteErrorFile( "NetErr.log", pUnit->nID );
		*/
		RUN_UNIT_ToDie( pUnit );
		return TRUE;
	}

	// Ѫ
	if( EYE_IfFocusOnUnit( pUnit ) )
	{
		// Ѫ
		if( EYE_IfUnitIsGen( pUnit ) )
		{
			FACE_ShowProcessBar( PROCESSBAR_BLOOD, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile ) );
		}
		else if( CTRL_nHitCounter == 1 )
			FACE_ShowProcessBar( PROCESSBAR_STONE, pUnit->nLife*100/EYE_GetFullLife( pUnit->Draw.nPlayer, pUnit->Draw.nFile ) );
	}
	return TRUE;
}

// defined in CBDrawOT.cpp
// Դ״̬ıʱո󣩣Ҫ¸
// nZ,nX,nY :	
extern void DRAW_OTHER_UpdateResource( int nZ, int nX, int nY );
// ɾЧԴԴʹõ
void OTHER_HUOGONG_Die( int nIndex )
{
	// ԴԴʹõ
	struct OTHER_STRUCT *pOther = &OTHER[nIndex];
	WORD codeG = MAP_GetGroundData( 0, pOther->ptEnd.x, pOther->ptEnd.y );
	if( codeG != MAP_DATA_NONE )
	{
		struct MAP_GROUND_CODE_STRUCT stctG;
		MAP_GroundDeCode( codeG, &stctG );
		if( stctG.nAttr != MAP_SPECIAL_NONE && stctG.nAttr < 4 )
		{
			stctG.nAttr += 8;	// 
			codeG = MAP_GroundEnCode( stctG );
			MAP_SetGroundData( 0, pOther->ptEnd.x, pOther->ptEnd.y, codeG );
			DRAW_OTHER_UpdateResource( 0, pOther->ptEnd.x, pOther->ptEnd.y );
		}
	}

	// Ż־
	WORD codeR = MAP_GetRegionData( pOther->ptEnd.x, pOther->ptEnd.y );
	struct MAP_REGION_CODE_STRUCT stctR;
	MAP_RegionDeCode( codeR, &stctR );
	Assert( stctR.nPlayer == 1 );
	stctR.nPlayer = 0x0F;
	codeR = MAP_RegionEnCode( stctR );
	MAP_SetRegionData( pOther->ptEnd.x, pOther->ptEnd.y, codeR );
}
/////////////////
