/////////////
//	CBRunOT.cpp		:	v0020
//	Written by		:	Liu Gang
//	Compiler		:	Microsoft Visual C++ 4.2
//	Copyright (C)	:	1996 WayAhead Corporation
//	v0010			:	Nov.18.1996
//	v0020			:	Mar.24.1997, seperated from CBRun.cpp
/////////////
// implementation file
// components of CBRun
// CBRun.cppĸģ

#include "stdafx.h"
#include "Assert.h"
#include "CBRun.h"
#include "CBGame.h"
#include "CBMap.h"
#include "CBData.h"
#include "CBOther.h"
#include "CBEyes.h"

#include "CBMini.h"	// MINI_SetBlink()

//-- LHJ
#include "cbprompt.h"	// FACE_UpdateGrade()
#include "interfac.h"
//-- LHJ

#include <math.h>	// sqrt()

#include "CBRDelay.h"	// defines

/////////////
extern POINT DRAW_ptScreenOffset;			// defined in CBDraw.cpp
extern int GFWI_bUpdate;	// defined in CBDRAW.cpp, for test only
extern RECT DRAW_rcScreen;	// defined in CBDraw.cpp
// Чÿһʱÿش򿪣ĻҷԪ/
// ܵʱɻϷWe are under attack!
// Ϊʱش򿪣ԷϢ
BOOL RUN_SOUND_bWeAreUnderAttack = TRUE;

// defined in CBCTRl.cpp, debug for do not die
extern BOOL CTRL_bDebugDie;
/////////////


/////////////
// Local functions
// жԪС0ԸõԪ´ɾ
// ֻеʾȫ󣬲CTRL_UNIT_Detroy()ɾ
void RUN_UNIT_ToDie( struct UNIT_STRUCT *pUnit );
/////////////

/////////////
// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
void RUN_SOUND_Hit( int nX, int nY, int nFile );

// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
void RUN_SOUND_HitF( int nX, int nY, int nFile );

// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
void RUN_SOUND_Die( int nX, int nY, int nFile );

// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
void RUN_SOUND_Wounded( int nX, int nY, int nFile );

// Чÿһʱÿش򿪣ĻҷԪ/
// ܵʱɻϷWe are under attack!
// עҪںжϷ
// nX, nY	:	Ԫλ
// nFile	:	Ԫļ
void RUN_SOUND_UnderAttack( int nX, int nY, int nFile );
/////////////

/////////////
// 㹥ڲʹ
int RUN_FIGHT_calcHitPoint( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU );
int RUN_FIGHT_calcHitPointF( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU );

// =+ϵ+ϵ+ϵ
// =+ϵ+ϵ+ϵ

// 
int RUN_FIGHT_calcHitPoint( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU )
{
	// 
	//----------------------------------------
	int nHit, nAttack, nDefend;
	Assert( EYE_IfUnitIsSoldier( pUnit ) 
		|| EYE_IfUnitIsGen( pUnit ) );

	nAttack = EYE_GetNearAttack( pUnit );
	nDefend = EYE_GetNearDefend( pU );

	// adjust hit
	nHit = nAttack - nDefend;
	if( nHit <= 0 ) nHit = 1;
	// Բ״̬
	// July.17.1997, Liu Gang
	if( CTRL_bDebugDie == TRUE && GAME.nMe == pU->Draw.nPlayer )
		nHit = 0;
	//----------------------------------------
	return nHit;
}

// Զ
int RUN_FIGHT_calcHitPointF( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU )
{
	// 
	//----------------------------------------
	int nHit, nAttack, nDefend;
	Assert( EYE_IfUnitIsSoldier( pUnit ) 
		|| EYE_IfUnitIsGen( pUnit ) 
		|| EYE_IfUnitIsTower( pUnit ) );

	nAttack = EYE_GetFarAttack( pUnit );
	nDefend = EYE_GetFarDefend( pU );

	// adjust hit
	nHit = nAttack - nDefend;
	if( nHit <= 0 ) nHit = 1;
	// Բ״̬
	// July.17.1997, Liu Gang
	if( CTRL_bDebugDie == TRUE && GAME.nMe == pU->Draw.nPlayer )
		nHit = 0;
	//----------------------------------------
	return nHit;
}
/////////////

// ǷǮ
BOOL RUN_CREATE_IfEnoughMoney( int nPlayer, int nFile )
{
	// Դ
	if( GAME.Players[nPlayer].nFood < DATA_Lib.Unit[nFile].nCreateFood 
		|| GAME.Players[nPlayer].nWood < DATA_Lib.Unit[nFile].nCreateWood
		|| GAME.Players[nPlayer].nGold < DATA_Lib.Unit[nFile].nCreateGold
		|| GAME.Players[nPlayer].nIron < DATA_Lib.Unit[nFile].nCreateIron )
	{
		OutputDebugString( "RUN_CreateUnit Error: Short of Resource!\n" );
		//------------ʾ
		if( GAME.nMe == nPlayer )
		{
			if( nFile >= 0 && nFile < 27 )
			{	//Ѳ޷
				FACE_ShowPromptInfor( 6 );
			}
			else
			{	//Ѳ޷ѵ
				FACE_ShowPromptInfor( 8 );
			}
			//---- Ч
			// noselect.wav
			DATA_WAVE_EffectPlay( 99 );
			//---- Ч
		}
		//------------ʾ
		return FALSE;
	}
	return TRUE;
}

// Ǯ
BOOL RUN_CREATE_Consume( int nPlayer, int nFile )
{
	if( !RUN_CREATE_IfEnoughMoney( nPlayer, nFile ) )
		return FALSE;
	// Ǯ
	GAME.Players[nPlayer].nGold -= DATA_Lib.Unit[nFile].nCreateGold;
	GAME.Players[nPlayer].nFood -= DATA_Lib.Unit[nFile].nCreateFood;
	GAME.Players[nPlayer].nWood -= DATA_Lib.Unit[nFile].nCreateWood;
	GAME.Players[nPlayer].nIron -= DATA_Lib.Unit[nFile].nCreateIron;
	GFWI_bUpdate = TRUE;
	return TRUE;
}

// 졢ȡǮ
BOOL RUN_CREATE_PayBack( int nPlayer, int nFile )
{
	// Ǯ
	GAME.Players[nPlayer].nGold += DATA_Lib.Unit[nFile].nCreateGold*RUN_CREATE_PAYBACK/100;
	GAME.Players[nPlayer].nFood += DATA_Lib.Unit[nFile].nCreateFood*RUN_CREATE_PAYBACK/100;
	GAME.Players[nPlayer].nWood += DATA_Lib.Unit[nFile].nCreateWood*RUN_CREATE_PAYBACK/100;
	GAME.Players[nPlayer].nIron += DATA_Lib.Unit[nFile].nCreateIron*RUN_CREATE_PAYBACK/100;
	GFWI_bUpdate = TRUE;
	return TRUE;
}

// õԪĶ
// pUnit	:	ĵԪָ
void RUN_DESTROY_SetAfterLife( struct UNIT_STRUCT *pUnit )
{
	struct CTRL_FRAME_STRUCT *pDraw = &pUnit->Draw;

	// detect if should really draw 
//	if( pUnit->Draw.nFile >= 27 )	// ʿжǷĻ
	// Ҫж
	POINT ptPOS[2][25]=
		{
			{{-1,0,},{1,0},{-1,1},{0,1},
			{-1,2},{0,2},{1,2},{-1,3},{0,3},
			{-1,4},{0,4},{1,4},{-1,5},{0,5},
			{-1,6},{0,6},{1,6},{-1,7},{0,7},
			{-1,8},{0,8},{1,8},{-1,9},{0,9},{0,10}},

			{{-1,0,},{1,0},{1,1},{0,1},
			{-1,2},{0,2},{1,2},{1,3},{0,3},
			{-1,4},{0,4},{1,4},{1,5},{0,5},
			{-1,6},{0,6},{1,6},{1,7},{0,7},
			{-1,8},{0,8},{1,8},{1,9},{0,9},{0,10}},
		};
	BOOL bSet = TRUE;	//ΪʱҪʾ״̬Ѫ
	int nX, nY;
	BOOL bOdd = pUnit->Draw.nY&1;
	for( int y=0; y<25; y++ )
	{
		nX = pUnit->Draw.nX + ptPOS[bOdd][y].x, 
		nY = pUnit->Draw.nY + ptPOS[bOdd][y].y;
		if( EYE_IfOutOfRange( nX, nY ) )
			break;//
		struct MAP_GROUND_CODE_STRUCT stctG;
		WORD codeG = MAP_GetGroundData( pUnit->Draw.nLayer, nX, nY );
		MAP_GroundDeCode( codeG, &stctG );
		if( stctG.nAttr != MAP_SPECIAL_NONE )
		{
			if( (stctG.nAttr == MAP_SPECIAL_WOOD
				|| stctG.nAttr == MAP_SPECIAL_DO_WOOD)
				&& y<6 )	// ľΧڲʾ
			{
				bSet = FALSE;//Դʾ
				break;
			}
			else if( (stctG.nAttr == MAP_SPECIAL_WHEAT
				|| stctG.nAttr == MAP_SPECIAL_DO_WHEAT)
				&& y<4 )	// ľһΧڲʾ
			{
				bSet = FALSE;//Դʾ
				break;
			}
		}

		if( pUnit->Draw.nLayer < 2 )
		{
			codeG = MAP_GetGroundData( pUnit->Draw.nLayer+1, nX, nY );
			if( codeG != MAP_DATA_NONE )
			{	// еڶΣʾ
				bSet = FALSE;
				break;
			}
		}

		if( pUnit->Draw.nLayer < 1 )
		{
			codeG = MAP_GetGroundData( pUnit->Draw.nLayer+2, nX, nY );
			if( codeG != MAP_DATA_NONE )
			{	// е
				bSet = FALSE;
				break;
			}
		}
	}
	if( pUnit->Draw.nFile < 27			// ǽűը
		|| pUnit->Draw.nFile == 34 )	// Ͷʯ
	{
		// ñը
		struct OTHER_STRUCT otherBomb;
		OTHER_ClearData( &otherBomb );

		otherBomb.nFile = 1;
		otherBomb.nType = OTHER_TYPE_BOMB;
		otherBomb.nDelay = RUN_TIMEDELAY_BOMB;

		RECT rect = MAP_GetOtherRect( DRAW_ptScreenOffset,
			pDraw->nLayer, pDraw->nX, pDraw->nY, 1 );
		otherBomb.ptBegin.x = rect.left+DRAW_ptScreenOffset.x;
		otherBomb.ptBegin.y = rect.top+DRAW_ptScreenOffset.y;
		if( pDraw->nLocationSize == 1 )	
			otherBomb.ptBegin.y -= MAP_Lib.szItem.cy;
		else if( pDraw->nLocationSize == 2 )
			otherBomb.ptBegin.y -= MAP_Lib.szItem.cy*3>>1;
		otherBomb.szItem.cx = MAP_Lib.Other[otherBomb.nFile].szItem.cx;
		otherBomb.szItem.cy = MAP_Lib.Other[otherBomb.nFile].szItem.cy;
		for( int i=0; i<8; i++ )
		{
			otherBomb.nCol[i] = i;
		}
		otherBomb.nMaxFrame = 8;
		OTHER_CreateData( &otherBomb );

		//--Ч
		// 24: obreak04.wavը
		POINT pt;
		pt.x = pUnit->Draw.nX, pt.y = pUnit->Draw.nY;
		if( PtInRect( &DRAW_rcScreen, pt ) )
		{
			DATA_WAVE_EffectPlay( 24 );
		}
		else
		{
			DATA_WAVE_EffectPlayLow( 24 );
		}
		//--Ч

		if( pUnit->Draw.nFile == 16 || pUnit->Draw.nFile == 17 )
		{	// ŲʾѪֻը
			return;
		}
	}
	if( bSet == FALSE )	return;	// ʾѪ


	// set after life
	struct OTHER_STRUCT other;
	OTHER_ClearData( &other );

	other.nType = OTHER_TYPE_BLOOD;
	other.nDelay = RUN_TIMEDELAY_DIE;

	RECT rect = MAP_GetUnitRect( DRAW_ptScreenOffset, pDraw );
	other.ptBegin.x = rect.left+DRAW_ptScreenOffset.x;
	other.ptBegin.y = rect.top+DRAW_ptScreenOffset.y;
	other.szItem.cx = rect.right - rect.left;
	other.szItem.cy = rect.bottom - rect.top;

	if( EYE_IfUnitIsBuild( pUnit ) 
		|| pDraw->nFile == 34 )	// Ͷʯ
	{	// 
		if( pDraw->nFile != 34 )
		{	// ֻǽʱ״̬
			if( pDraw->nFile == 0 || pDraw->nFile == 1 )
			{
				other.nCol[0] = 8 + MAP_Lib.AniSeq[0].nOffset;
				other.nCol[1] = 9 + MAP_Lib.AniSeq[0].nOffset;
			}
			else if( pDraw->nLocationSize == 0 )
			{
				other.nCol[0] = 1 + MAP_Lib.AniSeq[26].nOffset;
				other.nCol[1] = 1 + MAP_Lib.AniSeq[26].nOffset;
			}
			else if( pDraw->nLocationSize == 1 )
			{
				other.nCol[0] = 1 + MAP_Lib.AniSeq[24].nOffset;
				other.nCol[1] = 2 + MAP_Lib.AniSeq[24].nOffset;
			}
			else if( pDraw->nFile == 20 )	// 
			{
				other.nCol[0] = 1 + MAP_Lib.AniSeq[pDraw->nFile].nOffset;
				other.nCol[1] = 2 + MAP_Lib.AniSeq[pDraw->nFile].nOffset;
			}
			else
			{
				other.nCol[0] = 1 + MAP_Lib.AniSeq[22].nOffset;
				other.nCol[1] = 1 + MAP_Lib.AniSeq[22].nOffset;
			}
			other.nMaxFrame = 2;
		}
	}
	else
	{	// 
		if( pDraw->nFile >= 37 && pDraw->nFile <= 44 )
		{	// Լ
			// ״̬Ϊԭ״̬
			// ֡
			int nMaxFrame = MAP_Lib.AniSeq[pDraw->nFile].nMaxSequence[pDraw->nState];
			for( int i=0; i< nMaxFrame-6; i++ )
			{
				other.nCol[i] = MAP_Lib.AniSeq[pDraw->nFile].nAniSeq[pDraw->nState][i+6]
							+ MAP_Lib.AniSeq[pDraw->nFile].nOffset;
			}
			other.nMaxFrame = i;
		}
		else
		{
			int nFile = 29;
			// ֡
			int nMaxFrame = 7;	// 
			for( int i=0; i< nMaxFrame; i++ )
			{
				other.nCol[i] = MAP_Lib.AniSeq[nFile].nOffset-1 + ((i+1)*5);
			}
			other.nMaxFrame = i;
			SIZE sz;
			sz.cx = MAP_Lib.Unit[nFile].szItem.cx;
			sz.cy = MAP_Lib.Unit[nFile].szItem.cy;
			other.ptBegin.x += (other.szItem.cx - sz.cx)>>1;
			other.ptBegin.y = other.ptBegin.y + other.szItem.cy - sz.cy;
		}
	}
	Assert( other.nFrame == 0 );
	if( pDraw->nFile != 34 )
	{	// Ͷʯ״̬
		if( OTHER_CreateData( &other ) == -1 )
			OutputDebugString( "RUN_SetAfterLife Error: max number reached!\n" );
	}
}

// ʱҪŻ
// pU	:	Ľָ
void RUN_FIGHT_SetFire( struct UNIT_STRUCT *pU )
{
	if( pU->nLife < EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile)/3
		&& pU->Build.nFireLvl < 2 )
		//&& pU->Draw.nLocationSize > 0 )
	{	// ӵڶ
		struct OTHER_STRUCT other;
		OTHER_ClearData( &other );
		other.nType = OTHER_TYPE_FIRE;
		other.nFile = 3;
		other.nCol[0] = 0;
		other.nCol[1] = 1;
		other.nCol[2] = 2;
		other.nCol[3] = 3;
		other.nMaxFrame = 4;
		other.nDelay = 4;
		other.szItem.cx = MAP_Lib.Other[other.nFile].szItem.cx;
		other.szItem.cy = MAP_Lib.Other[other.nFile].szItem.cy;
		RECT rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pU->Draw );
		other.ptBegin.x = rect.right-other.szItem.cx+DRAW_ptScreenOffset.x-8;
		other.ptBegin.y = rect.top+DRAW_ptScreenOffset.y+10;
		pU->Build.nFireID[pU->Build.nFireLvl] = OTHER_CreateData( &other );
		pU->Build.nFireLvl++;
	}
	else if( pU->nLife >= EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile)/3
		&& pU->nLife < EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile)*2/3
		&& pU->Build.nFireLvl != 1 )
	{	// һ
		if( pU->Build.nFireLvl == 0 )
		{	// ӵһ
			struct OTHER_STRUCT other;
			OTHER_ClearData( &other );
			other.nType = OTHER_TYPE_FIRE;
			other.nFile = 3;
			other.nCol[0] = 0;
			other.nCol[1] = 1;
			other.nCol[2] = 2;
			other.nCol[3] = 3;
			other.nMaxFrame = 4;
			other.nDelay = 4;
			other.szItem.cx = MAP_Lib.Other[other.nFile].szItem.cx;
			other.szItem.cy = MAP_Lib.Other[other.nFile].szItem.cy;
			RECT rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pU->Draw );
			if( pU->Draw.nLocationSize == 0 )
			{	// center
				other.ptBegin.x = (rect.right+rect.left)/2 - other.szItem.cx/2+DRAW_ptScreenOffset.x;
			}
			else other.ptBegin.x = rect.left+DRAW_ptScreenOffset.x+10;
			other.ptBegin.y = rect.top+DRAW_ptScreenOffset.y-5;
			pU->Build.nFireID[pU->Build.nFireLvl] = OTHER_CreateData( &other );
			pU->Build.nFireLvl++;
		}
		else
		{	// ٵڶ
			OTHER_DestroyData( pU->Build.nFireID[pU->Build.nFireLvl-1] );
			pU->Build.nFireLvl--;
		}
	}
	else if( pU->nLife >= EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile)*2/3
		&& pU->Build.nFireLvl > 0 ) 
	{	// ٵһл
		for( int i=0; i<pU->Build.nFireLvl; i++ )
		{
			OTHER_DestroyData( pU->Build.nFireID[i] );
		}
		pU->Build.nFireLvl=0;
	}
}

// ͶʯҪͶʯ
// pUnit	:	Ͷʯ
// pU		:	
void RUN_FIGHT_SetStone( struct UNIT_STRUCT *pUnit , struct UNIT_STRUCT *pU )
{
	Assert( EYE_IfUnitIsCatapult( pUnit ) );

	struct OTHER_STRUCT other;
	OTHER_ClearData( &other );
	// ͣСʾ
	other.nType = OTHER_TYPE_STONE;
	other.nFile = 4;

	// õ
	//----------------------------------------
	int nAttack;
	Assert( EYE_IfUnitIsCatapult( pUnit ) );
	nAttack = EYE_GetFarAttack( pUnit );
	//other.nHit = RUN_FIGHT_calcHitPoint( pUnit, pU );
	//----------------------------------------
	other.nHit = nAttack;

	other.nSpeed = 8;
	other.nMaxFrame = 1;
	other.szItem.cx = MAP_Lib.Other[other.nFile].szItem.cx;	// size
	other.szItem.cy = MAP_Lib.Other[other.nFile].szItem.cy;
	other.nOwnerID = pUnit->nID;	// ԼıʶΪ˺˵nIDAttackMeֵ

	// ʼͽ
	// УҪCBOther.cppļOTHER_Hit()Уͬ
	POINT ptEnd;
	RECT rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pUnit->Draw );
	other.ptBegin.x = ((rect.left+rect.right)>>1) + DRAW_ptScreenOffset.x;// begin position
	other.ptBegin.y = ((rect.top+rect.bottom)>>1) + DRAW_ptScreenOffset.y-10;
	rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pU->Draw );
	ptEnd.x = ((rect.left+rect.right)>>1) + DRAW_ptScreenOffset.x;// end position
	// ע⣺˴빭ֲһ
	Assert( ptEnd.y >=0 );
	Assert( ptEnd.x >=0 );
	ptEnd.y = ((rect.top+rect.bottom)>>1) + DRAW_ptScreenOffset.y;
	other.ptEnd.x = pU->Draw.nX;	// Ŀĵǵλ
	other.ptEnd.y = pU->Draw.nY;
	
	// Ϊƶ׼
	int nDistX, nDistY;
	nDistX = ptEnd.x - other.ptBegin.x;
	nDistY = ptEnd.y - other.ptBegin.y;
	other.nDelay = (int)sqrt( float(nDistX*nDistX+nDistY*nDistY) );	// бߵĳ
	other.fSin = nDistY/(float)other.nDelay;// Sin()
	other.fCos = nDistX/(float)other.nDelay;// Cos()

	// ÷
	int nDir = -1;
	float fSin = other.fSin;
	float fCos = other.fCos;
	if( fSin >= 0.866 )		nDir = 4;	// 60-120
	else if( fSin<0.866 && fSin>=0.5 )	
	{
		if( fCos<0.866 && fCos>=0.5 )
				nDir = 3;				// 30-60
		else	nDir = 5;				// 120-150
	}
	else if( fSin<0.5 && fSin>=-0.5 )
	{
		if( fCos>0.866 )
				nDir = 2;				// 330-30
		else	nDir = 6;				// 150-210
	}
	else if( fSin<-0.5 && fSin>=-0.866 )
	{
		if( fCos<-0.5 && fCos>=-0.866 )
				nDir = 7;				// 210-240
		else	nDir = 1;				// 300-330
	}
	else if( fSin<-0.866 )	nDir = 0;	// 240-300

//	other.nCol[0] = nDir;
	Assert( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0 );

#ifdef	_DEBUG_OFFSET_
	if( !( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0) )
	{
		pUnit->Draw.ptOff.x = pUnit->Draw.ptOff.y = 0;
//		WriteLogFile( "off.log", "Setstone\n" );
	}
#endif //_DEBUG_OFFSET_

	pUnit->Draw.nDir = nDir;	// ˳Ҳ

	OTHER_CreateData( &other );

	//---- Ч
	// Ͷʯ
	POINT pt;
	pt.x = pUnit->Draw.nX, pt.y = pUnit->Draw.nY;
	if( PtInRect( &DRAW_rcScreen, pt ) )
	{
		// throw.wav
		DATA_WAVE_EffectPlay( 105 );
	}
	//---- Ч
}

// 100˵Ĳ͹ʹõļıǹľ
// pUnit	:	Ͷľ
// pU		:	
void RUN_FIGHT_SetGunMu( struct UNIT_STRUCT *pUnit , struct UNIT_STRUCT *pU )
{
	// ǣ˵Ĳ򹭱
	Assert( pUnit->Draw.nFile == 32 || pUnit->Draw.nFile == 45 );

	struct OTHER_STRUCT other;
	OTHER_ClearData( &other );
	// ͣСʾ
	other.nType = OTHER_TYPE_GUNMU;
	if( pUnit->Draw.nFile == 32 )
		other.nFile = 9;	// ʯͷ
	else
		other.nFile = 10;	// ľͷ

	// õ
	//----------------------------------------
	int nAttack;
//	Assert( EYE_IfUnitIsCatapult( pUnit ) );
//	nAttack = EYE_GetFarAttack( pUnit );
	nAttack = 30;
	//other.nHit = RUN_FIGHT_calcHitPoint( pUnit, pU );
	//----------------------------------------
	other.nHit = nAttack;

	other.nSpeed = 8;
	other.nMaxFrame = 1;
	other.szItem.cx = MAP_Lib.Other[other.nFile].szItem.cx;	// size
	other.szItem.cy = MAP_Lib.Other[other.nFile].szItem.cy;
	other.nOwnerID = pUnit->nID;	// ԼıʶΪ˺˵nIDAttackMeֵ

	// ʼͽ
	// УҪCBOther.cppļOTHER_Hit()Уͬ
	POINT ptEnd;
	RECT rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pUnit->Draw );
	other.ptBegin.x = ((rect.left+rect.right)>>1) + DRAW_ptScreenOffset.x;// begin position
	other.ptBegin.y = ((rect.top+rect.bottom)>>1) + DRAW_ptScreenOffset.y-10;
	rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pU->Draw );
	ptEnd.x = ((rect.left+rect.right)>>1) + DRAW_ptScreenOffset.x;// end position
	// ע⣺˴빭ֲһ
	Assert( ptEnd.y >=0 );
	Assert( ptEnd.x >=0 );
	ptEnd.y = ((rect.top+rect.bottom)>>1) + DRAW_ptScreenOffset.y;
	other.ptEnd.x = pU->Draw.nX;	// Ŀĵǵλ
	other.ptEnd.y = pU->Draw.nY;
	
	// Ϊƶ׼
	int nDistX, nDistY;
	nDistX = ptEnd.x - other.ptBegin.x;
	nDistY = ptEnd.y - other.ptBegin.y;
	other.nDelay = (int)sqrt( float(nDistX*nDistX+nDistY*nDistY) );	// бߵĳ
	other.fSin = nDistY/(float)other.nDelay;// Sin()
	other.fCos = nDistX/(float)other.nDelay;// Cos()

	// ÷
	int nDir = -1;
	float fSin = other.fSin;
	float fCos = other.fCos;
	if( fSin >= 0.866 )		nDir = 4;	// 60-120
	else if( fSin<0.866 && fSin>=0.5 )	
	{
		if( fCos<0.866 && fCos>=0.5 )
				nDir = 3;				// 30-60
		else	nDir = 5;				// 120-150
	}
	else if( fSin<0.5 && fSin>=-0.5 )
	{
		if( fCos>0.866 )
				nDir = 2;				// 330-30
		else	nDir = 6;				// 150-210
	}
	else if( fSin<-0.5 && fSin>=-0.866 )
	{
		if( fCos<-0.5 && fCos>=-0.866 )
				nDir = 7;				// 210-240
		else	nDir = 1;				// 300-330
	}
	else if( fSin<-0.866 )	nDir = 0;	// 240-300

	other.nCol[0] = nDir;
	Assert( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0 );

#ifdef	_DEBUG_OFFSET_
	if( !( pUnit->Draw.ptOff.x == 0 && pUnit->Draw.ptOff.y == 0) )
	{
		pUnit->Draw.ptOff.x = pUnit->Draw.ptOff.y = 0;
//		WriteLogFile( "off.log", "Setstone\n" );
	}
#endif //_DEBUG_OFFSET_

	pUnit->Draw.nDir = nDir;	// ˳Ҳ

	OTHER_CreateData( &other );

	//---- Ч
	// Ͷʯ
	POINT pt;
	pt.x = pUnit->Draw.nX, pt.y = pUnit->Draw.nY;
	if( PtInRect( &DRAW_rcScreen, pt ) )
	{
		// throw.wav
		DATA_WAVE_EffectPlay( 105 );
	}
	//---- Ч
}

// ڹ֣¥սҪȻ
// pUnit	:	
// pU		:	
void RUN_FIGHT_SetArrow( struct UNIT_STRUCT *pUnit , struct UNIT_STRUCT *pU )
{
	Assert( EYE_IfUnitIsArcher( pUnit ) 
		|| EYE_IfUnitIsTower( pUnit ) 
		|| EYE_IfUnitIsBattleShip( pUnit ) );
/*
	if( pUnit->bHasStone == TRUE )
	{	// ѾͶʯͷˣͶ
		return;
	}
	// Ͷı־
	pUnit->bHasStone = TRUE;
*/
	struct OTHER_STRUCT other;
	OTHER_ClearData( &other );
	// ͣСʾ
	other.nType = OTHER_TYPE_ARROW;
	other.nFile = 0;

	// õԶ̴
	other.nHit = RUN_FIGHT_calcHitPointF( pUnit, pU );

	other.nSpeed = 16;
	other.nMaxFrame = 1;
	other.szItem.cx = MAP_Lib.Other[other.nFile].szItem.cx;	// size
	other.szItem.cy = MAP_Lib.Other[other.nFile].szItem.cy;
	other.nOwnerID = pUnit->nID;	// ԼıʶΪ˺˵nIDAttackMeֵ
	other.nTargetID = pU->nID;		// ˵ıʶȻ

	// ʼͽ
	// УҪCBOther.cppļOTHER_Hit()Уͬ
	RECT rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pUnit->Draw );
	other.ptBegin.x = ((rect.left+rect.right)>>1) + DRAW_ptScreenOffset.x;// begin position
	other.ptBegin.y = ((rect.top+rect.bottom)>>1) + DRAW_ptScreenOffset.y-10;
	rect = MAP_GetUnitRect( DRAW_ptScreenOffset, &pU->Draw );
	other.ptEnd.x = ((rect.left+rect.right)>>1) + DRAW_ptScreenOffset.x;// end position
	other.ptEnd.y = ((rect.top+rect.bottom)>>1) + DRAW_ptScreenOffset.y-10;
	
	// Ϊƶ׼
	int nDistX, nDistY;
	nDistX = other.ptEnd.x - other.ptBegin.x;
	nDistY = other.ptEnd.y - other.ptBegin.y;
	other.nDelay = (int)sqrt( float(nDistX*nDistX+nDistY*nDistY) );	// бߵĳ
	other.fSin = nDistY/(float)other.nDelay;// Sin()
	other.fCos = nDistX/(float)other.nDelay;// Cos()

	// ÷
	int nDir = -1;
	float fSin = other.fSin;
	float fCos = other.fCos;
	if( fSin >= 0.866 )		nDir = 4;	// 60-120
	else if( fSin<0.866 && fSin>=0.5 )	
	{
		if( fCos<0.866 && fCos>=0.5 )
				nDir = 3;				// 30-60
		else	nDir = 5;				// 120-150
	}
	else if( fSin<0.5 && fSin>=-0.5 )
	{
		if( fCos>0.866 )
				nDir = 2;				// 330-30
		else	nDir = 6;				// 150-210
	}
	else if( fSin<-0.5 && fSin>=-0.866 )
	{
		if( fCos<-0.5 && fCos>=-0.866 )
				nDir = 7;				// 210-240
		else	nDir = 1;				// 300-330
	}
	else if( fSin<-0.866 )	nDir = 0;	// 240-300

	other.nCol[0] = nDir;
	pUnit->Draw.nDir = nDir;	// ˳Ҳ

	OTHER_CreateData( &other );

	// Ч
	RUN_SOUND_HitF( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
	// Ч
}

// mouse hit result
// ļ
extern int	CTRL_nHitCounter;
// սЧ
// pUnit	:	
// pU	:	
// return	:	TRUE if һ
BOOL RUN_FIGHT_CalcResult( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU )
{
	// July 31. 1997, Liu Gang
	if( EYE_IfUnitIsDead( pU ) )
		return FALSE;	//

	// ñ־
	if( pUnit->Draw.nPlayer != pU->Draw.nPlayer )
	{
		pU->nIDAttackMe = pUnit->nID;
		if( pU->Draw.nPlayer == GAME.nMe )	// Ϸ
		{
			MINI_SetBlink( pU->Draw.nDrawX, pU->Draw.nDrawY );
			RUN_SOUND_UnderAttack( pU->Draw.nX, pU->Draw.nY, pU->Draw.nFile );
		}
	}

	// Ѫڱǰֵһ룬ֵһ룬
	// 򷢳
	BOOL bWounded = FALSE;
	if( pU->nLife>=(EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile )>>1) )
		bWounded = TRUE;
	// 
	pU->nLife -= RUN_FIGHT_calcHitPoint( pUnit, pU );
	if( pU->nLife>=(EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile )>>1) 
		|| bWounded == FALSE )
		bWounded = FALSE;
	if( bWounded == TRUE )
		// Ч
		RUN_SOUND_Wounded( pU->Draw.nX, pU->Draw.nY, pU->Draw.nFile );
		// Ч

	// Ч
	RUN_SOUND_Hit( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
	// Ч

	// 鿴Ƿ
	if( pU->nLife <= 0  )
	{
		RUN_UNIT_ToDie( pU );
		return TRUE;
	}

	if( EYE_IfFocusOnUnit( pU ) )
		//&& EYE_IfSheIsMine( pU )
	{
		// Ѫ
		if( EYE_IfUnitIsGen( pU ) )
		{
			FACE_ShowProcessBar( PROCESSBAR_BLOOD, pU->nLife*100/EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile) );
		}
		else if( CTRL_nHitCounter == 1 )
			FACE_ShowProcessBar( PROCESSBAR_STONE, pU->nLife*100/EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile) );
	}
	return FALSE;
}

// Ƿ񵽴Ŀĵ
// pUnit	:	ĵԪ
// return	:	Ӧתķ0-1Ϊ-1ʱδ
int RUN_MOVE_IfArrived( struct UNIT_STRUCT *pUnit )
{
	// ͣɼnTaskIDExָĿĵǵΣ֣
	// вӹĹʿĽĿǵ
	if( (pUnit->Task.nTaskID == YUNSONG 
		&& pUnit->Status.nTaskID == YIDONG 
		&& pUnit->Status.nTaskIDEx == 1 ) )
	{
		if( EYE_IfUnitIsWorker( pUnit )
		&& pUnit->Soldier.nGenID == MAP_DATA_NONE )
		;
		else
		{
			Assert( (EYE_IfUnitIsWorker( pUnit )
			&& pUnit->Soldier.nGenID != MAP_DATA_NONE)
			|| EYE_IfUnitIsWorkerGen( pUnit ) );

			Assert( pUnit->Task.nTaskIDEx2 < 2 
				&& pUnit->Task.nTaskIDEx2 >= 0 );

			int nDir;
			nDir = EYE_IfResIsInRange( pUnit, pUnit->Task.nTaskIDEx2 );
			if( nDir != -1 )
			{
				pUnit->Status.nParam4 = 0;	// ȡԤ
				return nDir;
			}
		}
	}

	// ǷӽĿĵأĿĵǵԪ
	if( pUnit->Status.nTaskIDEx == 2 )
	{
		int nDir, nRange;
		// ֻжٵĸ
		if( pUnit->Task.nTaskID == GONGJI )
			nRange = -1;	
		else	nRange = 1;	// ǹǿжΧǣ
		if( (nDir = EYE_IfUnitIsInRange( pUnit->nID, pUnit->Task.nParam1, nRange )) >= 0 )
		{	// Ŀĵ
			pUnit->Status.nParam4 = 0;	// ȡԤ
			return nDir;
		}

		// ǷĿ굥ԪѾɾڽڲ
		struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Task.nParam1 );
		Assert( pU );
		if( EYE_IfUnitIsDead( pU ) 
			|| nDir == -2 )	
		{	// Ŀĵ
			pUnit->Status.nParam4 = 0;	// ȡԤ
			return pUnit->Draw.nDir;
		}
	}

	if( pUnit->MarchTrack[pUnit->StepNum] == 255 )
	{	// Ŀĵ
		if( pUnit->Task.nTaskID == JIANZAO 
			&& pUnit->Task.nTaskIDEx2 == 20// 촬
			&& pUnit->Task.nTaskIDEx == 1 
			&& pUnit->Status.nParam4 != 255 )
			//&& MAP_GetUnitDataEx( pUnit->Status.nParam2, pUnit->Status.nParam3 ) == MAP_DATA_NONE
			//&& EYE_IfShipYardIsInRange( pUnit, pUnit->Status.nParam2, pUnit->Status.nParam3 ) )	// 
		{	// ˮ
			// 任콨룩λȥʡ
			pUnit->Draw.nXLast = pUnit->Draw.nX;	
			pUnit->Draw.nYLast = pUnit->Draw.nY;
			pUnit->Draw.nX = pUnit->Task.nParam2,
			pUnit->Draw.nY = pUnit->Task.nParam3;
			MAP_SetUnitDataEx( pUnit->Draw.nXLast, pUnit->Draw.nYLast, MAP_DATA_NONE );
			MAP_SetUnitDataEx( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->nID );
			pUnit->Status.nParam4 = 0;	// ȡԤ
			// ƶӰ
			CTRL_UNIT_MoveShadow( &pUnit->Draw );
		}
		return pUnit->Draw.nDir;	
	}

	// ·
	if( pUnit->StepNum >= GAME_MARCH_MAX )
	{
		return pUnit->Draw.nDir;	
	}
	return -1;
}

// ȡԴĶ
// pUnit	:	˲
// pU		:	Դ
// return	:	ڻȡΪ0ԴȡΪ1ԴݽΪ2
int RUN_HARVEST_Build( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU )
{
	if( EYE_IfUnitIsDead( pU ) )
		return 2;	// ԴѾݽ
	if( pUnit->nCounter < RUN_TIMEDELAY_HARVEST )
		return 0;	// ڽ

	Assert( EYE_IfUnitIsRes( pU ) 
		|| pU->Draw.nFile == 10 
		|| pU->Draw.nFile == 11 );
	Assert( EYE_IfUnitIsWorker( pUnit )	|| EYE_IfUnitIsWorkerGen( pUnit ) );

	int *pSource = NULL;
	if( pU->Draw.nFile == 10 || pU->Draw.nFile == 11 )
	{	// ˵
		pSource = &GAME.Players[pU->Draw.nPlayer].nFood;
	}
	else
	{	// һԴ
		pSource = &pU->Build.nResource;
	}
	if( *pSource > 0 )
	{
		if( EYE_IfUnitIsWorker( pUnit ) )
		{
			pUnit->Soldier.nResource = RUN_RESOURCE_GET;
			// ⣬ҪӸľʳп۳
			*pSource -= RUN_RESOURCE_GET;
		}
		// ԴݽߣɾԴ
		if( *pSource <= 0 )
		{
			pUnit->Soldier.nResource += *pSource;	// ضɵԴ
			pU->nLife = 0;
			struct CTRL_TASK_STRUCT task;
			CTRL_TASK_Clear( &task );
			task.nID = pU->nID;
			task.bIRQ = TRUE;
			task.nTaskID = SHANCHU;
			task.bDone = TRUE;
			CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &task );
		}

		// ޸һBugԭɼʱԴʾʱ
		// ڸ, July 18, 1997
		if( pU->Draw.nFile != 10 
			&& pU->Draw.nFile != 11
			&& EYE_IfFocusOnUnit( pU ) )	// Դڽ״̬
		{
			// Դ󣩴
			FACE_UpdateGrade( pU->Build.nResource );
		}
		return 1;	// ɹɼ
	}
	else
		return 2;	// ԴѾݽ
}

//ѲɼԴͻص
BOOL RUN_RETURN_Build( struct UNIT_STRUCT *pUnit, struct UNIT_STRUCT *pU )
{
	BOOL bSuccess = TRUE;

//added by tian yue
	int nJingYanGrade[10]={200,500,1000,1800,3000,5000,8000,12000,18000,27000};

	if( EYE_IfUnitIsWorker( pUnit ) )
	{
		switch( pUnit->Soldier.nResType )
		{
		case	SHULIN:		// 
			GAME.Players[pUnit->Draw.nPlayer].nWood += pUnit->Soldier.nResource;
			break;
//			GAME.Players[pUnit->Draw.nPlayer].nFood += pUnit->Soldier.nResource;
//			break;
		case	TIEKUANG:	// 
			GAME.Players[pUnit->Draw.nPlayer].nIron += pUnit->Soldier.nResource;
			break;
		case	MINJU:		// 
			GAME.Players[pUnit->Draw.nPlayer].nGold += pUnit->Soldier.nResource;
			break;
		case	MAITIAN:	// 
		case	LIANGCANG:	// 
			GAME.Players[pUnit->Draw.nPlayer].nFood += pUnit->Soldier.nResource;
			if( EYE_IfFoodExceeded( pUnit->Draw.nPlayer ) )
			{
				GAME.Players[pUnit->Draw.nPlayer].nFood -= pUnit->Soldier.nResource;
				OutputDebugString( "Food Exceeded!\n" );
				if( EYE_IfSheIsMine( pUnit ) )
				{
					// ֲ޷޽֡
					FACE_ShowPromptInfor( 10 );
				}
				bSuccess = FALSE;
			}
			break;
		}
		if( bSuccess )
		{
			pUnit->Soldier.nResType = QXZIYUAN;	// Դ
			pUnit->Soldier.nResource = 0;
			GFWI_bUpdate = TRUE;
		}
		else
			return FALSE;
	}
	else
	{
		Assert( EYE_IfUnitIsWorkerGen( pUnit ) );
		DATA_Lib.Gen[pUnit->Gen.nID].nJingYan++;	// 1
		//DATA_Lib.Gen[pUnit->Gen.nID].nJingYan+=50;	// 1
		
		//added by tian yue.
		// 
		if( DATA_Lib.Gen[pUnit->Gen.nID].nLevel < 9 )
		{
			if( DATA_Lib.Gen[pUnit->Gen.nID].nJingYan >= nJingYanGrade[DATA_Lib.Gen[pUnit->Gen.nID].nLevel] )
			{
				DATA_Lib.Gen[pUnit->Gen.nID].nJingYan -= nJingYanGrade[DATA_Lib.Gen[pUnit->Gen.nID].nLevel];
				DATA_Lib.Gen[pUnit->Gen.nID].nLevel++;

				//ҽսӢ£ն࣬һ
				if( EYE_IfFocusOnUnit( pUnit ) && EYE_IfSheIsMine( pUnit ) )
				{
					FACE_ShowPromptInfor( 12 );
					//---- ϶Ч
					// victory.wav
					DATA_WAVE_EffectPlay( 106 );
					//---- ϶Ч
				}
			}
		}
	}
	return TRUE;
}

// 
BOOL RUN_REPAIR_Build( struct UNIT_STRUCT *pUnit )
{
	Assert( pUnit->Status.nParam1 != MAP_DATA_NONE );
	struct UNIT_STRUCT *pU = MAP_GetUnit( pUnit->Status.nParam1 );
	Assert( pU );	// Ľָ
	if( EYE_IfUnitIsDead( pU ) )
	{
		pUnit->Status.bDone = TRUE;
		return TRUE;
	}
	Assert( EYE_IfUnitIsBuild( pU ) && pU->Draw.nPlayer == pUnit->Draw.nPlayer );

	//---- Ч
	POINT pt;
	pt.x = pUnit->Draw.nX, pt.y = pUnit->Draw.nY;
	if( PtInRect( &DRAW_rcScreen, pt ) )
	{
		// repair.wav
		DATA_WAVE_EffectPlay( 101 );
	}
	//---- Ч
	
//	int nHit = DATA_Lib.Unit[pUnit->Draw.nFile].nNearAttack 
//				+ GAME.Players[pUnit->Draw.nPlayer].nAddNearAttack;
	int nHit = RUN_CREATE_VALUE<<3;

	if( GAME.Players[pUnit->Draw.nPlayer].nGold < RUN_CREATE_VALUE
		|| GAME.Players[pUnit->Draw.nPlayer].nFood < RUN_CREATE_VALUE
		|| GAME.Players[pUnit->Draw.nPlayer].nWood < RUN_CREATE_VALUE
		|| GAME.Players[pUnit->Draw.nPlayer].nIron < RUN_CREATE_VALUE )
	{	// ûǮˣ
		pUnit->Status.bDone = TRUE;		
		return TRUE;
	}

	pU->nLife += nHit;
	GAME.Players[pUnit->Draw.nPlayer].nGold -= RUN_CREATE_VALUE;
	GAME.Players[pUnit->Draw.nPlayer].nFood -= RUN_CREATE_VALUE;
	GAME.Players[pUnit->Draw.nPlayer].nWood -= RUN_CREATE_VALUE;
	GAME.Players[pUnit->Draw.nPlayer].nIron -= RUN_CREATE_VALUE;
	GFWI_bUpdate = TRUE;

	// 
	if( pU->nLife >= EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile) )
	{	
		pU->nLife = EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile);
		pUnit->Status.bDone = TRUE;
		return TRUE;
	}

	// ޸Ļ
	if( pU->Status.nTaskID != JIANZAOZHONG )
		RUN_FIGHT_SetFire( pU );

	if( EYE_IfFocusOnUnit( pU ) )
		//&& EYE_IfSheIsMine( pU ) )
	{
		// Ѫ
		FACE_ShowProcessBar( PROCESSBAR_STONE, pU->nLife*100/EYE_GetFullLife( pU->Draw.nPlayer, pU->Draw.nFile) );
	}
	return FALSE;
}

// жǷǮ
BOOL RUN_UPGRADE_IfEnoughMoney( int nPlayer, int nTaskIDEx )
{
	BOOL bRet = TRUE;
	// 
	switch( nTaskIDEx )
	{
	case	SHENGJI1:
	case	SHENGJI2:
	case	SHENGJI3:
	case	GONGJIAN1:
	case	GONGJIAN2:
	case	GONGJIAN3:
	case	BINGQI1:
	case	BINGQI2:
	case	BINGQI3:
	case	HUJIA1:
	case	HUJIA2:
	case	HUJIA3:
	case	TOUSHICHE1:
	case	TOUSHICHE2:
	case	XIAOCHUAN:
	case	DACHUAN:
	case	CHUANTI:
		if( GAME.Players[nPlayer].nGold < DATA_Lib.Upgrade[nTaskIDEx].nGold
			|| GAME.Players[nPlayer].nWood < DATA_Lib.Upgrade[nTaskIDEx].nWood
			|| GAME.Players[nPlayer].nIron < DATA_Lib.Upgrade[nTaskIDEx].nIron )
			bRet = FALSE;
		break;
	case	MUCAI1:	// 1000ľĻǮ
		if( GAME.Players[nPlayer].nWood < DATA_Lib.Upgrade[MUCAI1].nWood )
			bRet = FALSE;
		break;
	case	MUCAI2:	// 5000ľĻǮ
		if( GAME.Players[nPlayer].nWood < DATA_Lib.Upgrade[MUCAI2].nWood )
			bRet = FALSE;
		break;
	case	LIANGSHI1:	// 1000ʳǮ
		if( GAME.Players[nPlayer].nFood < DATA_Lib.Upgrade[LIANGSHI1].nFood )
			bRet = FALSE;
		break;
	case	LIANGSHI2:	// 5000ʳǮ
		if( GAME.Players[nPlayer].nFood < DATA_Lib.Upgrade[LIANGSHI2].nFood )
			bRet = FALSE;
		break;
	case	TIEKUANG1:	// 1000ʯǮ
		if( GAME.Players[nPlayer].nIron < DATA_Lib.Upgrade[TIEKUANG1].nIron )
			bRet = FALSE;
		break;
	case	TIEKUANG2:	// 5000ʯǮ
		if( GAME.Players[nPlayer].nIron < DATA_Lib.Upgrade[TIEKUANG2].nIron )
			bRet = FALSE;
		break;
	}
	if( bRet == FALSE && GAME.nMe == nPlayer )
	{
		//------------ʾ
		//Ѳ޷
		FACE_ShowPromptInfor( 7 );
		//------------ʾ

		//---- Ч
		// noselect.wav
		DATA_WAVE_EffectPlay( 99 );
		//---- Ч
	}
	return bRet;
}

// Ԥ
BOOL RUN_UPGRADE_Pay( int nPlayer, int nTaskIDEx )
{
	if( !RUN_UPGRADE_IfEnoughMoney( nPlayer, nTaskIDEx ) )
		return FALSE;

	// 
	switch( nTaskIDEx )
	{
	case	SHENGJI1:
	case	SHENGJI2:
	case	SHENGJI3:
	case	GONGJIAN1:
	case	GONGJIAN2:
	case	GONGJIAN3:
	case	BINGQI1:
	case	BINGQI2:
	case	BINGQI3:
	case	HUJIA1:
	case	HUJIA2:
	case	HUJIA3:
	case	TOUSHICHE1:
	case	TOUSHICHE2:
	case	XIAOCHUAN:
	case	DACHUAN:
	case	CHUANTI:
		GAME.Players[nPlayer].nGold -= DATA_Lib.Upgrade[nTaskIDEx].nGold;
		GAME.Players[nPlayer].nWood -= DATA_Lib.Upgrade[nTaskIDEx].nWood;
		GAME.Players[nPlayer].nIron -= DATA_Lib.Upgrade[nTaskIDEx].nIron;
		break;
	case	MUCAI1:	// 1000ľĻǮ
		GAME.Players[nPlayer].nWood -= DATA_Lib.Upgrade[MUCAI1].nWood;
		break;
	case	MUCAI2:	// 5000ľĻǮ
		GAME.Players[nPlayer].nWood -= DATA_Lib.Upgrade[MUCAI2].nWood;
		break;
	case	LIANGSHI1:	// 1000ʳǮ
		GAME.Players[nPlayer].nFood -= DATA_Lib.Upgrade[LIANGSHI1].nFood;
		break;
	case	LIANGSHI2:	// 5000ʳǮ
		GAME.Players[nPlayer].nFood -= DATA_Lib.Upgrade[LIANGSHI2].nFood;
		break;
	case	TIEKUANG1:	// 1000ʯǮ
		GAME.Players[nPlayer].nIron -= DATA_Lib.Upgrade[TIEKUANG1].nIron;
		break;
	case	TIEKUANG2:	// 5000ʯǮ
		GAME.Players[nPlayer].nIron -= DATA_Lib.Upgrade[TIEKUANG2].nIron;
		break;
	}
	GFWI_bUpdate = TRUE;
	return TRUE;
}

// 
//void RUN_UPGRADE_Get( int nPlayer, int nTaskIDEx )
void RUN_UPGRADE_Get( struct UNIT_STRUCT *pUnit )
{
//	int nFile = -1;
	Assert( EYE_IfUnitIsBuild( pUnit ) );
	int nPlayer = pUnit->Draw.nPlayer;
	int nTaskIDEx = pUnit->Status.nTaskIDEx;
	// 
	switch( nTaskIDEx )
	{
	case	SHENGJI1:
		GAME.Players[nPlayer].dwLifeUp = DATA_Lib.Upgrade[SHENGJI1].dwParam1;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_MAIN] = 1;
		{
			for( int i=0; i<PLAYER_UNIT_MAX; i++ )
			{	// ǽǼ¥
				struct UNIT_STRUCT *pU = &GAME.Players[nPlayer].Unit[i];
				if( EYE_IfUnitIsBuild( pU ) 
					&& !EYE_IfUnitIsTower( pU ) )
				{
					pU->nLife += DATA_Lib.Upgrade[SHENGJI1].dwParam1;
				}
			}
		}
		pUnit->Build.dwUpgrade[0]=1;
		break;
	case	SHENGJI2:
		GAME.Players[nPlayer].dwLifeUp = DATA_Lib.Upgrade[SHENGJI2].dwParam1;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_MAIN] = 2;
		{
			for( int i=0; i<PLAYER_UNIT_MAX; i++ )
			{	// ǽǼ¥
				struct UNIT_STRUCT *pU = &GAME.Players[nPlayer].Unit[i];
				if( EYE_IfUnitIsBuild( pU ) 
					&& !EYE_IfUnitIsTower( pU ) )
				{
					pU->nLife += DATA_Lib.Upgrade[SHENGJI1].dwParam1;
				}
			}
		}
		pUnit->Build.dwUpgrade[0]=2;
		break;
	case	SHENGJI3:
		GAME.Players[nPlayer].dwLifeUp = DATA_Lib.Upgrade[SHENGJI3].dwParam1;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_MAIN] = 3;
		{
			for( int i=0; i<PLAYER_UNIT_MAX; i++ )
			{	// ǽǼ¥
				struct UNIT_STRUCT *pU = &GAME.Players[nPlayer].Unit[i];
				if( EYE_IfUnitIsBuild( pU ) 
					&& !EYE_IfUnitIsTower( pU ) )
				{
					pU->nLife += DATA_Lib.Upgrade[SHENGJI1].dwParam1;
				}
			}
		}
		pUnit->Build.dwUpgrade[0]=3;
		break;
	case	GONGJIAN1:
	case	GONGJIAN2:
	case	GONGJIAN3:
		// Զ̹
		GAME.Players[nPlayer].nAddFarAttack[0] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam1;
		GAME.Players[nPlayer].nAddFarAttack[1] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam2;
		GAME.Players[nPlayer].nAddFarAttack[2] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam3;
		GAME.Players[nPlayer].nAddFarAttack[3] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam4;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_GONGJIAN] = nTaskIDEx - GONGJIAN1 + 1;
		pUnit->Build.dwUpgrade[0] = nTaskIDEx - GONGJIAN1+1;
//		nFile = 4;	// ľĳ
		break;
	case	BINGQI1:
	case	BINGQI2:
	case	BINGQI3:
		// ̹
		GAME.Players[nPlayer].nAddNearAttack[0] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam1;
		GAME.Players[nPlayer].nAddNearAttack[1] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam2;
		GAME.Players[nPlayer].nAddNearAttack[2] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam3;
		GAME.Players[nPlayer].nAddNearAttack[3] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam4;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_BINGQI] = nTaskIDEx - BINGQI1 + 1;
//		nFile = 2;	// 
		pUnit->Build.dwUpgrade[0] = nTaskIDEx - BINGQI1+1;
		break;
	case	HUJIA1:
	case	HUJIA2:
	case	HUJIA3:
		// Զ̷
		GAME.Players[nPlayer].nAddNearDefend[0] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam1;
		GAME.Players[nPlayer].nAddNearDefend[1] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam2;
		GAME.Players[nPlayer].nAddNearDefend[2] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam3;
		GAME.Players[nPlayer].nAddNearDefend[3] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam4;
		GAME.Players[nPlayer].nAddFarDefend[0] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam1;
		GAME.Players[nPlayer].nAddFarDefend[1] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam2;
		GAME.Players[nPlayer].nAddFarDefend[2] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam3;
		GAME.Players[nPlayer].nAddFarDefend[3] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam4;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_HUJIA] = nTaskIDEx - HUJIA1 + 1;
//		nFile = 2;	// 
		pUnit->Build.dwUpgrade[1] = nTaskIDEx - HUJIA1+1;
		break;
	case	TOUSHICHE1:
	case	TOUSHICHE2:	// Ͷʯ仯
		GAME.Players[nPlayer].nAddSFarAttack = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam1;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_TOUSHICHE] = nTaskIDEx - TOUSHICHE1 + 1;
//		nFile = 8;	// 
		pUnit->Build.dwUpgrade[0] = nTaskIDEx - TOUSHICHE1+1;
		break;
	case	XIAOCHUAN:	// Сս仯
		GAME.Players[nPlayer].nAddWaterAttack[0] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam1;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_CHUAN1] = 1;
//		nFile = 20;	// 
		pUnit->Build.dwUpgrade[0] = 1;
		break;
	case	DACHUAN:	// ս仯
		GAME.Players[nPlayer].nAddWaterAttack[1] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam1;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_CHUAN2] = 1;
//		nFile = 20;	// 
		pUnit->Build.dwUpgrade[1] = 1;
		break;
	case	CHUANTI:	// ս仯
		GAME.Players[nPlayer].nAddWaterDefend[0] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam1;
		GAME.Players[nPlayer].nAddWaterDefend[1] = (char)DATA_Lib.Upgrade[nTaskIDEx].dwParam2;
		GAME.Players[nPlayer].nGrade[PLAYER_GRADE_CHUAN3] = 1;
//		nFile = 20;	// 
		pUnit->Build.dwUpgrade[2] = 1;
		break;
	case	MUCAI1:	// 1000ľĻǮ
		GAME.Players[nPlayer].nGold += DATA_Lib.Upgrade[MUCAI1].nGold;
//		nFile = 23;	// Ǯׯ
		break;
	case	MUCAI2:	// 5000ľĻǮ
		GAME.Players[nPlayer].nGold += DATA_Lib.Upgrade[MUCAI2].nGold;
//		nFile = 23;	// Ǯׯ
		break;
	case	LIANGSHI1:	// 1000ʳǮ
		GAME.Players[nPlayer].nGold += DATA_Lib.Upgrade[LIANGSHI1].nGold;
//		nFile = 23;	// Ǯׯ
		break;
	case	LIANGSHI2:	// 5000ʳǮ
		GAME.Players[nPlayer].nGold += DATA_Lib.Upgrade[LIANGSHI2].nGold;
//		nFile = 23;	// Ǯׯ
		break;
	case	TIEKUANG1:	// 1000ʯǮ
		GAME.Players[nPlayer].nGold += DATA_Lib.Upgrade[TIEKUANG1].nGold;
//		nFile = 23;	// Ǯׯ
		break;
	case	TIEKUANG2:	// 5000ʯǮ
		GAME.Players[nPlayer].nGold += DATA_Lib.Upgrade[TIEKUANG2].nGold;
//		nFile = 23;	// Ǯׯ
		break;
	}
	GFWI_bUpdate = TRUE;
}

// ȡǮ
// nTaskIDEx	:	
void RUN_UPGRADE_PayBack( int nPlayer, int nTaskIDEx )
{
	switch( nTaskIDEx )
	{
	case	SHENGJI1:
	case	SHENGJI2:
	case	SHENGJI3:
	case	GONGJIAN1:
	case	GONGJIAN2:
	case	GONGJIAN3:
	case	BINGQI1:
	case	BINGQI2:
	case	BINGQI3:
	case	HUJIA1:
	case	HUJIA2:
	case	HUJIA3:
	case	TOUSHICHE1:
	case	TOUSHICHE2:
	case	XIAOCHUAN:
	case	DACHUAN:
	case	CHUANTI:
		GAME.Players[nPlayer].nGold += DATA_Lib.Upgrade[nTaskIDEx].nGold*RUN_CREATE_PAYBACK/100;
		GAME.Players[nPlayer].nWood += DATA_Lib.Upgrade[nTaskIDEx].nWood*RUN_CREATE_PAYBACK/100;
		GAME.Players[nPlayer].nIron += DATA_Lib.Upgrade[nTaskIDEx].nIron*RUN_CREATE_PAYBACK/100;
		break;
	case	MUCAI1:	// 1000ľĻǮ
		GAME.Players[nPlayer].nWood += DATA_Lib.Upgrade[MUCAI1].nWood*RUN_CREATE_PAYBACK/100;
		break;
	case	MUCAI2:	// 5000ľĻǮ
		GAME.Players[nPlayer].nWood += DATA_Lib.Upgrade[MUCAI2].nWood*RUN_CREATE_PAYBACK/100;
		break;
	case	LIANGSHI1:	// 1000ʳǮ
		GAME.Players[nPlayer].nFood += DATA_Lib.Upgrade[LIANGSHI1].nFood*RUN_CREATE_PAYBACK/100;
		break;
	case	LIANGSHI2:	// 5000ʳǮ
		GAME.Players[nPlayer].nFood += DATA_Lib.Upgrade[LIANGSHI2].nFood*RUN_CREATE_PAYBACK/100;
		break;
	case	TIEKUANG1:	// 1000ʯǮ
		GAME.Players[nPlayer].nIron += DATA_Lib.Upgrade[TIEKUANG1].nIron*RUN_CREATE_PAYBACK/100;
		break;
	case	TIEKUANG2:	// 5000ʯǮ
		GAME.Players[nPlayer].nIron += DATA_Lib.Upgrade[TIEKUANG2].nIron*RUN_CREATE_PAYBACK/100;
		break;
	}
	GFWI_bUpdate = TRUE;
}
/////////////

/////////////
// жԪС0ԸõԪ´ɾ
// ֻеʾȫ󣬲CTRL_UNIT_Detroy()ɾ
void RUN_UNIT_ToDie( struct UNIT_STRUCT *pUnit )
{
	if( EYE_IfUnitIsDead( pUnit ) )
		return;

	int nJingYanGrade[10]={200,500,1000,1800,3000,5000,8000,12000,18000,27000};

	Assert( EYE_IfUnitIsBuild( pUnit ) 
			||	(pUnit->nHasShadow == TRUE
				&& !EYE_IfUnitIsBuild( pUnit ) ) );	// 

	// ֵʿ
	// ûйߣԼ˸ɵ
	struct UNIT_STRUCT *pU=NULL;
	if( pUnit->nIDAttackMe != MAP_DATA_NONE )
	{
		pU = MAP_GetUnit( pUnit->nIDAttackMe );
		Assert( pU );

		// սǷ֣Nov.6.1997
	//-----------
		if( EYE_IfUnitIsGen( pUnit ) )
		{
			RUN_CountDown[pU->Draw.nPlayer].nKilledGenerals ++;
		}
		else if( EYE_IfUnitIsBuild( pUnit ) )
		{
			RUN_CountDown[pU->Draw.nPlayer].nKilledBuildings ++;
		}
		else if( EYE_IfUnitIsSoldier( pUnit ) )
		{
			RUN_CountDown[pU->Draw.nPlayer].nKilledSoldiers += EYE_GetFullLife( -1, pUnit->Draw.nFile );
		}
	//-----------
	
		pU = EYE_GetGeneral( pU );
		if( pU )	// ߵĽ
		{
			DATA_Lib.Gen[pU->Gen.nID].nJingYan += DATA_Lib.Unit[pUnit->Draw.nFile].nAddExp;
			// debug only
//			DATA_Lib.Gen[pU->Gen.nID].nJingYan += nJingYanGrade[DATA_Lib.Gen[pU->Gen.nID].nLevel];

			// 
			if( DATA_Lib.Gen[pU->Gen.nID].nLevel < 9 )
			{
				if( DATA_Lib.Gen[pU->Gen.nID].nJingYan >= nJingYanGrade[DATA_Lib.Gen[pU->Gen.nID].nLevel] )
				{
					DATA_Lib.Gen[pU->Gen.nID].nJingYan -= nJingYanGrade[DATA_Lib.Gen[pU->Gen.nID].nLevel];
					DATA_Lib.Gen[pU->Gen.nID].nLevel++;

					//ҽսӢ£ն࣬һ
					if( EYE_IfFocusOnUnit( pU ) && EYE_IfSheIsMine( pU ) )
					{
						FACE_ShowPromptInfor( 12 );
						//---- ϶Ч
						// victory.wav
						DATA_WAVE_EffectPlay( 106 );
						//---- ϶Ч
					}
				}
			}

			pU->Gen.nMorale += DATA_Lib.Unit[pUnit->Draw.nFile].nAddMorale;

			if( EYE_IfFocusOnUnit( pU ) )
			{
				//¼ƣֵʿ
				char strLvl[32];
				EYE_GetLevelName( pU->Gen.nID, strLvl );
				FACE_UpdateOffice( strLvl );
				FACE_UpdateExperience( DATA_Lib.Gen[pU->Gen.nID].nJingYan );
				FACE_UpdateSoliderNumber( CTRL_GetFocusSoldierNumber() );
				FACE_ShowProcessBar( PROCESSBAR_POWER, EYE_GetWuLi( pU->Gen.nID )*100/120 );
				//// ʿ
				FACE_UpdateMorale( EYE_GetMorale( pU ) ) ;
			}
		}
	}

	// Լʿ
	pU = EYE_GetGeneral( pUnit );// ԼĽ
	if( pU )
	{
		pU->Gen.nMorale -= DATA_Lib.Unit[pUnit->Draw.nFile].nAddMorale;
		if( EYE_IfFocusOnUnit( pU ) )
		{	// ʿ
			FACE_UpdateMorale( EYE_GetMorale( pU ) ) ;
		}
	}

	// Ǵ죬ҪԼвӵʿ
	// Aug 14, 1997
	if( pUnit->Draw.nFile == 26 )
	{
		for( int i=0; i<PLAYER_GROUP_MAX; i++ )
		{
			WORD wGroup = GAME.Players[pUnit->Draw.nPlayer].wGroup[i];
			if( wGroup != MAP_DATA_NONE )
			{
				pU = MAP_GetUnit( wGroup );
				Assert( pU );
				Assert( EYE_IfUnitIsGen( pU ) );
				pU->Gen.nMorale -= 50;
				if( EYE_IfFocusOnUnit( pU ) )
				{	// ʿ
					FACE_UpdateMorale( EYE_GetMorale( pU ) ) ;
				}
			}
		}
	}

	// ´ɾ
	struct CTRL_TASK_STRUCT hitDest;
	CTRL_TASK_Clear( &hitDest );

	// 
	Assert( pUnit );
	Assert( pUnit->nLife <= 0 );
	pUnit->nIDAttackMe = MAP_DATA_NONE;

	hitDest.bDone = TRUE;
	hitDest.bIRQ = TRUE;		// ǿж
	hitDest.nID = pUnit->nID;
	hitDest.nLevel = 0;			// ļ,0 is the highest, 5 is the lowest
	hitDest.nTaskID = SHANCHU;	// 
	hitDest.nTaskIDEx = 0;		// ɱ

	// ´񵽶
	CTRL_TASK_DeployByComputer( pUnit->Draw.nPlayer, &hitDest );

	// Ч
	RUN_SOUND_Die( pUnit->Draw.nX, pUnit->Draw.nY, pUnit->Draw.nFile );
	// Ч
}
/////////////

/////////////
BOOL RUN_MOULUE_IfEnough( struct UNIT_STRUCT *pUnit, CTRL_JIMOU nJiMou )
{
	Assert( EYE_IfUnitIsGen( pUnit ) );
	if( DATA_Lib.Gen[pUnit->Gen.nID].nMouLue < RUN_MOULUE_nConsume[nJiMou] )
	{
		if( EYE_IfSheIsMine( pUnit ) )
		{
			// ıֵ޷ʹøüı
			FACE_ShowPromptInfor( 9 );
			//---- Ч
			// noselect.wav
			DATA_WAVE_EffectPlay( 99 );
			//---- Ч
		}
		return FALSE;
	}
	return TRUE;
}
/////////////

/////////////
// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
void RUN_SOUND_Hit( int nX, int nY, int nFile )
{
	//---- Ч
	POINT pt;
	pt.x = nX, pt.y = nY;
	if( PtInRect( &DRAW_rcScreen, pt ) )
	{
		int nID=-1;

		switch( nFile )
		{
		case	31://
			//fight01.wav
			nID = 9;
			break;
		case	32://100
		case	38://200
			//fight02.wav
			nID = 10;
			break;
		case	41://500
		case	43://1000
			//fight03,04.wav
			nID = getrandom(11,12);
			break;
		case	35://ｫ
		case	36://100
		case	37://200
		case	40://500
			nID = 10;
			break;
		case	29://Ľ
		case	30://
			//hitbody4.wav
			nID = 16;
			break;
		};
		if( nID != -1 )
		{
			DATA_WAVE_EffectPlay( nID );
		}
	}
	//---- Ч
}

// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
void RUN_SOUND_HitF( int nX, int nY, int nFile )
{
	//---- Ч
	// 100-200ˣ
	POINT pt;
	pt.x = nX, pt.y = nY;
	if( PtInRect( &DRAW_rcScreen, pt ) )
	{
		int nID=-1;
		switch( nFile )
		{
		case	18:// ¥
		case	19:
			//arrow07.wav
			nID = 6;	
			break;
		case	33://
			//arrow01.wav
			nID = 0;
			break;
		case	45://100
		case	39://200
			//arrow02-04.wav
			nID = getrandom(1,3);
			break;
		case	42://500
		case	44://1000
			//arrow05,06.wav
			nID = getrandom(4,5);
			break;
		case	46:// Сս
		//case	47:// 䴬
		case	48:// ս
		case	49:// 
			nID = getrandom(1,3);
			break;
		}
		if( nID != -1 )
		{
			DATA_WAVE_EffectPlay( nID );
		}
		//---- Ч
	}
}

// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
void RUN_SOUND_Die( int nX, int nY, int nFile )
{
	//----Ч
	POINT pt;
	pt.x = nX, pt.y = nY;
	if( PtInRect( &DRAW_rcScreen, pt ) )
	{
		int nID = -1;
		switch( nFile )
		{
		case	27:// Ůƽ
		case	28:// ƽ
			break;
		case	29:// Ľ
//			break;
		case	30:// 
			break;
		case	31:// 
	//		break;
		case	32:// 100
		case	38:// 200
		case	41:// 500
		case	43:// 1000
			// died1.wav
			nID = 93;
			break;
		case	34:// 
			break;
		case	35:// ｫ
//			break;
		case	36:// 100
		case	37:// 200
		case	40:// 500
			// died3.wav
			nID = 95;
			break;
		case	33:// 
//			break;
		case	45:// 100
		case	39:// 200
		case	42:// 500
		case	44:// 1000
			// died2.wav
			nID = 94;
			break;
		case	52:// ˮ
//			break;
		case	46:// Сս
		case	47:// 䴬
		case	48:// ս
		case	49:// 
//			break;
			// boatrune.wav
			nID = 90;
			break;
		case	50:// 
		case	51:// 
			break;
		}
		if( nID != -1 )
		{
			DATA_WAVE_EffectPlay( nID );
		}
	}
	//----Ч
}

// Ч
// nX, nY	:	λ
// nFile	:	Ԫļ
void RUN_SOUND_Wounded( int nX, int nY, int nFile )
{
	//----Ч
	POINT pt;
	pt.x = nX, pt.y = nY;
	if( PtInRect( &DRAW_rcScreen, pt ) )
	{
		int nID = -1;
		switch( nFile )
		{
		case	27:// Ůƽ
		case	28:// ƽ
			break;
		case	29:// Ľ
//			break;
		case	30:// 
			break;
		case	31:// 
	//		break;
		case	32:// 100
		case	38:// 200
		case	41:// 500
		case	43:// 1000
			// wounded1.wav
			nID = 107;
			break;
		case	34:// 
			break;
		case	35:// ｫ
//			break;
		case	36:// 100
		case	37:// 200
		case	40:// 500
			// wounded3.wav
			nID = 109;
			break;
		case	33:// 
//			break;
		case	45:// 100
		case	39:// 200
		case	42:// 500
		case	44:// 1000
			// wounded2.wav
			nID = 108;
			break;
		case	52:// ˮ
//			break;
		case	46:// Сս
		case	47:// 䴬
		case	48:// ս
		case	49:// 
//			break;
			break;
		case	50:// 
		case	51:// 
			break;
		}
		if( nID != -1 )
		{
			DATA_WAVE_EffectPlay( nID );
		}
	}
	//----Ч
}

// Чÿһʱÿش򿪣ĻҷԪ/
// ܵʱɻϷWe are under attack!
// עҪںжϷ
// nX, nY	:	Ԫλ
// nFile	:	Ԫļ
void RUN_SOUND_UnderAttack( int nX, int nY, int nFile )
{
	if( RUN_SOUND_bWeAreUnderAttack == FALSE )
		return;
	POINT pt;
	pt.x = nX, pt.y = nY;
	if( PtInRect( &DRAW_rcScreen, pt ) )
		return;	// Ļڲ˵

	RUN_SOUND_bWeAreUnderAttack = FALSE;	// عر
	int nID = -1;
	if( nFile >= 0 && nFile < 27 )
	{	// XRe-XRg.wav
		nID = getrandom( 81,83 );
	}
	else
	{
		switch( nFile )
		{
		case	29:	//Ľ
			//XG4e-g.wav
			nID = getrandom(75,77);
			break;
		case	31:	//
			//XG1e-g.wav
			nID = getrandom(54,56);
			break;
		case	33:	//
			//XG2e-g.wav
			nID = getrandom(61,63);
			break;
		case	35:	//ｫ
			//XG3e-g.wav
			nID = getrandom(68,70);
			break;
		case	52:	//ˮ
			//XG2e-g.wav
			nID = getrandom(61,63);
			break;
		default:	// ʿ
			nID = getrandom(78,80);
		}
	}
	if( nID != -1 )
	{
		DATA_WAVE_EffectPlay( nID );
	}
}
/////////////
