/////////////////////////
// 	Interfa2.h	:	v0010
//	Written by 	:	Li	Haijun
//	Compiler	:	Microsoft Visual C++ 4.0
//	v0010		:	Nev.7.1996
/////////////////////////

/////////////////////////////////////////////////////////////////////////////
// All button operation function for the interface
 
#ifndef __INTERFA2_H__
#define __INTERFA2_H__

#include	"ddapi.h"
#include	"stdafx.h"

///////////////////////////////////////
//	to set the message 
void	FACE_SetMessage(void);
// to show the net work message at the set net work menu
// to set the message for the set network menu
void	FACE_NetWorkSetMessage(void) ;


/////////////////////////////////////////
// to test whether a button is clicked
/////////////////////////////////////////
BOOL	FACE_LeftButtonDown(int xPos, int yPos);
// to test whether cursor is on current button when left button up
BOOL	FACE_LeftButtonUp(int xPos, int yPos);
// to test whether cursor is moved on a button
BOOL	FACE_MouseMove(WPARAM wParam,int xPos, int yPos);
// to test whether cursor is select a general if selected to confirm it
BOOL	FACE_LeftButtonDoubleClick(WPARAM wParam, int xPos, int yPos);
// to cancel this menu 
void	FACE_RightButtonDown(WPARAM wParam, int xPos, int yPos);

//////////////////////////////////////////////////////////////////////////////////////////
//     						prompt functions											//
//																						//
//		LPCTSTR	GetCurrentString()														//
//		void Prompt( HWND hwnd, LPCTSTR message, int posX = 30, int posY = 460 )			//
//		void echo_prompt( HWND hwnd, LPCTSTR message, int posX = 30, int posY = 460 )	//
//////////////////////////////////////////////////////////////////////////////////////////
// to check whether inputting a string, if do, put the string into MESSAGE_BUF
BOOL FACE_IsInputString( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
// to get the current input string from outside
LPCTSTR	FACE_GetCurrentString();
// to show a string to the directly rigon
void FACE_Prompt( HWND hwnd, LPCTSTR message, int posX = 30, int posY = 460 );
// to show the message string to the bottom block rigon
void FACE_ShowMessage( HWND hwnd, LPCTSTR message, int posX = 30, int posY = 460 );
//	to show the prompt message and keybroad input together
void FACE_Echo_prompt( HWND hwnd = NULL, int posX = 30, int posY = 460 );
// to update the bottom message rectangle of the inner game
void FACE_UpdateMessageRect(void);

////////////////////////////////////////////////////////////////////////
//
//
//		The following functions are used to send message and show them 
//
//			at the rectly rectangle areas
//
////////////////////////////////////////////////////////////////////////
//	to send the message to the others and show it at my own 
//		network message rectangle display area
void	FACE_NetworkSendMessage(void) ;
// to update the send message rectangle of the set network menu
void FACE_UpdateNetWorkMessageRect(void);
// to update the display message rectangle of the set network menu
void FACE_UpdateNetworkComMessageRect(void) ;
///////////////////////////////////////////////////////////////////////
//	to init the four string that store the network message
void	FACE_InitNetworkMessage(void) ;
///////////////////////////////////////////////////////////////////////
//	to set the network message and show it
void	FACE_SetNetworkMessage(	LPCTSTR name, LPCTSTR message ) ;

//////////////////////////////////////////////////////////
// to initialation all CDDString instances and all strings
void FACE_InitAllStrings() ;
/////////////////////////////////////////
#endif
