/*
                                   ©պ

                                             ĳ 19972
	v0020	Mar.22.1997, by Liu Gang
*/
//#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <sys\stat.h>
#include <sys\types.h>
#include <fcntl.h>

#include "Assert.h"
#include "L_image.h"

     //ѹļ;
void CPicture_image::image_open_compress (char compress_file_name[20])
{
    int   handle,compress_bytes;
    handle=open (compress_file_name,O_RDONLY|O_BINARY);

    if (handle!=-1)
       compress_bytes=filelength (handle);

    if ((compress_file=fopen (compress_file_name,"rb"))==NULL)
    {
	printf ("This file no find !!!");
	exit (1);
    }

    close ( handle );
    if ((compress_buf=new char [compress_bytes])==NULL)
    {
	printf("Memory out !!!");
	exit (2);
    }
    fread (compress_buf,1,compress_bytes,compress_file);
}

     //رѹļ;
void CPicture_image::image_close_compress (void)
{
    fclose ( compress_file );
    delete (compress_buf);
}

     //ļ;
void CPicture_image::image_open_index (char index_file_name[20])
{
    int   handle,index_bytes;
    handle=open (index_file_name,O_RDONLY);

    if (handle!=-1)
       index_bytes=filelength (handle);
    index_bytes=index_bytes>>1;
    if ((index_file=fopen (index_file_name,"rb"))==NULL)
    {
	printf ("This file no find !!!");
	exit (1);
    }

    close ( handle );
    if ((index_buf=new int [index_bytes])==NULL)
    {
	printf("Memory out !!!");
	exit (2);
    }
    fread (index_buf,4,index_bytes,index_file);
}
     //رļ;
void CPicture_image::image_close_index (void)
{
    fclose ( index_file );
    delete (index_buf);
}


//#define	_L_INVIDEO_
/*
   ©:
	   int x:ͼƬϽ;
       int y:ͼƬϽ;
	   int   screen_width:ĻĿ;
	   char * screen_point:Ļָ;
	   int   color_variable:ɫƫ;
*/
// general functions, to change colors
void CPicture_image::P_image (int x,int y,
			      int   screen_width,
			      char  * screen_point,
			      int   color_variable,
			      int   picture_number
			      )
{
	char    * compress_backup;       //ѹָ;
	char    * screen_backup;         //screen_point;
	int       compress_data_length;  //;
	short     count,count0;   //¼0ɫͷ0ɫĸ;
//	int       compress_picture_width;    //ѹͼƬͼƬĿ;
//	short     compress_tag;   //ͼƬȽ־;
	short     i;
	short     screen_endl;

	compress_backup=compress_buf+*(index_buf+picture_number);

	//*Ļָ(Ļ)*/
	screen_point+=(x+y*screen_width);
	screen_backup=screen_point;

	//*ѹļͷ*/
	screen_endl=screen_width-*((int *) compress_backup);
	compress_backup+=10;
	compress_data_length=*((int *) compress_backup)-4;      //ѹݳ;
	compress_backup+=4;
	//*©*/
	while ( compress_data_length>=0 )
	{
		count0=*((short *) compress_backup);   //0ɫĸ;
		compress_backup+=2;
		count=*((short *) compress_backup);    //0ɫĸ;
		compress_backup+=2;
		compress_data_length-=4;
		screen_backup+=count0;		 //0ɫ(0ɫ);
		if (!count)		    //count==0;
		{  //ָƶһ
			screen_backup+=screen_endl;
		}
		else
		{  //0ɫĴ;
			// standard C code
			//д
#ifdef	_L_INVIDEO_
			memcpy (screen_buffers,compress_backup,count);
			for (i=0;i<count;i++)
			{
				if (( screen_buffers[i] >= START_COLOR_NUMBER )
				&& (screen_buffers[i] <= END_COLOR_NUMBER))
				{
					screen_buffers[i]+=color_variable;
				}
			}
			memcpy (screen_backup,screen_buffers,count);

			// counters and pointers
			compress_data_length-=count;
			compress_backup+=count;
			screen_backup+=count;
#else
		   for (i=0;i<count;i++)
		   {
			   if (( *compress_backup >= START_COLOR_NUMBER )
			  && (*compress_backup <= END_COLOR_NUMBER))
			   {
					  *screen_backup=*compress_backup+color_variable;
			   }
  		   
			   else
			   {
			  *screen_backup=*compress_backup;
			   }
			   screen_backup++;
			   compress_backup++;
		   }
			compress_data_length-=count;
#endif
		}
	}
}

/*
   ©:
	   int x:ͼƬϽ;
       int y:ͼƬϽ;
	   int   screen_width:ĻĿ;
	   char * screen_point:Ļָ;
	   int   color_variable:ɫƫ;
*/
// ɫ
// do not change colors
void CPicture_image::P_imageDirect (int x,int y,
			      int   screen_width,
			      char  * screen_point,
			      int   color_variable,
			      int   picture_number
			      )
{
	char    * compress_backup;       //ѹָ;
	char    * screen_backup;         //screen_point;
	int       compress_data_length;  //;
	short     count,count0;   //¼0ɫͷ0ɫĸ;
//	int       compress_picture_width;    //ѹͼƬͼƬĿ;
//	short     compress_tag;   //ͼƬȽ־;
//	short     i;
	short     screen_endl;

	compress_backup=compress_buf+*(index_buf+picture_number);

	//*Ļָ(Ļ)*/
	screen_point+=(x+y*screen_width);
	screen_backup=screen_point;

	//*ѹļͷ*/
	screen_endl=screen_width-*((int *) compress_backup);
	compress_backup+=10;
	compress_data_length=*((int *) compress_backup)-4;      //ѹݳ;
	compress_backup+=4;
	//*©*/
	while ( compress_data_length>=0 )
	{
		count0=*((short *) compress_backup);   //0ɫĸ;
		compress_backup+=2;
		count=*((short *) compress_backup);    //0ɫĸ;
		compress_backup+=2;
		compress_data_length-=4;
		screen_backup+=count0;		 //0ɫ(0ɫ);
		if (!count)		    //count==0;
		{  //ָƶһ
			screen_backup+=screen_endl;
		}
		else
		{  //0ɫĴ;
			memcpy (screen_backup,compress_backup,count);

			// counters and pointers
			compress_data_length-=count;
			compress_backup+=count;
			screen_backup+=count;
		}
	}
}


//-for MMX extension, Liu Gang
extern "C"
{
extern void MMX_PImage(
	char *lpDest,	// Ŀĵػָ
	char *lpSrc,	// Դָ
	int nColor,		// Ҫıɵɫϵ
	int nCount		// ֽ
);
}
//-for MMX extension, Liu Gang

/*
   ©:
	   int x:ͼƬϽ;
       int y:ͼƬϽ;
	   int   screen_width:ĻĿ;
	   char * screen_point:Ļָ;
	   int   color_variable:ɫƫ;
*/
// MMX extension
void CPicture_image::P_imageMMX (int x,int y,
			      int   screen_width,
			      char  * screen_point,
			      int   color_variable,
			      int   picture_number
			      )
{
	char    * compress_backup;       //ѹָ;
	char    * screen_backup;         //screen_point;
	int       compress_data_length;  //;
	short     count,count0;   //¼0ɫͷ0ɫĸ;
//	int       compress_picture_width;    //ѹͼƬͼƬĿ;
//	short     compress_tag;   //ͼƬȽ־;
//	short     i;
	short     screen_endl;

	compress_backup=compress_buf+*(index_buf+picture_number);

	/*Ļָ(Ļ)*/
	screen_point+=(x+y*screen_width);
	screen_backup=screen_point;

	//*ѹļͷ*/
	screen_endl=screen_width-*((int *) compress_backup);
	compress_backup+=10;
	compress_data_length=*((int *) compress_backup)-4;      //ѹݳ;
	compress_backup+=4;
	//*©*/
	while ( compress_data_length>=0 )
	{
		count0=*((short *) compress_backup);   //0ɫĸ;
		compress_backup+=2;
		count=*((short *) compress_backup);    //0ɫĸ;
		compress_backup+=2;
		compress_data_length-=4;
		screen_backup+=count0;		 //0ɫ(0ɫ);
		if (!count)		    //count==0;
		{  //ָƶһ
			screen_backup+=screen_endl;
		}
		else
		{  //0ɫĴ;
			memcpy (screen_buffers,compress_backup,count);
//-for MMX extension, Liu Gang
			// MMX extension
			MMX_PImage( screen_buffers, screen_buffers, color_variable, count );
//-for MMX extension, Liu Gang
			memcpy (screen_backup,screen_buffers,count);

			// counters and pointers
			compress_data_length-=count;
			compress_backup+=count;
			screen_backup+=count;
		}
	}
}

