/////////////
//	Marco.h			:	v0010
//	Written by		:	Li Haijun
//	Compiler		:	Microsoft Visual C++ 4.0 & DirectX
//	Library			:	No .Lib
//	Copyright (C)	:	1996 WayAhead Corporation 
//	v0010			:	Nev.11.1996
/////////////
// to define all marcro of interface
//////////////////////////////
#ifndef __MARCRO_H__
#define __MARCRO_H__

#define INTERFACE_ERROR	2000

#define	CHAO			0	//to identify to show which command unit when show build command unit
#define	LIU				1

#define NONE			-10
#define FIRST			-10

//	to define the picture of this game 
#define	PICTURE_BEGIN		0
#define	PICTURE_WAIT		1
#define	PICTURE_END			2
#define PICTURE_FAIL		3

// the max number of file that you can save
#define	MAX_SAVEFILE		20
// the max maps that could find in you map directory
#define MAX_MAPS			64

// the max number of general that a king can have
#define MAX_ONEKINGGENERAL	54

#define	MAX_DIALOG_LETTER		9
#define	MAX_PROMPT_LETTER		128
#define MAX_MESSAGE_LETTER		128
#define NETWORK_MAX_MESSAGE_LETTER	23 
#define	MAX_NAME_LETTER			32

//	show list paramiter 
#define FIRST_IN		0
#define PAGE_UP			1
#define PAGE_DOWN		2
#define GET_CURRENT		3
// program states
#define	PROGRAM_STATE_NONE		0		// a null program state , if everthing OK, this state will never appear
#define	PROGRAM_STATE_ERROR		-10		// this program happened a fatal error
#define	PROGRAM_STATE_PLAY		1		// this program is playing ( eg: solier is moving, battle is doing )
#define	PROGRAM_STATE_PAUSE		2		// this program is paused by player or one of a player( in network play mode )
#define PROGRAM_STATE_MENU		3		// current program is handling a menu, in sigle player mode it will pause the game,
										//		in network mode it will not pause
#define PROGRAM_STATE_AVI		4		// this program is playing a avi
#define PROGRAM_STATE_RESULT	5		// to show the battle result of this companion, this state only use in network version

// command states
#define	COMMAND_STATE_NONE		0
#define COMMAND_STATE_ERROR		-10
#define COMMAND_STATE_PLAY		20
#define	COMMAND_STATE_PAUSE		21
#define	COMMAND_STATE_MENU		22
#define	COMMAND_STATE_MESSAGE	26
#define COMMAND_STATE_DIALOG	27
//////////////////////////////
#define COMMAND_STATE_AVI_BEGIN		30		// current program is playing a AVI, so program is pausing and wait for AVI stop
#define COMMAND_STATE_AVI_END		31		// current program is playing a AVI, so program is pausing and wait for AVI stop
#define COMMAND_STATE_AVI_MISSION	32		// current program is playing a AVI, so program is pausing and wait for AVI stop
#define COMMAND_STATE_AVI_REALTIME	33		// current program is playing a AVI, so program is pausing and wait for AVI stop
#define COMMAND_STATE_AVI_SINGLE	34		// current program is playing a AVI, so program is pausing and wait for AVI stop
#define COMMAND_STATE_AVI_HISTORY	35		// current program is playing a AVI, so program is pausing and wait for AVI stop
#define COMMAND_STATE_RESULT		40		// to show the battle result of this companion, this state only use in network version


// the volume of global variable pAllBitmap[] array
#define	MAX_BITMAP			5
// the volume of global variable pAllButton[] array
#define	MAX_BUTTON			200
// the volume of all command button in pAllCommandButton[] array
#define MAX_COMMANDBUTTON	150
// the volume of a button unit pButton[MAX_BUTTONINUNIT]
#define MAX_BUTTONINUNIT	15
// the volume of pAllCheckBoxUnit[MAX_CHECKBOXUNIT] array
#define	MAX_CHECKBOXUNIT	20
// the volume of pCheckBox[MAX_CHECKBOXINUNIT] array
#define	MAX_CHECKBOXINUNIT	5
// the volume of pAllListUnit[MAX_LISTUNIT] array
#define	MAX_LISTUNIT		5
// the volume of a list unit pList[MAX_LISTINUNIT]
#define MAX_LISTINUNIT		10
// the volume of pAllComboUnit[MAX_COMBOUNIT] array
#define MAX_COMBOBOX		5
// the volume of pAllScrollBar[MAX_SCROLLBAR] array
#define MAX_SCROLLBAR		5
// the volume of pAllText[] array
#define MAX_TEXT			4

// button states
#define	BUTTON_NONE		-10
#define BUTTON_UP		0
#define BUTTON_DOWN 	1
#define BUTTON_FOCUS	2
#define BUTTON_DISABLE	3
#define BUTTON_HIDE		4

// check-box states
#define	CHECKBOX_NONE				-10
#define CHECKBOX_NOCHECK_UP			0
#define CHECKBOX_NOCHECK_DOWN		1
#define CHECKBOX_CHECK_UP			2
#define CHECKBOX_CHECK_DOWN			3
#define CHECKBOX_DISABLE			4
#define	CHECKBOX_HIDE				5
// button states
#define	LIST_NONE		-10
#define LIST_UP			0
#define LIST_DOWN	 	1
#define LIST_FOCUS		2
#define LIST_DISABLE	3
#define LIST_HIDE		4

// combo state
#define COMBOBOX_NONE		-10
#define COMBOBOX_UP			0
#define COMBOBOX_DOWN		1
#define COMBOBOX_FOCUS		2
#define COMBOBOX_DISABLE	3

// scroll-bar state
#define SCROLLBAR_NONE		-10
#define SCROLLBAR_UP		0
#define SCROLLBAR_FOCUS		1
#define SCROLLBAR_DISABLE	2
//////////////////////////////////////

//////////////////////////////////////
#define	WM_GAME_END			10000
#define NEW_MESSION			10010
//////////////////////////////////////

//////////////////////////////////////
//	10000 --- 10100	    menu identify
#define	SHOW_MAIN_MENU							20001	// to show this main menu
#define MENU_MAIN								20000	// the main menu to game
	#define BUTTON_MENU_MAIN_NEWGAME				20100
		#define MENU_MAIN_NEWGAME					20101	// to select king
			#define BUTTON_MENU_MAIN_NEWGAME_CHAO		20112
			#define BUTTON_MENU_MAIN_NEWGAME_LEAGUE		20114
			#define	BUTTON_MENU_MAIN_NEWGAME_OK			20116
			#define	BUTTON_MENU_MAIN_NETWORK_NEWGAME_OK	20117
			#define	BUTTON_MENU_MAIN_NEWGAME_CANCEL		20118
	#define BUTTON_MENU_MAIN_LOAD				20200
		#define	MENU_MAIN_LOAD					20201	// to load a schedual
			#define	BUTTON_MENU_MAIN_LOAD_OK			20210
			#define	BUTTON_MENU_MAIN_LOAD_CANCEL		20220
			#define BUTTON_MENU_MAIN_LOAD_ARROW_TOP		20230
			#define	BUTTON_MENU_MAIN_LOAD_ARROW_BOTTOM	20240
	#define BUTTON_MENU_MAIN_NETWORK		21000
		#define MENU_MAIN_NETWORK_INPUTNAME				20250	//to input the player's name
			#define	DIALOG_MENU_MAIN_NETWORK_NAME 				20251	// to store player's name
			#define	BUTTON_MENU_MAIN_NETWORK_INPUTNAME_OK		20252
			#define	BUTTON_MENU_MAIN_NETWORK_INPUTNAME_CANCEL	20253
			#define	MENU_MAIN_NETWORK					21001	// to set multipule players
				#define BUTTON_MENU_MAIN_NETWORK_OK			21002
				#define BUTTON_MENU_MAIN_NETWORK_CANCEL		21004
				#define	BUTTON_MENU_MAIN_NETWORK_IPX		22000
					#define MENU_MAIN_NETWORK_IPX				22001	//
						#define	LISTUNIT_MENU_MAIN_NETWORK_IPX		22100	// to show all game that you can join or see
						#define	BUTTON_MENU_MAIN_NETWORK_IPX_ARROW_TOP		22110	// to show the previous page
						#define	BUTTON_MENU_MAIN_NETWORK_IPX_ARROW_BOTTOM	22120	// to show the next page
						#define	BUTTON_MENU_MAIN_NETWORK_IPX_CANCEL			22130	// to show the next page
						#define BACKTO_BUTTON_MENU_MAIN_NETWORK_IPX_CREATE		22138	// use for to back to the state of BUTTON_MENU_MAIN_NETWORK_IPX_CREATE
						#define	BUTTON_MENU_MAIN_NETWORK_IPX_CREATE				22200	// to create a new game
							#define	MENU_MAIN_NETWORK_SETNET			22201	// to show the situation of this game
								#define BUTTON_MENU_SENDMESSAGE				22202	// to send the message that player want to send
								#define NET_UPDATESETTING					22204	// to send this message when you have receive a network message that the setting has been change
							#define	MENU_MAIN_NETWORK_IPX_CREATE		22201	// to show the situation of this game
								#define BUTTON_MENU_MAIN_NETWORK_IPX_KING1		22210	// to show the one king of the game
								#define BUTTON_MENU_MAIN_NETWORK_IPX_KING2		22212
								#define BUTTON_MENU_MAIN_NETWORK_IPX_KING3		22214
								#define BUTTON_MENU_MAIN_NETWORK_IPX_KING4		22216
								#define MENU_MAIN_NETWORK_SETNET_SELECTKING			22218	//the son menu to select which king you are
								#define MENU_MAIN_NETWORK_IPX_SETNET_SELECTKING		22218	//the son menu to select which king you are
									#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_SELECTKING_LIU		22220	// Liu Bei
									#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_SELECTKING_SHUN		22222	// Shun Quan
									#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_SELECTKING_CHAO		22224	// Chao Chao
							#define BUTTON_MENU_MAIN_NETWORK_IPX_SETNET_EXIT	22299	// to show the one exit port of the player
								#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_EXIT1	22300	// to show the one exit port of the player
								#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_EXIT2	22302
								#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_EXIT3	22304
								#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_EXIT4	22306
							#define BUTTON_MENU_MAIN_NETWORK_SETNET_AGREE1		30010	// to set the allies of you
							#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOAGREE1	30011	// to set the allies of you
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY11		22308	// to set the allies of you
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY11	22309	// to set the allies of you
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY12		22310
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY12	22311
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY13		22312
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY13	22313
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY14		22314
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY14	22315
							#define BUTTON_MENU_MAIN_NETWORK_SETNET_AGREE2		30020	// to set the allies of you
							#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOAGREE2	30021	// to set the allies of you
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY21		22316
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY21	22317
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY22		22318
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY22	22319
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY23		22320
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY23	22321
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY24		22322
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY24	22323
							#define BUTTON_MENU_MAIN_NETWORK_SETNET_AGREE3		30030	// to set the allies of you
							#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOAGREE3	30031	// to set the allies of you
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY31		22324
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY31	22325
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY32		22326
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY32	22327
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY33		22328
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY33	22329
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY34		22330
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY34	22331
							#define BUTTON_MENU_MAIN_NETWORK_SETNET_AGREE4		30040	// to set the allies of you
							#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOAGREE4	30041	// to set the allies of you
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY41		22332
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY41	22333
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY42		22334
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY42	22335
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY43		22336
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY43	22337
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_ALLY44		22338
								#define BUTTON_MENU_MAIN_NETWORK_SETNET_NOALLY44	22339
								#define BITMAP_MENU_MAIN_NETWORK_SETNET_PROMPT		22340	// to show the prompt top bitmap
								#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_MAP			22400
								#define MENU_MAIN_NETWORK_SETNET_SELECTMAP			22401	//the son menu to select a map
								#define MENU_MAIN_NETWORK_IPX_CREATE_SELECTMAP			22401	//the son menu to select a map
									#define BUTTON_MENU_MAIN_NETWORK_SETNET_SELECTMAP_FIND				22410
									#define BUTTON_MENU_MAIN_NETWORK_SETNET_SELECTMAP_ARROW_TOP			22412
									#define BUTTON_MENU_MAIN_NETWORK_SETNET_SELECTMAP_ARROW_BOTTOM		22414
									#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_SELECTMAP_OK		22416
									#define BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_SELECTMAP_CANCEL	22418
								#define	BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_BEGIN	22450	//to begin this game
								#define	BUTTON_MENU_MAIN_NETWORK_IPX_CREATE_CANCEL	22452	// to cancel the net set of create
						#define	BUTTON_MENU_MAIN_NETWORK_IPX_JOIN		22500	// to join a game that have been create
						#define SHOW_MENU_MAIN_NETWORK_IPX_JOIN			22502
//						#define	BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_1		22501	// to join a game that have been create
//						#define	BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_2		22502	// to join a game that have been create
//						#define	BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_3		22503	// to join a game that have been create
							#define	MENU_MAIN_NETWORK_IPX_JOIN_1		22505	// to show the situation of this game
								#define	BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_1_CANCEL		22510	// to cancel the net set of join
								#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_CANCEL		22515	
								#define MENU_MAIN_NETWORK_IPX_JOIN_1_SELECTKING				22520	//the son menu to select which king you are
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_SELECTKING_LIU		22522	// Liu Bei
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_SELECTKING_SHUN		22524	// Shun Quan
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_SELECTKING_CHAO		22526	// Chao Chao
							#define	MENU_MAIN_NETWORK_IPX_JOIN_2		22600	// to show the situation of this game
								#define	BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_2_CANCEL		22610	// to cancel the net set of join
								#define MENU_MAIN_NETWORK_IPX_JOIN_2_SELECTKING			22620	//the son menu to select which king you are
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_2_SELECTKING_LIU		22622	// Liu Bei
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_2_SELECTKING_SHUN		22624	// Shun Quan
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_2_SELECTKING_CHAO		22626	// Chao Chao
							#define	MENU_MAIN_NETWORK_IPX_JOIN_3		22700	// to show the situation of this game
								#define	BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_3_CANCEL		22710	// to cancel the net set of join
								#define MENU_MAIN_NETWORK_IPX_JOIN_3_SELECTKING			22720	//the son menu to select which king you are
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_3_SELECTKING_LIU		22722	// Liu Bei
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_3_SELECTKING_SHUN		22724	// Shun Quan
									#define BUTTON_MENU_MAIN_NETWORK_IPX_JOIN_3_SELECTKING_CHAO		22726	// Chao Chao
						#define	BUTTON_MENU_MAIN_NETWORK_IPX_SEE		22800	// to see a game that have been create
							#define	MENU_MAIN_NETWORK_IPX_SEE			22801	// to show the situation of this game
								#define	BUTTON_MENU_MAIN_NETWORK_IPX_SEE_CANCEL			22810	// to cancel the net set of see
				#define	BUTTON_MENU_MAIN_NETWORK_MODEM				23000
					#define	MENU_MAIN_NETWORK_MODEM					23001	// to set modem	mode
						#define	BUTTON_MENU_MAIN_NETWORK_MODEM_CANCEL		23010
						#define	BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE	23020
							#define MENU_MAIN_NETWORK_MODEM_WAITPHONE			23021	//the son menu to select which king you are
								#define	BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_BEGIN	23030
								#define	BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_CANCEL	23032
								#define BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_EXIT1	23034	// to show the one exit port of the player
								#define BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_EXIT2	23036
								#define	BUTTON_MENU_MAIN_NETWORK_MODEM_KING1			23037
								#define	BUTTON_MENU_MAIN_NETWORK_MODEM_KING2			23038
								#define MENU_MAIN_NETWORK_MODEM_WAITPHONE_SELECTKING	23040	//the son menu to select which king you are
									#define BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_SELECTKING_LIU		23042	// Liu Bei
									#define BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_SELECTKING_SHUN	23044	// Shun Quan
									#define BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_SELECTKING_CHAO	23046	// Chao Chao
								#define BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_MAP	23048
								#define MENU_MAIN_NETWORK_MODEM_WAITPHONE_SELECTMAP		23050	//the son menu to select a map
									#define BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_SELECTMAP_OK		23052
									#define BUTTON_MENU_MAIN_NETWORK_MODEM_WAITPHONE_SELECTMAP_CANCEL	23054
						#define	BUTTON_MENU_MAIN_NETWORK_MODEM_PHONE	23100
							#define	MENU_MAIN_NETWORK_MODEM_PHONE		23101
								#define BUTTON_MENU_MAIN_NETWORK_MODEM_PHONE_CANCEL		23110
								#define MENU_MAIN_NETWORK_MODEM_PHONE_SELECTKING		23120	//the son menu to select which king you are
									#define BUTTON_MENU_MAIN_NETWORK_MODEM_PHONE_SELECTKING_LIU		23122	// Liu Bei
									#define BUTTON_MENU_MAIN_NETWORK_MODEM_PHONE_SELECTKING_SHUN	23124	// Shun Quan
									#define BUTTON_MENU_MAIN_NETWORK_MODEM_PHONE_SELECTKING_CHAO	23126	// Chao Chao
				#define	BUTTON_MENU_MAIN_NETWORK_SERIAL			24000
					#define	MENU_MAIN_NETWORK_SERIAL			24001	// to set serial-interface mode
						#define	BUTTON_MENU_MAIN_NETWORK_SERIAL_CANCEL		24010
						#define	BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE		24020
							#define	MENU_MAIN_NETWORK_SERIAL_CREATE			24021
								#define	BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_BEGIN	24030
								#define	BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_CANCEL	24032
								#define BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_EXIT1	24034	// to show the one exit port of the player
								#define BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_EXIT2	24036
								#define	BUTTON_MENU_MAIN_NETWORK_SERIAL_KING1			24037
								#define	BUTTON_MENU_MAIN_NETWORK_SERIAL_KING2			24038
	//							#define MENU_MAIN_NETWORK_SETNET_SELECTKING				24040	//the son menu to select which king you are
								#define MENU_MAIN_NETWORK_SERIAL_CREATE_SELECTKING		24040	//the son menu to select which king you are
									#define BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_SELECTKING_LIU		24042	// Liu Bei
									#define BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_SELECTKING_SHUN		24044	// Shun Quan
									#define BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_SELECTKING_CHAO		24046	// Chao Chao
								#define BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_MAP					24048
								#define MENU_MAIN_NETWORK_SERIAL_CREATE_SELECTMAP		24050	//the son menu to select a map
									#define BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_SELECTMAP_OK			24060
									#define BUTTON_MENU_MAIN_NETWORK_SERIAL_CREATE_SELECTMAP_CANCEL		24062
						#define	BUTTON_MENU_MAIN_NETWORK_SERIAL_JOIN		26070
							#define	MENU_MAIN_NETWORK_SERIAL_JOIN			26071
								#define	BUTTON_MENU_MAIN_NETWORK_SERIAL_JOIN_CANCEL		26080
								#define MENU_MAIN_NETWORK_SERIAL_JOIN_SELECTKING		26090	//the son menu to select which king you are
									#define BUTTON_MENU_MAIN_NETWORK_SERIAL_JOIN_SELECTKING_LIU		26092	// Liu Bei
									#define BUTTON_MENU_MAIN_NETWORK_SERIAL_JOIN_SELECTKING_SHUN	26094	// Shun Quan
									#define BUTTON_MENU_MAIN_NETWORK_SERIAL_JOIN_SELECTKING_CHAO	26096	// Chao Chao
				#define	BUTTON_MENU_MAIN_NETWORK_INTERNET			25000
					#define	MENU_MAIN_NETWORK_INTERNET				25001	// to set internet mode
						#define	BUTTON_MENU_MAIN_NETWORK_INTERNET_CANCEL	25010
	#define BUTTON_MENU_MAIN_HISTORY		26000
	#define BUTTON_MENU_MAIN_EXIT			27000
///////////////////////////////////////////////////////////////////////////////
#define	BUTTON_PAUSE		60000

#define	BUTTON_SYSTEMENU	60001
	#define	MENU_SYSTEMENU		60002

#define	BUTTON_SYSTEMENU_SAVE		61000
	#define MENU_SYSTEMENU_SAVE			61001	// to save a schedual
		#define	BUTTON_SYSTEMENU_SAVE_OK			61102
		#define	BUTTON_SYSTEMENU_SAVE_CANCEL		61104
		#define	BUTTON_SYSTEMENU_SAVE_ARROW_TOP		61106
		#define	BUTTON_SYSTEMENU_SAVE_ARROW_BOTTOM	61108
		#define	BUTTON_SYSTEMENU_SAVE_LIST			61110
#define	BUTTON_SYSTEMENU_LOAD		62000
	#define	MENU_SYSTEMENU_LOAD			62001
		#define	BUTTON_SYSTEMENU_LOAD_OK			62102
		#define	BUTTON_SYSTEMENU_LOAD_CANCEL		62104
		#define	BUTTON_SYSTEMENU_LOAD_ARROW_TOP		62106
		#define	BUTTON_SYSTEMENU_LOAD_ARROW_BOTTOM	62108
		#define	BUTTON_SYSTEMENU_LOAD_LIST			62110
#define	BUTTON_SYSTEMENU_EXIT		63000
	#define	MENU_SYSTEMENU_EXIT			63001
		#define	BUTTON_SYSTEMENU_EXIT_RESTART		63102
		#define	BUTTON_SYSTEMENU_EXIT_TOMAINMENU	63104
		#define BACK_BUTTON_SYSTEMENU_EXIT_TOMAINMENU		63105
		#define	BUTTON_SYSTEMENU_EXIT_EXITGAME		63106
		#define	BUTTON_SYSTEMENU_EXIT_BACKTOGAME	63108
#define	BUTTON_SYSTEMENU_QUERY_CAMPAIGN_MISSION		64500	// to show info of campaign
	#define	MENU_SYSTEMENU_QUERY_CAMPAIGN_MISSION		64501	// to show info of campaign
		#define	BUTTON_MENU_QUERY_CAMPAIGN_FINISH			64502
#define	BUTTON_SYSTEMENU_OPTION			65000
	#define MENU_SYSTEMENU_OPTION			65001	// to set system options
		#define SCROLLBAR_SYSTEMENU_OPTION_MUSIC		65002	// to set the background music of game
		#define SCROLLBAR_SYSTEMENU_OPTION_SOUND		65004	// to set the sound volume of game
		#define SCROLLBAR_SYSTEMENU_OPTION_SPEED		65006	// to set the speed of game going
		#define SCROLLBAR_SYSTEMENU_OPTION_SCROLLSPEED	65008	// to set the scroll speed of screen
		#define	BUTTON_SYSTEMENU_OPTION_SINGLE_ON		65010	// to set whether to see the single-fight show
		#define	BUTTON_SYSTEMENU_OPTION_SINGLE_OFF		65012	// to set whether to see the single-fight show
		#define	BUTTON_SYSTEMENU_OPTION_OK				65014	// to finish this menu
#define	BUTTON_SYSTEMENU_HELP			66000
	#define	MENU_SYSTEMENU_HELP				66001
		#define	BUTTON_SYSTEMENU_HELP_OPREATE		66100
			#define	MENU_SYSTEMENU_HELP_OPREATE			66101
				#define	BUTTON_SYSTEMENU_HELP_OPREATE_PAGEUP		66102
				#define	BUTTON_SYSTEMENU_HELP_OPREATE_PAGEDOWN		66104
				#define	BUTTON_SYSTEMENU_HELP_OPREATE_FINISH		66106
		#define	BUTTON_SYSTEMENU_HELP_ICON	66200
			#define	MENU_SYSTEMENU_HELP_ICON		66201
				#define	BUTTON_SYSTEMENU_HELP_ICON_PAGEUP		66202
				#define	BUTTON_SYSTEMENU_HELP_ICON_PAGEDOWN		66204
				#define	BUTTON_SYSTEMENU_HELP_ICON_FINISH		66206
		#define	BUTTON_SYSTEMENU_HELP_BUILDING	66300
			#define	MENU_SYSTEMENU_HELP_BUILDING		66301
				#define	BUTTON_SYSTEMENU_HELP_BUILDING_PAGEUP	66302
				#define	BUTTON_SYSTEMENU_HELP_BUILDING_PAGEDOWN	66304
				#define	BUTTON_SYSTEMENU_HELP_BUILDING_FINISH	66306
		#define	BUTTON_SYSTEMENU_HELP_GAME		66400
			#define	MENU_SYSTEMENU_HELP_GAME		66401
				#define	BUTTON_SYSTEMENU_HELP_GAME_PAGEUP		66412
				#define	BUTTON_SYSTEMENU_HELP_GAME_PAGEDOWN		66414
				#define	BUTTON_SYSTEMENU_HELP_GAME_FINISH		66416
		#define	BUTTON_SYSTEMENU_HELP_BACKTOGAME	66500
#define	BUTTON_SYSTEMENU_BACKTOGAME		67000


#define SHOW_BATTLE_RESULT				67010		// a flag to show the battle result of this companion
#define MENU_BATTLE_RESULT				67012		// the menu to show the battle result
	#define BUTTON_MENU_BATTLE_RESULT_OK	67014	// the default button of this menu
/////////////////////////////////////////////////////////
//	select general menu when you establish a battle unit 
/////////////////////////////////////////////////////////
//#define	BUTTON_ESTABLISH		16144
	#define	MENU_SELECT_GENERAL			70001
		#define	BUTTON_SELECT_GENERAL_OK			70002
		#define	BUTTON_SELECT_GENERAL_CANCEL		70004
		#define	BUTTON_SELECT_GENERAL_ARROW_TOP		70006
		#define	BUTTON_SELECT_GENERAL_ARROW_BOTTOM	70008
		#define	BUTTON_SELECT_GENERAL_LIST			70010
#define	ESTABLISH_UNIT					70020
////////////////////////////////////////
//	to show the mession of this section
////////////////////////////////////////
#define SHOW_CAMPAIGN_MISSION						70030
#define BUTTON_SHOW_CAMPAIGN_MISSION_CONTINUE		70031
/////////////////////////////////////////////
//	to show the single battle menu
/////////////////////////////////////////////
//#define	BUTTON_SINGLE		16137
#define	BUTTON_SINGLE_SHOWMENU	70040
	#define MENU_SINGLE					70042
		#define BUTTON_SINGLE_OK					70044
		#define BUTTON_SINGLE_CANCEL				70046
//	to show the reject information if the computer doesn't want to single battle
#define	BUTTON_SINGLE_REJECT	70050
	#define MENU_SINGLE_REJECT			70052
		#define BUTTON_SINGLE_REJECT_OK				70054
//	to show the result of a single battle
#define	BUTTON_SINGLE_RESULT	70060
	#define MENU_SINGLE_RESULT			70062
		#define BUTTON_SINGLE_RESULT_OK				70064
/////////////////////////////////////////////
//	to define all other pop-up message box
/////////////////////////////////////////////
#define	MENU_WAIT						15810	// waiting window --> to show a waiting message
	#define	BUTTON_MENU_WAIT_OK				15812	// cancel button in waiting window

#define	OUTTER_LINK_ERROR				15820	// a message for to send a outter network link error
#define	MENU_OUTTER_LINK_ERROR						15822	// link error message window --> to show a message of some error
	#define	BUTTON_MENU_OUTTER_LINK_ERROR_OK			15824	// OK button in link error message window

#define	INNER_LINK_ERROR				15830	// a message for to send a outter network link error
#define	MENU_INNER_LINK_ERROR						15832	// link error message window --> to show a message of some error
	#define	BUTTON_MENU_INNER_LINK_ERROR_OK			15834	// OK button in link error message window

#define	INNER_PLAYER_LOSE					15835	// a player is lose from this game( may be the net_work error or ALT+TAB )
#define MENU_INNER_PLAYER_LOSE				15837
	#define BUTTON_MENU_INNER_PLAYER_LOSE_OK		15839
	

#define	MENU_VALIDATE					15840	// validate window --> to show a message wait for your 
	#define	BUTTON_MENU_VALIDATE_OK			15842	// OK button in validate window
//////////////////////////////////////
// to define all menu button
//#define MENU_MAIN			10000
#define BUTTON_DIALOG_OK			10020
#define	BUTTON_DIALOG_CANCEL		10021

//////////////////////////////////////
//	to define all button's command
//	Ϣ
#define	BUTTON_NUMBERARROW	16000
#define	BUTTON_NUMBER_1		16001
#define	BUTTON_NUMBER_2		16002
#define	BUTTON_NUMBER_3		16003
#define	BUTTON_NUMBER_4		16004
#define	BUTTON_NUMBER_5		16005
#define	BUTTON_NUMBER_6		16006
#define	BUTTON_NUMBER_7		16007
#define	BUTTON_NUMBER_8		16008
#define	BUTTON_NUMBER_9		16009
#define	BUTTON_NUMBER_10	16010
#define	BUTTON_NUMBER_11	16011
#define	BUTTON_NUMBER_12	16012
#define	BUTTON_NUMBER_13	16013
#define	BUTTON_NUMBER_14	16014
#define	BUTTON_NUMBER_15	16015
#define	BUTTON_NUMBER_16	16016
#define	BUTTON_NUMBER_17	16017
#define	BUTTON_NUMBER_18	16018
#define	BUTTON_NUMBER_19	16019
#define	BUTTON_NUMBER_20	16020

////////////////////////////////////////////////
//		to define all ID of command button 
////////////////////////////////////////////////
//		ȡһϢ
#define	BUTTON_CANCEL				16025				
#define BUTTON_IRONMINE				16028

//	˧Ϣ
#define BUTTON_MAIN_PEASANT			16030
//	ܲ˧Ϣ
#define BUTTON_CHAO_MAIN_UPGRADE1	16031
#define BUTTON_CHAO_MAIN_UPGRADE2	16032	
#define BUTTON_CHAO_MAIN_UPGRADE3	16033
//	˧Ϣ
#define BUTTON_LIU_MAIN_UPGRADE1	16034
#define BUTTON_LIU_MAIN_UPGRADE2	16035	
#define BUTTON_LIU_MAIN_UPGRADE3	16036
//	ľĳϢ
#define BUTTON_LUMBER_UPGRADEBOW1	16040
#define BUTTON_LUMBER_UPGRADEBOW2	16041
#define BUTTON_LUMBER_UPGRADEBOW3	16042
//	Ϣ
#define BUTTON_WEAPONFACTORY_UPGRADEWEAPON1		16050
#define BUTTON_WEAPONFACTORY_UPGRADEWEAPON2		16051
#define BUTTON_WEAPONFACTORY_UPGRADEWEAPON3		16052
#define BUTTON_WEAPONFACTORY_UPGRADEARMOR1		16053
#define BUTTON_WEAPONFACTORY_UPGRADEARMOR2		16054
#define BUTTON_WEAPONFACTORY_UPGRADEARMOR3		16055
//	ǮׯϢ
#define BUTTON_SHOP_SALE100WOOD		16060
#define BUTTON_SHOP_SALE100FOOD		16061
#define BUTTON_SHOP_SALE100IRON		16062
#define BUTTON_SHOP_SALE1000WOOD	16063
#define BUTTON_SHOP_SALE1000FOOD	16064
#define BUTTON_SHOP_SALE1000IRON	16065
//	Ϣ
#define BUTTON_FOOTMANSCHOOL_100	16070
#define BUTTON_FOOTMANSCHOOL_200	16076
#define BUTTON_FOOTMANSCHOOL_500	16079
#define BUTTON_FOOTMANSCHOOL_1000	16081
//	Ϣ
#define BUTTON_KNIGHTSCHOOL_100		16090
#define BUTTON_KNIGHTSCHOOL_200		16091
#define BUTTON_KNIGHTSCHOOL_500		16094
//	Ϣ
#define BUTTON_BOWMANSCHOOL_200		16101
#define BUTTON_BOWMANSCHOOL_500		16104
#define BUTTON_BOWMANSCHOOL_1000	16106
#define BUTTON_BOWMANSCHOOL_100		16107
//	Ϣ
#define BUTTON_VEHICLEMANSCHOOL_VEHICLEMAN		16110
#define BUTTON_VEHICLEMANSCHOOL_UPGRADE1		16111
#define BUTTON_VEHICLEMANSCHOOL_UPGRADE2		16112
//	촬Ϣ
#define BUTTON_SHIPYARD_DESTROYER			16120
#define BUTTON_SHIPYARD_TRANSPORT			16121
#define BUTTON_SHIPYARD_BATTLESHIP			16122
#define BUTTON_SHIPYARD_GROUPSHIP			16123
#define BUTTON_SHIPYARD_UPGRADEDESTROYER	16124
#define BUTTON_SHIPYARD_UPGRADEBATTLESHIP	16125
#define BUTTON_SHIPYARD_UPGRADESHIPARMOR	16126
//	ˣսӣʿʿϢ
#define	BUTTON_MOVE			16130
#define	BUTTON_ATTACK		16131
#define	BUTTON_GUARD		16132
#define	BUTTON_LINEUP		16133
#define	BUTTON_REST			16134
#define	BUTTON_STRATAGEM	16135
#define	BUTTON_DISMISS		16136
#define	BUTTON_SINGLE		16137
#define	BUTTON_TRANSPORT	16138
#define	BUTTON_CHAO_BUILD	16139
#define BUTTON_LIU_BUILD	16140
#define	BUTTON_REPAIR		16141
#define	BUTTON_SHIP			16142
#define	BUTTON_UNSHIP		16143
#define	BUTTON_ESTABLISH	16144
#define	BUTTON_JOIN			16145
#define BUTTON_BACK			16146
//	ΪܲٵĹ˵ĽϢ
#define	BUTTON_CHAO_BUILD_MAIN				16150
#define	BUTTON_LIU_BUILD_MAIN				16151
#define	BUTTON_CHAO_BUILD_WEAPONFACTORY		16152
#define	BUTTON_LIU_BUILD_WEAPONFACTORY		16153
#define	BUTTON_CHAO_BUILD_LUMBER			16154
#define	BUTTON_LIU_BUILD_LUMBER				16155
#define	BUTTON_CHAO_BUILD_KNIGHTSCHOOL		16156
#define	BUTTON_LIU_BUILD_KNIGHTSCHOOL		16157
#define	BUTTON_CHAO_BUILD_VEHICLEMANSCHOOL	16158
#define	BUTTON_LIU_BUILD_VEHICLEMANSCHOOL	16159
#define	BUTTON_CHAO_BUILD_FARM				16160
#define	BUTTON_LIU_BUILD_FARM				16161
#define	BUTTON_CHAO_BUILD_FOOTMANSCHOOL		16162
#define	BUTTON_LIU_BUILD_FOOTMANSCHOOL		16163
#define	BUTTON_CHAO_BUILD_BOWMANSCHOOL		16164
#define	BUTTON_LIU_BUILD_BOWMANSCHOOL		16165
#define	BUTTON_CHAO_BUILD_DOOR				16166
#define	BUTTON_LIU_BUILD_DOOR				16167
#define	BUTTON_CHAO_BUILD_TOWER				16168
#define	BUTTON_LIU_BUILD_TOWER				16169
#define	BUTTON_CHAO_BUILD_SHIPYARD			16170
#define	BUTTON_LIU_BUILD_SHIPYARD			16170
#define	BUTTON_CHAO_BUILD_SHOP				16173
#define	BUTTON_LIU_BUILD_SHOP				16173
#define	BUTTON_CHAO_BUILD_FLAG				16176
#define	BUTTON_LIU_BUILD_FLAG				16176
#define	BUTTON_CHAO_BUILD_PAGEUP			16180
#define	BUTTON_CHAO_BUILD_PAGEDOWN			16181
#define	BUTTON_LIU_BUILD_PAGEUP				16183
#define	BUTTON_LIU_BUILD_PAGEDOWN			16184
#define	BUTTON_CHAO_HOUSE					16186		// ܲٷͼ
#define	BUTTON_LIU_HOUSE					16187		// ͼ
//	ΪĹ˵ĽϢ
//	սӵϢ
#define	BUTTON_LINEUP_ONE		16190
#define	BUTTON_LINEUP_TWO		16191
#define	BUTTON_LINEUP_THREE		16192
#define	BUTTON_LINEUP_FOUR		16193
#define	BUTTON_LINEUP_FIVE		16194
#define	BUTTON_LINEUP_SIX		16195
#define	BUTTON_LINEUP_SEVEN		16196
#define	BUTTON_LINEUP_EIGHT		16197
#define	BUTTON_LINEUP_NINE		16198
#define	BUTTON_LINEUP_TEN		16199
#define	BUTTON_LINEUP_PAGEUP	16200
#define	BUTTON_LINEUP_PAGEDOWN	16201
//	սӵļıϢ
#define	BUTTON_STRATAGEM_ENCOURAGE		16210
#define	BUTTON_STRATAGEM_SPEEDUP		16211
#define	BUTTON_STRATAGEM_SPEEDDOWN		16212
#define	BUTTON_STRATAGEM_SEEFAR			16213
#define	BUTTON_STRATAGEM_ANARCHY		16214
#define	BUTTON_STRATAGEM_ROLLTIMBER		16215
#define	BUTTON_STRATAGEM_AMBUSCADE		16216
#define	BUTTON_STRATAGEM_BRINGBACK		16217
#define	BUTTON_STRATAGEM_FIRE			16218

///////////////////////////////////
// to define all command unit idification
//	command unit of all people unit
#define COMMANDUNIT_CANCEL				70000
#define COMMANDUNIT_NONE				70001

#define COMMANDUNIT_CHAO_PEASANT				70100	//ũ񲿶
	#define COMMANDUNIT_CHAO_BUILD_PAGEONE		70110	//ĵһҳ
	#define COMMANDUNIT_CHAO_BUILD_PAGETWO		70120	//ĵڶҳ
#define COMMANDUNIT_LIU_PEASANT				70150	//ũ񲿶
	#define COMMANDUNIT_LIU_BUILD_PAGEONE		70160	//ĵһҳ
	#define COMMANDUNIT_LIU_BUILD_PAGETWO		70170	//ĵڶҳ
#define COMMANDUNIT_FIGHTUNIT			70200	//ս
	#define COMMANDUNIT_LINEUP_PAGEONE		70210	//սӵĵһҳ
	#define COMMANDUNIT_LINEUP_PAGETWO		70220	//սӵĵڶҳ
	#define COMMANDUNIT_STRATAGEM			70230	//սӵļı
#define COMMANDUNIT_SINGLESOLDIER		70300	//ʿ
#define COMMANDUNIT_REGIMENTSOLDIER		70400	//ʿ
#define COMMANDUNIT_TRANSPORTSHIP		70500	//䴬
// command unit of all building
#define COMMANDUNIT_CHAO_MAINBUILDING		70600	//˧
#define COMMANDUNIT_LIU_MAINBUILDING		70700	//˧
#define COMMANDUNIT_LUMBER					70800	//ľĳ
#define COMMANDUNIT_WEAPONFACTORY			70900	//
#define COMMANDUNIT_SHOP					71000	//Ǯׯ
#define COMMANDUNIT_FOOTMANSCHOOL			71100	//	FOOTMAN--
#define COMMANDUNIT_KNIGHTSCHOOL			71200	//	
#define COMMANDUNIT_BOWMANSCHOOL			71300	//
#define COMMANDUNIT_VEHICLEMANSCHOOL		71400	//	VEHICLE MAN-->	
#define COMMANDUNIT_SHIPYARD				71500	//
///////////////////////////////////
#endif
